#!
# (c) Guenther Alka 2016,2019
# menu: appliance maps
# for napp-it pro complete
# 25.sep 17
# 8.aug 2017, hgst map
# 25.sep, maps as folder
# 11.1.2018,  disk=blue if not a poolmember
# 7. apr 2018, controller m,l
# 9. apr 2018 dd
# 25.jul 2018, last known disk is editable
# 16. jan 19 problems with some HBAs (disks not shown)   id_sas_slot > id_slot


use strict;         # check for proper code

# slot map for 1..6 maps
# slot numbering: nn.nn.nn (map.row.pos), ex 02.01.04


###############
sub my_action {
###############     build actions according to this template

# declare all your variables as local or you will get errors
my ($out,$var,$k,$v,@s,$r,$p,$nr,$map,$maps,@d,$d,$row,$pos,$rows,$cols);

# in %p
# map1_type    # chenbro_50
# map1_slot    # C0e1S0 or c1t1d0


&load_lib("disklib.pl"); if ($cfg{'ver'}=~/c/) { &load_lib("get-disk-sas2.pl"); }

#read smart values
&my_read_smart;

# collect all needed infos to %p to make editing easier
%p=();                                           # parameter for map
$p{'all_dsk'}=$disk{'all_dsk'};                  # current disks ec from format
$p{'all_lsi'}=$disk{'all_lsi'};                  # wwn
$p{'all_nlsi'}=$disk{'all_nlsi'};                # port numbers like c1t1d0
$p{'all_replaceable'}=$disk{'all_replaceable'};  # all disks from zpool status (used by a pool)

#$p{'brands'}="bordeaux,blue,green,orange,silver";
$p{'brands'}=&my_maps;

# SET, Image-Submit to select a slot for a disk
$p{'question_submit'}="<button type='submit' title='Insert and select a new disk&#10;and set it then to this slot' value=\"=val=\" name='submit' style='width:30px; height:30px'><img src='/_doc/set.png'></button>";

# clear-Submit to del a row
$p{'clear_submit'}="<button type='submit' onclick=\"return confirm('Do you really want to delete the slots in this row?')\" title='Delete all slots in this row' value=\"delrow_=val=\" name='submit' style='width:30px; height:30px'><img src='/_doc/del.png'></button>";

# clear-Submit to calc a row
$p{'calc_submit'}="<button type='submit' onclick=\"return confirm('Do you really want to calculate next 4 slot numbers from left to right?')\" title='Calc next 3 slots (increase or decrease)' value=\"calcrow_=val=\" name='submit' style='width:30px; height:30px'><img src='/_doc/add.png'></button>";

# remove a single old-disk from id.txt
$p{'del_old_id'}="<a title=\"=title=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;prop==prop=\&amp;action=delete_old_id\" onclick=\"return(confirm('delete old slot id =nr= from map history?'))\">=text=</a>";

# add diskinfo
$p{'edit_slot'}="<a title=\"=title=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;prop==prop=\&amp;action=ed_slot\"><img src='/_doc/edit.png'></a>";


 ####################
 # read all map files        01..09
 ####################

 for ($nr=1;$nr<=9;$nr++) {

     $map=$nr;
     if ($map < 10) { $map="0$map";  $map=~s/^0+/0/; } # map 01 .. 06

     ##
     #######################
     #map 1 type
     # read map typeinfo from config file /_log/maps/map1_type.txt
     # ex
     # 0 type    ex 3h
     # 1 rows
     # 2 cols
     # hide      ex 00,01
     # nvme      opt ex 02,03
     # Text      ex SM 16bay
     # Desc      neues Case mit 12G

     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_type.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_type.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        $t="map$map\_type";   $p{$t}=$t[0];
        $t="map$map\_rows";   $p{$t}=$t[1];
        $t="map$map\_cols";   $p{$t}=$t[2];
        $t="map$map\_hide";   $p{$t}=$t[3];
        $t="map$map\_nvme";   $p{$t}=$t[4];
        $t="map$map\_text";   $p{$t}=$t[5];
        $t="map$map\_desc";   $p{$t}=$t[6];
        $t="map$map\_brand";  $p{$t}=$t[7];
        $p{'all_maps'}.="$map\t";
     }

     if (!($cfg{'ver'}=~/c/)) {
        last;
     }

     #set cols and rows of this map
     $rows="map$map"."_rows";
     $rows=$p{$rows};

     $cols="map$map"."_cols";
     $cols=$p{$cols};

     ###########################################################################
     # read slotmap
     # read map slotinfo from config file /_log/maps/map1_slot.txt
     # each line is a row, slots are separated with \t

     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_slot.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_slot.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

       #  &print_array(@t);

        for (my $row=0;$row<@t;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # pos 0 ..n
                for (my $pos=0;$pos<@s;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    if ($s[$pos] eq "") { next; }

                    $t="enc_of_slot_$map\.$row\.$pos";
                    $p{$t}=$s[$pos];

                    # revers disk_in_slot{'slot'}=>id        # wwn only
                    $t="disk_in_slot_$map\.$row\.$pos";
                    $d="$s[$pos]"."_disk";                   # $s=pos

                    #debug
                    #print "$s[$pos] => $disk{$d} <br>";

                    if ($d=~/:/) {
                         $p{$t}=$disk{$d};                   # -> wwn disk
                     } else {
                         $p{$t}=$s[$pos];                    # -> port like c0t0t0
                     }

                    # $p{'map1_slot_00.02'}=c1...
                    $p{'all_known_slots'}.="$map\.$row\.$pos\t";
                }
        }

     }

     ###########################################################################
     # read list of last id/wwn with current  disk_in_slot
     # keep missing id intact

     # read last map WWN info from config file /_log/maps/map1_id.txt
     # this info is used only in case a disks is missing to display the location of a damaged disk
     # each line is a row, valuse are separated with \t

     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        for (my $row=0;$row<$rows;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # slots 0 ..n

                for (my $pos=0;$pos<$cols;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    # check if there is a disk in this slot
                    # disk_in_slot_01.00.23        ->         'c2t0d0 or c2t500..'

                    $t="disk_in_slot_$map\.$row\.$pos";
                    if ($p{$t}=~/c/) {
                          $p="last_disk_in_slot_$map\.$row\.$pos";
                          $p{$p}=$p{$t};                              # current disk will be last disk
                          $s[$pos]=$p{$t};                            # save current disk

                    } else {
                          $t="last_disk_in_slot_$map\.$row\.$pos";    # keep former last disk intact
                          $p{$t}=$s[$pos];                            # =c1...
                    }

                }
                $t[$row]=join("\t",@s);
                #&print_array(@s);
        }

        #&print_array(@t);
        # update id.txt

        foreach my $t (@t) { $t.="\n"; }
        &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");
     }


     ###########################################################################
     # read slotinfo
     # read map slotinfo from config file /_log/maps/map1_info.txt
     # each line is a row, slots are separated with \t

     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_info.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_info.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        # &print_array(@t);

        for (my $row=0;$row<@t;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # pos 0 ..n
                for (my $pos=0;$pos<@s;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    if ($s[$pos] eq "") { next; }

                    $t="info_of_slot_$map\.$row\.$pos";
                    $p{$t}=$s[$pos];

                }
        }

     }


  } #/read maps 1..n
  ##############################################################################
  $p{'all_known_slots'}=~s/\t+$//;

  # debug
  #&print_hash(%p);
  #&print_hash(%in);

  # demo map
  #$p{'all_maps'}="";
  ##############################################################################
  if ( (!($cfg{'ver'}=~/c/))  || ($p{'all_maps'} eq "") ) {
        $p{'demo'}="1";     # demo mode

        $t="map01\_brand";  $p{$t}='blue';
        $t="map01\_type";   $p{$t}='3h';
        $t="map01\_rows";   $p{$t}='2';
        $t="map01\_cols";   $p{$t}='4';
        $t="map01\_hide";   $p{$t}='00.00,00.01,01.02,01.03';
        $t="map01\_nvme";   $p{$t}='01.00,01.01';
        $t="map01\_text";   $p{$t}='Demo - Boot mirror and NVMes in slot 1 and 2';

        $t="map02\_brand";  $p{$t}='bordeaux';
        $t="map02\_type";   $p{$t}='3h';
        $t="map02\_rows";   $p{$t}='3';
        $t="map02\_cols";   $p{$t}='4';
        $t="map02\_hide";   $p{$t}='';
        $t="map02\_text";   $p{$t}='Demo - 3,5" enclosure';

        $t="map03\_brand";  $p{$t}='green';
        $t="map03\_type";   $p{$t}='2v';
        $t="map03\_rows";   $p{$t}='1';
        $t="map03\_cols";   $p{$t}='24';
        $t="map03\_hide";   $p{$t}='';
        $t="map03\_text";   $p{$t}='Demo - 2,5 enclosure"';

        $t="map04\_brand";  $p{$t}='silver';
        $t="map04\_type";   $p{$t}='3v';
        $t="map04\_rows";   $p{$t}='5';
        $t="map04\_cols";   $p{$t}='12';
        $t="map04\_hide";   $p{$t}='';
        $t="map04\_text";   $p{$t}='Demo - 3,5h Petabyte enclosure"';

        $p{'all_maps'}="01\t02\t03\t04";
 }

############################ edit ##############################################
#&print_hash(%in);
if ($in{'action'} eq "delete_old_id") {          # delete old disk id from history in id.txt
     if ($p{'demo'} eq "1")   { &mess("not possible in demo mode"); }
     &my_del_old_slot_id;
}

if ($in{'action'} eq "ed_slot") {                # edit slot
     if ($p{'demo'} eq "1")   { &mess("not possible in demo mode"); }
     if ($in{'answered'}) {
        &my_write_edit;
     }
     &my_edit_slot;
}

if ($in{'answered'}) {
     if ($p{'demo'} eq "1")   { &mess("not possible in demo mode"); }
     if (!($cfg{'ver'}=~/c/)) { &mess('only available in napp-it Pro complete'); }

     # set(assign a disk to a slot via its port id or enc id
     if ($in{'submit'}=~/^\d+\.\d+\.\d+$/) {
        &my_update_slots;
     }

     #del row
     if ($in{'submit'}=~/delrow_\d/) {
        &my_del_slots;
     }

     # add/update row
     if ($in{'submit'}=~/calcrow_\d/) {
        &my_calc_slots;
     }
     &reload;

}
################################################################################


  #####################################
  # ok config data readed, process data
  #####################################

  ## all_replacable = all disks used in pools
  ## all_dsk        = all current disks found by format

  # need a list of disks that are not assigned to a slot (c1t1d0 or c1e1s00)
  @s=();
  @s=split(/\t/,$p{'all_known_slots'});

  #&print_array(@s);

  $p{'all_disks_unassigned'}=$p{'all_dsk'};

  foreach my $s (@s) {               # all known slots
     @d=();
     @d=split(/\t/,$p{'all_dsk'});
     # &print_array(@d);

     @t=();
     @t=split(/\./,$s);
     $map=$t[0];
     $row=$t[1];
     $pos=$t[2];
     #&print_array(@t);

     foreach my $d (@d) {             # all disks

             # process each found disk only once
             if ($p{'all_disks_ok_in_slots'}=~/$d/) {  next; }

             #&print_array(@d);

             if (length($d) > 15) {   # WWN
                     $t="$d"."_slot";
                     $r="enc_of_slot_$map\.$row\.$pos";                  # ex enc_of_slot_01.00.02 -> c2t0d0

                     # debug
                     # print "$s $d -> $disk{$t} = $p{$r} <br>";

                     if ($disk{$t} eq $p{$r}) {                          # ok, disk is in correct slot
                        if (!($p{'all_disks_ok_in_slots'}=~/$d/)) {
                           $p{'all_disks_ok_in_slots'}.="$d\t";
                        }
                        $p{'all_disks_unassigned'}=~s/$d//;              # remove found
                        next;
                     }
                    # if (!($p{'all_disks_missing_in_slots'}=~/$d/)) {  #???
                    #      $p{'all_disks_missing_in_slots'}.="$d\t";
                    # }
             } else {                                                    # port ex c1t1do
                     $t="enc_of_slot_$map\.$row\.$pos";                  # ex enc_of_slot_01.00.02 -> c2t0d0

                     # debug
                     # print "$s -> $d -> $p{$t} <br>";

                     if ($p{$t} eq $d) {                                 # ok, this disk is in slot
                          if (!($p{'all_disks_ok_in_slots'}=~/$d/)) {
                              $p{'all_disks_ok_in_slots'}.="$d\t";
                          }
                          $p{'all_disks_unassigned'}=~s/$d//;            # remove found
                          next;
                     }
             }
     }
  }
  # $p{'all_disks_missing_in_slots'}=~s/\t+$//;       # ??
  $p{'all_disks_ok_in_slots'}=~s/\t+$//;
  $p{'all_maps'}=~s/\t+$//;
  $p{'all_disks_unassigned'}=~s/\t+/\t/g;
  $p{'all_disks_unassigned'}=~s/\t+$//;
  $p{'all_disks_unassigned'}=~s/^\t+//;

  #debug
  #$p{'_hashname'}="%p";  &print_hash(%p);


##################
# css for all maps
##################
print <<EoF;
   <style>
       div {
         background-repeat: no-repeat; border: none; font-size: 12px;
       }
   </style>
EoF

  ########################
  # print maps over a form
  ########################

  # begin maps
  print <<EoF;
 <form name="begin" id="begin" method="post" action="/cgi-bin/admin.pl">
        <input type="hidden" name="id" value="$in{'id'}">
        <input type="hidden" name="l1" value="$in{'l1'}">
        <input type="hidden" name="l2" value="$in{'l2'}">
        <input type="hidden" name="l3" value="$in{'l3'}">
        <input type="hidden" name="answered" value="1">
EoF

  # print maps
  @t=();
  @t=split(/\t/,$p{'all_maps'});
  foreach my $t (@t) {
     &my_prepare_map($t);        # map nr ex 01 .. 06
  }


  #####################################
  #print radio list of unassigned disks
  #####################################

  @s=();
  @s=split(/\t/,$p{'all_disks_unassigned'});
  $out="";

#&print_array(@s);

  foreach my $s (@s) {

    # wwn
    $d=$s;
    if (length($d) > 15) {

        # must have an enclosure
        $t=$s."_slot";                       # 16.01.2019
        if ($disk{$t} eq "")    {  next; }   # required
        $p=$disk{$t};

        # bold of last char only
        $t=substr($d,0,14);
        $r=substr($d,15);

        $d="<font style='color:#666666'>$t</font><b> $r";
        if ($d=~/d0/) {                        #  bold last 4 char without d0
            $d=~s/d0/<\/b> <font style='color:#666666'>d0<\/font>/;
        } else {
            $d.="</b>";
        }

    }   else {
        $d="<b>$d</b>";
        $p="$s";
        $p=~s/d\d//;
        $p=~s/t/:t/;
    }
    $t="$s"."_product";
    $d.= "&nbsp;&nbsp;&nbsp;$disk{$t}";

    $t="$s"."_partcap";
    $d.= "&nbsp;&nbsp;$disk{$t}";
    $d.= "&nbsp;&nbsp;<b>$p</b>";           # enclosure

    #with real hba
    $out.="<input type=\"radio\" name=\"radio_set_disk\" value=\"$s\"> $d <br>";
  }

print <<EoF;
<div style='margin-left: 15px;font-size:11px;color:black'><br><br>
<b>How to assign disks to a map</b><br>
Insert a new disk - best in the first slot of a row and wait a few seconds, then press reload to display the disk.<br>
Select this disk and assign it to a slot. Click on add to auto assign the next 3 slots of the row or press del to delete a whole row<br><br>

<b>You can only assign disks with a port id like c1t1d0 or an enclosure id</b> like e1:m1:s0 from menu Disks > Location. <br>
Apppliance Map works with Sata, Atto or LSI HBAs. Use Disks > Location in a second Window to identify disks via dd<br>
<br>
If you change sasicru or disk detection mode in Disks > Location to driver internal detection, your controller id will change.<br>
Use a printout of your old map then to re-create a map with disks at the same physical slot but with a different controller id.<br>
<br>


$out
 </div>
EoF

if ($out eq "") {
  print "<br><br><b>&nbsp;&nbsp;&nbsp;&nbsp;There are no disks with a port id or enclosure id available that can be assigned to a slot.</b>";
}

# end maps
print "</form>";
print "<script language='javascript'>document.getElementById('hl').innerHTML='Appliance Map (pro feature) $current{'acc_mess'}'</script>\n";

#############
# end logging
#############
if ($cfg{'ver'}=~/c/) {
    &log_end;

    #enable blink
    if ($in{'list'} ne "") {
      $in{'disk'}=$in{'prop'}; # diskid
      &my_dd_blink;    # reload after a few sec
    }

    #######################
    # debug, show after map
    #######################
    if (-f "/tmp/nappit/napp-it_edit_on") {
       $p{'_hashname'}="%p";
       &print_hash(%p);
    }
}



#

} #/ my_action


##########
sub my_maps {
##########
my (@t,$r,$m);
$r=`/usr/gnu/bin/find /var/web-gui/data/wwwroot/_doc/map/ -type d -maxdepth 1`;
@t=split(/\n/,$r);
@t=sort(@t);
foreach my $t (@t) {
  $t=~s/.*\///;       # name only
  if (!($t=~/[a-z]/)) { next; }
  if ($t=~/[A-Z]/)    { next; }   # private
  $m.="$t,";
}

if (!(-d "/var/web-gui/_my/wwwroot/_doc"))     { mkdir("/var/web-gui/_my/wwwroot/_doc"); }
if (!(-d "/var/web-gui/_my/wwwroot/_doc/map")) { mkdir("/var/web-gui/_my/wwwroot/_doc/map"); }

$r=`/usr/gnu/bin/find /var/web-gui/_my/wwwroot/_doc/map/ -type d -maxdepth 1`;
@t=split(/\n/,$r);
@t=sort(@t);
foreach my $t (@t) {
  $t=~s/.*\///;       # name only
  if (!($t=~/[A-Z]/)) { next; }
  $m.="$t,";
}
$m=~s/,+$//;
return($m);

}

###########   50 x 3,5" disks, 0-12 rows,
sub my_prepare_map {
###########
  my ($t,$slot,$map,$cols,$rows,$type,$hide,$nvme,$k,$v,$conf);

  $p{'current_map'}=$_[0];            # prepare map ex 1 . n

  # delete all old my_ values from former maps
  foreach $k (sort keys %p) {
    if ($k=~/^my\d/) {
       $p{$k}="";
       delete $p{$k};
    }
  }

  # read pos.txt > %p
  $conf=$p{'current_map'};       # ex 01
  chomp($conf);
  $conf="map".$conf."_brand";
  $conf=$p{$conf};               # ex blue

  if ($conf=~/[A-Z]/) {
     $conf="/var/web-gui/_my/wwwroot/_doc/map/".$conf."/pos.txt";
  } else {
     $conf="/var/web-gui/data/wwwroot/_doc/map/".$conf."/pos.txt";
  }

  $p{'my0_lastfile'}=$conf;
  if (-f "$conf") {
     @p=();                                # only hash needed
     &read_ahfile("$conf","p","h+");       # add pos data ex pos_map01_text
  }
  #####

  if ($p{'current_map'} < 10) {
       $p{'current_map'}="0$p{'current_map'}";
       $p{'current_map'}=~s/^0+/0/;
  }
  $map=$p{'current_map'};             # map  number ex map 01

  #set cols and rows of this map
     $t="map$map"."_rows";
     $p{'current_rows'}=$p{$t};

     $t="map$map"."_cols";
     $p{'current_cols'}=$p{$t};

  $t="map$map"."_rows";               # 1..n
  $rows=$p{$t};

  $t="map$map"."_cols";               # 1..n
  $cols=$p{$t};

  $t="map$map"."_hide";               # ex 00.00,00.01
  $hide=$p{$t};

  $t="map$map"."_text";
  if ($p{$t} ne "") {
     if ($map > 1) { print "<br><br>"; }  # not on first map
     print "<b style='margin-left: 15px'>Map $map: $p{$t}</b>";                # header
  }

  #current map type
  $t="map$map"."_type";
  $type=$p{$t};

  #####################
  # map type default 3,5" horizontal 300 x 75px per slot
  if ($type eq "3h") {

    # calc mapwidth
    $p{'mapwidth'}=($cols*300)+60;   # 1260  for 4 x 3,5" (4 x 300 + 2 x 30 border)

    # calc mapheight
    $p{'mapheight'}=$rows*75;        # 975 for 13 x 3,5" rows (chenbro 50)
  }

  if ($type eq "2v") {

    # calc mapwidth
    $p{'mapwidth'}=($cols*50)+60;    # 1260  for 4 x 3,5" (4 x 300 + 2 x 30 border)

    # calc mapheight
    $p{'mapheight'}=$rows*300;       # 975 for 13 x 3,5" rows (chenbro 50)
  }

  ####################  ex for HGST 60 (12r, 5c, 3v)
  if ($type eq "3v") {

    if ($p{'current_cols'} <=12) {           # any + hgst 60
          #
          # calc mapwidth
          $p{'mapwidth'}=($cols*100)+60;     # 1260  for 4 x 3,5" (4 x 300 + 2 x 30 border)

          # calc mapheight
          $p{'mapheight'}=$rows*300;         # 975 for 13 x 3,5" rows (chenbro 50)

    } else {         # 80px with, sm toploader
          #
          # calc mapwidth
          $p{'mapwidth'}=($cols*80)+60;      # 1260  for 4 x 3,5" (4 x 300 + 2 x 30 border)

          # calc mapheight
          $p{'mapheight'}=$rows*300;         # 975 for 13 x 3,5" rows (chenbro 50)

    }
  }

  # print map border with width +60px
  print "<div style='position:relative; border-style:outset; border-color:#999999; border-width: 8px; height: $p{'mapheight'}"."px; width:$p{'mapwidth'}"."px; z-index:1; margin-left:10px; background-color:#eeeeee'>";

  # border left 30px
  print "<div style='position: relative; margin-left: 30px'>";
  #####

  for (my $row=0;$row<$rows;$row++) {
      for (my $pos=0;$pos<$cols;$pos++) {
          if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
          if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

          $slot="$row\.$pos";
          $t=$slot; $t=~s/\./\\./;                 # mask 00.00 to 00\.00

          if ($hide=~/$t/) {
               &my_print_map("-",$row,$pos);
          } else {
               $t="enc_of_slot_$map\.$row\.$pos";  # slot_00.03
               &my_print_map("$p{$t}",$row,$pos);  # ex c1e1s1    1  1
          }
      }
  }

  print "</div></div>";
  #####

  #debugmode
  if (-f "/tmp/nappit/napp-it_edit_on") {
      # show my_ values for map
      print "<br>edit/debug enabled<br>";
      foreach $k (sort keys %p) {
        if ($k=~/^my\d/) {
          print "$k -> $p{$k} <br>";
        }
      }
  }

}


########### map 3,5" x n hor
sub my_print_map {
###########
  #par:
  my ($dd,$slot,$id,$d,@v,$ver,$hor,@t,$s,$n,$wwn,$title,$temp,$smart,$red,$reset,$resetleft,$add,$bg,$bgx,$bgy,$brand,$color,$conf,$src,$k,$v);

  # read pos.txt > %p
  $conf=$p{'current_map'};       # ex 01
  $conf="map".$conf."_brand";
  $conf=$p{$conf};               # ex blue

  if ($conf=~/[A-Z]/) {
     $conf="/var/web-gui/_my/wwwroot/_doc/map/".$conf."/pos.txt";
     $src="/_my/_doc/map";
  } else {
     $conf="/var/web-gui/data/wwwroot/_doc/map/".$conf."/pos.txt";
     $src="/_doc/map";
  }

  #&print_hash(%p);
  #&mess($conf);

  if (-f "$conf") {
     #&read_ahfile("$conf","p","h+");       # add pos data ex pos_map01_text
     #&print_hash(%p);
  }

  $red="#ff9702";                # alert color
  $color="white";                # text color

  my $slot =$_[0];               # c1e1s00
  my $row  =$_[1];               # 0  .. n
  my $pos  =$_[2];               # 0  .. n

  $ver=$row;                     # 00,01,02
  $hor=$pos;                     # 00,01,02

  # disk id in current slot
  $t="disk_in_slot_$p{'current_map'}\.$row\.$pos";
  $id=$p{$t};                     # wwn or c3t0d0

  my $alertimg="greyb.png";        # default


  # product
  $t="$id"."_product";
  my $prod=$disk{$t};
  my $prod0=$prod;
  $prod=substr($prod,0,10);
  $title="Prod: $disk{$t} &#10;";       # Produkt \n

  #brand/color
  $brand="bordeaux";                               # default img folder bordeaux for SuperMicro and similar

  $t="map$p{'current_map'}"."_brand";
  if ($p{$t} ne "") { $brand="$p{$t}";  }          # use images from this color

  ##cap
  $t="$id"."_partcap";
  $title.="Cap: $disk{$t} &#10;";

  ##wwn/id
  $title.="ID: ".$id."&#10;";

  # serial
  $s="$id"."_sn";
  $title.="Serial: ".$disk{$s}."&#10;";

  #Pool and vdev
  $s="$id"."_pool";
  if ($disk{$s} ne "") {
    $title.="Pool: ".$disk{$s}."&#10;";

    $s="$id"."_vdev";
    $title.="Vdev: ".$disk{$s}."&#10;";
  }

  # sas slot
  $s="$id"."_slot";
  if ($disk{$s} ne "") {
    $title.="Slot: ".$disk{$s}." ($p{'current_map'}\.$row\.$pos)"."&#10;";
  }

  # mpt target  ex 9
  $s="$id"."_target";
  if ($disk{$s} ne "") {
    $title.="MPT Target: ".$disk{$s}."&#10;";
  }

  # format id
  $s="$id"."_format_id";
  $title.="Fmt_id:".$disk{$s}."&#10;";

  #info
  $s="info_of_slot_$p{'current_map'}\.$row\.$pos";
  if ($p{$s} ne "") {
     $t=$p{$s};
     $t=~s/<n>/&#10;/gs;
     $title.="&#10;Info: $t";
  }

  # size/cap
  $t="$id"."_partcap";
  my $cap=$disk{$t};
  if ($cap=~/\d\d+\./) {
    $cap=~s/\.\d+ //;                # int only
  }
  $cap=~s/B//;

  # iostat err
  $t="$id"."_error";
  my $err=$disk{$t};
  $t=$err; $t=~s/\D//g;           # ex S:10 H5: T0 > 105
  if ($t>10) {
     $err="<font style=\"color:$red\">$err</font>";
  } else {
     $err="<font style=\"color:white\">$err</font>";
  }
  $err="<a title=\"Messages from iostat\">$err</a>";

  my $ins="greyb.png";
  $t=$id."_stat";
  if (($id=~/c/) && ($disk{$t} eq "ok")) {
     $ins="blueb.png";
  }

  # show set when slot has no map id    $p{'map1_slot_01.02'}
  my $question="";
  $t="enc_of_slot_$p{'current_map'}\.$row\.$pos";                    # slot not assigned to a enclosure id
  if ($p{$t} eq "") {
    $question=$p{'question_submit'};
    $question=~s/=val=/$p{'current_map'}\.$row\.$pos/;
  }

  $add="";
  $reset="";
  $resetleft=($p{'mapwidth'}-60)."px";         # position of del button

  if ($pos==0) {
     #
     # reset/del button
     $reset=$p{'clear_submit'};
     $reset=~s/=val=/$p{'current_map'}\.$row/;

     # add/calc next 3 slot numbers fro first slot
     $add=$p{'calc_submit'};
     $add=~s/=val=/$p{'current_map'}\.$row/;
  }


  # smart temp
  $temp="";
  $s="$id"."_temp";
  if ($disk{$s} ne "") {
    $temp="$disk{$s}";
    $t=$temp;
    $4=~s//\&deg;/;               #  -> due utf8
    $t=~s/\D//g;
    if ($t>49) {
       $temp="<font style=\"color:$red\">$temp</font>";
    } else {
       $temp="<font style=\"color:$color\">$temp</font>";
    }
    $temp="<a title=\"Smart Temperature\">$temp</a>";
  }

  # smart stat
  $smart="";
  $s="$id"."_smart_overview2";     # was smart_selftest
  if ($disk{$s} ne "") {
    $smart="$disk{$s}";
    $smart=~s/\-\-//;
    $t=$smart;
    if ($t=~/problem/) {
       $smart="<font style=\"color:$red\">$smart</font>";
    }  else {
       $smart="<font style=\"color:$color\">$smart</font>";
    }
    $smart="<a title=\"Smart Overview\">$smart</a>";
  }

  # edit
  my $edit_slot=$p{'edit_slot'};
  $edit_slot=~s/=prop=/$p{'current_map'}\.$row\.$pos/;
  $edit_slot=~s/=title=/edit slot $p{'current_map'}\.$row\.$pos/;

  ################# pos ##############

  my ($wwnpos,$setpos,$idpos,$setpos,$insled,$actled,$alertled,$slotpos,$slotcolor,$cappos,$prodpos,$errpos,$temppos,$serrpos,$editpos,$image);
  $t="map$p{'current_map'}"."_type";

  #####################  current or last wwn/id

  #debug
  #$p{'disk_in_slot_01.00.04'}="";

  # disk is missing when there is a last disk but not a currenz
  $s="disk_in_slot_$p{'current_map'}\.$row\.$pos";
  $d="last_disk_in_slot_$p{'current_map'}\.$row\.$pos";

  $wwn=$p{$s};                              # = $id
  if (($p{$s} eq "") &&  ($p{$d} ne "")) {
     $wwn="!$p{$d}";                        # show last
  }

  ###################  enclosure


  ################### 3,5/nvme hor
  if ($p{$t}=~/3h/) {
  ###############################

      #
      $bg="3h.png";                       # default

      $ver=$ver*75;
      $hor=$hor*300;

      # default sm
      #
      $idpos="height: 75px; width: 300px; left: $hor"."px; top: $ver"."px";                      # always there

      $setpos="left: 180px; top:37px";
      if ($p{'my3h_setpos'} ne "") { $setpos=$p{'my3h_setpos'}; }

      $editpos="left: 245px; top:55px";
      if ($p{'my3h_editpos'} ne "") { $editpos=$p{'my3h_editpos'}; }

      $insled="left: 275px; top:34px";                                                           # inserted led
      if ($p{'my3h_insled'} ne "") { $insled=$p{'my3h_insled'}; }

      $actled="left: 275px; top:47px";                                                           # activity led
      if ($p{'my3h_actled'} ne "") { $actled=$p{'my3h_actled'}; }

      $alertled="left: 275px; top:60px";                                                         # alert led
      if ($p{'my3h_alertled'} ne "") { $alertled=$p{'my3h_alertled'}; }

      $slotpos="left: 10px; top:55px; color: #fbfad2; font-size:14px; font-weight: 900";         # default
      if ($p{'my3h_slotpos'} ne "") { $slotpos=$p{'my3h_slotpos'}; }

      #cover
      if ($slot eq "-") {
          $image="<img src=\"$src/$brand/grauspace.png\" style=\"width: 295px; height: 75px\">";
      }

      $cappos="left: 0px; top:7px; width: 280px; text-align: right";
      $wwnpos="left: 7px; top: 7px; font-size:11px";
      $prodpos="left: 165px; top: 7px; z-index:100";

      $errpos="top:32px; left:0; width: 216px; text-align: right;";                        # iostat err
      if ($p{'my3h_errpos'} ne "") { $errpos=$p{'my3h_errpos'}; }

      $temppos="left: 0px; top:46px; width: 216px; text-align: right;";                    # smart
      if ($p{'my3h_temppos'} ne "") { $temppos=$p{'my3h_temppos'}; }

      $serrpos="left: 0px; top:58px; width: 216px; text-align: right;";                    # smart
      if ($p{'my3h_serrpos'} ne "") { $serrpos=$p{'my3h_serrpos'}; }

      # add title as link
      $prod="<a title=\"$title\"><b style='color:black'>$prod</b></a>";                     # link with title + sn for full product name

      # slot nvme
      $s="map$p{'current_map'}"."_nvme";
      $n="$row\.$pos";
      if ($p{$s}=~/$n/) {
         $bg="nvme.png";
      }

      # wwn
      $t=$wwn;                  # wwn or slot
      $d="";
      if ($t=~/d\d$/) {
         $d=$t;
         $d=~s/.*d/d/;         # d0
         $t=~s/d\d$//;         # c1t0
      }

      if (length($t)>15) {     # wwn
         $s=$t; $s=~s/t.*//;   # keep c1 or !c1
         # $wwn="$s";          # c1
         $wwn="";

         #$wwn.=" ...<br>";
         $s=$t;
         $s=substr($s,-4);     # last 4
         $t=~s/$s//;           # first

         $wwn.="$t <b style='color: black; font-size:12px'>$s</b> $d";
      } else {
         $wwn="<b style='color: black; font-size:12px'>$wwn</b>";
      }
  }


  ###################################### 60/90 toploader
  if ($p{$t}=~/3v/) {        # 80 x 300 (60/90 SM) or 100x300 (hgst 60)
  ######################################

      # default 100px x 300px (hgst)
      if ($p{'current_cols'} <=12) {           # any + hgst 60
          #
          $bg="3v.png";                       # default

          $ver=$ver*300;
          $hor=$hor*100; $hor++;

          $idpos="height: 300px; width: 100px; left: $hor"."px; top: $ver"."px";

          #cover
          if ($slot eq "-") {
             $image="<img src=\"$src/$brand/grauspace.png\" style=\"width: 99px; height: 295px\">";
          }

          $setpos="left: 45px; top:190px";
          if ($p{'my3v_setpos'} ne "") { $setpos=$p{'my3v_setpos'}; }

          $editpos="left: 60px; top:239px";
          if ($p{'my3v_editpos'} ne "") { $editpos=$p{'my3v_editpos'}; }

          # led
          $insled="left: 41px; top:270px";     # insert led
          if ($p{'my3v_insled'} ne "") { $insled=$p{'my3v_insled'}; }

          $alertled="left: 60px; top:270px";   # alert led
          if ($p{'my3v_alertled'} ne "") { $alertled=$p{'my3v_alertled'}; }

          $actled="left: 79px; top:270px";     # activity led
          if ($p{'my3v_actled'} ne "") { $actled=$p{'my3v_actled'}; }

          # pos 3v
          $slotpos="left: 36px; top:209px; color: #fbfad2; font-size:11px; font-weight: bold; ";
          if ($p{'my3v_slotpos'} ne "") { $slotpos=$p{'my3v_slotpos'}; }

          $wwnpos="left: -110px; top: 145px; font-size:14px; color: black; width: 250px; transform:rotate(-90deg)";
          if ($p{'my3v_wwnpos'} ne "") { $wwnpos=$p{'my3v_wwnpos'}; }

          $prodpos="left: 2px; top: 82px; z-index:100; font-size:16px; color:black; font-weight: bold; transform:rotate(-90deg)";
          if ($p{'my3v_prodpos'} ne "") { $prodpos=$p{'my3v_prodpos'}; }

          $cappos="left: -9px; top:30px; width: 50px; text-align: right; color: black; text-size:14px; font-weight: bold; transform:rotate(-90deg)";
          if ($p{'my3v_cappos'} ne "") { $cappos=$p{'my3v_cappos'}; }

          $serrpos="top:150px; left:10px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v_serrpos'} ne "") { $serrpos=$p{'my3v_serrpos'}; }

          $temppos="top:150px; left:25px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v_temppos'} ne "") { $temppos=$p{'my3v_temppos'}; }

          $errpos="top:150px; left:40px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v_errpos'} ne "") { $errpos=$p{'my3v_errpos'}; }

      } else {         #opt 80px width (supermicro topload 60/90 with 15cols)

          $bg="3v2.png";

          $ver=$ver*300;
          $hor=$hor*80;
          $hor++;

          $idpos="height: 300px; width: 80px; left: $hor"."px; top: $ver"."px";

          #cover
          if ($slot eq "-") {
             $image="<img src=\"$src/$brand/grauspace.png\" style=\"width: 79px; height: 295px\">";
          }

          $setpos="left: 38px; top:190px";
          if ($p{'my3v2_setpos'} ne "") { $setpos=$p{'my3v2_setpos'}; }

          $editpos="left: 60px; top:239px";
          if ($p{'my3v2_editpos'} ne "") { $editpos=$p{'my3v2_editpos'}; }

          # led
          $insled="left: 37px; top:270px";     # insert led
          if ($p{'my3v2_insled'} ne "") { $insled=$p{'my3v2_insled'}; }

          $alertled="left: 51px; top:270px";   # alert led
          if ($p{'my3v2_alertled'} ne "") { $alertled=$p{'my3v2_alertled'}; }

          $actled="left: 65px; top:270px";     # activity led
          if ($p{'my3v2_actled'} ne "") { $actled=$p{'my3v2_actled'}; }

          # pos 3v2
          $slotpos="left: 36px; top:209px; color: #fbfad2; font-size:13px; font-weight: bold; ";
          if ($p{'my3v2_slotpos'} ne "") { $slotpos=$p{'my3v2_slotpos'}; }

          $wwnpos="left: -110px; top: 145px; font-size:14px; color: black; width: 250px; transform:rotate(-90deg)";
          if ($p{'my3v2_wwnpos'} ne "") { $wwnpos=$p{'my3v2_wwnpos'}; }

          $prodpos="left: 2px; top: 82px; z-index:100; font-size:16px; color:black; font-weight: bold; transform:rotate(-90deg)";
          if ($p{'my3v2_prodpos'} ne "") { $prodpos=$p{'my3v2_prodpos'}; }

          $cappos="left: -9px; top:30px; width: 50px; text-align: right; color: black; text-size:14px; font-weight: bold; transform:rotate(-90deg)";
          if ($p{'my3v2_cappos'} ne "") { $cappos=$p{'my3v2_cappos'}; }

          $serrpos="top:150px; left:8px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v2_serrpos'} ne "") { $serrpos=$p{'my3v2_serrpos'}; }

          $temppos="top:150px; left:23px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v2_temppos'} ne "") { $temppos=$p{'my3v2_temppos'}; }

          $errpos="top:150px; left:36px; width: 90px; text-align:left; transform:rotate(-90deg)";
          if ($p{'my3v2_errpos'} ne "") { $errpos=$p{'my3v2_errpos'}; }

      }


      #$smart="smart test";
      #$temp="40C";
      # end sm 80

      $t=$wwn;                  # wwn or slot

      $d="";
      if ($t=~/d\d$/) {
         $d=$t;
         $d=~s/.*d/d/;         # d0
         $t=~s/d\d$//;         # c1t0
      }

      # wwn
      $t=$wwn;                  # wwn or slot
      $d="";
      if ($t=~/d\d$/) {
         $d=$t;
         $d=~s/.*d/d/;         # d0
         $t=~s/d\d$//;         # c1t0
      }

      if (length($t)>15) {     # wwn
         $s=$t; $s=~s/t.*//;   # keep c1 or !c1
         # $wwn="$s";          # c1
         $wwn="";

         #$wwn.=" ...<br>";
         $s=$t;
         $s=substr($s,-4);     # last 4
         $t=~s/$s//;           # first

         $wwn.="$t <b style='color: black; font-size:14px'>$s</b> $d";
      } else {
         $wwn="<b style='color: black; font-size:14px'>$wwn</b>";
      }


      $prod=$prod0;           # text only
      $t=substr($prod,0,5);
      $prod="<a title=\"$title\"><font style='color:black'>$t</font></a>";
      #$cap="";                # include with prod

  }
  # /end 3v


  ######################################
  if ($p{$t}=~/2v/) {        # 50 x 300
  ######################################

      $bg="2v.png";          # default

      $ver=$ver*300;
      $hor=$hor*50; $hor++;
      $idpos="height: 300px; width: 75px; left: $hor"."px; top: $ver"."px";

      $setpos="left: 7px; top:190px";
      if ($p{'my2v_setpos'} ne "") { $setpos=$p{'my2v_setpos'}; }

      $editpos="left: 30px; top:251px";
      if ($p{'my2v_editpos'} ne "") { $editpos=$p{'my2v_editpos'}; }

      $insled="left: 5px; top:275px";     # insert led
      if ($p{'my2v_insled'} ne "") { $insled=$p{'my2v_insled'}; }

      $actled="left: 18px; top:275px";    # activity led
      if ($p{'my2v_actled'} ne "") { $actled=$p{'my2v_actled'}; }

      $alertled="left: 32px; top:275px";  # activity led
      if ($p{'my2v_alertled'} ne "") { $alertled=$p{'my2v_alertled'}; }

      #cover
      if ($slot eq "-") {
         $image="<img src=\"$src/$brand/grauspace.png\" style=\"width: 48px; height: 300px\">";
      }

      $slotpos="left: 10px; top:20px; color: $color; font-size:14px";
      if ($p{'my2v_slotpos'} ne "") { $slotpos=$p{'my2v_slotpos'}; }

      $slotcolor=$color;
      $slot=~s/:/:<br>/g;
      $slot=~s/t/<br>t/; $slot=~s/d/<br>d/;

      if ($p{'my2v_slotcolor'} ne "") { $slotcolor=$p{'my2v_slotcolor'}; }
      $slot="<b style=\"color:$slotcolor; font-size:13px\">$slot </b>";

      $prodpos="left: 5px; top: 67px; z-index:100; color:$color";
      if ($p{'my2v_prodpos'} ne "") { $prodpos=$p{'my2v_prodpos'}; }

      $cappos="left: 5px; top:80px; width: 50px; text-align: left; color: $color; text-size:14px";
      if ($p{'my2v_cappos'} ne "") { $cappos=$p{'my2v_cappos'}; }

      $wwnpos="left: 7px; top: 100px; font-size:12px; color: $color; width: 250px;";
      if ($p{'my2v_wwnpos'} ne "") { $wwnpos=$p{'my2v_wwnpos'}; }

      $errpos="top:175px; left:-35px; width: 90px; text-align:left; color:$color; transform:rotate(-90deg)";
      if ($p{'my2v_errpos'} ne "") { $errpos=$p{'my2v_errpos'}; }

      $temppos="top:175px; left:-22px; width: 90px; text-align:left;  color:$color; transform:rotate(-90deg)";
      if ($p{'my2v_temppos'} ne "") { $temppos=$p{'my2v_temppos'}; }

      $serrpos="top:175px; left:-9px; width: 90px; text-align:left; transform:rotate(-90deg)";
      if ($p{'my2v_serrpos'} ne "") { $serrpos=$p{'my2v_serrpos'}; }

      $t=$wwn;                  # wwn or slot

      $d="";
      if ($t=~/d\d$/) {
         $d=$t;
         $d=~s/.*d/d/;         # d0
         $t=~s/d\d$//;         # c1t0
      }

      $s=$t; $s=~s/t.*//;      # keep c1
      # $wwn="$s";               # c1
      $wwn="";

      if (length($t)>15) {     # wwn
         $wwn.=" ...<br>";
         $s=$t;
         $s=substr($s,-4);     # last 4
         $wwn.="<b style=\"color:$color\">$s</b><br>$d";
      } else {
         $wwn.="<br>";
         $s=$t;
         $s=~s/^c\d+//;        # target
         $wwn.="<b style=\"color:$color\">$s&nbsp;&nbsp;&nbsp;</b><br>$d";
      }

      $prod=$prod0;           # text only
      $t=substr($prod,0,5);
      $prod="<a title=\"$title\"><font style=\"color:$color\">$t<br>$cap</font></a>";
      $cap="";                # include with prod

  }
  # /end 2v


  # disk is missing when there is a last disk but not a currenz
  $s="disk_in_slot_$p{'current_map'}\.$row\.$pos";
  $d="last_disk_in_slot_$p{'current_map'}\.$row\.$pos";


  # show pool membership
  $t=$p{$s};                  # WWN in Slot
  $t.="_pool";
  if ($disk{$t} ne "") {
    $t=" $disk{$t}";
  } else {
    $t="";
  }

  my $act="greyb.png";        # default, active (member of a pool)
  my $act_desc="pool member$t";


  # disk has part
  my $part="0";               # has no part
  $t=$p{$s};                  # WWN in Slot
  $t.="_has_part";
  if ($disk{$t} eq "yes") {
        $part="1";
        $act_desc="disk has partitions";
  }


  if (($p{$s} eq "") &&  ($p{$d} ne "")) {            # empty bay

        $n=$p{'del_old_id'};                          # link
        $n=~s/=text=/$wwn/;

        $t="last_disk_in_slot_$p{'current_map'}\.$row\.$pos";
        $t=$p{$t};             # last disk

        $n=~s/=nr=/$p{'current_map'}\.$row\.$pos/;
        $n=~s/=prop=/$p{'current_map'}\.$row\.$pos/;
        $n=~s/=title=/There is currently no disk in this slot $p{'current_map'}\.$row\.$pos&#10;Shown is the disk that was previously assigned.&#10;$t&#10;&#10;Click on the disk to remove it from history./;
        $n=~s/white|black/red/;
        $wwn=$n;

        #&mess($n,'','abs');

        $prod="n.a.";
        $cap="n.a.";
        $question="";
        $alertimg="orange.png";

  }   else {      # if not member of a pool-> blue image
       $t=$p{$s};                 #WWN in Slot
       $t.="_vdev";
       if (($disk{$t} eq "") && ($p{$s} ne "")) {     # vdev of disk
          $act="greenb.png";      # not a poolmember
          $act_desc="not a pool member";
       }
       if ($p{$s} eq "") {  $act_desc="pool membership (no disk)"; }

       # &print_hash(%disk);
  }

  #dd detection
  $dd="<img src=\"/_doc/$alertimg\" title=\"bay empty/ history\">"; # default grey or orange

  if (($alertimg=~/grey/) && ($ins=~/blue/)) {    # allow dd
     if ($in{'list'} eq "dd") {
        $t="/cgi-bin/admin.pl?id=$in{'id'}\&l1=$in{'l1'}\&l2=$in{'l2'}\&l3=$in{'l3'}";
        if ($id eq $in{'prop'}) {   # this disk: dd
             $dd="<a href=\"$t\"><img src=\"/_doc/redb.png\" title=\"disk dd detection on\"></a>";
             #enable blink (sas2lib)  end of script
        } else {
             $dd="<a href=\"$t\"><img src=\"/_doc/$alertimg\" title=\"enable dd detection\"></a>"
        }

     } else {
        # create link
        $t="/cgi-bin/admin.pl?id=$in{'id'}\&l1=$in{'l1'}\&l2=$in{'l2'}\&l3=$in{'l3'}\&prop=$id\&list=dd";
        $dd=<<EoF;
        <a href="$t"><img src="/_doc/$alertimg" title="enable disk dd detection"></a>
EoF
    }
  }

  if ($part) {                   # disk has part, can be a member of several pools
        $act="orange.png";
        $act_desc="disk has partitions";
  }

  print <<EoF;
  <div id="$id" style="position: absolute; background-image: url($src/$brand/$bg); $idpos">

     <!-- WWN oder slot id -->
     <div id="id_$id" style="position: absolute; z-index: 100; $wwnpos">
$wwn
     </div>

     <div id="prod_$id" style="position: absolute; $prodpos">
$prod
     </div>

     <div id="cap_$id" style="position: absolute; $cappos">
$cap
     </div>

     <!-- iostat -->
     <div id="err_$id" style="position: absolute; color: $color; font-size:10px; $errpos">
$err
     </div>

     <!-- smart temp -->
     <div id="temp_$id" style="position: absolute; color: $color; font-size:10px; $temppos">
$temp
     </div>

     <!-- smart selftest -->
     <div id="temp_$id" style="position: absolute; color: $color; font-size:10px; $serrpos">
$smart
     </div>

     <!-- disk inserted -->
     <div id="inserted_$id" style="position: absolute; $insled">
        <img src="/_doc/$ins" title='disk inserted'>
     </div>

     <!-- disk member of vdev -->
     <div id="activity_$id" style="position: absolute; $actled">
        <img src="/_doc/$act" title="$act_desc">
     </div>


     <!-- disk alert/identify -->
     <div id="faulted_$id" style="position: absolute; $alertled">
        $dd
     </div>

     <!-- add comment -->
     <div id="comment_$id" style="position: absolute; z-index: 201; $editpos">
$edit_slot
     </div>

     <!-- show set link, currently no slot assigned -->
     <div id="no_$id" style="position: absolute; $setpos">
$question
     </div>

     <!-- calc next 3 row numbers from left -->
     <div id="reset_$row" style="position: absolute; left: -30px; top:36px">
$add
     </div>

     <!-- show reset link, del row -->
     <div id="reset_$row" style="position: absolute; left: $resetleft; top:36px; z-index:100">
$reset
     </div>

     <!-- slot id c2t0d0 -->
     <div id="slot_$id" style="position: absolute; $slotpos">
$slot
     </div>

     <!-- grey cover, no disk at this pos -->
     <div id="no_$id" style="position: absolute; left: 0; top:0; z-index:200">
$image
     </div>


  </div>
EoF



}


################### include smartvalues
sub my_read_smart {
###################

      my ($last,$diff,$disk1,$disk2);

      # accelerator
      if (-f "/tmp/nappit/smart_last.smart") {                 # last time get_disk-sas2 is called by napp-it (not aa)
         #
         open (F,"</tmp/nappit/smart_last.smart");
            flock(F, LOCK_EX);
            @t=<F>;
         close (F);

         $t=time;
         if ($t-$t[0] > 1200) {                              # acc files older 20 min
           `sudo rm /tmp/nappit/*.smart`;                    # too old, rm all ircu files
         }
      }

     ## read values
     if (-f "/tmp/nappit/smart_data.smart")  {

        #load smart_temp to %disk
        &read_ahfile("/tmp/nappit/smart_data.smart","disk","h+");

        #get disk'unused' from all disks,..
         &get_mydsk_stat;
     }

}


#################### a disk keeps known after a failure, delete id now
sub my_del_old_slot_id {
###################

     my ($t,$map,$row,$pos,@s,@p,$r,$slot);
     # prop        ->         '01.00.04'

     @p=split(/\./,$in{'prop'});
     $map=$p[0];
     $row=$p[1];
     $pos=$p[2];

     if (!($map>0))            { &mess("missing enclosure map number"); }
     if (!($row>=0))           { &mess("missing row number"); }
     if (!($pos>=0))           { &mess("missing pos number"); }

     #&print_array(@p);

     # read last id info
     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     ## delete old id
     $r="0";
     foreach my $l (@t) {        # rows
         if ($r == $row) {
            @s=();
            @s=split(/\t/,$l);   # positions 0..3 in line
            $s[$pos]="";         # del old id
            $l=join("\t",@s);    # write new row
            last;
         }
         $r++;
     }

    # &print_array(@t);
    #&print_hash(%in);
    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");

}

####################  a disk was selected and set is clicked: -> set this slotnumber
sub my_update_slots {
###################

#&print_hash(%in);

    my ($t,$map,$row,$pos,@s,@p,$r,$slot,$n);
    my $newslot=$in{'submit'};

    @p=split(/\./,$newslot);  # 01.03.06  (Map.Row.Pos)

    $map=$p[0];
    $row=$p[1];
    $pos=$p[2];

    if (!($map>0))                   { &mess("missing enclosure map number"); }
    if (!($row>=0))                  { &mess("missing row number"); }
    if (!($pos>=0))                  { &mess("missing pos number"); }
    if ($in{'radio_set_disk'} eq "") { &mess("Please select a disk first for that slot"); }

    my $id=$in{'radio_set_disk'};    # WWN c0t500..  oder port id like c1t0d0

    if (length($id)>15) {
         $t=$id."_slot";
         if ($disk{$t} eq "") {  &mess("no sas enclosure id like e1:c1:s3 for $id found"); }
         $slot=$disk{$t};        # sas slot ex e1:m3:s4
    } else {
         if (!($id=~/^c\d+/)) {  &mess("wrong id $id"); }
         $slot=$id;              # ex c2t0d0
    }

    # read slots
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_slot.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_slot.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     ## update slot, extend @n if needed
     $t=@t;
     if ($row >= $t) {
         $t=$row-$t;
         for (my $i=0;$i<=$t;$i++) { push (@t,"");  }
     }

     $r="0";
     foreach my $l (@t) {        # rows
         @p=();
         @p=split(/\t/,$l);      # give positions 0..n in line

         #insert slot
         if ($r == $row) {
            $p[$pos]=$slot;
         }
         $l=join("\t",@p);
         $r++;
     }

    #&mess("$map $row $pos");
    #&print_array(@t);

    # save slot info
    foreach my $t (@t) {
            $t.="\n";
    }
    &array2file("t","/var/web-gui/_log/maps/map$map\_slot.txt");

   # read last id info
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     # ex
     #                c3t2d0        c3t4d0
     # c1t5000CCA23DF2EEA4d0        c1t5000CCA24CE11EE1d0        c1t5000CCA22BC92D3Ed0        c1t5000CCA23DF2EB36d0
     # c1t5000CCA25DE157FFd0        c1t5000CCA22BD2C6B0d0        c1t5000CCA23DF220B8d0        c1t5000CCA22BD42E28d0


     ## extend lines/rows if needed
     $t=@t;
     if ($row >= $t) {
         $t=$row-$t;
         for (my $i=0;$i<=$t;$i++) { push (@t,"");  }
     }


     # update id/wwn
     for (my $i=0;$i<@t;$i++) {
         if (!($i == $row))     { next; }         # not my row

         @p=();
         @p=split(/\t/,$t[$i]);                   # positions 0..n in row
         $p[$pos]=$id;
         $t[$i]=join("\t",@p);
     }

# &mess($id);
#&print_array(@t);
#&print_hash(%in);
    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");

#&print_array(@t);
}


#############
sub my_calc_slots {
#############
my ($t,$map,$row,$pos,@s,@p,$r,$slot,@newslot,@newid,$i);

$t=$in{'submit'};
$t=~s/calcrow_//;
my @p=split(/\./,$t);

my $map=$p[0];
my $row=$p[1];

if (!($map>0))            { &mess("missing enclosure map number"); }
if (!($row>=0))           { &mess("missing row number"); }

#print "calc $map\:$row<br>";

# read slots
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_slot.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_slot.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     $r="0";

     foreach my $l (@t) {             # rows
         #calc row
         if ($r == $row) {            # calc nex 3
             $l=&my_calc_add("$l","$map");
             @newslot=split(/\t/,$l);
         }
         $r++;

     }

   # &mess($id);
   # &print_array(@t);

    # save slots
    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_slot.txt");

   # update id info
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     ## update id/wwn, extend @n if needed
     $t=@t;
     if ($row >= $t) {
         $t=$row-$t;
         for (my $i=0;$i<=$t;$i++) { push (@t,"");  }
     }

     $r="0";
     foreach my $l (@t) {        # rows
         @p=();
         @p=split(/\t/,$l);      # positions 0..3 in line
         if ($r == $row) {
            @newslot=();
            for (my $i=0;$i<@newslot;$i++) {
                if ($newslot[$i]=~/:/) {
                     $t=$newslot[$i]."_disk";
                     push(@newid,$disk{$t});
                } else {
                     push(@newid,$newslot[$i]);          # slot and id the same ex c1t1d0
                }
            }
            $l=join("\t",@newid);
         }
         $r++;
     }

    #&print_hash(%disk);
    #&print_array(@t);

    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");

}

###############
sub my_calc_add {
###############

# process a row and increase slot number of empty positions
my ($maxpos,$t,@s,$s,@slots,$pos,$last,$slot,$i,$q,@d,$calc);
my $row =$_[0];                              #ex 00.00
my $map=$_[1];                               #ex 01

@slots=split(/\t/,$row);

$t="map$map"."_cols";
my $cols=$p{$t};                             # ex 24

#debug
#&mess($cols);
#&print_hash(%p);

for ($q=0;$q<$cols;$q=($q+4)) {

    # calc only in blocks of 4 disks related to the first
    $slot=$slots[$q];
    if ($slot ne "")  {
         $last=$slots[$q];                        # next step 4 disks

         # add or sub for next 3
         if ($last=~/:/) {                        # c1:e1:s0
            @s=();
            @s=split(/:/,$last);
            $s[2]=~s/s//;
            if (($s[2] == 7) || ($s[2] == 3)) {   # q start with 7 or 3
                  $calc="sub";
            }  else {
                  $calc="add";
            }
         }
    } else {                                      # nothing when first q slot is empty
         next;
    }


    for (my $i=($q+1);$i<($q+4);$i++) {           # for next 3 disks
         $slot=$slots[$i];                        # next slot to calc
         if ($slot ne "")  {
             $last=$slots[$i];                    # next
             next;
         }

print "$q -> $i $calc from $last<br>";
         #
         if ($last=~/:/) {                        # c1:e1:s0
            @s=();
            @s=split(/:/,$last);
            $s[2]=~s/s//;

            if ($calc eq "add") {
               $s[2]++;
            } else {
               $s[2]--;                           # slot numbering 7,6,5,4
            }
            $s[2]="s$s[2]";                       # 1 -> s1
            $slots[$i]=join(":",@s);
            $last=$slots[$i];                     # new last

          } else {                                #ex  c1t0d0

            @s=();
            @s=split(/t/,$last);
            @p=split(/d/,$s[1]);

            #&print_array(@p);

            $p[0]++;                              # target nr ++                                  # when slot0=00
            $s[2]="s$s[2]";                       # s1 -> s2
            $slots[$i]=$s[0]."t".$p[0]."d".$p[1]; # ex c1t1d0
            $last=$slots[$i];                     # new last
          }
   }
}
$row=join("\t",@slots);

sleep(2);
#&print_array(@slots);
# &mess($row);

return($row);

}

#############
sub my_del_slots {
#############
my ($t,$map,$row,$pos,@s,@p,$r,$slot);

$t=$in{'submit'};
$t=~s/delrow_//;
my @p=split(/\./,$t);

my $map=$p[0];
my $row=$p[1];

if (!($map>0))            { &mess("missing enclosure map number"); }
if (!($row>=0))           { &mess("missing row number"); }


# read slots
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_slot.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_slot.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }
     #&print_array(@t);

     $r="0";
     foreach my $l (@t) {        # rows
         #remove rowi
         if ($r == $row) {
            $l="";
         }
         $r++;
     }

   # &mess($id);
    # &print_array(@t);

    # save slots
    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_slot.txt");

   # read last id info
    @t=();
    if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     ## update id/wwn, extend @n if needed
     $t=@t;
     if ($row >= $t) {
         $t=$row-$t;
         for (my $i=0;$i<=$t;$i++) { push (@t,"");  }
     }

     $r="0";
     foreach my $l (@t) {        # rows
         @p=();
         @p=split(/\t/,$l);      # positions 0..3 in line
         if ($r == $row) {
            $l="";
         }
         $r++;
     }

    #&print_array(@t);
    #&print_hash(%in);
    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");

}

####################  slot is edited, write form
sub my_write_edit {
###################
    my ($t,$map,$row,$pos,@s,@p,$r,$slot,$opt,$form,@last);

#&print_hash(%in);

    @p=split(/\./,$in{'prop'});                          # '01.12.00'
                                                         # map.row,pos
    $map=$p[0];
    $row=$p[1];
    $pos=$p[2];

    ################################## unassign ################################
    if ($in{'slot_action'} eq "unassign") {      # unassign a single dislk
            # read slotmap
            # read map slotinfo from config file /_log/maps/map1_slot.txt
            # each line is a row, slots are separated with \t

            @t=();
            if (-f "/var/web-gui/_log/maps/map$map\_slot.txt") {
               &read_ahfile("/var/web-gui/_log/maps/map$map\_slot.txt","t","b");
               foreach my $t (@t) { chomp ($t); }
               # &print_array(@t);

               for ($r=0;$r<@t;$r++) {
                       if (!($r==$row))  { next; }
                       @s=();
                       @s=split(/\t/,$t[$r]);                             # row with pos pos 0 ..n
                       for (my $p=0;$p<@s;$p++) {
                              if ($pos == $p) {
                                $s[$p]="";
                              }
                       }
                       $t[$r]=join("\t",@s);
               }

               foreach my $t (@t) { $t.="\n"; }
               &array2file("t","/var/web-gui/_log/maps/map$map\_slot.txt");


            }

            # read idtmap
            # read map slotinfo from config file /_log/maps/map1_id.txt
            # each line is a row, slots are separated with \t

            @t=();
            if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
               &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
               foreach my $t (@t) { chomp ($t); }
               # &print_array(@t);

               for ($r=0;$r<@t;$r++) {
                       @s=();
                       @s=split(/\t/,$t[$r]);                             # row with pos pos 0 ..n
                       for (my $p=0;$p<@s;$p++) {
                              if ($pos == $p) {
                                $s[$p]="";
                              }
                       }
                       $t[$r]=join("\t",@s);
               }

               foreach my $t (@t) { $t.="\n"; }
               &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");
            }

            $in{'action'}="";
            $in{'edited'}="";
            &reload;
    }

    if ($in{'slot_action'} eq "update") {      # allow edit last known disk
            # pos   # '01.12.00'    map, row , pos

            @t=();
            if (-f "/var/web-gui/_log/maps/map$map\_id.txt") {
               &read_ahfile("/var/web-gui/_log/maps/map$map\_id.txt","t","b");
               foreach my $t (@t) { chomp ($t); }
               # &print_array(@t);

               for ($r=0;$r<@t;$r++) {
                       if ($r == $row) {
                          @s=();
                          @s=split(/\t/,$t[$r]);                       # row with pos pos 0 ..n

                          # update  entry for a position in row
                          $s[$pos]=$in{'last'};                        # last is editable

                          $t[$r]=join("\t",@s);
                       }
               }

               foreach my $t (@t) { $t.="\n"; }
#&print_array(@t);
               &array2file("t","/var/web-gui/_log/maps/map$map\_id.txt");
            }
    }

    ################################ / unassign ###############################


    # 1. write slot type parameter
    ###################
    @t=();

    #$t="map$map"."_type";
    #$t[0]=$p{$t};              # keep maptype 3h (n x 3,5)
    $t[0]=$in{'type'};             # update layout type ex 3h

    $t="map$map"."_rows";
    $t[1]=$p{$t};              # keep rows

    $t="map$map"."_cols";
    $t[2]=$p{$t};              # keep cols

    $t="map$map"."_hide";
    $t[3]=$p{$t};              # old hide/cover

    if ($in{'slottype'} eq "cover") {
       # add when missing
       if (!($t[3]=~/$row\.$pos/)) {
           $t[3].=",$row\.$pos";
       }
    }  else {
       # remove when set
       if ($t[3]=~/$row\.$pos/) {
           $t[3]=~s/$row\.$pos\.*//;
       }
    }

    $t="map$map"."_nvme";
    $t[4]=$p{$t};              # old nvme

    if ($in{'slottype'} eq "nvme") {
       # add when missing
       if (!($t[4]=~/$row\.$pos/)) {
           $t[4].=",$row\.$pos";
       }
    }  else {
       # remove when set
       if ($t[4]=~/$row\.$pos/) {
           $t[4]=~s/$row\.$pos\.*//;
       }
    }

    $t[5]=$in{'header'};            # update header
    $t[6]=$in{'desc'};              # update descr
    $t[7]=$in{'brand'};             # update brand

#&print_array(@t);

    foreach my $t (@t) {
            $t.="\n";
            $t=~s/^,+//;
            $t=~s/,+$//;
             $t=~s/,+/,/g;
    }
    &array2file("t","/var/web-gui/_log/maps/map$map\_type.txt");


    # 1. write info
    ###################
    $in{'info'}=~s/\n/<n>/gs;
    $in{'info'}=~s/\r//gs;


   #############################################################################
   # read slotinfo
   #############################################################################
     @t=();
     if (-f "/var/web-gui/_log/maps/map$map\_info.txt") {
        &read_ahfile("/var/web-gui/_log/maps/map$map\_info.txt","t","b");
        foreach my $t (@t) { chomp ($t); }
     }

     ## update slot, extend @n if needed
     $t=@t;
     if ($row >= $t) {
         $t=$row-$t;
         for (my $i=0;$i<=$t;$i++) { push (@t,"");  }
     }

     my $r="0";
     foreach my $l (@t) {        # rows
         @p=();
         @p=split(/\t/,$l);      # positions 0..3 in line
         if ($r == $row) {
            $p[$pos]=$in{'info'};
         }
         $l=join("\t",@p);
         $r++;
     }

    #&print_hash(%disk);
    #&print_array(@t);

    foreach my $t (@t) { $t.="\n"; }
    &array2file("t","/var/web-gui/_log/maps/map$map\_info.txt");

    $in{'action'}="";
    $in{'edited'}="";
    &reload;

#&print_hash(%in);

}

####################  a disk was selected tp edit
sub my_edit_slot {
###################
    my ($t,$map,$row,$pos,@s,@p,$r,$slot,$opt,$form,$brand,$layout);

    @p=split(/\./,$in{'prop'});
                                                         # map.row,pos
    $map=$p[0];
    $row=$p[1];
    $pos=$p[2];

    #&print_array(@p);

    my $last="";
    $t="last_disk_in_slot_$map\.$row\.$pos";
    $last=$p{$t};

    my $type="disk";
    $t="map$map"."_nvme";
    if ($p{$t}=~/$row\.$pos/) { $type="nvme"; }            # disk is nvme

    $t="map$map"."_hide";
    if ($p{$t}=~/$row\.$pos/) { $type="cover"; }           # hide disk

    my $types="disk,nvme,cover";
    $t="map$map"."_type";
    $layout=$p{$t};                                        # ex 3h

    if (!($p{$t}=~/3/))       { $types="disk,cover"; }     # nvme req 3,5"

    my $info="";
    $t="info_of_slot_$map\.$row\.$pos";
    $info=$p{$t};
    $info=~s/<n>/\n/gs;

    $t="map$map"."_text";
    my $header=$p{$t};

    $t="map$map"."_desc";
    my $desc=$p{$t};

    $t="map$map"."_brand";
    my $brand=$p{$t};

    $form="<table><tr><td>\n";
    $form .="Slot&nbsp;&nbsp;</td><td style=\"padding-right: 20px\">". &select('slot_action','update,unassign','update')."</td><td>Update or unasisgn the slot";

    $form.="</td></tr><tr><td>";
    $form .="Brand&nbsp;&nbsp;</td><td style=\"padding-right: 20px\">". &select('brand',$p{'brands'},$brand)."</td><td>global brand";

    $form.="</td></tr><tr><td>";
    $form .="Layout&nbsp;&nbsp;</td><td style=\"padding-right: 20px\">". &select('type','3h,3v,2v',$layout)."</td><td>global layout";

    $form.="</td></tr><tr><td>";
    $form .="Header &nbsp;</td><td style=\"padding-right: 20px\"><input type=\"text\" name=\"header\" value=\"$header\" style=\"width: 250px\">  </td><td>global Header of a Map";

    $form.="</td></tr><tr><td>";
    $form .="Desc &nbsp;</td><td style=\"padding-right: 20px\"><input type=\"text\" name=\"desc\" value=\"$desc\" style=\"width: 250px\">  </td><td>global Map description";

    $form.="</td></tr><tr><td>";
    $form .="Last &nbsp;</td><td style=\"padding-right: 20px\"><input type=\"text\" name=\"last\" value=\"$last\" style=\"width: 250px\">  </td><td>Last known disk in slot (editable)";

    $form.="</td></tr><tr><td>";
    $form .="Bay&nbsp;&nbsp;</td><td style=\"padding-right: 20px\">". &select('slottype',$types,$type)."</td><td>Bay: disk, nvme or cover";

    $form.="</td></tr><tr><td>";
    $form .='Info &nbsp;</td><td style="padding-right: 20px">'       ."<textarea name=\"info\" style=\"width: 250px; margin-left: 0px; padding: 1px\" class=\"input\" wrap=\"off\">$info</textarea>"."</td><td>Infos about that slot";

    $form.="</td></tr></table><br>\n";

    $info=<<EoF;
<br>Edit global Map properties and infos about this slot or the disk within.
EoF
   $opt= "onclick=\"return(confirm('update map?'))\"";
   print &ask_pop("$form","$info","$opt");


   #  &print_hash(%in);
}

###############################################
#end of my script, do not delete the line below
1;
