# aclib2


############  user:123 -> winname:paul from %current and id2sid
sub uid2winname {
###########
   #
   my ($n,$g,@w);
   my $t=$_[0];
   my @t=split(/\n/,$t);

#&print_array(@t);
#&print_hash(%current);

   foreach my $t (@t)  {
      $t=~s/^ +//;
      if ($t=~/^user:\d+:|^group:\d+:/)  {
          @g=();
          @g=split(/:/,$t);
          $n="$g[0]".":$g[1]";
          if ($current{$n}=~/^win/) {
               @w=();
               @w=split(/::/,$current{$n});
               $g[0]=$w[0];
               $g[1]=$w[1];
               $t=join(":",@g);
          }
      }
   }
   $t=join("\n",@t);
   return($t);
}

############
sub id2sid {
############

# default SID:
# SID: S-1-1-0               Name: "Jeder, Everyone"
# SID: S-1-5-32-546          Name: Gste, Guests
# SID: S-1-5-32-545          Name: Benutzer, Users
# SID: S-1-5-32-547          Name: Hauptbenutzer, Power-User (Gruppe)
# SID: S-1-5-32-544          Name: Administratoren, Administrators

# SID: S-1-3-0               Name: Ersteller-Besitzer, Creator Owner
# SID: S-1-3-1               Name: Erstellergruppe, Creator Group
# SID: S-1-5-11              Name: Authentifizierte Benutzer, Authenticated Users  (Gruppe)

# SID: S-1-5-21-domain-501   Name: Gast, Guest
# SID: S-1-5-21-domain-500   Name: Administrator, Administrator
# SID: S-1-5-21-domain-512   Name: Domnen-Admins, Domain Admins (Gruppe)
# SID: S-1-5-21-domain-513   Name: Domnen-Benutzer, Domain Users (Gruppe)

# get values to %current
# user/group_'name'          get unix uid/gid from Windows name
# name_'user/group:id'       get Windows name from uid/gid      ex $current{'id_maeyer@xx.yy'} ->  uid:214748713

# name_'sid'                 get name from sid
# sid_'name'                 get sid from name

# sid_'id'                   get sid from unix id
# id_'sid'                   get unix id from sid

# possible names from
# local user or smb groups
# alreday available domain user and groups (ephemeral)
# from manual mapping via idmap



#####################################
# step 1: read idmap  sid == uid/gif
#####################################

   #read list
   my $dump=&exe('idmap dump','','acllib 1739');

   my @l=split(/\n/,$dump);
   my (@w,$k,$n,$r);
   foreach my $l (@l) {
       @w=();
       $l=~s/\s*=.\s*/==/;              # == or =>
       $l=~s/uid:/user:/;               # acl list is like user:2145678
       $l=~s/gid:/group:/;              # acl list is like group:2145679

       @w=split(/==/,$l);                 # usid:S-1...     == user:2345476
                                          # gsif:S-1-5-2    == group:2345657

       if ($w[1] ne "") {
          $current{$w[1]}="$w[2]";           # usid:S-123..    -> user:2147483876
       }
       if ($w[2] ne "") {
          $current{$w[2]}="$w[1]";           # user:2147483876 -> usid:S-123
       }
   }


#####################################
# step 2: read idmap  winname == uid/gid
#####################################
   #read list

   $dump=&exe('idmap dump -n','','acllib 1764');
   @l=();
   @l=split(/\n/,$dump);
   foreach my $l (@l) {
       @w=();
       $l=~s/\s*=.\s*/==/;               # == or =>

       $l=~s/uid:/user:/;                # acl list is like user:2145678
       $l=~s/gid:/group:/;               # acl list is like group:2145679

       @w=split(/==/,$l);                # winuser:aa@bb.cc  user:2345476 or without name:
                                         # usid:S-123..       user:234565

       $current{$w[1]}=$w[0];            # name_uid:2147483876 -> winuser:meyer@xx.dd.ee, without name:
                                         # name_uid:2147483876 -> usid:S-123..

       $current{$w[0]}=$w[1];            # winname-> id


       #mapping ex winuser:xyz == unixuser:root
       if ($w[1]=~/unix/) {
         $t= "map_$w[0]";
         $current{$t}=$w[1];
         $current{$t}=~s/unixuser:/u:/;
         $current{$t}=~s/unixgroup:/g:/;
       }


       # default sid
       if ($w[0]=~/sid:/) {

            # SID: S-1-5-21-domain-501   Name: Gast, Guest
            if ($current{$w[1]}=~/-501$/) { $current{$w[1]}=~s/:.*/:domain guests/; }

            # SID: S-1-5-21-domain-500   Name: Administrator, Administrator
            if ($current{$w[1]}=~/-500$/) { $current{$w[1]}=~s/:.*/:domain administrator/; }

            # SID: S-1-5-21-domain-512   Name: Domnen-Admins, Domain Admins (Gruppe)
            if ($current{$w[1]}=~/-512$/) { $current{$w[1]}=~s/:.*/:domain admins/; }

            # SID: S-1-5-21-domain-513   Name: Domnen-Benutzer, Domain Users (Gruppe)
            if ($current{$w[1]}=~/-513$/) { $current{$w[1]}=~s/:.*/:domain users/; }
       }
   }


   ##################################################
   #get clearnames for local smb groups from gid:1224
   ##################################################
   # defaults

            # SID: S-1-1-0               Name: "Jeder, Everyone"
            $current{'gsid:S-1-1-0'}="local everyone";

            # SID: S-1-5-32-546          Name: Gste, Guests
            $current{'gsid:S-1-5-32-546'}="local guests";

            # SID: S-1-5-32-545          Name: Benutzer, Users
            $current{'gsid:S-1-5-32-545'}="local users";

            # SID: S-1-5-32-547          Name: Hauptbenutzer, Power-User (Gruppe)
            $current{'gsid:S-1-5-32-547'}="local power users";

            # SID: S-1-5-32-544          Name: Administratoren, Administrators
            $current{'gsid:S-1-5-32-544'}="local administrators";

            # SID: S-1-5-32-551          Name: backup operators
            $current{'gsid:S-1-5-32-551'}="local backup operators";

            # SID: S-1-3-0               Name: Ersteller-Besitzer, Creator Owner
            $current{'usid:S-1-3-0'}="local creator owner";

            # SID: S-1-3-1               Name: Erstellergruppe, Creator Group
            $current{'gsid:S-1-3-1'}="local creator group";

            # SID: S-1-5-11              Name: Authentifizierte Benutzer, Authenticated Users  (Gruppe)
            $current{'gsid:S-1-5-11'}="local authenticated users";



            #

   my $smbadm=&exe('smbadm show','','acllib 1846');
   $smbadm=~s/\n\s+SID: //gs;
   @l=split(/\n/,$smbadm);

   foreach my $l (@l) {                # backup operators (Members can bypass file security to back up files)S-1-5-32-551
        $l=~s/ \(.*\)/:/;
        @w=();
        @w=split(/:/,$l);               # [0] -> 'administrators'
                                        # [1] -> 'S-1-5-32-544'

#&print_array(@w);

        $k="gsid:$w[1]";
        $current{$k}="local $w[0]";     # sid -> clear SMB name

        $k="local $w[0]";
        $current{$k}="gsid:$w[1]";     # clear SMB name -> sid

        if (!($current{'local_smb_groups'}=~/$w[0]/)) {
           $current{'local_smb_groups'}.="local $w[0],";
        }

   }
   $current{'local_smb_groups'}=~s/,$//;


  ####################################################
  # get local unix groups with a mapping to smb groups
  ####################################################
  $current{'local_mapped_groups'}="";
           $r=&exe('cat /etc/group','','acllib 1876');
           @l=split(/\n/,$r);

           $r=&exe('idmap list','','acllib 1879');
           foreach my $l (@l) {
                   @w=();
                   @w=split(/:/,$l);

                   # default mapping power users -> staff ??
                   if ($w[0] eq "staff") {
                       $current{'local_mapped_groups'}.="power users => staff,";
                       next;
                   }

                   if ($w[2] < 100)   { next; }          # root etc
                   if ($w[2] > 9999)  { next; }          # special

                   if ($r=~/wingroup:$w[0]\@BUILTIN.+unixgroup:$w[0]\b/is) {
                            $current{'local_mapped_groups'}.="$w[0] => $w[0],";
                   }
                   # mapping?


           }
           $current{'local_mapped_groups'}=~s/,$//;

  #&mess($smbadm);
  # mappings winuser -> unixuser
  #&print_hash(%current);

}


1;