#!/usr/bin/perl

## agent_acc.pl
## (c) Gnther Alka  2010-2017

## debug: start 'perl /path/agent_acc.pl disk' manually from console
## used for background GUI acceleration
## print of background tasks -> /tmp/crout...a
## disable all prints after debugging

#define global var and settings
       use strict;
       use vars qw($par $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t @t $f @f %data $D);

       $par=$ARGV[0];
       if (!(defined($par))) { $par=""; }
       if ($par eq "") { print "no agent given\n"; exit; }

use Fcntl qw(:flock);                                                    # filelocking
$|=1;

use strict;
use warnings;

#Debug=0/1
$D="0";

$t=`ps axw | grep agent_acc.pl | grep ' $par' | grep -v grep`;           # all agents ex for par = " zfs"
@t=split(/\n/,$t);

if ($par eq "disk") {                                                    # only one instance
     if (@t > 1) {
          print "disk acc is already running\n";
          exit;
     }
     &disk_acc;
}

if ($par eq "zfs") {                                                     # only one instance
     if (@t > 1) {
          print "zfs acc is already running\n$t\n";
          exit;
     }
     &zfs_acc;
}

if ($par eq "group") {                                                     # only one instance
     if (@t > 1) {
          print "group acc is already running\n$t\n";
          exit;
     }
     &group_acc;
}

if ($par eq "html") {                                                     # only one instance
     if (@t > 1) {
          print "group acc is already running\n$t\n";
          exit;
     }
     &html_refresh;                                                        # was agent-pages
}


#print "no valid acc given: disk,..\n";
exit;

# read exclusive
#  open (F,"<$log");
#        flock(F, LOCK_EX);
#        @data=<F>;
#  close (F);                                                                        # keine Pufferung, no buffering

# write ex
# open (PF, ">$log");
#    flock(PF, LOCK_EX);
#    print PF "$t";
#    print PF @data;
# close (PF);


############# group overview in grouplib
sub group_acc {
##############
   my ($t,$group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask,$host,$s,$z,$p,$count,$url2);

   while(1) {
    #
    #########################  part of acceleration see agent_acc.pl ###########

    $url2="_URL_type==type=\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm(\'=ask2=?\'))\"";

     #read list of groups-members
     $t="/var/web-gui/_log/group";
     @t=();

     # read group members
     opendir(DIR, $t);
          @t = readdir(DIR);
     closedir(DIR);

     @g=();
     push (@g,"<b>group-members</b>\t<b>ip</b> (klick to connect)\t<b>online</b>\t<b>napp-it version</b>\t<b>status</b>\t<b>option</b>");
     foreach $t (@t) {
                if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }                #np group member
                $t=~s/~/\t/; $t=~s/\.txt$//;
                push (@g," $t");
     }

    #list members from /_log/members -> ip.txt, content = napp-it key = login admin+ip -> return key
    #insert link to details

    foreach $t (@g) {
        @w=();
        @w=split(/\t/,$t);

        $n=$w[0]=~s/ +$//;                #no space at end

        if (!($w[1]=~/\d\./)) { next; }                #  ip


        # groupname -> link. show members (details) -> "prop"
        # +ZFS,SNAP.PID
        ################

                $host=$w[0]; $host=~s/\s//g;   # remove spaces
                $z=$url2;                       # for zfs list
                $s=$url2;                       # for snaplist
                $p=$url2;                       # for pslist
                $w[0]="<b>$host</b> ";

                ## ZFS, Snaps and Processes
                $z=~s/=text=/ZFS /;
                $z=~s/=list=/details/;
                $z=~s/=prop=/$host/;
                $z=~s/=action=/remote-details/;
                $z=~s/=type=/zfs/;
                $z=~s/=old=//;
                $z=~s/=ask=//;

                $s=~s/=text=/Snaps /;
                $s=~s/=list=/details/;
                $s=~s/=prop=/$host/;
                $s=~s/=action=/remote-details/;
                $s=~s/=type=/snapshot/;
                $s=~s/=old=//;
                $s=~s/=ask=//;

                $p=~s/=text=/Pid /;
                $p=~s/=list=/details/;
                $p=~s/=prop=/$host/;
                $p=~s/=action=/remote-details/;
                $p=~s/=type=/ps/;
                $p=~s/=old=//;
                $p=~s/=ask=//;
                $w[0].="( $z / $s / $p)";

        #online and status
                #ping it
                #  $r=&exe("ping $w[1] -w 1");                                     # on Linux

                #$r=&exe("ping $w[1] 1");  #timeout 1
                $r=`/usr/sbin/ping $w[1] 1`;  #timeout 1                         # use this in acc-script

                if ($r=~/alive|icmp/s) { $w[2]="ok"; } else {  $w[2]="offline"; }  # icmp on Linux

                if ($w[2] eq "ok") {

                        #connect via netcat on port $sys{'port'} (81)
                        $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc -w 5 $w[1] 81`;
                        if ($r eq "")                         {
                                                    $w[3]="<font color='red'>remote call: timeout</font>";
                          } else {
                                                    if ($r=~/refused/s)    { $w[3]="webserver: no"; }
                                                    if ($r=~/napp-it-ok:/s)  {
                                                          $w[3]=$r;
                                                          $w[3]=~s/.*napp-it-ok://s;
                                                          $w[3]=~s/: command not found//s;
                                                    }  else {
                                                          $w[3]="not a napp-it server";
                                                          $w[0]= $host;
                                                    }
                         }
                }  else {
                       $w[3]="-"; $w[0]=" $host";
                }

       # 4 delete member
               if ($w[1]=~/\d+\.\d+\.\d+\.\d+/) {
                        $n="delete";
                        $w[4]=$url2;
                        $w[4]=~s/=text=/$n/;
                        $w[4]=~s/=action=/del-nasgroupmember/;
                        $w[4]=~s/=old=/$host\~$w[1]"/;
                        $w[4]=~s/=ask=/$ask/;
                        $w[4]=~s/=ask2=/delete group-member $host ?/;
                        $w[4]=~s/=list=//;
                        $w[4]=~s/=prop=//;
                        $count++;

                        # no link with 127.0.0.1
                        if ($w[1] eq "127.0.0.1")  { $w[4]="-"; }
                }



        #ip. last item to keep ip
                $n=$w[1];                                                #ip
                $w[1]="<a target=\"_blank\" href=\"http://$n:81/cgi-bin/admin.pl\">$n</a>";

                # no link with 127.0.0.1
                if ($n eq "127.0.0.1")  {$w[1]="127.0.0.1 localhost"; }



       $t=join("\t",@w);
       #$t.="\n";
    }

    ## / acceleration in grouplib
    #########################################################

    $t=time();
    $r=join("\n",@g);
    open (PF, ">/tmp/acc-group.log");
               flock(PF, LOCK_EX);
               print PF "$t\n";
               print PF $r;
     close (PF);

     &acc_pause("group");    # pause depending on napp-it access
   }
}


#############       # pool-status does the same bit acc is priority
sub zfs_acc {
#############
   my $r="";
   my ($t);
   while(1) {
              $r=`/usr/sbin/zpool status`;
              $t=time();
              open (PF, ">/tmp/poolstat.log");
                        flock(PF, LOCK_EX);
                        print PF "$t\n";
                        print PF "$r";
              close (PF);

              #add zfsstat
              # NAME                                             TYPE        CREATION                USED  AVAIL  REFER ..
              $r=`/usr/sbin/zfs list -o all`;
              $r=&parse_mydate($r);

 #print "zfs acc 242 $r\n";

              $t=time();
              open (PF, ">/tmp/zfsstat.log");
                        flock(PF, LOCK_EX);
                        print PF "$t\n";
                        print PF "$r";
              close (PF);

              $r=`/usr/sbin/zfs list -H -r -t snapshot -o name,creation,used,avail,refer -S creation`;   # default newest first
              #$r=`/usr/sbin/zfs list -o all`;     # NAME                                             TYPE        CREATION                USED  AVAIL  REFER ..
              $r=&parse_mydate($r);                # Dez 1 -> Dez 01
              $t=time();
              open (PF, ">/tmp/acc-snap.log");
                        flock(PF, LOCK_EX);
                        print PF "$t\n";
                        print PF "$r";
              close (PF);

              &acc_pause("zfs");    # pause depending on napp-it access

              # debug
 #print "zfs acc 263 $t\n";
   }
}


############
sub disk_acc {
############

   my $r="";
   my $f="parted";
   while(1) {

     # print "hello\n";
     #use format to check disks
     if (-f "/var/web-gui/_log/partitions.enabled") {
         $r=`/usr/sbin/parted -lm`;
         if (!($r=~/\/dev\/dsk/s)) { $r=""; }
     } else {
         $f="format";
         $r=`echo | /usr/sbin/format`;
         if (!($r=~/AVAILABLE/s)) { $r=""; }
     }

     #write log
     my $t=time();
     if ($r ne "") {
        open (PF, ">/tmp/acc-$f.log");
           flock(PF, LOCK_EX);
           print PF "$t\n";
           print PF $r;
        close (PF);
     }

     &acc_pause("disk");   # pause depending on napp-it access
   }
}


############ # former agent-pages
sub html_refresh {
############

  # /cgi-bin/monitor-lib sends a request like l1_id.req_htm ex 15_admin,14566734.req_htm
  # this script deletes the request and creates 15_14566734.htm
  # /cgi-bin/monitor-lib updates the htm via ajax and deletes the .htm
  # /cgi-bin/monitor-lib sends a new request like l1_id.req ex 15_14566734.req
  # this script also deletes .htm older 30s

  my ($id,$l1,$pagenr,$time);

  while(1) {

     # step1, read  /tmp/nappit/ for .req_htm and .htm
     $time=time();
     @t=();


     &my_read_dir('/tmp/nappit/','t','htm$');      # .htm and req_htm

     # optional delete old htm
     &html_del_old;

     foreach my $t (@t) {
        chomp($t);
        if ($t=~/\.req_htm$/) {
                 &html_write_new("$t");
                 next;
        }

     }
     sleep(2);


  } #/while
}

############ check for pagefiles older 10s
sub html_write_new {
############

  #
     my $file=$_[0];
     $file="/tmp/nappit/$file";
     #print "new filename $file\n\n";

     #read request exclusive time, id, l1, l2, l3 per line
     @f=();

     open (F,"<$file");
        flock(F, LOCK_EX);
        @f=<F>;
     close (F);

     ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
     $mon++;
     if ($sec < 10)  { $sec  = "0$sec";  }
     if ($min < 10)  { $min  = "0$min";  }
     if ($hour < 10) { $hour = "0$hour"; }
     if ($mday < 10) { $mday = "0$mday"; }
     if ($mon < 10)  { $mon  = "0$mon";  }
     $year=1900+$year;
     my $time=time();

     # req too old
     if ($f[0]=~/time: \d+/) {
         $f[0]=~s/time: //;
         if ($time-$f[0] > 10) {
             unlink("$file");
if ($D) { print "unlink old req $file\n\n"; }
             return;
         }
     }

     my $id=$f[1];  chomp($id);
     my $l1=$f[2];  chomp($l1);
     my $l2=$f[3];  chomp($l2);
     my $l3=$f[4];  chomp($l3);

     ## 'cli=1::id=xx yy::l1=abc::...'
     my $r=`/usr/bin/perl /var/web-gui/data/wwwroot/cgi-bin/admin.pl \"cli=1::id=$id\::l1=$l1\::l2=$l2\::l3=$l3\"`;

#print "$r\n";
#exit;

     #login form
     if ($r=~/form name=\"login\"/s ) {
             unlink("$file");
if ($D) { print "unlink req loginform from $file\n\n"; }
             return;
     }

     #remove </body>  and header
     $r=~s/.*<body>//s;
     $r=~s/<\/body>//gs;
     $r=~s/<\/html>//gs;

     #debug
     # print "#### $r\n";


     #<!--wscontent--> =whole page or <!--wsarea--> = area with div=wsarea
     if (($r=~/<!\-\-wsarea\-\->/) && ($r=~/<!\-\-wsarea_end\-\->/s)) {
        $r=~s/.*<!\-\-wsarea\-\->//s;
        $r=~s/<!\-\-wsarea_end\-\->.*//s;
        $r="<!--wsarea-->$r\n<!--wsarea_end-->\n";
     } else {
        if ($r=~/<!\-\-wscontent\-\->/s) {
              $r=~s/.*<!\-\-wscontent\-\->/<!--wscontent-->/s;
        } else {
              # debug only
              # wscontent missing in page\n";

              #nothing todo
              if ($D) { print "no wscontent in $file\n"; }
              unlink("$file");  # unlink request
              return;

        }
     }

     # add time to #hl
     $r.=<<EoF;

       <script type="text/javascript">
         \$("#minilog").append("reload $hour\:$min $sec s");
         \$("#minilog").animate({opacity: 'hide'}, 'slow');
       </script>
EoF


     #add timestamp
     $r.="<div style='z-index: 10; position: absolute; top: 150px; width: 99%; font-size:8px;color:#666666; margin:10px 30px 0 0; text-align:right'>update $hour:$min $sec s </div><!--time-->$time";

     #log file to /tmp/page_id
     if (!($r=~/<!\-\-nows\-\->/s)) {          # skip realtime update (ex pop-windows open)

       $t=$file; $t=~s/\.req_htm/.htm/;
       if ($D) { print "create $t\n"; }
       open (F,">$t");                        # ex 15_admin,875438.htm
          flock(F, LOCK_EX);
          print F "time: $time\n";             # first line: timestamp
          print F "$r";
       close (F);
     } else {
        # debug
        if ($D) {  print "nows missing in request for $file\n";   }
     }


    # delete this request
    if ($D) { print "del after create $file\n";   }
    unlink("$file");

    #exit;
}


############ check for pagefiles older 10s
sub html_del_old {
############
  my (@data,$r);
  my $time=time();

  # &my_read_dir('/tmp/nappit/','t','htm$');      # from main

  foreach my $t (@t) {
      chomp($t);

      if (!($t=~/\.htm$/)) { next; }              #.htm only

      #read
      open (F,"</tmp/nappit/$t");
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);
      if ($data[0]=~/^time: \d+/) {
         $data[0]=~s/time: //;
         if ($time-$data[0] > 10) { unlink("/tmp/nappit/$t"); }
      }
  }
}

############
sub my_read_dir { # &read_dir("dir","arrayname","Muster","Zeilennr")
############ directory lesen ergebnis in array "arrayname" (files+directories!!) oder Muster=/
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;

 local (*F);
 if ($par[0] eq "") { &CgiDie("(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])"); }
 if ($par[1] eq "") { &CgiDie("(lib-562 read_dir: $par[2]) Programmfehler: Es wurde kein Array angegeben (ref $_[3])"); }
 if (!(-d $par[0])) { &CgiDie("(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[3])"); }

 opendir(F, $par[0]) || &CgiDie("(lib-564 read_dir: $par[2]) Programmfehler: Verzeichnis $par[0] gesperrt");
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file"; if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[2]=~/\./) {        #.xxx
                if ($file=~/$par[2]$/) {  push (@t,$file); }
        } else {
                if ($file=~/$par[2]/)  {  push (@t,$file); }
        }
 }
 closedir(F);
 return;
}



############# call this for pause between running of system calls
sub acc_pause {
#############
    my $acc=$_[0];
    my ($m,$l,$t,$s);


    #run as long a sacc or mon is acrive !!
    sleep(10);
    return;

    #or
    # reload accelerator
    # wait 30s when last general access to napp-it is no older than 20min
    # wait 6s when the affected menu is accessed within the last 5 min
    # otherwise wait 1h

    while (1) {
       # check current accel

       # 6 times current menu, every 6s within 300s
       sleep(6);                                                                  # wait 6s always
       $s=&get_last_access($acc);  if ($s < 300) { return; }  sleep(6);           # wait 6s
       $s=&get_last_access($acc);  if ($s < 300) { return; }  sleep(6);           # wait 6s
       $s=&get_last_access($acc);  if ($s < 300) { return; }  sleep(6);           # wait 6s
       $s=&get_last_access($acc);  if ($s < 300) { return; }  sleep(6);           # wait 6s


       # global access reload after 36s
       $s=&get_last_access('-');
       if ($s < 600) {                               # last access newer 10min
            return;
       } else {
            if ($s > 3600) {  return; }              # last access older 1h
       }
    }
}


##
sub parse_mydate { # ex  Jan  1:18 -> Jan 01:18 or  Tue  1  -> Tue 01 ex in zfs creation
#############
  my $s=$_[0];
  my @m=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  for (my $i=0;$i<=9; $i++) { $s=~s/  $i:/ 0$i:/gs; }
  foreach my $m (@m) {  for (my $i=1;$i<=9; $i++) { $s=~s/ $m  $i / $m 0$i /gs; }  }
  return($s);
}

############### read zfs and snap log and return larger file
sub get_zfs_snap_larger {
###############
    my @data;
    my $z="0";
    my $s="0";
    if (-f "/tmp/nappit/menue-07.log") {
      open (F,"</tmp/nappit/menue-07.log");               # zfs
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);
      if ($data[0] > 0)  { $z=$data[0]; }
    }
    @data=();
    if (-f "/tmp/nappit/menue-08.log") {
      open (F,"</tmp/nappit/menue-08.log");               # snap
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);
      if ($data[0] > 0)  { $s=$data[0]; }
    }
    if ($s > $z) {
         return ("/tmp/nappit/menue-08.log");             # snap
    } else {
         return ("/tmp/nappit/menue-07.log");             # zfs
    }

}

###############   sek since last last acces to napp-it or napp-it menu
sub get_last_access  {
###############
   my $t=time();
   my $acc=$_[0];           #accelerator like disk, zfs
   my $log="/tmp/nappit/menue-last.log";
   if ($acc eq "disk")   { $log="/tmp/nappit/menue-05.log"; }   # disk is menu 05
   if ($acc eq "zfs")    { $log=&get_zfs_snap_larger; }         # zfs  is menu 07, snap is menu 08
   if ($acc eq "group")  { $log="/tmp/nappit/menue-20.log"; } # extension is menu 20

   if (-f "$log") {
     open (F,"<$log");
        flock(F, LOCK_EX);
        my @data=<F>;
     close (F);
     if ($data[0] > 0) { $data[0]=~s/\D//g; }                   # time of last access
     my $d=$t-$data[0];                                         # difference in s

     # debug only (prints to /tmp in background)
     # print "$log - > $d\n";

     return ($d);
   } else {
     return (3600);                                              # max time 3600/1h
   }
}

sub getmydate {                # setzt datumsvariablen
###########
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10)  { $sec = "0$sec"; }
 if ($min < 10)  { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10)  { $mon = "0$mon"; }
 $year=1900+$year;
 $date_and_time = "$mday\.$mon\.$year, $hour:$min $sec s";
 $date = "$mday\.$mon\.$year";
 $date_us= "$mon\.$mday\.$year";
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}

###############################################
#end of my script, do not delete the line below
1;
