#!
# (c) Guenther Alka, oct 04 2019
# lib for zraid SSF functions

use strict;         # check for proper code

# this lib is called by
# z-raid menu and zraid/setting
# grouplib
# agent-bootinit (my_zlib_bootup)

##############


###  called by menus and acc
sub get_state {
##
     require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/grouplib.pl";

     my $action=$_[0];
     my $ip=$_[1];
     my $ref=$_[2];                 # ex h1
     my ($k,@w,$w,$p);

#debug
#$ip="172.16.16.28";
#$ref="h1";

     # get state
     $p{'netaction'}=$action;    # ex "get_cl_control_state";
     $p{'netdata'}="";

# accelerator
# acc: del old files

     if (!( $current{'callby.acc'} )) {                      # sub called by accelerator
        if (-f "/tmp/nappit/cluster_last.clu") {              # last time this is called by napp-it (not aa)
           #
           open (F,"</tmp/nappit/cluster_last.clu");
              flock(F, LOCK_EX);
              @t=<F>;
           close (F);

           $t=time;
           if ($t-$t[0] > 1200) {                              # acc files older 20 min
             `sudo rm /tmp/nappit/*.clu`;                      # too old, rm all ircu files
           }
        }

        if ($current{'callby.acc'}) {
           print "866 action.pl delete old\n\n";
        } #debug
     }

     # update accelerator
     if ((-f "/tmp/nappit/cluster_$ref.clu") && (!($current{'callby.acc'})) )  {
        if ($current{'callby.acc'}) { print "read cluster_$ref.clu\n"; }

         open (F,"</tmp/nappit/cluster_$ref.clu");
              flock(F, LOCK_EX);
              @t=<F>;
         close (F);
         $p=join("",@t);

         if ($current{'callby.acc'}) {
           print "858 action.pl load from disk: $p\n\n";
         } #debug

         &exe("cat /tmp/nappit/cluster_$ref.clu");                   #log
         $current{'acc_mess'}=" acc";

     } else {

         $p=&grouplib_ask_remote_zraid($ip,'','get_state 528');
         if ($current{'callby.acc'}) {                                           # sub called by accelerator
                     open (PF, ">/tmp/nappit/cluster_$ref.clu");
                           flock(PF, LOCK_EX);
                           print PF "$p";
                     close (PF);
         }

         if ($current{'callby.acc'}) {
           print "875 action.pl load remote $ref $ip: $p\n\n";
         } #debug
     }


     my @v=split(/;/,$p);


#debug
#if ($current{'callby.acc'}) { print "-- 849: $p\n\n";  }




#&print_hash(%p);
#&print_array(@v);

     if (!($p=~/hostname=/)) {
       $k="$ref\_hostname";
       $p{$k}="<font style='color:red'>Group problem</font>";
     }

     foreach my $v (@v) {
          @w=split(/=/,$v);

          $k="$ref"."_$w[0]";
          $p{$k}=$w[1];                # ex c1_hostname=server1

          #ha_ip on head1/1
          if ($w[0] eq "ifconfig") {
             #h1
             if ($p{'ha_heads'} eq "") { $p{'ha_heads'}="0"; }
             if ($ref eq "h1") {
               if (($w[1]=~/$p{'value_ip_ha'}/) && ($p{'value_ip_ha'}=~/\d+\./)) { $p{'head_ha_ip'}="h1"; }
               $p{'ha_heads'}++;
             }
             #h2
             if ($ref eq "h2") {
               if (($w[1]=~/$p{'value_ip_ha'}/) && ($p{'value_ip_ha'}=~/\d+\./)) { $p{'head_ha_ip'}="h2"; }
               $p{'ha_heads'}++;
             }
          }

          #z-raid on head1/1
          if ($w[0] eq "zlist") {
             #
             if ($p{'zraid_heads'} eq "") { $p{'zraid_heads'}="0";  }

             #h1
             if ($ref eq "h1") {
               if ($w[1]=~/zraid/)  {
                    $p{'h1_zraid_mounted'}="1";
                    $p{'zraid_heads'}++;
               }

             }

             #h2
             if ($ref eq "h2") {
               if ($w[1]=~/zraid/)  {
                    $p{'h2_zraid_mounted'}="1";
                    $p{'zraid_heads'}++;
               }
             }
          }
     }

     #debug
     #&print_hash(%p);
     #&print_array(@v);
     #&mess($p);

     return(@v);
}


###################
sub my_get_state {                  # called by manual failover
###################
     my $action=$_[0];
     my $ip=$_[1];
     my $ref=$_[2];                 # ex h1
     my $autolog=$_[3];             # 1 if called by agent

     my ($k,@w,$w);

     # get state
     $p{'netaction'}=$action;       # ex "get_cl_control_state";
     if ($action ne "sync_cluster_user") {  # userrange
        $p{'netdata'}="";
     }

     my $p=&grouplib_ask_remote_zraid($ip,'','my_get_state 528','',$autolog);

     if ($autolog eq "1") {
       &my_zlog("clusterlib log: ask remote zraid $ip $action $ref\: $p");
     }

     my @v=split(/;/,$p);

     if (!($p=~/hostname=/)) {
       $k="$ref\_hostname";
       $p{$k}="<font style='color:red'>Group problem</font>";
     }

     foreach my $v (@v) {
          @w=split(/=/,$v);
          $k="$ref"."_$w[0]";
          $p{$k}=$w[1];                # ex c1_hostname=server1
     }

     #debug
     #return("$action: $p");
     #&print_hash(%p);
     #&print_array(@v);
     #&mess($p);

     if ($action eq "sync_cluster_user")    { return($p); }
     if ($action eq "sync_cluster_comstar") { return($p); }

     return(@v);

}

############# read zraid settings -> %p
sub my_read_settings {
#############
     my @t=();                                                     # public @t
     my ($k,$v,@w,$w,$t);

     if (-f "/var/web-gui/_log/cluster/settings.txt") {
        open (F,"</var/web-gui/_log/cluster/settings.txt");
           flock(F, LOCK_EX);
           @t=<F>;
        close (F);
        foreach my $t (@t) {
                chomp ($t);
                @w=();
                @w=split(/ : /,$t);    # key : value

                $w="$w[0]";
                $p{$w}=$w[1];

                # check stonith on c2 is same as on cs1
                if ($w eq "value_cs1")  { $p{'value_cs2'}=$w[1];  }
                if ($w eq "value_rcs1") { $p{'value_rcs2'}=$w[1];  }
        }
     }
     #failover
     if (-f "/var/web-gui/_log/cluster/failover.txt") {
        open (F,"</var/web-gui/_log/cluster/failover.txt");
           flock(F, LOCK_EX);
           @t=<F>;
        close (F);
        foreach my $t (@t) {
                chomp ($t);
                @w=();
                @w=split(/ : /,$t);    # key : value

                $w="$w[0]";
                $p{$w}=$w[1];
        }
     }
}


#########    man log
sub my_log {
########
  my (@data,$log,$t,$info);
  my $info=$_[0];        # log text

  $log="/var/web-gui/_log/cluster/manual.log";                                      # $path = path to ../napp-it/_log/
  &getdate();
#return;
  #log newest at top
  ###################
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$sys{'date_all'}\: $info\n");

  if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);
 return;
}

############   auto log
sub my_zlog {
############
my (@data);
my $log="/var/web-gui/_log/cluster/auto.log";

  if ($p{'lastlog'} eq $_[0]) { return; }  # do not log twice

  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift
  #$t=time();

  &getdate;
  unshift(@data,"$sys{'date_all'}\: $_[0]\n");

  if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);                 # delete from 50+
  }

  $t=join("",@data);
  open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
  close (PF);

  $p{'lastlog'}=$_[0];

}

###############################################
#end of my script, do not delete the line below
1;
