#!/usr/bin/perl
#(c) napp-it 2012-2019

 #########
sub comstarlib {  #5.02.2019
###########################
}

#feb 2019 comlib_list_p

#########################
##    1. logical units
#########################

#########
sub iscsi_lib {  #05.02.2019
###########################
}

#################
sub comlib_list_p {
#################   z.B. itadm list-target -v
      #TARGET NAME                                                  STATE    SESSIONS
      #iqn.2010-09.org.zfs-san:1549387676                           online   0
      #        alias:                      solaris114
      #        auth:                       none
      #        targetchapuser:             -
      #        targetchapsecret:           unset
      #        tpg-tags:                   default
      #iqn.2010-09.org.zfs-san:1549386939                           online   0
      #        alias:                      solaris114
      #        auth:                       none
      #        targetchapuser:             -
      #        targetchapsecret:           unset
      #        tpg-tags:                   default

      # for same output like OmniOS itadm list-target -pv
      # iqn.2010-09.org.zfs-san:1549355801      online  0       h2      none    -       unset   default
      # iqn.2010-09.org.zfs-san:1549029133      online  0       h2      chap    -       set     default


      my $t=$_[0];
      my @l=split(/\n/,$t);
      my $r="";
      for (my $i=0; $i<@l; $i++) {
          if ($l[$i]=~/^[A-Z]+/)     { next; }                       # skip HEADER

          if ($l[$i]=~/^[a-z]+/)     {     # new main value iqn...
               $l[$i]=~s/\s+$//;           # end of string
               $l[$i]=~s/\s\s+/\t/g;       # spaces = tab
               $r=~s/\(nl\)/\n/gs;         # last nl
               $r.="$l[$i](nl)";
               next;
          }   # ex target per line


          if ($l[$i]=~/:\s+/) {
               $l[$i]=~s/^\s+//;
               $l[$i]=~s/^.*:\s+//;          # ex none
               $r=~s/\(nl\)/\t$l[$i](nl)/;   # add to line of iqn prior nl
          }
      }
      $r=~s/^\n//s;
      $r=~s/\(nl\)/\n/gs;

      #sort
      @l=();
      @l=split(/\n/,$r);
      @l=sort(@l);
      $r=join("\n",@l);

      #debug
      #$r=~s/\t/ -> /gs;
      #&mess($r);
      #&print_var($r);
      #exit;

      return($r);
}


#####################
sub comstarlib_lu_details {       #hide: ask for property, return list
#####################
    my $r=&exe("stmfadm list-lu -v $in{'zfs'}","","comstarlib 22");
    $r=~s/LU Name:/<b>LU NAME:/s;
    $r=~s/\n/<\/b><hr>/s;
    print "<pre>$r</pre>";
}


#####################
sub comstarlib_lu_overview {       #hide: ask for property, return list
#####################
   my ($l,$r,$t,$out,$lu,$h,$s);

   #change zfs property
   if ($in{'answered'}) { &comstarlib_change_property; }


   $r=&exe("stmfadm list-lu -v","","comstarlib 38");

   if ($r eq "") {
        $r="-none-";
   } else {

        #url
        my $url="<a class=\"=style=\" href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;zfs==zfs=\&amp;prop==prop=\&amp;prop2==prop2=\&amp;old==old=\">=text=</a>";

        #editable not in overview
        if ($in{'l2'} eq "") { $url="=text="; }

        @l=split(/\n/,$r);


        foreach $l (@l) {

                $z=$l;
                $z=~s/^\s+//;

                if ($l=~/^LU Name/) {
                     $h="LU\t";                    # first menu item

                     $lu=$l;
                     $lu=~s/.*: //;

                      $z=~s/.*: //;
                      $t=$url;                    # value
                      $t=~s/=old=/$z/;
                      $t=~s/=text=/$z/;
                      $t=~s/=prop=//;
                      $t=~s/=zfs=/$lu/;
                      $t=~s/=list=/yes/;
                      $out.=$t."\t";
                      $s="0";                     # to skip unregistered
                      next;
                }

                if ($l=~/Status/) {               # Operational Status
                   $h.="Status\t";
                   $z=~s/\n//;
                   $z=~s/.*: //;
                   $out.=$z."\t";
                   if ($z=~/unregistered/) { $s="1"; $out.="\n"; } else { $s="0"; } # to skip unregistered
                   next;
                }

                if ($s) { next; }

                if ($z=~/Alias/)   {              # Aliasname
                      $h.="Alias\t";
                      $z=~s/.*: //;
                      $t=$url;                    # value
                      $t=~s/=old=/$z/;
                      $t=~s/=text=/$z/;
                      $t=~s/=prop=/alias/;
                      $t=~s/=zfs=/$lu/;
                      $out.=$t."\t";
                      next;
                }

                if ($l=~/View/) {               # View
                   $h.="Views\t";
                   $z=~s/\n//;
                   $z=~s/.*: //;
                   $out.=$z."\t";
                   next;
                }

                if ($l=~/Data/) {               # Data File
                   $h.="Datafile\t";
                   $z=~s/\n//;
                   $z=~s/.*: //;
                   $out.=$z."\t";
                   next;
                }

                if ($z=~/^Size/)   {          # Size
                          $h.="max Size dec\t";
                          $z=~s/.*: //;
                          $z=~s/\s//g;

                          $z=&b_convert("$z","","1s");
                          #$z=&comstarlib_val2MGT($z);

                          $out.=$z."\t";

                          $h.="max Size bin\t";
                          $z=~s/.*: //;
                          $z=~s/\s//g;

                          $z=&b_convert("$z","","1is");
                          #$z=&comstarlib_val2MGT($z);

                          $out.=$z."\t";


                          next;
                }

                if ($l=~/Write Protect/i) {               # Data File
                   $h.="Write Protect\t";
                   $z=~s/\n//;
                   $z=~s/.*: //;
                   $out.=$z."\t";
                   next;
                }

                if ($z=~/Writeback/)   {      # Writeback Cache
                      $h.="Writeback Cache\t";
                      $z=~s/.*: //;
                      $t=$url;                    # value
                      $t=~s/=old=/$z/;
                      $t=~s/=text=/$z/;
                      $t=~s/=prop=/wcd/;
                      $t=~s/=zfs=/$lu/;
                      $out.=$t."\t";
                      next;
                }


                if ($l=~/Access State/) {  # last entry ol LU, next LU
                   $h.="Access State\t";
                   $z=~s/\n//;
                   $z=~s/.*: //;
                   $out.=$z."\n";
                   next;
                }

               #otherwise
                next;


        } # end for
        $h=~s/\t$//;
        #$pre="<B>LU<\B>"."\t"."<B>Status<\B>"."\t"."<B>Provider<\B>"."\t"."<B>Alias<\B>"."\t"."<B>Views<\B>"."\t"."<B>Data File<\B>"."\t"."<B>Meta File<\B>"."\t"."<B>maxSize<\B>"."\t"."<B>Block<\B>"."\t"."<B>Mgmt URL<\B>"."\t"."<B>Vendor<\B>"."\t"."\t"."<B>Prod ID<\B>"."\t"."\t"."<B>Serial Num<\B>"."\t"."<B>Wr.Protect<\B>"."\t"."<B>Wrb cache<\B>"."\t"."<B>Access<\B>"."\t"."\n";
  }

   if ($h eq "") { $h="-none-"; $n="Local LU";}
   print &list2table("$h\n$out","100%,210px,100px");
   print "<br>\n";

   #ask property
   if (($in{'prop'} ne "") && ($in{'answered'} ne "1")) { print &comstarlib_ask_property; }

   #show details
   if (($in{'list'} eq "yes") && ($in{'zfs'} ne "")) { &comstarlib_lu_details; }
}

sub comstarlib_val2MGT {
#########################
     my $val=$_[0];         # in KB
     $val=~s/\D//g;
     $val=sprintf ("%.0f", $val);
     if (!($val > 0))   { return ("0");  }

     # EB
     if ($val > 1000000000000000000) {
          $val=$val/1000000000000000000;
          $val=sprintf ("%.1f", $val);
          return ("$val EB");
     }

     # PB
     if ($val > 1000000000000000) {
          $val=$val/1000000000000000;
          $val=sprintf ("%.1f", $val);
          return ("$val PB");
     }

     # TB
     if ($val > 1000000000000) {
          $val=$val/1000000000000;
          $val=sprintf ("%.1f", $val);
          return ("$val TB");
     }
     #GB
     if ($val > 1000000000) {
          $val=$val/1000000000;
          $val=sprintf ("%.1f", $val);
          return ("$val GB");
     }
     #MB
     if ($val > 1000000) {
          $val=$val/1000000;
          $val=sprintf ("%.1f", $val);
          return ("$val MB");
     } else {
          $val=$val/1000;
          $val=sprintf ("%.1f", $val);
          return ("$val KB");
     }

}

#####################
sub comstarlib_ask_property {       #hide: ask for property
#####################
    my ($ask,$close,$form,$info,$t,$opt,$r);

# answered
    if ($in{'answered'}) { &comstarlib_change_property;  exit; }

# ask
    $close="<a href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";

    #Writeback Cache setting
    if ($in{'prop'} eq "wcd") {
      if ($in{'old'} eq "Disabled") {
        $form="Writeback cache = <input type='text' class='input' name='text' value='Enabled' style='width: 150px' readonly> ";
        $info="set Writeback cache of $in{'zfs'} to Enabled.";

      } else {
        $form="Writeback cache = <input type='text' class='input' name='text' value='Disabled' style='width: 150px' readonly> ";
        $info="set Writeback cache of $in{'zfs'} to Disabled.";
      }
      $info.="<br><br>Disabled is safe but slow without a high speed LOG device<br>Enabled is fast but not safe, <br>because sync writes becomes async and a LOG device is not used !";
    }

    #Alias setting
    if ($in{'prop'} eq "alias") {
        $form="Alias = <input type='text' class='input' name='text' value='$in{'old'}' style='width: 150px'> ";
        $info="modify Alias of $in{'zfs'}";
    }


 ### form ###
     $ask=&ask_pop("$form","$info","$opt");
     return ($ask);

}

#####################
sub comstarlib_change_property {       #hide: ask for property
#####################
    my ($r,$s,$t,@l,$l,@n,$i);

  #wcd   Writeback Cache setting
  ############
  if ($in{'prop'} eq "wcd") {
        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }
        if ($in{'text'} eq "Disabled") {  $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=true $in{'zfs'}","","comstarlib 262");  }
        if ($in{'text'} eq "Enabled")  {  $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=false $in{'zfs'}","","comstarlib 263");  }
        if ($r ne "") {  &mess($r); }
  }

  #alias
  if ($in{'prop'} eq "alias") {
        $in{'text'}=~s/[^a-zA-Z0-9\_\-]//g;
        $r=&exe("stmfadm modify-lu -p alias=$in{'text'} $in{'zfs'}","","comstarlib 270");
        if ($r ne "") {  &mess($r); }
  }
}


 sub lu_commalist {            # return list of logical units: lu1,lu2,..
###################
   my ($l,$r,@l,$id,$f,$s,@s,@l,@n,$ok,@t);

   $l=&exe("sbdadm list-lu");       # 600144f070cc440000004c1434720366  429496729600         /dev/zvol/rdsk/testssd/data/iscsi_1434720366
   $s=&exe("stmfadm list-lu");      # show all views, even this to missing target groups (600144f070cc4400..)

   # get a new list of all views (with size, file or without
   @l=split(/\n/,$l);
   @s=split(/\n/,$s);

   foreach my $s (@s) {
          $s=~s/.*: //;
          if (!($s=~/^\d+/))    { next; }       # 600144f070cc4..

          $ok="1";
          foreach my $l (@l) {
             if (!($l=~/^\d+/)) { next; }       # 600144f070cc4.. 600144F070CC4..
             if ($l=~/$s/i) {
                # in both lists
                $ok="0";

                $l=~s/ +/ /g;
                @t=split(/ /,$l);               # 6000.. 42193 /dev/zvol/../id_123
                $t[2]=~s/.*\/rdsk\///;
                $t[2]=~s/\/iscsi\_.*//;         # keep fs

                push (@n,"$t[0] ($t[2])");      # add view, fileid
                last;
             }
          }
          if ($ok) {
               push (@n,$s);
          }
   }
   @l=sort(@n);
   $r="";
   if ($_[0] ne "") {                          # additional and preset patameter
        $r="$_[0],";
   }
   foreach my $l (@l) {
        if (!($l=~/^\d+/)) { next; }
        $r.="$l,";                             # ex 600312332424(mac3)

   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }


sub get_lu {                  # return first lu of a given list
##########
  my $t;
  my $l=$_[0];
        @t=();
        @t=split(/\n/,$l);
        foreach $t (@t) {
                if ($t=~/\d+/) { $t=~s/ .+//; return($t); }
        }
}


sub list_views {                     #show all locigal units with views
###############
         my ($l,$id,$r,@l,$f);
        $t=&exe("sbdadm list-lu","","comstarlib 314");
        @l=split(/\n/,$t);
        foreach $l (@l) {
                if ($l=~/^Found /) { next; }                                #Found n LU(s)
                if ($l=~/GUID/)    { next; }                                #GUID DATA SIZE SOURCE)
                if ($l=~/-+/)      { next; }                                 #-----

                $r.="$l"."\n";
                if (!($l=~/^\d+/))  { next; }
                #print "L ".$l ;
                $id=&get_lu($l);        #600144f0476d400000004ae491460014  1073741824   /pool11/comstar/a -> 600..
                $r.="\n".&exe("stmfadm list-view -l $id","","comstarlib 325")."\n";
                $r=~s/:/\t/g;    # change semicolon to TAB
                $r=~s/stmfadm.* no views found/ no views found/s;
                $r.="<br><hr><br>";

        }
        $r=~s/found/found\n\n/gs;
        $r=~s/\t//g;             #tab separates values like comma
        return ("$r");
}

 ###############
  sub delete_lu {                #delete lu from list
 #################    show_set details
    my ($lu,@z,$url,$id,@id,$n);

    #do?
    if ($in{'lu'} ne "") { &delete_lu_do; }
    ###########################################

    #show klickable list
    ####################

    #del url
       $url="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;lu_del=1\&amp;lu==f=\" onclick=\"return(confirm('Delete lu =f= ?'))\">delete =n=</a>";

       $lu=&exe("sbdadm list-lu","","comstarlib 351");                #list of available units
         @t=();
        @t=split(/\n/,$lu);
        foreach $t (@t) {
                if ($t=~/^\d+/) { push (@id,$t); }        # array of lu
        }

        print "id  size  file<br>\n";
        foreach $t (@id) {
                $id=$t;
                $id=~s/ .*//;

                $n=$t;
                $n=~s/^.* \///;

                $t=~s/\/.*//;                        #remove filename
                $t.="  $url";
                $t=~s/=f=/$id/g;
                $t=~s/=n=/$n/;

                print "$t\n";
        }
       exit;
 }

 ###############
  sub delete_lu_do        {        # hide: delete selected lu
 #################

   my $r=&exe("sbdadm delete-lu $in{'lu'}","","comstarlib 380");                #delete unit
   if ($r ne "") {&mess($r);}

   $in{'lu'}="";
   &reload;
   exit;
 }




#############################
#        2. targets
#############################


 sub target_commalist {        # return list of targets: target1,target2,..
###################
   my ($l,$r,@l);
   $l=&exe("stmfadm list-target","","comstarlib 399");
   @l=split(/\n/,$l);
   @l=sort(@l);
   if ($_[0] ne "") {                #additional and preset patameter
        $r="$_[0],";
   }
   foreach $t (@l) {
    $t=~s/^.*: //;
    $r.="$t,";
   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }





 ###############
  sub delete_target {           # delete target from list
 #################    show_set details
    my ($lu,@z,$url,$id,@id,$n);

    #do?
    if ($in{'target'} ne "") { &delete_target_do; }
    ###########################################

    #show klickable list
    ####################

    #del url
       $url="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;target_del=1\&amp;target==f=\" onclick=\"return(confirm('Delete target =f= ?'))\">delete =n=</a>";

       $lu=&exe("itadm list-target","","comstarlib 433");                #list of available units
         @t=();
        @t=split(/\n/,$lu);
        foreach $t (@t) {
                if ($t=~/^\iqn/) {
                $t=~s/ .*//;
                push (@id,$t); }        # array of targets
        }

        print "Targets:<br>\n";
        foreach $t (@id) {
                 $id=$t;
                $id=~s/ .*//;

                $n=$t;
                $n=~s/^.* \///;

                $t="$url";
                $t=~s/=f=/$id/g;
                $t=~s/=n=/$n/;

                print "$t\n";
        }
       exit;
 }

 ###############
  sub delete_target_do        {        # hide: delete selected target
 #################

   my $r=&exe("itadm delete-target -f $in{'target'}","","comstarlib 363");                #delete target
   if ($r ne "") {&mess($r);}

   $in{'lu'}="";
   &reload;
   exit;
 }


 ###############
  sub edit_target {              #edit target from list
 #################    show_set details
    my ($lu,@z,$url,$id,@id,$n,$del,$add);


    #do?
    if ($in{'target'} ne "") { &delete_target_do; }
    ###########################################


    #show klickable list
    ####################

    #del urli
    $del="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;\&amp;target==f=\" onclick=\"return(confirm('Delete target =f= ?'))\">delete</a>";

    $add="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&action=\&l1=$in{'l1'}\&l2=$in{'l2'}\&l3=$in{'l3'}\&lu_del=1\&target=add\" onclick=\"return(confirm(add target?'))\">add target</a>\n";


       $lu=&exe("itadm list-target -v","","comstarlib 492");                #list of available targets
         @t=();
        @t=split(/\n/,$lu);

        print "<pre>delete ";
        foreach $t (@t) {
                 $id=$t;
                $id=~s/ .*//;

                if ($t=~/^ *iqn/) {
                $t="\n$del $t";
                $t=~s/=f=/$id/g;
              } else {
                   $t="     $t";
                }

                     print "$t\n";
        }
        print "\n\n$add\n</pre>";

       exit;


 }

sub add_target {
###################
   $var="<pre>".&exe("itadm create-target","","comstarlib 515");
   print $var.="\ntargets: ".&exe("itadm list-target","","comstarlib 520")."</pre>";
   exit;
}



#########################
#    3. target groups
##########################

 sub tg_commalist {            # return list of targetgroups: group1,group2,..
###################
   my ($l,$r,@l);
   $l=&exe("stmfadm list-tg","","comstarlib 533");
   @l=split(/\n/,$l);
   @l=sort(@l);
   if ($_[0] ne "") {                #additional and preset patameter
        $r="$_[0],";
   }

   foreach $t (@l) {
    $t=~s/^.*: //;
    $r.="$t,";
   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }

###############
  sub delete_tg {                #delete tg from list
 #################    show_set details
    my ($tg,@z,$url,$id,@tg,$n);

    #do?
    if ($in{'tg'} ne "") { &delete_tg_do; }
    ###########################################

    #show klickable list
    ####################

    #del url
       $url="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;tg_del=1\&amp;tg==n=\" onclick=\"return(confirm('Delete target group =n= ?'))\">delete =n=</a>";

       $tg=&exe("stmfadm list-tg","","comstarlib 564");                #list of available hg
       @tg=();
       @tg=split(/\n/,$tg);

        print "target groups:<br>\n";
        foreach $t (@tg) {                                #ex. Host Group: name

              $n=$t;
              $n=~s/^.*: //;
              $t="  $url";
              $t=~s/=n=/$n/g;
              print "$t\n";
        }
       exit;
 }

 ###############
  sub delete_tg_do        {        # hide: delete selected lu
 #################

   my $r=&exe("stmfadm delete-tg $in{'tg'}","","comstarlib 584");                #delete tg
   if ($r ne "") {&mess($r);}

   $in{'tg'}="";
   &reload;
   exit;
 }



######################
#    4. host groups
######################

 sub hg_commalist {            # return list of host-groups: group1,group2,..
###################
   my ($l,$r,@l);
   $l=&exe("stmfadm list-hg","","comstarlib 601");
   @l=split(/\n/,$l);
   if ($_[0] ne "") {                #additional and preset patameter
        $r="$_[0],";
   }
   foreach $t (@l) {
    $t=~s/^.*: //;
    $r.="$t,";
   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }

###############
  sub delete_hg {                #delete hg from list
 #################    show_set details
    my ($hg,@z,$url,$id,@hg,$n);

    #do?
    if ($in{'hg'} ne "") { &delete_hg_do; }
    ###########################################

    #show klickable list
    ####################

    #del url
       $url="<a style='color:red; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;hg_del=1\&amp;hg==n=\" onclick=\"return(confirm('Delete host group =n= ?'))\">delete =n=</a>";

       $hg=&exe("stmfadm list-hg","","comstarlib 630");                #list of available hg
       @hg=();
       @hg=split(/\n/,$hg);

        print "host groups:<br>\n";
        foreach $t (@hg) {                                #ex. Host Group: name

                $n=$t;
                $n=~s/^.*: //;
                $t="  $url";
                $t=~s/=n=/$n/g;
                print "$t\n";
        }
       exit;
 }

 ###############
  sub delete_hg_do        {        # hide: delete selected lu
 #################

   my $r=&exe("stmfadm delete-hg $in{'hg'}","","comstarlib 650");                #delete unit
   if ($r ne "") {&mess($r);}

   $in{'hg'}="";
   &reload;
   exit;
 }


 sub hg_memb_commalist {            # return list of host-groups: group1,group2,..
###################
   my ($l,$r,@l,@z);
   $l=&exe("stmfadm list-hg -v $in{'select_group'} | grep Member:","","comstarlib 662");
   foreach $n (@l) {
        @z=split(/ /,$n);
            $r.="$z[1],";
   }
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }




 #######################################################################################
 # add by h gauvrit
 #######################################################################################




 sub hg_comma_list {            # return list of hostgroups: group1,group2,..
###################
   my ($l,$r,@l);
   $l=&exe("stmfadm list-hg","","comstarlib 684");
   @l=split(/\n/,$l);
   @l=sort(@l);
   foreach $t (@l) {
    $t=~s/^.*: //;
    $r.="$t,";
   }
   $r=~s/\t//g;             #tab separates values like comma
   $r=~s/,+$//;
   return $r;
 }

sub tg_comma_list {            # return list of targetgroups: group1,group2,..
###################
   my ($l,$r,@l);
   $l=&exe("stmfadm list-tg","","comstarlib 699");
   @l=split(/\n/,$l);
   @l=sort(@l);
   foreach $t (@l) {
    $t=~s/^.*: //;
    $r.="$t,";
   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }

 sub tg_mem_comma_list {            # return list of member of target group
###################
   my ($l,$r,@l,@z,$tg);
   if ($_[0] ne "") {                # tg param
        $tg=$_[0];
   }
   $l=&exe("stmfadm list-tg -v $tg | grep Member:","","comstarlib 717");

   @l=split(/\n/,$l);
   # &print_array(@l);

   foreach $n (@l) {
        $n=~s/.* //;
        $r.="$n".",";
   }
   $r=~s/\t//g;             #tab separates values like comma

   return $r;
 }



 sub hg_mem_comma_list {            # return list of member of host group
###################
   my ($l,$r,@l,@z,$hg);
   if ($_[0] ne "") {                #hg parameter
        $hg=$_[0];
   }
   $l=&exe("stmfadm list-hg -v $hg | grep Member:","","comstarlib 735");
   @l=split(/\n/,$l);
   foreach $n (@l) {
        $n=~s/.* //;
        $r.="$n".",";
   }
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }




##########################
#  iscsi target
sub iscsi_target_comma_list {
#############################
# iqn.blablabla,iqn.bla1bal1

my ($tpg,@tpg,$r,$t);

$tpg=&exe("itadm list-target","","comstarlib 756");                #list of available iscsi target
@tpg=split(/\n/,$tpg);              #
foreach $t (@tpg) {
          $t=~s/ .*//;             # remove end statment
          if ($t ne "TARGET") {       # remove header
               $r.=$t.",";
               }
          }
          $r=~s/\t//g;             #tab separates values like comma
return($r);
}

sub ext_iscsi_target_comma_list {      # return list of iscsi target
##############################
# iqn.blablabla (alias) ,iqn.bla1bal1  (alias)

my ($tpg,@tpg,$r,$t);

$tpg=&exe("itadm list-target","","comstarlib 774");        #list of available iscsi target
@tpg=split(/\n/,$tpg);                 #
foreach $t (@tpg) {
          $t=~s/\s.*//;                # remove end statment
          if ($t ne "TARGET") {        # remove header
               $alias=&exe("itadm list-target $t -v | grep alias","","comstarlib 779");
               $alias=~s/.* //;
               $r.=$t." (".$alias."),";
               }
          }
$r=~s/\t//g;             #tab separates values like comma
return($r);
}

sub alias_target_commalist {        # return list of targets:
###################
# target1 (alias1), target2 (alias2),
   my ($l,$r,@l);
   $l=&exe("stmfadm list-target","","comstarlib 792");
   @l=split(/\n/,$l);
   @l=sort(@l);
   if ($_[0] ne "") {                #additional and preset patameter
        $r="$_[0],";
   }
   foreach $t (@l) {
    $t=~s/^.*: //;
    $l2=&exe("stmfadm list-target -v $t | grep iSCSI","","comstarlib 800");
    $l2=~s/^.*: //;
        if ($l2 ne ""){
                    $l3=&exe("itadm list-target -v $t | grep alias","","comstarlib 803");
                 $l3=~s/^.*: //;
                $r.=$t." (".$l3."),";
        } else {
                    $r.="$t,";
        }
   }
   $r=~s/,+$//;
   $r=~s/\t//g;             #tab separates values like comma
   return $r;
 }



#####################
# Portal group

sub ext_tpg_comma_list {
########################
#
# name of portal = ip:port|ip:port , name of portal2 = ip:port|ip:port
#
    my ($tpg,@tpg,$r,$t);
    $tpg=&exe("itadm list-tpg -v","","comstarlib 826");                #list of available tpg
    @tpg=split(/\n/,$tpg);
    foreach $t (@tpg) {
          $n=$t;
          $n=~s/ //g;
          $z=substr($n,0,8);
#          print "\n";
#print "\n N : $n | ".$z;

          if (substr($n,0,6) eq "TARGET") {
             # header, don't care
             $r="";
          } elsif ($z eq "portals:") {
            $n=~s/portals://;
            $n=~s/,/ /;   # if multiple IP in n, remove comma
            $r.=$n.",";
            } else {
              $t=~s/ .*//;
              # it's a portal name
              $r.=$t."=";
           }
        }
    $r=~s/\t//g;             #tab separates values like comma
    return($r);
}

sub tpg_comma_list {
####################
#
# name of portal =  name1,name2
#
    my ($tpg,@tpg,$r,$t);
    $tpg=&exe("itadm list-tpg","","comstarlib 858");                #list of available tpg
    @tpg=split(/\n/,$tpg);
    foreach $t (@tpg) {
          $n=$t;
          $n=~s/ //g;
          $z=substr($n,0,8);
          if (substr($n,0,6) eq "TARGET") {
             # header, don't care
             $r="";
          } elsif ($z eq "portals:") {
            } else {
              $t=~s/ .*//;
              # it's a portal name
              $r.=$t.",";
           }
        }
    $r=~s/\t//g;             #tab separates values like comma
    return($r);
}





##########################
sub eth_comma_list {
##########################
  my ($r,@l,@t,$t,$i,$list,$link,$ip);
  &load_lib("get-current-net.pl");                 # link details

  # $t=`sudo /usr/sbin/dladm show-link | grep up`;  # old

  # use ifconfig that allows subinterfaces
  $r=&exe("ifconfig -a");
  $r=~s/\n\s*inet/ inet/gs;   # one line per interface

  @t=split(/\n/,$r);
  foreach my $t (@t) {
          $t=~s/^\s+//;
          chomp($t);
          if (!($t=~/inet/))  { next; }   #ex ether
          if ($t=~/^lo/)      { next; }   #loopback
          if ($t=~/::\/0/)    { next; }   #no ip

          $t=~s/: / /;         # e1000g0: -> e1000g0
          $link=$t;
          $link=~s/\s.*//;

          $ip=$t;
          $ip=~s/.*inet6* //;
          $ip=~s/ .*//;
          if ($ip=~/:/) { $ip="[$ip\]"; }

          $out.="$ip - $link,";
  }
  $out=~s/,$//;
  return ($out);             #comma separated values like: 172.16.1.22 - rz0,172.19.30.22 - sanneu0    ip6 like [ip]
}



 ###################
 sub get_ip {   # hide: ip    -> par link
 ###################
     my ($i,$n,$r,$m,$t,$d,$l);
     $l=$_[0];
     $r=&exe("ifconfig $l | grep inet","","comstarlib 908");  $r=~s/\n//gs;
     if ($r=~/ifconfig/) { return("-,-,no such interface,-"); }
     $r=~s/[^A-Za-z0-9\: \.]//g;
     #ip
     $i=$r;
     $i=~s/^.*inet\s*//;
     $i=~s/\s*netmask.*//;
     if ($i eq "") {
             $i="No ip address";
        }
     return("$i");         #ip
 }

 ##########################
sub all_eth_comma_list {
##########################
  my ($r,@l,@t,$t);
  @t=split(/\n/,&exe("dladm show-phys | grep Ethernet","","comstarlib 925"));
  foreach $t (@t) {
    $t=~s/ .*//;   chomp($t);
    push (@l,$t);
    $r.="$t,";
  }
  $r=~s/\t//g;             #tab separates values like comma
  return ($r);
}

sub all_disk_comma_list {      # all disk (free or not)
  my ($r,@t,$t);
  @a=&array_hd;    # all hds id \t info
        foreach $h (@a) {
              $i=$h;
              chomp($i);
              $i=~s/\t.*//;                          # id only
              $r.=$i.",";
          }
  $r=~s/\t//g;             #tab separates values like comma
  return($r);         #list of disk c0d0t0,c0d1t0 ...
}



##########################
sub disk_comma_list {       # list all disk c0d0t0,c0d1t0 ...
##########################
  my ($r,@t,$t);
        @t=split(/\n/,&list_freehd('n'));
        foreach         $t (@t) {
                         chomp($t);
                         $t=~s/\t.*//;                          # id only  c0t0d0
                         $r.=$t.",";
        }
     $r=~s/\t//g;             #tab separates values like comma
     return($r);         #list of disk c0d0t0,c0d1t0 ...
}

##########################
sub fcoe_comma_list {       # list all fcoe interface ...
                            # $type could be nothing, i for initiator, t for target
##########################
  my ($r,$z,@z,$z_left,$z_right,$wwn,$eth);
     if ($_[0] eq "") {
             $type="";
     } else {
              $type=" - ".$_[0];
     }
     @z=split(/\n/,&exe("fcadm list-fcoe-ports $type","","comstarlib 974"));   # all FCOE  interface port only
     $eth="";
     $wwn="";
     foreach $z (@z) {
              $z_left=$z;
              $z_left=~s/:.*//;
              $z_right=$z;
              $z_right=~s/^.*: //;
              $z_right=~s/ //g;  # remove space to help test below
              $z_left=~s/ //g;   # remove space to help test below
              chomp($z_left);
              if ($z_left eq "HBAPortWWN" ) {
                   $wwn="wwn.".$z_right;
                   }
              if (substr($z_left,1,7) eq "MACName") {
                  $eth=$z_right;
                  $r.=$eth." : ".$wwn.",";
                  }
              }
     $r=~s/\t//g;             #tab separates values like comma
     return($r);         #list all fcoe interface ...
}



sub views_comma_list {           #show view for a specific logical unit
###############
# view entry: number | host group : name | target group : name | LUN : number
        my ($r,@l,$lu,$z,$t);
        $lu=$_[0];
        $z=&exe("stmfadm list-view -l $lu","","comstarlib 1004");
        $z=~s/stmfadm.* no views found/no views found/s;
        if ($z ne "no views found") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 $l=~s/\t//g;
                 if ($l !~ /LUN/) {
                      $l=~s/.*://g;
                      $r.=$l." \t";
                 } else {
                      $l=~s/.*://g;
                      $r.=$l."  \t";
                      $r.=$lu."\n";
                 }
             }
        } else {
            $r=$z;
        }
        #chop($r); # remove last "|"
        $r=~s/\t//g;             #tab separates values like comma
        return ("$r");
}

#########################################################
# Initiators
#########################################################


sub init_comma_list  {  # return a list of initiator
#########################
# init1, init2

#
my ($r,@l,$z);
        $z=&exe("itadm list-initiator","","comstarlib 1038");
        $z=~s/stmfadm.* no views found/ no views found|/s;
        if ($z ne "") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 $l=~s/ .*//;
                 if (substr($l,0,4) eq "INIT") {
                 } else {
                    $r.=$l.",";
                 }
             }
        } else {
            $r=$z;
        }
        $r=~s/\t//g;             #tab separates values like comma
        return ($r);
}

###########################################################
# zfs volumes, snapshot, clone
###########################################################

sub snap_tab_list  {    # list tab ( snapshot name, creation date, used)
my ($r,@l,$z,$var,$creation,$used);
$z=&snap_comma_list($_[0]);
if ($z ne "") {
             @l=split(/,/,$z);
             foreach $l (@l) {
                 #$l=~s/\,//;
                 $creation=&exe("zfs get -rH creation $l","","comstarlib 1067");
                 $creation=~s/.*creation//;
                 $creation=~s/-.*//;
                 $used=&exe("zfs get -rH used $l","","comstarlib 1070");
                 $used=~s/.*used//;
                 $used=~s/-.*//;
                 #print "creation ".$creation ;
                 #print "USED ".$used;

                 $r.=$l." \t".$creation." \t".$used."\n";
             }
       }
        return ($r);
} # endsub




#############################
sub snap_comma_list  {      # all snapshot, clone on every pool except rpool/syspool
                            #
                            #
#############################

my ($r,@l,$z,$var);
$var=$_[0];
if ($var ne "") {
        $z=&exe("zfs list -rH -t snapshot $var","","comstarlib 1094");
}
        if ($z ne "") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 $l=~s/\t.*//;
                    $r.=$l.",";
             }
        } else {
            $r=$z;
        }
        $r=~s/\t//g;             #tab separates values like comma
        return ($r);
}





sub filesystem_comma_list  { # all filesystem on every pool except rpool/syspool
                            # if $_[0]="all" then all pool including rpool
                            # if $_[0]=something , then var=something
                            # otherwise all pool excluding rpool
#############################

my ($r,@l,$z,$var);
$var=$_[0];
if ($var eq "all") {
        $z=&exe("zfs list -rH -t filesystem","","comstarlib 1122");
} elsif ($var ne "") {
        $z=&exe("zfs list -rH -t filesystem \"$var\"","","comstarlib 1123");
} else {
        $z=&exe('zfs list -rH -t filesystem |  grep -v "^(rpool|syspool)/?"');
}
        if ($z ne "") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 $l=~s/\t.*//;
                 $r.=$l.",";
             }
        } else {
            $r=$z;
        }
        $r=~s/\t//g;             #tab separates values like comma
        return ($r);
}


#############################
sub volume_comma_list  {    # all volume, snapshot, clone on every pool except rpool/syspool
                            # if $_[0]="all" then all pool including rpool/syspool
                            # otherwise all pool excluding rpool
#############################

my ($r,@l,$z,$var);
$var=$_[0];

$type=$_[1];
if ($type eq "") {$type="snapshot,volume"; }
if ($var eq "all") {
        $z=&exe("zfs list -rH -t $type","","comstarlib 1154");
} elsif ($var ne "") {
        $z=&exe("zfs list -rH -t $type \"$var\"","","comstarlib 1156");
} else {
        $z=&exe('zfs list -rH -t ".$type." |  egrep -v "^(rpool|syspool)/?"');
}

        if ($z ne "") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 $l=~s/\t.*//;
                    $r.=$l.",";
             }
        } else {
            $r=$z;
        }
        $r=~s/\t//g;             #tab separates values like comma
        return ($r);
}

#########################################
sub pool_comma_list { # list of all pool
                      # if $_[0]="all" then all pool including rpool
                      # if $_[0]="data" then all pool excluding rpool/ syspool
#####################
my ($r,@l,$z,$var);

$var=$_[0];
if ($var eq "all") {
$z=&exe("zpool list","","comstarlib 1183");
} elsif ($var eq "data") {
$z=&exe("zpool list | grep -v rpool | grep -v syspool");
}
        if ($z ne "") {
             @l=split(/\n/,$z);
             foreach $l (@l) {
                 #$l=~s/ .*//;
                 if (substr($l,0,4) eq "NAME") {
                 } else {
                     $l=~s/ .*//;
                    $r.=$l.",";
                 }
             }
        } else {
            $r=$z;
        }
        $r=~s/\t//g;             #tab separates values like comma
        return ($r);
}

########################################
sub lu_comma_list  {  # list of all lu
######################################

my ($r,@l,$z,$lu);
@z=split(/\n/,&exe("stmfadm list-lu","","comstarlib 1209"));
foreach $l (@z) {
 if ($l ne "stmfadm: list failed") {
      $l=~s/.*\://;
      $lu=lc($l);
      $r.=&exe("sbdadm list-lu | grep $lu","","comstarlib 1004").",";
 } else {
      $r="";
      }
}
$r=~s/\t//g;             #tab separates values like comma
return($r)
}

##############################
sub lu_file_comma_list {     # list all file used for thin-prov
                             # all
                             # thin = file used by thin prov LU
                             # vol = for ZFS volumes
##############################
my ($r,@l,$z,@z,$var,$path,$pool);

@z=split(/\,/,&pool_comma_list('data'));

$var=$_[0];
if ($var eq "") { $var="all"; }

foreach $pool (@z) {
   if ($var eq "thin" || $var eq "all") {
       @t=split(/\n/,&exe("ls /".$pool."/comstar -RF1 | grep -v '/$' "));
       print "ls /".$pool."/comstar --file-type -R -1";
       foreach $l (@t) {
                 print "\n";
          print "L1 ".$l;
          $l=~s/ //;
          if (substr($l,0,1) eq "/") {
                      $l=~s/\://;
                      $path=$l;
           } elsif (substr($l,-1,1) ne "/" && substr($l,0,1) ne "-")  {  # it's a file name
                      $r.=$path."/".$l.",";
          }
          print "\n";
          print "L2 ".$l;
       }
   }
   if ($var eq "vol" || $var eq "all") {
       @t=split(/\n/,&exe("ls /dev/zvol/rdsk/".$pool."  -RF1 | grep -v '/$' "));
       foreach $l (@t) {
          print "\n";
          print "L1 ".$l;
          $l=~s/ //;
          if (substr($l,0,1) eq "/") {
                      $l=~s/\://;
                      $path=$l;
           } elsif (substr($l,-1,1) ne "/" && substr($l,0,1) ne "-")  {  # it's a file name
                      $r.=$path."/".$l.",";
          }
          print "\n";
          print "L2 ".$l;
       }
   }

}
print "R ".$r;
$r=~s/\t//g;             #tab separates values like comma
return($r);
} # end sub

sub save_view  {  # save view for a specific LU
###################
my ($lu,$l,$hg,$tg,$view,@view);
$lu=$_[0];
$view=&exe("stmfadm list-view -l $lu","","comstarlib 1281");
if (substr($view,0,8) ne "stmfadm:") {
@view=split(/\n/,$view);
foreach $l (@view) {
    $l=~s/ //g;       # remove space
    if (substr($l,0,3) eq "Hos")  {
        $hg=$l;
        $hg=~s/.*://;
    } elsif (substr($l,0,3) eq "Tar") {
        $tg=$l;
        $tg=~s/.*://;
    } elsif (substr($l,0,3) eq "LUN") {
        $lun=$l;
        $lun=~s/.*://;
        $matrix.=$hg.",".$tg.",".$lun."\n";
    }
}
} else {
   $matrix="";
}
return($matrix);

} # end sub

sub restore_view  {  # restore view for a specific LU with matrix
###################
my ($lu,$l,$hg,$tg);
$lu=$_[0];
$matrix=$_[1];

           #
           # restore previously saved view
           #
           @matrix=split(/\n/,$matrix);
           foreach $l (@matrix) {
                @z=split(/\,/,$l);
                if ($z[0] eq "All") {
                   $hg="";
                } else {
                   $hg=" -h ".$z[0];
                }
                if ($z[1] eq "All") {
                   $tg="";
                } else {
                   $tg=" -t ".$z[1];
                }
                #print "Restore view for ".$lu;
                #print "\n";
                #print "host group ".$hg." target group ".$tg." LUN ".$z[2];
                &exe("stmfadm add-view".$tg.$hg." -n ".$z[2]." ".$lu);
           }
} # end sub

#eof
1;
