# gethash-current-net.pl
# network infos to hash current
# edited 22.7.2015
#
# (c) napp-it 2010-15
# fill %sys with net infos

use strict;


&get_mynet;                # add netinfos
$current{'count_add'}++;


##############
sub get_mynet  {
##############
  my (@w,$w,$key,$k,$n,$r,$h1,$h2,$h3,$h4);

  #1. infos from dladm (phys: link and device)
      $r=&exe("dladm show-phys",'','get current net 63');


      @t=split(/\n/,$r);
      @t=sort(@t);
      $current{'link_phys'}="";
      $current{'device_phys'}="";
      foreach $t (@t) {
          if ($t=~/^LINK/) { next; }
          chomp($t);
          $t=~s/ +/\t/g;
          @p=();
          @p=split(/\t/,$t);                              # link, media, state, speed, duplex, device
          $current{'device_phys'}.="$p[5]\t";
          $current{'link_phys'}.="$p[0]\t";

          $p="phys_$p[5]\_link";   $current{$p}=$p[0]; #linkname of device
          $p="phys_$p[0]\_media";  $current{$p}=$p[1]; #media  (of link)
          $p="phys_$p[0]\_state";  $current{$p}=$p[2]; #state
          $p="phys_$p[0]\_speed";  $current{$p}=$p[3]; #speed
          $p="phys_$p[0]\_duplex"; $current{$p}=$p[4]; #duplex

      }
      $current{'link_phys'}=~s/\t$//;
      $current{'device_phys'}=~s/\t$//;

  # 2. infos from ifconfig: ether and netmask

      $r=&exe('ifconfig -a','','get current net 48');  # lo0: flags=2001000849<UP,LOOPBACK,RUNNING,MULTICAST,IPv4,VIRTUAL> mtu 8232 index 1
                                                       #        inet 127.0.0.1 netmask ff000000
                                                       # e1000g0: flags=1000843<UP,BROADCAST,RUNNING,MULTICAST,IPv4> mtu 1500 index 2
                                                       #        inet 192.168.88.100 netmask ffffff00 broadcast 192.168.88.255
                                                       #        ether 0:c:29:26:b:23
                                                       # lo0: flags=2002000849 mtu 8252 index 1
                                                       #        inet6 ::1/128
      # get netmask, macadr, mtu

        @w=split(/\n/,$r);
        foreach my $w (@w) {
           chomp($w);
           if ($w=~/^\w+/) {                           # new adapter
                $n=$w;
                $n=~s/:.*//;                           # e1000g0
                next;
           } else {
                #netmask
                $k=$w;
                if ($k=~/netmask /) {
                     $k=~s/.*netmask\s*//;
                     $k=~s/\s.*//;

                     if ($k eq "0") {
                              $k="0.0.0.0";
                     }  else {
                              #dezimal
                              $h1=hex(substr($k,0,2));
                              $h2=hex(substr($k,2,2));
                              $h3=hex(substr($k,4,2));
                              $h4=hex(substr($k,6,2));
                     }
                     $t="if_$n\_netmask";
                     $current{$t}="$h1.$h2.$h3.$h4";
                     next;
                }
                #ether
                $k=$w;
                if ($k=~/ether\s*/) {
                     $k=~s/.*ether\s*//;
                     $k=~s/\s.*//;
                     $t="if_$n\_ether";
                     $current{$t}="$k";
                }
            }
        }




  #3. infos from dladm (link,class,mtu,state,bridge,over)
      $r=&exe("dladm show-link",'','get current net 89');

      @t=split(/\n/,$r);
      @t=sort(@t);
      my @a;
      $current{'link_all'}="";
      foreach $t (@t) {
          if ($t=~/^LINK/) { next; }
          chomp($t);
          $t=~s/  +/\t/g;
          @p=();
          @p=split(/\t/,$t);                           # link,class,mtu,state,bridge,over

          $current{'link_all'}.="$p[0]\t";             # all  links

          $p="link_$p[0]\_class";  $current{$p}=$p[1]; #class (phys,vlan)
          $p="link_$p[0]\_mtu";    $current{$p}=$p[2]; #mtu
          $p="link_$p[0]\_state";  $current{$p}=$p[3]; #state
          $p="link_$p[0]\_bridge"; $current{$p}=$p[4]; #bridge
          $p="link_$p[0]\_over";   $current{$p}=$p[5]; #over
          $current{$p}=~s/ /\t/g;

          #aggr -> link_aggr=AGGR
          if ($p[0] =~/aggr/) {
             $p="link_over_$p[0]";
             $current{$p}="$p[5]";
             $current{$p}=~s/ /\t/g;
             @a=split(/\s/,$p[5]);
             foreach my $a (@a) {
                $p="aggr_over_$a";
                $current{$p}="$p[0]";
             }
          }

      }
      $current{'link_all'}=~s/\t$//;


  #4. vlan infos from dladm (link,vlan,over, flags )
      $r=&exe("dladm show-vlan",'','get current net 115');
      @t=split(/\n/,$r);
      @t=sort(@t);
      $current{'link_vlan'}="";
      foreach $t (@t) {
          chomp($t);
          if ($t=~/^LINK/) { next; }

          $t=~s/ +/\t/g;
          @p=();
          @p=split(/\t/,$t);

          $current{'link_vlan'}.="$p[0]\t";            # all vlan links

          $p="vlan_$p[0]\_id";     $current{$p}=$p[1]; #vlan id
          $p="vlan_$p[0]\_over";   $current{$p}=$p[2]; #vlan over link
          $p="vlan_$p[0]\_flags";  $current{$p}=$p[3]; #vlan flags

          # add v..to over link
          $p="vlan_over_$p[2]";    $current{$p}.="\t$p[0]"; #v.. of "over" link
          $current{$p}=~s/^\t//;
      }
      $current{'link_vlan'}=~s/\t$//;


  #5. vnic infos from dladm (link,over, speed, macaddr, macaddrtype, VID)
      $r=&exe("dladm show-vnic",'','get current net 115');
      @t=split(/\n/,$r);
      @t=sort(@t);
      $current{'link_vnic'}="";
      foreach $t (@t) {
          chomp($t);
          if ($t=~/^LINK/) { next; }

          $t=~s/ +/\t/g;
          @p=();
          @p=split(/\t/,$t);

          $current{'link_vnic'}.="$p[0]\t";            # all vniclinks

          $p="vnic_$p[0]\_over";   $current{$p}=$p[1]; #vnic over link
          $p="vnic_$p[0]\_speed";  $current{$p}=$p[2]; #vnic speed
          $p="vnic_$p[0]\_macaddr";$current{$p}=$p[3]; #vnic macaddr
          $p="vnic_$p[0]\_mactype";$current{$p}=$p[4]; #vnic macaddrtype
          $p="vnic_$p[0]\_vid";    $current{$p}=$p[5]; #vnic vid

          # add v.. to over link
          $p="vnic_over_$p[1]";    $current{$p}.="\t$p[0]"; #v.. of "over" link
          $current{$p}=~s/^\t//;
      }
      $current{'link_vnic'}=~s/\t$//;

  #6. aggr infos from dladm (link,policy,adrpolicy,lacpactivity,lacptimer,flags)
      $r=&exe("dladm show-aggr",'','get current net 185');
      @t=split(/\n/,$r);
      @t=sort(@t);
      $current{'link_aggr'}="";
      foreach $t (@t) {
          chomp($t);
          if ($t=~/^LINK/) { next; }

          $t=~s/ +/\t/g;
          @p=();
          @p=split(/\t/,$t);

          $current{'link_aggr'}.="$p[0]\t";            # all aggr

          $p="aggr_$p[0]\_policy";       $current{$p}=$p[1]; #
          $p="aggr_$p[0]\_adrpolicy";    $current{$p}=$p[2]; #
          $p="aggr_$p[0]\_lacpactivity"; $current{$p}=$p[3]; #
          $p="aggr_$p[0]\_lacptimer";    $current{$p}=$p[4]; #
          $p="aggr_$p[0]\_flags";        $current{$p}=$p[5]; #
      }
      $current{'link_aggr'}=~s/\t$//;

  # 7. aggr details
      #  LINK      PORT           SPEED  DUPLEX  STATE     ADDRESS            PORTSTATE
      #  aggr1     --             1000Mb full    up        0:c:29:45:ba:3d    --
      #            lan0           1000Mb full    up        0:c:29:45:ba:3d    attached
      #            e1000g3        1000Mb full    up        0:c:29:45:ba:51    attached

   if ($current{'link_aggr'} ne "") {

      $r=&exe("dladm show-aggr -x",'','get current net 214');
      @t=();
      @t=split(/\n/,$r);
      @t=sort(@t);
      foreach $t (@t) {
          if ($t=~/^LINK/) { next; }

          $t=~s/ +/\t/g;
          @p=();
          @p=split(/\t/,$t);

          $p="aggr_$p[0]$p[1]\_speed";
          $p=~s/\s|\-//g;           # aggr1 or e1000g3
          $current{$p}=$p[2];       # speed

          $p=~s/speed/duplex/;
          $current{$p}=$p[3];       # duplex

          $p=~s/duplex/state/;
          $current{$p}=$p[4];       # state

          $p=~s/state/adress/;
          $current{$p}=$p[5];       # mac address

          $p=~s/adress/portstate/;
          $current{$p}=$p[6];       # portstate

      }
   }

  # 8. infos from ipadm show-addr
  # ADDROBJ    TYPE    STATE            ADDR
  # e1000/g4   static  ok               192.168.88/24
  #            dhcp    inaccessable     172.16.1.1/16

  $r=&exe("ipadm show-addr",'','get current net 79');     # aaddrobj, type, state, addr
  #ex: e1000g/v4   dhcp   ok   192.168.1.10/24
      @p=();
      @t=split(/\n/,$r);
      @t=sort(@t); 
#&print_array(@t);
      foreach $t (@t) {                #lines
          if ($t=~/^ADDROBJ/)  { next; }
          $t=~s/ +/,/g;
          @w=();
          @w=split(/,/,$t);

          if ($w[3]=~/^127\./)       { next; }     # localhost
          if ($w[3]=~/::1\/128/)     { next; }     # v6 localhost
          if ($w[3]=~/::\/128/)      { next; }     # v6 missing ip


          #Linkname
          $n=$w[0];
          $n=~s/\/.*//;

          #ADDROBJ
          $k="adr_$n\_addrobj";
          $current{$k}=$w[0];

          #Type
          $k="adr_$n\_type";
          $current{$k}=$w[1];

          #STATE
          $k="adr_$n\_state";
          $current{$k}=$w[2];

          #ADDR
          $k="adr_$n\_addr";
          $current{$k}=$w[3];

          #inet
          if ($w[3]=~/::/) {              #v6
            $k="adr_$n\_inet6";
          } else {
            $k="adr_$n\_ip";
            $current{$k}=$w[3];
            $current{$k}=~s/\/.*//;
          }
      }


      # 3. get defaultroute
      $r=&exe("netstat -rn",'','get current net 120');
      @p=();
      @t=split(/\n/,$r);
      foreach $t (@t) {
          if (!($t=~/default/))  { next; }
          $t=~s/ +/,/g;
          @w=();
          @w=split(/,/,$t);
          if ($w[1]=~/^\d+/) {
                 $k="net_gateway";
                 $current{$k}=$w[1];
                 last;
          }
       }

  #add to %sys
  #&print_hash(%current);

}  #eof sub



# eof
1;
