                                                                       # get-disk-smart-bg.pl
# this script is initiated via get-disk-smart.pl and loggs all smartvalues in the background to a file /tmp/nappit/smart_data.smart
# reason: cgi timeouts on large installations
# debug: perl /var/web-gui/data/napp-it/zfsos/_lib/get-disk-smart-bg.pl
# 8.8.2018, skip smartcheck of ESXi vdisks

# (c) napp-it 2010-2021
# last 18.8.2020 search smartctl, require admin-lib, no double smart data on tmp
# jul 01 2021, background check, allow Completed     123 as ok
# jun 02, 2022 check attr 194 temp on sata line 346

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($data $cgipath $i $t $p $o $action $txt $ev %t %p %in %cfg @p @t @cfg %disk %sys %zfs %action %current %opt %txt $check);         # menues and global var + global temp


if ($sys{'sbinpath'} eq "") { $sys{'sbinpath'}="/usr/sbin/"; }

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";                          # common used functions of napp-it in this script
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk.pl";                 # load basic disk infos

# preload  (function is pre/autoloaded in sas and smartmenu)
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/disklib.pl";
&get_mydisk_smart;


##############
sub get_mydisk_smart  {
##############      opt parameter: none

$data="please wait, read smartvalues.....\n\n";

# to increase performance, use accelerator
   my (@disks,$disks,$r,@s,$s,$k,@w,$w,$type,$dev,$id,$smart_id,%sv);

###
  my $smt="/usr/sbin/smartctl";  # compiled
  $r=`find /opt -name smartctl`;    $r=~s/\n.*//s;  # first entry
  if ($r=~/smartctl/) { $smt=$r; }



  @w=();
  @w=split(/\t/,$disk{'all_dsk'});
  $data.=  "all disks\n$disk{'all_dsk'}\n\n";

  foreach $w (@w) {
       if ($disks=~/,$w/) { next; }                                             # have it already
       if (!($w=~/s0$|p0$/)) { $w.="s0"; }
       $disks.="$w,";
       push (@disks,$w);
  }

  # delete old values
  if (-f "/tmp/nappit/smart_alldisks.smart")  {
      `sudo rm /tmp/nappit/smart_alldisks.smart`;
  }

  if (-f "/tmp/nappit/smart_data.smart.tmp")  {
      `sudo rm /tmp/nappit/smart_data.smart.tmp`;
  }

  # step 1, skip if smart is not supported
  foreach my $disk (@disks) {

      $id=$disk;
      $id=~s/s0$|p0$//;

      # ESXi 6.7 crashed with vmware disks
      $k="$id\_product";
      if ($disk{$k} =~/vmware/i) {
           $data.= "vmware disk, skip<br>"; sleep(1);
           next;
      }

      $k="$id\_modell";
      if ($disk{$k} =~/dvd/) { next; }                                          # dvd drive


     # 1. try to get basic info
      $r=`sudo $smt -i -T permissive /dev/rdsk/$disk`;            # without -d or system may hang

      #Command window
      &log_add("get-disk-smart.pl 90 basic info $disk# $smt -i -T permissive /dev/rdsk/$disk<hr>$r");

      if ($r=~/not support SMART/is) {                                          # not smart capable
           $k="$id\_smart_health";
           $disk{$k}="n.a.";

           @w=(); @w=split(/\n/,$r);

           # not smart capable but maybee some infos
           foreach $w (@w) {
                    if ($w=~/Device type:/i) {                                  # Device type: disk
                         $w=~s/.*Device type: +//i;
                         $k="$id\_smart_type";
                         $disk{$k}="$w";
                    }
                    if ($w=~/Device:/i) {                                       # Device: Vmware virtual disk
                         $w=~s/.*Device: +//i;
                         $k="$id\_smart_device";
                         $disk{$k}="$w";

                         $k="$id\_smart_model";
                         $disk{$k}="$w";
                         $disk{$k}=~s/ .*//;;                                   # ex Vmware Virtual Disk ..
                    }

                    if ($w=~/Serial number:/i) {                                # Device: Vmware virtual disk sn
                         $w=~s/.*number: +//i;
                         $k="$id\_smart_sn";

                         # $disk{$k}="$w";                                      # too long
                          $disk{$k}="n.a.";

                          ## add smart.txt
                          open (PF, ">>/tmp/nappit/smart_alldisks.smart");
                                     print PF "$k|$disk{$k}|\n";

                                     # opt sn
                                     $k="$id\_sn";
                                     if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

                                     # opt configured
                                     $k="$id\_busy";
                                     if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

                           close (PF)

                    }
           }
           next;

      }  else {


           # try to enable smart to check sat/scsi type
           # default = sat= sat,16 is needed for 48bit ATA support
           # default (16) is reported to have problems on some intel ahci so use sat,12


           $r=`sudo $smt -d sat,12 -T permissive --smart=on /dev/rdsk/$disk`;
           &log_add("get-disk-smart.pl detect type via smartctl -d sat,12 -T permissive --smart=on /dev/rdsk/$disk<hr>$r");

           $k="$id\_smart_type";
           if ($r=~/SMART Enabled/is) {
                $disk{$k}="sat,12";
           }

           if ($disk{$k} eq "") {
                # try to enable smart to check scsi type
                $r=`sudo $smt -d scsi -T permissive --smart=on /dev/rdsk/$disk`;
                &log_add("get-disk-smart.pl detect type via smartctl -d scsi -T permissive --smart=on /dev/rdsk/$disk<hr>$r");

                      if ($r=~/SMART Enabled|SMART\) enabled/is) {             # SMART Enabled or (SMART) enabled
                           $k="$id\_smart_type";
                           $disk{$k}="scsi";
                      }
           }

           #cannot detect type, next
           if ($disk{$k} eq "") {
                $disk{$k}="n.a.";
                next;
           }
           ##

      }

      # ok smart supported
      # device must be specified!  (sat, scsi),

      # get values
      ############
      %sv=();                                                 # collect smart values for current disk

      $k="$id\_smart_type";
      $r=`sudo $smt -a -d $disk{$k} -T permissive /dev/rdsk/$disk`;                    # get all infos, use type (produce a soft error in Illumos)

      #Command window
      &log_add("get-disk-smart.pl 165 all infos $disk# smartctl -a -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$r");

      #check selftest log
      $check=`sudo $smt -l selftest -d $disk{$k} -T permissive /dev/rdsk/$disk`;       # get check log
      &log_add("get-disk-smart.pl 176 selftest $disk#smartctl -l selftest -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$check");

      @s=();
      @s=split(/\n/,$check);

      $k="smart_selftest";
      $sv{$k}="--";
      foreach my $c (@s) {
            if (!($c=~/Completed/i))    { next; }

            if ($c=~/without error|Completed\s+\-|Completed\s+\d/) {        # some disk report 'Completed  -' (not 'Completed,  without error', some only Completed)
                $sv{$k}="without error";                     # Completed without error
            } else {
                $sv{$k}="ERROR";
                $sv{'smart_overview'}.="4";                  # 1=smart enabled, 2=warning, 3=health_err, 4=selftest_err, 5=smarterr, 6=health_err (>2 critical))
            }
      }

      $sv{'smart_overview'}=~s/4+/4/;
     #      print "+++++++++ selftest +++++++++++++++++\n$sv{$k}\n";

     # cmd option # http://sourceforge.net/apps/trac/smartmontools/ticket/261, without softerror but miss health state
       # $r=`sudo $smt -i -c -A -l error -l selftest -l selective -d $disk{$k} -T permissive /dev/rdsk/$disk`;
     # log
       # &log_add("get-disk-smart.pl 193 all infos $disk# smartctl -i -c -A -l error -l selftest -l selective -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$r");



      #smart support
      if ($r=~/SMART support is: *Available/s) {
         $k="smart_support";
         $sv{$k}="available";
         if ($r=~/SMART support is: Enabled/s) {
              $sv{$k}.=", enabled";
         }
         $sv{'smart_overview'}.="0";                  # 0=smart enabled, 1/2=warning, 3=health_err, 4=selftest_err, 5=smarterr, 6=health_err (>2 critical)
      }


      @s=();
      @s=split(/\n/,$r);

      foreach my $s (@s) {

           # most critical are value 5,187,188,197.198
           if ($s=~/^  5 /) { #reallocated sector count, 1-4 keep an eye, 4+ bad
              $s=~s/.* //;
              $k="smart_5";
              $sv{$k}=$s;
              if ($s > 1) { $sv{$k}="<b class='font_orange'>$s</b>";  $sv{'smart_overview'}.="2"; }
              if ($s > 4) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }
           if ($s=~/^187 /) { #reported uncorrectable errors, 0 is good, >0 is bad
              $s=~s/.* //;
              $k="smart_187";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }
           if ($s=~/^188 /) { #command timerout, 0 is good, 1-13 keep an eye, 13+ is bad
              $s=~s/.* //;
              $k="smart_188";
              $sv{$k}=$s;
              if ($s > 1)  { $sv{$k}="<b class='font_orange'>$s</b>"; $sv{'smart_overview'}.="2"; }
              if ($s > 13) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5";}
              next;
           }
           if ($s=~/^197 /) { #current pending sector, 0 is good, 1+ is bad
              $s=~s/.* //;
              $k="smart_197";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }
           if ($s=~/^198 /) { #offline uncorrectable, 0 is good, 1+ is bad
              $s=~s/.* //;
              $k="smart_198";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }

           #sas disks only
           if ($s=~/^read: /) { #total uncorrected read errors, 0 is good. >0 is bad
              $s=~s/.* //;
              $k="smart_sasread_err";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }
           if ($s=~/^write: /) { #total uncorrected write errors, 0 is good. >0 is bad
              $s=~s/.* //;
              $k="smart_saswrite_err";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }
           if ($s=~/^verify: /) { #total uncorrected verify  errors, 0 is good. >0 is bad
              $s=~s/.* //;
              $k="smart_sasverify_err";
              $sv{$k}=$s;
              if ($s > 0) { $sv{$k}="<b class='font_darkred'>$s</b>"; $sv{'smart_overview'}.="5"; }
              next;
           }

           #Health status
           if ($s=~/Health Status|SMART overall-health/i) {
                $s=~s/.*: +//;
                $k="smart_health";
                $s=~s/ +//g;
                if (!($s =~/\w/)) { $s="n.a."; }
                $sv{$k}=$s;

                if ($s=~/[A-Z]/) {
                  if (!($sv{$k}=~/PASSED|OK/)) {
                       $sv{'smart_overview'}.="6"; }    # 0=smart enabled, 1/2=warning, 3=health_err, 4=selftest_err, 5=smarterr, 6=health_err (>2 critical)
                  }

                next;
           }

           #sn
           if ($s=~/Serial Number/i) {           # a-z, A-Z, 0-9, no '-' (suppressed sometimes)
                $s=~s/.*: +//;
                $k="smart_sn";
                $s=~s/\s+//g;
                $s=~tr/a-z/A-Z/;
                $s=~s/[^A-Z0-9]//g;

                $sv{$k}=$s;
                next;
           }

           #Model  (sata)
           if ($s=~/^Device Model:/i) {
                $s=~s/.*Model: +//;
                $k="smart_model";
                $sv{$k}=$s;
                next;
           }
           #or Product  (sas)
           if ($s=~/^Product:/i) {
                $s=~s/.*Product: +//;
                $k="smart_model";
                $sv{$k}=$s;
                next;
           }

           #Firmware
           if ($s=~/Firmware Version:/i) {
                $s=~s/.*Version: +//;
                $k="smart_firmware";
                $sv{$k}=$s;
                next;
           }

           #temp  attr 194
           if ($s=~/Temperature/i) {
                if ($s=~/^ *\d\d\d\s/)        {                      # only sata, not SAS
                   if (!($s=~/^ *194/))          { next; }           # temp is 194
                }

                if ($s=~/Max Temperature/i)   { next; }              # no min/max
                if ($s=~/Temperature Limit/i) { next; }              # no limit count
                if ($s=~/Trip Temperature/i)  { next; }              # no Drive Trip Temperature (dsumike modification)

                $s=~s/.*  +//;
                $s=~s/ .*//;                                         # only temp not temp + min/max

                $k="smart_temp";
                if ($s=~/\d$/) { $s.=' &deg;C'; }                    #  for utf8 &#8451;

                $sv{$k}=$s;
                next;
           }



      }   # /smartvalues

      # add smart-values to %disk like $disk{'c0t0d0_temp'} = 30 Celsius
      #############
      $k="$id\_smart_selftest";
      $disk{$k}=$sv{'smart_selftest'};

      $k="$id\_smart_support";
      $disk{$k}=$sv{'smart_support'};

      $k="$id\_smart_health";
      $disk{$k}=$sv{'smart_health'};

      $k="$id\_temp";
      $disk{$k}=$sv{'smart_temp'};

      $k="$id\_smart_model";
      $disk{$k}=$sv{'smart_model'};

      $k="$id\_smart_sn";
      $sv{'smart_sn'}=~s/^ +//;
      $disk{$k}=$sv{'smart_sn'};

      # critical values  5,187,188,197,198
      $k="$id\_smart_5";
      $disk{$k}=$sv{'smart_5'};

      $k="$id\_smart_187";
      $disk{$k}=$sv{'smart_187'};

      $k="$id\_smart_188";
      $disk{$k}=$sv{'smart_188'};

      $k="$id\_smart_197";
      $disk{$k}=$sv{'smart_197'};

      $k="$id\_smart_198";
      $disk{$k}=$sv{'smart_198'};

      # sas values read_err, write_err, verify_err
      $k="$id\_smart_sasread_err";
      $disk{$k}=$sv{'smart_sasread_err'};

      $k="$id\_smart_saswrite_err";
      $disk{$k}=$sv{'smart_saswrite_err'};

      $k="$id\_smart_sasverify_err";
      $disk{$k}=$sv{'smart_sasverify_err'};

      $k="$id\_smart_overview";
      $disk{$k}=$sv{'smart_overview'};

      $k="$id\_smart_overview2";           # -, ok, warning, critical
      $disk{$k}="-";
      if ($sv{'smart_overview'}=~/0/)       { $disk{$k}="ok"; }
      if ($sv{'smart_overview'}=~/1|2/)     { $disk{$k}="<b class='font_orange'>smartpar</b>";  }
      if ($sv{'smart_overview'}=~/3|4|5|6/) { $disk{$k}="<b class='font_darkred'>smartpar</b>"; }

      ## add smart data
      open (PF, ">>/tmp/nappit/smart_data.smart.tmp");
           flock(PF, LOCK_EX);

            # smart sn
            $k="$id\_smart_sn";
            print PF "$k|$disk{$k}|\n";

            # opt sn
            $k="$id\_sn";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            # opt configured
            $k="$id\_busy";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            # opt selftest
            $k="$id\_smart_selftest";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            #debug via cli
           # print "----- $id\_smart_selftest -----:$disk{$k}\n";

            # opt type
            $k="$id\_smart_type";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            #new model health temp (agents)
            $k="$id\_smart_model";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_temp";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_health";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            # critical values
            $k="$id\_smart_5";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_187";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_188";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_197";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_198";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            #sas values
            $k="$id\_smart_sasread_err";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_saswrite_err";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_sasverify_err";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_overview";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

            $k="$id\_smart_overview2";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }  $disk{$k}="";

      close (PF);

      $k="$id\_smart_firmware";
      $disk{$k}=$sv{'smart_firmware'};

  }  #/disks


  # update data from tmp
  $t=`sudo cat /tmp/nappit/smart_data.smart.tmp`;
  `sudo rm /tmp/nappit/smart_data.smart.tmp 2> /dev/null`;
      open (PF, ">/tmp/nappit/smart_data.smart");
           flock(PF, LOCK_EX);
           print PF "$t";
      close (PF);


## print new disks.txt
#     $t=`sudo /usr/bin/iostat -En | grep Vendor`;


#     open (PF, ">/tmp/nappit/napp-it_disks.txt");
#           flock(PF, LOCK_EX);
#           print PF "$t";
#     close (PF);

     # last acc data from
     $t=time();
     open (PF, ">/tmp/nappit/smart_last.smart");                                    # write time(), delete old logfile
          flock(PF, LOCK_EX);
           print PF "$t\n";
     close (PF);

     return($data);
}

##############
sub log_add {
##############      replaces admin-lib function, loggs to /tmp/nappit/get-smart-bg.log
# debug only
     #open (PF, ">>/tmp/nappit/get-smart-bg.log");
     #      flock(PF, LOCK_EX);
     #      print PF "$_[0]\n";
     #close (PF);

     #debug at cli
     print "$_[0]\n";
}

##############      #replaces admin-lib function exe
sub exe {
   my $e="$_[0]";
   $e=~s/^\s*sudo\s+//;
   my $r=`$e 2>&1`;
   &log_add("$r");
}

#############       #replaces admin-lib function exe for sub get-disk, can write only hash disk
sub hash2file {
# schreibt hash disk in file

        my @tmp = @_;
        my $tmp;
        my $k;
        my $v;
        my @out;
        local (*F);

        open(F, ">$tmp[1]");
                 flock(F, LOCK_EX);
                 while (($k,$v) = each %disk) {
                    push (@out,"$k\|$v\|\n")
                 }
                 @out=sort(@out);
                 foreach $tmp (@out) { print F "$tmp";}
         close(F);
  return 0;
}


# eof
1;
