# get zpool status
#
# (c) napp-it 2010-2022
# edited 3.1.2018 all_mirror
# edited 10.1.2018, allow c1t1d0s0 (remove/ add botdisk mirror)
# 11.okt 2022, basic vdev wrongly detected
# 13.nov special pools

# fill %sys with basic infos
# detach replacing

use strict;


# 1. zpool hash (info)
#######################
#    disk hash  (poolmember)

        #name of syspool (syspool or rpool)                                   # names of syspool in nexenta/osol
        if ($sys{'auto_os'} =~/nexenta/i) {
                $zfs{'syspool'}="syspool";
        }  else  {
                $zfs{'syspool'}="rpool";
        }
        if ($sys{'auto_os'} eq "Linux") {   $zfs{'syspool'}=""; }

        #network defalt or nwam?
        my $r=&exe("svcs | grep network/physical",'','get sys status 23');

        if ($r=~/:nwam/s)    { $sys{'network'}="nwam"; }
        if ($r=~/:default/s) { $sys{'network'}="default"; }

# zpool status
  &gethash_sys_myzpool;



########## ok thats it ################
#test
#&print_hash(%zpool);


##############
sub gethash_sys_special  {                                        #hide:    get special vdev info
##############
    my ($r,$p,@p,@l,$size,$free);
    my $pool=$_[0];
    $r=&exe("zpool list -Hpv $pool");     # tab separated, fillrate ohne %, bytes
#    NAME        SIZE       ALLOC      FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALTROOT
#    c3t1d0      2013265920 1231208448  782057472  -            - 6       61 -     ONLINE
#        mirror  2013265920  434577408 1578688512 -  -            0       21 -     ONLINE
#        c1t2d0        -          -          -          -  - -  -  -     ONLINE
#        c1t3d0        -          -          -          -  - -  -  -     ONLINE
    $r=~s/.* special//s;          # list prior special vdev
    $r=~s/ \w.*//s;               # more/next vdev

    @l=split(/\n/,$r);
    foreach my $l (@l) {
        @p=split(/\s+/,$l);
        if (!($p[2]=~/\d/))  { next; }
        # debug #if ($p[1]=~/mirror/)  { next; }

        $t="$pool\_special_size";
        $zfs{$t}=$zfs{$t}+$p[2];
        $size=$zfs{$t};

        $t="$pool\_special_free";
        $zfs{$t}=$zfs{$t}+$p[4];
        $free=$zfs{$t};

       # &print_hash(%zfs);
       # print_array(@p);
    }
    $t="$pool\_special_used";
    $zfs{$t}=$free/$size*100;
    $zfs{$t}=sprintf("%.0f", $zfs{$t});
    $zfs{$t}.='%';

    $t="$pool\_special_size";
    $zfs{$t}=&b_convert($zfs{$t},"b","d");

   # if ($zfs{$t}>55) { $zfs{$t}='<font style="color:red">'.$zfs{$t}.'</font>'; }
   #&print_hash(%zfs);
   # print_array(@l);
   # &mess($zfs{$t});
}

##############
sub gethash_sys_myzpool  {                                        #hide:    get basic disk and pool infos
##############
  my (@w,$w,$key,$k,$n,@l,$l,$t,@d,$d,$m,@pools,$pool,$config,$errors,$v,$c,$i,@data,$repl,$repl_list,$repl_nr);
  my $ant="";


  # check accelerator
  if ((-f "/tmp/poolstat.log") && ($cfg{'ver'} ne "")) {
          open (F,"</tmp/poolstat.log");
                flock(F, LOCK_EX);
                @data=<F>;
          close (F);
          $t=time();
          if ($t-$data[0] < 3700) {   # max 1h
               shift @data;           # remove time
               $ant=join("",@data);
          }
          if (!($ant=~/pool:/s)) { $ant=""; }
  }

  if ($ant eq "") {
       $ant=&exe('zpool status','','get sys status 61');                                # get status info
  }
  #&mess($ant);

  @pools=split(/pool: /,$ant);                                 # line 1..n are pools

  #debug
  # print "Content-type: text/html\n\n";   &print_array(@pools);

  #[10] -> '(tab) ->NAME                         STATE     READ WRITE CKSUM'
  #[11] -> '        b4                           DEGRADED     0     0     0'
  #[12] -> '        (2sp)raidz3-0                   DEGRADED     0     0     0'
  #                       spare-1
  #[13] -> '                replacing-0              UNAVAIL      0     0     0  insufficient replicas'
  #[14] -> '                  c6t5000C5004E94BE1Ad0  UNAVAIL      0     0     0  cannot open'
  #[15] -> '                  c6t5000C50066259F7Ed0  FAULTED      0     0     0  too many errors'
  #[16] -> '            c6t5000C5003CF4B7C1d0    ONLINE       0     0     0'
  #[17] -> '            replacing-2              DEGRADED     0     0     0'
  #[18] -> '              c6t5000C5004E94C6B0d0  UNAVAIL      0     0     0  cannot open'
  #[19] -> '              c6t5000CCA22BD43247d0  ONLINE       0     0     0  (resilvering)'
  #[20] -> '            c6t5000C5004EC60702d0    ONLINE       0     0     0'
  #[21] -> '            c6t5000C5004E94DC7Ed0    ONLINE       0     0     0'

  # basic
  #                   c6t5000C5004E94DC7Ed0

  # get all vdevs per pool for vdev remove
  # [8] -> '         ->test          ONLINE       0     0     0'        # poolname after tab
  # [9] -> '         ->  c2t1d0      ONLINE       0     0     0'        # basic vdev after tab # 2 spaces
  # [10] -> '        ->  c2t2d0      ONLINE       0     0     0'
  # [11] -> '        ->  mirror-3    ONLINE       0     0     0'        # vdev after tab # 2 spaces
  # [12] -> '        ->    c2t3d0    ONLINE       0     0     0'
  # [13] -> '        ->    c2t4d0    ONLINE       0     0     0'

  foreach $p (@pools) {
      $pool=$p;
      $pool=~s/\n.*//s;              # poolname
      if (!($pool=~/\w/)) { next; }  # not a pool (first line in split)

      @l=();
      @l=split(/\n/,$p);


      foreach $l (@l) {
           if (!($l=~/^\t  \w/)) { next; }    # this line is not a vdev
           $l=~s/^\s+//;
           $l=~s/ .*//;      # vdev name only

           $k="all_vdevs_$pool";
           $disk{$k}.="\t$l";
           $disk{$k}=~s/^\t+//;
      }
  }

  #&print_hash(%disk);

  $disk{'all_failed'}="";
  $repl_nr="0";
  foreach $p (@pools) {


           if (!($p=~/state: /s)) { next; }                # first line  of array


           $errors=$p; $errors=~s/.*errors:\s+//s;         # get/ remove errors:
           $p=~s/errors: .*//s;

           @l=();
           @l=split(/\n/,$p);

           $c="0";

           foreach $l (@l) {

                    #find first vdev
                    if (!($l=~/^\t/)) { next; }                 # pool and vdev must start with tab
                                                                # disks tab + "  "
                    $l=~s/^\t//;                                # remove tab

                    if ($l=~/^NAME/)         { $c="1"; next;  } # headline

                    if ($c==0) { next; }                        # header messages


                    if (!($l=~/^  /))  {
                        if (!($l=~/logs|spares|cache/))  { next; }  # ex poolname
                    }

                    if ($l=~/raidz/)            { $v=$l; $v=~s/^\s+//; $v=~s/ .*//;    next; }
                    if ($l=~/mirror/)           { $v=$l; $v=~s/^\s+//; $v=~s/ .*//;    next; }
                    if ($l=~/logs/)             { $v="logs";    next; }
                    if ($l=~/cache/)            { $v="cache";   next; }
                    if ($l=~/spares/)           { $v="spares";  next; }

                   if ($l=~/^  c\d+t\d+|^ \d+$/) {               # vdev: \t + 2 spaces
                       $v="basic";
                   }

                    # replacing            tab + 4/6 spaces
                    #   disk               tab + 6/8 spaces (8 on spare-xx)
                    #   disk2

                        if ($l=~/replacing|spare/) {
                          $repl="1";
                          next;
                        }

                        if ($repl eq "1") {
                             if ($l=~/^      +c*\d/) {            # a replacing disk c1 or 123

                               $t=$l;
                               $t=~s/^\s+//;
                               $t=~s/ .*//;
                               $t=~s/p0$//;
                               $repl_list.="\t$t";
                               $repl_list=~s/^\t+//;
                               $repl_nr++;
                             }
                       }
                       # end of repl/ spare
                       if (!($l=~/^      +\w/)) {
                           if ($repl_nr > 1) {                    # removeable disks only if nr > 0
                                    $disk{'all_replacing'}.="\t$repl_list";
                                    $disk{'all_replacing'}=~s/^\t+//;
                           }

                           $repl="0";
                           $repl_list="";
                           $repl_nr="0";

                       }

                    if ($l=~/^ *c*\d/) {                           # its a normal disk
                         $t=index($l,"c");

                         $t=$l;
                         $t=~s/^\s+//;
                         $t=~s/ .*//;
                         $t=~s/p0$//;                             # allow bootmirror is ex c1t1d0s0, was $t=~s/s0$|p0$//;

                         # add to inuse
                         if (!($disk{'all_inuse'}=~/$t/)) { $disk{'all_inuse'}.="$t\t";   }

                         #add to replaceable
                         if (!($disk{'all_replaceable'}=~/$t/)) { $disk{'all_replaceable'}.="$t\t";  }

                         $key="all_$v";        # vdev type
                         $disk{$key}.="$t\t";

                         $key=$t."_vdev";        #c1.._vdev=type
                         $disk{$key}=$v;

                         if ($v=~/mirror/) {
                               #add to all_mirror
                               if (!($disk{'all_mirror'}=~/$t/)) { $disk{'all_mirror'}.="$t\t";  }
                         }


                         $c=index($l,"c");       # first pos of c
                    }


                    if ($l=~/UNAVAIL/) {           # disk or vdev
                         if ($l=~/^\s+c\d|^\s*\d+/)    {   # its a disk
                              $t=$l;
                              $t=~s/^\s+//;
                              $t=~s/ .*//;
                              $t=~s/p0$//;                          # bootmirror is ex c1t1d0s0

                              $key="all_unavail";
                              $disk{$key}.="$t\t";

                              $key=$t."_state";
                              $disk{$key}="UNAVAIL";

                              #get poolname
                              $key=$t."_pool";
                              $t=$p; $t=~s/\n.*//s;    # poolname
                              $disk{$key}=$t;

                              #failed
                              $disk{'all_failed'}.="\t$t";

                         }
                    }
                    if ($l=~/FAULTED/) {               # disk or vdev
                    #print "Content-type: text/html\n\n113";   &print_var($l);
                         if ($l=~/^\s*\d+.*was /)    {   # its a disk gid like: 7421814458019931978 FAULTED 0 0 0 was /dev/dsk/c3t0d0s0'
                              $t=$l;
                              $t=~s/^\s+//;
                              $t=~s/ .*//;
                              $t=~s/p0$//;

                              $key="all_unavail";
                              $disk{$key}.="$t\t";
                              #print "Content-type: text/html\n\n120";   &print_var($p);

                              $key=$t."_state";
                              $disk{$key}="FAULTED";

                              #get poolname
                              $key=$t."_pool";
                              $t=$p; $t=~s/\n.*//s;    # poolname
                              $disk{$key}=$t;

                              #add to replaceable
                              if (!($disk{'all_replaceable'}=~/$t/)) { $disk{'all_replaceable'}.="$t\t";  }

                         }
                    }

                    if ($l=~/^\s+c\d|^\s*\d+/)    {   # its a disk
                        if ($l=~/OFFLINE|REMOVED|UNAVAIL/) {
                           #failed
                           $t=$l;
                           $t=~s/^\s+//;
                           $t=~s/ .*//;
                           $t=~s/p0$//;                          # bootmirror is ex c1t1d0s0
                           $disk{'all_failed'}.="\t$t";
                        }
                    }
           }

           $disk{'all_failed'}=~s/^\t+//;

           #&print_array(@l);
           #&print_hash(%disk);

           #get pool values
           $pool="";
           foreach $l (@l) {              # list of values from pools

                         if ($l eq "") { next; }
                         $l=~s/^\s+//;

                         #get  poolname
                          if ($pool eq "") {
                                 $pool=$l[0];
                                 if (!($zfs{'allpools'}=~/\b$pool\b/)) {
                                     $zfs{'allpools'}.="$pool\t";
                                 }
                                 if ($pool ne $zfs{'syspool'})  {             # kein syspool
                                   if (!($zfs{'datapools'}=~/\b$pool\b/)) {
                                      $zfs{'datapools'}.="$pool\t";           # tablist
                                   }
                                 }

                                 if ($p=~/\tspecial\b/) {
                                    if (!($zfs{'specialpools'}=~/\b$pool\b/)) {
                                       $zfs{'specialpools'}.="$pool\t";
                                       $t="$pool\_special";
                                       $zfs{$t}="1";
                                       &gethash_sys_special($pool);;  # add special data
                                    }

                                 }

                                 $t="$pool\_config";                     #config state of pool
                                 $config=$p; $config=~s/.*CKSUM\s+$pool\s+//s;
                                 $config=~s/\s+$//s;
                                 $zfs{$t}=$config;

                                 $t="$pool\_errors";                     #config state of pool
                                 $errors=~s/\s+$//s;
                                 $zfs{$t}=$errors;
                                 $l="";
                                 next;
                         }

                         #get id
                         if ($l=~/id: /) {
                                $l=~s/id: //;
                                $t="$pool\_id";
                                $zfs{$t}=$l;                             # tank_id
                                $l="";
                                next;
                         }


                         #get state
                         if ($l=~/state: /) {
                                $l=~s/state: //;
                                $t="$pool\_state";
                                $zfs{$t}=$l;                             # tank_state
                                $l="";
                                next;
                         }

                         #get status
                         if ($l=~/status: /) {
                                $l=~s/status: //;
                                $t="$pool\_status";
                                $zfs{$t}=$l;                             # tank_status
                                $l="";
                                next;
                         }

                         #get action
                         if ($l=~/action: /) {
                                 $l=~s/action: //;
                                $t="$pool\_action";
                                $zfs{$t}=$l;                             # tank_action
                                 $l="";
                                next;
                         }

                         #get scan
                         if ($l=~/scan: /) {
                                $l=~s/scan: //;
                                $t="$pool\_scan";
                                $zfs{$t}=$l;                             # tank_scan
                                $l="";
                                next;
                         }


                         if ($l=~/^$pool\s+/) {                          # poolname ONLINE 0 0 0
                               $l="";
                               next;
                         }


                         #get used disks and pool member                 # if ($l )
                         if ($l=~/^c\d+.*d/) {                           # disk
                               $l=~s/\t/ /g;
                               $l=~s/ +/\t/;                                # disk state
                               $l=~s/ +/\t/;                                # state read
                               $l=~s/ +/\t/;                                # read write
                               $l=~s/ +/\t/;                                # write cksum
                               $l=~s/ +/\t/;                                # cksum info
                               @d=();
                               @d=(split/\t/,$l);                           # c1t8d0 FAULTED 0 0 0 too many errors

                               # add to part

                               if ($d[0]=~/s\d+$|p\d+$/) {
                                    if (!($disk{'all_dsk_with_part'}=~/$d[0]/)) { $disk{'all_dsk_with_part'}.="$d[0]\t";   }

                                    # disk has part
                                    $t=$d[0];
                                    $t=~s/s\d+$|p\d+$//;
                                    $t=$t."_has_part";
                                    $disk{$t}="yes";
                               }


                               $d[0]=~s/p0$//;                           # no slices but mootmirror is ex c1t1d0s0

                               # add to inuse
                               if (!($disk{'all_inuse'}=~/$d[0]/)) { $disk{'all_inuse'}.="$d[0]\t";   }

                               #add to replaceable
                               if (!($disk{'all_replaceable'}=~/$d[0]/)) { $disk{'all_replaceable'}.="$d[0]\t";  }

                               $t="$pool\_members";                         # pool members
                               $zfs{$t}.="$d[0]\t";

                               $t="$d[0]\_state";                           # disk state
                               $disk{$t}=$d[1];
#&print_var("$t -> $d[1]");
                               $t="$d[0]\_pool";                            #disk pool
                               $disk{$t}=$pool;

                               $t="$d[0]\_rwc";                             # disk read write cksum
                               $disk{$t}="$d[2] $d[3] $d[4]";

                               $t="$d[0]\_info";                            # failure info
                               $disk{$t}=$d[5];

                         }

           }
           $v="";                                           # reset vdev type
           $t="$pool\_members";                             # remove last tab
           $zfs{$t}=~s/\t+$//;


  } # end foreach pool

  $zfs{'allpools'}=~s/\t+$//;
  $zfs{'datapools'}=~s/\t+$//;
  $zfs{'specialpools'}=~s/\t+$//;

  $disk{'all_dsk_with_part'}=~s/\t+$//;                         #

  $disk{'all_inuse'}=~s/\t+$//;
  $disk{'all_replaceable'}=~s/\t+$//;

  $disk{'all_replacing'}=~s/\t+$//;

  $disk{'all_basic'}=~s/\t$//;
  $disk{'all_mirror'}=~s/\t$//;
  $disk{'all_raidz'}=~s/\t$//;
  $disk{'all_logs'}=~s/\t$//;
  $disk{'all_cache'}=~s/\t$//;
  $disk{'all_spares'}=~s/\t$//;
  $disk{'all_unavail'}=~s/\t$//;

  #add to %sys
  # print "Content-type: text/html\n\n";
  #&print_hash(%disk);
  #&print_hash(%zfs);

  # !! %disk must not be the up to date, only processed uner disks or pools

}


# eof
1;
