#!
# remote functions for napp-it
# Copyright (c) 2010-2022 napp-it
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require

#last edit: send/ receive >> 2>&1 /tmp/monitor.log
# 4.8.15 call repli send via at now
# 7.11.15 ping timeout 4s
# 29.2.16 wrong key -> unknown member
# 20.6.16 hold n d or n s
# 14.8.16 zraid
# 22.3.17 keep parameter
# 29.6.17 zraid
# 10.1.18 uname -v in overview
# 22.1.18 machine id
# 23. apr 18 send_option, pvsend_limit
# 8. jul 18, allow rpool + BE locally
# 30. aug restore BE to rpool/ROOT
# 26.nov 2018 cluster
# 11.dec 18 acc
# 5. jan 19, remote log
# 26 feb solaris be repli
# 10. mai, backup settings
# 17.mai add ha groupmember
# 28. mai backup/restore iscsi
# 17.7.19 s_opt and r_opt for repli
# 12.8. 19 cluster post script
# 18.10. cluster
# 12.5.2020 daisy chain repli
# 05.08.2020 zfs send requested via taskserver, not at 1895
# 11.3.2021  call z_raid: set multihost=on
# 7. apr 2022  netcat wait timeout configurable in about > settings
# 4. mar include esxi hotsnaps in replication snapsvia soap
###############################

#########
sub grouplib {
###########################
}


##################
sub grouplib_remote_call_zraid {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,@z,$t,$action,$netaction,$netdata,$r,@r,$v,@v,$s,@s,$i,@i);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong, unknow member"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        $netaction=$in{'netaction'};
        $netdata=$in{'netdata'};

        if ($netaction eq "") { $netaction="netaction is missing!"; }
        ############################### actions ################################
        $r="request=$netaction;";

        #remote log
        &grouplib_remote_log("cluster call: $netaction");

        # 1. node_status
        if ($netaction =~/get_.._control_state/) {  # .. ex c1 or h1, b1 s1

           #hostname
             $t=`hostname`;
             chomp ($t);
             $r.="hostname=$t\;";

           #mounted pools, zpool list
             $t=&exe("zpool list -H -o name,size,free,frag,cap,health rpool");   # first
             $t.="<n>";
             $t.=&exe("zpool list -H -o name,size,free,frag,cap,health | grep -v rpool");
             chomp ($t);

             $r.="zlist=$t\;";

           # importable pools
             if ($netaction =~/_c\d|_h\d/) {
               $t =&exe("zpool import | grep -v pool: | grep zraid");     chomp($t);  # only pool state of zpool-1/2
             } else {
               $t =&exe("zpool import | grep -v pool:");     chomp($t);  # all pools
             }

             @t=split(/\n/,$t);
             foreach my $pl (@t) {
               $pl=~s/^\s*//; $pl=~s/\s+/ /; $pl.=", ";
             }
             $t=join("\n",@t);
             $t=~s/, $//;     # zpool-1 ONLINE, zpool-2 DEGRADED
             $r.="importable=$t\;";

           # failovermode auto or manual
             $t="";
             if (-f "/var/web-gui/_log/cluster/settings.txt") {
               $t=&exe("cat /var/web-gui/_log/cluster/settings.txt | grep _failover_mode");
               chomp($t);
               $t=~s/.* |.*://g;
             }
             # add service state
             $s=`sudo ps axw | grep zraid | grep -v grep`;
             if ($s =~/zraid/) { $r.="failover_mode=$t running\;"; } else { $r.="failover_mode=$t\;"; }


           # servermode
             $r.="servermode=$cfg{'select_servermode'}\;";

           # disks
            if ($netaction =~/_c\d|h\d/) {
              $t=`iostat -Enr | grep -v Illegal | grep -v Media`; chomp($t);
              $t=~s/ +,Soft Errors/   S/gs; $t=~s/Hard Errors/ H/gs; $t=~s/Transport Errors/ T/gs;
              $t=~s/ ,/,/gs;
              @t=split(/\n/,$t);
              foreach my $d (@t) {
                $d=~s/<.+>//;       # remove bytes
                $d=~s/Vendor: +//;  # remove
                $d=~s/ +,Product:/, Product:/;  # remove
                $d=~s/ *,Revision.+Serial +/<n>Serial /;  # remove
              }
              $t=join("\n",@t);
              $t=~s/\nc/\n\nc/gs;         # disk new line
              $t=~s/\nSize/ Size/gs;      # no new line
              $r.="disks=$t\;";

              #add status of zraid agent
              if ($netaction =~/_c\d/) {
                $t=`ps axw | grep agent_zraid`;      $t=~s/.*grep agent_zraid//s;
                $r.="agent_zraid=$t\;";
              }
            }

           # zpool status
           if (!($netaction =~/_c\d/)) { # h,s,b
              $t =&exe("zpool status");     chomp($t);  # all pools
              @v=split(/\n/,$t);

              # add product, serial and size
              $i=`iostat -Enr | grep -v Illegal | grep -v Media`;
              chomp($i);
              $i=~s/\nVendor:/ Vendor: /gs;
              $i=~s/\nSize:/ Size: /gs;      # one line per disk

              @s=split(/\n/,$i);
              foreach my $s (@s) {   # iostat values
                    $s=~s/<\d.+>//;  # remove size in bytes
                    $s=~s/\s+,Revision.+Serial No:/ SN /;  # shorten
                    $s=~s/,Soft Errors:/ S:/;              # shorten
                    $s=~s/,Hard Errors:/ H:/;              # shorten
                    $s=~s/,Transport Errors:/ T:/;         # shorten
                    $s=~s/\s+/  /g;
                    $z=$s; $z=~s/ .*//;   # disk ex c1t0d0
                    $s=~s/^c.+S: /S: /;     # without id
                    foreach my $v (@v) {  # status output
                       if ($v=~/$z/) {    # disk found
                             $v.="      $s";
                       }
                    }
              }

              $t=join("\n",@v);
              $r.="status=$t\;";
           }

           #ifconfig, head or control
           if ($netaction =~/_h\d|_c\d/) {
              $t =`sudo /usr/sbin/ifconfig -a`;     chomp($t);  # all ip
              $t=~s/\=/ /gs;                        # = not allowed
              $t=~s/\n\t+inet /  inet /gs;           # single line of ip and link
              $r.="ifconfig=$t\;";
           }

           $r=~s/;$//;

        } #/get state

        #  sync settings
        if ($netaction eq 'sync_cluster_settings') {
             $t=$netdata;  # <n> -> \n with ;_ as delimiter
             $t=~s/<n>/\n/gs;

             `sudo touch /var/web-gui/_log/cluster/settings.txt`;
             &exe("chmod 666 /var/web-gui/_log/cluster/settings.txt");
             open (PF, ">/var/web-gui/_log/cluster/settings.txt");
                       flock(PF, LOCK_EX);
                       print PF "$t";
             close (PF);
             &exe("chmod 644 /var/web-gui/_log/cluster/settings.txt");
             $r="settings updated.";
        }


        if ($netaction eq 'sync_failover_settings') {
             $t=$netdata;  # <n> -> \n
             $t=~s/<n>/\n/gs;
             `sudo touch /var/web-gui/_log/cluster/failover.txt`;
             &exe("chmod 666 /var/web-gui/_log/cluster/failover.txt");
             open (PF, ">/var/web-gui/_log/cluster/failover.txt");
                       flock(PF, LOCK_EX);
                       print PF "$t";
             close (PF);
             &exe("chmod 644 /var/web-gui/_log/cluster/failover.txt");
             $r="settings updated.";
        }


        # sync user ex 100-30000
        if ($netaction eq 'sync_cluster_user') {
                $t=$netdata;
                $t=~s/.*usersave=//;
                $t=~s/;_.*//;

                if ($t=~/^\d\d+\-\d\d+/) {          # ex range 100-65000
                   $r.="<br>user sync $t: ".&grouplib_remote_call_usersave($t);
                }
        }

        if ($netaction eq 'sync_cluster_comstar') {
                $t=$netdata;
                   $r.="<br>Comstar sync: ";
                   $t=&grouplib_remote_call_comstarsave();
                   if ($t eq "") { $r.="done"; } else { $r.="$t"; }
        }

        #  get ping
        if ($netaction eq 'get_ping') {
            $r=&exe("ping $netdata 1");
            $r=~s/\n/<n>/gs;
        }
        #  get ifconfig
        if ($netaction eq 'get_ifconfig') {
            $r=&exe("ifconfig -a");
            $r=~s/\n/<n>/gs;
        }

        # get physical links
        if ($netaction eq 'show_link') {
           $r=&exe("dladm show-link");
           $r=~s/\n/<n>/gs;
        }

        #############################
        # clustermember this shutdown
        #############################

        if ($netaction eq 'clusternode_down') {
           # only if mode= cluster-failover
           $t=`cat /var/web-gui/_log/napp-it.cfg`;
           if ($t=~/cluster\-failover/s) {
                $r="Head to shutdown is in Cluster-Failovermode<br>";

                # unplumb ha ip
                $t=$netdata;
                if ($t=~/ha\-link=\w+/) {
                   $t=~s/.*ha\-link=//;
                   $t=~s/;_.*//;
                   if ($t=~/\w:3/) {
                       $r.="unplumb ha ip $t ";
                       $r.=`ifconfig $t unplumb 2>&1`;
                   }
                }

                #avoid auto-mount of zraid-n in any case
                if (-f "/etc/zfs/zpool.cache") {
                  $t=`cat /etc/zfs/zpool.cache`;
                  if ($t=~/zraid\-\d/s) {
                     &grouplib_remote_log("cluster problem: zpool.cache wants to automount a zraid pool, disable zpool.cache");
                     `sudo cp /etc/zfs/zpool.cache /etc/zfs/zpool.cache.last`;
                     `sudo rm /etc/zfs/zpool.cache`;
                  }
                }

                $r.="<br>";  # extra line prior user and Comstar

                # user save
                $t=$netdata;
                $t=~s/.*usersave=//;
                $t=~s/;_.*//;

                if ($t=~/^\d\d+\-\d\d+/) {          # ex range 100-65000
                   $r.="<br>user backup $t: ".&grouplib_remote_call_usersave($t);
                }

                # Comstar save
                $t=$netdata;
                if ($t=~/comstarsave=yes/) {
                   $r.="<br>Comstar backup: ";
                   $t=&grouplib_remote_call_comstarsave();
                   if ($t eq "") { $r.="done"; } else { $r.="$t"; }
                }

                # initate down when pre_script is finished, latest after 10s
                $r.="<br><br>Initiate fast shutdown via uadmin 2 1 (with filesystem sync) on /temp/node.down, at least after 10s<br>";

                if (-f "/tmp/down.sh")   { `sudo rm /tmp/down.sh`; }
                if (-f "/tmp/node.down") { `sudo rm /tmp/node.down`; }

                `echo '#!/bin/bash' > /tmp/down.sh`;
                `echo 'counter=0' >> /tmp/down.sh`;
                `echo 'while [[ "\$counter" -le 7 ]]; do' >> /tmp/down.sh`;
                `echo '  if [ -f /tmp/node.down ]; then' >> /tmp/down.sh`;
                `echo '       sleep 2s' >> /tmp/down.sh`;
                `echo '       sudo /sbin/zpool sync' >> /tmp/down.sh`;
                `echo '       sudo /usr/sbin/uadmin 2 1' >> /tmp/down.sh`;
                `echo '  else' >> /tmp/down.sh`;
                `echo '       counter=\$((counter+1))' >> /tmp/down.sh`;
                `echo '       sleep 1s' >> /tmp/down.sh`;
                `echo '  fi' >> /tmp/down.sh`;
                `echo 'done' >> /tmp/down.sh`;
                `echo 'sudo /usr/sbin/uadmin 2 1' >> /tmp/down.sh`;
                `chmod 755 /tmp/down.sh`;

                $r.=`sudo /usr/bin/at -s -f /tmp/down.sh now 2>&1`;      # start in background:

                #### go down in latest 10s ###

                # execute pre
                if (-f "/tmp/pre.sh") { `sudo rm /tmp/pre.sh`; }
                $t=$netdata;
                if ($t=~/pre=/) {
                   $t=~s/.*pre=//; $t=~s/\;_.*//;    # shell script
                   $r.="<br><br>Initiate pre-script. <n>";            # \n is <n>

                   # do not allow zfs, zpool, rm, dd, mv
                   if ($t=~/zfs\b|zpool\b|rm\b|mv\b|dd\b/s) {
                      $r.="<br>Warning: Pre script contains unallowed commands like zfs, zpool, rm, mv or dd: cancel pre";
                      `touch /tmp/node.down`;  # go down in 2s
                   } else {
                        #
                        $t=~s/<n>/\n/gs;
                        open (PF, ">/tmp/pre.sh");
                              print PF "$t";
                        close (PF);

                        #backup pre
                        `sudo cp /tmp/pre.sh /zraid-1/backup_appliance/cluster/pre.txt`;

                        `chmod 755 /tmp/pre.sh`;
                         $r.=`sudo sh /tmp/pre.sh 2>&1`;
                         `touch /tmp/node.down`;  # go down in 2s
                   }
                } else {
                   `touch /tmp/node.down`;  # go down in 2s
                }
           } else {
               $r="<br><br>cannot shutdown this head, not set to cluster-failover mode!";
           }
        }

        ##################################
        # set this clustermember to master
        ##################################

        if ($netaction eq 'clusternode_up') {

           # only if mode= cluster-failover
           $t=`cat /var/web-gui/_log/napp-it.cfg`;
           if ($t=~/cluster\-failover/s) {

                $r="Set as master in Cluster-Failovermode and import zraid pools<br>";

                # import pools
                $t=`sudo /usr/sbin/zpool import | grep 'pool: zraid'`;
                @z=split(/\n/,$t);
                foreach my $z (@z) {
                    $z=~s/.*: //;
                    if ($z =~/zraid\-\d/) {
                       $r.="import $z<br>";

                       #rmdir empty regular folder
                       $t=`sudo ls -a /$z 2> /dev/null`;   $t=~s/\s|\.+//gs;
                       $i=`sudo /sbin/zpool list -H -o name`;
                       if (($t eq "") && (!($i=~/$z/s)) )   {  # empty regular pool
                            `sudo rmdir /$z`;                  # empty regular folder with poolname only
                       }

                       $r.=`sudo /usr/sbin/zpool import -f $z 2>&1`;
                       $r.=`sudo /usr/sbin/zpool set cachefile=/var/web-gui/_log/cluster/$z.cache $z 2>&1`;   # do not automount

                       # set multihost to on to avoid multiple mounts
                       $r.=`sudo /usr/sbin/zpool set multihost=on $z 2>&1`;

                       if ($z eq "zraid-1") {
                          $t=$netdata;
                          $t=~s/.*jobs=//; $t=~s/;_.*//;
                          if ((-d "/zraid-1/backup_appliance/cluster/jobs/") && ($t=~/yes/)) {
                            $r.=`sudo cp /zraid-1/backup_appliance/cluster/jobs/*.par /var/web-gui/_log/jobs/`;
                          }
                       }
                    }
                }


                # initate/plumb ha ip
                $t=$netdata;
                if (($t=~/ha-ip=\d+\./) && ($t=~/ha\-netmask=\d+\./) && ($t=~/ha\-link=\w/)) {
                   @v=();
                   $t=~s/.*ha\-link=//; $t=~s/;_.*//; $v[0]=$t;     # if
                   $t=$netdata;
                   $t=~s/.*ha\-ip=//; $t=~s/;_.*//; $v[1]=$t;       # ip
                   $t=$netdata;
                   $t=~s/.*ha\-netmask=//; $t=~s/;_.*//; $v[2]=$t;  # netmask

                   #plumb
                   $r.="<br>assign HA ip<br>ifconfig $v[0] plumb<br>ifconfig $v[0] $v[1] netmask $v[2] up<br>";
                   $r.=`sudo /usr/sbin/ifconfig $v[0] plumb 2>&1`;

                   #ifconfig $if $ip netmask 255.255.255.0 up
                   $r.=`sudo /usr/sbin/ifconfig $v[0] $v[1] netmask $v[2] up 2>&1`;
                }

                # user restore
                $t=$netdata;
                if ($t=~/userrestore=\d+/) {
                   $t=~s/.*userrestore=//;
                   $t=~s/;_.*//;
                   $r.="<br>user restore range: $t ".&grouplib_remote_call_userrestore($t);  # range ex 100-10000
                }

                # comstar restore
                $t=$netdata;
                if ($t=~/comstarrestore=yes/) {
                   $t=~s/.*comstarrestore=//;
                   $t=~s/;_.*//;
                   $r.="<br>Comstar restore: ".&grouplib_remote_call_comstarrestore($t);
                }


                # jobs restore
                $t=$netdata;
                if ($t=~/jobs=yes/) {
                   require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/backup-lib.pl";
                   $r.=&bl_default_bkp_perm("zraid-1");
                   $r.="<br>jobs restore ".`sudo /usr/bin/cp /zraid-1/backup_appliance/cluster/jobs/*.par /var/web-gui/_log/jobs 2>/dev/null`;
                }

                #backup cluster settings
                $t=$netdata;
                if ($t=~/clsettings=/) {
                     $t=~s/.*clsettings=//;
                     $t=~s/;_.*//;
                     $t=~s/<n>/\n/gs;
                     $t=~s/<N>/<n>/gs;             # keep linebreaks in setting
                     open (PF, ">/tmp/cl.tmp");
                              print PF "$t";
                     close (PF);
                     `sudo cp /tmp/cl.tmp /zraid-1/backup_appliance/cluster/settings.txt`;
                     `rm /tmp/cl.tmp`;
                }
                #backup failover settings
                $t=$netdata;
                if ($t=~/fosettings=/) {
                     $t=~s/.*fosettings=//;
                     $t=~s/;_.*//;
                     $t=~s/<n>/\n/gs;
                     $t=~s/<N>/<n>/gs;             # keep linebreaks in setting
                     open (PF, ">/tmp/cl.tmp");
                              print PF "$t";
                     close (PF);
                     `sudo cp /tmp/cl.tmp /zraid-1/backup_appliance/cluster/failover.txt`;
                     `rm /tmp/cl.tmp`;
                }

                # execute post
                $t=$netdata;
                if ($t=~/post=/) {
                   $t=~s/.*post=//; $t=~s/\;_.*//;    # shell script
                   $r.="<br><br>Initiate post shellscript <n>";            # \n is <n>

                   # do not allow zfs, zpool, rm, dd, mv
                   if ($t=~/zfs\b|zpool\b|rm\b|mv\b|dd\b/s) {
                      $r.="<br>Warning: Post shellscript contains unallowed commands like zfs, zpool, rm, mv or dd: cancel post";
                   } else {
                        #
                        $t=~s/<n>/\n/gs;
                        open (PF, ">/tmp/post.sh");
                              print PF "$t";
                        close (PF);

                        &grouplib_remote_log("Cluster post script: $t");

                        #backup post
                        `sudo cp /tmp/post.sh /zraid-1/backup_appliance/cluster/post.txt`;

                        `chmod 755 /tmp/post.sh`;
                         $r.=`sudo sh /tmp/post.sh 2>&1`;
                         `rm /tmp/post.sh`;
                   }
                }

           } else {
               $r="cannot set this head to master mode, server not set to cluster-failover mode!";
           }

        }

        ############################### return values ##########################
        $r=~s/;+$//;
        $r=~s/\n/<n>/gs;
        print "Content-type: text/plain\r\nnapp-it-ok:$r";

        #remote log
        &grouplib_remote_log("cluster result: $r");

        &log("## noid | glib grouplib_remote_call_zraid|request zraid $in{'do'} $netaction from $from||$t","m");
        exit;
}

###########################     save initiated by backupjob, clusteragent or comsar full backup
sub grouplib_remote_call_comstarsave {
###########################
    my ($r,$x);
    my $r=`sudo test -d /zraid-1/backup_appliance/web-gui/_log/iscsi/current && echo 1 || echo 2`;  chomp($r);
    if ($r eq "1") {
        $x=`sudo rm /zraid-1/backup_appliance/web-gui/_log/iscsi/current/*`;
        require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/backup-lib.pl";
        $x=&bl_iscsi_backup_full("zraid-1");     # full backup
        return($x);
    }
    return("backupfolder not found");
}

###########################     full restore with clear
sub grouplib_remote_call_comstarrestore {
###########################
    my ($r,$x);
    my $r=`sudo test -f /zraid-1/backup_appliance/web-gui/_log/iscsi/current/restore.sh && echo 1 || echo 2`;  chomp($r);
    if ($r eq "1") {
        require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/backup-lib.pl";
        $x=&bl_iscsi_restore_full("zraid-1");
        return($x);
    }
    return("/zraid-1/backup_appliance/web-gui/_log/iscsi/current/restore.sh not found");
}



###########################
sub grouplib_remote_call_usersave {
###########################
# cluster failover with user settings failover
my ($r,$range);
$range=$_[0];
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/backup-lib.pl";
$r=&bl_save_user("zraid-1",$range);       # inkl smb
$r.=&bl_save_idmap("zraid-1");

if ($r eq "") { $r="done"; }
return ("$r");

} #/ my_action



###########################     requires a backup job running (man or auto)
sub grouplib_remote_call_userrestore {
###########################
# cluster failover with user settings failover
my ($r,$range);
$range=$_[0];
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/backup-lib.pl";
$r=&bl_restore_user("zraid-1",$range);       #
$r.=&bl_restore_idmap("zraid-1");

if ($r eq "") { $r="done"; }
return ($r);

#debug
#&print_array(@new);


} #/ my_action



######################
sub grouplib_ask_remote_zraid {                #hide:
######################
        #&print_hash(%p);

        my ($host,$t,$f,$i,$n,$noerr,$ref,$netaction,$netdata,@w,$if,$autolog);
        $host=$_[0];
        $noerr=$_[1];
        $ref=$_[3];
        $autolog=$_[4];     # clustermode auto, debug-log

        $noerr="always";    # skip error always

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

       $if=`/usr/sbin/ifconfig -a`;
       if ($if=~/ $host /s)   { $host="127.0.0.1"; }           # local call

       #read access key of host
       $f="/var/web-gui/_log/group";
       `sudo /usr/bin/chmod -R 700 $f`;

       @t=();
       &read_dir("$f","t");
       @w=@t;

       foreach $t (@w) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"t");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                ## actions + data ##
                $netaction=$p{'netaction'};
                $netdata=$p{'netdata'};
                $f="action=rgroup&key=$t[0]&do=request_zraid&hostname=$n&netaction=$netaction&netdata=$netdata";
                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_zraid $netaction,$autolog");

                if ($noerr eq "") {                 # do not stop on error
                  if ($r=~/error/is) {
                       $r=~s/.*error/error/is;
                       &mess("sub ask_remote_zraid $i:<hr>$r");
                  }
                }

                $r=~s/.*napp-it-ok://s;

                if ($autolog eq "1") {
                   #&my_zlog("grouplib log 947 $host, f=$f, netaction=$p{'netaction'}");
                   &my_zlog("grouplib log 947 $host, r=$r, netaction=$p{'netaction'}");
                }
                return ($r);
        }

       if ($autolog eq "1") {
         &my_zlog("grouplib log 954 $host, $r");
       }

        if ($host eq "localhost") {
           return ("only remote actions allowed");
        }
        return ("not a member");
}



###########  ## log last run in jobfile /_log/jobs/id...job
sub grouplib_remote_log {
###########

  my @p1=caller(0); # this:
  my @p2=caller(1); # parent:  package, filename, line, subroutine, hasargs, wantarray, evaltext, is_require, hints, hitmask
  my @p3=caller(2);

  my $rem="/var/web-gui/_log/remote.log";

  my (@v,$v,$n,$l,$f1,$f2,@data);
  my $info="## $sys{'hour'}:$sys{'min'} $sys{'sec'} grouplib $p1[2]: $_[0]";

  # write
  @data=();
      if (-f $rem) {
         open (F,"<$rem");
               flock(F, LOCK_EX);
               @data=<F>;
         close (F);
      }

      $info=~s/\n/<br>/gs;
      unshift(@data,"$info\n");

      if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
      }

      $t=join("",@data);
      open (PF, ">$rem");
          flock(PF, LOCK_EX);
          print PF "$t";
      close (PF);

}

############################
sub grouplib_ask_remote_sync {   # hide: request remote sync transfer
############################

       my $source_host=$_[0];      # sync from
       if (!($source_host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }


       my @vars=split(/,/, $_[1]); # id,source_ip,target_ip,action,source_zfs

       my $noerr=$_[2];            # no stop on error
       my $ref=$_[3];              # sub called from


       my $id=$vars[0];
       my $source_ip=$vars[1];     # my ip to answer
       my $target_ip=$vars[2];     # my ip to answer
       my $r_action=$vars[3];      # initial, delta, kill
       my $source_zfs=$vars[4];    #

       my $target_host=`hostname`; # hostname not ip
       chomp($target_host);

       #read access key of host
       my $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");


       foreach $t (@t) {
                if (!($t=~/^$source_host\~|~$source_host\b/)) { next; }


                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $f="action=rgroup\&key=$p[0]&do=request_sync";
                $f.="&hostname=$target_host";
                $f.="&id=$id";
                $f.="&source_ip=$source_ip";
                $f.="&target_ip=$target_ip";
                $f.="&target_host=$target_host";
                $f.="&r_action=$r_action";                         # remote action
                $f.="&source_zfs=$source_zfs";


                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_zfs_sync 46\n $id $i");

                #log
                $t=$r; $t=~s/\n/, /gs;
                $f=~s/.*do/do/;
                print "glib 60 \&grouplib_ask_remote=$f\n\nresult=$r\n";
                &log("jobid $id | glib 61 request remote zfs sync $i:\n from $source_ip $source_zfs to $target_ip\n action=$f \n\nresult $t\n\n","l");

                if ($r=~/error/is) {
                    $r=~s/.*error/error/is;
                    $r="sub ask_remote_zfs_send:<hr>$r";
                } else {
                    $r=~s/.*napp-it-ok://s;
                }

                return ($r);
        }
        return ("not a member");
}

###################################
sub grouplib_replication_job_delete {      # hide: delete replication job
###################################
    # called from autojob

    my ($r,@w,$w,$snap_var);
    require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/zfslib.pl";

    $sys{'port'}    = 81;
    my $id          = $_[0];
    my $myhost      = $_[1];
    my $host        = $_[2];
    my $source      = $_[3];
    my $destination = $_[4];
    my $snap_rec    = $_[5];

    # delete source snaps
    $r = &grouplib_ask_remote_snaplist("$host");
    @w = split (/,/,$r);
    foreach $w (@w) {
        if (!($w=~/$source\@$id\_repli_zfs_$myhost\_/)) { next; }
        $w=~s/\ .*//;
        $w=~s/$source\@$id\_repli_zfs_$myhost\_//;
        $snap_var="snap_name=$source\@$id\_repli_zfs_$myhost\_$w\n";
        $snap_var.="snap_rec=$snap_rec\n";
        &grouplib_ask_remote_destroy_snap ("$host", $snap_var);
    }

    # delete destination snaps
    $r = &zfslib_list_datasnaps ("l");
    @w = split (/,/,$r);
    foreach $w (@w) {
        if (!($w=~/$destination\@$id\_repli_zfs_$myhost\_/)) { next };
        $w=~s/\ .*//;
        $w=~s/$destination\@$id\_repli_zfs_$myhost\_//;
        &exe ("zfs destroy $snap_rec $destination\@$id\_repli_zfs_$myhost\_$w");
    }
}


########################
sub grouplib_replication {  # hide:      first time/ incremental replication  from 0.8
#######################
 ###obsolet
 &mess("group_replication: obsolete");  # separate job-script
}

#################################
sub grouplib_start_zfs_receiver {   #  start zfs receiver
#################################
    my (@vars,%vars,$do,$k,$v,$r,$w,@w,$timer,$p,@lr,$lr,$cmd,@s,$s);
    %vars = ();
    @vars=split (/\n/, $_[0]);
    foreach $v (@vars) {
        if (!($v=~/\=/)) { next; }
        chomp($v);
        $k=$v; $k=~s/\=.*//;
        $k=~s/[^a-zA-Z0-9\-\_]//g;
        if ($k ne "") {
            $v=~s/.*\=//;
            $vars{$k} = $v;
        }
    }

    #auto_error_log
       &log("jobid $vars{'id'} | glib grouplib_start_zfs_receiver 550 <br> init receiver $vars{'id'} | zfs receive $vars{'reset_to_snap'} $vars{'dest_zfs'} ","lmp");

   # local transfer # receiver is implemented in remote_call_zfs_send   (netcat locally only ok on Nexenta)
   ##################
   if ($vars{'host'} eq $vars{'myhost'}) {

       $in{'myhost'}=$vars{'myhost'};
       &log("jobid $vars{'id'} < glib grouplib_start_zfs_receiver 550|init local transfer $vars{'id'}","mpl");
       return "OK";
   }
   #### / local


   ## receive options
   ##################
   $p="";
   $timer = time();
   if ($vars{'dest_zfs'}=~/\/\w+/)   {
        # call perlsript post_replication (shares off/ opt on, set ro)
        $p=" \&\& perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/post_replication.pl $vars{'id'} $timer || perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/post_replication.pl $vars{'id'} error";
   }

  $cmd="$vars{'dest_interface'} | /usr/sbin/zfs receive $vars{'reset_to_snap'} $vars{'dest_zfs'} >>/tmp/monitor.log 2>&1$p";


   #######
   #run it, (do not restart if running!)
   #######

   # Nexenta NCP and OI/SE11 behaves different
   #######################################

   if ($sys{'auto_os_type'} eq "osol_n") {
       #Nexenta
       $cmd=~s/ -d / /;           # nc -d -l is not allowed, use nc -l only
   }
   $cmd=~s/sudo //g;
   $cmd=~s/ +/ /g;
   #########################################



   #Run via file:
         open (PF, ">/var/web-gui/data/napp-it/_log/tmp/$vars{'id'}\.request_sh");
               print PF "$cmd\n";
         close (PF);


&log("jobid $vars{'id'} | glib grouplib_start_zfs_receiver 599 | console cmd|$cmd","mpl");
sleep (1);

#return "OK";

# wait until receiver is running
################################

my $once="1";

   @lr = split(/\+\+/,$vars{'local_running_ps'});
   my $pscount=@lr;
   $timer = time() + 60;                                   # Wait long enough, especially needed with more than one replication

   do {
        $run = "";
        foreach $lr (@lrdo) {
            $r = &exe("ps axw");
            @w=();
            @w = split(/\n/,$r);

            if ($once) { &log("jobid | $vars{'id'} glib repli 600 \: check $lr","pl"); $once="0"; }
            $r = "";
            foreach $w (@w) {
                if ($w=~/sudo/)   { next; }
                if ($w=~/grep/)   { next; }
                if (!($w=~/$lr/)) { next; }
                $r .= "1";
                $t= time(); $t= $t - ($timer - 60);
                &log("$vars{'id'} | glib repli 608 \: found $w after $t s","pl");

            }
            $run .= $r;
        }
        sleep (2);

   } until ((length($run) == $pscount) or (time() >= $timer));

$t= time(); $t= $t - ($timer - 60);
&log("$vars{'id'}| glib grouplib_start_zfs_receiver 640 <br> start receiver |receiver started after $t s","pl");
#$run=@lr;
#&print_var($run);

   #log
       my $pid=`ps axw`;
                @t=();
                @t=split(/\n/,$pid);
                $pid="";
                foreach $t (@t) {
                   if ($t=~/$p|$vars{'dest_zfs'}/) {
                      $pid.="\n$t";
                   }
                }
                if ($pid eq "") { $pid=" -check local ps for this job; ok, none"; }
                &log("$vars{'id'} | glib repli 633 $vars{'id'}\: \nlocal ps=\n$pid\n\ncmd=\n$cmd\n","pl");


    $t=length($r);
    if ($t < @pscount) {
        &log("$vars{'id'} | glib *** grouplib_start_zfs_receiver 660| could not start receiver","ampl");
        return "Error: could not start receiver!";
    } else {
        &log("$vars{'id'} | glib grouplib_start_zfs_receiver 663|receiver  | receiver started successfully","mpl");
        return "OK";
    }
}

###########################
sub grouplib_source_target {   #  get source and target of a replication
###########################
    my (@source,@target,$s,$t,@g,$g,$r,@w,$w,$hostname,@h,$v);

    # always a member
       $hostname=`hostname`;
       chomp($hostname);


    #read list of groups-members
       $t="/var/web-gui/_log/group";
       @t=();
       &read_dir("$t","t");
       foreach $t (@t) {
                if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }                #np group member
                $t=~s/~/ /; $t=~s/\.txt$//;
                push (@g,"$t");
       }

       if ($in{'autoselect_host'} eq "") { $in{'autoselect_host'}="$hostname 127.0.0.1"; }        #default

       #zfs list (source)
       if ($in{'autoselect_host'} eq "$hostname 127.0.0.1") {
         $r=&exe("zfs list -t filesystem,volume | grep -v rpool");
         $r.="\n";
         $r.=&exe("zfs list -t filesystem,volume | grep rpool | grep -v ROOT");

         @w=split(/\n/,$r);
#&print_array(@w);
         foreach $w (@w) {

            $w=~s/\s.*//;
            if ($w eq "NAME") { next; }

            if ($w eq "$zfs{'syspool'}") { next; }               # not rpool itself
            if ($w=~/^$zfs{'syspool'}\//) {
                 if ($w=~/\/export|dump|swap|VARSHARE/) { next; }   # VARSHARE on Solaris
            }

            push (@source,$w);
         }

         # add current BE for local transfers only
         $t=&exe("beadm list | grep ' N' | grep -v ' Name'");     # -v ' Name' required on Solaris 11.4, 26.2.19
         chomp($t); $t=~s/\s.*//;
#&mess($t);
         push (@source,"$zfs{'syspool'}/ROOT/$t");                # N = curreNt BE

         @target=@source;
         push(@target,$zfs{'syspool'});
         push(@target,"$zfs{'syspool'}/ROOT");


       } else {        # remote source

            $w=$in{'autoselect_host'}; $w=~s/ .*//;                #hostname only
            $r=&grouplib_ask_remote_zfslist($w,"","","grouplib_source_target 709");            #commalist
#&mess($r);
            @w=split(/,/,$r);
            foreach $w (@w) {
              $w=~s/\s.*//;
              push (@source,$w);
            }

            #get target
            $r=&exe("zfs list -H -o name -t filesystem | grep -v rpool");
            $r.="\n";
            $r.=&exe("zfs list -H -o name -t filesystem | grep rpool");
            @w=split(/\n/,$r);
            foreach $w (@w) {
                    $w=~s/\s.*//;
                    if ($w eq "NAME") { next; }

                    if ($w=~/^$zfs{'syspool'}\b/) {
                       if ($w=~/\/export|\/ROOT/) { next; }
                    }

                    push (@target,$w);
            }

       }

       #form source

        if ($in{'changed'} eq "")  { $in{'checkbox'} ="a,c"; }


        print "<div class='info'>$txt{'jobs_replicate_info'}</div><br>";

        &ask('begin','b');

        print " <b style='background-color:#dddddd'>Replication from:</b><br>";
        print "<font style='color:red'>Do not</font> auto-snap source filesystems with delzero=yes.<br><br>";

         $g=join(",",@g);
        &ask('autoselect_host','Source host',$g,$in{'autoselect_host'});
         $s=join(",",@source);
        &ask('select_src_zfs','Source Pool/ ZFS',$s,$in{'select_src_zfs'});

        print "it is suggested to disable recursiv and create multiple jobs as an interupt may lead to do inconsistent snap states";
        &ask('checkbox_recursive','enable recursiv','enable',"disable");             # war $in{'checkbox_recursive'}

        print "Incremental send: only newest data (-i) or include all intermediary snapshots and clones(-I)<br>With -I you may need to destroy intermediate snaps manually on replication problems!";
        &ask('select_send_i','zfs send incremental snapshot option','-i,-I');

        print "do a test prior using the dedup option";
        &ask('checkbox_dedup','zfs send with dedup option -D','enable',$in{'checkbox_dedup'});

        print "<br> <b style='background-color:#dddddd'>Replicate to Localhost</b><br>";


        $t=join(",",@target);
        &ask('select_dest_zfs','to ZFS folder(s) below',$t,$in{'select_dest_zfs'});
        &ask('value_zfs_name','Name of new ZFS (empty=same)',$in{'value_zfs_name'});

        print "<br> <b style='background-color:#dddddd'>Options:</b><br><br>";
        &ask('select_type','Replication type','zfs send via netcat',$in{'select_type'});
#        &ask('select_type','Replication type','zfs send via mbuffer,zfs send via netcat',$in{'select_type'});

        &ask('value_pv_limit','Limit throughput for zfs send over pv<br></b>ex \'-L 300k\'<b>',$in{'value_pv_limit'});
        &ask('value_zfs_sendopt','zfs send options <br></b>ex raw send \'-w\' or \'--raw\' to send an encrypted raw filesystem <br>on current OI/OmniOS or -p to include properties<b>',$in{'value_zfs_sendopt'});
        &ask('value_zfs_recopt','zfs receive options <br></b>ex -u (do not mount received filesystem)<b>',$in{'value_zfs_sendopt'});

        # daisy chain, todo
        #&ask('value_zfs_daisy','Daisy chain replication job id<br></b>based on this replication as source<b>',$in{'value_zfs_daisy'});

        # esxi hotsnaps via soap
        &ask('value_esxi','This filesystem is a NFS datastore for ESXi server with ip<br></b>to include ESXi restorable hotmemory snaps in ZFS snaps<br>Setup in menu System > ESXi > NFS datastores<b>',$in{'value_esxi'});

        &ask('value_zfs_share','SMB share destination as',$in{'value_zfs_share'});
        &ask('checkbox_guest','SMB share guest access','enable',$in{'checkbox_guest'});
        &ask('checkbox_abe','SMB share ABE (show only permitted files)','enable',$in{'checkbox_abe'});

        # only needed to recreate job
        &ask('value_force_id','Force jobid (recreation only, otherwise keep empty)',$in{'value_force_id'});

        #keep
        print "<br>";
        if ($in{'value_keep'} eq "") { $in{'value_keep'}="hours:24,days:32,months:3,years:0"; }
        $t="hours:n, (one per last n hours)<br>days|months|years:n, (one per n last days|months|years)<br>ex hours:48,days:32,months:12,years:2";
        &ask('value_keep',"Keep target repli snaps (commalist of values or char)<br></b>$t<b>",$in{'value_keep'});
        &ask('value_hold','Hold target repli snaps for n (days) or n s (snaps), optional<br></b>ex 8 = 8days or 8s = 8 snaps, keep empty to hold last two snaps<b><br><br>Keep and hold are both respected <br><font style=\'color:red\'>but not working with recursive replications</font>',$in{'value_hold'});

        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";
        if (!($cfg{'ver'}=~/r|c/)) {
            &ask('select_month','If you want to use timetables and remote replication, <br>you must register the replication extension.','manual','manual');
        } else {

           &ask('select_month','Month (1..12)','every,every-2,every-3,every-4,every-6,1,2,3,4,5,6,7,8,9,10,11,12','every');
           &ask('select_day','Day (1..31 sun..sat)',',every,every-2,every-3,every-7,every-14,every/1,mon-fri,mon-sat,sat-sun,first-sat,first-sun,sun,mon,tue,wed,thu,fri,sat,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','every');
           &ask('select_hour','Hour (0..23)','every,every-1BC,every-2,every-2BC,every-3BC,every-4,every-6,every-6BC,every-12,every/0,every/23;0;1,0,3,6,7,8,9,10,11,12,13,14,15,16,17,18,19,22,23,8;12;16,8;10;12;14;16;18,8;11;14;17;20,0;6;12;18','23');
           &ask('select_min','Minute',',every,every-5,every-15,every-20,every-30,every/0,15;45,0,15,30,45,once','0');

           print "<br>\n";
           &ask('select_status','Status','manual,active','manual');
        }

        &ask('hidden','changed','1');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2, every-3,every-4, every-6";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br>minute=once means: execute job once after each reboot";
        print "<br><br>Your source/target must have different hostnames and should not change IP";
        print "<br>Your target ZFS is read-only after replication. After disabling replication, you can set it to read/write and use it at usual";
        print "</div><br><br>";

        &ask('end');    # create job , start it manually
        print "<br>Replication is speed optimized. <br>If you want to replicate over unsecure networks like Internet, a VPN link or encrypted send is suggested!<br>\n";
        print "An optional script ../jobs/jobid.pre or ../jobs/jobid.post is executed prior or post a replication automatically";




#print_array(@source);


}

##################
sub grouplib_remote_stat {        # hide:
################# basic stats like cap, pool or job error

   #pool stat
   my ($stat,$n,@c,$u,$a,$t,$m,$col);
   my $ant=`sudo $sys{'sbinpath'}zpool list -H -o name`;
   chomp($ant);
   my @p=split(/\n/,$ant);
   my @pools=();

   #first rpool then rest
   if ($sys{'auto_os'} ne "Linux") {
      push(@pools,"rpool");
   }
   @p=sort(@p);

   foreach my $p (@p) {
       if ($p eq "rpool") { next; }
       push(@pools,$p);
   }
   my $pu="";  # p_used
   my $ps="";  # p_stat

   foreach my $p (@pools) {

           # status
           $ant=`sudo $sys{'sbinpath'}zpool status $p`;
           chomp($ant);


           if ($p eq "rpool") {
              if ($ant=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/s) {
                 $stat.=" r_stat: <img src=\"/_doc/red.png\" title=\"rpool status error\" style='margin-right:10px'> ";
              } else {
                 $stat.=" r_stat: <img src=\"/_doc/green.png\" title=\"rpool status ok\" style='margin-right:10px'> ";
              }
           } else {
                $t="";
                if ($ant=~/OFFLINE/)  { $t="OFFLINE";  }
                if ($ant=~/DEGRADED/) { $t="DEGRADED"; }
                if ($ant=~/UNAVAIL/)  { $t="UNAVAIL";  }
                if ($ant=~/FAULTED/)  { $t="FAULTED";  }
                if ($ant=~/REMOVED/)  { $t="REMOVED";  }

                if ($t ne "") {
                   $ps.="pool $p: $t, ";
                }
           }

           #cap
           $ant=`sudo $sys{'sbinpath'}zfs list -H -o used,avail $p`;
           chomp($ant); $ant=~s/\s+/ /g;
           @c=split(/ /,$ant);
           $u=&grouplib_kb($c[0]);
           $a=&grouplib_kb($c[1]);

           $t=$u/($u+$a); $t=$t*100; $t=sprintf ("%.0f", $t);         # percent used

           # debug
           # $stat.=",p=$p,c0=$c[0],c1=$c[1],u=$u,a=$a,t=$t %";

           if ($p eq "rpool") {
                $col="green.png";
                if ($t>70) { $col="yellow.png"; }
                if ($t>85) { $col="red.png"; }
                $stat.=" r_used: <img src=\"/_doc/$col\" title=\"rpool used=$t%\" style='margin-right:10px'>";
           } else {
                if ($t>$m) { $m=$t; $pu.="pool $p\: $t\%, "; }                      # max pool used
           }
   }

   $ps=~s/, $//;
   if ($ps ne "") {
        $stat.=" p_stat: <img src=\"/_doc/red.png\" title=\"$ps\" style='margin-right:10px'> ";
   } else {
        $stat.=" p_stat: <img src=\"/_doc/green.png\" title=\"datapool status ok\" style='margin-right:10px'> ";
   }


   if ($m>0) {
            $pu=~s/, $//;
            $col="green.png";
            if ($t>70) { $col="yellow.png"; }
            if ($t>85) { $col="red.png"; }
            $stat.=" p_used: <img src=\"/_doc/$col\" title=\"$pu\" style='margin-right:10px'>";
   }

   # joberr
   # jobinfos id.par
        @t=();
        @t=&get_dir('/var/web-gui/_log/jobs/');

        my $tmp="";
        my ($id,$j);
        foreach my $t (@t) {

            # check in id.par if status=active
            if (!($t=~/\.par$/))      { next; }

            $id=$t; $id=~s/\..*//; chomp($id);                         # jobid

            #

            # check if status=active
            $j=`cat /var/web-gui/_log/jobs/$t`;
            if (!($j=~/status=active/s))  { next; }                    # job is not active

            # check laststate
            if (!(-f "/var/web-gui/_log/jobs/$id.log"))       { next; }                    # no log
            $j=`cat /var/web-gui/_log/jobs/$id.log`;

            #check if log starts with error
            if ($j=~/^error/) {
               $j=~s/\n.*//s;
               $tmp.="$id,";
            }
        }
        if ($tmp eq "") {
             $stat.=" jobs: <img src=\"/_doc/green.png\" title=\"active jobs: no error\" style='margin-right:10px'>";
        } else {
             $stat.=" jobs: <img src=\"/_doc/red.png\" title=\"active jobs with errors\" style='margin-right:10px'>";
        }
    ##
    $stat=~s/^,//;
    return("$stat");

}

sub grouplib_kb {
#################
      my $w1=$_[0]; $w1=~s/ //g;
      if ($w1=~/K/) { $w1=~s/K//;  }
      if ($w1=~/M/) { $w1=~s/M//; $w1=$w1*1000; }
      if ($w1=~/G/) { $w1=~s/G//; $w1=$w1*1000000; }
      if ($w1=~/T/) { $w1=~s/T//; $w1=$w1*1000000000; }
      if ($w1=~/P/) { $w1=~s/P//; $w1=$w1*1000000000000; }
      return ($w1);
}

##################
sub grouplib_remote_call {                # hide:
##################

        #############################################
        # this part is called by other napp-it server
        # to answer remote calls
        #############################################

        # actions #########
        # do="" -> return ok:napp-it
        # do=request_membership (pw=adminpw) -> return napp-it-ok:$name=$access (access key from ip+pw)
        #############################################

        # called when:  action=rgroup by sub nasgroup_change_property in nasgroup-lib.pl
        #############

        # other parameter
        # do=        request (request membership)        with ip + pw (admin)
        my ($ver,$status,$r);



#ask if napp-it?
################
        if ($in{'do'} eq "") {

                # version like OmniOS, OpenIndiana or Solaris + Mainrelase  + subrelease
                # ex Solaris 11.3
                # OmniOS 151024 c23a3tg
                # OpenIndiana 2017.10 2675353

                # get mainrelease
                $r=`cat /etc/release`;
                $r=~s/\n.*//s;
                $r=~s/^\s+//; # leading spaces

                $ver=$r;      # default

                #omni  OmniOS v11 r151024  -> OmniOS r151024
                if ($r=~/OmniOS/i) {
                   $r=~s/ v\d+//;
                   $ver=$r;

                   # add subrelease
                   $r=`uname -v`; chomp($r);     # omnios-r151024-c2a1589567
                   $r=~s/omnios//; $r=~s/r151\d+//; $r=~s/\-+//g;
                   $ver .=" ($r)";                 # OmniOS r151024 (c2a12..)
                }

                #OI  OpenIndiana Hipster 2017.10 (powered by Illumos)
                if ($r=~/OpenIndiana/i) {
                   $r=~s/ Hipster//i;
                   $r=~s/ \(.*//;
                   $ver=$r;                      # OpenIndiana 2017.10

                   # add subrelease
                   $r=`uname -v`; chomp($r);     # illumos-27746d6
                   $r=~s/illumos//;  $r=~s/\-+//g;
                   $ver .=" ($r)";                 # OpenIndiana 2017.10 (c2a12..)
                }

                #Solaris  Oracle Solaris 11.3 X86
                if ($r=~/Solaris/i) {
                   $ver="Solaris";               # Solaris

                   # add subrelease
                   $r=`uname -v`; chomp($r);     # 11.3
                   $ver .=" $r";                 # Solaris 11.3
                }

                # add napp-it version
                if ($sys{'version'} eq "") {
                    $ver.=", app. n.a.";
                } else {
                    $ver.=", app. $sys{'version'}";
                }
                if ($sys{'auto_os'} eq "Linux") { $ver ="<b>Linux</b>"; }


                #add ext
                if ($cfg{'ver'} ne "") {
                     $ver.=" ,$cfg{'ver'}\t";

                     if ($cfg{'ver'}=~/c|m/) {
                          #stat
                          $ver.=&grouplib_remote_stat;
                     }
                     #&log("noid| grouplib 593 remote call status|request status","m");
                } else {
                     $ver.="\t p_stat: <img src=\"/_doc/grey.png\" title=\"monitor extension required\" style='margin-right:10px'>";
                     $ver.=" r_stat: <img src=\"/_doc/grey.png\" title=\"monitor extension required\" style='margin-right:10px'>";
                     $ver.=" r_used: <img src=\"/_doc/grey.png\" title=\"monitor extension required\" style='margin-right:10px'>";
                     $ver.=" p_used: <img src=\"/_doc/grey.png\" title=\"monitor extension required\" style='margin-right:10px'>";
                     $ver.=" jobs: <img src=\"/_doc/grey.png\" title=\"monitor extension required\" style='margin-right:10px'>";
                     &log("noid| grouplib 600 remote call | require extension","m");
                }

                #get/ return basic status
                $status=$ver;                                # was ok$ver

                print "Content-type: text/plain\r\nnapp-it-ok:$status";
                exit;
        }  else {
                &log("noid| grouplib 889 remote call | do=<br> $in{'do'}","m");
        }

        #log##
       # &log("grouplib_remote_call 838|||$in{'do'}","lm");                #opt


# request zraid functions
##############
        if ($in{'do'} =~/request_zraid/) {
            &grouplib_remote_call_zraid;     #
            exit;
        }

# request sync
##############
        if ($in{'do'} eq "request_sync") {
            &grouplib_remote_call_sync;
            exit;
        }

#request membership from other system?
######################################
        if ($in{'do'} eq "request_membership") {
            &grouplib_remote_call_membership;
            exit;
        }
#request pslist?
################# with key but only form host from /group/filename

        if ($in{'do'} eq "request_pslist") {
            &grouplib_remote_call_pslist;
            exit;
        }
#request zfslist?
################# with key but only form host from /group/filename

        if ($in{'do'} eq "request_zfslist") {
            &grouplib_remote_call_zfslist;
            exit;
        }
#request zfs_send?
##################
        if ($in{'do'} eq "request_zfs_send") {
            &grouplib_remote_call_zfs_send;
            exit;
        }
#request get_my_ip?
###################
        if ($in{'do'} eq "request_get_my_ip") {
            &grouplib_remote_call_get_my_ip;
            exit;
        }
#request destroy_snap?
######################
        if ($in{'do'} eq "request_destroy_snap") {
            &grouplib_remote_call_destroy_snap;
            exit;
        }
#request destroy_proc?
######################
        if ($in{'do'} eq "request_destroy_proc") {
            &grouplib_remote_call_destroy_proc;
            exit;
        }

        exit;
}


######################################
#request membership from other system?
######################################

##################
sub grouplib_remote_call_membership {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$t);


        $from=$ENV{'REMOTE_ADDR'};
        $name=`hostname`;
        chomp($name);

        #pw ok?
        if ($cfg{'value_adminpw'} ne "") {
           $pass=&gethash("admin",$in{'pw'});

           if ($cfg{'value_adminpw'} ne "$pass" ) {
              print "Content-type: text/plain\r\nok:request_membership:wrong admin password for $name";
              exit;
           }
        }

        #pw ok -> return accesspw bound to ip
        $access=&gethash("ad",$from);
        if ($access=~/^\$/) { $access=~s/.*\$//; }

        $t=&gethash("ad",$in{'pw'});
        if ($t=~/^\$/) { $t=~s/.*\$//; }
        $access.=$t;

        #write access key to /group/hostname~ip.txt
        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";

        # cluster mirror
        if ($in{'aid'} =~/\w+/) { $access=$in{'aid'}; }

        # $access="access=$in{'aid'}"; #debug
        &str2file("$access","$file");

        print "Content-type: text/plain\r\nnapp-it-ok:$name=$access";

         &log("## noid |  glib grouplib_remote_call_membership 923|request membership $from||ok $name","mr");

        exit;
}




#request zfslist?
################# with key but only form host from /group/filename

##################
sub grouplib_remote_call_pslist {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$t);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong, unknow member"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        #get ps list
                $r=`sudo ps axw`;

                @t=();
                @t=split(/\n/,$r);
                $r="";
                $t="";
                foreach $z (@t) {
                          $z=~s/^ +//;
                          if ($z=~/^PID/)              { next; }
                          $z=~s/ .*\d:\d\d /  /;        # pid command
                          $z=~s/\;\;//g;

                          # only zfs, mbuffer,rsync,cp,nc
                          if (!($z=~/zfs |mbuffer |rsync |\bcp |\bnc /))  { next; }
                          $r.="$z".";;";           # trennzeichen
                          $t.="$z\n";
                }

               #opt. log to replicate-log
               #open (PF, ">>/var/web-gui/data/napp-it/_log/last_replication.log");
               #   print PF "\n\n###sub grouplib_remote_call_zfs_pslist_return value###\n$r\n";
               #close (PF);


        $r=~s/;+$//;
        print "Content-type: text/plain\r\nnapp-it-ok:$r";

        &log("## noid | glib grouplib_remote_call_pslist 986|request pslist $from||$t","m");
        exit;
}

##################
sub grouplib_remote_call_zfslist {                # hide:         answer
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$t,$be);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong, unknow member"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        #get zfs/ snap list
                if ($in{'type'}=~/snap/) {
                                $r=&exe("/usr/sbin/zfs list -r -o name,used,avail,refer -t snapshot -S creation");   #newest first
                } else {
                                $r=&exe("/usr/sbin/zfs list -t filesystem,volume");
                }
                @t=();
                @t=split(/\n/,$r);
                $r="";
                $t="";
                foreach $z (@t) {
                           if ($z=~/^syspool\b/)              { next; }
                           if ($z=~/^rpool\b/)                { next; }
                           if ($z=~/^NAME\s/)                 { next; }
                           $r.="$z,";
                           $t.="$z\n";
                }

               # add current BE for remote replication, can be a security problem, so disable per default
               #$be=&exe("beadm list | grep ' N'");
               #chomp($be); $be=~s/ .*//;
               #$be="$zfs{'syspool'}/ROOT/$be";                # N = curreNt BE
               #$t.="$be\n";

        $r=~s/,+$//;
        print "Content-type: text/plain\r\nnapp-it-ok:$r";

        &log("## noid | glib 1067 <br> grouplib_remote_call_zfslist|request zfslist ($in{'type'}\) $from|||","mr");
        exit;
}


##################
sub grouplib_remote_call_sync {                # hide:
##################

        my $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        my $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong, unknow member"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        if ($in{'id'} eq "") {
             print "Content-type: text/plain\r\nnapp-it-ok:id is missing"; exit;
        }

        ############
        # part 1 create snap
        ############

        # delete this snap if already exist due to an former error
        # zfs@job_sync_repli_target_host

        my $name="$in{'id'}"."_sync";
        $name=~s/^\/+//;        # pool/zfs

        my $r=`sudo /usr/sbin/zfs list -t snapshot -H -o name | grep $name`;

        $name="$in{'source_zfs'}\@$in{'id'}"."_sync_repli_$in{'target_host'}";
        $name=~s/^\/+//;        # pool/zfs

        if ($r=~/\@/) {
           &log("jobid $in{'id'} | glib 1115 <br> request snapdel | del old dnap <br> $name","mr");
           $r=`sudo /usr/sbin/zfs destroy -f $name`;
        }

        $r=`sudo /usr/sbin/zfs snapshot $name`;       # crete new snap
        &log("jobid $in{'id'} | glib 1121 created snap<br> zfs snapshot | create snap <br> $name <br>$r","mr");

        ###########################
        # part 2 start initial sync
        ###########################   source: $s="$source_zfs/.zfs/snapshot/$job\_sync_repli_$target_host";

        my $port=&port_from_id($in{'id'});

        my $s="/$in{'source_zfs'}/.zfs/snapshot/$in{'id'}\_sync_repli_$in{'target_host'}";
        $s=~s/^\/+/\//;

        # log folder
        $t=`sudo ls $s/.`;
        $t=substr($t,0,200); $t=~s/\n/<br>/gs; $t.=" ...";

        &log("jobid $in{'id'} | glib 1134 folders in <br>$s  | $t","mr");


        my $cmd="cd $s\n /usr/sbin/tar cpf - ./ | /usr/bin/nc $in{'target_ip'} $port\n";
        $cmd.=" rm /var/web-gui/data/napp-it/_log/jobs/$in{'id'}\~remote~initiated.job";


         # create job in joblist
         `touch /var/web-gui/data/napp-it/_log/jobs/$in{'id'}\~remote~initiated.job`;


        #1. optional, delete running send job (must be an error)

            $r = `ps axw | grep nc.*$port`;
            if ($r ne "") {
                 @t=();
                 @t=split(/\n/,$r);
                 foreach my $t (@t) {
                    &log("jobid $in{'id'} | glib 952<br> kill |$t ","r");
                    $t=~s/^\s+//;
                    $t=~s/ .*//; # keep nr
                    print "old process: kill -9 $t\n";
                    `sudo kill -9 $t`;
                 }
            }


         # 2. Run via file and background agents:
         open (PF, ">/var/web-gui/data/napp-it/_log/tmp/$in{'id'}\.request_sh");
               print PF "#!/bin/sh\n";
               print PF "$cmd\n";
         close (PF);

     #debig
     # `sudo cp /root/a.sh /var/web-gui/data/napp-it/_log/tmp/1338226601.request_sh`;
     #    $r=`sudo nohup sh /tmp/$in{'id'}\_sync_request.sh &`;
     #   $r=`sudo nohup sh /tmp/a.sh &`;


      # start sender once
         $cmd=~s/\|/I/gs;
         &log("jobid $in{'id'} | glib 1166<br> try to start sync sender jobid<br>wait 50s<br>$r  | $cmd","mlr");
         &log("jobid $in{'id'} | glib 1168 <br> result<br>$r","ml");


      sleep(5);

      $r="";
      #check for nc .. port
      my $timer = time() + 50;
      do {
         $r = `ps axw | grep nc.*$port`;
         @t=();
         @t=split(/\n/,$r);
         $r="";
         foreach $t (@t) {
           if ($t=~/grep/) { next; }
           $r.="$t\n"
         }
         sleep (2);
      } until (($r ne "") or (time() >= $timer));

      # to debug, start receiver then sender script manually
      #if (-f "/var/web-gui/data/napp-it/_log/sender.sh") {
      #     print "Content-type: text/plain\r\nnapp-it-ok:";
      #     exit;
      #}
      #/debug
      #######

       print "Content-type: text/plain\r\nnapp-it-ok:";               # no return value

       if ($r ne "") {
          $r.= `ps axw | grep /usr/sbin/tar `;
          &log("jobid $in{'id'} | glib 1193<br> sync sender  started: ok | $r","mlr");
       }  else {
          &log("jobid $in{'id'} | glib 1195<br> start sync sender jobid $in{'id'} failed | process nc.*$port<br> not found <br>error: sender not started","mlpra");
       }

}




#request zfs_send?
##################
##################
sub grouplib_remote_call_zfs_send {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$cmd,$p,$timer,$used,$t);

# log
#####

## basics
#########

        $from=$ENV{'REMOTE_ADDR'};

        &grouplib_remote_log("$from remote call zfs send $in{'id'} initiated from $from<br>_________________________________________________________<br>");

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing";
                   &grouplib_remote_log("remote call zfs send $in{'id'} error: member key is missing");
                   exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member";
                   &grouplib_remote_log("remote call zfs send $in{'id'} error: $from not a member");
                   exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong";
                   &grouplib_remote_log("remote call zfs send $in{'id'} error: member key is wrong, unknow member");
                   exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from";
                   &grouplib_remote_log("remote call zfs send $in{'id'} error: ip $from not allowed");
                   exit;
        }

        # touch fs to avoid zero snaps
        $t=$in{'snap_name2'};
        $t=~s/\@.*//;            # fs
        $t.="/.snap";
        `touch $t`;
        `rm $t`;

############
#part 1 create snap
############
        # delete this snap if already exist due to an former error
        $r=&exe("/usr/sbin/zfs list -H -o name $in{'snap_name2'}");
        if ($r=~/\@/) {
           &log("noid | glib grouplib_remote_call_zfs_send 1286<br>request snapdel $from|||delete $in{'snap_name2'}","m");
           $r=&exe("/usr/sbin/zfs destroy -f $in{'snap_name2'}");
        }

        # snap
        $r=&exe("/usr/sbin/zfs snapshot $in{'snap_rec'} $in{'snap_name2'} 2>&1");
        &grouplib_remote_log("$from zfs snapshot $in{'snap_rec'} $in{'snap_name2'} initiated $from<br>$r");
        &log("noid | glib grouplib_remote_call_zfs_send 1291<br>request snapdel $from||zfs snapshot $in{'snap_rec'} $in{'snap_name2'}","m");


        # get snap used
        $used="";
        $t=&exe("/usr/sbin/zfs list -H -o used $in{'snap_name1'}");
        if (($t=~/\d/) && ($in{'snap_name1'}=~/\@/)) {
           $used="$t,";
        } else {
           $used="-,";
        }

        $t=&exe("/usr/sbin/zfs list -H -o used $in{'snap_name2'}");
        if (($t=~/\d/) && ($in{'snap_name2'}=~/\@/)) {
           $used.="$t";
        } else {
           $used.="-";
        }

        # optional function, may be not needed it a failed to read from stream is not treated as an final error
        # code will be removed after some more testings
        # opt. discard zero transfers
        #if ($in{'send_r'} eq "") {                    # not on recursive transfers
        #  if (($in{'transfer_zero'} ne "yes") && ($used=~/0+,/))  {
        #     print "Content-type: text/plain\r\nnapp-it-ok: send requested, discard: used=$used";
        #     exit;
        #  }
        #}

       # test: init send job
       # $cmd="sudo /usr/sbin/zfs send $in{'send_dedup'} $in{'send_rec'} $in{'send_inc'} $in{'snap_name1'} $in{'snap_name2'} | $in{'src_interface'} >> /tmp/monitor.log 2>&1$t";

        if (!($in{'id'} > 0)) { $in{'id'}=time(); }

        #parameter
        #&grouplib_remote_log("initiate file /tmp/nappit/job-repli-send.$in{'id'}");
        open (PF, ">/tmp/nappit/job-repli-send.$in{'id'}");         # e
                       flock(PF, LOCK_EX);
                       print PF "id=$in{'id'}\n";
                       print PF "send_dedup=$in{'send_dedup'}\n";

                       print PF "send_option=$in{'send_option'}\n";
                       print PF "pv_limit=$in{'pv_limit'}\n";

                       print PF "send_rec=$in{'send_rec'}\n";
                       print PF "send_inc=$in{'send_inc'}\n";
                       print PF "snap_name1=$in{'snap_name1'}\n";
                       print PF "snap_name2=$in{'snap_name2'}\n";
                       print PF "src_interface=$in{'src_interface'}\n";

                       print PF "send_ip=$in{'ip'}\n";
                       print PF "port=$in{'port'}\n";
                       print PF "transport=$in{'transport'}\n";
                       print PF "buffer=$in{'buffer'}\n";
                       print PF "send_i=$in{'send_i'}\n";
        close (PF);
        #&grouplib_remote_log("initiate file /tmp/nappit/job-repli-send.$in{'id'} done");
        # request !! this deletes former job for concurrent call of the script, run via at
        # open (PF, ">/tmp/nappit/job-repli-send.request");          #
        #               flock(PF, LOCK_EX);
        #               print PF "remote_$in{'id'} $time";
        # close (PF);

#        &grouplib_remote_log("create of job-repli-send via /var/web-gui/_log/tmp/now_$in{'id'}.sh initiated from $from");
        `echo \'/usr/bin/perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-repli-send.pl remote_$in{'id'}\' > /var/web-gui/_log/tmp/now_$in{'id'}.sh`;
#        &grouplib_remote_log("/var/web-gui/_log/tmp/now_$in{'id'}.sh initiated ok from $from");

        # start via taskserver.sh
        # /var/web-gui/_log/tmp/xx.sh

        &grouplib_remote_log("job-repli-send.pl for id $in{'id'} on interface $in{'src_interface'} initiated from $from<br>$r");


        $r=&exe("/usr/sbin/zfs list -H -o name $in{'snap_name2'}");
        if (!($r=~/\@/))  {
             $r.=" error: snap $in{'snap_name2'} not created.";
             &log("noid | glib grouplib_remote_call_zfs_send 1049<br>request snap $in{'snap_name2'}||error: snap not created","m");
        }  else {
            $r=~s/ .*//; $r="created snap $r";
       }

       # check sendscript
       $r=&exe("perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-repli-send.pl");

       if ($r=~/missing parameter/is) {
              print "Content-type: text/plain\r\nnapp-it-ok: send requested with missing par, $r\n\n";
       } else {
              #&log("job-repli-send.pl error: $r","lr");
              print "Content-type: text/plain\r\nnapp-it-ok: send via taskserver.sh and job-repli-send.pl ($r), used=$used\n\n";
       }

 ####

 exit;

}


#request get my ip?
###################

##################
sub grouplib_remote_call_get_my_ip {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong, unknow member"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }
        &log("## noid | glib 1200 remote call get my ip|||from $from","mr");
        print "Content-type: text/plain\r\nnapp-it-ok:$from";
        exit;
}


#request destroy_snap?
######################

##################
sub grouplib_remote_call_destroy_proc {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$r,$t);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        $r=&exe("ps axw");
        @n=split(/\n/,$r);
        if ($in{'kill_rproc'}=~/zfs send|nc /) {
           foreach $z (@n) {
                 if ($z=~/$in{'kill_rproc'}/) {
                      &log("request kill from $from | glib 1235<br> kill |$z ","r");
                      $z=~s/^\s+//;
                      $z=~s/ .*//;
                      $z.=`sudo kill -9 $z`;                  #id
                      $t.="kill $z\n";
                 }
           }
        }

        print "Content-type: text/plain\r\nnapp-it-ok:$r";

        &log("## noid | glib grouplib_remote_call_destroy_proc 1274 <br>request kill $from|||$t","mr");                #opt

        exit;
}

##################
sub grouplib_remote_call_destroy_snap {                # hide:
##################
my ($from,$pass,$access,$file,$name,$status,$key,$id,@n,$z,$t);
        $from=$ENV{'REMOTE_ADDR'};

        #key ok?
        if ($in{'key'} eq "") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is missing"; exit;
        }

        $file="/var/web-gui/_log/group/$in{'hostname'}\~$from\.txt";
        if (!(-f $file)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:error this host $from is not a member"; exit;
        }
        &read_ahfile($file,"t");
        if ($t[0] ne "$in{'key'}") {
                   print "Content-type: text/plain\r\nnapp-it-ok:member key is wrong"; exit;
        }

        if (!($file=~/$from/)) {
                   print "Content-type: text/plain\r\nnapp-it-ok:not allowed for ip $from"; exit;
        }

        $r=&exe("/usr/sbin/zfs destroy $in{'snap_rec'} $in{'snap_name'}");

#         $r="\n";
#         $r.="zfs destroy $in{'snap_rec'} $in{'snap_name'}";

        print "Content-type: text/plain\r\nnapp-it-ok:$r";

         &log("glib grouplib_remote_call_destroy_snap 1311|request destroy snap $from|||zfs destroy $in{'snap_rec'} $in{'snap_name'}\n$r","m");                #opt
         &grouplib_remote_log("remote call destroy snap $in{'id'}: zfs destroy $in{'snap_rec'} $in{'snap_name'}");

        exit;
}

######################
sub grouplib_ask_remote_pslist {                #hide: parameter host, return commalist of ps - id + command (if a nas-member)
######################
        my ($host,$t,$f,$i,$n,$noerr,$ref);
        $host=$_[0];
        $noerr=$_[1];
        $ref=$_[3];

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

       foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_pslist&hostname=$n";

                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_pslist 1332");

                if ($noerr eq "") {
                  if ($r=~/error/is) {
                       $r=~s/.*error/error/is;
                       &mess("sub ask_remote_pslist $i:<hr>$r");
                  }
                }

                $r=~s/.*napp-it-ok://s;

                return ($r);
        }
        if ($host eq "localhost") {
           $r=&exe("ps axw");
           $r=~s/\n/;;/gs;
           return ($r);
# &mess($r);
        }
        return ("not a member");
}

######################
sub grouplib_ask_remote_zfslist {                #hide: parameter host, return commalist of zfs (if a nas-member)
######################
        my ($host,$t,$f,$i,$n,$noerr,$ref);
        $host=$_[0];          # use ip, not hostname
        $noerr=$_[1];
        $ref=$_[3];

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;
                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_zfslist&hostname=$n";
                $f.="&host_ip=$host";

                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_zfslist 1379");
                if ($noerr eq "") {
                  if ($r=~/error/is) {
                       $r=~s/.*error/error/is;
                       return($r);
                       #&mess("sub ask_remote_zfslist $i:<hr>$r");
                  }
                }
                $r=~s/.*napp-it-ok://s;
                return ($r);
        }
        return ("not a member");
}

######################
sub grouplib_ask_remote_snaplist {                #hide: parameter host, return commalist of zfs (if a nas-member)
######################
        my ($host,$t,$f,$i,$n,$noerr,$ref);
        $host=$_[0];
        $noerr=$_[1];
        $ref=$_[3];

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;
                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_zfslist&hostname=$n&type=snapshots";
                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_snaplist 1416");
                if ($noerr eq "") {
                  if ($r=~/error/is) {
                       $r=~s/.*error/error/is;
                       &mess("sub ask_remote_snaplist $i:<hr>$r");
                  }
                }
                $r=~s/.*napp-it-ok://s;
                return ($r);
        }
        return ("not a member");
}

######################
sub grouplib_ask_remote_zfs_send {                #hide: parameter host,
######################
        my ($host,@vars,%vars,$k,$v,$t,$f,$i,$n,$noerr,$rh,$ref);
        %vars = ();
        $host=$_[0];
       if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

        @vars=split (/\n/, $_[1]);
        foreach $v (@vars) {
            if (!($v=~/\=/)) { next; }
            chomp($v);
            $k=$v; $k=~s/\=.*//;
            $k=~s/[^a-zA-Z0-9\-\_]//g;
            if ($k ne "") {
                $v=~s/.*\=//;
                $vars{$k} = $v;
            }
        }
        $noerr=$_[2];
        $ref=$_[3];
#test
#&print_hash(%vars);


       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_zfs_send&hostname=$n";
                $f.="&snap_name1=$vars{'snap_name1'}";
                $f.="&snap_name2=$vars{'snap_name2'}";
                $f.="&snap_rec=$vars{'snap_rec'}";
                $f.="&send_rec=$vars{'send_rec'}";
                $f.="&send_inc=$vars{'send_inc'}";               # -i
                $f.="&send_i=$vars{'send_i'}";                   # new parameter in 0.9 send_rec=-i/-I
                $f.="&send_option=$vars{'send_option'}";         # send option like --raw
                $f.="&pv_limit=$vars{'pv_limit'}";               # pv limit ex -L 300k

                $f.="&send_dedup=$vars{'send_dedup'}";
                $f.="&src_interface=$vars{'src_interface'}";

                $f.="&transfer_zero=$vars{'transfer_zero'}";

                #needed locally
                $f.="&dest_zfs=$vars{'dest_zfs'}";
                $f.="&dest_shareguest=$vars{'dest_shareguest'}";
                $f.="&dest_sharename=$vars{'dest_sharename'}";
                $f.="&reset_to_snap=$vars{'reset_to_snap'}";
                $f.="&id=$vars{'id'}";
                $f.="&host=$vars{'host'}";
                $f.="&myhost=$vars{'myhost'}";

                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_zfs_send 1483\n $n $i");

#print "\n\n####grouplib 1472 ask remote zfs send $i\n$f\n\nanswer\n$r\n\n";

                #log
                $t=$r; $t=~s/\n/, /gs;
                &log("noid | glib 1455 request remote zfs send $i:\n sender snap $vars{'id'}\: zfs snapshot $vars{'snap_rec'} $vars{'snap_name2'}\n sender $vars{'id'} : $host\: zfs send $vars{'send_dedup'} $vars{'send_rec'} $vars{'send_inc'} $vars{'snap_name1'} $vars{'snap_name2'}\n result: $t","l");

                if ($r=~/error/is) {
                    $r=~s/.*error/request send error, check opt. destroy last (zero) snap /is;
                    $r="sub ask_remote_zfs_send grouplib 1419:<hr>$r";
                } else {
                    $r=~s/.*napp-it-ok://s;
                }

                return ($r);
        }
        return ("not a member");
}


######################
sub grouplib_ask_remote_get_my_ip {                #hide: parameter host, return my ip
######################
        my ($host,$noerr);
        $host=$_[0];
        $noerr=$_[1];

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

        #read access key of host
        $f="/var/web-gui/_log/group";
        @t=();
        &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\./)) { next; }          # ex san1~192.168.1.1.txt

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_get_my_ip&hostname=$n";

                $r=&grouplib_ask_remote("$f","$i","$noerr");

                #if ($r=~/error/is) { $r=~s/.*error/error/is; &mess("sub ask_remote_get_my_ip $n:<hr>$r"); }
                #if ($r=~/error/is) { $r=~s/.*error/error/is; print("\n1531 *** sub ask_remote_get_my_ip $n:\n$r"); exit; }

                $r=~s/.*napp-it-ok://s;
                return ($r);
        }
        return ("not a member");
}

######################
sub grouplib_ask_remote_destroy_proc {                #hide: parameter host, proc
######################
        my ($host,@vars,%vars,$k,$v,$t,$f,$i,$n,$noerr,$proc,$ref);
        $host=$_[0];
        $proc=$_[1];
        $noerr=$_[2];
        $ref=$_[3];

       if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }

       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_destroy_proc&hostname=$n";
                $f.="&kill_rproc=$proc";

                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_destroy_proc");
                if ($r=~/error/is) {
                    $r=~s/.*error/error/is;
                    $r="sub ask_remote_zfs_send:<hr>$r";
                } else {
                    $r=~s/.*napp-it-ok://s;
                }
                return ($r);
        }
        return ("not a member");
}

######################
sub grouplib_ask_remote_destroy_snap {                #hide: parameter host, return my ip
######################
        my ($host,@vars,%vars,$k,$v,$t,$f,$i,$n,$noerr,$ref);
        %vars = ();
        $host=$_[0];
        @vars=split (/\n/, $_[1]);
        foreach $v (@vars) {
            if (!($v=~/\=/)) { next; }
            chomp($v);
            $k=$v; $k=~s/\=.*//;
            $k=~s/[^a-zA-Z0-9\-\_]//g;
            if ($k ne "") {
                $v=~s/.*\=//;
                $vars{$k} = $v;
            }
        }
        $noerr=$_[2];
        $ref=$_[3];

        if (!($host=~/\w+|\d+\.\d+\.\d+\.\d+/)) { return('need hostname or ip'); }


       #read access key of host
       $f="/var/web-gui/_log/group";
       @t=();
       &read_dir("$f","t");

        foreach $t (@t) {
                if (!($t=~/^$host\~|~$host\b/)) { next; }

                # read access key
                $f="/var/web-gui/_log/group/$t";
                &read_ahfile($f,"p");
                $i=$t; $i=~s/\.txt$//; $i=~s/.*\~//;

                $n=`hostname`;
                chomp($n);

                $f="action=rgroup\&key=$p[0]&do=request_destroy_snap&hostname=$n";
                $vars{'snap_name'}=~s/ .*//;
                $f.="&snap_name=$vars{'snap_name'}";
                $f.="&snap_rec=$vars{'snap_rec'}";

#&print_var("$f -> $i");

                $r=&grouplib_ask_remote("$f","$i","$noerr","$ref -> grouplib_ask_remote_destroy_snap");
                if ($r=~/error/is) {
                    $r=~s/.*error/error/is;
                    $r="sub ask_remote_zfs_send:<hr>$r";
                } else {
                    $r=~s/.*napp-it-ok://s;
                }
                return ($r);
        }
        return ("not a member");
}


###############
sub grouplib_ask_remote {      # hide:  ask remote group via post and netcat/socat, return answer
###############
#parameter:         0=data (encoded) -> a-z A-Z 0-9 ,._;:#+- allowed
#                1=ip

# connect a remote napp-it via netcat (opt socat) on port  = 81 per default to request a remote function
# data are transfered via post to hide them from logs (pw etc)
# -> connect to sub remote_call (see above)

#        POST /cgi-bin/program.pl HTTP/1.0\r\n
#        Accept: www/source\r\n
#        Accept: text/html\r\n
#        Accept: text/plain\r\n
#        User-Agent: Lynx/2.4 libwww/2.14\r\n
#        Content-type: application/x-www-form-urlencoded\r\n
#        Content-length: 35\r\n\r\n
#        user=Larry%20Bird&age=35&pass=testing                                        #urlencoded data!!
##############################################


# example get html page via netcat/socat
#        $ socat - TCP:localhost:$sys{'port'}
#          netcat $sys{'port'}
#        GET /
#        <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
#        <html>
#        ...
##############################################
#$data=~ s/([^A-Za-z0-9\=\;\&\_\-])/sprintf("%%%02X", ord($1))/seg;                  #url-encode
#$str =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;                                #url-decode

        my ($ask,$l,$data,$ip,@w,$host,$noerr,$ref,$autolog,$ncwait);
        $data=$_[0];
        $ip=$_[1];
        $noerr=$_[2];
        $ref=$_[3];        # debuginfo called from
        $autolog=$_[1];    # autolog called from cluster agent

        #netcat wait from about > settings
        $ncwait=90;
        $t=`cat /var/web-gui/_log/napp-it.cfg | grep nc_wait`;      chomp($t);
        $t=~s/\D//gs;
        if ($t>10) {
          $ncwait=$t;
          &log("noid | glib 2430 | repli ask remote host via nc $ip $sys{'port'}|ncwait=$ncwait","lm");
        }

        #alive?
        if ($sys{'auto_os'} eq "Linux") {
           $r=&exe("ping $ip -w 4");
        } else {
           $r=`/usr/sbin/ping $ip 4`;  #timeout 4s
        }

        if (!($r=~/alive|icmp/s)) { # icmp Linux
            if ($noerr eq "") {
                &log("noid | glib 1688| repli ask remote host $ip $sys{'port'}|error: $ip offline","lm");
                return ("error: $ip offline");
            } else {
                return;
            }
        }


        @w=split(/\&/,$data);
        foreach my $t (@w) {
           $t=~ s/([^A-Za-z0-9\=\,\.\-\_\/])/sprintf("%%%02X", ord($1))/seg;
        }

        $data=join("&amp;",@w);
        $l=length($data);

        $ask ="POST /cgi-bin/admin.pl HTTP/1.0\r\n";
        $ask.="Accept: www/source\r\n";
        $ask.="Accept: text/html\r\n";
        $ask.="Accept: text/plain\r\n";
        $ask.="Content-type: application/x-www-form-urlencoded\r\n";
        $ask.="Content-length: $l\r\n\r\n";
        $ask.= $data;

        #connect via netcat/ socat on port $sys{'port'}
        $ask="'print \""."$ask"."\";'";
        #############################

        #$r=&exe("perl -e $ask | socat - TCP:$ip:$sys{'port'}");
        if (!($sys{'port'} > 1)) {  $sys{'port'}="81"; }                 # default

        #$r=&exe("perl -e $ask | nc -w 50 $ip $sys{'port'}");            # timeout
        $r=`perl -e $ask | nc -w $ncwait $ip $sys{'port'}`;              # timeout after ncwait s

        if (($r=~/404 not found/is) || ($r eq ""))  {                    # old path
           $ask=~s/admin.pl/napp-it\/admin.pl/s;
           $r=`perl -e $ask | nc -w $ncwait $ip $sys{'port'}`;           # timeout
        }

       # $t=$ask; $t=~s/.*do=/do=/s;
       # &log("noid | glib 1719 | repli ask remote host $ip  $sys{'port'}|$ref <br>$t,"lm");

        if (($r eq "") && ($noerr eq ""))  { $r="timeout or path error grouplib 2487"; }

        $ask=~s/.*Content-length: $l\r\n\r\n//s;
        $w=$r; $w=~s/\n/, /gs;

        $t=$ask; $t=~s/.*do=/do=/; $t=~s/\".*//;  $t=~s/\%2F/\//g; $t=~s/\%20/ /g; $t=~s/\%40/\@/g;      # short monitorlog
        my $answer=$w; $answer=~s/.*napp-it-ok://s;
        $host=$t;
        if ($host=~/hostname/) { $host=~s/.*hostname=//; $host=~s/\&.*//; } else { $host=""; }
        if ($answer ne "") {
          &log("noid | glib 1731| repli ask remote host $ip $sys{'port'}|$ref <br>nc -w $ncwait $ip $sys{'port'}\n$t|answer=<br>$answer","l");           # log only
        }

        #debug only
        #print "\n ### grouplib 1723 remote ask:\n$ask | nc -w 90 $ip $sys{'port'}\n\nanswer:\n$r\n\n";

        return ($r);
}



#######################
 sub grouplib_nasgroup_overview {            # print group overview (smb-groups only)
 ############### print overview if user zfs
    my ($group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask,$host,$s,$z,$p,$count,$url2,$sp1,$sp2);
    $count="0";
    #set property -> answered
            if ($in{'answered'}) { &grouplib_change_property; }

    #delete -> answered
            if ($in{'action'} eq "del-nasgroupmember") { &grouplib_change_property; }

    #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;";
    print "<div class='info'>$txt{'groups_info'}</div>";

   # check accelerator
   $r="";  @g=();
   if ((-f "/tmp/nappit/group_last.group") && ($cfg{'ver'} ne "")) {
                open (F,"</tmp/nappit/group_last.group");
                     flock(F, LOCK_EX);
                     @g=<F>;
                close (F);
                $t=time();

                # read acc

#&mess("$t - $g[0]");
                if (($t-$g[0] < 1200) && (-f "/tmp/nappit/group_list.group"))   { # max 20min
                      @g=();
                      open (F,"</tmp/nappit/group_list.group");
                           flock(F, LOCK_EX);
                           @g=<F>;
                      close (F);
                      foreach $t (@g) {
                          chomp $t;
                      }

                      &exe("echo acc_read_group");
                      $current{'acc_mess'}="acc";
                 } else {
                      &exe("rm /tmp/nappit/*.group");
                      @g=();
                }
   }

    #$r="";
    if (@g == 0) {
           #

           #########################  part of acceleration see agent_acc.pl ###########

           $url2="_URL_type==type=\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
           $ask=" onclick=\"return(confirm(\'=ask2=?\'))\"";

            #read list of groups-members
            $t="/var/web-gui/_log/group";
            @t=();

            # read group members
            opendir(DIR, $t);
                 @t = readdir(DIR);
            closedir(DIR);

            @g=();
            $sp1='&nbsp;' x 15;
            $sp2='&nbsp;' x 130;
            push (@g,"<b>group-members</b>$sp1\t<b>ip</b> (klick to connect)\t<b>state</b>\t<b>key</b>\&nbsp;\&nbsp;\t<b>appliance&nbsp;version</b>$sp2\t<b>status</b>\t<b>option</b>");
            foreach $t (@t) {
                       if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }                #np group member
                       $t=~s/~/\t/; $t=~s/\.txt$//;
                       push (@g," $t");
            }

           #list members from /_log/members -> ip.txt, content = napp-it key = login admin+ip -> return key
           #insert link to details
#&print_array(@g);
           foreach $t (@g) {
               @w=();
               @w=split(/\t/,$t);

               $n=$w[0]=~s/ +$//;                      #no space at end

               if (!($w[1]=~/\d\./)) { next; }         #  ip

               # groupname -> link. show members (details) -> "prop"
               # +ZFS,SNAP.PID
               ################

                       $host=$w[0]; $host=~s/\s//g;    # remove spaces
                       $z=$url2;                       # for zfs list
                       $s=$url2;                       # for snaplist
                       $p=$url2;                       # for pslist
                       $w[0]="<b>$host</b> ";

                       ## ZFS, Snaps and Processes
                       $z=~s/=text=/ZFS /;
                       $z=~s/=list=/details/;
                       $z=~s/=prop=/$w[1]/;
                       $z=~s/=action=/remote-details/;
                       $z=~s/=type=/zfs/;
                       $z=~s/=old=//;
                       $z=~s/=ask=//;

                       $s=~s/=text=/Snaps /;
                       $s=~s/=list=/details/;
                       $s=~s/=prop=/$w[1]/;
                       $s=~s/=action=/remote-details/;
                       $s=~s/=type=/snapshot/;
                       $s=~s/=old=//;
                       $s=~s/=ask=//;

                       $p=~s/=text=/Pid /;
                       $p=~s/=list=/details/;
                       $p=~s/=prop=/$w[1]/;
                       $p=~s/=action=/remote-details/;
                       $p=~s/=type=/ps/;
                       $p=~s/=old=//;
                       $p=~s/=ask=//;
                       $w[0].="( $z / $s / $p)";

               #online and status
                       #ping it
                       #  $r=&exe("ping $w[1] -w 1");                                     # on Linux

                       $r=&exe("ping $w[1] 2");       # timeout 2s

                       if ($r=~/alive|icmp/s) { $w[2]="alive"; } else {  $w[2]="<font style='color:red'>offline</font>"; }  # icmp on Linux

                       if ($w[2] eq "alive") {

                               # alive but key ok?
                               $r=&grouplib_ask_remote_pslist($w[1],,"overview");        # proc;;proc;;
                               if ($r=~/wrong|unknow/is) {
                                    $r="<font style='color:#ba2f28'>invalid</font>";     # invalid dkey
                               } else {
                                    $r="ok";
                               }
                               $w[3]="$r";

                               #connect via netcat on port $sys{'port'} (81)
                               $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc -w 5 $w[1] 81`;
                               if ($r=~/404 not found/is) {        # old path
                                $r=`perl -e 'print\"GET /cgi-bin/napp-it/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc -w 5 $w[1] 81`;
                               }

                               if ($r eq "")   {
                                                           $w[4]="<font style='color:red'>remote call: timeout</font>";
                               } else {
                                                           if ($r=~/refused/s)    { $w[4]="<font style='color:red'>webserver: no answer</font>"; }
                                                           if ($r=~/napp-it-ok:/s)  {

                                                                 $w[4]=$r;
                                                                 $w[4]=~s/.*napp-it-ok:/alive/s;
                                                                 $w[4]=~s/: command not found//s;
                                                                 $w[4]=~s/alive//;
                                                           }  else {
                                                                 $w[4]="not a napp-it server";
                                                                 $w[0]= $host;
                                                           }
                               }
                       }  else {
                              $w[4]="-"; $w[0]=" $host";
                       }

              # 4 delete member
                      if ($w[1]=~/\d+\.\d+\.\d+\.\d+/) {
                               $n="delete";
                               $w[5]=$url2;
                               $w[5]=~s/=text=/$n/;
                               $w[5]=~s/=action=/del-nasgroupmember/;
                               $w[5]=~s/=old=/$host\~$w[1]"/;
                               $w[5]=~s/=ask=/$ask/;
                               $w[5]=~s/=ask2=/delete group-member $host ?/;
                               $w[5]=~s/=list=//;
                               $w[5]=~s/=prop=//;
                               $count++;

                               # no link with 127.0.0.1
                               if ($w[1] eq "127.0.0.1")  { $w[5]="-"; }
                       }



               #ip. last item to keep ip
                       $n=$w[1];                                                #ip
                       $w[1]="<a target=\"_blank\" href=\"http://$n:81/cgi-bin/admin.pl\">$n</a>";

                       # no link with 127.0.0.1
                       if ($n eq "127.0.0.1")  {$w[1]="127.0.0.1 localhost"; }



              $t=join("\t",@w);
           }

           ## / acceleration in grouplib
           #########################################################
    } else {
        $url2="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;type==type=\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
        $ask=" onclick=\"return(confirm(\'=ask2=?\'))\"";
    }

    #add new group member
    $t="";

    if (!($cfg{'ver'}=~/c|r/)) {
          $r="$cfg{'app_name'} appliance $t";
    } else {
         $r=$url2;
         $r=~s/=text=/<b>++ $txt{'add'} appliance <\/b><br> $t/;
         $r=~s/=list=//;
         $r=~s/=prop=/add-nasgroupmember/;
         $r=~s/=action=/add-nasgroupmember/;
         $r=~s/=old=//;
     }
     push(@g,"<br>$r");
     $out=join("\n",@g);

     # add url
     $out=~s/_URL_/$url/gs;

#test
#&print_array(@g); exit;


   #show as table
    print "<br>\n";
    print &list2table($out,'100%,200px,180px,300px,50%','sort2');


   #remote napp-it details
            if ($in{'action'} eq "remote-details")     { &grouplib_nasgroup_details; }


   #popup/ edit-window
   if ($in{'action'} =~/add/) {
         &grouplib_ask_property;
   }

    print "\n</body></html>";
    return;

 } #/sub


#######################
 sub grouplib_nasgroup_details {            # hide: show status of remote napp-it server
#######################
    my ($group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask);

    # show as table

    if ($in{'type'} eq "snapshot") {
         $in{'prop'}=~s/\s//g;
         $out="<b>ZFS of $in{'prop'} </b>\tUsed\tAvail\tRefer\tMounted";
         $r=&grouplib_ask_remote_snaplist($in{'prop'},,"grouplib_nasgroup_details 1916");
    }
    if ($in{'type'} eq "zfs") {
         $in{'prop'}=~s/\s//g;
         $out="<b>ZFS of $in{'prop'} </b>\tUsed\tAvail\tRefer\tMounted";
         $r=&grouplib_ask_remote_zfslist($in{'prop'},,"grouplib_nasgroup_details 1921");
    }
    if ($in{'type'} eq "ps") {
         $in{'prop'}=~s/\s//g;
         $out="<b>PID's of $in{'prop'}\tCommand (storage related only)</b>";
         $r=&grouplib_ask_remote_pslist($in{'prop'},,"grouplib_nasgroup_details 1926");
         $r=~s/;;/\n/gs;
    }

    $r=~s/,/\n/gs;
    $out.="\n$r";


    @z=split(/\n/,$out);
    foreach my $z (@z) {
        if ($z=~/ZFS of/)    { next; }
        $z=~s/ +/\t/gs;
    }
    $out=join("\n",@z);

    print "<br><br>\n";
    print &list2table($out,'','sort2');
}




#######################
sub grouplib_ask_property {        #hide:
#######################

    ################################
    # create form to edit a property
    ################################

    my ($ask,$close,$form,$info,$t,$opt,$r,$do,$hn);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";


    #add nas group-member
    ######################
    if ($in{'action'} eq "add-nasgroupmember") {
        $do="1";

        $form="<table><tr>";
        $form.="<td>Add member ip:&nbsp;</td>    <td><input type='text' name='ip' value='192.168.1.' style='width: 130px'></td>";    # 4td
        $form.="<td>&nbsp;&nbsp;admin pw: &nbsp;&nbsp;</td>  <td><input type='password' name='pw' value='' style='width: 130px'></td></tr>";

        $info="Enter management ip and appliance admin pw of a new group-member<br>";

        #cluster: mirror ha ip to
        ###
        $form.="<tr><td colspan='4'>\&nbsp;</tr>";

        $form.="<tr><td colspan='2'><b>Cluster:</b> use ip of first head and add</td>";
        $form.="<td>&nbsp;&nbsp;name (opt)&nbsp;</td><td><input type='text' name='clname' value='' style='width: 130px'></td></tr>";

        $form.="<tr><td>head2 ip&nbsp;&nbsp;</td> <td><input type='text' name='head2' value='' style='width: 130px'></td>";
        $form.="<td>&nbsp;&nbsp;ha ip&nbsp;</td>  <td><input type='text' name='ha-ip' value='' style='width: 130px'></td></tr>";

        $info.="<br><b>Add HA Cluster:</b> Add the management ip of the first head and additionally the management ip of the ";
        $info.="second head and the common HA ip. Both heads must share the same appliance pw. A Cluster name is optional. ";
        $info.="This can be the for ex the DNS name of the HA ip. A Cluster allows to replicate from the failover HA ip.";

        ##
        $form.="</table><br>";

        #&print_hash(%cfg);


    }


     ### form ###
     if ($do) {
        print &ask_pop("$form","$info","$opt");
     }

} #/sub





 ##############################
 sub grouplib_change_property {                 #hide:
 ##############################
 my ($r,$s,$t,$do,$aid,$n,$han,$ha);

 # this part is called after user have edited a property (ex by form &ask_property above) and this change should happen now
 ##########################################################################################################################

 if (-f "/tmp/acc-group.log") {  `sudo rm /tmp/acc-group.log`; }

  #del-nasgroup_member
  if ($in{'action'} eq "del-nasgroupmember") {
        $do="1";

        # delete file _log/group/$in{'old'}.txt
        $n="/var/web-gui/_log/group/$in{'old'}.txt";
        if (-f $n) { unlink ($n); }

#test
#&mess($n);
        if (-f '/tmp/nappit/group_last.group') { &exe("rm /tmp/nappit/*.group"); }
        $in{'action'}="";
        &reload();
  }

  #add member to nas group
  if ($in{'action'} eq "add-nasgroupmember") {
        $do="1";
        print "<br>please wait..\n";

        $in{'prop'}="'".$in{'prop'}."'";
        $in{'prop'}=~s/\'+/\'/g;
        $in{'ip'}=~s/[^0-9\.]//g;
        if (!($in{'ip'}=~/^\d+\.\d+\.\d+\.\d+$/)) { &mess ('please enter a valid ip'); }

        #opt
        $in{'ha-ip'}=~s/[^0-9\.]//g;
        $in{'head2'}=~s/[^0-9\.]//g;
        $in{'clname'}=~s/[^a-zA-Z0-9\-\_]//g;

        #member/head1 alive?
        if ($sys{'auto_os'} eq "Linux") {
           $r=&exe("ping $in{'ip'} -w 2");
        } else {
           $r=&exe("ping $in{'ip'} 2");  #timeout 2s
        }
        if (!($r=~/alive|icmp/s)) { &mess("member or head1 $in{'ip'} is offline<br>$r"); }  # icmp on Linux

        #head 2 alive
        if ($in{'head2'}=~/\d/) {
             if ($sys{'auto_os'} eq "Linux") {
                $r=&exe("ping $in{'head2'} -w 2");
             } else {
                $r=&exe("ping $in{'head2'} 2");  #timeout 2s
             }
             if (!($r=~/alive|icmp/s)) { &mess("head2 $in{'head2'} is offline<br>$r"); }  # icmp on Linux
        }

        # check key on 1
        $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc $in{'ip'} $sys{'port'}`;
        if ($r=~/404 not found/is) {                  # old path
             $r=`perl -e 'print\"GET /cgi-bin/napp-it/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc $in{'ip'} $sys{'port'}`;
        }
        if ($r=~/refused/s)         { &mess ("host $in{'ip'} is not responding on port $sys{'port'}"); }
        if (!($r=~/napp-it-ok:/s))  { &mess ("host $in{'ip'} error; not a valid response"); }

        # check key on 2
        if ($in{'head2'}=~/\d/) {
                $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc $in{'head2'} $sys{'port'}`;
                if ($r=~/404 not found/is) {                  # old path
                     $r=`perl -e 'print\"GET /cgi-bin/napp-it/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc $in{'head2'} $sys{'port'}`;
                }
                if ($r=~/refused/s)         { &mess ("host $in{'head2'} is not responding on port $sys{'port'}"); }
                if (!($r=~/napp-it-ok:/s))  { &mess ("host $in{'head2'} error; not a valid response"); }
        }

        #request membership
        ###################
        # ask_remote
        # do=Larry%20Bird&age=35&pass=testing ,ip

        $in{'pw'}=~s/\|//g;

        $n=`hostname`;
        chomp($n);

        # build group with member
        $t="action=rgroup&do=request_membership\&pw=$in{'pw'}\&hostname=$n";


       # handled by -> &remote_call in admin.pl
       $r=&grouplib_ask_remote("$t","$in{'ip'}");

       # if ok: r="ok:gid" or r="wrong pw"
       if ($r=~/wrong/) { $r=~s/.*://s; &mess("$r");}

       #if ok:hostname=accessid

       $n=$r; $n=~s/^.*://s; $n=~s/=.*//;                 # other hostname
       $aid=$r; $aid=~s/^.*=//s; $aid=~s/\s//gs;          # $aid=key from remote
       $han=$n;                                           # remember for ha name

       # filename per default contains remote host (man ip)
       # if this is a ha ip, add ha-hostname or use clustername

       #write access id to file ip.txt
       $file="/var/web-gui/_log/group/$n"."~$in{'ip'}.txt";   # file with remote hostname
       if ($n=~/konnte nicht geschrieben werden/) {
               &error("Could not write membership file on remote system<br>$n");
       }
       &str2file("$aid",$file);

       # if this is a cluster, add head 2 with same key
       ##################
       if ($in{'head2'}=~/\d/) {

              #request membership
              ###################
              # ask_remote
              # do=Larry%20Bird&age=35&pass=testing ,ip

              $in{'pw'}=~s/\|//g;

              $n=`hostname`;  chomp($n);
              $t="action=rgroup&do=request_membership\&pw=$in{'pw'}\&hostname=$n\&aid=$aid"; # key from first

              # handled by -> &remote_call in admin.pl
              $r=&grouplib_ask_remote("$t","$in{'head2'}");

              # if ok: r="ok:gid" or r="wrong pw"
              if ($r=~/wrong/) { $r=~s/.*://s; &mess("join head2: $r");}

              # filename per default contains remote host (man ip)
              # if this is a ha ip, add ha-hostname or use clustername
              $n=$r; $n=~s/^.*://s; $n=~s/=.*//;                 # other hostname

              #write access id to file ip.txt
              $file="/var/web-gui/_log/group/$n"."~$in{'head2'}.txt";   # file with remote hostname
              if ($n=~/konnte nicht geschrieben werden/) {
                      &error("Could not write membership file on remote system<br>$n");
              }
              &str2file("$aid",$file);

              # add cluster entry for ha ip
              if ($in{'ha-ip'}=~/\d/) {
                     $n=$in{'clname'};
                     if ($n eq "") {
                          $n="ha-$han";
                     }
              }

              # write local ha member
              $file="/var/web-gui/_log/group/$n"."~$in{'ha-ip'}.txt";   # file with clustername and remote ha ip
              if ($n=~/konnte nicht geschrieben werden/) {
                      &error("Could not write membership file on remote system<br>$n");
              }
              &str2file("$aid",$file);

       } #/head2


       # group acc
       if (-f '/tmp/nappit/group_last.group') { &exe("rm /tmp/nappit/*.group"); }
       $in{'action'}="";
       &reload();
  }


#&mess('ok');
} #/sub



#EoF ######################
# do not remove line below (return true)
1;
