# acl lib

######################################################################################
# extension: ACL management
# (c) napp-it 2011, 2012, 2013
# this is a nonfree extension to napp-it, use requires a key/license
######################################################################################

use strict;

# debug only
 # use vars qw($cgipath $i $t $p $o $action $txt $ev %t %p %in %cfg @p @t @cfg %disk %sys %zfs %action %current %opt %txt);         # menues and global var + global temp
 # sub exe {}
# /debug
my ($k,$r,$acl,$k,$path,$rec,@fo,$f,@fi,$fi,$i,@i,$u,$a,$in,$ad);


#parse
  $in{'file'}=~s/\.\.+|\/+//g;
  $in{'folder'}=~s/\.\.+//g;
  $in{'folder'}=~s/\/+/\//g;


#umlauts and ' or "

#################
# default is _url
#################

    $in{'file_url'}   =&fn2url($in{'file'});                    # keep url translation ex folder=:auml..
    $in{'folder_url'} =&fn2url($in{'folder'});
    $in{'zfs_url'}    =&fn2url($in{'zfs'});

    $in{'file'}       =$in{'file_url'};                         # reason: used in popup
    $in{'folder'}     =$in{'folder_url'};
    $in{'zfs'}        =$in{'zfs_url'};

    $in{'file_text'}  =&url2text($in{'file'});                  # translation ex folder=:auml.. to text &auml;
    $in{'folder_text'}=&url2text($in{'folder'});
    $in{'zfs_text'}   =&url2text($in{'zfs'});

    $in{'file_fn'}  =&url2fn($in{'file'});                      # translation ex folder=:auml.. to text &auml;
    $in{'folder_fn'}=&url2fn($in{'folder'});
    $in{'zfs_fn'}   =&url2fn($in{'zfs'});

    $in{'path'}="/$in{'zfs_fn'}/$in{'folder_fn'}/$in{'file_fn'}";        # path with real filenames
    $in{'path'}=~s/\/+/\//g;
    $in{'path'}=~s/\/$//;

    $in{'path'}     =&fn2url($in{'path'});
    $in{'path_fn'}  =&url2fn($in{'path'});                      # parse ' in names
    $in{'path_text'}=&fn2text($in{'path_text'});                # use html entitities


#&print_hash(%in);
#ls and chmodpath

     $current{'ls'}='/usr/bin/ls';
     $current{'chmod'}='/usr/bin/chmod';

if ($sys{'auto_os_type'} =~/_n/i) {                             # linux, nexenta at least v2 stores needed ls and chmod in /usr/sun/bin
     $current{'ls'}='/usr/sun/bin/ls';                          # obsolete in future ver
     $current{'chmod'}='/usr/sun/bin/chmod';
}


# preload infos to hash current.
if ($in{'zfs'} ne "") {
   &acllib_getacl($in{'path_fn'});
}


# preload acl infos
  &id2sid;

#####################################################################

#########
sub acllib {  #27.01.2013
#############################
}


sub fn2fn {           # hide:  parse ' and " in filenames   quoting in unix: don't  -> 'don'\''t' or "don't"
    my $t=$_[0];
    $t=~s/^\'//;
    $t=~s/\'$//;               #

    $t=~s/\'\\\'\'/\'/g;       # do not double  '\'' -> '
    $t=~s/\'/\'\\\'\'/g;       # ' -> '\''

    chomp($t);
    return ($t);
}

# char translation
sub acllib_sz {
###########
# !! single char after Multichar
my $sz=<<EoF;
 Ä Auml
 Ö Ouml
 Ü Uuml
 ä auml
 ö ouml
 ü uuml
 ß szlig
 á aacute
 Â Acirc
 â acirc
 Æ AElig
 æ aelig
 À Agrave
 Å Aring
 å aring
 Ã Atilde
 ã atilde

 Ç Ccedil
 ç ccedil
 É Eacute
 é eacute
 Ê Ecirc
 ê ecirc
 È Egrave
 è egrave

 í iacute
 Î Icirc
 î icirc
 Ì Igrave
 ì igrave
 ï iuml

 Ñ Ntilde
 ñ ntilde

 Ó Oacute
 ó oacute
 Ô Ocirc
 ô ocirc
 Œ OElig
 œ oelig
 Ò Ograve
 ò ograve
 Ø Oslash
 ø oslash
 Õ Otilde
 õ otilde

 š scaron

 Þ THORN
 þ thorn

 Ú Uacute
 ú uacute
 Û Ucirc
 û ucirc

 Ù Ugrave
 ù ugrave

 ý yacute
 Ÿ Yuml
 ÿ yuml

 Ý Yacute

 à agrave
 Á Aacute
 Å Aaring
 Í Iacute
 Ï Iuml

 ¢ cent
 ¤ curren
 € euro
 £ pound
 ¥ yen

 © copy
 ® reg
 ‰ permil
 ¶ para
 § sect
 ™ trade

 „ bdquo
 « laquo
 “ ldquo
 ‹ lsaquo
 ‘ lsquo
 » raquo
 ” rdquo
 › rsaquo
 ’ rsquo
 ‚ sbquo

 ´ acute



EoF

# problems with nonvisible second char ex  , do not delete !!



$sz=~s/ +/ /gs;
return($sz);

}

sub url2fn {          # hide: url to filenames
##################    # -> text of a link  ex :auml -> ä (coded )
    my $t=$_[0];

    #example $t=~s/:auml/ä/gs;

    my $sz=&acllib_sz;
    my @l=split(/\n/,$sz);  # lines
    my ($v,@v);
    foreach my $l (@l) {
       @v=();
       @v=split(/ /,$l);                   #  ä auml
       if ($v[2] eq "") { next; }
       $t=~s/:$v[2]/$v[1]/g;               # example $t=~s/:auml/ä/gs;
    }

    $t=~s/:acute/\'/g;
    $t=~s/:quot/\"/g;

    $t=~s/´/\'/g;                         # case ' was translated
    #$t=&fn2fn($t);                         # handle '

    return ($t);
    #########
}


sub fn2url {         # hide:  filename -> url
#################    # ex ä (coded ) -> :auml
    my $t=$_[0];
    # ex $t=~s/ä/:auml/gs;

    my $sz=&acllib_sz;
    my @l=split(/\n/,$sz);  # lines
    my ($v,@v);
    foreach my $l (@l) {
       @v=();
       @v=split(/ /,$l);                 #  ä auml
       if ($v[1] eq "") { next; }
       $t=~s/$v[1]/:$v[2]/g;             # ex $t=~s/ä/:auml/gs;
    }

    $t=~s/\'/:acute/g;
    $t=~s/\"/:quot/g;

    return ($t);
}


sub fn2text {         # hide:  filename -> text
#################     # ex  -> &auml;
    my $t=$_[0];
    # ex $t=~s/ä//gs;

    my $sz=&acllib_sz;
    my @l=split(/\n/,$sz);  # lines
    my ($v,@v);
    foreach my $l (@l) {
       @v=();
       @v=split(/ /,$l);                 #  ä auml
       if ($v[1] eq "") { next; }
       $t=~s/$v[1]/$v[0]/g;              # ex $t=~s/ä//gs;
    }

    $t=~s/\'/&acute;/g;
    $t=~s/\"/&quot;/g;


    # add a url2text (sometimes needed because url is default) to have always text as result
    $t=&url2text($t);

    return ($t);
}

#
# quoting in web:  -> &auml;

sub url2text {        # hide: url to text
##################    # ex :auml -> &auml;
    my $t=$_[0];

    # ex $t=~s/:Auml/&Auml;/gs;    # 

    my $sz=&acllib_sz;
    my @l=split(/\n/,$sz);  # lines
    my ($v,@v);
    foreach my $l (@l) {
       @v=();
       @v=split(/ /,$l);                 #  ä auml
       if ($v[2] eq "") { next; }
       $t=~s/:$v[2]/\&$v[2]\;/g;         # ex $t=~s/:Auml/&Auml;/gs;    # 
    }

    ##
    $t=~s/:acute/\'/gs;
    $t=~s/:quot/\"/gs;
    return ($t);
    #########

}



#####################
sub acllib_getpools {
#####################
    my ($sel,$l,$t);
    my $url=$_[0];
    my @datapools=split(/\t/,$zfs{'datapools'});

    ###
    print "<b>Select a ZFS-Pool</b>";

    if ($zfs{'datapools'} eq "") { print "-no datapools found-"; return; }

     if ($in{'zfs'} eq "") {
          $in{'zfs'}=$zfs{'datapools'};
          $in{'zfs'}=~s/\t.*//;                 # first datapool
     }

    $sel="";
    $i=0;

    foreach my $tmp (@datapools) {
        $l=$url;

        $t=&fn2text($tmp);

        $l=~s/<a /<a title=\'$t\' /;
        if (length($t)> 18) {
             $t=substr($t,0,18); $t.="..";
        }
        $t.="/"; $t.=" "x20; $t=substr($t,0,20);

        $l=~s/=text=/$t/;                                                       # name of pool

        $t=&fn2url($tmp);
        $l=~s/=zfs=/$t/;
        $l=~s/=old=//; $l=~s/=prop=//;   $l=~s/=file=//;   $l=~s/=folder=//;    # not needed
        $sel.= "$l\t";
        $i++;
        if ($i >= 8) { $i=0;  $sel.="\t\n"; }                    # max 8
    }

    $sel=~s/\t+$//s;
    $sel=~s/\t+/\t/gs;

    $sel=~s/ +$//s;
    print &list2table($sel);
    print "<br>";
}


#####################
sub acllib_getfs {
#####################
    my ($sel,$l,$t,$o);
    my $url=$_[0];

    print "<b>Select a ZFS-Filesystem</b>";

    my $pool=$in{'zfs'};
    $pool=~s/\/.*//;

     #get list of zfs
     my $zfslist=&exe('/usr/sbin/zfs list -H -o name,mountpoint','','acllib 182');
     chomp($zfslist);
     my @t=split(/\n/,$zfslist);
     my @fs=();

     # pool-list
     ###########
     foreach my $t (@t) {
             if (!($t=~/^$pool\//))  { next; }                    # not pool istself or fs on other pools
             if ($t=~/\-$/)          { next; }                    # no mountpoint
             $t=~s/\t.*|   .*//;                                  # del mountpoint
             push (@fs,$t);
     }

     $sel.="\n";
     @fs=sort(@fs);

     foreach my $tmp (@fs) {

             $l=$url;
             $t=&fn2text($tmp);
             $l=~s/<a /<a title=\'$t\' /;
             if (length($t)> 18) {
                 $t=substr($t,0,18); $t.="..";
             }
             $t.="/"; $t.=" "x20; $t=substr($t,0,20);

             if ($tmp eq $in{'zfs'}) {
                     $l=~s/=text=/<b class='font_darkred'>$t<\/b>/;   # name of current zfs
             } else {
                     $l=~s/=text=/$t/;                                # name of zfs
             }

             $t=&fn2url($tmp);
             $l=~s/=zfs=/$t/;

             $l=~s/=folder=//;    $l=~s/=old=//;    $l=~s/=prop=//;
             $l=~s/=file=//;      $l=~s/=list=//;   $l=~s/=user=//;   # not needed
             $sel.="$l\t";

     }
     $sel=~s/\t+/\t/gs;


     @t=();
     @t=split(/\t/,$sel);
     $i=1;
     $sel="";

     foreach my $c (@t) {
           $sel.="$c\t";
           if ($i >= 10) {   $i=1; $sel.="\n"; }       # number of colums  always 10
           $i++;
     }
     $sel=~s/\t+$//s;
     $sel=~s/\t+/\t/gs;

#debug
#@t=split(/\n/,$sel);
#&print_array(@t);


     $sel=~s/ +$//s;
     print &list2table($sel);

}

#####################      # get regular folder
sub acllib_getfolder {
#####################
    my ($sel,$l,$t);
    my $url=$_[0];
    my $path="\'$in{'path'}/\'";

    #url
          $l=$url;

          $l=~s/=text=/<b class='font_darkred'>$in{'zfs_text'}<\/b>/;      $l=~s/=zfs=/$in{'zfs_url'}/;
          $l=~s/=old=//; $l=~s/=prop=//;               $l=~s/=file=//;     $l=~s/=list=//;  $l=~s/=user=//;
          $l=~s/=folder=//;  # not needed

          $t="$in{'folder'}/$in{'file'}";
          $t=fn2text($t);
          $t="/$l <br><b class='font_darkred' style='font-size: 11px'>/$t</b>";
          $t=~s/\/+/\//g;
          $t=~s/\/$//;


          # current folder
          ###############
          print "<br><br><b>Select a regular folder in this Filesystem:</b> <b class='font_darkred'>$t </b>";

          @t=();
          @t=&get_dir($in{'path_fn'});
                                                                       # do not use path_fn with perl read_dir
#push(@t,"$in{'path_fn'}");
#&print_array(@t);

          my @fol=();                                                   # folderlist
          my @fil=();                                                   # filelist
          my $fol;
          my $folder;


          my $up="";
          if ($in{'folder'} =~/\//) {                                   #folderlist
               push (@t,'/..');
               $up=$in{'folder'};
               $t=rindex($up,'/');
               $up=substr($up,0,$t);
          }
          @t=sort(@t);

          foreach my $t (@t) {
                  if ($t=~/\/$|\.\./) {
                    $t=~s/\/$//;
                    push (@fol,$t)                                     # folders
                  } else {
                    push (@fil,$t);                                    # files
                  }
          }

          $i=0;
          my @len;
          foreach my $tmp (@fol) {

             $l=$url;
             $t=&fn2text($tmp);

             $t=&fn2text($tmp);

             $l=~s/<a /<a title=\'$t\' /;
             if (length($t)> 18) {
                 $t=substr($t,0,18); $t.="..";
             }
             $t.="/"; $t.=" "x20; $t=substr($t,0,20);

             if ($path=~/\/$in{'folder'}$/) {
                     $l=~s/=text=/<u>$t<\/u>/g;                          # name of current folder
             } else {
                     $l=~s/=text=/$t/g;                                  # name of zfs

             }
             $l=~s/=zfs=/$in{'zfs_url'}/;
             $folder="$in{'folder'}\/$tmp"; $folder=~s/^\///;

             if ($tmp=~/\.\./) {
                $folder=$up;
             }

             #mask umlauts
             $t=&fn2url($folder);
             $l=~s/=folder=/$t/;

             $l=~s/=old=//; $l=~s/=prop=//;    $l=~s/=file=//;    $l=~s/=list=//;   $l=~s/=user=//;    # not needed
             $fol.="$l\t";
          }


          @t=();
          @t=split(/\t/,$fol);
          $i=1;
          $sel="";
          foreach my $c (@t) {
                     $sel.="$c\t";
                     if ($i >=10) { $i=0; $sel.="\n"; }                    # number of colums always 12
                     $i++;
          }
#&mess($sel);

          $sel=~s/ +$//s;
          print &list2table($sel);
#&mess($sel);
          return (@fil);                        # return files
}


######################
sub acllib_overview {
##################### show acl of a folder/ subfolder (parameter pool, folder, subfolder)

    my (@l,@w,$w,$pool,$fs,$l,$k,$v,$sel,$i,$share,$path,$r,$p,@files);

    #change acl property
    if ($in{'answered'}) { &acllib_change_property; }

    #change acl property
    if ($in{'prop'} eq "acl_delete") { &acllib_delete; }


    #url
    my $url="<a class=\"acl\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs==zfs=\&amp;folder==folder=\&amp;file==file=\&amp;prop==prop=\&amp;old==old=\&amp;user==user=\&amp;list==list=\"=ask=>=text=</a>";
    my $ask=" onclick=\"return(confirm('=ask2=?'))\"";

    #############
    # parse input
    #############
        $in{'zfs'}=~s/^\/+//;
        $in{'zfs'}=~s/^\s*\.+//;

#&print_hash(%zfs);
    $path="\'$in{'path_fn'}/\'";


     # only datapools
        if ($in{'zfs'} eq "/")                   { &mess('/ not allowed');   }
        $t=$in{'zfs'};
        $t=~s/\/.*//;
        if (!($zfs{'datapools'}=~/\b$t\b/))      { &mess("53 Folder not allowed - not a datapool, try ZFS folder -> reload <hr>ZFS: $in{'zfs'}<hr>datapools: $zfs{'datapools'}"); }


    ###########
    ## headline
    ###########

    if ($in{'l3'} =~/01/) {
        #print "<div class='hline'>ACL on folders (set and delete trivial and local user ACL is a free option, otherwise please contribute to development)</div>";
        print "<script language='javascript'>document.getElementById('hl').innerHTML='ACL on Folders (set and delete trivial and local user ACL is a free option, otherwise please contribute to development)'</script>\n";
    }
    if ($in{'l3'} =~/02/) {
        # print "<div class='hline'>ACL on SMB shares - SMB service is restarted after modifications !!</div><br>";
        print "<script language='javascript'>document.getElementById('hl').innerHTML='ACL on SMB shares - SMB service is restarted after modifications !!'</script>\n";
    }


    #######################
    # 1. level: datapools >>  select a pool
    #######################
      &acllib_getpools($url);



    ##########################
    # 2a. level: >> select filesystems
    ##########################
      &acllib_getfs($url);


     if (!($in{'zfs'} =~/\//)) {
          print "<hr>Please select a ZFS dataset.";
          return;
     }


    ##########################
    # 2b. level: get regular subfolder
    ##########################

     if ($in{'l3'}=~/01/) {                                                # print regular folder
         @files=&acllib_getfolder($url);
     }


    ############################################
    # 2c. level: get ACL of files and or folders
    ############################################

    if ($in{'l3'}=~/01/) {  # acl files and regular folder

        # my @files=&get_dir($in{'path_fn'});
         foreach my $tmp (@files) {
            #if ()

            $l=$url;

            $t=&fn2text($tmp);
            $l=~s/=text=/$t/;                             # name of file/folder

            $t=&fn2url($tmp);
            $l=~s/=prop=/$t/;                           # prop-> file

            $l=~s/=zfs=/$in{'zfs_url'}/;

            $l=~s/=old=//;     $l=~s/=list=//;            # not needed
       #    print "$l <br>";
         }
     }


    #####################################
    # 2d show acl of pool/zfs/file_folder
    #####################################

    # acls in class info2
    print "<div class='info2' style='margin:20px 0 0 0; padding:0'>";


    # file/folder level
    $t=&fn2text($in{'path'});
    if ($in{'l3'} =~/01/) {
       if ($current{'permstr'}=~/^d/)     {     # regular folder
             print "<div class='hline2' style='width:99%; text-align:center'><b class='font_darkred'>ACL of folder $t</b></div>";               #print headline
       } else {
             print "<div class='hline2' style='width:99%; text-align:center'><b class='font_darkred'>ACL of file $t</b></div>";
       }
       &acllib_getacl($in{'path_fn'});
    }

    # share level
    if ($in{'l3'} =~/02/) {

         $share="/$in{'zfs'}/.zfs/shares/";            # name could be sharename or path
         $share=`sudo /usr/bin/ls $share`;
         $share=~s/\n.*//s;

         ###
         print "<div class='hline2' style='width:99%; text-align:center'><b class='font_darkred'>ACL of SMB share $share (/$in{'zfs'}/.zfs/shares/$share)</b></div>";
         &acllib_getacl("/$in{'zfs'}/.zfs/shares/$share");
    }



    # add unix permissions
    $t=$current{'permstr'};
    $t=~s/\/.*//;
    print "<b style='padding-left: 2px'>$t ($current{'perm2'}) </b>";

    ######################
    # create a nice table
    ######################

#test
# $alert="Options:\\nf = file_inherit\\nd = dir_inherit\\ni = inherit_only\\nn = no_propagate";
# $l="<a href=\"#\" onClick=\"javascript:alert(\'$alert\')\">$current{$k}</a>";

      my $list.="ACL\tUser/ Group\tacl\tacl-set\tdetails\tinheritance\ttype\toption\n\n";

      my ($c,$i,$alert,$ID);

      ############################################
      for  ($t=0;$t<$current{'acl-count2'};$t++) {
           $c=$t;



           ##show id (0,1,2..)
                      $k="acl$t-user";
                      $list.="$c\t";

           # show name  ex user:nnn
                  if ($current{$k}=~/:\d+$/) {                     #ex user:2147483648
                       if ($current{$current{$k}} ne "") {
                          $list.="$current{$current{$k}}\t";
                       } else {
                          $list.="$current{$k}\t";
                       }
                  } else {
                      $current{$k}=~s/group:staff/wingroup:power users => group:staff/;
                      $list.="$current{$k}\t";                      # id   \t user
                  }

           if ($current{$k} eq "") { $list="\tno ACL ";next; }          # no user


           #show/ edit acl
           ################
                      $k="acl$t-acl";
                      $l=$url;
                      $l=~s/=text=/$current{$k}/;  $l=~s/=ask=//;         $l=~s/=file=/$in{'file_url'}/;  $l=~s/=folder=/$in{'folder_url'}/;
                      $l=~s/=zfs=/$in{'zfs_url'}/; $l=~s/=prop=/acl/;     $l=~s/=list=/$c/;

                      $k="acl$t-user";
                      $l=~s/=user=/$current{$k}/;

                      #old, use long acl
                      $k="acl$t-acl2";
                      $l=~s/=old=/$current{$k}/;

                      $list.="$l\t";

           #show/ edit aclset
           #################
                      $k="acl$t-aclset";
                      $l=$url;
                      $l=~s/=text=/$current{$k}/;  $l=~s/=ask=//;         $l=~s/=file=/$in{'file_url'}/; $l=~s/=old=/$current{$k}/;
                      $l=~s/=folder=/$in{'folder_url'}/;
                      $l=~s/=zfs=/$in{'zfs_url'}/;
                      $l=~s/=prop=/aclset/;  $l=~s/=list=/$c/;            $k="acl$t-user"; $l=~s/=user=/$current{$k}/;
                      $list.="$l\t";


           #show details
           ##############    like add (fi,dir), read (fi,dir), x,s
                      $k="acl$t-acl2";
                      # must shorten output
                      $v=$current{$k};

                      #read
                      $l="";
                      if ($v=~/read_/) {
                         $l="rd(";
                         if ($v=~/read_acl/)     {   $l.="acl,";   }
                         if ($v=~/read_attr/)    {   $l.="att,";   }
                         if ($v=~/read_xattr/)   {   $l.="xatt,";  }
                         $l=~s/,$//; $l.=") ";
                      }

                      #write
                      if ($v=~/write_/) {
                         $l.=" wr(";
                         if ($v=~/write_acl/)    {   $l.="acl,";   }
                         if ($v=~/write_attr/)   {   $l.="att,";   }
                         if ($v=~/write_xattr/)  {   $l.="xatt,";  }
                         if ($v=~/write_owner/)  {   $l.="own,";   }
                         $l=~s/,$//; $l.=") ";
                      }

                       #add
                      if ($v=~/add_/) {
                         $l.=" add(";
                         if ($v=~/add_file/)    {   $l.="fi,";     }
                         if ($v=~/add_subd/)    {   $l.="sdir,";   }
                         $l=~s/,$//; $l.=") ";
                      }

                       #delete
                      if ($v=~/delete/) {
                         $l.=" del(";
                         if ($v=~/delete\b/)     {   $l.="yes,";    }
                         if ($v=~/delete_child/) {   $l.="child,";  }
                         $l=~s/,$//; $l.=") ";
                      }

                      #execute
                      if ($v=~/execute/) {  $l.=" x,";  }
                      #sync
                      if ($v=~/sync/)    {  $l.=" s,";  }

                      $l=~s/,$//;   $l=~s/ +/ /g;
                      $v=$l;

                      $l=$url;
                      $l=~s/=text=/$v/;         $l=~s/=ask=//;         $l=~s/=file=/$in{'file'}/;   $l=~s/=old=/$current{$k}/;
                      $l=~s/=folder=/$in{'folder_url'}/;
                      $l=~s/=zfs=/$in{'zfs_url'}/;  $l=~s/=prop=/acl/; $l=~s/=list=/$c/;            $k="acl$t-user";           $l=~s/=user=/$current{$k}/;
                      $list.="$l\t";


           #show/ edit inherit
           ###################
              if ($current{'permstr'}=~/^d/) {
                      $k="acl$t-inherit2";
                      $v=$current{$k};
                      $v=~s/_inherit//g;  $v=~s/inherit_only/only/g; $v=~s/no_propagate/no_prop/g;
                      $l=$url;
                      $l=~s/=text=/$v/;  $l=~s/=ask=//;    $l=~s/=file=/$in{'file_url'}/; $l=~s/=old=/$current{$k}/;
                      $l=~s/=folder=/$in{'folder_url'}/;
                      $l=~s/=zfs=/$in{'zfs_url'}/;         $l=~s/=prop=/inherit/;         $l=~s/=list=/$c/;
                      $k="acl$t-user"; $l=~s/=user=/$current{$k}/;
                      $list.="$l\t";
              } else {
                     $list.="folder only\t";
              }


           #show/ edit type (allow/deny)
           ###################
                      $k="acl$t-type";
                      $l=$url;
                      $l=~s/=text=/$current{$k}/;  $l=~s/=ask=//;         $l=~s/=file=/$in{'file_url'}/;  $l=~s/=old=/$current{$k}/;
                      $l=~s/=folder=/$in{'folder_url'}/;
                      $l=~s/=zfs=/$in{'zfs_url'}/; $l=~s/=prop=/type/;    $l=~s/=list=/$c/;               $k="acl$t-user"; $l=~s/=user=/$current{$k}/;
                      $list.="$l\t";


           ## acl_delete
           #############
           $l=$url;
           $l=~s/=ask=/$ask/; $l=~s/=ask2=/delete ACL $t?\\n$txt{'proceed'}/; $l=~s/=zfs=/$in{'zfs'}/;  $l=~s/=file=//;  $l=~s/=user=//; $l=~s/=old=//;
           $l=~s/=prop=/acl_delete/; $l=~s/=folder=/$in{'folder_url'}/;
           $l=~s/=text=/delete/;
           $l=~s/=list=/$t/;      # id

           $list.="$l";

           ## next line
           $list.="\n";
      }


      print &list2table($list);

      ############# add a <hr>
      print "<br><hr>";

      # acl_add trivial (..@) +++
      #############
        $l=$url;
        $l=~s/=text=/\&nbsp;<b> ++ add trivial ACL\@<\/b>/;
        $l=~s/=zfs=/$in{'zfs'}/; $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=/acl_add_trivial/; $l=~s/=list=/$current{'acl-count'}/;
        $l=~s/=old=//;  $l=~s/=file=//;      # not needed
        print "<br> | $l |";

      # acl_add local user +++
      #############
        $l=$url;
        $l=~s/=text=/\&nbsp;<b> ++ add local user<\/b>/;
        $l=~s/=zfs=/$in{'zfs'}/;
        $l=~s/=prop=/acl_add_local_user/;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=old=//;  $l=~s/=list=//;  $l=~s/=file=//;            # not needed
        print " $l |";

      # acl_add local SMB/unix group  +++
      #############
        $l=$url;
        $l=~s/=text=/\&nbsp;<b> ++ add local group<\/b>/;
        $l=~s/=zfs=/$in{'zfs'}/; $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=/acl_add_local_smbgroup/;
        $l=~s/=old=//;  $l=~s/=list=//;  $l=~s/=file=//;            # not needed
        print " $l |";

      $v=&exe('smbadm list','','acllib 578');
      if ($v=~/S\-\d+\-/) {    # Domain with SID
            # acl_add ad user +++
            #############
              $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
              $l=~s/=text=/\&nbsp;<b> ++ add AD user<\/b>/;
              $l=~s/=zfs=/$in{'zfs'}/;
              $l=~s/=prop=/acl_add_ad_user/;
              $l=~s/=old=//;  $l=~s/=list=//;  $l=~s/=file=//;      # not needed
              print  " $l |";

            # acl_add ad group  +++
            #############
              $l=$url;   $l=~s/=folder=/$in{'folder_url'}/;
              $l=~s/=text=/\&nbsp;<b> ++ add AD group<\/b>/;
              $l=~s/=zfs=/$in{'zfs'}/;
              $l=~s/=prop=/acl_add_ad_group/;
              $l=~s/=old=//;  $l=~s/=list=//;  $l=~s/=file=//;      # not needed
              print " $l |";
     }


    # reset to basics ACL root=full, everyone=modify
    #############
    if ($in{'l3'} =~/01/) {    # folder

        #print "<br>";         # aclreset newline

        # reset ACL
#&print_hash(%in);
#$in{'folder_url'}=~s/\"/\\\"/;

        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b> reset ACL's<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=/acl_reset/;
        $l=~s/=old=//;  $l=~s/=list=//;  $l=~s/=file=//;            # not needed
        print  " $l |";


        if ($in{'folder'} eq "") {
          #set aclinherit {
              $t=&exe("zfs list -H -o aclinherit \'$in{'zfs'}\'","","acllib 616");
              $l=$url;
              $l=~s/=text=/\&nbsp;<b>aclinherit ($t)<\/b>/;
              $l=~s/=zfs=/$in{'zfs_url'}/; $l=~s/=folder=//;
              $l=~s/=prop=/aclinherit/; $l=~s/=list=//;
              $l=~s/=old=//;  $l=~s/=file=//;      # not needed
              print " $l |";

          # set aclmode
              $t=&exe("zfs list -H -o aclmode \'$in{'zfs'}\'","","acllib 625");
              $l=$url;
              $l=~s/=text=/\&nbsp;<b>aclmode ($t)<\/b>/;
              $l=~s/=zfs=/$in{'zfs_url'}/; $l=~s/=folder=//;
              $l=~s/=prop=/aclmode/; $l=~s/=list=//;
              $l=~s/=old=//;  $l=~s/=file=//;      # not needed
              print " $l |";
        }

        # show files
        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b>file-Perm<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=//;
        $l=~s/=old=//;  $l=~s/=list=/files/;  $l=~s/=file=//;               # not needed
        print " $l |";


        # show files +acl
        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b>file-ACL<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=//;
        $l=~s/=old=//;  $l=~s/=list=/files_acl/;  $l=~s/=file=//;            # not needed
        print " $l |";

        # show files +aclkompakt
        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b>file-ACL2<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=//;
        $l=~s/=old=//;  $l=~s/=list=/files_aclk/;  $l=~s/=file=//;            # not needed
        print " $l  |";

        # show acl-log
        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b>aclreset-log<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=//;
        $l=~s/=old=//;  $l=~s/=list=/aclreset-log/;  $l=~s/=file=//;            # not needed
        print " $l |";

        # show acl20-log
        $l=$url;  $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=text=/\&nbsp;<b>aclreset20-log<\/b>/;
        $l=~s/=zfs=/$in{'zfs_url'}/;
        $l=~s/=folder=/$in{'folder_url'}/;
        $l=~s/=prop=//;
        $l=~s/=old=//;  $l=~s/=list=/aclreset20-log/;  $l=~s/=file=//;            # not needed
        print " $l |";

    }
    ####################################################################################
    # 1. add acl property
    #if ($in{'prop'} eq "acl_add") { &acllib_add; }

    # 2. ask new property
    if (($in{'prop'} ne "") && ($in{'answered'} ne "1")) { print &acllib_ask_property; }

    # acls in class info2
    print "<br><br></div>\n";

    #basis info about ACL
    print "<br><br><div class='info'>$txt{'extension_acl_basics'}</div>";

    #####################
    # print acl-reset20.log
    #####################
    if ($in{'list'} eq "aclreset20-log") {

       $r=`sudo ps axw | grep acllib_reset`;
       if ($r ne "") {
            print "running tasks<hr>";
            @t=split(/\n/,$r);
            foreach my $t (@t) {
                if ($t=~/grep/) {  next; }
                $t=~s/perl .*acl/acl/;
                $t=~s/\..*//;
                print "$t<br>";
            }
            print "<br><br>";
       }

       print "aclreset-log (last 20, newest top)<hr>";
       if (-f "/tmp/nappit/aclreset20.log") {
              @t=();
              open (F,"</tmp/nappit/aclreset20.log");
                  flock(F, LOCK_EX);
                  @t=<F>;
              close (F);
              foreach my $t (@t) {
                  print "$t<br>\n";
              }
       }
      print "<br><br>";
      &log_end;
      exit;
    }

    #####################
    # print acl-reset.log
    #####################
    if ($in{'list'} eq "aclreset-log") {
       print "aclreset-log (newest bottom)<hr>";
       if (-f "/tmp/nappit/aclreset.log") {
              @t=();
              open (F,"</tmp/nappit/aclreset.log");
                  flock(F, LOCK_EX);
                  @t=<F>;
              close (F);
              foreach my $t (@t) {
                  print "$t<br>\n";
              }
       }
       print "<br><br>";
       &log_end;
       exit;
    }



    ################################
    #print filelist with permissions
    ################################

    if ($in{'list'} eq "files") {
         $t=&fn2text();
         print "<br>Files in <span style='background-color:#dddddd'>$in{'path_text'}</span> (everyone=read is needed on this folder to read files)<hr><pre>";

         $p="$in{'path_fn'}";
         #$r=`sudo ls \'$p\'`;

         @p=(); @p=&get_dir($p);
#debug
#&print_array(@p);

         foreach my $t (@p) {
            if ($t=~/\/$/)     { next; }  # folder
            if ($t=~/^\./)     { next; }  # hidden

            $t="$p/$t";
            $t=&fn2fn($t);

            $t="\'$t\'";
            $r=`sudo $current{'ls'} -l $t`;
            $r=&fn2text($r);
            print "$r";
         }
    }

    #####################
    #print filelist + acl
    #####################

    if ($in{'list'} eq "files_acl") {
         print "<br>Files in $path (everyone=read is needed on this folder to read files)<hr><pre>";

         $p="$in{'path_fn'}";
         @p=();
         @p=&get_dir("$p","p");

#debug
#&print_array(@p);

         foreach my $t (@p) {
            if ($t=~/\/$/)     { next; }  # folder
            if ($t=~/^\./)     { next; }  # hidden

            $t="$p/$t";
            $t=&fn2fn($t);
            $t="\'$t\'";

            $r=`sudo $current{'ls'} -lv $t`;

            #all acl in one line
            $r=~s/\n +\//\//gs;
            print "$r<hr>";
         }
    }

    #######################################
    #file acl2: print filelist + acl kompakt
    ########################################
    if ($in{'list'} eq "files_aclk") {
         print "<br>Files in $path (listings > 20 needs registration) <hr><pre>";

         $p="$in{'path_fn'}";
         @p=();
         @p=&get_dir("$p","p");

         $i=1;
         foreach my $t (@p) {
            if ($t=~/\/$/)     { next; }  # folder
            if ($t=~/^\./)     { next; }  # hidden

            $t="$p/$t";
            $t=&fn2fn($t);
            $t="\'$t\'";

            $r=`sudo $current{'ls'} -lV $t`;

            #get win-names
            $w=$r; $w=~s/\n.*//s; $w=~s/ +/ /g;
            @w=split(/ /,$w);
            $w[2]="user:$w[2]";
            $w[3]="group:$w[3]";

            #debug
            #print "$w[2] -> $current{$w[2]}"; exit;

            #w2=user, w3=group
            if (($current{$w[2]} ne "") || ($current{$w[3]} ne "")) {
                  $r=~s/\n/\nowner: $current{$w[2]} $current{$w[3]}\n/s;
                  $r=~s/ä//gs;  # Domnen-..
            }

            # filename bold
            $r=~s/\//<b style='background-color:#dddddd'>\//s;
            $r=~s/\n/<\/b>\n/s;

            #all acl in one line
            $r=~s/:\-+:/:/gs;
            $r=&zfslib_acl2set($r);

            # add clearnames to ACL
            @w=();
            @w=split(/\n/,$r);
            foreach $w (@w) {
                     if ($w=~/user:\d+/) {
                          $t=$w; $t=~s/^ +//; $t=~s/user://; $t=~s/:.*//;  $t="user:$t";  $w.=" ($current{$t})";
                     }
                     if ($w=~/group:\d+/) {
                          $t=$w; $t=~s/^ +//; $t=~s/group://; $t=~s/:.*//; $t="group:$t"; $w.=" ($current{$t})";
                     }
            }
            $r=join("\n",@w);

            print "$r<hr>";

            if ($i == 21) { &acllib_v('nopop'); exit; }
            $i++;

         }
    }
}




 #####################
 sub acllib_delete { #hide:
 #####################
   my ($r,$acl,$k,$t,$path);


   $path="\'$in{'path_fn'}/\'";

   #&print_hash(%in);
   # on files/folder
   if ($in{'l3'}=~/01/) {
     $r=`sudo $current{'chmod'} A$in{'list'}\- $path`;
   } else {
   # on shares ex /tank/a/.zfs/shares/a
     $t=$in{'zfs'}; $t=~s/.*\///;

     #hidden?
     if (-f "/$in{'zfs'}/.zfs/shares/$t\$") { $t.="\$"; }

     $r=`sudo $current{'chmod'} A$in{'list'}\- /$in{'zfs'}/.zfs/shares/$t`;
   }
   if ($r ne "") { &mess($r); }
   $in{'prop'}="";
   &reload;

 }



 #####################
 sub acllib_change_property { #hide:
 #####################
   my ($r,$acl,$k,$path,$rec,@fo,$f,@fi,$fi,$i,@i,$u,$a,$in,$ad,$log);

#&print_hash(%current);
#&print_hash(%in);

   $path="$in{'path_fn'}/";
   $path=&fn2fn($path);                    # allow ' in names

   ##############################
   if ($in{'prop'} eq "acl_reset")  {
   ##############################
             if ($in{'aclreset'} ne "modify") { &acllib_v; }

             ####### reset is a backgroundtask, (>  maxtime of cgi)
             print "<br>ACL_reset: initiate background operation<br>\n";

             ###########
             $t="";
             if ($in{'onfiles'})   { $t.="onfiles"; }
             if ($in{'onfolders'}) { $t.=" onfolders"; }
             if ($in{'recursiv'})  { $t.=" recursiv"; }

             $log="/tmp/nappit/aclreset.log";
             $r=time();
             open (PF, ">$log");
                 flock(PF, LOCK_EX);
                 print PF "<b style='background-color:#dddddd'>initiate reset $sys{'date_and_time'} $in{'aclreset'} $t\: $in{'path'}</b>\n";
                 # debug
                 # print PF "perl /var/web-gui/data/napp-it/zfsos/_lib/acllib_reset.pl aclreset_$r.txt\n";
             close (PF);
             $log="/tmp/nappit/aclreset20.log";
             open (PF, ">$log");
                 flock(PF, LOCK_EX);
                 print PF "<b style='background-color:#dddddd'>initiate reset $sys{'date_and_time'} $in{'aclreset'} $t\: $in{'path'}</b>\n";
             close (PF);
             ###########


             $in{'acl_reset'}="aclreset_$r";

             #save %in   #hash in file (hashname,file,modus,zeilennr,lf)
             &hash2file("in","/tmp/nappit/aclreset_$r.txt");

             #initiate task
             $p="perl /var/web-gui/data/napp-it/zfsos/_lib/acllib_reset.pl aclreset_$r.txt";
             $r=`echo \'$p\' | sudo at -s now`;
             print "$r\n";

             #exit;
             #reload
             $in{'prop'}="";
             $in{'answered'}="";
             $in{'action'}="";
             $in{'list'}="";
             sleep(2);
             &reload;

   }


   #change aclmode
   if ($in{'prop'} eq 'aclmode') {
        $r=&exe("zfs set aclmode=$in{'aclmode'} \'$in{'zfs'}\'","","acllib 1016");
        if ($r ne "") { &mess($r); }
   }

    #change aclmode
   if ($in{'prop'} eq 'aclinherit') {
        $r=&exe("zfs set aclinherit=$in{'aclinherit'} \'$in{'zfs'}\'","","acllib 1022");
        if ($r ne "") { &mess($r); }
   }


   #add user trivial,local,group or ad
   ###################################
   if ($in{'prop'} =~/^acl_add/)  {

#&print_hash(%in);
        # local or trivial
        if (!($in{'add_name'}=~/\@/)) {

            # local user
            if ($in{'prop'}=~/local_user/) {
               $in{'add_name'}="user:\'$in{'add_name'}\'";
            }

            #local smb group    ex wingroup:Backup Operators@BUILTIN
            if ($in{'prop'}=~/group/) {
               &acllib_v;
               $in{'add_name'}=~s/.*\=> *//;
               if ($in{'add_name'} eq "-") { &mess('You need to select a SMB group with a mapping to a Unix group'); }
               $in{'add_name'}="group:\'$in{'add_name'}\'";
            }

        } else {

            if ($in{'prop'} ne "acl_add_trivial") { &acllib_v; }

            # ad/ ephemeral mapped user
            if ($in{'prop'}=~/ad_user/) {
               $t=$in{'add_name'};
               $in{'add_name'}=$current{$in{'add_name'}};
            }

            # add ephemeral mapped group
            if ($in{'prop'}=~/ad_group/) {
               $t=$in{'add_name'};
               $in{'add_name'}=$current{$in{'add_name'}};
            }

            # optional: unixuser:root or  user:2147483649
            $in{'add_name'}=~s/unixuser:/user:/;                       # only name
        }


        $acl="A$in{'pos'}\+$in{'add_name'}\:";                        # A3+name..:

        $in{'aclset'}=&zfslib_set2acl($in{'aclset'});
        $acl.="$in{'aclset'}\:";                                     # add acl:

        $in{'inherit'}=~s/; *//g;
        $in{'inherit'}=~s/file_inherit/f/;                           # selectbox needs ;
        $in{'inherit'}=~s/dir_inherit/d/;
        $in{'inherit'}=~s/no_inherit/-------/;
        $in{'inherit'}.=$in{'inherit_only'};
        $in{'inherit'}.=$in{'no_propagate'};
        $acl.="$in{'inherit'}\:";                                    # add inherit:

        $acl.="$in{'type'}";                                         # add type from form

        # zfs-folder
        if ($in{'l3'}=~/01/) {
             $acl.=" $path";
        }

        # share
        if ($in{'l3'}=~/02/) {
             &acllib_v;

             $t="/$in{'zfs'}/.zfs/shares/";            # name could be sharename or path
             $t=`sudo /usr/bin/ls $t`;
             $t=~s/\n.*//s;

             $t="/$in{'zfs'}/.zfs/shares/$t";          # path to control file
             $acl.=" \'$t\'";

        }


#&mess("sudo $current{'chmod'} $acl");
        $r=`sudo $current{'chmod'} $acl`;
        if ($r ne "") { &mess($r); };

   }

   #change type allow/deny
   if ($in{'prop'} eq 'type') {
        &acllib_v;

        $acl="A$in{'list'}\=";                                      # id=
        $k="acl$in{'list'}\-user";      $acl.="$current{$k}\:";     # add user:
        $k="acl$in{'list'}\-acl";       $acl.="$current{$k}\:";     # add acl:
        $k="acl$in{'list'}\-inherit";   $acl.="$current{$k}\:";     # add inherit:
        $k="acl$in{'list'}\-type";      $acl.="$in{'text'}";        # add type from form

        # zfs-folder
        if ($in{'l3'}=~/01/) {            # files and folders
             $r=`sudo $current{'chmod'} $acl $path`;
             if ($r ne "") { &mess($r); };
        }
        if ($in{'l3'}=~/02/) {          # shares
             $t="/$in{'zfs'}/.zfs/shares/";            # name could be sharename or path
             $t=`sudo /usr/bin/ls $t`;
             $t=~s/\n.*//s;

             $t="/$in{'zfs'}/.zfs/shares/$t";          # path to control file
             $r=`sudo $current{'chmod'} $acl \'$t\'`;
        }

   }

   #change inherit
   if ($in{'prop'} eq 'inherit') {
        &acllib_v;
        $in{'inherit'}=~s/; //g;
        $in{'inherit'}=~s/file_inherit/f/;         #selectbox needs ;
        $in{'inherit'}=~s/dir_inherit/d/;
        $in{'inherit'}=~s/no_inherit/-------/;
        $in{'inherit'}.=$in{'inherit_only'};
        $in{'inherit'}.=$in{'no_propagate'};
        $acl="A$in{'list'}\=";                                      # id=
        $k="acl$in{'list'}\-user";      $acl.="$current{$k}\:";     # add user:
        $k="acl$in{'list'}\-acl";       $acl.="$current{$k}\:";     # add acl:
        $k="acl$in{'list'}\-inherit";   $acl.="$in{'inherit'}\:";   # add inherit:
        $k="acl$in{'list'}\-type";      $acl.="$current{$k}";       # add type

        # zfs-folder
        if ($in{'l3'}=~/01/) {
             $r=`sudo $current{'chmod'} $acl $path`;
        }

   }

   #change acl_set
   if ($in{'prop'} eq 'aclset') {
        &acllib_v;
        $in{'aclset'}=&zfslib_set2acl($in{'aclset'});
        $acl="A$in{'list'}\=";                                      # id=
        $k="acl$in{'list'}\-user";      $acl.="$current{$k}\:";     # add user:
        $k="acl$in{'list'}\-acl";       $acl.="$in{'aclset'}\:";    # add acl:
        $k="acl$in{'list'}\-inherit";   $acl.="$current{$k}\:";     # add inherit:
        $k="acl$in{'list'}\-type";      $acl.="$current{$k}";       # add type

        # zfs-folder
        if ($in{'l3'}=~/01/) {
             $r=`sudo $current{'chmod'} $acl $path`;
        }

        # share
        if ($in{'l3'}=~/02/) {
             &acllib_v;
             $t="/$in{'zfs'}/.zfs/shares/";            # name could be sharename or path
             $t=`sudo /usr/bin/ls $t`;
             $t=~s/\n.*//s;

             $t="/$in{'zfs'}/.zfs/shares/$t";          # path to control file
             $r=`sudo $current{'chmod'} $t`;
        }

 #&mess($acl);

   }

   #change acl
   if ($in{'prop'} eq 'acl') {
        &acllib_v;
        my $nacl="";
        if ($in{'list_directory'} ne "")      { $nacl.="r"; } else { $nacl.="-"; }
        if ($in{'add_file'} ne "")            { $nacl.="w"; } else { $nacl.="-"; }
        if ($in{'execute'} ne "")             { $nacl.="x"; } else { $nacl.="-"; }
        if ($in{'add_subdirectory'} ne "")    { $nacl.="p"; } else { $nacl.="-"; }
        if ($in{'delete'} ne "")              { $nacl.="d"; } else { $nacl.="-"; }
        if ($in{'delete_child'} ne "")        { $nacl.="D"; } else { $nacl.="-"; }
        if ($in{'read_attributes'} ne "")     { $nacl.="a"; } else { $nacl.="-"; }
        if ($in{'write_attributes'} ne "")    { $nacl.="A"; } else { $nacl.="-"; }
        if ($in{'read_xattr'} ne "")          { $nacl.="R"; } else { $nacl.="-"; }
        if ($in{'write_xattr'} ne "")         { $nacl.="W"; } else { $nacl.="-"; }
        if ($in{'read_acl'} ne "")            { $nacl.="c"; } else { $nacl.="-"; }
        if ($in{'write_acl'} ne "")           { $nacl.="C"; } else { $nacl.="-"; }
        if ($in{'write_owner'} ne "")         { $nacl.="o"; } else { $nacl.="-"; }
        if ($in{'synchronize'} ne "")         { $nacl.="s"; } else { $nacl.="-"; }

        $acl="A$in{'list'}\=";                                      # id=
        $k="acl$in{'list'}\-user";      $acl.="$current{$k}\:";     # add user:
        $k="acl$in{'list'}\-acl";       $acl.="$nacl\:";            # add acl:
        $k="acl$in{'list'}\-inherit";   $acl.="$current{$k}\:";     # add inherit:
        $k="acl$in{'list'}\-type";      $acl.="$current{$k}";       # add type

        # zfs-folder
        if ($in{'l3'}=~/01/) {
             $r=`sudo $current{'chmod'} $acl $path`;
        }

        # share
        if ($in{'l3'}=~/02/) {
             $t="/$in{'zfs'}/.zfs/shares/";            # name could be sharename or path
             $t=`sudo /usr/bin/ls $t`;
             $t=~s/\n.*//s;

             $t="/$in{'zfs'}/.zfs/shares/$t";          # path to control file
             $r=`sudo $current{'chmod'} $acl $t`;
        }

# &mess($acl);
        if ($r ne "") {  mess($r); }
   }

   # share level acl -> restart smb
   if ($in{'l3'}=~/02/) {
     $r.=&exe('svcadm restart smb/server','','acllib 1236');
   }

   #error?
   if ($r ne "") { &mess($r); }                            # only debug

   #reload
   $in{'prop'}="";
   $in{'answered'}="";
   $in{'action'}="";
   $in{'list'}="";
   &reload;

 }

 #####################
 sub acllib_ask_property {       #hide: ask for property
 #####################
     my $aclsets="full_set,modify_set,write_set,read_set,create_file_set,create_folder_set,create_file_folder_set,owner_default_set,reads_set,readx_set,readxs_set,writex_set,writexs_set,none";
     my ($pos,$i,@w,$k,$v);

    #change acl
    ############
    if ($in{'answered'}) { &acllib_change_property;  exit; }


    my ($ask,$close,$form,$info,$t,$opt,$r);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;file=$in{'file'}\&amp;zfs=$in{'zfs'}\&amp;folder=$in{'folder'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";


     #ask ACL reset
    ######################
    if ($in{'prop'} eq 'acl_reset') {
        $form="Reset ACL: ".&select('aclreset','current-folder,remove,modify,root,owner,owner+read,owner+readx,owner=root,777,766,755,744,700','modify');
        $form.="folder <input type='checkbox' name='onfolders' value='1' checked> files <input type='checkbox' name='onfiles' value='1'> recursive <input type='checkbox' name='recursiv' value='1'>";
        $info ="Reset ACL entries (optional include files or recursively).<br><br>";
        $info.="Current-folder: reset ACL to current folder settings (use for files or recursive)<br><br>";
        $info.="Remove: reset ACL to OS default<br>";
        $info.="Modify: root=full, everyone=modify (free option)<br>";
        $info.="Root: only root=full<br>";
        $info.="Owner: only owner/root=full<br>";
        $info.="Owner + read: owner/root=full, everyone=read<br>";
        $info.="Owner + readx: owner/root=full, everyone=read + execute<br>";
        $info.="Owner = root: change owner to root<br><br>";
        $info.="<font class='font_darkred'><b>Warning:</b> If you reset ACL to Unix permissions, you will delete all ACL inheritance settings. ";
        $info.="<br>Best use on Solaris based systems is to set all permissions with ACLs only - especially when using the Solaris CIFS server. ";
        $info.="Use trivial ACLs like owner\@, group\@ or everyone\@ instead for basic setups. ";
        $info.="They work similar to Unix permissions but offer advanced ACL inheritance options.";
    }

    #ask add ACL trivial
    ######################
    if ($in{'prop'} eq 'acl_add_trivial') {
        $pos="";
        for  ($i=$current{'acl-count'};$i>=0;$i--) { $pos.="$i,"; } $pos=~s/,$//;           #acl position
        $form =" Group&nbsp;&nbsp;:" . &select('add_name','owner@,group@,everyone@','')."<br>" ;
        $form.=" ACLset&nbsp;:". &select('aclset',$aclsets,$in{'old'}). "Type". &select('type','allow,deny') . "ACL Position". &select('pos',$pos)."<br>";
        if ($current{'permstr'}=~/^d/) {
          $form.=" Inherit:". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit');
          $form.=" &nbsp;inherit only:  <input type='checkbox' name='inherit_only' value='i'> no_propagate <input type='checkbox' name='no_propagate' value='n'><br><br>";
        }
        $info="$txt{'extension_acl_trivial'}";
    }


    #ask add ACL local user
    ######################
    if ($in{'prop'} eq 'acl_add_local_user') {

        #get member of staff
        my @user=();

        $r=&exe("cat /var/smb/smbpasswd");    # all smbuser
        my @logins=split(/\n/,$r);
        my $users="";
        foreach my $t (@logins) {
                    $t=~s/:.*//;
                    $users.="$t,";
        }
        $users=~s/,$//;
        $pos=""; for  ($i=$current{'acl-count'};$i>=0;$i--) { $pos.="$i,"; } $pos=~s/,$//;           #acl position
        $form =" User&nbsp;&nbsp;:" . &select('add_name',$users,'')."<br>" ;
        $form.=" ACLset&nbsp;:". &select('aclset',$aclsets,$in{'old'}). "Type". &select('type','allow,deny') . "ACL Position". &select('pos',$pos)."<br>";
        $form.=" Inherit:". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit');
        $form.=" &nbsp;inherit only:  <input type='checkbox' name='inherit_only' value='i'> no_propagate <input type='checkbox' name='no_propagate' value='n'><br><br>";
        $info="$txt{'extension_acl_local_user'}";
    }

    #ask add ACL local group
    ############################
    if ($in{'prop'} eq 'acl_add_local_smbgroup') {

#&mess($current{'local_mapped_groups'});
        $t=$current{'local_mapped_groups'}; if ($t eq "") { $t="-"; }
        $pos=""; for  ($i=$current{'acl-count'};$i>=0;$i--) { $pos.="$i,"; } $pos=~s/,$//;           #acl position
        $form =" Group&nbsp;&nbsp;:" . &select('add_name',$current{'local_mapped_groups'},'')."SMB group => unix group<br>" ;
        $form.=" ACLset&nbsp;:". &select('aclset',$aclsets,$in{'old'}). "Type". &select('type','allow,deny') . "ACL Position". &select('pos',$pos)."<br>";
        $form.=" Inherit:". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit');
        $form.=" &nbsp;inherit only:  <input type='checkbox' name='inherit_only' value='i'> no_propagate <input type='checkbox' name='no_propagate' value='n'><br><br>";

        $info ="You can only use local SMB groups with a idmapping to a local unix group because ACL's could only be assigned to unixgroups and you need the mapping to establish a relationship.";
        $info.="You can create local SMB groups with menu users. The corresponding unixgroup (same name) and the needed mapping is created automatically by napp-it. If you create users with napp-it, a default mapping Wingroup:power users = Unixgroup:staff is established";
    }

    #ask add ACL ephemeral AD user
    ####################
    if ($in{'prop'} eq 'acl_add_ad_user') {


        # get userlist
         $t="";
         while (($k,$v) = each %current) {
              if ($k=~/^winuser:/) {
                if ($k=~/</) { next; }    # double entry ex. also per manual mapping
                $t.="$k,";
              }
         }
         $t=~s/,$//;

         # sort entries
         @t=();
         @t=split(/,/,$t);
         @t=sort(@t);
         $t=join(",",@t);

         $pos=""; for  ($i=$current{'acl-count'};$i>=0;$i--) { $pos.="$i,"; } $pos=~s/,$//;           #acl position
         $form =" User&nbsp;&nbsp&nbsp;:" . &select('add_name',$t,'')." (Ephemeral)<br>" ;
         $form.=" ACLset&nbsp;:". &select('aclset',$aclsets,$in{'old'}). "Type". &select('type','allow,deny') . "ACL Position". &select('pos',$pos)."<br>";
         $form.=" Inherit:". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit');
         $form.=" &nbsp;inherit only:  <input type='checkbox' name='inherit_only' value='i'> no_propagate <input type='checkbox' name='no_propagate' value='n'><br><br>";

         $info="Add ephemeral domainuser. If you want to add users with a static mapping to a local user, add this local user.";
    }

    #ask add ACL AD group
    #####################
    if ($in{'prop'} eq 'acl_add_ad_group') {

        &acllib_v;
        # get group
         $t="";
         while (($k,$v) = each %current) {
              if ($k=~/^wingroup:/) {
                $t.="$k,";
              }
         }
         $t=~s/,$//;

         # sort entries
         @t=();
         @t=split(/,/,$t);
         @t=sort(@t);
         $t=join(",",@t);

         $pos=""; for  ($i=$current{'acl-count'};$i>=0;$i--) { $pos.="$i,"; } $pos=~s/,$//;           #acl position
         $form =" Group&nbsp;&nbsp&nbsp;:" . &select('add_name',$t,'')." (Ephemeral)<br>" ;
         $form.=" ACLset&nbsp;:". &select('aclset',$aclsets,$in{'old'}). "Type". &select('type','allow,deny') . "ACL Position". &select('pos',$pos)."<br>";
         $form.=" Inherit:". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit');
         $form.=" &nbsp;inherit only:  <input type='checkbox' name='inherit_only' value='i'> no_propagate <input type='checkbox' name='no_propagate' value='n'><br><br>";

         $info="Add ephemeral domaingroup. If you want to add groups with a static mapping to a local group, add this local group.";

    }


    #ask type (allow/deny)
    ######################
    if ($in{'prop'} eq 'type') {
      if ($in{'old'} eq "allow") {
        $form="Type of Rule $in{'list'} $in{'user'} = <input type='text' class='input' name='text' value='deny' style='width: 150px' readonly>";
        $info="$txt{'extension_acl_deny'}";
      } else {
        $form="type of Rule $in{'list'} $in{'user'} = <input type='text' class='input' name='text' value='allow' style='width: 150px' readonly>";
        $info="$txt{'extension_acl_allow'}";
      }
    }

    #ask inherit
    ######################
    if ($in{'prop'} eq 'inherit') {
        my ($inho,$nop);
        if ($in{'old'}=~/inherit_only/) { $in{'old'}=~s/,*inherit_only//; $inho=" checked"; }
        if ($in{'old'}=~/no_propagate/) { $in{'old'}=~s/,*no_propagate//; $nop=" checked"; }
        $in{'old'}=~s/,/; /g;
        $form="Inheritance". &select('inherit','file_inherit; dir_inherit,file_inherit,dir_inherit,no_inherit',$in{'old'});
        $form.=" inherit only:  <input type='checkbox' name='inherit_only' value='i'$inho> no_propagate <input type='checkbox' name='no_propagate' value='n'$nop>";
        $info=<<EoF;
$txt{'extension_acl_inherit'}
EoF
    }

    #ask acl-set
    ######################
    if ($in{'prop'} eq 'aclset') {

        $form="ACL-set". &select('aclset',$aclsets,$in{'old'});
        if ($in{'l3'}=~/01/) { #share level
             $form="ACL-set on SMB-Share". &select('aclset',$aclsets,$in{'old'});
        }


        $info=<<EoF;
$txt{'extension_acl_sets'}
EoF
    }


    #ask acl
    ######################  rwxpdDaARWcCos
    if ($in{'prop'} eq 'acl') {
        my $list_directory="";
        my $add_file="";
        my $execute="";
        my $add_subdirectory="";
        my $delete="";
        my $delete_child="";
        my $read_attributes="";
        my $write_attributes="";
        my $read_xattr="";
        my $write_xattr="";
        my $read_acl="";
        my $write_acl="";
        my $write_owner="";
        my $synchronize="";
        if ($in{'old'}=~/list_directory/)      { $list_directory=" checked"; }
        if ($in{'old'}=~/add_file/)            { $add_file=" checked"; }
        if ($in{'old'}=~/execute/)             { $execute=" checked"; }
        if ($in{'old'}=~/add_subdirectory/)    { $add_subdirectory=" checked"; }
        if ($in{'old'}=~/delete/)              { $delete=" checked"; }
        if ($in{'old'}=~/delete_child/)        { $delete_child=" checked"; }
        if ($in{'old'}=~/read_attributes/)     { $read_attributes=" checked"; }
        if ($in{'old'}=~/write_attributes/)    { $write_attributes=" checked"; }
        if ($in{'old'}=~/read_xattr/)          { $read_xattr=" checked"; }
        if ($in{'old'}=~/write_xattr/)         { $write_xattr=" checked"; }
        if ($in{'old'}=~/read_acl/)            { $read_acl=" checked"; }
        if ($in{'old'}=~/write_acl/)           { $write_acl=" checked"; }
        if ($in{'old'}=~/write_owner/)         { $write_owner=" checked"; }
        if ($in{'old'}=~/synchronize/)          { $synchronize=" checked"; }

        $form="<input type='checkbox' name='list_directory' value='1'$list_directory> (r) list_directory <br>";
        $form.="<input type='checkbox' name='add_file' value='1'$add_file> (w) add_file<br>";
        $form.="<input type='checkbox' name='execute' value='1'$execute> (x) execute<br>";
        $form.="<input type='checkbox' name='add_subdirectory' value='1'$add_subdirectory> (p) add_subdirectory<br>";
        $form.="<input type='checkbox' name='delete' value='1'$delete> (d) delete<br>";
        $form.="<input type='checkbox' name='delete_child' value='1'$delete_child> (D) delete_child<br>";
        $form.="<input type='checkbox' name='read_attributes' value='1'$read_attributes> (a) read_attributes<br>";
        $form.="<input type='checkbox' name='write_attributes' value='1'$write_attributes> (A) write_attributes<br>";
        $form.="<input type='checkbox' name='read_xattr' value='1'$read_xattr> (R) read_xattr<br>";
        $form.="<input type='checkbox' name='write_xattr' value='1'$write_xattr> (W) write_xattr<br>";
        $form.="<input type='checkbox' name='read_acl' value='1'$read_acl> (c) read_acl<br>";
        $form.="<input type='checkbox' name='write_acl' value='1'$write_acl> (C) write_acl<br>";
        $form.="<input type='checkbox' name='write_owner' value='1'$write_owner> (o) write_owner<br>";
        $form.="<input type='checkbox' name='synchronize' value='1'$synchronize> (s) synchronize<br>";

        $info=<<EoF;
$txt{'extension_acl_special'}
EoF
    }

    #ask aclinherit
    ######################
    if ($in{'prop'} eq 'aclinherit') {

    # get current  # not working?
    $t=&exe("zfs list -H -o aclinherit \'$in{'zfs'}\'","","acllib 1494");
    chomp($t);
    # &mess($t);

        $form="ZFS property aclinherit of $in{'zfs'}". &select('aclinherit','passthrough,discard,noallow,restricted,passthrough-x',$t);
        $info=<<EoF;
<pre>The ZFS file system includes the aclinherit property to determine the behavior
of ACL inheritance when creating files and folders. Values include the following:

discard  For new objects, no ACL entries are inherited when a file or directory
is created. The ACL on the file or directory is equal to the permission mode of
the file or directory.

noallow  For new objects, only inheritable ACL entries that have an access type
of deny are inherited.

restricted  For new objects, the write_owner and write_acl permissions are
removed when an ACL entry is inherited.

passthrough  When property value is set to passthrough, files are created with
a mode determined by the inheritable ACEs. If no inheritable ACEs exist that affect
the mode, then it is set in accordance to the requested mode from the application.

passthrough-x  Has the same semantics as passthrough, except when passthrough-x
is enabled, files are created with the execute (x) permission, but only if execute
permission is set in the file creation mode and in an inheritable ACE that affects
the mode. The default mode for the aclinherit is restricted.

<b>For AFP and SMB use and a Windows like behaviour: use pass-through.</b>
</pre>
EoF
    }

    #ask aclmode
    ######################
    if ($in{'prop'} eq 'aclmode') {
    # get current  # not working?
    $t=&exe("zfs list -H -o aclmode \'$in{'zfs'}\'",'','acllib 1528');
    chomp($t);

    my $res=`sudo /usr/sbin/zfs get 2>&1 | grep aclmode`;
    if ($res=~/restricted/) { $res=",restricted"; } else { $res=""; }           # only in newer Illumos builds, https://www.illumos.org/issues/3254

    $form="ZFS property aclmode of $in{'zfs'}". &select('aclmode',"passthrough,groupmask,discard$res",$t);
    $info=<<EoF;
<pre>The aclmode property that determines how the ACL permissions on a file are modified
during a chmod operation is reintroduced in OI and Solaris 11. The aclmode values
are discard, mask, and passthrough. The discard default value is the most
restrictive, and the passthrough value is the least restrictive. Aclmode is not
used with SMB (no chmod) but for example with NFS clients. For use with AFP (netatalk)
you must set aclmode to pass-through.

Aclmode=restricted is added in newer Illumos to avoid unwanted ACL modifications
via chmod, more <a href="https://www.illumos.org/issues/3254" target="_blank">www.illumos.org/issues/3254</a>
</pre>
EoF
    }


     ### form ###
     $ask=&ask_pop("$form","$info","$opt");
     return ($ask);

 }


####################
sub acllib_getacl {
####################
   # preloaded for path=first action
   # parameter 1: file or folder
   # write to %current

   my $p=$_[0];  # may contain 'path'
   $p=~s/^\'|\'$//;

           &load_lib('zfslib.pl');

           $current{'acl-object'}=$p;
           my (@w,$i,$k);

   #####################################
   # compact output with job-id and rwx
   #####################################

#&mess($current{'acl-object'});
$current{'acl-object'}=&fn2fn($current{'acl-object'});                       # allow ' in names

           $t=`sudo $current{'ls'} -dV \'$current{'acl-object'}\'`;          # perm + ACL  of dataset (or file with list="/file or folder")
                                                                             # dV = compact format rwxp.. , dv = extended format add_subdirectory/..
#&mess(__LINE__);

           @t=(); @t=split(/\n/,$t);
           my $i="0";
           foreach my $t (@t) {
              $t=~s/^\s+//;
              $t=~s/ +/ /g;
              if ($t=~/^[drwx\-]/) {                             # drwxrwx...  = unix perm
                 $current{'permstr'}=$t;

                 @w=();
                 @w=split(/ /,$t);
                 $current{'perm'}=$w[0];

                 $current{'perm2'}=$w[0];
                 $current{'perm2'}=~s/\+//;    $current{'perm2'}=~s/^d//;
                 $current{'perm2'}=~s/rwx/7/g; $current{'perm2'}=~s/rw-/6/g;   $current{'perm2'}=~s/-w-/2/g;
                 $current{'perm2'}=~s/r-x/5/g; $current{'perm2'}=~s/r--/4/g;   $current{'perm2'}=~s/---/0/g;

                 $current{'owner'}=$w[2];
                 $current{'group'}=$w[3];
                 $current{'fdate'}="$w[4] $w[5] $w[6]";
                 $current{'ftime'}="$w[7]";
                 next;
              }
              @w=();
              @w=split(/:/,$t);              #from back> allow/deny  :: inherit :: acl :: user/group :: user
                                             #                                     or  :: everybody@
              @w=reverse(@w);

              $k="acl$i-user";
              $current{$k}="$w[3]";          # everyone@
              if ($w[4] ne "") {
                   $current{$k}="$w[4]:$current{$k}";
              }

              $k="acl$i-type";
              $current{$k}="$w[0]";          # allow/deny

              $k="acl$i-inherit";
              $current{$k}="$w[1]";

              $k="acl$i-acl";               # short
              $current{$k}="$w[2]";         #

              $k="acl$i-aclset";
              $current{$k}=$w[2];
              $current{$k}=&zfslib_acl2set($current{$k});      # ex full_set
              $i++;

           }

           #$i--;
           $current{'acl-count'}=$i;

#&print_hash(%current);
           ######################################################
           # extended output with job-id and add_subdirectory/..
           ######################################################

           $t=`sudo $current{'ls'} -dv \'$current{'acl-object'}\'`;
 #&mess($t);
           $t=~s/\n\s+\//\//gs;                                 # multiline -> one rule per line
           $t=~s/\n\s+\:/\:/gs;

           $t=~s/\//,/gs;
           @t=(); @t=split(/\n/,$t);
                                                                # 0:user:root:list_directory,read_data, ....
#&print_array(@t);                                              # 1:everyone@:list_directory,..
           $i="0";
           foreach my $t (@t) {
              $t=~s/^\s+//;
              $t=~s/ +/ /g;
              if ($t=~/^[drwx\-]/) {                             # drwxrwx...  = unix perm
                 next;
              }
              @w=();
              @w=split(/:/,$t);              #from back> allow/deny  : inherit : acl    : root       : user : id
                                             #                                   or     : everyone@  : id
                                             # or basic  allow/deny  : acl     : owner@ : id

                                             #           0             1        2       3             4       5

              @w=reverse(@w);

              if ($w[4] eq "") {             # ex 2 : everyone@ : read_xattr/read_attributes/read_acl/synchronize : allow
                                             #    3   2           1                                                 0

                            $k="acl$i-user2";
                            $current{$k}="$w[2]";          # everyone@

                            $k="acl$i-type2";
                            $current{$k}="$w[0]";          # allow/deny

                            $k="acl$i-inherit2";
                            $current{$k}='-------';        # no inherit

                            $k="acl$i-acl2";               # long  read_attr,..
                            $current{$k}="$w[1]";


              } else {
                            $k="acl$i-user2";
                            $current{$k}="$w[3]";          # everyone@
                            if ($w[5] ne "") {
                                 $current{$k}="$w[4]:$current{$k}";
                            }

                            $k="acl$i-type2";
                            $current{$k}="$w[0]";          # allow/deny

                            $k="acl$i-inherit2";
                            $current{$k}="$w[1]";

                            $k="acl$i-acl2";               # long  read_attr,..
                            $current{$k}="$w[2]";
              }

              $i++;
           }


           #$i--;
           $current{'acl-count2'}=$i;




#&print_hash(%current);
}
  ############
sub id2sid {
############

# default SID:
# SID: S-1-1-0               Name: "Jeder, Everyone"
# SID: S-1-5-32-546          Name: Gste, Guests
# SID: S-1-5-32-545          Name: Benutzer, Users
# SID: S-1-5-32-547          Name: Hauptbenutzer, Power-User (Gruppe)
# SID: S-1-5-32-544          Name: Administratoren, Administrators

# SID: S-1-3-0               Name: Ersteller-Besitzer, Creator Owner
# SID: S-1-3-1               Name: Erstellergruppe, Creator Group
# SID: S-1-5-11              Name: Authentifizierte Benutzer, Authenticated Users  (Gruppe)

# SID: S-1-5-21-domain-501   Name: Gast, Guest
# SID: S-1-5-21-domain-500   Name: Administrator, Administrator
# SID: S-1-5-21-domain-512   Name: Domnen-Admins, Domain Admins (Gruppe)
# SID: S-1-5-21-domain-513   Name: Domnen-Benutzer, Domain Users (Gruppe)

# get values to %current
# user/group_'name'          get unix uid/gid from Windows name
# name_'user/group:id'       get Windows name from uid/gid      ex $current{'id_maeyer@xx.yy'} ->  uid:214748713

# name_'sid'                 get name from sid
# sid_'name'                 get sid from name

# sid_'id'                   get sid from unix id
# id_'sid'                   get unix id from sid

# possible names from
# local user or smb groups
# alreday available domain user and groups (ephemeral)
# from manual mapping via idmap



#####################################
# step 1: read idmap  sid == uid/gif
#####################################

   #read list
   my $dump=&exe('idmap dump','','acllib 1739');

   my @l=split(/\n/,$dump);
   my (@w,$k,$n,$r);
   foreach my $l (@l) {
       @w=();
       $l=~s/\s*=.\s*/==/;              # == or =>
       $l=~s/uid:/user:/;               # acl list is like user:2145678
       $l=~s/gid:/group:/;              # acl list is like group:2145679

       @w=split(/==/,$l);                 # usid:S-1...     == user:2345476
                                          # gsif:S-1-5-2    == group:2345657

       if ($w[1] ne "") {
          $current{$w[1]}="$w[2]";           # usid:S-123..    -> user:2147483876
       }
       if ($w[2] ne "") {
          $current{$w[2]}="$w[1]";           # user:2147483876 -> usid:S-123
       }
   }


#####################################
# step 2: read idmap  winname == uid/gid
#####################################
   #read list

   $dump=&exe('idmap dump -n','','acllib 1764');
   @l=();
   @l=split(/\n/,$dump);
   foreach my $l (@l) {
       @w=();
       $l=~s/\s*=.\s*/==/;               # == or =>

       $l=~s/uid:/user:/;                # acl list is like user:2145678
       $l=~s/gid:/group:/;               # acl list is like group:2145679

       @w=split(/==/,$l);                # winuser:aa@bb.cc  user:2345476 or without name:
                                         # usid:S-123..       user:234565

       $current{$w[1]}=$w[0];            # name_uid:2147483876 -> winuser:meyer@xx.dd.ee, without name:
                                         # name_uid:2147483876 -> usid:S-123..

       $current{$w[0]}=$w[1];            # winname-> id


       #mapping ex winuser:xyz == unixuser:root
       if ($w[1]=~/unix/) {
         $t= "map_$w[0]";
         $current{$t}=$w[1];
         $current{$t}=~s/unixuser:/u:/;
         $current{$t}=~s/unixgroup:/g:/;
       }


       # default sid
       if ($w[0]=~/sid:/) {

            # SID: S-1-5-21-domain-501   Name: Gast, Guest
            if ($current{$w[1]}=~/-501$/) { $current{$w[1]}=~s/:.*/:domain guests/; }

            # SID: S-1-5-21-domain-500   Name: Administrator, Administrator
            if ($current{$w[1]}=~/-500$/) { $current{$w[1]}=~s/:.*/:domain administrator/; }

            # SID: S-1-5-21-domain-512   Name: Domnen-Admins, Domain Admins (Gruppe)
            if ($current{$w[1]}=~/-512$/) { $current{$w[1]}=~s/:.*/:domain admins/; }

            # SID: S-1-5-21-domain-513   Name: Domnen-Benutzer, Domain Users (Gruppe)
            if ($current{$w[1]}=~/-513$/) { $current{$w[1]}=~s/:.*/:domain users/; }
       }
   }


   ##################################################
   #get clearnames for local smb groups from gid:1224
   ##################################################
   # defaults

            # SID: S-1-1-0               Name: "Jeder, Everyone"
            $current{'gsid:S-1-1-0'}="local everyone";

            # SID: S-1-5-32-546          Name: Gste, Guests
            $current{'gsid:S-1-5-32-546'}="local guests";

            # SID: S-1-5-32-545          Name: Benutzer, Users
            $current{'gsid:S-1-5-32-545'}="local users";

            # SID: S-1-5-32-547          Name: Hauptbenutzer, Power-User (Gruppe)
            $current{'gsid:S-1-5-32-547'}="local power users";

            # SID: S-1-5-32-544          Name: Administratoren, Administrators
            $current{'gsid:S-1-5-32-544'}="local administrators";

            # SID: S-1-5-32-551          Name: backup operators
            $current{'gsid:S-1-5-32-551'}="local backup operators";

            # SID: S-1-3-0               Name: Ersteller-Besitzer, Creator Owner
            $current{'usid:S-1-3-0'}="local creator owner";

            # SID: S-1-3-1               Name: Erstellergruppe, Creator Group
            $current{'gsid:S-1-3-1'}="local creator group";

            # SID: S-1-5-11              Name: Authentifizierte Benutzer, Authenticated Users  (Gruppe)
            $current{'gsid:S-1-5-11'}="local authenticated users";



            #

   my $smbadm=&exe('smbadm show','','acllib 1846');
   $smbadm=~s/\n\s+SID: //gs;
   @l=split(/\n/,$smbadm);

   foreach my $l (@l) {                # backup operators (Members can bypass file security to back up files)S-1-5-32-551
        $l=~s/ \(.*\)/:/;
        @w=();
        @w=split(/:/,$l);               # [0] -> 'administrators'
                                        # [1] -> 'S-1-5-32-544'

#&print_array(@w);

        $k="gsid:$w[1]";
        $current{$k}="local $w[0]";     # sid -> clear SMB name

        $k="local $w[0]";
        $current{$k}="gsid:$w[1]";     # clear SMB name -> sid

        if (!($current{'local_smb_groups'}=~/$w[0]/)) {
           $current{'local_smb_groups'}.="local $w[0],";
        }

   }
   $current{'local_smb_groups'}=~s/,$//;


  ####################################################
  # get local unix groups with a mapping to smb groups
  ####################################################
  $current{'local_mapped_groups'}="";
           $r=&exe('cat /etc/group','','acllib 1876');
           @l=split(/\n/,$r);

           $r=&exe('idmap list','','acllib 1879');
           foreach my $l (@l) {
                   @w=();
                   @w=split(/:/,$l);

                   # default mapping power users -> staff ??
                   if ($w[0] eq "staff") {
                       $current{'local_mapped_groups'}.="power users => staff,";
                       next;
                   }

                   if ($w[2] < 100)   { next; }          # root etc
                   if ($w[2] > 9999)  { next; }          # special

                   if ($r=~/wingroup:$w[0]\@BUILTIN.+unixgroup:$w[0]\b/is) {
                            $current{'local_mapped_groups'}.="$w[0] => $w[0],";
                   }
                   # mapping?


           }
           $current{'local_mapped_groups'}=~s/,$//;

  #&mess($smbadm);
  # mappings winuser -> unixuser
  #&print_hash(%current);

}

##############
sub acllib_v {
  my $t=&getv($cfg{'app_acl'});
  if ($t=~/eval/is) {
     my $opt="";
     my $info= "<b>You need a valid agreement or licence to use this extensions. <br>More infos or a 60 day evaluation key see <a href='http://www.napp-it.org/extensions/index_en.html' target='_blank'>napp-it.org/extensions</a></b><br>";
     my $form="only available after registration";

     if ($_[0] eq "nopop") {
        print "$info";
     } else {
        print &ask_pop("$form","$info","$opt");
     }
     exit;
    }
}


#end
1;