#!/usr/bin/perl
# (c) Gnther Alka 2012..2015
# 6.mai 2015

# request page.htm ex 15.htm and write to /tmp
# this file is then updated via the websocketserver

# jobes: every 3s      (l1=15)
# other every 6s

# debug at CLI:
# perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agent-pages.pl 15.htm 140001


#use strict;
use vars qw($par $page_id $time @data $data $datatime $sec $min $hour $mday $mon $year $wday $ydat $isdst $t $f @t @m $m $r $d $out);

use Fcntl qw(:flock);                                                               # filelocking
$|=1;                                                                               # no buffering

$page_id=$ARGV[0];
$par=$ARGV[1];

$page_id=~s/\'//g;
$par=~s/\'//g;

if (!(defined($par))) {
     # print "agent-pages 27:  missing parameter\n";
     exit;
}


 if (!($page_id=~/\d.*\.htm/)) {
     # print "agent-pages 24:  missing page id\n";                                   # after login/ no page selected
     exit;
 }


#####
## do not start multiple times with same page id
       $r=`ps axw | grep scripts`;
       @t=split(/\n/,$r);
       $f="1";
       foreach my $t (@t)  {
               if ($t=~/grep/) { next; }
               if ($t=~/$page_id/ ) {
                    if ($f eq "1") { $f++; next; }
                    #debug
                    print "########## agent-pages.pl 42:$t\n $page_id already started\n";
                    exit;
               }
 }
 #####

 # debug
# print "agent-pages 505 page id: $page_id\nparameter: $par\n\n";


 #date
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
      $mon++;
      if ($sec < 10)  { $sec  = "0$sec";  }
      if ($min < 10)  { $min  = "0$min";  }
      if ($hour < 10) { $hour = "0$hour"; }
      if ($mday < 10) { $mday = "0$mday"; }
      if ($mon < 10)  { $mon  = "0$mon";  }
      $year=1900+$year;
      $time=time();


 $par="socketserver=1:$par";            # need special parsing in admin.pl

 # debug
 print "\nagent-pages.pl 77\n/perl /var/web-gui/data/wwwroot/cgi-bin/admin.pl \"$par\"\n";
 #exit;

 $r=`/usr/bin/perl /var/web-gui/data/wwwroot/cgi-bin/admin.pl \"$par\"`;

 #remove </body>  and header
 $r=~s/.*<body>//s;
 $r=~s/<\/body>//gs;
 $r=~s/<\/html>//gs;

 #debug
 # print "#### $r\n";


 #<!--wscontent--> =whole page or <!--wsarea--> = area with div=wsarea
 if (($r=~/<!\-\-wsarea\-\->/) && ($r=~/<!\-\-wsarea_end\-\->/s)) {
    $r=~s/.*<!\-\-wsarea\-\->//s;
    $r=~s/<!\-\-wsarea_end\-\->.*//s;
    $r="<!--wsarea-->$r";
 } else {
    if ($r=~/<!\-\-wscontent\-\->/s) {
         $r=~s/.*<!\-\-wscontent\-\->/<!--wscontent-->/s;
    } else {
          # debug only
          #print "100 wscontent missing in page\n";

          #nothing todo
          exit;


    }
 }

 # add time to #hl
 $r.=<<EoF;

   <script type="text/javascript">
     \$("#minilog").append("reload $hour\:$min $sec\s");
     \$("#minilog").animate({opacity: 'hide'}, 'slow');
   </script>
EoF


 #add timestamp
 $r.="<div style='z-index: 10; position: absolute; top: 150px; width: 99%; font-size:8px;color:#666666; margin:10px 30px 0 0; text-align:right'>update $hour:$min $sec s </div><!--time-->$time";

 #log file to /tmp/page_id
 if (!($r=~/<!\-\-nows\-\->/s)) {                         # skip realtime update (ex pop-windows open)
   open (F,">/tmp/nappit/agent-pages_$page_id");          # ex agent-pages_15.htm
      flock(F, LOCK_EX);
      print F "$r";
   close (F);
 } else {
    # debug
    # print "agent-pages 111: $page_id\: --nows--\n";
 }


 if ($page_id =~/^15/) {               # jobs more often
   sleep (1);
 } else {
   sleep(6);
 }

 #unlink("/tmp/nappit/agent-pages_$page_id");
 &del_old;
 exit;



############ check for pagefiles older 10s
sub del_old {
############
  my $r;
  my $time=time();
  @t=();
  &read_dir('/tmp/nappit/','t','htm$');
  foreach my $t (@t) {
      if (!($t=~/^agent-pages\_\d+/)) { next; }
      # print "agent-pages 136 check $t\n";

      #read
      $r=`cat /tmp/nappit/$t`;
      if ($r=~/<!\-\-time\-\->/s) {
         $r=~s/.*<!\-\-time\-\->//s;
         if ($time-$r > 10) { unlink("/tmp/napp-it/$t");}
      }
  }

}


############
sub read_dir { # &read_dir("dir","arrayname","Muster","Zeilennr")
############ directory lesen ergebnis in array "arrayname" (files+directories!!) oder Muster=/
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;

 local (*F);
 if ($par[0] eq "") { &CgiDie("(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])"); }
 if ($par[1] eq "") { &CgiDie("(lib-562 read_dir: $par[2]) Programmfehler: Es wurde kein Array angegeben (ref $_[3])"); }
 if (!(-d $par[0])) { &CgiDie("(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[3])"); }

 opendir(F, $par[0]) || &CgiDie("(lib-564 read_dir: $par[2]) Programmfehler: Verzeichnis $par[0] gesperrt");
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file"; if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[2]=~/\./) {        #.xxx
                if ($file=~/$par[2]$/) {  push (@{$par[1]},$file); }
        } else {
                if ($file=~/$par[2]/) {  push (@{$par[1]},$file); }
        }
 }
 closedir(F);
 return;
}