# get-disk-sas2.pl
#
# (c) napp-it 2010, 2011, 2012, 2013

use strict;

# fill %disk with disk sas2 infos
&get_mydisk_sas2;      # load values on require  in menu sas2 extension


######################
sub get_mydisk_sas2  {
#######################      # parameter full (= with additional v7 info GUID and SAS Adress)


  #default
  $disk{'all_lsi2'}="";
  $disk{'all_lsi2_used'}="";
  $disk{'all_lsi2_unused'}="";

   # each disk has a controller, encolosure and slot info with properties like
   # c0e1s23_Serial No -> abcd
   my ($out, $ant, @l, $l, @c, $c, $n, $t, @d, $d, @w, $w, $k, $i, $sn, $u, $con, $enc, $slot, $id, $ver);

   @w=();  @w=split(/\t/,$disk{'all_dsk'}); if ((@w > 8) && (!($cfg{'ver'}=~/c|m/)))   { print "$txt{'me'}"; sleep(2); &log_end; exit; }

   if (!(-f '/var/web-gui/_my/tools/sas2ircu/sas2ircu')) {

         &get_check;

         # not available
         # $disk{'nlsi2'}=$disk{'all_dsk'};
         # return;

   } else {

          # v2 or 3
          if (-f '/var/web-gui/_my/tools/sas3ircu/sas3ircu') {
            $ant=&exe('chmod 755 /var/web-gui/_my/tools/sas3ircu/sas3ircu');             # executable, displays all disks but no GUID
            $ant=&exe('/var/web-gui/_my/tools/sas3ircu/sas3ircu LIST','','31 get-disk-sas2.pl');
            $ver=$ant; $ver=~s/.*Version //s; $ver=~s/ .*//s;
            $disk{'sasircu'}="sas3ircu $ver";
          } else {
            $ant=&exe('chmod 755 /var/web-gui/_my/tools/sas2ircu/sas2ircu');             # executable, displays all disks but no GUID
            $ant=&exe('/var/web-gui/_my/tools/sas2ircu/sas2ircu LIST','','31 get-disk-sas2.pl');
            $ver=$ant; $ver=~s/.*Version //s; $ver=~s/ .*//s;
            $disk{'sasircu'}="sas2ircu $ver";
          }

          #debug
          #&mess($ant);

          if (!($ant=~/successfully/is)) {
              #  - No supported SAS2 controllers found

              $disk{'all_nlsi2'}=$disk{'all_dsk'};
              $disk{'all_nlsi2_used'}=$disk{'all_inuse'};
              $disk{'all_nlsi2_unused'}=$disk{'all_unused'};

              if ($ant=~/error/is) { &mess("check SAS2 controller or try a reboot:<hr>$ant"); }
              return;
          }
   }



# to increase performance, slotinfo is only loaded when alldisk has changed
     my ($disk1,$disk2,$last);

     if (-f '/tmp/nappit/napp-it_smart.last')  { $last=&exe("cat /tmp/nappit/napp-it_smart.last"); }
     my $diff=time();

     if ($last >0) { $diff=$diff-$last; }
     if ($diff < 50) {

               # check if (-f "/tmp/napp-it_smart.txt") and load
               if (-f "/tmp/nappit/napp-it_smart.txt") {
                   $disk1=&exe("cat /tmp/nappit/napp-it_disks.txt");
                   $disk2=&exe('iostat -En | grep Vendor');

                   #Command window
                    &log_add("62 get-disk-sas2.pl# compare /tmp/nappit/napp-it_disks.txt vs iostat -En | grep Vendor <hr>$disk1<hr>$disk2");

                   #up to date?
                   if ($disk1 eq "$disk2") {

                        if ((-f "/tmp/nappit/napp-it_smart.txt") && (-f "/tmp/nappit/napp-it_sas2.txt"))  {

                                      #load smart to %disk
                                      &read_ahfile("/tmp/nappit/napp-it_smart.txt","disk","h+");

                                      #load sas to %disk
                                      &read_ahfile("/tmp/nappit/napp-it_sas2.txt","disk","h+");

                                      #debug
                                      #&print_hash(%disk);

                                      #ok, return
                                      return;
                        }
                   }
              }
      }


#############################
  # del logfiles.txt}
  if (-f "/tmp/nappit/napp-it_sas2.txt")   {  &exe("rm /tmp/nappit/napp-it_sas2.txt");   }


   #List of SAS2 controller -> @c
   @l=split(/\n/,$ant);
   foreach $l (@l) {
           $l=~s/^\s+//;
           $l=~s/\s+/\t/g;
           if ($l=~/^\d/) {
                push (@c,$l);
                $l=~s/\t$//;
                @w=();
                @w=split(/\t/,$l);
                $disk{'controller_sas2'}.="$w[0]\t";
                $t="controller_sas2_$w[0]";
                $disk{$t}=$l;

                ## add sas2.txt
                open (PF, ">>/tmp/nappit/napp-it_sas2.txt");   print PF "$t|$l|\n";  close (PF);


           }
   }
   $disk{'controller_sas2'}=~s/\t$//;                                           # ex 0\t1

   ## add sas2.txt
   open (PF, ">>/tmpnappit//napp-it_sas2.txt");   print PF "controller_sas2|$disk{'controller_sas2'}|\n";  close (PF);


    #####################
   # read base smartinfos (full sn needed as key)
   ######################
    &get_mydisk_smart('');                                                  # get full/base info -> %disk

   ##############
   # SAS2 details
   ##############

   my $controllerinfo;
   my $irvolinfo;
   my ($enclosureinfo,$enclosure);
   my ($physinfo,$phys);
   my $devtype;
   my %dsk;

   # each controller
   foreach $c (@c) {
         chomp($c);
         $con=$c; $con=~s/\t.*//;                                               # Controller Number


         #############
         #### step 1 get all disks but guid is not displayed  (v7 shows guid but not all disks)
         #############

         if (-f '/var/web-gui/_my/tools/sas3ircu/sas3ircu') {
           $ant=&exe("/var/web-gui/_my/tools/sas3ircu/sas3ircu $con display",'','163 get-disk-sas2.pl');              # displays all disks
         } else {
           $ant=&exe("/var/web-gui/_my/tools/sas2ircu/sas2ircu $con display",'','166 get-disk-sas2.pl');
         }

         #debug
       #print "Content-type: text/html\n\n<pre>$ant"; exit;

         if ($ant=~/successfully/is) {

                  $physinfo=$ant;
                  $physinfo=~s/.*Physical device information\n\-*\n*//is;
                  $physinfo=~s/\-\-\-+.*//s;
                  @t=();
                  @t=split(/Device is a/,$physinfo);
                  $disk{'devices'}=@t;
                  $disk{'devices'}--;

                  ## add sas2.txt
                  open (PF, ">>/tmp/nappit/napp-it_sas2.txt");   print PF "devices|$disk{'devices'}|\n";  close (PF);

                  #debug devices/disks
                  # print "Content-type: text/html\n\n$#t";
                  # &print_array(@t);  exit;

                  # get keys/ values from all devices
                  # line 1: Device is a Hard disk
                  # line 2: Enclosure #   :  2
                  # line 3: Slot #        :  23


                  # devices
                  for ($i=1;$i<@t; $i++) {

                      $devtype="";
                      $enc="";
                      $slot="";
                      %dsk=();
                      $dsk{'con'}=$con;

                      @l=();
                      @l=split(/\n/,$t[$i]);

                      # debug lines of a device
                      # if ($t[$i]=~/3LN4TW4X/s) {       # sn
                      #   print "Content-type: text/html\n\n";
                      #   &print_array(@l);  exit;
                      # }

                      # lines of a device
                      foreach my $l (@l) {

                                           $l=~s/^ +//;

                                           # device type, line1
                                           if (!($l=~/:/)) {
                                               $dsk{'sas2_devtype'}=$l;
                                               next;
                                           }
                                           if (!($l=~/:/)) { next; }

                                           @w=();
                                           @w=split(/ *: */,$l);

                                           if ($w[0] eq "") { next; }

                                           # Enclosure, line 2
                                           if ($w[0]=~/^Enclosure/) {
                                               $dsk{'enc'}=$w[1];
                                               next;
                                           }

                                           # slot, line 3
                                           if ($w[0]=~/^Slot/) {
                                               $dsk{'slot'}=$w[1];
                                               next;
                                           }


                                           # Sn
                                           if ($w[0]=~/Serial/i) {
                                               $dsk{'sn'}=$w[1];
                                               $dsk{'sn'}=~tr/a-z/A-Z/;
                                               $dsk{'sn'}=~s/[^A-Z0-9]//g;            #normalize  /could be diff with '-'
                                               next;
                                           }

                                           # State
                                           if ($w[0]=~/^State/) {
                                               $dsk{'state'}=$w[1];
                                               next;
                                           }

                                           # Protocol
                                           if ($w[0]=~/^Protocol/) {
                                               $dsk{'protocol'}=$w[1];
                                               next;
                                           }
                                           # Drive type
                                           if ($w[0]=~/^Drive Type/) {
                                               $dsk{'drive_type'}=$w[1];
                                               next;
                                           }
                      } # end lines of device



                    # debug
                    #  print "Content-type: text/html\n\n<pre>sn=$dsk{'sn'}\n";
                    #  &print_array(@l);  exit;
                    #  &print_hash(%dsk); exit;

                      # get id from serial
                      @w=();
                      @w=split(/\t/,$disk{'all_dsk'});
                      $id="";
                      foreach $w (@w) {
                           $t="$w\_smart_sn";
                           if (($disk{$t} ne "") && ($dsk{'sn'} ne "")) {
                              if ($dsk{'sn'} eq $disk{$t}) { $id=$w; last; }
                           }
                           $t="$w\_sn";
                           if (($disk{$t} ne "") && ($dsk{'sn'} ne "")) {
                              if ($dsk{'sn'} eq $disk{$t}) { $id=$w; last; }
                           }
                      }

                      #problem: sn from scr2icu only part (beginning) of smart sn
                      if ($id eq "") {
                        foreach $w (@w) {
                           $t="$w\_smart_sn";
                           if (($disk{$t} ne "") && ($dsk{'sn'} ne "")) {
                              if ($disk{$t}=~/^$dsk{'sn'}/) { $id=$w; $disk{$t}.="<br>LSI_sn:$dsk{'sn'}"; last; }
                           }
                        }
                      }


                      # write to %disk
                      if ($id ne "") {

                           ## add sas2.txt
                           open (PF, ">>/tmp/nappit/napp-it_sas2.txt");

                                                      $t="$id\_sas2_slot";
                                                      $disk{$t}="c$con\:e$dsk{'enc'}\:s$dsk{'slot'}";
                                                      print PF "$t|$disk{$t}|\n";

                                                      $t="$id\_sas2_state";
                                                      $disk{$t}="$dsk{'state'}";
                                                      print PF "$t|$disk{$t}|\n";

                                                      $t="$id\_sas2_protocol";
                                                      $disk{$t}="$dsk{'protocol'}";
                                                      print PF "$t|$disk{$t}|\n";

                                                      $t="$id\_sas2_drive_type";
                                                      $disk{$t}="$dsk{'drive_type'}";
                                                      print PF "$t|$disk{$t}|\n";

                                                      $t="$id\_sas2_sn";
                                                      $disk{$t}="$dsk{'sn'}";
                                                      print PF "$t|$disk{$t}|\n";
                           close (PF);

                    }

                    # debug
                    # $t="$id\_smart_sn";
                    # print "Content-type: text/html\n\n<pre>268 dsksn=$dsk{'sn'} id=$id disksmart_sn=$disk{$t} \n";
                    # &print_hash(%disk); exit;

                    ###############
                    # end of step 2
                    ################

 #&print_hash(%disk);
                    # add
                     $disk{'all_lsi2'}.="$id\t";

                     #lsi (un)used?
                     if ($disk{'all_inuse'}=~/\b$id\b/) {
                             $disk{'all_lsi2_used'}.="$id\t";
                     } else {
                             $disk{'all_lsi2_unused'}.="$id\t";
                    }


               }  # /devices

               # get non lsi2
               ##############

               # debug
               #   print "Content-type: text/html\n\n<pre>227 \n";
               #   &print_hash(%disk); exit;

               # 3. get enclosureinfo
               ######################
                  $enclosureinfo=$ant;
                  $enclosureinfo=~s/.*Enclosure information\n\-*\n*//is;
                  $enclosureinfo=~s/\-\-\-+.*//s;
                  @t=();
                  @t=split(/Enclosure#/,$enclosureinfo);
                  $disk{'enclosures'}=@t;
                  $disk{'enclosures'}--;


                  ## add sas2.txt
                  open (PF, ">>/tmp/nappit/napp-it_sas2.txt");   print PF "enclosures|$disk{'enclosures'}|\n";  close (PF);

                  # debug
                        #print "Content-type: text/html\n\n<pre>$ant";
                        #&print_array(@t);  exit;

                  # get keys/values from all enclosures

                  for (my $i=1;$i<@t; $i++) {

                    $enc="";

                    @l=();
                    @l=split(/\n/,$t[$i]);

                    foreach my $l (@l) {
                       $l=~s/^ +//;

                       @w=();
                       @w=split(/ *: */,$l);
                       $w[0]=~s/^ +//;

                       # first line= Enc-nr
                       if ($w[0] eq "") {
                            $enc=$w[1];
                            next;
                       }                 # enclosure number only

                       if (!($disk{'enclosure_keys'}=~/$w[0]/))   {         # new key
                           $disk{'enclosure_keys'}.="$w[0]\t";
                       }
                       $t="enclosure$enc"."_$w[0]";
                       $w[1]=~s/\s+/ /g;
                       $disk{$t}=$w[1];
                    }
                  }
                  $disk{'enclosure_keys'}=~s/\t$//;


           } #/ success

  }
         #######################################################################

  $disk{'all_lsi2'}=~s/\t$//;
  $disk{'all_lsi2_used'}=~s/\t$//;
  $disk{'all_lsi2_unused'}=~s/\t$//;

   ## add sas2.txt
     open (PF, ">>/tmp/nappit/napp-it_sas2.txt");
           print PF "all_lsi2|$disk{'all_lsi2'}|\n";
           print PF "all_lsi2_used|$disk{'all_lsi2_used'}|\n";
           print PF "all_lsi2_unused|$disk{'all_lsi2_unused'}|\n";
           print PF "enclosure_keys|$disk{'enclosure_keys'}|\n";
     close (PF);

  # debug
  # $t="$id\_smart_sn";
  # print "Content-type: text/html\n\n<pre>268 dsksn=$dsk{'sn'} id=$id disksmart_sn=$disk{$t} \n";
  # &print_hash(%disk); exit;

  # get non lsi2
  ##############
  @w=();
  @w=split(/\t/,$disk{'all_dsk'});
  foreach $w (@w) {
     if (!($disk{'all_lsi2'}=~/\b$w\b/)) {

          $disk{'all_nlsi2'}.="$w\t";

         #nlsi (un)used?
         if ($disk{'all_inuse'}=~/\b$w\b/) {
              $disk{'all_nlsi2_used'}.="$w\t";
         } else {
              $disk{'all_nlsi2_unused'}.="$w\t";
         }

     }
  }
  $disk{'all_nlsi2'}=~s/\t$//;
  $disk{'all_nlsi2_used'}=~s/\t$//;
  $disk{'all_nlsi2_unused'}=~s/\t$//;

   ## add sas2.txt
     open (PF, ">>/tmp/nappit/napp-it_sas2.txt");
           flock(PF, LOCK_EX);
           print PF "all_nlsi2|$disk{'all_nlsi2'}|\n";
           print PF "all_nlsi2_used|$disk{'all_nlsi2_used'}|\n";
           print PF "all_nlsi2_unused|$disk{'all_nlsi2_unused'}|\n";
           print PF "sasircu|$disk{'sasircu'}|\n";
     close (PF);

  #

  @t=();  @t=split(/\t/,$disk{'all_lsi2'}); $t="";

  #debug
 #&print_hash(%disk);





}


#################
sub get_check  {
#################
my $r;
my $f="www.napp-it.org/doc";
   if (-f '/var/web-gui/_my/tools/sas2ircu/sas2ircu') { return; }

   # tool needed
   print "<b><br><br><br> LSI SAS2 slot management requires the sas2ircu tool for slot discovery, free downloadable from LSI, SuperMicro, Oracle and others.</b><br><br>";
   print "If you own a supported LSI SAS2 controller, you can now download the sas2ircu tool provided by LSI or Supermicro <br>http://www.lsi.com/downloads/Public/Host%20Bus%20Adapters/Host%20Bus%20Adapters%20Common%20Files/SAS_SATA_6G_P17/SAS2IRCU_P17.zip<br>";
   print "<br>or a newer version from http://www.lsi.com/products/storagecomponents/Pages/LSISAS9207-8i.aspx <br>under download misc ";
   print "and save it under /var/web-gui/_my/tools/sas2ircu/. (If you need sas3ircu, download at save it under /var/web-gui/_my/tools/sas3ircu/ )";
   &ask('begin');
   print "<br><br>If you want to download, read the LSI's end-user licence agreement from www.lsi.com -> support -> documents and downloads<br><br>";
   &ask('confirm','I want to download sas2ircu','I want to download sas2ircu on my own risk');

   if ($in{'answered'}) {
       print "<br><br>downloading, please wait ..<br>";
       $r=&exe("ping www.napp-it.org 1");
       if (!($r=~/alive/)) { print "Could not download. Network/ DNS/ Router not ready";  exit; }
       $r=&exe("wget -q -O - $f/sas2ircu > /tmp/sas2ircu");

       $f= -s "/tmp/sas2ircu";
       if ($f eq "0") { print "Could not download, try later or download manually and copy to /var/web-gui/_my/tools/sas2ircu/sas2ircu";  exit; }

       if (!(-d '/var/web-gui/_my/tools'))          { `mkdir /var/web-gui/_my/tools`; }
       if (!(-d '/var/web-gui/_my/tools/sas2ircu')) { `mkdir /var/web-gui/_my/tools/sas2ircu`; }

       $r=&exe("mv /tmp/sas2ircu /var/web-gui/_my/tools/sas2ircu");
       $r=&exe("chmod 755 /var/web-gui/_my/tools/sas2ircu/sas2ircu");
       sleep (1);
       &reload;
   }

   exit;
}






# eof
1;