# get-disk-smart-bg.pl
# this script is initiated via get-disk-smart.pl and loggs all smartvalues in the background to a file /tmp/nappit/napp-it_smart.txt
# reason: cgi timeouts on large installations
# debug: perl /var/web-gui/data/napp-it/zfsos/_lib/get-disk-smart-bg.pl

# (c) napp-it 2010-2014

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($cgipath $i $t $p $o $action $txt $ev %t %p %in %cfg @p @t @cfg %disk %sys %zfs %action %current %opt %txt $check);         # menues and global var + global temp

#require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";                          # common used functions of napp-it in this script
require "/var/web-gui/data/napp-it/zfsos/_lib/get-disk.pl";                         # load basic disk infos

$t=time();
     open (PF, ">/tmp/nappit/get-smart-bg.log");                                    # write time(), delete old logfile
          flock(PF, LOCK_EX);
           print PF "$t\n";
     close (PF);

# preload  (function is pre/autoloaded in sas and smartmenu)
&get_mydisk_smart;




##############
sub get_mydisk_smart  {
##############      opt parameter: none


# to increase performance, smart is loaded via monitor agent or if data is older 50s
     my (@disks,$disks,$r,@s,$s,$k,@w,$w,$type,$dev,$id,$smart_id,%sv);


  # del old smart.txt
       if (-f "/tmp/nappit/napp-it_smart.txt") {  &exe("rm /tmp/nappit/napp-it_smart.txt"); }

  #  add smart.txt
       open (PF, ">>/tmp/nappit/napp-it_smart.txt");
           flock(PF, LOCK_EX);
           # opt configured
           $k="all_dsk";
           if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }
       close (PF);


  @w=();
  @w=split(/\t/,$disk{'all_dsk'});

  foreach $w (@w) {
       if ($disks=~/,$w/) { next; }                                             # have it already
       if (!($w=~/s0$|p0$/)) { $w.="s0"; }
       $disks.="$w,";
       push (@disks,$w);
  }


  # step 1, skip if smart is not supported
  foreach my $disk (@disks) {

      $id=$disk;
      $id=~s/s0$|p0$//;


      $k="$id\_modell";
      if ($disk{$k} =~/dvd/) { next; }                                          # dvd drive


     # 1. try to get basic info
      $r=`sudo /usr/sbin/smartctl -i -T permissive /dev/rdsk/$disk`;            # without -d or system may hang

      #Command window
      &log_add("get-disk-smart.pl 90 basic info $disk# /usr/sbin/smartctl -i -T permissive /dev/rdsk/$disk<hr>$r");

      if ($r=~/not support SMART/is) {                                          # not smart capable
           $k="$id\_smart_health";
           $disk{$k}="n.a.";

           @w=(); @w=split(/\n/,$r);

           # not smart capable but maybee some infos
           foreach $w (@w) {
                    if ($w=~/Device type:/i) {                                  # Device type: disk
                         $w=~s/.*Device type: +//i;
                         $k="$id\_smart_type";
                         $disk{$k}="$w";
                    }
                    if ($w=~/Device:/i) {                                       # Device: Vmware virtual disk
                         $w=~s/.*Device: +//i;
                         $k="$id\_smart_device";
                         $disk{$k}="$w";

                         $k="$id\_smart_model";
                         $disk{$k}="$w";
                         $disk{$k}=~s/ .*//;;                                   # ex Vmware Virtual Disk ..
                    }

                    if ($w=~/Serial number:/i) {                                # Device: Vmware virtual disk sn
                         $w=~s/.*number: +//i;
                         $k="$id\_smart_sn";

                         # $disk{$k}="$w";                                      # too long
                          $disk{$k}="n.a.";

                          ## add smart.txt
                          open (PF, ">>/tmp/nappit/napp-it_smart.txt");
                                     print PF "$k|$disk{$k}|\n";

                                     # opt sn
                                     $k="$id\_sn";
                                     if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

                                     # opt configured
                                     $k="$id\_busy";
                                     if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

                           close (PF)

                    }
           }
           next;

      }  else {


           # try to enable smart to check sat/scsi type
           # default = sat= sat,16 is needed for 48bit ATA support
           # default (16) is reported to have problems on some intel ahci so use sat,12


           $r=`sudo /usr/sbin/smartctl -d sat,12 -T permissive --smart=on /dev/rdsk/$disk`;
           &log_add("get-disk-smart.pl detect type via smartctl -d sat,12 -T permissive --smart=on /dev/rdsk/$disk<hr>$r");

           $k="$id\_smart_type";
           if ($r=~/SMART Enabled/is) {
                $disk{$k}="sat,12";
           }

           if ($disk{$k} eq "") {
                      # try to enable smart to check scsi type
                      $r=`sudo /usr/sbin/smartctl -d scsi -T permissive --smart=on /dev/rdsk/$disk`;
                      &log_add("get-disk-smart.pl detect type via smartctl -d scsi -T permissive --smart=on /dev/rdsk/$disk<hr>$r");

                      if ($r=~/SMART Enabled|SMART\) enabled/is) {             # SMART Enabled or (SMART) enabled
                           $k="$id\_smart_type";
                           $disk{$k}="scsi";
                      }
           }

           #cannot detect type, next
           if ($disk{$k} eq "") {
                $disk{$k}="n.a.";
                next;
           }
           ##

      }

      # ok smart supported
      # device must be specified!  (sat, scsi),

      # get values
      ############
      %sv=();                                                 # collect smart values for current disk

      $k="$id\_smart_type";

      $r=`/usr/sbin/smartctl -a -d $disk{$k} -T permissive /dev/rdsk/$disk`;                    # get all infos, use type (produce a soft error in Illumos)
      #Command window
      &log_add("get-disk-smart.pl 169 all infos $disk# smartctl -a -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$r");

     #check selftest log
      $check=`/usr/sbin/smartctl -l selftest -d $disk{$k} -T permissive /dev/rdsk/$disk`;       # get check log
      &log_add("get-disk-smart.pl 173 selftest $disk#smartctl -l selftest -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$check");

      @s=();
      @s=split(/\n/,$check);
      $k="smart_selftest";
      $sv{$k}="--";
      foreach my $c (@s) {
            if (!($c=~/Completed/i))    { next; }

            if ($c=~/without error|Completed\s+\-/) {        # some disk report 'Completed  -' (not 'Completed without error')
                $sv{$k}="without error";                     # Completed without error
            } else {
                $sv{$k}="ERROR";
            }
      }
     #      print "+++++++++ selftest +++++++++++++++++\n$sv{$k}\n";

     # cmd option # http://sourceforge.net/apps/trac/smartmontools/ticket/261, without softerror but miss health state
       # $r=`sudo /usr/sbin/smartctl -i -c -A -l error -l selftest -l selective -d $disk{$k} -T permissive /dev/rdsk/$disk`;
     # log
       # &log_add("get-disk-smart.pl 193 all infos $disk# smartctl -i -c -A -l error -l selftest -l selective -d $disk{$k} -T permissive /dev/rdsk/$disk<hr>$r");



      #smart support
      if ($r=~/SMART support is: Available/s) {
         $k="smart_support";
         $sv{$k}="available";
         if ($r=~/SMART support is: Enabled/s) {
              $sv{$k}.=", enabled";
         }
      }


      @s=();
      @s=split(/\n/,$r);

      foreach my $s (@s) {

           #Health status
           if ($s=~/Health Status|SMART overall-health/i) {
                $s=~s/.*: +//;
                $k="smart_health";
                $s=~s/ +//g;
                if (!($s =~/\w/)) { $s="n.a."; }
                $sv{$k}=$s;
                next;
           }

           #sn
           if ($s=~/Serial Number/i) {           # a-z, A-Z, 0-9, no '-' (suppressed sometimes)
                $s=~s/.*: +//;
                $k="smart_sn";
                $s=~s/\s+//g;
                $s=~tr/a-z/A-Z/;
                $s=~s/[^A-Z0-9]//g;

                $sv{$k}=$s;
                next;
           }

           #Model
           if ($s=~/Device Model:/i) {
                $s=~s/.*Model: +//;
                $k="smart_model";
                $sv{$k}=$s;
                next;
           }

           #Firmware
           if ($s=~/Firmware Version:/i) {
                $s=~s/.*Version: +//;
                $k="smart_firmware";
                $sv{$k}=$s;
                next;
           }

           #temp
           if ($s=~/Temperature/i) {

                if ($s=~/Max Temperature/i)   { next; }              # no min/max
                if ($s=~/Temperature Limit/i) { next; }              # no limit count
                if ($s=~/Trip Temperature/i)  { next; }              # no Drive Trip Temperature (dsumike modification)

                $s=~s/.*  +//;
                $s=~s/ .*//;                                         # only temp not temp + min/max

                $k="smart_temp";
                if ($s=~/\d$/) { $s.=" C" }

                $sv{$k}=$s;
                next;
           }



      }   # /smartvalues

      # add smart-values to %disk like $disk{'c0t0d0_temp'} = 30 Celsius
      #############
      $k="$id\_smart_selftest";
      $disk{$k}=$sv{'smart_selftest'};

      $k="$id\_smart_support";
      $disk{$k}=$sv{'smart_support'};

      $k="$id\_smart_health";
      $disk{$k}=$sv{'smart_health'};

      $k="$id\_temp";
      $disk{$k}=$sv{'smart_temp'};

      $k="$id\_smart_model";
      $disk{$k}=$sv{'smart_model'};

      $k="$id\_smart_sn";
      $sv{'smart_sn'}=~s/^ +//;
      $disk{$k}=$sv{'smart_sn'};

      ## add smart.txt
      open (PF, ">>/tmp/nappit/napp-it_smart.txt");
           flock(PF, LOCK_EX);

            # smart sn
            $k="$id\_smart_sn";
            print PF "$k|$disk{$k}|\n";

            # opt sn
            $k="$id\_sn";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            # opt configured
            $k="$id\_busy";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            # opt selftest
            $k="$id\_smart_selftest";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            #debug via cli
           # print "----- $id\_smart_selftest -----:$disk{$k}\n";

            # opt type
            $k="$id\_smart_type";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            #new model health temp (agents)
            $k="$id\_smart_model";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            $k="$id\_temp";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

            $k="$id\_smart_health";
            if ($disk{$k} ne "") { print PF "$k|$disk{$k}|\n";  }

      close (PF);

      $k="$id\_smart_firmware";
      $disk{$k}=$sv{'smart_firmware'};

  }  #/disks


  ## print new disks.txt
     $t=&exe('/usr/bin/iostat -En | grep Vendor');
     open (PF, ">/tmp/nappit/napp-it_disks.txt");
           flock(PF, LOCK_EX);
           print PF "$t";
     close (PF);

     $t=time();
     open (PF, ">/tmp/nappit/napp-it_smart.last");
           flock(PF, LOCK_EX);
           print PF "$t";
     close (PF);


}

##############
sub log_add {
##############      replaces admin-lib function, loggs to /tmp/nappit/get-smart-bg.log
     open (PF, ">>/tmp/nappit/get-smart-bg.log");
           flock(PF, LOCK_EX);
           print PF "$_[0]\n";
     close (PF);

     #debug at cli
     print "$_[0]\n";
}

##############      #replaces admin-lib function exe
sub exe {
   my $e="$_[0]";
   $e=~s/^\s*sudo\s+//;
   my $r=`$e 2>&1`;
   &log_add("$r");
}

#############       #replaces admin-lib function exe for sub get-disk, can write only hash disk
sub hash2file {
# schreibt hash disk in file

        my @tmp = @_;
        my $tmp;
        my $k;
        my $v;
        my @out;
        local (*F);

        open(F, ">$tmp[1]");
                 flock(F, LOCK_EX);
                 while (($k,$v) = each %disk) {
                    push (@out,"$k\|$v\|\n")
                 }
                 @out=sort(@out);
                 foreach $tmp (@out) { print F "$tmp";}
         close(F);
  return 0;
}


# eof
1;
