# get-disk-smart, read smartvalues (per background task or buffered info)
#
# (c) napp-it 2010, 2011, 2012, 2013

use strict;

# preload  (function is pre/autoloaded in sas and smartmenu)
&load_lib("disklib.pl");
&get_mydisk_smart;


##############
sub get_mydisk_smart  {
##############      opt parameter: none


# to increase performance, smart is loaded via monitor agent or if data is older n seconds
     my ($disk1,$disk2,$last,$diff,$reload,$p,$r);


     # check background task
     $r=`ps axw | grep get-disk-smart-bg.pl | grep -v grep`;
     if ($r ne "") {
           print "<script language='javascript'>\$('#hl').html('Smartvalues (background job running, please wait..)')</script>\n";
           while ($r ne "") {
                 sleep(2);
                 if (-f "/tmp/nappit/napp-it_smart.txt") {
                    $t="";
                    open (FILE, "/tmp/nappit/napp-it_smart.txt");
                       flock(PF, LOCK_EX);
                       while(<FILE>) {
                          $t = $_ if eof;
                       }
                    close (PF);
                    &log_add_mini($t);
                 }
                 $r=`ps axw | grep get-disk-smart-bg.pl | grep -v grep`;
           }
     }

     $reload="0";

     if (-f '/tmp/nappit/napp-it_smart.last')  { $last=&exe("cat /tmp/nappit/napp-it_smart.last"); }
     $diff=time();

     if ($last >0) { $diff=$diff-$last; }
#&mess($last);

     # maxold=60min = 120/3600s
     $disk{'smart_age'}="";
     if ($diff < $cfg{'get-smart-reload'}) {

          $disk{'smart_age'}=" ($diff/$cfg{'get-smart-reload'} s)";
          # check if (-f "/tmp/nappit/napp-it_smart.txt") and load
          if ((-f "/tmp/nappit/napp-it_smart.txt") && (-f "/tmp/nappit/napp-it_disks.txt")) {
              $disk1=&exe("cat /tmp/nappit/napp-it_disks.txt");
              $disk2=&exe('iostat -En | grep Vendor');

              #Command window
              &log_add("28 get-disk-smart.pl 28# compare /tmp/nappit/napp-it_disks.txt vs iostat -En | grep Vendor <hr>$disk1<hr>$disk2");

              #up to date?
              if ($disk1 eq "$disk2") {
                   #load smart_temp to %disk
                   &read_ahfile("/tmp/nappit/napp-it_smart.txt","disk","h+");

                   #get disk'unused' from all disks,..
                   &get_mydsk_stat;

                   &log_add("get-disk-smart.pl 35# compare /tmp/nappit/napp-it_disks.txt vs iostat -En | grep Vendor <hr>identical, use buffered smart info");
                   # read log
                   if (-f "/tmp/nappit/get-smart-bg.log") {
                                         open(PF, "</tmp/nappit/get-smart-bg.log");
                                            flock(PF, LOCK_EX);
                                            my @data = <PF>;
                                         close(PF);
                                         $t=join("",@data);
                                         &log_add($t);                                  # log last background run
                   }
                   return;
              }

          } else {
               $reload="1";
          }
     }  else { # too old, re-read
         $reload="1";
     }

  #############################  reload?
  if ($reload) {
          # del buffered infos
          if (-f "/tmp/nappit/napp-it_smart.txt") {  &exe("rm /tmp/nappit/napp-it_smart.txt"); }
  } else {
          &read_ahfile("/tmp/nappit/napp-it_smart.txt","disk","h+");
          return;
  }


  # show smartvalues from list only for a special disk, do not load all values, use cache
  if (($in{'disk'} ne "") && (-f "/tmp/nappit/napp-it_smart.txt")) {
          &read_ahfile("/tmp/nappit/napp-it_smart.txt","disk","h+");
          return;
  }

  print "initiate background task, please wait..!<br>";
  $p="perl /var/web-gui/data/napp-it/zfsos/_lib/get-disk-smart-bg.pl";
  $r=`echo \'$p\' | sudo at -s now`;
  print "$r\n";
  &log_end;
  sleep(3);
  &reload();
}

# eof
1;