# get-disk.pl (Linux)
# edited 24.1.2014
#
# (c) napp-it 2010-2014
# fill %disk with disk infos ls -l /dev/disk/by-id/
# called on Linux by get-disk.pl

 use strict;

 &get_mydisk_by_id;
 &get_mydisk_member;               # update unused and replaceable  aus disklib.pl, ger_mydisk on Solaris

 #&print_hash(%disk);
return(1);


 ###################### available disks, member of pool etc
 sub get_mydisk_member {
 ########################
     my $k;
     &log_add("exe(get-disk.pl 20): check!\n");


 }


 ################## par like KNAME,LABEL,SIZE,FSTYPE,UUID,MODEL,STATE,TYPE
 sub get_disk_lsblk {
 ##################
   my ($k,$p,$w,@w,@l,$l,$r,$t);
   $p=$_[0];
   $r=&exe("lsblk -o KNAME,$p");
   @l=split(/\n/,$r);
   foreach $l (@l) {
            if (!($l=~/^[a-z]/)) { next; }    # ex sda
            $l=~s/ /\t/; $l=~s/ +/ /g;        # sda\tvalue
            $l=~s/ $//;
            @w=(); @w=split(/\t/,$l);
            if ($w[1] eq "") { next; }

            $k=$w[0]."_$p";
            $disk{$k}=$w[1];

   }





 }

 #######################  use parted to read partitions
 sub get_mydisk_by_id {
 #######################
       my ($r,$v,$k,@w,$w,$id,$p,$d,@d,$t,$id,@l,$l);

       $disk{'all_dsk'}="";
       $disk{'all_dsk_count'}="0";

       $disk{'all_dvd'}="";

       $disk{'all_part'}="";
       $disk{'all_part_count'}="0";
       $disk{'all_dsk_nopart'}="";

       $disk{'all_zfs_usable'}="";       # disks for ZFS: not with K or M in size and part 1..4,

       $r=&exe('ls -l /dev/disk/by-id/');

       # lrwxrwxrwx 1 root root  9 Jan 24 17:55 ata-VMware_Virtual_IDE_CDROM_Drive_10000000000000000001 -> ../../sr0

       # lrwxrwxrwx 1 root root  9 Jan 24 17:55 scsi-36000c29091d042c83d5a715aefa0fedb -> ../../sda
       # lrwxrwxrwx 1 root root 10 Jan 24 17:55 scsi-36000c29091d042c83d5a715aefa0fedb-part1 -> ../../sda1
       # ..
       # lrwxrwxrwx 1 root root  9 Jan 24 17:55 wwn-0x6000c29091d042c83d5a715aefa0fedb -> ../../sda
       # lrwxrwxrwx 1 root root 10 Jan 24 17:55 wwn-0x6000c29091d042c83d5a715aefa0fedb-part1 -> ../../sda1

       @l=split(/\n/,$r);
       foreach $l (@l) {
                if (!($l=~/\->/))   {  next; }

                $l=~s/.*ata\-/ata-/;
                $l=~s/.*scsi\-/scsi-/;
                $l=~s/.*wwn\-/wwn-/;

                $l=~s/ .*\// /;        # wwn-0x6000c29091d042c83d5a715aefa0fedb sda
                push(@w,$l);
       }

       @w=sort(@w);         # sorted list ata -> scsi -> wwn

       # get
       # sd  <-> sd_ata, sd_scsi, sd_wwn

       @l=();
       @l=@w;
       foreach $l (@l) {
                @w=();
                @w=split(/ /,$l);

                # default id
                $k=$w[1]."_id";
                $disk{$k}=$w[0];             #use any ata, scsi, wwn (last and default)

                if ($w[0]=~/^ata/) {
                  $k=$w[1]."_ata";
                  $disk{$k}=$w[0];

                  #reverse ata, scsi, wwn -> disk
                  $k=$w[0]."_sd";
                  $disk{$k}=$w[1];

                  $k=$w[1]."_id_ata";
                  $disk{$k}=$w[0];             #use any ata, scsi, wwn

                }
                if ($w[0]=~/^scsi/) {
                  $k=$w[1]."_scsi";
                  $disk{$k}=$w[0];

                  #reverse ata, scsi, wwn -> disk
                  $k=$w[0]."_sd";
                  $disk{$k}=$w[1];

                  $k=$w[1]."_id_scsi";
                  $disk{$k}=$w[0];             #use any ata, scsi, wwn

                }
                if ($w[0]=~/^wwn/) {
                  $k=$w[1]."_wwn";
                  $disk{$k}=$w[0];

                  #reverse ata, scsi, wwn -> disk
                  $k=$w[0]."_sd";
                  $disk{$k}=$w[1];

                  $k=$w[1]."_id_wwn";
                  $disk{$k}=$w[0];             #use any ata, scsi, wwn
                }

                # skip cd
                if ($w[1]=~/sr|sc/) {
                    $disk{'all_dvd'}.="$w[1]\t";
                     next;
                }

                #part or disk
                if ($w[1]=~/\d/) {
                     if ($disk{'all_part'}=~/$w[1]/) { next; }

                     # only part 1..4
                     $t=$w[1];
                     $t=~s/\D//g;
                     if ($t>4) { next; }

                     $disk{'all_part'}.="$w[1]\t";
                     $disk{'all_part_count'}++;
                } else {
                     if ($disk{'all_dsk'}=~/$w[1]/) { next; }
                     $disk{'all_dsk'}.="$w[1]\t";
                     $disk{'all_dsk_count'}++;
                }
       }
       $disk{'all_part'}=~s/\t+$//;
       $disk{'all_dsk'}=~s/\t+$//;
       $disk{'all_dvd'}=~s/\t+$//;

#&print_hash(%disk);

       # sd -> NAME,MODEL,SIZE

       # lsblk -o KNAME,LABEL,UUID,MODEL,SIZE,FSTYPE,STATE,TYPE
       # KNAME LABEL                         UUID                                 MODEL         SIZE FSTYPE     STATE  TYPE
       # sda                                                                      Virtual dis    16G            runnin disk
       # sda1                                96e66eb9-acc1-49c9-9ee1-6320d58543f8                14G ext4              part


       #LABEL
       &get_disk_lsblk('LABEL');

       #SIZE
       &get_disk_lsblk('SIZE');

       #FSTYPE
       &get_disk_lsblk('FSTYPE');

       #MODEL
       &get_disk_lsblk('MODEL');

       #TYPE
       &get_disk_lsblk('TYPE');

       #UUID
       &get_disk_lsblk('UUID');

       #STATE
       &get_disk_lsblk('STATE');

       #MOUNTPOINT
       &get_disk_lsblk('MOUNTPOINT');


       # get list of disks or partitions usable for zfs
       &get_mydisk_zfs;


       #&print_array(@l);
       #&print_hash(%disk);

 }

#####
sub get_mydisk_ksize {
#####
     my $s=$_[0];
     if ($s=~/M/) { $s=$s*1000; }
     if ($s=~/G/) { $s=$s*1000000; }
     if ($s=~/T/) { $s=$s*1000000000; }
     if ($s=~/P/) { $s=$s*1000000000000; }
     $s=~s/\D//g;
     return($s);
}

######## get list of all disks or partitions for ZFS
sub get_mydisk_zfs {
########
my @d=split(/\t/,$disk{'all_dsk'});
my @p=split(/\t/,$disk{'all_part'});
my ($s1,$s2,$t,$k,$mp);
     foreach my $d (@d) {

             # sum of partitions, if eqal to disk, use disk
             $k=$d."_SIZE";
             $s1=&get_mydisk_ksize($disk{$k});     # size of disk in KB
             $s2="0";
             $mp="";
             foreach my $p (@p) {
                   if (!($p=~/$d/)) { next; }      # not this disk

                   #p1
                   $k=$p."_SIZE";
                   $s2=&get_mydisk_ksize($disk{$k});

             }


             # s2=0 (no part) or s2=s1: use disk
             if ( ($s2 eq "0") || ($s1 eq $s2) ) {
                   $disk{'all_zfs_usable'}.="$d\t";       # this disk
             } else {  # use part
                   foreach my $p (@p) {
                       if (!($p=~/$d/)) { next; }         # not this disk

                       #has mountpoint=skip
                       $k=$p."_MOUNTPOINT";
                       if ($disk{$k} ne "") { next; }

                       #is size < 900KB , skip
                       $k=$p."_SIZE";
                       $t=&get_mydisk_ksize($disk{$k});
                       if (!($t>900)) { next; }

                       #add part
                       $disk{'all_zfs_usable'}.="$p\t";    # this part
                   }
             }

     }
     $disk{'all_zfs_usable'}=~s/\t+$//;
}



##############
sub get_mydisk  {
##############
  &error('get_mydisk - ill only');
}

# eof
1;