# get zpool status   (Linux)

# edited 26.1.2014
#
# (c) napp-it 2010-2014
# fill %sys with basic infos

use strict;


# 1. zpool hash (info)
#######################
#    disk hash  (poolmember) with sd value as key

     #name of syspool (syspool or rpool)                                   # names of syspool in nexenta/osol
     if ($sys{'auto_os'} eq "Linux") {   $zfs{'syspool'}=""; }

# zpool status
  &gethash_sys_myzpool;


##############
sub gethash_sys_myzpool  {                                        #hide:    get basic disk and pool infos
##############
  my (@w,$w,$key,$k,$n,@l,$l,$t,@d,$d,$m,@pools,$pool,$config,$errors,$v,$c,$i,$ant,$pn,$pv,$pd,$vdev,$cs,$conf);

  &load_lib('get-disk.pl');   # basic infos

  #debug
  # print "Content-type: text/html\n\n";   &print_array(@pools);


  #[0] -> 'pool: tank'
  #[1] -> 'state: UNAVAIL'
  #[2] -> 'status: One or more devices are faulted in response to IO failures.'
  #[3] -> 'action: Make sure the affected devices are connected, then run 'zpool clear'.'
  #[4] -> 'see: http://www.sun.com/msg/ZFS-8000-HC'
  #[5] -> 'scan: scrub repaired 0 in 307445734561471011h20m with 0 errors on Thu Jan  1 01:00:00 1970'
  #[6] -> 'config:'
  #[7] -> ''
  #
  #      NAME                                        STATE     READ WRITE CKSUM
  #      xx                                          ONLINE       0     0     0
  #        wwn-0x6000c29a6af0d593d7de74c926c9be8d    ONLINE       0     0     0
  #        mirror-1                                  ONLINE       0     0     0
  #          wwn-0x6000c295f6b94f766b4524ea6e8d2e7e  ONLINE       0     0     0
  #          wwn-0x6000c293ced432fed30c92d3e790dd14  ONLINE       0     0     0
  #        wwn-0x6000c299ee811176cc2d44dd9a324f40    ONLINE       0     0     0
  #        mirror-3                                  ONLINE       0     0     0
  #          wwn-0x6000c296c05729230a99d11086822acc  FAULTED      0     0     0  too many errors
  #          wwn-0x6000c2984162f65b9d622a390a7f4b7b  ONLINE       0     0     0
  #      logs
  #        mirror-1
  #          wwn-..
  #          wwn-..
  #      cache
  #        wwn-..
  #        wwn-..
  #      spares
  #        wwn-..    AVAIL

  # &mess("p=$zfs{'datapools'}");

  $disk{'all_unused'}=$disk{'all_zfs_usable'};               # remove poolmembers now (use sd..)

  @pools=split(/\t/,$zfs{'datapools'});
  foreach $p (@pools) {

           $ant=&exe("zpool status $p");                     # get status info

           $errors=$ant; $errors=~s/.*errors:\s+//s;         # get/ remove errors:
           $key=$p."_errors";
           $zfs{$key}=$errors;

           $ant=~s/errors: .*//s;
           @l=();
           @l=split(/\n/,$ant);

           $cs="";                                           # cache, log or spare switch
           $conf="";

           # get pn,pv,pd and general poolinfos
           $pn="0"; # pos NAME
           $pv="0"; # pos vdev
           $pd="0"; # pos disks in vdevs

           foreach $l (@l) {
              $l=~s/\t/ /g;
              if (!($l=~/\w/)) { next; }     # empty line

              # id
              if ($l=~/id:/) {
                 $l=~s/^ *id: //;
                 $key=$p."_id";
                 $zfs{$key}=$l;
                 next;
              }

              # state:  UNAVAIL
              if ($l=~/state:/) {
                 $l=~s/^ *state: //;
                 $key=$p."_state";
                 $zfs{$key}=$l;
                 next;
              }

              # status: One or more disks contains corrupted data
              if ($l=~/status:/) {
                 $l=~s/^ *status: //;
                 $key=$p."_status";
                 $zfs{$key}=$l;
                 next;
              }

              # action: The pool cannot be imported ..
              if ($l=~/action:/) {
                 $l=~s/^ *action: //;
                 $key=$p."_action";
                 $zfs{$key}=$l;
                 next;
              }

              # pos of NAME and "pool"
              if ($l=~/NAME /) {
                 $t=$l;
                 $t=~s/N.*//;
                 $pn=length($t);             # number of spaces for NAME, "pool", cache and logs
                 next;
              }

              if ($pn eq "0")   { next; }    # skip to NAME
              if ($l =~/ +$p /) { next; }    # skip poolname with errors

              # next is disk config:
              if ($l =~/config: /) { $conf="1";  next; }  # config
              if ($conf ne "") { next; }


              # next entry is a first basic disk or first vdev name
              $t=$l; $t=~s/\w.*//; $t=length($t); # number of spaces
              if ($pv eq "0") {                   # first vdev is a basic disk or mirror, raidz, logs or cache
                  $pv=$t;
                  if ($l=~/mirror|raidz|logs|cache|spares/) {   # vdev
                     $v=$l; $v=~s/^ +//; $v=~s/ .*//;
                  } else {                        # is disk
                     $v="basic";
                  }
                  &get_my_disk_pool_state($p,$v,$l);
                  next;
              }

              # next line is cache, log or spare switch
              if ($l=~/logs|cache|spare/) {
                   $cs="$l"; $cs=~s/^ +//; $cs=$cs."_";
                   next;
              }

              # next line is vdev
              if ($l=~/mirror|raidz/) {
                   $v=$l; $v=~s/^ +//; $v=~s/ .*//;
                   next;
              }

              #next line is basic disk
              $t=$l; $t=~s/\w.*//; $t=length($t);
              if ( ($t eq $pv) && ($l=~/sd|ata\-|scsi\-|wwn\-|\d\d\d+/) ) {
                   $v=$cs."basic";
                   &get_my_disk_pool_state($p,$v,$l);
                   next;
              }

              # next line is a vdev disk
              if ($l=~/sd|ata\-|scsi\-|wwn\-|^ +\d+/) {
                   &get_my_disk_pool_state($p,"$cs$v",$l);
                   next;
              }

           }
           $t=$p."_members";                  # pool member disks
           $disk{$t}=~s/\t+$//;

  } # end foreach pool


           $zfs{'allpools'}=~s/\t+$//;
           $zfs{'datapools'}=~s/\t+$//;

           $disk{'all_inuse'}=~s/\t+$//;
           $disk{'all_unused'}=~s/\t+$//;

           $disk{'all_basic'}=~s/\t$//;
           $disk{'all_mirror'}=~s/\t$//;
           $disk{'all_raidz'}=~s/\t$//;
           $disk{'all_logs'}=~s/\t$//;
           $disk{'all_cache'}=~s/\t$//;
           $disk{'all_spares'}=~s/\t$//;

           $disk{'all_online'}=~s/\t$//;
           $disk{'all_faulted'}=~s/\t$//;
           $disk{'all_unavail'}=~s/\t$//;

           $disk{'all_spare_avail'}=~s/\t$//;
           $disk{'all_spare_inuse'}=~s/\t$//;

           $disk{'all_offline'}=~s/\t$//;
           $disk{'all_degraded'}=~s/\t$//;





  #
  # print "Content-type: text/html\n\n";
  # &print_hash(%disk);

}


############ par pool,vdev,discline of zpool status, all references against id from zpool status
sub  get_my_disk_pool_state {
############
   my $t;
   my $p=$_[0];                                          # poolname
   my $v=$_[1];                                          # vdev
   my $l=$_[2]; $l=~s/^ +//;  $l=~s/ +/ /g;              # line
   my @w=split(/ /,$l);                                  # disk  state read write cksum
   if (!($w[0]=~/sd|ata\-|scsi\-|wwn\-|\d\d\d+/)) { return; }  # not a disk like a vdev

   my $sd=$w[0]."_sd";                                   # sd of disk ex sdb
   $sd=$disk{$sd};                                       # sd as key??, do not activate, use ids from zpool

   my $d=$w[0];
   my $k=$d."_pool";   $disk{$k}=$p;                     # pool of disk

   $k=$p."_members"; $disk{$k}.="$w[0]\t";               # pool members

   $k=$d."_state";     $disk{$k}=$w[1];                  # state of disk
   if ($w[2]=~/\d+/) {
     $k=$d."_rwc";       $disk{$k}="$w[2],$w[3],$w[4]";  # r w cksum
     $k=$d."_info";      $disk{$k}=$w[5];                # info
   } else {
     $k=$d."_info";      $disk{$k}=$w[2];                # info ex spare
   }
   $k=$d."_vdev";      $disk{$k}=$v;                     # vdev

   $disk{'all_inuse'}.="$d\t";
   $disk{'all_unused'}=~s/$sd\t*//;                       # remove  sd

   # online
   if ($w[1] eq "ONLINE") {
       $disk{'all_online'}.="$d\t";
   }

   # faulted
   if ($w[1] eq "FAULTED") {
       $disk{'all_faulted'}.="$d\t";
   }

   # unavail
   if ($w[1] eq "UNAVAIL") {
       $disk{'all_unavail'}.="$d\t";
   }

   # avail spare
   if ($w[1] eq "AVAIL") {
       $disk{'all_spare_avail'}.="$d\t";
   }

   # inuse spare
   if ($w[1] eq "INUSE") {
       $disk{'all_spare_inuse'}.="$d\t";
   }

   # offline
   if ($w[1] eq "OFFLINE") {
       $disk{'all_offline'}.="$d\t";
   }

   # degraded
   if ($w[1] eq "DEGRADED") {
       $disk{'all_degraded'}.="$d\t";
   }

   if (!($v=~/\_/)) {  # log, cache or spare
     if ($v =~/basic/)   { $disk{'all_basic'}.="$d\t";  }
     if ($v =~/mirror/)  { $disk{'all_mirror'}.="$d\t";  }
     if ($v =~/raidz/)   { $disk{'all_raidz'}.="$d\t";  }
   }


   if ($v =~/logs/)     { $disk{'all_logs'}.="$d\t";  }
   if ($v =~/cache/)    { $disk{'all_cache'}.="$d\t";  }
   if ($v =~/spares/)   { $disk{'all_spares'}.="$d\t";  }


   # add MODEL and SIZE from sd to product and partcap (Solaris compatible)
   $k=$sd."_MODEL";
   $t=$d."_product"; $disk{$t}="$sd $disk{$k}";

   $k=$sd."_SIZE";
   $t=$d."_partcap"; $disk{$t}="$disk{$k}";

 #&print_hash(%disk);
}

# eof
1;