# get_zfs-lib.pl
# edited 19.10.2012
#
# (c) napp-it 2010 2011 2012
# fill %zfs with 'zfs get all' and editable parameter with 'zfs set'
# basics from zfs list in %zpool, already set in getbasics-lib.pl (allpools, syspool, datapools)

#

use strict;
&get_myzfs;                # add infos

##############
sub get_myzfs  {                #basic info all zfs
##############
  my (@w,$w,$w,@l,$l,$zfs,$option,$ant,$p,$name,$prot,$path, $iro, $irw, $inone, $f,$r);

  # zfsinfos are reloaded on demand or via agent-monitor
  # zfs.conf must be deleted on modify actions

  $p="/tmp/nappit/zfs.cfg";
  $t=time();
  if (-f $p) {
         &read_ahfile($p,'zfs','h+');                           # add to base info from  get-sys.pl

         # &print_hash(%zfs);

         @t=(); @t=split(/\t/,$zfs{'allfs'});
         $t=@t;

         #&mess($t);
         if ($t > 99) {                                         # no zfs buffering with less than 100 filesystems
              # too old?
              if ($t-$zfs{'buffertime'} < 45)  {                # maxage 45s
                   return;
              }
         }


        $t=$zfs{'allpools'};                                   # keep these settings from get-sys
        $w=$zfs{'datapools'};

        %zfs=();                                               # delete buffered infos
        $zfs{'allpools'}=$t;                                   # restore
        $zfs{'datapools'}=$w;
  }
  $zfs{'syspool'}="rpool";
   if ($sys{'auto_os'} eq "Linux") {   $zfs{'syspool'}=""; }

  #&print_hash(%zfs);

  # get all supported properties -> zfs{'properties'} from first datapool or syspool
  $t=$zfs{'datapools'};
  $t=~s/\t.*//;
  if ($t eq "") { $t=$zfs{'syspool'}; }

  $ant=&exe("$sys{'sbinpath'}zfs get -H -o property all $t",'','get zfs 45');      # all prperties

 #  print "Content-type: text/plain\n\n";
 # &print_var("$t<hr>$ant");

  @w=();
  @w=split(/\n/,$ant);
  foreach $t (@w) {
        chomp($t);
        if (!($zfs{'properties'}=~/\b$t\b/)) {
          $zfs{'properties'}.="$t\t"
        }
  }
  $zfs{'properties'}=~s/\t$//;


  #add most used prop for all zfs
  # 1.  get all fs
    $ant=&exe("$sys{'sbinpath'}zfs list -H -o name,avail,used,readonly,reservation,refreservation,refquota,quota,mountpoint,compression,nbmand,sharesmb,sharenfs -t filesystem",'','get zfs 61');

    # on S11: sharenfs and sharesmb gives "- off" wheras OI gives "off"

# &mess($ant);

    @l=();
    @l=split(/\n/,$ant);
    @l=sort(@l);

    $zfs{'allfs'}="\t";                            # to have delimiter \t for all fs
    foreach my $l (@l) {
        if ($l=~/^rpool\b/) { next; }

        $l=~s/  +/\t/g;
        @w=();
        @w=split(/\t/,$l);
 #&print_array(@w);
        if (!($zfs{'allfs'}=~/\t$w[0]\t/)) {
           $zfs{'allfs'}.="$w[0]\t";  #name des fs
        }

        #datapools
        $p=$w[0];
        $p=~s/\/.*//;
        if (!($zfs{'datapools'} =~/\b$p\b/)) {                     #
           $zfs{'datapools'}.="\t$p";
        }

        if ($sys{'auto_os'} eq "Solaris 11")  {
                $w="$w[0]_sharesmb";
                $zfs{$w}=$w[12];
                $w="$w[0]_sharenfs";
                $zfs{$w}=$w[14];
        } else {
                $w="$w[0]_sharesmb";
                $zfs{$w}=$w[11];
                $w="$w[0]_sharenfs";
                $zfs{$w}=$w[12];
        }

        $w="$w[0]_avail";
        $zfs{$w}=$w[1];
        $w="$w[0]_used";
        $zfs{$w}=$w[2];
        $w="$w[0]_readonly";
        $zfs{$w}=$w[3];

        $w="$w[0]_reservation";
        $zfs{$w}=$w[4];

        $w="$w[0]_refreservation";
        $zfs{$w}=$w[5];

        $w="$w[0]_refquota";
        $zfs{$w}=$w[6];


        $w="$w[0]_quota";
        $zfs{$w}=$w[7];
        $w="$w[0]_mountpoint";
        $zfs{$w}=$w[8];
        $w="$w[0]_compression";
        $zfs{$w}=$w[9];
        $w="$w[0]_nbmand";
        $zfs{$w}=$w[10];

        if ($zfs{'properties'}=~/dedup/) {
           $t=&exe("$sys{'sbinpath'}zfs get -H dedup $w[0]",'','get zfs 114');

           if (!($t=~/bad |invalid /s)) {
               $t=~s/\s+/\t/g;
               @t=();
               @t=split(/\t/,$t);       # zfs  prop  value  source
               $w="$w[0]_dedup";
               $zfs{$w}=$t[2];
#&print_array(@t);
           }
        }
        if ($zfs{'properties'}=~/encryption/) {
           $t=&exe("$sys{'sbinpath'}zfs get -H encryption $w[0]",'','get zfs 126');
           if (!($t=~/bad |invalid /s)) {
               $t=~s/\s+/\t/g; ;
               @t=();
               @t=split(/\t/,$t);       # zfs  prop  value  source
               $w="$w[0]_encryption";
               $zfs{$w}=$t[2];
               if ($zfs{$w}=~/\d+/) {        #aes-256
                 $zfs{$w}="on";
               }
           }
           $t=&exe("$sys{'sbinpath'}zfs get -H keystatus $w[0]",'','get zfs 137');
           if (!($t=~/bad |invalid /s)) {
               $t=~s/\s+/\t/g;
               @t=();
               @t=split(/\t/,$t);       # zfs  prop  value  source
               $w="$w[0]_keystatus";
               $zfs{$w}=$t[2];
           }
        }
        if ($zfs{'properties'}=~/sync/) {
           $t=&exe("$sys{'sbinpath'}zfs get -H sync $w[0]",'','get zfs 147');
           if (!($t=~/bad |invalid /s)) {
# &print_var($t);
               $t=~s/\s+/\t/g;
               @t=();
               @t=split(/\t/,$t);       # zfs  prop  value  source
               $w="$w[0]_sync";
               $zfs{$w}=$t[2];
           }
        }
    }
#&print_hash(%zfs);
  $zfs{'allfs'}=~s/^\t//;
  $zfs{'allfs'}=~s/\t$//;

  $zfs{'datapools'}=~s/^\t|//;

  #add all properties for preselected zfs
  $zfs=$zfs{'add_details'};
  if ($zfs=~/ /) { $zfs=""; }
  if ($zfs ne "") {
        $ant=&exe("$sys{'sbinpath'}zfs get -H all $zfs",'','get zfs 166');
        if ($ant=~/not exist/s) { $ant=""; }
  }



## stage 1b Solaris 11
######################
# set sharesmb and sharenfs are obsolet, use new zfs set share=name=xx,path=xx,prot=nfs/smb zfs
# get shareinfo smb+nfs: zfs get -H -o name,value share
# ex
# tank/data     name=zyz,path=/tank/data,prot=smb        rw=, ro=, none=, guestok=true
# tank/data     name=zyy,path=/tank/data,prot=nfs        rw=, ro=, none=

if ($sys{'auto_os'} eq "Solaris 11") {
     $ant=&exe("zfs get -H -o name,value share",'','get zfs 181');
     @l=();
     @l=split(/\n/,$ant);
     foreach $l (@l) {

              $prot="smb";
              if ($l=~/prot=nfs/) { $prot="nfs"; }

              $zfs=$l; $zfs=~s/\s+name=.*//;
              $l=~s/^.*name=/name=/;
              @w=();
              @w=split(/,/,$l);
              $iro="1";
              $irw="1";
              $inone="1";
              foreach $w (@w) {                   # commavalues
                       if ($w=~/name=/) {          # name=abc
                            $w=~s/name=//;
                            $t="$zfs\_$prot"."name";
                            $zfs{$t}.="$w\t";          #tank/data_smbname -> abc , multiple namse possible
                       }
                       if ($w=~/path=/) {          # name=abc
                            $w=~s/path=//;
                            $t="$zfs\_$prot"."path";
                            $zfs{$t}=$w;          #
                       }
                       if ($w=~/ro=/) {            # ro=..
                            $w=~s/ro=//;
                            $t="$zfs\_$prot"."ro$iro";
                            $zfs{$t}=$w;          #
                            $iro++;
                       }
                       if ($w=~/rw=/) {            # rw=..
                            $w=~s/rw=//;
                            $t="$zfs\_$prot"."rw$irw";
                            $zfs{$t}=$w;          #
                            $irw++;
                       }
                       if ($w=~/none=/) {            # none=..
                            $w=~s/none=//;
                            $t="$zfs\_$prot"."none$inone";
                            $zfs{$t}=$w;          #
                            $inone++;
                       }
                       if ($w=~/guestok=/) {         # guestok=..
                            $w=~s/guestok=//;
                            $t="$zfs\_$prot"."guestok";
                            $zfs{$t}=$w;          #
                       }
              }
     }
}

# opt needed
        my @prop;
        my @edit;
        my @inherit;
        my @values;

####################################################
#stage2 get editable properties if details are asked
####################################################

#test
#$zfs{'add_details'}="1";

  if ($zfs{'add_details'} eq "1") {

          @w=split(/\t/,$zfs{'properties'});
          @l=();


          foreach $w (@w)  {
                $w=~s/^\s+//;                                #empty line
                if ($w eq "") { next; }
                if ($w =~/^PROPERTY/) { next; }        #PROPERTY  EDIT  INHERIT  VALUES

                $w=~s/  +/\t/;                        #property \t edit
                $w=~s/  +/\t/;                        #property \t edit  \t inherit
                $w=~s/  +/\t/;                        #property \t edit  \t inherit  \t values

                @l=();
                @l=split(/\t/,$w);

                if (!($zfs{'properties'}=~/\b$l[0]\b/)) {
                   $zfs{'properies'}.="$l[0]\t";        #list of properties
                }

                $t="editable_$l[0]";
                $zfs{$t}=$l[1];

                $t="inherit_$l[0]";
                $zfs{$t}=$l[2];

                $t="values_$l[0]";
                $zfs{$t}=$l[3];

                #push (@l,$w);
        }
        $zfs{'properies'}=~s/\t$//;
  }


##################################
#stage3 get volumes and info about volumes (iscsi as a zfs property)
##################################



                  $ant=&exe("zfs list -H -t volume",'','get zfs 291');                #list of all volumes
                                # NAME              USED  AVAIL  REFER  MOUNTPOINT                # -H
                                # data/comstar/xx  1.50G   731G    16K  -
                                # syspool/swap     1.03G  2.23G    16K  -

#&mess($ant);
                  @w=(); @w=split(/\n/,$ant);
                  foreach $w (@w)  {
                        $w=~s/ +/\t/g;
                        @l=();
                        @l=split(/\t/,$w);

                        $zfs{'volumes'}.="$l[0]\t";        #list of volumes

                        $t="$l[0]\_used";
                        $zfs{$t}=$l[1];

                        $t="$l[0]\_avail";
                        $zfs{$t}=$l[2];

                        $t="$l[0]\_refer";
                        $zfs{$t}=$l[3];

                        $t="$l[0]\_mountpoint";
                        $zfs{$t}=$l[4];

                        $t="$l[0]\_type";
                        $zfs{$t}='volume';

                        #iscsi_vol
                        if (!($w=~/\/iscsi_/)) { next; }

                        $t=$w; $t=~s/\/iscsi_.*//;              # zfs ex tank/data
                        $r=$w; $r=~s/.*iscsi_//;  $r=~s/\s.*//;  # id ex 1386116366
                        $t=$t."_iscsi_vol";
                        $zfs{$t}=$r;

                        # add size (avail+used)                         $current{'iscsi_my_size'}   =&zfslib_val2xb($v[1]/1000);            # in Bytes not KB
                        $p= &zfslib_val2kb($l[1]) + &zfslib_val2kb($l[2]);  # used + avail in KB

                        $t=$t."_size";
                        $zfs{$t}=$p;

                        $t.="2";                     # value in GB
                        $p=&zfslib_val2xb($p);
                        $zfs{$t}=$p;
                }
                $zfs{'volumes'}=~s/\t$//;


 # get default LU of a fs
 # ill only
 #               $ant=&exe("$sys{'sbinpath'}sbdadm list-lu | grep iscsi_",'','get lu 352');            # list of iscsi LU
 #               @w=(); @w=split(/\n/,$ant);
 #
 #               foreach $w (@w)  {
 #                   chomp($w);
 #                   $t=$w;
 #                   $t=~s/.*\/rdsk\///;
 #                   $t=~s/\/iscsi_.*//;      # keep zfs
 #                   $w=~s/\s.*//;            # LU
 #&mess($w);
 #                   if ($w=~/^\d+/) {
 #                      $t=$t.="_iscsi_LU";
 #                      $w=~tr/a-z/A-Z/;                                            # always uppercase
 #                      $zfs{$t}=$w;
 #
 #                      # view?
 #                      $r=&exe("$sys{'sbinpath'}stmfadm list-view -l $w"); chomp($r);      # View Entry or no views
 #                      if ($r=~/View/s) {
 #                          $t.="_view";
 #                          $zfs{$t}=$r;
 #                         # &mess($r);
 #                      }
 #
 #                   }
 #               }


#&print_hash(%zfs);





#stage4 get snaps and info about

#test
#$zfs{'add_snaps'}="1";

        if ($zfs{'add_snaps'} eq "1") {
                $ant=&exe("zfs list -H -t snapshot",'','get zfs 330');                #list of all snapshots
                                # NAME                                      USED    AVAIL  REFER  MOUNTPOINT                # -H
                                # data@hourly_1273532400               202M      -   202M    -
                                # data@hourly_1273539601                21K      -    27K    -


                  @w=split(/\n/,$ant);
                  foreach $w (@w)  {
                        $w=~s/ +/\t/g;
                        @l=();
                        @l=split(/\t/,$w);

                        if (!($l[0]=~/^$zfs{'syspool'}/)) {        #sys_snap
                                $zfs{'snaps_data'}.="$l[0]\t";        #list of data snaps
                        } else {
                                $zfs{'snaps_sys'}.="$l[0]\t";        #list of sys snaps
                        }

                        $t="$l[0]\_used";
                        $zfs{$t}=$l[1];

                        $t="$l[0]\_avail";
                        $zfs{$t}=$l[2];

                        $t="$l[0]\_refer";
                        $zfs{$t}=$l[3];

                        $t="$l[0]\_mountpoint";
                        $zfs{$t}=$l[4];

                        $t="$l[0]\_type";
                        $zfs{$t}='snapshot';

                }
                $zfs{'snaps_data'}=~s/\t$//;                       #data snaps
                $zfs{'snaps_sys'}=~s/\t$//;                        #sys snaps
        }



#stage 6
#get afp shares
###############
        # netatalk 3 detection admin.pl 904
        if ($sys{'netatalk3'} ne "") {

                $ant=&exe("cat $sys{'netatalk3'}",'','get zfs 376');

                #get shares
                # [share]
                # path= /a/b

                @l=split(/\[/,$ant);
                foreach $l (@l) {
                                  if (!($l=~/^\w+\]\n/)) { next; }                  # not a header like: [share]
                                  if ($l=~/^Global]\n/)  { next; }                  # Global header [Global]
                                  if ($l=~/^Homes]\n/)   { next; }                  # Home header [Homes]

                                  @w=();
                                  @w=split(/\n/,$l);

                                  $zfs="";
                                  # get zfs (path)
                                  foreach $w (@w) {
                                           #path
                                           if ($w=~/^path *=/) {
                                                $w=~s/^.*= *//;
                                                $w=~s/^\///;                        #ex tank/media_shareafp
                                                $zfs=$w;

                                                $t=$w."_shareafp";
                                                $zfs{$t}="on";
                                                last;
                                           }
                                  }

                                  # get other values
                                  foreach $w (@w) {
                                          # time machine = yes
                                           if ($w=~/^time machine *=/) {
                                                $w=~s/^.*= *//;
                                                $t=$zfs."_afp_time_machine";
                                                $zfs{$t}="$w";
                                           }


                                           # directory perm = 0770
                                           if ($w=~/^directory perm *=/) {
                                                $w=~s/^.*= *//;
                                                $t=$zfs."_afp_directory_perm";
                                                $zfs{$t}="$w";
                                           }

                                           # file perm = 0660
                                           if ($w=~/^file perm *=/) {
                                                $w=~s/^.*= *//;
                                                $t=$zfs."_afp_file_perm";
                                                $zfs{$t}="$w";
                                           }
                                 }


                }

                #debug
          #      &show_hash('zfs');
         #       &print_array(@w);


        } else { # netatalk 2
            if (-f "/etc/netatalk/AppleVolumes.default") {
                $ant=&exe("cat /etc/netatalk/AppleVolumes.default",'','get zfs 441');

                # get shares (lines beginning with /) ex.                               # /tank/timemachine TimeMachine allow:timemach options:tm
                                                                                        # /tank/media media forceuid:media
                                                                                        # /tank/software software forceuid:software
                @l=();
                @l=split(/\n/,$ant);
                foreach $l (@l) {
                        if (!($l=~/^\//)) { next; }
                        @w=();
                        $l=~s/ +/ /g;
                        @w=split(/ /,$l);
                        $t=$w[0]."_shareafp";
                        $t=~s/^\///;                        #ex tank/media_shareafp
                        $zfs{$t}=$w[1];

                        #opt1
                        $t=$w[0]."_shareafp_opt";
                        $t=~s/^\///;                        #ex allow:timemach options:tm

                        $zfs{$t}="$w[2] $w[3] $w[4]";
                        $zfs{$t}=~s/ +$//;
                }
            }
        }


 # write config
  $p="/tmp/nappit/zfs.cfg";
  &exe("chmod 666 $p");

  $zfs{'buffertime'}=time();
  &hash2file('zfs',$p);


#test
#&show_hash('zfs');
#&print_array(@w);


}



# eof
1;