#!
# Menu zfs folder >> iSCSI functions
# (c) Gnther Alka 2013
#
# functions are requested from zfslib.pl


# global settings
# short guid=last 10 from time(), guid= autogenerated from 600144f070cc440000004c + time()
$current{'iscsi-guid1'}="600144f070cc440000004c";

# get target, group settings
&zfslib_get_gt_settings;

# get LU settings
&zfslib_get_vlu_settings;

#debug
#&print_hash(%current);

#####################
sub zfslib_iscsi_modify {
#####################
my ($r,$t,@vol,$d,@v,$name,$id2,$id2,$z,$n,@g,$g);

 #&print_hash(%in);

 ############################ del selected view
 if ($in{'removeview'} ne "") {
 ############################
    # view
    if ($in{'LU'} eq "")              {  &mess('LU is missing');   }
    if (!($in{'views'} =~/View=\d/))  {  &mess('no View selected'); }
    $t=$in{'views'}; $t=~s/View=//; $t=~s/,.*//; $t=~s/\D//g;

    # remove view
    &exe("stmfadm remove-view -l $in{'LU'} $t");
    &reload;                          # back to form
 }


 ############################ add extra view
 if ($in{'addview'} ne "") {
 ############################
    # add view

    if ($in{'tgroups'} eq "-")   {  &mess('select a Target group for this extra view');   }    # unset

    if ($in{'LU'} eq "")         {  &mess('LU is missing');   }
    if ($in{'hgroups'} eq "")    {  &mess('no Host group selected'); }
    if ($in{'tgroups'} eq "")    {  &mess('no Target group selected'); }

    $t=" ";
    if ($in{'hgroups'} ne "All") {
         $t.="-h $in{'hgroups'} ";
    }
    if ($in{'tgroups'} ne "All") {
         $t.="-t $in{'tgroups'} ";
    }
    $t.=$in{'LU'};

    # add view
    print &exe("stmfadm add-view $t"); sleep(1);
    &reload;                          # back to form
 }

 ## nothing
  if ($in{'share_action'} =~/---/) { return; }

#&print_hash(%in);

  ##################################    delete views=hide
 if ($in{'share_action'} =~/hide/) {
 ##################################    del views of $in{'LU'} -> view numbers


      print "stmfadm remove-view -l $in{'LU'} -a <br>";
      $r= &exe("stmfadm remove-view -l $in{'LU'} -a");
      print "$r<br>";

      sleep(2);
      return;
 }

 ##################################    delete LU but keep views
 if ($in{'share_action'} =~/delete/) {
 ##################################    del views of $in{'LU'} -> view numbers


      if ($in{'LU'} eq "") { $in{'LU'}=$in{'prop2'} }    # off -> delete/destroy

      print "stmfadm delete-lu --keep-views $in{'LU'} <br>";
      $r= &exe("stmfadm delete-lu --keep-views $in{'LU'}");
      print "$r<br>";

      sleep(2);
      return;
 }


 ##################################     destroy lu with views
 if ($in{'share_action'} =~/destroy/) {
 ##################################

      if ($in{'LU'} eq "") { $in{'LU'}=$in{'prop2'} }    # off -> delete/destroy

      print "stmfadm delete-lu $in{'LU'} <br>";
      $r= &exe("stmfadm delete-lu $in{'LU'}");
      print "$r<br>";

      sleep(2);
      return;
 }

 #################################
 #########  on or edit ###########
 #################################
  if (($in{'share_action'} =~/on/) || ($in{'share_action'} eq "edit")) {

         $z=$in{'zfs'}; $z=~s/\//:/g;     # zfs with pool:zfs

         # create volume if missing
         ##########################
         @vol=split(/\t/,$current{'iscsi_all_volumes'});
         $d="1";
         foreach $vol (@vol) {
              @v=();
              @v=split(/ /,$vol);
              if ($v[0] =~/^$in{'zfs'}\/iscsi_\d+/) {
                   $d="0";
                   $id2=$v[0];
                   $id2=~s/.*iscsi\_//;                   # = GUID of LU
                   last;                                  # volume=tank/ab/iscsi_volume_GUID
              }                                           # name= iscsi_volume_LU-id generated from time
         }
         if ($id2 eq "") {
             # autogenerate GUID:
             # $id part1 ="600144f070cc440000004c";       # guid1
             $id2=time();                                 # guid2
             $id="$current{'iscsi-guid1'}$id2";
         }

         #GUID
         $id="$current{'iscsi-guid1'}$id2";

         if (!(length($id2)==10))  { &mess("Length of ($id2) must be 10 in $v[0] (zfs/iscsi_(10 digits)");  }

         # missing, create vol
         #####################
         if ($d) {
               $in{'units'}=~s/[^A-Z]//g;
               $in{'blocksize'}=~s/bytes//g;                                         # in case of 512bytes
               if ($in{'units'} eq "")    { &mess("create Volume: Units error"); }
               if (!($in{'volsize'} > 0)) { &mess("create Volume: Size error");  }

               $vol="$in{'zfs'}/iscsi_$id2";

               print "zfs create -s -V $in{'volsize'}$in{'units'} -b $in{'blocksize'} $vol<br>";
               $r=&exe("/usr/sbin/zfs create -s -V $in{'volsize'}$in{'units'} -b $in{'blocksize'} $vol");
               if ($r ne "") { &mess("zfs create -s -V $in{'volsize'}$in{'units'} -b $in{'blocksize'} $vol<hr>$r"); }
         }  else {
            # debug
            #&mess(__LINE__);
         }

    # debug
    # &mess($current{'iscsi_all_volumes'});


    # ## if vol was replicated: volname/id is no longer unique so rename zvol and readonly must be set to off
    if ($in{'share_action'} =~/rename/) {

                    # set vol r/w
                    print "/usr/sbin/zfs set readonly=off $in{'zfs'}\/iscsi_$id2<br>";
                    $r=&exe("/usr/sbin/zfs set readonly=off $in{'zfs'}\/iscsi_$id2");
                    if ($r ne "") { print "$r<br>"; sleep(2); }

                    #rename zvol from current
                    $t=time();

                    print "/zfs rename $in{'zfs'}\/iscsi_$id2 $in{'zfs'}\/iscsi_$t";
                    $r=&exe("/usr/sbin/zfs rename $in{'zfs'}\/iscsi_$id2 $in{'zfs'}\/iscsi_$t");
                    if ($r ne "") { print "$r<br>"; sleep(2); }

                    # new id
                    $id2=$t;                                 # guid2
                    $id="$current{'iscsi-guid1'}$id2";
     }


     # check LU with above GUID
     ##########################


               $r=&exe("/usr/sbin/sbdadm list-lu");  # list of LU
               @v=();
               @v=split(/\n/,$r);
               $d="1";
               foreach my $t (@v) {
                     if ($t=~/^$id/)  {  $d="0"; last; }
               }

               # missing LU, create LU
               ####################

               if ($d) {

                    # create a logical unit sbdadm create-lu
                    $vol="$in{'zfs'}/iscsi_$id2";

                    print "stmfadm create-lu -p guid=$id /dev/zvol/rdsk/$vol<br>";
                    $r=&exe("/usr/sbin/stmfadm create-lu -p guid=$id /dev/zvol/rdsk/$vol");
                    if ($r=~/created/) { $r=""; }
                    if ($r ne "") { &mess("stmfadm create-lu -p guid=$id /dev/zvol/rdsk/$vol<hr>$r"); }

                    # force rw (replicated volumes ar ro)
                    $r=&exe("zfs set readonly=off $vol");

                    # set writeback
                    if ($in{'writeback'} =~/enabled/i) {
                        $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=false $id");
                    }
                    if ($in{'writeback'} =~/disabled/i) {
                        $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=true $id");
                    }
                    #  writeback "Disabled" {  $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=true $in{'zfs'}","","comstarlib 262");  }
                    #  writeback "Enabled"  {  $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=false $in{'zfs'}","","comstarlib 263");  }

                    # set alias = zfs
                    $r=&exe("/usr/sbin/stmfadm modify-lu -p alias=$in{'zfs'} $id");

               } else {
                    # debug
                    #&mess(__LINE__);
               }


    #debug
    #&mess($current{'iscsi_all_vlu'});
   # &print_hash(%in);


        # set writeback cache of LU
        ###########################
        if ($in{'writeback'} =~/disabled/) {
             $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=true $id");   # security
             print "stmfadm modify-lu -p wcd=true $id<br>$r";
        }
        if ($in{'writeback'} =~/enabled/)    {
             $r=&exe("/usr/sbin/stmfadm modify-lu -p wcd=false $id");  # performance
             print "stmfadm modify-lu -p wcd=false $id<br>$r";
        }

        #debug
        #&exe("/usr/sbin/stmfadm modify-lu -p wcd=false $id");
        # $r=&exe("/usr/sbin/stmfadm list-lu -v");
        # &mess("$in{'writeback'}<hr>$r");

    ############################################################
    # (opt) create default target when default target is enabled
    ############################################################

    if ($in{'default_target'} ne "")  {
               $in{'default_target'}=~s/\..*|\s//gs;                     # zfs.+
               $d="1";

               if ($current{'iscsi_all_targets'}=~/napp-it:$z/s) {
                    $d="0";
               }

               # missing, create Target
               if ($d) {
                      $n="iqn.2010-09.org.napp-it:$z"; # node name
                      $r=&exe("/usr/sbin/itadm create-target -n $n -l $in{'zfs'} ");      # alias=zfs
                      if (!($r =~/successfully/)) {  &mess($r);   }
               } else {
                  # debug
                  #&mess(__LINE__);
               }

    } # /default target


    # debug
    #&print_hash(%in);
    # &print_hash(%current);



    ######################
    # default target group
    ######################

    my $dv="0"; # view to default target group -> default target group with default target is needed

    if ($in{'tgroups'} ne "") {                                           # ex 'tank/ab.+tank/data.+'

            @g=();
            $in{'tgroups'}=~s/\.+$|\s//gs;                                # tg1.+tg2.+
            @g=split(/\.\+/,$in{'tgroups'});
            foreach $g (@g) {
                 if ($g eq $in{'zfs'}) { $dv="1"; last; }                # zfs in groups
            }
#&mess($dv);
            ##########################################################
            # create default target group(s) when selected and missing
            ##########################################################
            if ($dv) {
                   $d="1";
                   @v=(); @v=split(/\t/,$current{'iscsi_all_tg'});
                   foreach $t (@v) {
                              if ($t eq $in{'zfs'}) { $d="0"; last; }                 # default available
                   }

                   #missing, create default target group
                   if ($d eq "1") {
                          print "stmfadm create-tg $in{'zfs'}<br>";
                          $r=&exe("/usr/sbin/stmfadm create-tg $in{'zfs'}");
                          if ($r ne "") { &mess("stmfadm create-tg $in{'zfs'}<hr>$r"); }
                   }  else {
                          # debug
                           #&mess(__LINE__);
                   }

                   # &mess($current{'iscsi_all_tg'});

                   ##########################
                   #add default target to to default target group when missing and default targret is enabled
                   ##########################
                   if ($in{'default_target'} ne "") {

                         # Target Group: tank/data
                         # Member: iqn.2010-09.org.napp-it:tank:data

                         # missing, add member in ex: iscsi_tg_member_tank/xy/data
                         $t="iscsi_tg_member_$in{'zfs'}";
                         if (!($current{$t}=~/napp-it:$z/)) {
                                  $n="iqn.2010-09.org.napp-it:$z";
                                  $r=&exe("/usr/sbin/stmfadm offline-target $n")."\n";           # edit member only offline

                                  print "stmfadm add-tg-member -g $in{'zfs'} iqn.2010-09.org.napp-it:$z<br>";
                                  $r=&exe("/usr/sbin/stmfadm add-tg-member -g $in{'zfs'} iqn.2010-09.org.napp-it:$z");
                                  if ($r ne "") { &mess("stmfadm add-tg-member -g $in{'zfs'} iqn.2010-09.org.napp-it:$z<hr>$r"); }
                                  print &exe("stmfadm online-target $n");

                         }  else {
                             # debug
                             # &mess(__LINE__);
                         }

                         #debug
                         $t="iscsi_tg_member_$in{'zfs'}";
                         #&mess($current{$t});
                 }
          }
    } #/ target groups


    #debug
    #&mess($current{'iscsi_all_targets'});
    #&print_hash(%in);


    ####################
    # set views to target groups and host groups
    ####################
    if ($in{'tgroups'} ne "-") {

            $t="";
            if ($in{'hgroups'} ne "All") {
                 $t.="-h $in{'hgroups'} ";
            }
            if ($in{'tgroups'} ne "All") {
                 $t.="-t $in{'tgroups'} ";
            }
            $t.="$id";

            # add view
            print "stmfadm add-view $t<br>";
            print &exe("stmfadm add-view $t");
            sleep(2);
   }
           ######
 }     # /on or edit
}

#####################
sub zfslib_iscsi_ask {
######################
my ($form,$d,$info,$p,$z,$form2,$action);

  # generate form, info for scsi settings in menu zfs filesystems
  ###############################################################

  ## get volumeinfo
  # state:
  # off=no zvol
  # off (z)=zvol, no LU
  # hide = zvol, lu, no views
  # or size


        if ($in{'old'} eq "off") {                             # create or edit?
                  # create
                  ($form2)=&zfslib_get_edit_basic  ;            # get values (to %current), return: form2
                  $d="<option>on</option>";
                  $d.="<option>on-rename</option>";              # replicated
                  if ($cfg{'ver'}=~/m|c/i) {
                    $t="$in{'zfs'}\_iscsi_LU";
                    if ($zfs{$t} ne "") {                       # inly if LU avail
                         $d.="<option>----</option>\n";
                         $d.="<option>delete LU</option>\n";
                         $d.="<option>destroy LU</option>";
                     }
                  }                              # option destroy
                } else {
                 ($form2,$action)=&zfslib_get_edit_basic;       # get values (to %current), return: form2
                 if ($cfg{'ver'}=~/m|c/i) {
                    $d="<option>hide=delete views</option>\n";
                    $d.="<option>update</option>\n";
                    $d.="<option>----</option>\n";
                    $d.="<option>delete LU</option>\n";
                    $d.="<option>destroy LU</option>";
                 } else {
                    $d="<option>hide=delete views</option>";
                 }
        }

        # table1
        $form="";
        $form.="";
        $form.="";
        $form.=<<EoF;
        <table style='padding:0 5px 0 5px; width:500px'>
        <tr><td style='width:120px;padding-right:5px'> iSCSI-share  </td>
        <td nowrap><input type='text' name='text' value=\"$in{'zfs'}\" style='width: 250px' readonly>
        &nbsp; set &nbsp;
        <select name="share_action" class="input">
        $d
        </select>
         <p style='font-size:10px; margin-top:7px'>Base settings rely on a 1:1 relation between ZFS filesystem, <br>
         Volume, Logical Unit (LU), Target Group and Target.<br>If you delete/destroy the LU you can reactivate unless you do not delete the volume.<br>
         Destroy LU deletes all views as well. On-rename is needed to enable replicated/duplicated zvols</p>
        </td>
        </tr></table>
EoF


#### form2
        $form.=<<EoF;
        <br>Base settings (all settings see menu Comstar)
        <hr><br>
        <table style='padding:0 5px 0 5px; width:500px'>
$form2
        </table>

EoF
        $info="<br><br>&nbsp;&nbsp;You can destroy volumes or logical units, modify settings or create advanced configs in menu Comstar";


         return("$form","$info");     # back to zfslib.pl
}


####### sub ###



############################   all target, hg, tg tgp settings
sub zfslib_get_gt_settings {
############################
my ($r,@l,@p,$p,$t,$s,$k,$v,$w,@w,$m);

  # all volumes                                          # name, used, avail, refer, mountpoint
     $r=&exe("/usr/sbin/zfs list -H -t volume");            #tank/ab/iscsi_volume_600144f070cc440000004c1384132220       87.4M  8.65G  87.4M
     chomp($r); @p=();
     $r=~s/ +|\t+/ /gs;
     @p=split(/\n/,$r);
     $current{'iscsi_all_volumes'}="";
      foreach $p (@p) {
          if (!($p=~/\d/)) { next; }
          @v=();
          @v=split(/ /,$p);
          $current{'iscsi_all_volumes'}.="$v[0]\t";

          # my volume?

      }
      $current{'iscsi_all_volumes'}=~s/\t$//;


  # all targets
     $r=&exe("/usr/sbin/stmfadm list-target");           # Target: iqn.2010-09.org.napp-it:tank:ab
     chomp($r); @p=();
     @p=split(/\n/,$r);
     $current{'iscsi_all_targets'}="";
      foreach $p (@p) {
          if (!($p=~/^Target:/)) { next; }
          $p=~s/Target: //;
          $current{'iscsi_all_targets'}.="$p\t";
      }
      $current{'iscsi_all_targets'}=~s/\t$//;

  # all hg
     $r=&exe("/usr/sbin/stmfadm list-hg");              # tank/data or hg1
     chomp($r); @p=();
     @p=split(/\n/,$r);
     $current{'iscsi_all_hg'}="";
      foreach $p (@p) {
          if (!($p=~/^Host Group:/)) { next; }
          $p=~s/Host Group: //;
          $current{'iscsi_all_hg'}.="$p\t";
      }
      $current{'iscsi_all_hg'}=~s/\t$//;

  ####################
  # all tg and members
  #####################
     $r=&exe("/usr/sbin/stmfadm list-tg -v");              # Target Group: tank/data
                                                           #   Member: iqn..
     chomp($r); @p=();
     @p=split(/\n/,$r);
     $current{'iscsi_all_tg'}="";
     $t="";
     foreach $p (@p) {
          if ($p=~/^Target Group:/) {
               $t=$p;
               $t=~s/Target Group: //;
               $current{'iscsi_all_tg'}.="$t\t";
          }
          if ($t eq "") { next; }

          # add members
          $m="iscsi_tg_member_$t";
          if ($p=~/Member:/) {
               $p=~s/\s+Member: //;
               $current{$m}.="\t$p";
               $current{$m}=~s/^\t+//;
          }


     }
     $current{'iscsi_all_tg'}=~s/\t$//;

  # all tpg
     $r=&exe("/usr/sbin/itadm list-tpg");              # tank/data or tpg1
     chomp($r); @p=();
     @p=split(/\n/,$r);
     $current{'iscsi_all_tpg'}="";
      foreach $p (@p) {
          if ($p=~/^TARGET PORTAL GROUP/) { next; }
          $p=~s/ .*//;
          $current{'iscsi_all_tpg'}.="$p\t";
      }
      $current{'iscsi_all_tpg'}=~s/\t$//;


   # all target portal names for target
   @p=();    @p=split(/\t/,$current{'iscsi_all_targets'});
   foreach $p (@p) {
      $r=&exe("/usr/sbin/itadm list-target -v $p");
      if ($r=~/tpg-tags:/s) { $r=~s/.*tpg-tags: *//s;}        # tank/xy/data = 4,xx = 3
      @w=(); @w=split(/,/,$r);

      $t="iscsi_tpg_of_$p";

      #&mess($r);
      #&print_array(@w);

      foreach $w (@w) {
               if (!($w=~/=/)) { next; }
               $w=~s/ *=.*//;
               $current{$t}.="$w\t";                          # current{'iqn.._tpg'}=xx\txy
      }
      $current{$t}=~s/\t+$|^\t+//g;
   }

   # all ip portals for all tpg
   @p=();    @p=split(/\t/,$current{'iscsi_all_tpg'});
   foreach $p (@p) {
              $t="iscsi_portals_$p";                           # xx  2
              $r=&exe("/usr/sbin/itadm list-tpg -v $p");       # portals:    192.168.56.1:3260,172.16.16.25:3260
              #&mess($r);
              if ($r=~/portals:/s) {
                   $r=~s/.*portals:\s*//s; $r=~s/\n.*//s;
                   $current{$t}=$r;
              }
   }
   #&print_hash(%current);
}

############################   all volume based lu settings: guid(short) of WriteBack etc
sub zfslib_get_vlu_settings {
############################
               my ($r,@l,$l,@p,$p,$t,$s,$k,$v,$w,@w);

# part1: lu ids, size and source

#              GUID                              DATA SIZE       SOURCE
#              -------  -------------------      -----------     ------
#              600144f070cc440000004c1384132220  94489280512     /dev/zvol/rdsk/tank/ab/iscsi_600144f070cc440000004c1384132220
#              short guid=last 10 from time(), guid= autogenerated from 600144f070cc440000004c + time()


               $r=&exe("/usr/sbin/sbdadm list-lu");                              # lowercase!, see also get-zfs -> %zfs
               $r=~s/ +|\t+/ /gs;
               @l=split(/\n/,$r);
               $current{'iscsi_all_vlu'}="";                                     # complete guid
               $current{'iscsi_all_vlu2'}="";                                    # short (last10) volume based lu's
#&print_array(@l);
               foreach my $l (@l) {                                              # LUs: GUID SIZE SOURCE
                    if (!($l=~/^600/))  { next; }
                    @v=split(/ /,$l);

                    $v[0]=~tr/a-z/A-Z/;                                            # always uppercase
                    $current{'iscsi_all_vlu'}.="$v[0]\t";

#&print_array(@v);
                    $t=substr($v[0],22);
                    $current{$t}=$v[0];                                            # short -> long

                    $current{'iscsi_all_vlu2'}.=$t."\t";
                    $t="/dev/zvol/rdsk/$in{'zfs'}/iscsi_$t";

# &mess("<br>$t<hr>$v[2]<br>");


                    if (!($v[2] eq $t)) { next; }
#  &print_array(@v);
                    $current{'iscsi_my_guid'}   =$v[0];                                 # same as $v[0]
                    $current{'iscsi_my_guid2'}  =substr($current{'iscsi_my_guid'},22);  # last 10 digits, first 22 are in guid1
                    $current{'iscsi_my_source'} =$v[2];
               }
               $current{'iscsi_all_vlu'}=~s/\t+$//;                                                # always uppercase
               $current{'iscsi_all_vlu2'}=~s/\t+$//;


# debug
#&print_hash(%in);

# part 2: lu details
               # LU Name: 600144F070CC440000004C1384218564
               #    Operational Status: Online
               #    Provider Name     : sbd
               #    Alias             : tank/xy/data
               #    View Entry Count  : 0
               #    Data File         : /dev/zvol/rdsk/tank/xy/data/iscsi_1384218564
               #    Meta File         : not set
               #    Size              : 53687091200
               #    Block Size        : 512
               #    Management URL    : not set
               #    Vendor ID         : SUN
               #    Product ID        : COMSTAR
               #    Serial Num        : not set
               #    Write Protect     : Disabled
               #    Writeback Cache   : Enabled
               #    Access State      : Active


               $r=&exe("/usr/sbin/stmfadm list-lu -v"); chomp($r);      # all LU
               $r=~s/ *: */:/gs;       # ' key text:value'
               @l=split(/LU Name:/,$r);

               foreach my $l (@l) {                                     # GUID Status: .. Writeback Cache: ..
                     if ($l eq "") { next; }                            # first line
                     @p=(); @p=split(/\n/,$l);
                     $p[0]=~tr/a-z/A-Z/;                                # only to be sure, always uppercase guid

                     # debug
                     # &print_var($l);
                     # &print_array(@p);
                     # &print_hash(%in);

                     $s=substr($p[0],22);                               # short guid, p[0]=guid
                     foreach my $p (@p) {
                             if (!($p=~/:/)) { next; }
                             $p=~s/^ +//; $p=~s/ +/_/;                  # ' Vendor ID:..' -> 'Vendor_ID:..'

                             @w=(); @w=split(/:/,$p);

                             $k="iscsi_lu_$s_$w[0]";
                             $current{$k}=$w[1];

                             # my value

                             if ($current{'iscsi_my_guid'} eq $p[0]) {    # guid
                                 $current{'iscsi_my_guid2'}=$s;
                                 $k="iscsi_my_lu_$w[0]";
                                 $current{$k}=$w[1];
                             }
                     }


               }

               # get my views as 1,tg:..,hg:..\t
               ##############
               $r=&exe("/usr/sbin/stmfadm list-view -l $current{'iscsi_my_guid'}"); chomp($r);

               if ($r=~/requires an argument/) { $r=""; }          # not defined

               # View Entry: 0
               # Host group   : All
               # Target group : tank/ab
               # LUN          : 0
               # View Entry: 1
               # Host group   : All
               # Target group : tank/data
               # LUN          : 0


               # create array of values 1,tg:..,hg:..\t
               $r=~s/\n//gs;
               $r=~s/ +Host group +: /, Hg=/gs;
               $r=~s/ +Target group +: /, Tg=/gs;
               $r=~s/ +LUN +: /, LUN=/gs;

               @p=(); @p=split(/View Entry: /,$r);
               $current{'iscsi_my_views'}="";
#debug
#&print_array(@p);
               foreach my $p (@p) {
                       if (!($p=~/,/)) { next; }
                       $current{'iscsi_my_views'}.="View=$p\t";
               }
               $current{'iscsi_my_views'}=~s/\t$//g;


               #&mess("$current{'iscsi_my_guid'}<hr>$r");


               #&print_array(@p);



               # debug
 #debug
 #&print_hash(%current);
}




####################
sub zfslib_edit_advanced {
##################### advanced settings
     my ($t, $r, $v, @v, $s, $p);


     # advanced settings

     ########################
     # Logical Unit writeback
     ########################
     if ($current{'iscsi_my_vol_id'} ne "") {         # new LU name
         $t="600144f070cc440000004".$current{'iscsi_my_vol_id'};
     } else {
         $t="create 600144f070cc440000004c(lu-id2)";
     }

     #&print_hash(%current);
     if ($current{'iscsi_my_lu_Writeback_Cache'} eq "Disabled") {
       $s ="   <option>security=writeback disabled</option>\n";
       $s.="   <option>performance=writeback enabled</option>\n";
     } else {
       $s ="   <option>performance=writeback enabled</option>\n";
       $s.="   <option>security=writeback disabled</option>\n";
     }
    #&mess("-$current{'iscsi_my_lu_Writeback_Cache'}-<br>$s");

     $r=<<EoF;
        <tr>
          <td style='width:120px; padding-bottom:1px'>
              <b>Logical Unit (LU):</b><br>
          </td>
          <td>
              $t <br>
          </td>
        </tr>
        <tr>
          <td style='width:120px; padding-bottom:15px'>
              optimized for:<br>
          </td>
          <td>
           <select name="writeback" class="input" style='width:220px'>
$s
           </select>
          </td>
        </tr>
EoF

     # zfs?
     $p=$in{'zfs'};        # default Target

     if ($p ne "")    {
          $p=~s/\//:/g;     # tank/data -> tank:data
          if (!($p=~/^iqn.2010-09.org.napp-it:/)) {
             $p="iqn.2010-09.org.napp-it:$p";
          }
     }


     ####################
     # show current views
     ####################
     #&print_hash(%current);

     $r.="<tr><td style='width:120px;  padding:15px 0 5px 0'><b>Current Views</b></td>\n";
     $r.="<td style=' padding:15px 0 5px 0'>\n";
     $r.="<select name='views' class='input' style='width:220px'>\n";

     @v=(); @v=split(/\t/,$current{'iscsi_my_views'});
     if (@v==0) { $v[0]="--"; }

     foreach $v (@v) {
              $v=~s/, LUN=.*//;                              # LUN not needed
              #$v=~s/,/,    /g;
              $r.="     <option>$v</option>\n\n";
     }
     $r.="</select>\n";
     $r.="<input type='hidden' name='LU' value=\"$current{'iscsi_my_guid'}\">";

     if ($current{'iscsi_my_vol_id'} ne "") {         # new LU name
       $r.="<input type='submit' name='removeview' value='remove view' style='font-size:9px'>";
     }

     $r.="</td></tr>\n";



     #######################  a target can be member of several groups
     #view to Target Group
     #######################
     $r.="<tr><td style='width:120px;  padding:15px 0 5px 0'><b>Add View to <br>Target Groups</b></td>\n";
     $r.="<td style=' padding:15px 0 5px 0'>\n";

     # default
     #&print_hash(%current);


     $r.="  <input type='radio' name='tgroups' value=\"-\"> unset<br>\n";
     $r.="  <input type='radio' name='tgroups' value=\"All\"> All<br>\n";

     # view tg (zfs) to alreaday set?
     @t=(); @t=split(/\t/,$current{'iscsi_my_tg_views'});

     # new: set default
     $r.="  <input type='radio' checked name='tgroups' value=\"$in{'zfs'}\"> $in{'zfs'} (1:1, create when missing) <br>\n";

     @v=(); @v=split(/\t/,$current{'iscsi_all_tg'});

     foreach $v (@v) {
              if ($v eq $in{'zfs'}) { next; }
              $r.="  <input type='radio' name='tgroups' value=\"$v\"> $v <br>\n";
     }

     $r.="  <p style='font-size:10px; margin-top:7px'>Advanced settings, see  menu Comstar</p>\n";
     $r.="</td></tr>\n";



     #######################  a target can be member of several groups
     #view to Host Group
     #######################
     $r.="<tr><td style='width:120px;  padding:15px 0 5px 0'><b>With View to <br>Host Groups</b></td>\n";
     $r.="<td style=' padding:15px 0 5px 0'>\n";

     # default
     #&print_hash(%current);

     $r.="<select name='hgroups' class='input' style='width:220px'>\n";
     $r.="     <option>All</option>\n\n";

     @v=(); @v=split(/\t/,$current{'iscsi_all_hg'});
     foreach $v (@v) {
              $r.="     <option>$v</option>\n\n";
     }
     $r.="</select>\n";
     if ($current{'iscsi_my_vol_id'} ne "") {         # new LU name
        $r.="<input type='submit' name='addview' value='add extra view' style='font-size:9px'>";
     }

     $r.="  <p style='font-size:10px; margin-top:7px'>Advanced settings, see menu Comstar</p>\n";
     $r.="</td></tr>\n";


     #######################
     #enable default  target
     #######################

     $r.="<tr><td style='width:120px; padding:10px 0 5px 0'><b>Enable Default Target</b></td>\n";
     $r.="<td style='padding:10px 0 5px 0'><input type='checkbox'  name='default_target' value='$in{'zfs'}.+' checked> default target: $in{'zfs'} (1:1)<br>\n";
     $r.="  <p style='font-size:10px; margin-top:7px'>Create default target when missing</p></td></tr>\n";

     # input select qsquery to disable others, obsolete
     # <input type='checkbox' class='hg1' onclick=\"\$('.hg0').attr('checked', false);\" name='hgroups' value=\"$v.+\"$t>     // optional $t=" checked";

     #&mess($r);
     &log_end;
     return($r);

}

#######################     create new/ edit
sub zfslib_get_edit_basic {
#######################
my ($t,$r,@vol,@v,$v,$form,$z);
# get volume status (avail, create)
# write zfs_vol('val') to current,  val=name,used,avail,refer,mountpoint

# volname: ex zfs=tank/ab -> volume=tank/ab/iscsi_GUID2

# autogenerate GUID:
# $t="600144f070cc440000004c";  # this one + time()
# $t.=time();

# current zfs: $in{'zfs'}
if ($in{'zfs'} eq "") { &mess("error: zfs is missing"); }


# create volume or show current?
my $vol="create /dev/zvol/rdsk/<br>$in{'zfs'}/iscsi_(lu-id2)";
@v=split(/\t/,$current{'iscsi_all_volumes'});
foreach $v (@v)  {
         if ($v =~/$in{'zfs'}\/iscsi/) {
              $vol=$v;
              $current{'iscsi_my_vol_id'}=$vol;
              $current{'iscsi_my_vol_id'}=~s/.*_//;
         }                       # show this
}

########
#volsize
#########

my $size=<<EoF;
           <select name="volsize" class="input" style='width:50px'>
              <option>1</option>
              <option>2</option>
              <option>3</option>
              <option>4</option>
              <option>5</option>
              <option>6</option>
              <option>7</option>
              <option>8</option>
              <option>9</option>
              <option>10</option>
              <option>20</option>
              <option>30</option>
              <option>40</option>
              <option>50</option>
              <option>60</option>
              <option>70</option>
              <option>80</option>
              <option>90</option>
              <option selected>100</option>
              <option>200</option>
              <option>300</option>
              <option>400</option>
              <option>500</option>
              <option>600</option>
              <option>700</option>
              <option>800</option>
              <option>900</option>
           </select>

           <select name="units" class="input" style='width:80px'>
              <option>Megabyte</option>
              <option selected>Gigabyte</option>
              <option>Terabyte</option>
              <option>Petabyte</option>
           </select>
EoF

$t=$in{'zfs'}."_iscsi_vol_size2";
if ($zfs{$t} ne "") { $size=$zfs{$t}; }

# debug
#&print_hash(%zfs);


#blocksize
##########
my $block=<<EoF;
           <select name="blocksize" class="input" style='width:132px'>
              <option>512B</option>
              <option>1KB</option>
              <option>2KB</option>
              <option>4KB</option>
              <option>8KB</option>
              <option>16KB</option>
              <option>32KB</option>
              <option selected>64KB</option>
              <option>128KB</option>
           </select>
EoF


$t=$in{'zfs'}."_iscsi_vol_size2";
if ($zfs{$t} ne "") { $block="set on create volume"; }


# advanced settings
my $advanced=&zfslib_edit_advanced();


#&print_hash(%cfg);
my $adv="Advanced settings (monitor extension)";
if ($cfg{'ver'}=~/m|c/i) {
   $adv="<a href='#' class='toggle'>Advanced settings</a> (monitor extension)";
}

# Form create
$form=<<EoF;
        <tr>
          <td style='width:120px; padding-bottom:5px'><b>Volume:</b><br><br></td>
          <td> $vol </td>
        </tr>
        <tr>
          <td style='width:120px; padding-bottom:5px'>Volume Size</td>
          <td>
$size

          </td>
        </tr>

        <tr>
          <td style='width:120px; padding-bottom:15px'>Block Size</td>
          <td>
$block
          </td>
        </tr>
        </table>

        <br>
        $adv <hr>
        <div class='toggle_content'>

        <table style='padding:10px 5px 0 5px; width:500px'>

$advanced
         </table>
         </div>
EoF


return($form);

#&print_array(@vol);
#$current{'volumes'}=$r;
#&print_hash(%current);

}

## eof
1;