#!/usr/bin/perl

## shebang needed only for tests !! agent1.pl is called via
## shellscript agent-manager.sh ( started at boot time together with napp-it)

# debug: kill taskserver.sh and start from console

## (c) Gnther Alka  2010-2020
# 05.08.2020
# path
# modified poef and redirection handling, thanks to Chris
# avoid permission problem with omni 151028

## intension of this script: inittask on boot time
##################################################

#define global var and settings
####### presets

       use strict;
       use vars qw(@jobs $jobid $jobtype $par $state $auto_os $os $path $cgipath $logpath $log $t $f $n @t @m @p $r %zfs %sys %p %cfg %in);

        use File::Copy;
        use File::Temp qw/ tempfile /;
        use Fcntl qw(:flock);                                                               # opt filelocking possible
        $|=1;                                                                               # keine Pufferung, no buffering

########################################## do it ############################################################
    # basic settings


     #create _my folder if not exist
      if (!(-d '/var/web-gui/_my')) { mkdir ('/var/web-gui/_my');  }

     #create _my/os folder if not exist
     if (!(-d '/var/web-gui/_my/zfsos')) { mkdir ('/var/web-gui/_my/zfsos');  }

     #create _my/os/_lib folder if not exist
     if (!(-d '/var/web-gui/_my/zfsos/_lib'))      { mkdir ('/var/web-gui/_my/zfsos/_lib');  }
     if (!(-d '/var/web-gui/_my/zfsos/_lib/lang')) { mkdir ('/var/web-gui/_my/zfsos/_lib/lang');  }

     #create _log folder if not exist
      if (!(-d '/var/web-gui/_log/'))              { mkdir ('/var/web-gui/_log/'); }

     #create /_log/group/ folder (group of boxes) if not exist
        if (!(-d '/var/web-gui/_log/group/'))      {   mkdir ('/var/web-gui/_log/group/');   }

     #create /_log/jobs/ folder (auto service) if not exist
        if (!(-d '/var/web-gui/_log/jobs/'))       {   mkdir ('/var/web-gui/_log/jobs/');    }

     #create /_log/temp/ folder (tmp files)
        if (!(-d '/var/web-gui/_log/tmp/'))         {   mkdir ('/var/web-gui/_log/tmp/');    }


     #change owner of /napp-it to web-account on every start of napp-it
     #set base permission to -R 755
      $f=`uname -a`;
      my $is_linux = $f=~/Linux/;
      my $is_sol11_2__9 = $f =~ /SunOS .*\s 5.11 \s+ 11\.[2-9]\./x;
      if ($is_linux) {
         `chown -R napp-it /var/web-gui`;
         `chmod -R 755 /var/web-gui/data`;
         $sys{'sbinpath'}='';
      } else {
         `/usr/bin/chown -R napp-it /var/web-gui`;
         `/usr/bin/chmod -R 755 /var/web-gui/data`;
         $sys{'sbinpath'}='/usr/sbin/';
      }
      `rm /var/web-gui/_log/tmp/* > /dev/null 2>&1`;  # del tmp folder content


     #check user_attr (on newer OmniOS napp-it must not be a role)
     $r=`cat /etc/user_attr`;
     if (!$? && $r=~/^napp\-it \b .*\b type=role \b/mx) {
          $r =~ s/^napp\-it \b .*\n?//mx;        # remove napp-it

          my ($ofh, $tempname) = tempfile("user_attrXXXXX", TMPDIR => 1, UNLINK => 0);
          if ($ofh && print $ofh $r) {
              undef $ofh;        # automatically closes the file
              `cat "$tempname" > /etc/user_attr`;        # cat to preserve meta for user_attr
              `rm "$tempname"`;
          }
     }

     # For commands which are %ENV-sensitive (e.g., pktool), we need pfexec
     # instead of sudo for the napp-it user. (Formerly napp-it setup,
     # www.napp-it.org/nappit, changed the user to a role after useradd. Any
     # still existing napp-it role attribute is removed above.)

     # On Solaris 11.2 and higher, 'Primary Administrator' is not available, so
     # add the equivalent 'napp-it Service' definitions (if not yet done), and
     # assign to the user.
     if ($is_sol11_2__9) {
         place_file('/var/web-gui/data/tools/solarish/org.napp-it.exec_attr',
             '/etc/security/exec_attr.d/org.napp-it.exec_attr');
         place_file('/var/web-gui/data/tools/solarish/org.napp-it.prof_attr',
             '/etc/security/prof_attr.d/org.napp-it.prof_attr');
         system("/usr/sbin/usermod -P'napp-it Service' napp-it");
     } elsif (!$is_linux) {
         # All other non-Linux (e.g. OmniOSce or earlier Solaris), assign
         # 'Primary Administrator' to the user.
         system("/usr/sbin/usermod -P'Primary Administrator' napp-it");
     }


     # ensure additional solarish run-control scripts--e.g., when upgrading
     # napp-it to the version where napp-it-poef appeared
     if (!$is_linux
         && -l '/etc/rc3.d/S99napp-it'
         && -f '/var/web-gui/data/tools/httpd/init.d/napp-it-poef') {

         place_file('/var/web-gui/data/tools/httpd/init.d/napp-it-poef',
             '/etc/init.d/napp-it-poef') and
           `/bin/chmod +x /etc/init.d/napp-it-poef`;

         my @poefrclinks = (
            '/etc/rc0.d/K99napp-it-poef',
            '/etc/rc2.d/S98napp-it-poef'
         );
         foreach my $lnk (grep { ! -l $_ } @poefrclinks) {
             `/bin/ln -s /etc/init.d/napp-it-poef "$lnk"`
         }
     }

     # add to /etc/sudoers to supress sudo console messages
     if (!$is_linux) {
         # Defaults logfile=/dev/null
         # Defaults !syslog

         $r=`cat /etc/sudoers`;
         if (!($r=~/\nDefaults logfile/s)) {
            $n=<<EoF;

## supress napp-it Console messages from sudo
Defaults logfile=/dev/null
Defaults !syslog
##
EoF
           $r=~s/\n\n/\n$n\n/s;        # insert at first empty line

           open (PF, ">/etc/sudoers");
           print PF "$r";
           close (PF);
         }
     }



   #################
   if (!($is_linux)) {

      # enable hotplug
      `svcadm enable hotplug`;

      # check/update /etc/hosts: 127.0.0.1  hostname (old hostname missing)
      my $ok=`hostname`;
      chomp($ok);         # thanks Rick
      $r=`cat /etc/hosts`; $r=~s/\n+/\n/gs;
      @t=(); @t=split(/\n/,$r);
      foreach my $t (@t) {
        if ($t=~/127.0.0.1\s+$ok\b/) { $ok="1"; last; }
      }
      if ($ok ne "1") {
        push (@t,"# next entry is done by napp-it agent-bootinit to avoid root console spamming, comment it optionally with a #");
        push (@t,"127.0.0.1\t$ok\n");
        $t=join("\n",@t);
        open (PF, ">/etc/hosts");
              print PF "$t";
        close (PF);
      }


     #autostart tftpd?
     if ((-f "/var/web-gui/_log/tftpd.autostart") && (-f "/var/web-gui/_log/tftpd.conf")) {
        $t=`cat /var/web-gui/_log/tftpd.conf`;
        chomp($t);

        print "start tftpd\n";
        if ($t=~/\-s \/\w+/) {
            print "start tftpd\n";
            $r=`/var/web-gui/data/tools/tftpd-hpa/sbin/in.tftpd -l $t\n`;
        }
     }

     # advertize services
     if (-f "/var/web-gui/_log/bonjour.sh") {
        print "start bonjour\n";
        `pkill -f dns-sd`;          # in case of restart

       #`echo "sh /var/web-gui/_log/bonjour.sh" | at -s now`;
       `cp /var/web-gui/_log/bonjour.sh /var/web-gui/_log/tmp/now_bonjour.sh`     # via taskserver
     }


      # z-raid handling, mount zraid on bootup?

      # mode is done by service !!
      #require ("/var/web-gui/data/napp-it/zfsos/06_Pools/50_Appliance_SSF_Z-RAID=-lin/zraid-lib.pl");
      #&my_zraid_boot;              # opt mount on bootup

      # start zraid service

      if (-f "/var/web-gui/_log/cluster/zraid_agent.on") {
          print "start zraid service\n";

         #`echo 'perl /var/web-gui/data/scripts/agents/agent_zraid_ssf.pl' > /tmp/t.sh`;
         #`echo "sh /tmp/t.sh" | at -s now`;

         `echo 'perl /var/web-gui/data/scripts/agents/agent_zraid_ssf.pl' > /var/web-gui/_log/tmp/now_zraid.sh`; # taskserver

         # sleep(2);
         #`rm /tmp/t.sh`;

        #`perl /var/web-gui/data/scripts/agents/agent_zraid_ssf.pl &`;
        #`echo "perl /var/web-gui/data/scripts/agent_zraid_ssf.pl" | at -s now`;
      }

      #

      #start autolock service?
      if (-f "/var/web-gui/_log/autolock/_settings/autostart_enabled") {
         print "\nstart autolock service\n";

         #`echo 'perl /var/web-gui/data/scripts/agents/agent_autolock.pl' > /tmp/t.sh`;
         `echo 'perl /var/web-gui/data/scripts/agents/agent_autolock.pl' > /var/web-gui/_log/tmp/now_autolock.sh`; # taskserver

         #`echo "sh /tmp/t.sh" | at -s now`;
         #sleep(2);
         #`rm /tmp/t.sh`;

      }  else {

         # remove autolock folders
         $t=$sys{'sbinpath'}."zfs list -H -o name -t filesystem | grep UserEncrypt";
         $r=`$t`;
         $r=~s/\n.*//s; chomp($r);

         # remove watched dubfolder
         if ($r=~/UserEncrypt/)      {
            `echo 'if user-locking is enabled for encrypted folders, move the switcher file to the lock or unlock subfolder' > "/$r/_use this watched folder for user crypt switching only.txt"`;

            if (-f "/usr/gnu/bin/find") {
               $t=`/usr/gnu/bin/find /$r -maxdepth 1 -type d`;

               # print "$t\n\n";

               @t=split(/\n/,$t);
               foreach my $t (@t) {
                  if ($t=~/UserEncrypt$/)     { next; }
                  if (!($t=~/UserEncrypt/))   { next; }

                  print "rm $t/service-state*\n";
                  `rm -f $t/service-state.*`;      # service state file, keep folder intact (acl)
                  if (-f "$t/=switcher.move")      { `rm -f $t/=switcher.move`; }
               }
            }

         }
      }

      #automount of encrypted fs
      print `perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent-bootunlock.pl`;
      sleep(2);
      print `/usr/sbin/svcadm refresh smb/server`;
   }

   # sensitive data
   if ($is_linux) {
         `chmod -R 700 /var/web-gui/_log`;
   } else {
         `/usr/bin/chmod -R 700 /var/web-gui/_log`;
   }

   # avoid napp-it:*LK*::::::: in /etc/shadow (permission error in napp-it)
     $r=`cat /etc/shadow`;
     if (!$? && $r=~/^napp\-it:\*LK\*:/mx) {
          $r =~ s/^napp\-it: .*\n?//mx;        # remove napp-it

          my ($ofh, $tempname) = tempfile("shadowXXXXX", TMPDIR => 1, UNLINK => 0);
          if ($ofh && print $ofh $r) {
              undef $ofh;        # automatically closes the file
              `echo "napp-it:NP:::::::" >> "$tempname"`;
              `cat "$tempname" > /etc/shadow`;        # cat to preserve meta for shadow
              `rm "$tempname"`;
          }
     }

   # avoid/remove napp-it as an SMB user
     $r=`cat /var/smb/smbpasswd`;
     if (!$? && $r=~/^napp\-it:/mx) {
          $r =~ s/^napp\-it: .*\n?//mx;        # remove napp-it

          my ($ofh, $tempname) = tempfile("smbpasswdXXXXX", TMPDIR => 1, UNLINK => 0);
          if ($ofh && print $ofh $r) {
              undef $ofh;        # automatically closes the file
              `cat "$tempname" > /var/smb/smbpasswd`; # cat to preserve meta for smbpasswd
              `rm "$tempname"`;
          }
     }

   # opt. del /tmp/err.log: created on problems as root and can hinder user napp-it to access
   if (-f "/tmp/err.log") { `rm /tmp/err.log`; }


   # start minio
   if (!($is_linux)) {
     `pkill -f minio`;          # in case of restart
     $t=`/sbin/zfs get s3_auto: | grep 'yes *local'`;
     @t=split(/\n/,$t);
     foreach my $l (@t) {
        $l=~s/ .*//;   # zfs
        if (-f "/$l/S3_config/minio.sh") {
          print "\nstart /$l/S3_config/minio.sh\n";
          #`echo "sh /$l/S3_config/minio.sh" | at -s now`;
          $t=$l; $t=~s/\//_/g;
          `cp /$l/S3_config/minio.sh /var/web-gui/_log/tmp/now_minio_$t.sh`;

        }
     }
   }
   print "\nbootinit: bye\n";

   #####
   exit;
   #####




###############################################
# Copies file $src to $tgt if $tgt is missing or if `diff`erent from $src.
# *** Note: filenames cannot contain whitespace!
# Returns: 1 if copied, 0 if not copied, or undef on copy error.
sub place_file {
   my ($src, $tgt) = @_;

   if (-f $src) {
      if (! -f $tgt || system("diff $src $tgt > /dev/null") != 0) {
         copy($src, $tgt) or return undef;
         return 1;
      }
   }
   return 0;
}

###############################################
#end of my script, do not delete the line below
1;
