#!/usr/bin/perl

## agent_acc.pl
## (c) Gnther Alka  2010-2020

## debug: start 'perl /path/agent_acc.pl disk' manually from console
## used for background GUI acceleration
## print of background tasks -> /tmp/crout...a
## disable all prints after debugging

# every napp-it call creates a /tmp/access.last with time in it
# acc checks this file continously and accelerates for next 20min

# 22. may 2019 use ip not hostname in group
# 3.6. require grouplib
# 6.5.2020 search smartctl

#define global var and settings
       use strict;
       use vars qw(%current %p %cfg %zfs %disk %in %sys %txt $i $si $par $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t @t $f @f %data $D);

       $par=$ARGV[0];
       if (!(defined($par))) { $par=""; }
       if ($par eq "") { print "no agent given\n"; exit; }

use Fcntl qw(:flock);                                                    # filelocking
$|=1;

use strict;
use warnings;

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/grouplib.pl";

#Debug=0/1
$D="0";

$t=`ps axw | grep agent_acc.pl | grep ' $par' | grep -v grep`;           # all agents ex for par = " zfs"
@t=split(/\n/,$t);

if ($par eq "disk") {                                                    # only one instance
     if (@t > 1) {
          print "disk acc is already running\n";
          exit;
     }
     &disk_acc;
}

if ($par eq "zfs") {                                                     # only one instance
     if (@t > 1) {
          print "zfs acc is already running\n$t\n";
          exit;
     }
     &zfs_acc;
}

if ($par eq "group") {                                                     # only one instance
     if (@t > 1) {
          print "group acc is already running\n$t\n";
          exit;
     }
     &group_acc;
}

if ($par eq "html") {                                                     # only one instance
     if (@t > 1) {
          print "group acc is already running\n$t\n";
          exit;
     }
     &html_refresh;                                                        # was agent-pages
}

if ($par eq "sas") {                                                     # only one instance
     if (@t > 1) {
          print "sas acc is already running\n$t\n";
          exit;
     }
     &sas_acc;
}

if ($par eq "cluster") {                                                     # only one instance
     if (@t > 1) {
          print "cluster acc is already running\n$t\n";
          exit;
     }
     &cluster_acc;
}

if ($par eq "smart") {                                                     # only one instance
     if (@t > 1) {
          print "smart acc is already running\n$t\n";
          exit;
     }
     &smart_acc;
}


#print "no valid acc given: disk,..\n";
exit;

# read exclusive
#  open (F,"<$log");
#        flock(F, LOCK_EX);
#        @data=<F>;
#  close (F);                                                                        # keine Pufferung, no buffering

# write ex
# open (PF, ">$log");
#    flock(PF, LOCK_EX);
#    print PF "$t";
#    print PF @data;
# close (PF);


############# group overview in grouplib
sub group_acc {
##############
   my ($tm,$t,$group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask,$host,$s,$z,$p,$count,$url2);

   while(1) {
    #
    #########################  part of acceleration see agent_acc.pl ###########

    $url2="_URL_type==type=\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm(\'=ask2=?\'))\"";

     #read list of groups-members
     $t="/var/web-gui/_log/group";
     @t=();

     # read group members
     opendir(DIR, $t);
          @t = readdir(DIR);
     closedir(DIR);

     @g=();
     my $sp1='&nbsp;' x 15;
     my $sp2='&nbsp;' x 130;
     push (@g,"<b>group-members</b>$sp1\t<b>ip</b> (klick to connect)\t<b>state</b>\t<b>key</b>\&nbsp;\&nbsp;\t<b>appliance&nbsp;version</b>$sp2\t<b>status</b>\t<b>option</b>");
     #push (@g,"<b>group-members</b>\t<b>ip</b> (klick to connect)\t<b>online</b>\t<b>napp-it version</b>\t<b>status</b>\t<b>option</b>");

     foreach $t (@t) {
                if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }                #np group member
                $t=~s/~/\t/; $t=~s/\.txt$//;
                push (@g," $t");
     }

    #list members from /_log/members -> ip.txt, content = napp-it key = login admin+ip -> return key
    #insert link to details

     print "run group acc, ";

    foreach $t (@g) {
        @w=();
        @w=split(/\t/,$t);

        $n=$w[0]=~s/ +$//;                #no space at end

        if (!($w[1]=~/\d\./)) { next; }                #  ip


        # groupname -> link. show members (details) -> "prop"
        # +ZFS,SNAP.PID
        ################

                $host=$w[0]; $host=~s/\s//g;   # remove spaces
                $z=$url2;                       # for zfs list
                $s=$url2;                       # for snaplist
                $p=$url2;                       # for pslist
                $w[0]="<b>$host</b> ";

                ## ZFS, Snaps and Processes
                $z=~s/=text=/ZFS /;
                $z=~s/=list=/details/;
                $z=~s/=prop=/$w[1]/;
                $z=~s/=action=/remote-details/;
                $z=~s/=type=/zfs/;
                $z=~s/=old=//;
                $z=~s/=ask=//;

                $s=~s/=text=/Snaps /;
                $s=~s/=list=/details/;
                $s=~s/=prop=/$w[1]/;
                $s=~s/=action=/remote-details/;
                $s=~s/=type=/snapshot/;
                $s=~s/=old=//;
                $s=~s/=ask=//;

                $p=~s/=text=/Pid /;
                $p=~s/=list=/details/;
                $p=~s/=prop=/$w[1]/;
                $p=~s/=action=/remote-details/;
                $p=~s/=type=/ps/;
                $p=~s/=old=//;
                $p=~s/=ask=//;
                $w[0].="( $z / $s / $p)";

        #online and status
                #ping it
                #  $r=&exe("ping $w[1] -w 1");                                     # on Linux

                #$r=&exe("ping $w[1] 1");     #timeout 1
                $r=`/usr/sbin/ping $w[1] 1`;  #timeout 1                         # use this in acc-script

                if ($r=~/alive|icmp/s) { $w[2]="alive"; } else {  $w[2]="<font style='color:red'>offline</font>"; }  # icmp on Linux

               if ($w[2] eq "alive") {

                        # alive but key ok?
                        $r=&grouplib_ask_remote_pslist($w[1],,"overview");        # proc;;proc;;
                        if ($r=~/wrong|unknow/is) {
                                  $r="<font style='color:#ba2f28'>invalid</font>";     # invalid dkey
                        } else {
                                  $r="ok";
                        }
                        $w[3]="$r";

                        #connect via netcat on port $sys{'port'} (81)
                        $r=`perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | nc -w 5 $w[1] 81`;
                        if ($r eq "")                         {
                                                    $w[4]="<font color='red'>remote call: timeout</font>";
                          } else {
                                                    if ($r=~/refused/s)    { $w[4]="webserver: no"; }
                                                    if ($r=~/napp-it-ok:/s)  {
                                                          $w[4]=$r;
                                                          $w[4]=~s/.*napp-it-ok://s;
                                                          $w[4]=~s/: command not found//s;
                                                    }  else {
                                                          $w[4]="not a napp-it server";
                                                          $w[0]= $host;
                                                    }
                         }
                }  else {
                       $w[4]="-"; $w[0]=" $host";
                }

       # 4 delete member
               if ($w[1]=~/\d+\.\d+\.\d+\.\d+/) {
                        $n="delete";
                        $w[5]=$url2;
                        $w[5]=~s/=text=/$n/;
                        $w[5]=~s/=action=/del-nasgroupmember/;
                        $w[5]=~s/=old=/$host\~$w[1]"/;
                        $w[5]=~s/=ask=/$ask/;
                        $w[5]=~s/=ask2=/delete group-member $host ?/;
                        $w[5]=~s/=list=//;
                        $w[5]=~s/=prop=//;
                        $count++;

                        # no link with 127.0.0.1
                        if ($w[1] eq "127.0.0.1")  { $w[5]="-"; }
                }



        #ip. last item to keep ip
                $n=$w[1];                                                #ip
                $w[1]="<a target=\"_blank\" href=\"http://$n:81/cgi-bin/admin.pl\">$n</a>";

                # no link with 127.0.0.1
                if ($n eq "127.0.0.1")  {$w[1]="127.0.0.1 localhost"; }



       $t=join("\t",@w);
       #$t.="\n";
    }

    ## / acceleration in grouplib
    #########################################################

    $t=time();
    $r=join("\n",@g);
    open (PF, ">/tmp/nappit/group_list.group");
               flock(PF, LOCK_EX);
               print PF $r;
     close (PF);


     # time of creation
     $tm=time;
     open (PF, ">/tmp/nappit/group_last.group");  # last run of acc
          flock(PF, LOCK_EX);
          print PF "$tm";                         # time
     close (PF);
     print ".. acc finished\n";
     &acc_pause();                                # pause
   }
}


#############       # pool-status does the same bit acc is priority
sub zfs_acc {
#############
   my $r="";
   my ($t,$tm,$f,$z);

   while(1) {

              #process 30 min after last access
              $tm=time();

              if (-f "/tmp/nappit/access.last") {          # last user access
                    open (F,"</tmp/nappit/access.last");
                            flock(F, LOCK_EX);
                            @t=<F>;
                    close (F);

                    $t=$tm-$t[0];
                    print " 308 last=$t[0] current tm=$tm diff in s=$t\n";

                    if ($t > 1800) {           # last access longer 30m (1800s)
                           print "last access too old, wait: $t";
                           sleep(10);

                           # del acc files
                           if (-f "/tmp/nappit/zfs_last.zfs") {
                             `sudo rm /tmp/nappit/*.zfs`;
                           }

                           next;                           # wait al little longer to recreate
                    }
              }

               print "zfs acc, ";

              $r=`/usr/sbin/zpool status`;
              open (PF, ">/tmp/nappit/zpool_status.zfs");
                        flock(PF, LOCK_EX);
                        print PF "$r";
              close (PF);

              print "zpool status\n$r\n";

              #add zfs
              # read by zfslib_overview

              # NAME                                             TYPE        CREATION                USED  AVAIL  REFER ..
              $r=`/usr/sbin/zfs list -o all | grep -v rpool`;
              $r.=`/usr/sbin/zfs list -o all | grep rpool`;     # rpool last

              open (PF, ">/tmp/nappit/zfs_list.zfs");           # get-zfs -> zfslib overview
                        flock(PF, LOCK_EX);
                        print PF "$r";
              close (PF);


              #get ls -l -d /pool/fs
              ##########
              @t=split(/\n/,$r);
              print "zpool filesystems\n";

              $f="";
              foreach my $t (@t) {
                if (!($t=~/  filesystem  /))         { next; }  # fs only
                if ($t=~/rpool\/ROOT|rpool\/export/) { next; }  # not ROOT

                $z=$t;
                $z=~s/  .*//;
                $r="$z\_ls";
                $current{$r}=`/usr/bin/ls -l -d \'/$z\'`;
                chomp($current{$r}); $current{$r}=~s/\n/<n>/gs;
                if ($current{$r} eq "") { $current{$r}="-"; }

                $f.="$r\|$current{$r}\|\n";
                print "$z -> $current{$r}";
              }
              open (PF, ">/tmp/nappit/zfs_ls.zfs");    # zfslib perm
                        flock(PF, LOCK_EX);
                        print PF "$f";
              close (PF);

              # get ls -dv fs
              print "\n\nzpool filesystems acl\n";

              $f="";
              foreach my $t (@t) {
                if (!($t=~/  filesystem  /))         { next; }  # fs only
                if ($t=~/rpool\/ROOT|rpool\/export/) { next; }  # not ROOT

                $z=$t;
                $z=~s/  .*//;
                $r="$z\_dv";
                $current{$r}=`/usr/bin/ls -dV \'/$z\'`;
                chomp($current{$r}); $current{$r}=~s/\n/<n>/gs;
                if ($current{$r} eq "") { $current{$r}="-"; }

                $f.="$r\|$current{$r}\|\n";
                print "$z -> $current{$r}";
              }
              open (PF, ">/tmp/nappit/zfs_dv.zfs");    # zfslib perm
                        flock(PF, LOCK_EX);
                        print PF "$f";
              close (PF);



              # snapshots
              $r=`/usr/sbin/zfs list -H -r -t snapshot -o name,creation,used,avail,refer,defer_destroy,userrefs,clones -S creation`;   # default newest first
              #$r=`/usr/sbin/zfs list -o all`;     # NAME                                             TYPE        CREATION                USED  AVAIL  REFER ..
              $r=&parse_mydate($r);                # Dez 1 -> Dez 01

              open (PF, ">/tmp/nappit/zfs_list_snaps1.zfs");    # zfslib list datasnap
                        flock(PF, LOCK_EX);
                        print PF "$r";
              close (PF);

       # time of creation
       $tm=time;
       open (PF, ">/tmp/nappit/zfs_last.zfs");  # last run of acc
            flock(PF, LOCK_EX);
            print PF "$tm";                     # time
       close (PF);

       print ".. acc finished\n";
       &acc_pause();

       # debug
       #print "zfs acc 263 $t\n";
   }
}

############
sub cluster_acc {
############

   my ($tm,$load);

   $load="1"; $current{'callby.acc'}="1"; $cfg{'ver'}="c"; # settings, call get-disk-sas2 from accelerator (=write acc file)
   require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";

   ##


   while(1) {

       #process 30 min after last access
       $tm=time();

       if (-f "/tmp/nappit/access.last") {          # last user access
              open (F,"</tmp/nappit/access.last");
                      flock(F, LOCK_EX);
                      @t=<F>;
              close (F);

              $t=$tm-$t[0];
              print " 308 last=$t[0] current tm=$tm diff in s=$t\n";

              if ($t > 1800) {           # last access longer 30m (1800s)
                     print "last access too old, wait: $t";
                     sleep(10);

                     # del acc files
                     if (-f "/tmp/nappit/cluster_last.clu") {
                        `sudo rm /tmp/nappit/*.clu`;
                     }
                     next;                           # wait
              }

              # active in mode cluster-control
              $t=`cat /var/web-gui/_log/napp-it.cfg`;
              #print "$t\n";
              if (!($t=~/cluster\-control/s)) {
                    print "not on mode cluster-control, wait";
                    sleep(10);
                    next;
              }
       }

       print "321 run cluster acc, ";

       # get values
       if ($load) {    # first time
         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/grouplib.pl";

         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk.pl";
         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/cluster-lib.pl";
         &my_read_settings;

         #require "/var/web-gui/data/napp-it/zfsos/03_System and network=-lin/11_Appliance_Cluster/action.pl";
         #&my_show_nodes;

         $load="0";

       } else {

         $disk{'all_lsi'}="";
         $disk{'all_nlsi'}="";

         #get settings                           # get disk is seperate
         &my_read_settings;                      # cluster-lib
         #&my_show_nodes;                         # action.pl
       }

# write acc values only

      print "-- 90 get state $p{'value_ip_mh1'}\n\n";

      if ($p{'value_ip_mc1'} =~/\d/) {     # control 1
        &get_state("get_cl_control_state","$p{'value_ip_mc1'}","c1");
      }
      $p{'value_ip_mc2'}.="";              # initialize when not set
      if ($p{'value_ip_mc2'} =~/\d/) {     # control 2
        &get_state("get_c2_control_state","$p{'value_ip_mc2'}","c2");
      }

      if ($p{'value_ip_mh1'} =~/\d/) {     # h1
        &get_state("get_h1_control_state","$p{'value_ip_mh1'}","h1");
      }
      if ($p{'value_ip_mh2'} =~/\d/) {     # h1
        &get_state("get_h2_control_state","$p{'value_ip_mh2'}","h2");
      }





# debug
# print "all_dsk $disk{'all_dsk'}\n";

       open (PF, ">/tmp/nappit/cluster_last.clu"); # last run of acc
            flock(PF, LOCK_EX);
            print PF "$tm";                     # time
       close (PF);

       print ".. acc finished\n";
       &acc_pause();                            # pause default 10..30s
   }
}



##############
sub sas_acc {
############
   my ($tm,$load);

   $load="1"; $current{'callby.acc'}="1"; $cfg{'ver'}="m"; # settings, call get-disk-sas2 from accelerator (=write acc file)
   require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
   while(1) {

       #process 30 min after last access
       $tm=time();

       if (-f "/tmp/nappit/access.last") {          # last user access
              open (F,"</tmp/nappit/access.last");
                      flock(F, LOCK_EX);
                      @t=<F>;
              close (F);

              $t=$tm-$t[0];
              print " 308 last=$t[0] current tm=$tm diff in s=$t\n";

              if ($t > 1800) {           # last access longer 30m (1800s)
                     print "last access too old, wait: $t";
                     sleep(10);

                     # del acc files
                     if (-f "/tmp/nappit/sas_last.ircu") {
                        `sudo rm /tmp/nappit/*.ircu`;
                     }
                     next;                           # wait al little longer to recreate
              }
       }

       print "321 run sas acc, ";

       # get values
       if ($load) {    # first time
         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk.pl";
         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk-sas2.pl";
         $load="0";
       } else {
         $disk{'all_lsi'}="";
         $disk{'all_nlsi'}="";

         #getdisk                           # get disk is seperate
         &get_mydisk_format;
         &get_mydisk;

         # get all lsi hba
         #&get_mylsi_all_hba;               # not needed

         # get lsi disks, slot and target
         #&get_mylsi_dsks_from_driver;      # not needed

         # get all disks from sasircu, overwrite values from mdb as sasircu is more accurate
         &get_mydisk_sasircu;

         # get usage (all_lsi_used etc)
         #&get_my_lsi_usage;
       }

# debug
# print "all_dsk $disk{'all_dsk'}\n";

       open (PF, ">/tmp/nappit/sas_last.ircu"); # last run of acc
            flock(PF, LOCK_EX);
            print PF "$tm";                     # time
       close (PF);

       print ".. acc finished\n";
       &acc_pause();                            # pause default 10..30s
   }
}

##############
sub smart_acc {
############
   my ($tm,$load,$r,$smt);

   $load="1"; $current{'callby.acc'}="1"; $cfg{'ver'}="m"; # settings, call get-disk-sas2 from accelerator (=write acc file)
   require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
   require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk.pl";

   while(1) {

       #process 30 min after last access
       $tm=time();

       if (-f "/tmp/nappit/access.last") {          # last user access
              open (F,"</tmp/nappit/access.last");
                      flock(F, LOCK_EX);
                      @t=<F>;
              close (F);

              $t=$tm-$t[0];
              print " 308 last=$t[0] current tm=$tm diff in s=$t\n";

              if ($t > 1800) {           # last access longer 30m (1800s)
                     print "last access too old, wait: $t\n";
                     sleep(10);

                     # del acc files
                     if (-f "/tmp/nappit/smart_last.smart") {
                        `sudo rm /tmp/nappit/*.smart`;
                     }
                     next;                           # wait al little longer to recreate
              }

              ###
              $smt="/usr/sbin/smartctl";  # compiled
              $r=`find /opt -name smartctl`;    $r=~s/\n.*//s;  # first entry
              if ($r=~/smartctl/) { $smt=$r; }

              #has smart installed
              if (!(-f "$smt")) {
                 print "Smartmontools are not installed, wait\n";
                 sleep(10);
                 next;
              }
       }

       print "543 run smart acc, ";

       # load disk
       if (-f "/var/web-gui/_log/partitions.enabled") {   # read partition only when enabled (parted has problems with some configs)

          &get_mydisk_parted;             # get partitions from parted, use format in case of errors
          if ($disk{'parted_error'}) {
            &get_mydisk_format;           # problem with parted, run detection with format addionally (shows disks only not partitions)
          }
       }  else {
           &get_mydisk_format;
       }
       &get_mydisk;                       # add disk{'all'} from iostat

       # get values
       if ($load) {    # first time
         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/disklib.pl";
         &get_mydisk;                      # alldisk

         require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk-smart-bg.pl";
         # with &get_mydisk_smart;

         $load="0";
       } else {
         $disk{'all_lsi'}="";
         $disk{'all_nlsi'}="";

         #getalldisk                           # get disks
         &get_mydisk;                           # disklib

         # smartlib
         &get_mydisk_smart;

       }

# debug
# print "all_dsk $disk{'all_dsk'}\n";

       open (PF, ">/tmp/nappit/smart_last.smart"); # last run of acc
            flock(PF, LOCK_EX);
            print PF "$tm";                     # time
       close (PF);

       print ".. acc finished\n";
       sleep (60);                          # pause default 10..60s
   }
}


############
sub disk_acc {
############

   my ($r,$f,$tm);
   $current{'callby.acc'}="1";

   ##########
   while(1) {

       $tm=time();

       if (-f "/tmp/nappit/access.last") {          # last user access
              open (F,"</tmp/nappit/access.last");
                      flock(F, LOCK_EX);
                      @t=<F>;
              close (F);

              $t=$tm-$t[0];
              print " 308 last=$t[0] current tm=$tm diff in s=$t\n";

              if ($t > 1800) {           # last access longer 30m (1800s)
                     print "last access too old, wait: $t";
                     # del acc files
                     if (-f "/tmp/nappit/format_last.dsk") { `sudo rm /tmp/nappit/*.dsk`;  }
                     if (-f "/tmp/nappit/parted_last.dsk") { `sudo rm /tmp/nappit/*.dsk`;  }
                     sleep(10);
                     next;                           # wait al little longer to recreate
              }

       }

       print "run disk acc, ";

       #use format to check disks
       if (-f "/var/web-gui/_log/partitions.enabled") {
           $f="parted";
           $r=`/usr/sbin/parted -lm`;
           if (!($r=~/\/dev\/dsk/s)) {
               $r="";
           } else {
                #write parted
                open (PF, ">/tmp/nappit/parted_lm.dsk");
                   flock(PF, LOCK_EX);
                   print PF "$r";
                close (PF);
                open (PF, ">/tmp/nappit/parted_last.dsk");      # last run of acc
                   flock(PF, LOCK_EX);
                   print PF "$tm";                   # time
                close (PF);
           }
       } else {
           $f="format";
           $r=`echo | /usr/sbin/format`;
           if (!($r=~/AVAILABLE/s)) {
               $r="";
           } else {
               #write format
                open (PF, ">/tmp/nappit/format.dsk");
                   flock(PF, LOCK_EX);
                   print PF "$r";
                close (PF);
                open (PF, ">/tmp/nappit/format_last.dsk");      # last run of acc
                   flock(PF, LOCK_EX);
                   print PF "$tm";                   # time
                close (PF);
           }
       }

     # last log
     print ".. acc finished\n";
     &acc_pause();   # pause default 10s
   }
}


############ # former agent-pages
sub html_refresh {
############

  # /cgi-bin/monitor-lib sends a request like l1_id.req_htm ex 15_admin,14566734.req_htm
  # this script deletes the request and creates 15_14566734.htm
  # /cgi-bin/monitor-lib updates the htm via ajax and deletes the .htm
  # /cgi-bin/monitor-lib sends a new request like l1_id.req ex 15_14566734.req
  # this script also deletes .htm older 30s

  my ($id,$l1,$pagenr,$time,$r);

  while(1) {

     # step1, read  /tmp/nappit/ for .req_htm and .htm
     $time=time();
     @t=();

     $r=`find /tmp/nappit/htm/ | grep htm 2>/dev/null`;
     @t=split(/\n/,$r);                              # with full path

     # optional delete old htm
     &html_del_old;

     foreach my $t (@t) {
        chomp($t);
        if ($t=~/\.req_htm$/) {
                 &html_write_new("$t");
                 next;
        }

     }
     sleep(2);


  } #/while
}

############ check for pagefiles older 10s
sub html_write_new {
############

  #
     my $file=$_[0];                          # filename with substr(id,0,24), napp-it owner 700

     #debug
     print "new filename $file\n\n";

     #read request exclusive time, id, l1, l2, l3 per line
     @f=();

     open (F,"<$file");
        flock(F, LOCK_EX);
        @f=<F>;
     close (F);

     ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
     $mon++;
     if ($sec < 10)  { $sec  = "0$sec";  }
     if ($min < 10)  { $min  = "0$min";  }
     if ($hour < 10) { $hour = "0$hour"; }
     if ($mday < 10) { $mday = "0$mday"; }
     if ($mon < 10)  { $mon  = "0$mon";  }
     $year=1900+$year;
     my $time=time();

     # req too old
     if ($f[0]=~/time: \d+/) {
         $f[0]=~s/time: //;
         if ($time-$f[0] > 10) {
             unlink("$file");
             if ($D) { print "unlink old req $file\n\n"; }
             return;
         }
     }

     my $id=$f[1];  chomp($id);
     my $l1=$f[2];  chomp($l1);
     my $l2=$f[3];  chomp($l2);
     my $l3=$f[4];  chomp($l3);

     ## 'cli=1::id=xx yy::l1=abc::...'
     my $r=`/usr/bin/perl /var/web-gui/data/wwwroot/cgi-bin/admin.pl \"cli=1::id=$id\::l1=$l1\::l2=$l2\::l3=$l3\"`;

#print "$r\n";
#exit;

     #login form
     if ($r=~/form name=\"login\"/s ) {
             unlink("$file");
if ($D) { print "unlink req loginform from $file\n\n"; }
             return;
     }

     #remove </body>  and header
     $r=~s/.*<body>//s;
     $r=~s/<\/body>//gs;
     $r=~s/<\/html>//gs;

     #debug
     # print "#### $r\n";


     #<!--wscontent--> =whole page or <!--wsarea--> = area with div=wsarea
     if (($r=~/<!\-\-wsarea\-\->/) && ($r=~/<!\-\-wsarea_end\-\->/s)) {
        $r=~s/.*<!\-\-wsarea\-\->//s;
        $r=~s/<!\-\-wsarea_end\-\->.*//s;
        $r="<!--wsarea-->$r\n<!--wsarea_end-->\n";
     } else {
        if ($r=~/<!\-\-wscontent\-\->/s) {
              $r=~s/.*<!\-\-wscontent\-\->/<!--wscontent-->/s;
        } else {
              # debug only
              # wscontent missing in page\n";

              #nothing todo
              if ($D) { print "no wscontent in $file\n"; }
              unlink("$file");  # unlink request
              return;

        }
     }

     # add time to #hl
     $r.=<<EoF;

       <script type="text/javascript">
         \$("#minilog").append("reload $hour\:$min $sec s");
         \$("#minilog").animate({opacity: 'hide'}, 'slow');
       </script>
EoF


     #add timestamp
     $r.="<div style='z-index: 10; position: absolute; top: 150px; width: 99%; font-size:8px;color:#666666; margin:10px 30px 0 0; text-align:right'>update $hour:$min $sec s </div><!--time-->$time";

     #log file to /tmp/page_id
     if (!($r=~/<!\-\-nows\-\->/s)) {          # skip realtime update (ex pop-windows open)

       $t=$file; $t=~s/\.req_htm/.htm/;
       if ($D) { print "create $t\n"; }

       open (F,">$t");                         # ex 15_admin,875438.htm       (short id), write as root
          flock(F, LOCK_EX);
          print F "time: $time\n";             # first line: timestamp
          print F "$r";
       close (F);

       `sudo /usr/bin/chown napp-it $t`;
       `sudo /usr/bin/chmod 700 $t`;           # contains id, htm file is read by mon as napp-it


     } else {
        # debug
        if ($D) {  print "nows missing in request for $file\n";   }
     }


    # delete this request
    if ($D) { print "del after create $file\n";   }
    unlink("$file");

    #exit;
}


############ check for pagefiles older 10s
sub html_del_old {
############
  my (@data,$r);
  my $time=time();

  # &my_read_dir('/tmp/nappit/','t','htm$');      # from main

  foreach my $t (@t) {
      chomp($t);

      if (!($t=~/\.htm$/)) { next; }              #.htm only

      #read
      open (F,"<$t");                             # contain path
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);

      if ($data[0]=~/^time: \d+/) {
         $data[0]=~s/time: //;
         if ($time-$data[0] > 10) { unlink("$t"); }
      }
  }
}

############
sub my_read_dir { # &read_dir("dir","arrayname","Muster","Zeilennr")
############ directory lesen ergebnis in array "arrayname" (files+directories!!) oder Muster=/
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;

 local (*F);
 if ($par[0] eq "") { &CgiDie("(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])"); }
 if ($par[1] eq "") { &CgiDie("(lib-562 read_dir: $par[2]) Programmfehler: Es wurde kein Array angegeben (ref $_[3])"); }
 if (!(-d $par[0])) { &CgiDie("(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[3])"); }

 opendir(F, $par[0]) || &CgiDie("(lib-564 read_dir: $par[2]) Programmfehler: Verzeichnis $par[0] gesperrt");
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file"; if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[2]=~/\./) {        #.xxx
                if ($file=~/$par[2]$/) {  push (@t,$file); }
        } else {
                if ($file=~/$par[2]/)  {  push (@t,$file); }
        }
 }
 closedir(F);
 return;
}



############# call this for pause between running of system calls
sub acc_pause {
#############

    #default pause 10..30s
    sleep(20);
    return;
}


##
sub parse_mydate { # ex  Jan  1:18 -> Jan 01:18 or  Tue  1  -> Tue 01 ex in zfs creation
#############
  my $s=$_[0];
  my @m=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  for (my $i=0;$i<=9; $i++) { $s=~s/  $i:/ 0$i:/gs; }
  foreach my $m (@m) {  for (my $i=1;$i<=9; $i++) { $s=~s/ $m  $i / $m 0$i /gs; }  }
  return($s);
}

############### read zfs and snap log and return larger file
sub get_zfs_snap_larger {
###############
    my @data;
    my $z="0";
    my $s="0";
    if (-f "/tmp/nappit/menue-07.log") {
      open (F,"</tmp/nappit/menue-07.log");               # zfs
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);
      if ($data[0] > 0)  { $z=$data[0]; }
    }
    @data=();
    if (-f "/tmp/nappit/menue-08.log") {
      open (F,"</tmp/nappit/menue-08.log");               # snap
         flock(F, LOCK_EX);
         @data=<F>;
      close (F);
      if ($data[0] > 0)  { $s=$data[0]; }
    }
    if ($s > $z) {
         return ("/tmp/nappit/menue-08.log");             # snap
    } else {
         return ("/tmp/nappit/menue-07.log");             # zfs
    }

}

###############   sek since last last acces to napp-it or napp-it menu
sub xxget_last_access  {
###############
print "############last access\n";
return(0);

}

sub getmydate {                # setzt datumsvariablen
###########
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10)  { $sec = "0$sec"; }
 if ($min < 10)  { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10)  { $mon = "0$mon"; }
 $year=1900+$year;
 $date_and_time = "$mday\.$mon\.$year, $hour:$min $sec s";
 $date = "$mday\.$mon\.$year";
 $date_us= "$mon\.$mday\.$year";
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}

###############################################
#end of my script, do not delete the line below
1;
