# (c) napp-it 2023
# 1. analyze blocksize of files in a filesystem via zdb filesystem
# 2. list all files in a filesystem with inode and last edit time


ps axw | grep -v grep | grep analyze.sh

# call scripr only once
Count=$(ps axw | grep -v grep | grep analyze.sh | awk '{print NR}' | wc -l)
echo $Count

if [ "$Count" -gt "1" ]; then
   echo $Count
   echo "script is already running, wait until finished!"
   exit
fi

# check parameter filesystem
if [ -z "$*" ];
then
  echo "Parameter 'filesystem' is missing."
  exit
fi

if [ ! -d /$1 ];
then
  echo "'filesystem' was not found.";
  exit;
fi

# create folder ../_log/tiering if missing
if [ ! -d /var/web-gui/_log/tiering ];
then
  mkdir -p /var/web-gui/_log/analyze
fi

# delete old analyze log files
# zdb
Logfile1=$(echo "/$1" | sed "s/\//_/g");
Logfile1="/var/web-gui/_log/analyze/$Logfile1.zdb";

# stat
Logfile2=$(echo "/$1" | sed "s/\//_/g");
Logfile2="/var/web-gui/_log/analyze/$Logfile2.stat";

# create new logfiles with date
date +%Y.%m.%d > $Logfile1
date +%s >> $Logfile1
echo "     inode  lvl   iblk   dblk  dsize  dnsize  lsize   %full  type" >> $Logfile1

date +%Y.%m.%d > $Logfile2
date +%s >> $Logfile2
echo "inode ; file ; last_; editdate " >> $Logfile2

# add zdb for plain files  (logfile1)
zdb $1  | grep plain >> $Logfile1
date +%s >> $Logfile1

# add stat (inode, file, lastedit to Logfile2)
find /$1 -type f -exec stat -c "%i;'%n';%z" {} \; | grep -v '.\$' >> $Logfile2
date +%s >> $Logfile2


