#!
# (c) Guenther Alka 2021

# backuplib contains functions for backup restore
# in backupjob, user restore and cluster failover
# 08. aug 2019
# 10.0kt.2021 save restore napp-it.cfg and bonjour.sh

use strict;  #disable when calling direct


#####
sub bl_iscsi_restore_basic {     #
#####
   my $pool=$_[0];
   my $r=`sudo test -f /$pool/backup_appliance/settings/COMSTAR-lastbackupjob.bkp && echo 1 || echo 2`;  chomp($r);
   if ($r eq "1") {
     `sudo cp /$pool/backup_appliance/settings/COMSTAR-lastbackupjob.bkp /var/web-gui/_log/COMSTAR-lastbackupjob.bkp`;
   }
}

#####
sub bl_restore_cl_settings {     # cluster settings on cluster control
#####
   my $pool=$_[0];
   my $r=`sudo test -d /$pool/backup_appliance/cluster/ && echo 1 || echo 2`;  chomp($r);
   if ($r eq "1") {
     `sudo cp /$pool/backup_appliance/cluster/settings.txt /var/web-gui/_log/cluster/settings.txt`;
     `sudo cp /$pool/backup_appliance/cluster/failover.txt /var/web-gui/_log/cluster/failover.txt`;
   }
}

#####
sub bl_restore_nappit {
#####
  my ($r,@v);
  my $pool=$_[0];
  my $restore_key=$_[1];  # restore napp-it key from backup?    -> "1"   , other=2, all=3

  $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
  if ($r eq "2") { return();  }

  `sudo /bin/chown -R napp-it /$pool/backup_appliance/web-gui/`;
  `sudo /bin/chmod 755 /$pool/backup_appliance/`;
  `sudo /bin/chmod -R 755 /$pool/backup_appliance/web-gui/`;

  # restore key ?
   if ($restore_key =~/k/) {
     `sudo cp /$pool/backup_appliance/web-gui/_log/appliance.log /var/web-gui/_log/`;
   }

   if (($restore_key eq "") || ($restore_key =~/n/)) {
       #cfg
       `sudo cp /$pool/backup_appliance/web-gui/_log/napp-it.cfg /var/web-gui/_log/`;

       #bonjour
       `sudo cp /$pool/backup_appliance/web-gui/_log/bonjour.sh /var/web-gui/_log/`;

      #autolock
      `sudo rm -r /var/web-gui/_log/autolock/* 2>/dev/null`;
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/autolock/* /var/web-gui/_log/autolock/  2>/dev/null`;

      #datamover
      `sudo rm -r /var/web-gui/_log/datamover/* 2>/dev/null`;
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/datamover/* /var/web-gui/_log/datamover/ 2>/dev/null`;

      # appliance group
      `sudo rm -r /var/web-gui/_log/group/* 2>/dev/null`;   # appliance group
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/group/* /var/web-gui/_log/group/ 2>/dev/null`;

      #jobs
      `sudo rm -r /var/web-gui/_log/jobs/* 2>/dev/null`;
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/jobs/* /var/web-gui/_log/jobs/ 2>/dev/null`;

      #maps
      `sudo rm -r /var/web-gui/_log/map/* 2>/dev/null`;
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/map/* /var/web-gui/_log/map/ 2>/dev/null`;

      #tunings
      `sudo rm -r /var/web-gui/_log/tunings/* 2>/dev/null`;
      `sudo cp -R /$pool/backup_appliance/web-gui/_log/tunings/* /var/web-gui/_log/tunings/ 2>/dev/null`;
   }

   `sudo /bin/chown -R napp-it /var/web-gui/_log/`;
   &bl_default_bkp_perm;      # set default perm
}

#####
sub bl_restore_idmap {
#####
  my ($r,@v);
  my $pool=$_[0];

  $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
  if ($r eq "2") { return();  }

  # remove old mappings
  `sudo /usr/sbin/idmap remove -a`;

   # load
   $r=`sudo cat /$pool/backup_appliance/settings/idmap.log`;
   @v=split(/\n/,$r);
   foreach my $v (@v) {
       if (!($v=~/^add/))               { next; }     # no info
       print " -- $v<br>\n";
       $v=~s/\s+/ /g;
       &exe("idmap $v");
   }
   return($r);
}


#####
sub bl_restore_user {                # unix user and groups
####
   my ($t,$r,$from,$to,@w,@l,@old,@new,$new,@user,$do,$ti,@v,$d,$g);
   my $pool=$_[0];

   $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
   if ($r eq "2") { return(); }

   # check folder
   $r=`sudo test -f /$pool/backup_appliance/etc/passwd_add && echo 1 || echo 2`;  chomp($r);
   if ($r eq "2") { return('user restore, no file /$pool/backup_appliance/etc/passwd_add'); }  # something went wrong

   $r=$_[1];  # ex 100-60000

   @w=split(/\-/,$r);
   $from=$w[0];
   $to=$w[1];

   if (!($from>100)) { $from=100; }          # no system user
   if (!($to>100))   { $to=60000; }
   print "restore uid $from\-$to<br>";

   $r="";

   ############
   #/etc/passwd
   $t=`sudo test -f /$pool/backup_appliance/etc/passwd_add && echo 1 || echo 2`;  chomp($t);
   if ($t eq "1") {
      #
      @new=(); @old=();
      $t=`sudo cat /etc/passwd`;
      @l=split(/\n/,$t);

      foreach my $l (@l) {
        if (!($l=~/:/)) { next; }
        @w=split(/:/,$l);                           # root:x:0:0:Super-User:/root:/usr/bin/bash
        if (($w[2]<$from) || ($w[2]>$to)) {
           push(@new,$l);                           # keep them
           push(@user,$w[0]);                       # failover list, keep user
        } # no failover user
      }

      # add new
       $t=`sudo cat /$pool/backup_appliance/etc/passwd_add`;
       @l=split(/\n/,$t);
       foreach my $l (@l) {
          if (!($l=~/:/)) { next; }
          @w=split(/:/,$l);
          if (($w[2]>=$from) && ($w[2]<=$to)) {
              push(@new,$l);                        # add them
          } # failover user
       }

      $t=join("\n",@new);

      # save new passwd to tmp
      $ti=time();
      if (@new > 0) {
        open (PF, ">/tmp/$ti.tmp");
           print PF "$t";
        close (PF);

        $r.=`sudo cp /tmp/$ti.tmp /etc/passwd`;     # with failover user
        $r.=`sudo rm /tmp/$ti.tmp`;
      }
   }


   ############
   #/etc/shadow
   $t=`sudo test -f /$pool/backup_appliance/etc/shadow_add && echo 1 || echo 2`;   chomp($t);
   if ($t eq "1") {
      #
      @new=(); @old=();
      $t=`sudo cat /etc/shadow`;
      @l=split(/\n/,$t);

      foreach my $l (@l) {
        if (!($l=~/:/)) { next; }
        @w=split(/:/,$l);                            # napp-it:NP:::::::

        $do="0";
        foreach my $u (@user) {                      # keep user
            if ($w[0] eq $u) { $do="1"; last; }      # keep this user
        }

        if ($do) {                                   # failover user
          push(@new,$l);                             # failover list
        } else {
          push(@old,$l);                             # skip them
        }
      }

       # add new
       $t=`sudo cat /$pool/backup_appliance/etc/shadow_add`;
       @l=split(/\n/,$t);
       foreach my $l (@l) {
          if (!($l=~/:/)) { next; }
          push(@new,$l);                             # add them
       }

      $t=join("\n",@new);

      # save shadow
      if (@new > 0) {
        $ti=time();
        open (PF, ">/tmp/$ti.tmp");
           print PF "$t";
        close (PF);

        $r.=`sudo cp /tmp/$ti.tmp /etc/shadow`;
        $r.=`sudo rm /tmp/$ti.tmp`;
      }
   }

   ############
   #/etc/group
   $t=`sudo test -f /$pool/backup_appliance/etc/group && echo 1 || echo 2`;  chomp($t);
   if ($t eq "1") {
      #
      @new=(); @old=();

      # add new
       $t=`sudo cat /$pool/backup_appliance/etc/group`;
       @l=split(/\n/,$t);
       foreach my $l (@l) {
          if (!($l=~/:/)) { next; }
          push(@new,$l);                             # add them
       }

      $t=join("\n",@new);

      # save new group to tmp
      if (@new > 0) {
        $ti=time();
        open (PF, ">/tmp/$ti.tmp");
           print PF "$t";
        close (PF);

        $r.=`sudo cp /tmp/$ti.tmp /etc/group`;
        $r.=`sudo rm /tmp/$ti.tmp`;
      }
   }


  #restore user from /var/smb/smbpasswd
  $t=`sudo test -f /$pool/backup_appliance/var/smb/smbpasswd && echo 1 || echo 2`;   chomp($t);
  if ($t eq "1") {
     #
     @new=(); @old=();  $new="";
     $t=`sudo cat /var/smb/smbpasswd`;
     @l=split(/\n/,$t);

     foreach my $l (@l) {
       if (!($l=~/:/)) { next; }
       @w=split(/:/,$l);                            # xx:102::

       $do="0";
       foreach my $u (@user) {                      # list of keep user
           if ($w[0] eq $u) { $do="1"; }            # keep this user
       }

       if ($do) {
         if (!($new=~/\b$l\b/)) {                   # already there
           if ((!($w[1]>=$from) && ($w[1]<=$to)) || ($w[0] eq "root")) {
              # failover user
              push(@new,$l);                        # failover list
           }
         }
         $new.="$l,";
       } else {
         push(@old,$l);                             # skip them
       }
     }

     # add new
     $new="";
     $t=`sudo cat /$pool/backup_appliance/var/smb/smbpasswd`;
     @l=split(/\n/,$t);
     foreach my $l (@l) {
         if (!($l=~/:/)) { next; }

         @w=split(/:/,$l);                          # xx:102::
         if (!($new=~/\b$l\b/)) {                   # already there
           if (($w[1]>=$from) && ($w[1]<=$to)) {
              push(@new,$l);                        # add them
           }
         }
         $new.="$l,";
     }

     $t=join("\n",@new);

     # save smbpasswd
     if (@new > 0) {
       $ti=time();
       open (PF, ">/tmp/$ti.tmp");
          print PF "$t";
       close (PF);

       $r.=`sudo cp /tmp/$ti.tmp /var/smb/smbpasswd`;
       $r.=`sudo rm /tmp/$ti.tmp`;
     }
   }
   ####

  $t=`sudo test -f /$pool/backup_appliance/var/smb/smbgroup.log && echo 1 || echo 2`;   chomp($t);
  if ($t eq "1") {

     ########### set current groups to default #############################
     print "<br><br>reset smbgroups to default<br>";

     $r.=`sudo /usr/sbin/smbadm show -m`;
     @v=split(/\n/,$r);

     # delete current non-default groups and remove all members
     foreach my $v (@v) {
             if (!($v=~/\w/))               { next; }     # no info
             if ($v=~/^\s/)                 { next; }     # not a groupname
             if ($v=~/^administrators\b/)   { next; }     # default group
             if ($v=~/^backup operators\b/) { next; }     # default group
             if ($v=~/^power users\b/)      { next; }     # default group

             #is a group to delete
             $v=~s/ \(.*//;
             print " -- delete current group $v\: ";
             print `sudo /usr/sbin/smbadm delete \'$v\'`;
             print "<br>";
     }

     # remove all members in default groups
     print "<br>remove members in default groups<br>";
     $r=`sudo /usr/sbin/smbadm show -m administrators`;
     $r=~s/\t/        /gs;
     @v=split(/\n/,$r);
     foreach my $v (@v) {
             if (!($v=~/\w/))              { next; }     # no info
             if ($v=~/^            /) {
                   $v=~s/\@.*//;
                   print " -- remove-member $v administrators\: ";
                   print `sudo /usr/sbin/smbadm remove-member -m $v administrators`;
                   print "<br>"
             }
             next;
     }

     $r=`sudo /usr/sbin/smbadm show -m 'backup operators'`;
     $r=~s/\t/        /gs;
     @v=split(/\n/,$r);
     foreach my $v (@v) {
             if (!($v=~/\w/))              { next; }     # no info
             if ($v=~/^            /) {
                   $v=~s/\@.*//;
                   print " -- remove-member $v 'backup operators': ";
                   print `sudo /usr/sbin/smbadm remove-member -m $v 'backup operators'`;
                   print "<br>"
             }
             next;
     }

     $r=`sudo /usr/sbin/smbadm show -m 'power users'`;
     $r=~s/\t/        /gs;
     @v=split(/\n/,$r);
     foreach my $v (@v) {
             if (!($v=~/\w/))              { next; }     # no info
             if ($v=~/^            /) {
                   $v=~s/\@.*//;
                   print " -- remove-member $v 'power users':";
                   print `sudo /usr/sbin/smbadm remove-member -m $v 'power users'`;
                   print "<br>"
             }
             next;
     }

     ######################### restore non-default groups and members ##########
     print "<br><br>restore non default group members<br>";
     $r=`sudo cat /$pool/backup_appliance/var/smb/smbgroup.log`;
     $r=~s/\t/        /gs;
     @v=split(/\n/,$r);

     # step 1, create groups
     foreach my $v (@v) {
             if (!($v=~/\w/))               { next; }     # no info
             if ($v=~/^\s/)                 { next; }     # not a groupname
             if ($v=~/^administrators\b/)   { next; }     # default group
             if ($v=~/^backup operators\b/) { next; }     # default group
             if ($v=~/^power users\b/)      { next; }     # default group

             print " -- restore group $v\: ";
             # description?
             if ($v=~/ \(/) {
                 $d=$v;
                 $d=~s/.*\(//;
                 $d=~s/\)//;
                 $v=~s/ \(.*//;
                 print `sudo /usr/sbin/smbadm create -d \'$d\' \'$v\'`;
             } else {
                 print `sudo /usr/sbin/smbadm create \'$v\'`;
             }
             print "<br>"
     }

     # setp 2, add members
     print "<br><br>restore members<br>";
     foreach my $v (@v) {
              if (!($v=~/\w/))               { next; }     # no info

              # groupname
              if (!($v=~/^\s/)) {
                  $g=$v;
                  $g=~s/ *\(.*//;           #  groupname only
              }

              #member?
              if ($v=~/^            /) {
                   $v=~s/\@.*//;        # name only
                   print " -- add-member $v \'$g\':";
                   print `sudo /usr/sbin/smbadm add-member -m $v \'$g\'`;
                   print "<br>"
              }
     }
  } else {
    print "no group log to restore";
  }
  return();

}


#####
sub bl_iscsi_save_base {
####
    my $pool=$_[0];

    my $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
    if ($r eq "2") { return("pool not mounted");  }

    # check if backup filesystem is available (adminlib), needed when backup target is a datapool
    if ($pool ne "rpool") {
      $t=&bl_check_appl_backup("$pool");
      if ($t ne "") { &mess($t); }
    }

    my $ti=time();
    $r=`/usr/sbin/svccfg export -a stmf > /tmp/$ti.bkp`;
    `sudo cp /tmp/$ti.bkp /$pool/backup_appliance/settings/COMSTAR-lastbackupjob.bkp`;  # like in menu save
    `sudo rm /tmp/$ti.bkp`;
    return($r);
}


#####
sub bl_save_idmap {
####
    my $pool=$_[0];

    my $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
    if ($r eq "2") { return("pool not mounted");  }

    # check if backup filesystem is available (adminlib), needed when backup target is a datapool
    if ($pool ne "rpool") {
      $t=&bl_check_appl_backup("$pool");
      if ($t ne "") { &mess($t); }
    }

    my $ti=time();
    $r=`sudo /usr/sbin/idmap list > /tmp/$ti.bkp`;
    `sudo cp /tmp/$ti.bkp /$pool/backup_appliance/settings/idmap.log`;
    `sudo rm /tmp/$ti.bkp`;
    return($r);
}


#####
sub bl_save_user {
#####
   my ($t,$r,@new,@old,@l,@w,$new,$ti,$from,$to,$pool,$userrange,@user,$do);

   $pool=$_[0];

   $userrange=$_[1];  # default 100-30000

   # check if backup filesystem is available (adminlib), needed when backup target is a datapool
   if ($pool ne "rpool") {

        $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($r);
        if ($r eq "2") { return("pool not mounted");  }

        $t=&bl_check_appl_backup("$pool");
        if ($t ne "") { &mess($t); }
   }

   $r="";

   # userrange
      @w=split(/\-/,$userrange);
      $from=$w[0];
      $to=$w[1];

      if (!($from>100))  { $from=100; }                       # defaults
      if (!($to>100))    { $to=60000; }
      $userrange="$from\-$to";

      #/etc/passwd, skip user < from
      @new=(); @old=();
      $t=`sudo cat /etc/passwd`;
      @l=split(/\n/,$t);

      foreach my $l (@l) {
             if (!($l=~/:/)) { next; }

             @w=split(/:/,$l);                            # root:x:0:0:Super-User:/root:/usr/bin/bash
             if (($w[2]>=$from) && ($w[2]<=$to)) {        # failover user ex 100-60000
               push(@new,$l);                             # failover list, whole line
               push(@user,$w[0]);                         # failover list, usernames
             } else {
               push(@old,$l);                             # skip them
             }
      }
      $t=join("\n",@new);

      # save additional user passwords
      $ti=time();
      if (@new > 0) {
               open (PF, ">/tmp/p$ti.tmp");
                     print PF "$t\n";
               close (PF);

               $r.=`sudo /bin/cp /tmp/p$ti.tmp /$pool/backup_appliance/etc/passwd_add`;
               $r.=`sudo /bin/rm /tmp/p$ti.tmp`;

               #userrange
               `sudo echo $userrange > /tmp/r$ti.tmp`;
               $r.=`sudo /bin/cp /tmp/r$ti.tmp /$pool/backup_appliance/etc/userrange.log`;
               $r.=`sudo /bin/rm /tmp/r$ti.tmp`;
      }

   ############
   #/etc/shadow
   ############

        @new=(); @old=();
        $t=`sudo cat /etc/shadow`;
        @l=split(/\n/,$t);

        foreach my $l (@l) {
          if (!($l=~/:/)) { next; }
          @w=split(/:/,$l);                            # napp-it:NP:::::::

          $do="0";
          foreach my $u (@user) {                      # list of failover user
              if ($w[0] eq $u) { $do="1"; last; }      # failover this user
          }

          if ($do) {        # failover user
            push(@new,$l);                             # failover list
          } else {
            push(@old,$l);                             # skip them
          }
        }

        $t=join("\n",@new);

        # save shadow to pool
        $ti=time();
        if (@new > 0) {
            open (PF, ">/tmp/s$ti.tmp");
                  print PF "$t\n";
            close (PF);

            $r.=`sudo /bin/cp /tmp/s$ti.tmp /$pool/backup_appliance/etc/shadow_add`;      # only new user from passwd
            $r.=`sudo /bin/rm /tmp/s$ti.tmp`;
        }
        ############

        #/etc/group
            ###########
            @new=(); @old=();
            $t=`sudo cat /etc/group`;
            @l=split(/\n/,$t);

            foreach my $l (@l) {
              if (!($l=~/:/)) { next; }                    # root::0:
              push(@new,$l);                               # failover list, whole line
            }
            $t=join("\n",@new);

            # save passwd
            $ti=time();
            if (@new > 0) {
                open (PF, ">/tmp/g$ti.tmp");
                      print PF "$t\n";
                close (PF);

                $r.=`sudo /bin/cp /tmp/g$ti.tmp /$pool/backup_appliance/etc/group`;
                $r.=`sudo /bin/rm /tmp/g$ti.tmp`;
            }

        #/var/smb/smbpasswd
            ##
            $t=`sudo test -f /var/smb/smbpasswd && echo 1 || echo 2`;      chomp($t);
            if ($t eq "1") {
               #
               @new=(); @old=();
               $t=`sudo cat /var/smb/smbpasswd`;
               @l=split(/\n/,$t);

               foreach my $l (@l) {
                 if (!($l=~/:/)) { next; }
                 @w=split(/:/,$l);                            # xx:102::

                 $do="0";
                 foreach my $u (@user) {                      # list of failover user
                     if ($w[0] eq $u) { $do="1"; last; }      # failover this user
                 }

                 if ($do) {        # failover user
                   push(@new,$l);                             # failover list
                 } else {
                   push(@old,$l);                             # skip them
                 }
               }
               $t=join("\n",@new);

               # save smbpasswd to pool
               $ti=time();
               if (@new > 0) {
                   open (PF, ">/tmp/s$ti.tmp");
                         print PF "$t\n";
                   close (PF);
                   $r.=`sudo /bin/cp /tmp/s$ti.tmp /$pool/backup_appliance/var/smb/smbpasswd`;
                   $r.=`sudo /bin/rm /tmp/s$ti.tmp`;
               }
            }

        ############### log smbgroup.db
            $ti=time();
            $r.=`sudo /usr/sbin/smbadm show -m > /tmp/$ti.tmp`;

            $r.=`sudo /bin/cp /tmp/$ti.tmp /$pool/backup_appliance/var/smb/smbgroup.log`;
            $r.=`sudo /bin/rm /tmp/$ti.tmp`;




        # other settings
            $t=`sudo test -f /etc/user_attr && echo 1 || echo 2`;      chomp($t);
           if ($t eq "1") {
              $r.=`sudo /usr/bin/cp -p /etc/user_attr /$pool/backup_appliance/etc/user_attr`;
           }
           return($r);

}

#####
sub bl_save_nappit {
#####
  my $pool=$_[0];

  $t=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;  chomp($t);
  if ($t eq "2") { return("pool not mounted"); }                                           # save to datapool

  my $fs="/$pool/backup_appliance";
  my $r=`sudo rm -r /$fs/web-gui/* 2>/dev/null`;              # delete old

  # check if backup filesystem is available (adminlib), needed when backup target is a datapool
  if ($pool ne "rpool") {
      $t=&bl_check_appl_backup("$pool");                      # create structure
      if ($t ne "") { &mess($t); }
  }


  # backup
     $r.=`sudo /bin/cp  -r /var/web-gui/_my/* /$pool/backup_appliance/web-gui/_my 2>/dev/null`;  # whole my folder

     $r.=`sudo /bin/cp  -r /var/web-gui/_log/autolock/* /$pool/backup_appliance/web-gui/_log/autolock 2>/dev/null`;  # whole my folder
     $r.=`sudo /bin/cp  -r /var/web-gui/_log/datamover/* /$pool/backup_appliance/web-gui/_log/datamover 2>/dev/null`;  # whole my folder
     $r.=`sudo /bin/cp  -r /var/web-gui/_log/group/* /$pool/backup_appliance/web-gui/_log/group 2>/dev/null`;  # whole my folder
     $r.=`sudo /bin/cp  -r /var/web-gui/_log/jobs/* /$pool/backup_appliance/web-gui/_log/jobs 2>/dev/null`;  # whole my folder
     $r.=`sudo /bin/cp  -r /var/web-gui/_log/maps/* /$pool/backup_appliance/web-gui/_log/maps 2>/dev/null`;  # whole my folder
     $r.=`sudo /bin/cp  -r /var/web-gui/_log/tunings/* /$pool/backup_appliance/web-gui/_log/tunings 2>/dev/null`;  # whole my folder

     # key
     $r.=`sudo /bin/cp /var/web-gui/_log/appliance.log /$pool/backup_appliance/web-gui/_log/ 2>/dev/null`;  # key
     $r.=`sudo /bin/cp /var/web-gui/_log/appliance.oldkey /$pool/backup_appliance/web-gui/_log/ 2>/dev/null`;  # oldkey

     #cfg /var/web-gui/_log/napp-it.cfg
     $r.=`sudo /bin/cp /var/web-gui/_log/napp-it.cfg /$pool/backup_appliance/web-gui/_log/ 2>/dev/null`;

     #bonjour  /var/web-gui/_log/bonjour.sh
     $r.=`sudo /bin/cp /var/web-gui/_log/bonjour.sh /$pool/backup_appliance/web-gui/_log/ 2>/dev/null`;

     # initfiles
     $r.=`sudo /bin/cp /etc/init.d/napp-it* /$pool/backup_appliance/etc/init.d/`;

}

#####
sub bl_check_appl_backup {
#####
# create appliance_backup, folder structure, set owner and perm to root
  my $pool=$_[0];
  my ($x,$r);

  if ($pool eq "rpool") { return; }

  # pool invalid or not mounted or other problem: return value=error
  if (!($pool=~/\w/))                     { return("no pool given"); }

  $t=`sudo /sbin/zpool list -H -o name`;
  if (!($t=~/\b$pool\b/s)) { return("not a mounted datapool ($pool)"); }

  #pool ok: check filesystem?
  $x=`sudo /sbin/zfs list | grep $pool/backup_appliance`; chomp($x);

  # create and verify
  if ($x eq "") {
      # if there is a regular folder, destroy
      $r=`sudo test -d /$pool/backup_appliance/ && echo 1 || echo 2`;   chomp($r);
      if ($r eq "1") { `sudo /bin/rm -fr /$pool/backup_appliance/`; }   # delete regular folder

       `sudo /sbin/zfs create $pool/backup_appliance`;
       $x=`sudo /sbin/zfs list | grep $pool/backup_appliance`; chomp($x);
       if ($x eq "") { return ("could not create backup_appliance"); }
  }

  # ok we have a zfs
  `sudo chmod 755 /$pool/backup_appliance 2>&1`;
  `sudo cp -r /var/web-gui/data/tools/b_stru/* /$pool/backup_appliance`;

  # chown to root and perm root
  &bl_default_bkp_perm($pool);
  return(""); #ok
}

#########################
sub bl_default_bkp_perm {
#########################
  my $pool=$_[0];
 `sudo /bin/chown -R root /$pool/backup_appliance 2>&1`;
 `sudo /bin/chmod 755 /$pool/backup_appliance 2>&1`;                         # backup folder 755
 `sudo /bin/chmod -R 755 /$pool/backup_appliance/cluster 2>&1`;              # backup folder/cluster 755
 `sudo /bin/chmod -R 755 /$pool/backup_appliance/settings 2>&1`;             # backup folder/settings 755 (idmap)
 `sudo /bin/chmod -R 700 /$pool/backup_appliance/etc 2>&1`;                  # backup folder/etc 700
 `sudo /bin/chmod -R 700 /$pool/backup_appliance/var 2>&1`;                  # backup folder/var 700

 `sudo /bin/chmod -R 755 /$pool/backup_appliance/web-gui 2>&1`;              # backup folder/web-gui 755
 `sudo /bin/chmod -R 700 /$pool/backup_appliance/web-gui/_log/group 2>&1`;        # group secrets 700
 `sudo /bin/chmod -R 700 /$pool/backup_appliance/web-gui/_log/iscsi 2>&1`;        # iscsi secrets 700
 `sudo /bin/chmod 700 /$pool/backup_appliance/web-gui/_log/napp-it.cfg 2> /dev/null`;     # admin pw 700, optional
}


sub bl_date {                #
###########
 my ($min,$hour,$mday,$sec,$mon,$year,$wday,$ydat,$isdat,$isdst);
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 return ("$year\.$mon\.$mday\.$hour\.$min\.$sec");
}


########################   clear must be executed prior restore
sub bl_iscsi_clear {
########################
  my (@l,$r,$sh,$f);
  my $exe_only=$_[0];   # ="" means do not display details

  # clear requires a restor.sh file
  $t=`sudo test -f /var/web-gui/_log/iscsi/restore.sh && echo 1 || echo 2`; chomp($t);

  #&mess($t);
  if ($t ne "1") {
     if ($exe_only ne "") {
       print "Clear not allowed when there is no restore file /var/web-gui/_log/iscsi/restore.sh<br>";
       return("error");
     }
     &mess("Clear not allowed when there is no restore file /var/web-gui/_log/iscsi/restore.sh<br>please run backup first!");
     &log_end; exit;
  }

  $t=&bl_date;
  $sh ="# Clear all Comstar settings\n# Date (dd.mm.yy): $t\n\n";
  $sh .="\necho 1._Logical_Units\n";
  ###


  # 1.delete lu
  $r=`sudo /usr/sbin/stmfadm list-lu`;  chomp($r);
  #[0] -> 'LU Name: 600144F070CC440000004C1549629476'
  #[1] -> 'LU Name: 600144F070CC440000004C1549632887'

  @t=split(/\n/,$r);
  foreach my $t (@t) {
     $t=~s/^.*: //;
     $sh.="/usr/sbin/stmfadm delete-lu $t\n";
  }

 $sh.="\necho 2._clear_target_portal_groups\n";
 #####################
 $r=`sudo /usr/sbin/itadm list-tpg | grep -v 'TARGET PORTAL'`;
 #tpg1      1
 #tpg2      1

 @t=split(/\n/,$r);
 foreach my $t (@t) {
     # delete members

     $t=~s/ .*//;
     $sh.="/usr/sbin/itadm delete-tpg -f $t\n";  # force
 }

 $sh.="\necho 3._clear_targets\n";
 ################################
 $r=`sudo /usr/sbin/stmfadm list-target`;
 # Target: iqn.2010-09.org.zfs-san:1550134537
 # Target: iqn.2010-09.org.zfs-san:1550151262

 @t=split(/\n/,$r);
 foreach my $t (@t) {
     $t=~s/^.*: //;
     $sh.="/usr/sbin/itadm delete-target -f $t\n";
 }


 $sh.="\necho 4._clear_client_initiators\n";
 ########################################
 $r=`sudo /usr/sbin/itadm list-initiator | grep -v INITIATOR`;
 # iqn.1986-03.com.sun:01.46f7e263                                       set
 # iqn.1986-03.com.sun:01.46f7e262                                       unset
 # iqn.1986-03.com.sun:01.46f7e262:1234                                  unset

 @t=split(/\n/,$r);
 foreach my $t (@t) {
     $t=~s/ .*//;
     $sh.="/usr/sbin/itadm delete-initiator $t\n";
 }

 $sh.="\necho 5/6._clear_target_groups\n";
 ################################
 $r=`sudo /usr/sbin/stmfadm list-tg`;
 chomp($r);
 # Target Group: tg1
 # Target Group: tg2


 @t=split(/\n/,$r);
 foreach my $t (@t) {
     $t=~s/^.*: //;
     $sh.="/usr/sbin/stmfadm delete-tg $t\n";
 }

$sh.="\necho 7/8._clear_host_groups\n";
####################################
 $r=`sudo /usr/sbin/stmfadm list-hg`;
 chomp($r);
 # Host Group: tg1
 # Host Group: tg2


 @t=split(/\n/,$r);
 foreach my $t (@t) {
     $t=~s/^.*: //;
     $sh.="/usr/sbin/stmfadm delete-hg $t\n";
 }

 $sh.="\necho 9._clear_views__already_cleared_in_1.\n";
 ###################################################

 if ($in{'checkbox_sim'} ne "") {
   print "<pre>Clear Actions (Simulation)<hr>\n\n$sh\n\n</pre>"; &log_end; exit;
 }

 # ok execute
 # write tmp
 $f=time();
 open (PF, ">/tmp/$f.ctmp");
    print PF "$sh";
 close (PF);

 ##
# print "<pre>cat /tmp/$f.ctmp<hr>"; `sudo cat /tmp/$f.ctmp`; #exit;

 print "<pre>\n";
 `sudo sh /tmp/$f.ctmp`;          # run clear
 print "</pre>";

 #exit;
 `rm /tmp/$f.ctmp`;               # del tmp

 if ($exe_only ne "") { return; } # just run, no relaad

 print "clear executed.";
 sleep(3);
 &reload;

}


########################
sub bl_iscsi_restore_full {
########################
my ($t,@t,$inv_date,$f,$r);
my $pool=$_[0];
my $version=$_[1];    # current, -[1-3]
my $exe_only=$_[2];   # ="" means do not print details and headers ex call by manual failover

if ($version eq "") { $version="current"; }   # default

# /var/web-gui/_log/iscsi/current/restore.sh
# /backup/backup_appliance/web-gui/_log/iscsi/current/restore.sh

my $path="";
my $path2="";
my $path3="";

#rpool
if ($pool =~/^rpool\b/) {
  $pool="rpool";
  $path="/var/web-gui/_log/iscsi";  # ../iscsi
} else {
  $path="/$pool/backup_appliance/web-gui/_log/iscsi";    # backup-appliance folder
  $path3="/$pool/backup_appliance";
}
$path2="$path/$version";

# current data (restore.sh and secrets in /iscsi, backups in /iscsi/current or iscsi/last-n)
# restore means copy data to /iscsi and restore from there

$f="$path2/restore.sh";
#&mess($f);

# restore.sh?
$t=`sudo test -f $f && echo 1 || echo 2`; chomp($t);
if ($t eq "1") {

     # step 1: clear
     print "<pre>Clear Comstar settings ";
     $r=&bl_iscsi_clear(1);         # exe only
     if ($r ne "") { return; }      # clear error

     # step 2: restore
     print "Restore Comstar settings<br>";

     if ($pool ne "rpool") {
       `sudo /bin/chmod -R 755 $path3`;                        # or cp gives an error
     }

     #del old active data
     `sudo rm /var/web-gui/_log/iscsi/restore.sh`;
     `sudo rm /var/web-gui/_log/iscsi/*chap 2> /dev/null`;     # secrets

     #restore active from backup
     `sudo cp $path2/* /var/web-gui/_log/iscsi/`;              # active restore.sh and secrets

     if ($exe_only eq "") {
         print "sh /var/web-gui/_log/iscsi/restore.sh<pre>";
         print `sudo sh /var/web-gui/_log/iscsi/restore.sh`;   # manual, show actions
     } else {
         print `sudo sh /var/web-gui/_log/iscsi/restore.sh > /dev/null`;  # failover, no actions
     }

     $f="done: restore.sh";

     if ($pool ne "rpool") {
       `sudo /bin/chmod -R 700 $path3`;                          # secure
     }

} else {
  if ($exe_only eq "") {
    print "Comstar restore: $f not found<br>";
  } else {
    &mess("Comstar restore: $f not found");
  }
  $f="";
}

return($f);

}

########################
sub bl_iscsi_backup_full {
########################
my ($t,@t,$w,@w,$sh,$r,$o,@l,$list,@list);
my $pool=$_[0];
my $exe_only=$_[1];  # exe only eq "" means print details and headlines
my $simulate=$_[2];  # simulate only (1)

if ($pool eq "") { $pool="rpool"; }  # default

# check if backup filesystem is available (adminlib), needed when backup target is a datapool
if ($pool ne "rpool") {
  $t=&bl_check_appl_backup("$pool");
  if ($t ne "") { print "$t"; return; }
}

$t=&bl_date;
$sh ="# Full Backup of all Comstar settings\n# Date (dd.mm.yy): $t\n";
$sh.="# to $in{'select_action'}\n\n";

# 1. sh to allow import logical units stmfadm create-lu -p guid=$g /dev/zvol/rdsk/$lu
######################################################################################

$r=`sudo /usr/sbin/stmfadm list-lu`;
# LU Name: 600144F070CC440000004C1549629476
# LU Name: 600144F070CC440000004C1549632887

@t=split(/\n/,$r);
$sh.="echo 1._restore_logical_units\n";
if ($exe_only eq "") { print "1._backup_logical_units<br>"; }

foreach my $t (@t) {
    # get details
    $t=~s/.* //;
    $r=`sudo /usr/sbin/stmfadm list-lu -v $t`;

    #Operational Status: Online
    #Provider Name     : sbd
    #Alias             : zraid-1/test2
    #View Entry Count  : 1
    #Data File         : /dev/zvol/rdsk/zraid-1/test2/iscsi_1549629476
    #Meta File         : not set
    #Size              : 1073741824
    #Block Size        : 512
    #Management URL    : not set
    #Vendor ID         : SUN
    #Product ID        : COMSTAR
    #Serial Num        : not set
    #Write Protect     : Disabled
    #Writeback Cache   : Enabled
    #Access State      : Active


    # vdev only
    if (!($r=~/\/dev\/zvol\/rdsk\//s)) { next; }

    # get zvol
    $r=`sudo /usr/sbin/stmfadm list-lu -v $t | grep 'Data File'`;
    chomp($r);
    $r=~s/.* : +//;

    $sh.="sudo /usr/sbin/stmfadm create-lu -p guid=$t $r\n";
}
$sh.="# /1.\n";


# 2. sh to restore tp groups
############################
$sh.="echo 2._restore_target_portal_groups\n";
if ($exe_only eq "") { print " 2._backup_target_portal_groups<br>";  }

$r=`sudo /usr/sbin/itadm list-tpg | grep -v 'TARGET PORTAL'`;

#TARGET PORTAL GROUP           PORTAL COUNT
#tpg2                          1
#tpg1                          1

# get portal
@l=split(/\n/,$r);

foreach my $l (@l) {
        $l=~s/ .*//;
        $r=`sudo /usr/sbin/itadm list-tpg -v $l | grep portals:`;
        chomp($r);

        #    portals:    172.16.111.44:3260         (single ip per group)

        $r=~s/.*portals:\s+//;
        $sh.="sudo /usr/sbin/itadm create-tpg $l $r\n";
}
$sh.="# /2.\n";

# 3. sh to allow import targets
###############################

$sh.="echo 3._restore_targets\n";
if ($exe_only eq "") { print "3._backup_targets<br>"; }

my ($auth,$user,$alias,$secret,$tpgtags,$tn);
$r=`sudo /usr/sbin/stmfadm list-target`;
#Target: iqn.2010-09.org.zfs-san:1550134537
#Target: iqn.2010-09.org.zfs-san:1549557077

@t=split(/\n/,$r);
$list=""; # list of secrets

$list="";
foreach my $t (@t) {
    # get details
    $t=~s/.* //;                          # target name
    $tn=$t;

    # auth=chap
    $r=`sudo /usr/sbin/itadm list-target -v $tn`;   # details like alias, auth etc
    $list.="$tn,";                                  # list of current targets

#debug
#&mess($r);

    #TARGET NAME                                                  STATE    SESSIONS
    #iqn.2010-09.org.napp-it:zraid-1:test3                        online   0
    #    alias:                      zraid-1/test3
    #    auth:                       none (defaults)
    #    targetchapuser:             -
    #    targetchapsecret:           unset
    #    tpg-tags:                   default

    $auth=""; $user=""; $alias=""; $secret=""; $tpgtags="default";
    @w=split(/\n/,$r);
    foreach my $w (@w) {
           if ($w=~/alias:/)         { $w=~s/.*://; $w=~s/\s+//g; $alias=$w;  }
           if ($w=~/auth:/)          { $w=~s/.*://; $w=~s/\s+//g;  if ($w=~/none/) { $w="none"; }  $auth=$w;   }
           if ($w=~/chapuser:\s+\w/) { $w=~s/.*://; $w=~s/\s+//g;$user=$w;   }
           if ($w=~/secret:/)        { $w=~s/.*://; $w=~s/\s+//;$secret=$w; }
           if ($w=~/tpg\-tags:/)     { $w=~s/.*://; $w=~s/ =.*//; $w=~s/\s+//g; $tpgtags=$w; }     #tpg1 = 2 -> tpg1
    }

#debug
#&mess($user);
#&mess($tpgtags);
#&print_array(@w);

    # sh to create this target
    $o="";
    if ($user ne "")        { $o.=" -u $user"; }
    if ($auth ne "")        { $o.=" -a $auth"; }         # ex chap

    # secret in path
    $t=`sudo test -f /var/web-gui/_log/iscsi/$tn\.tchap && echo 1 || echo 2`; chomp($t);
    if (($auth eq "chap") && ($t eq "1")) {
       $o.=" -S /var/web-gui/_log/iscsi/$tn\.tchap";
       $list.="$tn\.tchap,";  # list of secrets
    }
  #&mess($o);

    if ($alias ne "-")      { $o.=" -l $alias"; }
    if ($tpgtags ne "none") { $o.=" -t $tpgtags"; }

    $sh.="sudo /usr/sbin/itadm create-target$o -n $tn\n";

}   #/for

# check for secrets that are no longer needed
$r=`sudo ls -a /var/web-gui/_log/iscsi/*.tchap 2> /dev/null`;        # /var/web-gui/_log/iscsi/iqn.2010-09.org.zfs-san:1557740789.tchap
@list=split(/\n/,$r);

#&mess($list);
#print "-list-<hr>$list<br><br>";
#&print_array(@list);

foreach my $l (@list) {
  if (!($l=~/\.tchap/)) { next; }
  $l=~s/\.tchap$//;
  $l=~s/.*\///;         # target name only
  if ($list=~/$l/)      { next; }

  $l=~s/\.tchap//;
  `sudo rm /var/web-gui/_log/iscsi/$l.tchap`;
  print "rm obsolete /var/web-gui/_log/iscsi/$l.tchap<br>";
}

#&print_array(@list);

$sh.="# /3.\n";


# 4. add chap for client initiator like Windows,
###############################################

$sh.="echo 4._restore_client_initiators\n";
if ($exe_only eq "") {  print "4._backup_client_initiators<br>";  }

$r=`sudo /usr/sbin/itadm list-initiator | grep -v INITIATOR`;

# initiator                         chapuser    secret
# iqn.1986-03.com.sun:01.46f7e263   <none>      unset

@l=split(/\n/,$r);
# &print_array(@l);

$list=""; # list of initiator secrets
@list=();

foreach my $l (@l) {
        @w=();
        @w=split(/\s+/,$l);
        $list.="$w[0],";    # list of initiators

        #all initiators
        $user="";  $secret="";
        $o="";
        if (!($w[1]=~/none/)) { $o.=" -u $w[1]"; }

        # secret in path
         $t=`sudo test -f /var/web-gui/_log/iscsi/$w[0]\.ichap && echo 1 || echo 2`;   chomp($t);

        if ($t eq "1") {
           $o.=" -S /var/web-gui/_log/iscsi/$w[0]\.ichap";
        }
#&mess($o);
        $sh.="sudo /usr/sbin/itadm create-initiator$o $w[0]\n";
}

# check for secrets that are no longer needed
$t=`sudo ls -a /var/web-gui/_log/iscsi/*.ichap 2> /dev/null`;       # /var/web-gui/_log/iscsi/iqn.1991-05.com.microsoft:hostname1.ichap
@list=split(/\n/,$t);     # list of ichap files

#&mess($list);
#&print_array(@list);

foreach my $l (@list) {
  if (!($l=~/\.ichap/)) { next; }
  $l=~s/\.ichap$//;
  $l=~s/.*\///;         # initiator name only
  if ($list=~/$l/)      { next; }

  `sudo rm /var/web-gui/_log/iscsi/$l.ichap`;
  print "rm obsolete /var/web-gui/_log/iscsi/$l.ichap<br>";
}

#print "<hr>$list<hr>";
#&print_array(@list);

$sh.="# /4.\n";

# 5. sh to restore target groups
################################
$sh.="echo 5._restore_target_groups\n";
if ($exe_only eq "") {  print "5._backup_target_groups<br>"; }

$r=`sudo /usr/sbin/stmfadm list-tg`;
chomp($r);
# Target Group: tg1
# Target Group: tg2

@l=split(/\n/,$r);
foreach my $l (@l) {
    $l=~s/.*Group:\s+//;
    $sh.="sudo /usr/sbin/stmfadm create-tg $l\n";
}
$sh.="# /5.\n";


# 6. restore target group members
#################################
$sh.="echo 6._restore_target_group_members\n";
if ($exe_only eq "") { print "6._backup_target_groups_members<br>"; }

foreach my $l (@l) {        # target groups

$r=`sudo /usr/sbin/stmfadm list-tg -v $l | grep -v Group:`;
    chomp($r);

    #Target Group: tg1
    #    Member: iqn.2010-09.org.zfs-san:1549557077
    #    Member: iqn.2010-09.org.napp-it:zraid-1:test2


    # add member targets
    @w=split(/\n/,$r);
    foreach my $w (@w) {
      $w=~s/.*Member: +//s;
      $sh.="sudo /usr/sbin/stmfadm offline-target $w\n";        #must be offline
      $sh.="sudo /usr/sbin/stmfadm add-tg-member -g $l $w\n";
      $sh.="sudo /usr/sbin/stmfadm online-target $w\n";         #online
    }
}
$sh.="# /6.\n";


# 7. sh to restore host groups
##############################
$sh.="echo 7._restore_host_groups\n";
if ($exe_only eq "") {  print "7._backup_host_groups<br>"; }

$r=`sudo /usr/sbin/stmfadm list-hg`;
chomp($r);
# Host Group: hg1
# Host Group: hg2

@l=split(/\n/,$r);
foreach my $l (@l) {
    $l=~s/.*Group:\s+//;
    $sh.="sudo /usr/sbin/stmfadm create-hg $l\n";
}
$sh.="# /7.\n";


# 8. restore target group members
#################################
$sh.="echo 8._restore_host_group_members\n";
if ($exe_only eq "") {  print "8._backup_host_group_members<br>";  }

foreach my $l (@l) {        # target groups

$r=`sudo /usr/sbin/stmfadm list-hg -v $l | grep -v Group:`;
    chomp($r);

    #Host Group: tg1
    #    Member: iqn.2010-09.org.zfs-san:1549557077
    #    Member: iqn.2010-09.org.napp-it:zraid-1:test2


    # add member targets
    @w=split(/\n/,$r);
    foreach my $w (@w) {
      $w=~s/.*Member: +//s;
      $sh.="sudo /usr/sbin/stmfadm add-hg-member -g $l $w\n";
    }
}
$sh.="# /8.\n";


# 9. views
##########
my ($hg,$tg,$lun,$f);
$sh.="echo 9._restore_views\n";
if ($exe_only eq "") {  print "9._backup_views<br>"; }

$r=`sudo /usr/sbin/stmfadm list-lu`;
chomp($r);

# LU Name: 600144F070CC440000004C1549629476
# LU Name: 600144F070CC440000004C1549632887

# views for LU
@l=split(/\n/,$r);
foreach my $l (@l) {

    $l=~s/.*Name: +//;
#&mess($l);
    $r=`sudo /usr/sbin/stmfadm list-view -l $l 2>&1`;        # no views to restore
    if ($r=~/no views found/s) { next; }

#&mess($r);

    $r=`sudo /usr/sbin/stmfadm list-view -l $l`;      chomp($r);
    #View Entry: 0
    #    Host group   : hg1
    #    Target group : tg1
    #    LUN          : 0
    #View Entry: 1
    #    Host group   : hg1
    #    Target group : tg2
    #    LUN          : 44

    @w=split(/View Entry: /,$r);

    #[0] -> '0'
    #[1] -> '    Host group   : hg1'            # do not specify hg=all
    #[2] -> '    Target group : tg1'            # do not specify tg=all
    #[3] -> '    LUN          : 0'

    foreach my $w (@w) {
          if (!($w=~/\w/)) { next; }

          @t=split(/\n/,$w);
          $hg=""; $tg=""; $lun="";

          foreach my $t (@t) {
               if ($t=~/Host group/)   {  $t=~s/.* : //;  $hg=$t;  next; }
               if ($t=~/Target group/) {  $t=~s/.* : //;  $tg=$t;  next; }
               if ($t=~/LUN/)          {  $t=~s/.* : //;  $lun=$t; next; }
          }

          #&mess("$hg $tg $lun");
          #&print_array(@t);

          # add view for lu
          $o="";
          if (($hg ne "") && ($hg ne "All")) { $o.=" -h $hg"; }
          if (($tg ne "") && ($tg ne "All")) { $o.=" -t $tg"; }
          if ($lun ne "") { $o.=" -n $lun"; }

          $sh.="sudo /usr/sbin/stmfadm add-view$o $l\n";
    }

   # &print_array(@w);

}  #/@l
$sh.="# /9.\n";

if ($simulate ne "") {
  print "<pre>Restore Actions (<b>Simulation</b>)<hr>\n\n$sh\n\n</pre>"; &log_end; exit;
}

# write tmp
$f=time();
open (PF, ">/tmp/$f.itmp");
    print PF "$sh";
close (PF);


`sudo /bin/chmod -R 755 /var/web-gui/_log/iscsi/`;               # or cp give problems

# copy always to /var/web-gui/_log/iscsi/restore.sh              # active data
`sudo cp /tmp/$f.itmp /var/web-gui/_log/iscsi/restore.sh`;
`sudo rm /tmp/$f.itmp 2>&1`;

# keep last three restore files and secrets
# current (backup) version in ../iscsi/current
# former in ../iscsi/last-n (n=1-3)

$t=`sudo test -d /var/web-gui/_log/iscsi/last-3 && echo 1 || echo 2`; chomp($t);
if ($t eq "2") { `sudo mkdir /var/web-gui/_log/iscsi/last-3`; }

$t=`sudo test -d /var/web-gui/_log/iscsi/last-2 && echo 1 || echo 2`; chomp($t);
if ($t eq "2") { `sudo mkdir /var/web-gui/_log/iscsi/last-2`; }

$t=`sudo test -d /var/web-gui/_log/iscsi/last-1 && echo 1 || echo 2`; chomp($t);
if ($t eq "2") { `sudo mkdir /var/web-gui/_log/iscsi/last-1`; }

$t=`sudo test -d /var/web-gui/_log/iscsi/current && echo 1 || echo 2`; chomp($t);
if ($t eq "2") { `sudo mkdir /var/web-gui/_log/iscsi/current`; }

# step 1: delete -3
$t=`sudo test -f /var/web-gui/_log/iscsi/last-3/restore.sh && echo 1 || echo 2`; chomp($t);
if ($t eq "1") { `sudo /bin/rm /var/web-gui/_log/iscsi/last-3/*`; }

# step2: move 2->3 and 1->2 and default -> 1
`sudo mv /var/web-gui/_log/iscsi/last-2/* /var/web-gui/_log/iscsi/last-3/ 2>&1`;
`sudo mv /var/web-gui/_log/iscsi/last-1/* /var/web-gui/_log/iscsi/last-2/ 2>&1`;

#step3: delete current and copy from /iscsi
`sudo cp /var/web-gui/_log/iscsi/current/* /var/web-gui/_log/iscsi/last-1/`;

# copy always to /var/web-gui/_log/iscsi/restore.sh
`sudo rm /var/web-gui/_log/iscsi/current/* 2> /dev/null`;
`sudo cp /var/web-gui/_log/iscsi/restore.sh /var/web-gui/_log/iscsi/current/`;            #
`sudo cp /var/web-gui/_log/iscsi/*chap /var/web-gui/_log/iscsi/current/ 2> /dev/null`;

if ($pool ne "rpool") {

      #rm last
      $t=`sudo test -d /$pool/backup_appliance/web-gui/_log/iscsi && echo 1 || echo 2`; chomp($t);
      if ($t eq "1") {
        `sudo /bin/chmod -R 755 /$pool/backup_appliance`;                 # 755 otherwise copy problem
        `sudo rm /$pool/backup_appliance/web-gui/_log/iscsi/current/* 2>/dev/null`;
        `sudo rm /$pool/backup_appliance/web-gui/_log/iscsi/last-3/* 2>/dev/null`;
        `sudo rm /$pool/backup_appliance/web-gui/_log/iscsi/last-2/* 2>/dev/null`;
        `sudo rm /$pool/backup_appliance/web-gui/_log/iscsi/last-1/* 2>/dev/null`;

        # copy all iscsi data additionally to this pool
       `sudo cp /var/web-gui/_log/iscsi/current/* /$pool/backup_appliance/web-gui/_log/iscsi/current/`;
       `sudo cp /var/web-gui/_log/iscsi/last-1/* /$pool/backup_appliance/web-gui/_log/iscsi/last-1/`;
       `sudo cp /var/web-gui/_log/iscsi/last-2/* /$pool/backup_appliance/web-gui/_log/iscsi/last-2/`;
       `sudo cp /var/web-gui/_log/iscsi/last-3/* /$pool/backup_appliance/web-gui/_log/iscsi/last-3/`;

      # backup: owner root
      print `sudo /bin/chown -R root /$pool/backup_appliance/`;           # protect
      print `sudo /bin/chmod -R 700 /$pool/backup_appliance/`;            # always

      } else {
        print "/$pool/backup_appliance/web-gui/_log/iscsi/ not found!<br>";
      }
}

print "<br>";
print `sudo /bin/chown -R napp-it /var/web-gui/_log/iscsi/`;    # always
print `sudo /bin/chmod -R 700 /var/web-gui/_log/iscsi/`;        # always

if ($exe_only eq "") { return(); }                              # ex call by manual failover
return ($sh);

} # end sub
                                                                                                                                                                                         sub bl_do { my $exe_only=$_[0]; if (($exe_only eq "") && (!($cfg{'ver'} =~/c/))) { print "Comstar HA save/restore requires a Pro complete license"; &log_end; exit; }}


##
1;
