# lib for soap actions
use strict;

#saop lib 04.apr 2023

# parameter
# $in{'autoselect_host'}         host
# $in{'value_user'}             user and pw from System > ESXI > serverlist
# $in{'value_pass'}
# $in{'autoselect_vid'}         vm id
# $in{'select_mem'}             snap option
# $in{'autoselect_moid'}        datastore


#############
sub my_data {      # get summary
#############

   &my_read_serverlist;             # read user, pw for host

   my $soapcmd="perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/esxi/VMware_SOAP.pl";
   my ($par,$r,@snaps,@moid,@m,@n,@p,@v,@s,@data,$ds_id,$ds_name,$ds_type,$ds_status,$vm_id,$vm_name,$vm_last,$vm_status,@snap,$snap_id,$snap_current,$snap_name,$snap_desc,$snap_created,$snap_state,$snap_quiesced);

   $par="summary --plain --host $in{'autoselect_host'} --user $in{'value_user'} --password $in{'value_pass'}";

   $r=`sudo $soapcmd $par`;

   #debug only
   #&print_hash(%in);
   #&mess("$par<hr>$r");

   #per datastore
   @moid=split(/MOID: +/,$r); # data per datastore
   shift @moid;               # values start with $moid[1]
#&print_array(@moid);         # debug

   @t=sort(@moid);            # sort datastores
   @moid=();

   # Header
   push (@data,"<b>Host</b>\t<b>DataStore id</b>\t<b>DS type</b>\t<b>DS state</b>\t<b>VM id</b>\t<b>VM Name</b>\t<b>VM state</b>\t<b>Snap current</b>\t<b>Snap ID</b>\t<b>Snap name</b>\t<b>Snap desc</b>\t<b>Snap created</b>\t<b>Snap state</b>\t<b>Snap quiesced</b>");

   # all datastores or selected one
   $t=quotemeta($in{'autoselect_moid'});            # quote . / or -
   foreach my $m (@t) {
           $m=~s/\"//gs;                                                  # "values"
           if ($in{'autoselect_moid'} ne "*") {                           # all or selected datastore
               if ($m=~/^$t/) { push (@moid,$m); next; }                  # selected one
           }   else {
                 push (@moid,$m); next;
           }
   }
   #&print_array(@moid);              # debug, show datastores

   # Data per VM
   foreach my $m (@moid) {

           @v=split(/<VM>/,$m);    # Data per VM
#&print_array(@v);       # debug, vm details
           #
           #v[0] -> '192.168.2.203:/nvme/nfs ; Name: 192.168.2.203_nvme_nfs ; Type: NFS ; Status: green\n  |  |\n  |  |-'
           #v[1] -> 'ID: 10 ; Name: solaris11.4cbe ; State: green\n  |  |  |-<Snapshot current>10-snapshot-36</Snapshot current>\n  |  |  |  |-<Snapshot Tree>\n  |  |  |  |  |-<Snapshot>ID:   10-snapshot-36\n  |  |  |  |  |  |-Name:        2023-02-26 10:21:09\n  |  |  |  |  |  |-Description: \n  |  |  |  |  |  |-Created:     2023-02-26 @ 09:19:33 \n  |  |  |  |  |  |-State:       poweredOn\n  |  |  |  |  |  |-Quiesced:    false\n  |  |  |  |  | </Snapshot>\n  |  |  |  |  |\n  |  |  |  |  |-<Snapshot>ID:   10-snapshot-35\n  |  |  |  |  |  |-Name:        2023-02-26 10:19:05\n  |  |  |  |  |  |-Description: \n  |  |  |  |  |  |-Created:     2023-02-26 @ 09:17:28 \n  |  |  |  |  |  |-State:       poweredOn\n  |  |  |  |  |  |-Quiesced:    false\n  |  |  |  |  | </Snapshot>\n  |  |  |  |  |\n  |  |  |  |  |-<Snapshot>ID:   10-snapshot-34\n  |  |  |  |  |  |-Name:        2023-02-26 10:17:40\n  |  |  |  |  |  |-Description: \n  |  |  |  |  |  |-Created:     2023-02-26 @ 09:16:03 \n  |  |  |  |  |  |-State:       poweredOn\n  |  |  |  |  |  |-Quiesced:    false\n  |  |  |  |  | </Snapshot>\n  |  |  |  |  |\n  |  |  |  | </Snapshot Tree>\n  |  | </VM>\n  |  |\n  |  |-'
           #v[2] -> 'ID: 11 ; Name: w2019.125 ; State: green\n  |  |  |- No Snapshot available\n  |  | </VM>\n  |  |\n  |  |-'
           #v[3] -> 'ID: 12 ; Name: oi10.2022 ; State: gray\n  |  |  |- No Snapshot available\n  |  | </VM>\n  |  |\n  |  |-'

           #get moid,name,type,status

           @n=split(/ ; /,$v[0]);

           # n[0] -> '192.168.2.203:/nvme/nfs'                  # moid
           # n[1] -> 'Name: 192.168.2.203_nvme_nfs'
           # n[2] -> 'Type: NFS'
           # n[3] -> 'Status: green\n  |  |\n '

#&print_array(@n);              # debug, vm details
           $ds_id=$n[0];
           $ds_name=$n[1];    $ds_name=~s/Name: //;
           $ds_type=$n[2];    $ds_type=~s/Type: //;
           $ds_status=$n[3];  $ds_status=~s/Status: //;  $ds_status=~s/\n.*//s;

           shift @v;                 # vms start with $v[1]
#&print_array(@v);        # debug, vms

           #get info and snaps per vm
           foreach my $v (@v) {

              @p=split(/\<Snapshot/,$v);             # vm, current, snaps

              #p[0] -> 'ID: 10 ; Name: solaris11.4cbe ; State green\n  |  |  |-'
              #p[1] -> ' current>10-snapshot-9</Snapshot current>\n  |  |  |  |-'
              #p[2] -> ' Tree>\n  |  |  |  |  |-'
              #p[3] -> '>ID:   10-snapshot-9\n  |  |  |  |  |  |-Name:        zweite\n  |  |  |  |  |  |-Description: esxi web ui\n  |  |  |  |  |  |-Created:     2023-02-24 @ 19:36:09 \n  |  |  |  |  |  |-State:       poweredOn\n  |  |  |  |  |  |-Quiesced:    false\n  |  |  |  |  | </Snapshot>\n  |  |  |  |  |\n  |  |  |  |  |-'
              #p[4] -> '>ID:   10-snapshot-8\n  |  |  |  |  |  |-Name:        2023-02-24 20:33:32\


#&print_array(@p);        # debug, vm parameter + snaps
#&print_var($p[0]);
              $p[0]=~s/\n.*//s;
              $vm_id=$p[0];     $vm_id=~s/.*ID: //;        $vm_id=~s/ *;.*//s;
              $vm_name=$p[0];   $vm_name=~s/.*Name: //;    $vm_name=~s/ *;.*//s;
              $vm_status=$p[0]; $vm_status=~s/.*State *//; $vm_status=~s/[^a-z]//g;
#&print_var($vm_status);

              #no snapshot
              if ($v=~/No Snapshot/s) {
                 push (@data,"$in{'autoselect_host'}\t$ds_id\t$ds_type\t$ds_status\t$vm_id\t$vm_name\t$vm_status\tNo snapshot");
                 push (@data,"");    # extra line between VMs
                 next; # next vm
              }

              shift @p;               # remove VM info

              foreach my $p (@p) {
                  if(!($p=~/ID:|current\>/)) { next; }
                  #
                  $snap_id="";
                  $snap_current="";
                  $snap_name="";
                  $snap_desc="";
                  $snap_created="";
                  $snap_state="";
                  $snap_quiesced="";

                  # get current
                  if ($p=~/current\>/) {
                       $p=~s/\n.*//s;
                       $snap_current=$p;
                       $snap_current=~s/\<\/Snapshot current.*//s;
                       $snap_current=~s/.*current\>//s;
                  }


                  @snap=split(/\|\-/,$p);   # snap details

                  #snap[0] -> '>ID:   10-snapshot-9\n  |  |  |  |  |  '
                  #snap[1] -> 'Name:        zweite\n  |  |  |  |  |  '
                  #snap[2] -> 'Description: esxi web ui\n  |  |  |  |  |  '
                  #snap[3] -> 'Created:     2023-02-24 @ 19:36:09 \n  |  |  |  |  |  '
                  #snap[4] -> 'State:       poweredOn\n  |  |  |  |  |  '
                  #snap[5] -> 'Quiesced:    false\n  |  |  |

#&print_array(@snap);        # debug, snap array



                  foreach my $t (@snap) {
                          $t=~s/ *\n.*//s;
                          if ($t=~/:/) {
                              if ($t=~/ID:/)            { $t=~s/.*ID: *//;        $snap_id=$t;       }
                              if ($t=~/^Name:/)         { $t=~s/Name: *//;        $snap_name=$t;     }
                              if ($t=~/^Description:/)  { $t=~s/Description: *//; $snap_desc=$t;     }
                              if ($t=~/^Created:/)      { $t=~s/Created: *//;     $snap_created=$t;  }
                              if ($t=~/^State:/)        { $t=~s/State: *//;       $snap_state=$t;    }
                              if ($t=~/^Quiesced:/)     { $t=~s/Quiesced: *//;    $snap_quiesced=$t;  }
                              next;
                          }
                  } #/snap

#&print_var($snap_id);
#&print_var($snap_current);

                  #push (@data,"Host\tDatastore id\tDatastore name\tDatastore type\tDatastore state\tVM id\tVM Name\tVM status\tSnap current\tSnap ID\tSnap name\tSnap desc\tSnap created\tSnap state\tSnap quiesced");
                  push (@data,"$in{'autoselect_host'}\t$ds_id\t$ds_type\t$ds_status\t$vm_id\t$vm_name\t$vm_status\t$snap_current\t$snap_id\t$snap_name\t$snap_desc\t$snap_created\t$snap_state\t$snap_quiesced");
               } #/p
               push (@data,"");         #line between VMs
           }  #/v
           push (@data,""); # line between datastores
    } #/moid

   #&print_array(@data);
   return (@data);
}

########################
sub my_read_serverlist {
#######################

  my $ok="0";
  my $p=`sudo cat /var/web-gui/_log/esxi-webconsole.txt`;    chomp($p);   # ip root pw moidcommalist
  @t=split(/\n/,$p);

  foreach my $t (@t) {
         @p=split(/ +/,$t);
         if ($in{'autoselect_host'} eq $p[0]) {
             $in{'select_host'}=$in{'autoselect_host'};  # for ssh no autoselect
             $in{'value_user'}=$p[1];
             $in{'value_pass'}=$p[2];
             $in{'moids'}=$p[3];                # optional nfs datastores from serverlist (soap) or ssh
             $ok="1";
             # $in{'opt'} with mqp in job-esxisnap, p=soap, m=mem, q=quiesce
         }
  }

  #host, user,password always
  if ($ok eq "0")                   { print "serverlist, host not found \n"; exit; }
  if ($in{'autoselect_host'} eq "") { print "serverlist, missing: host \n"; exit; }
  if ($in{'value_user'} eq "")      { print "serverlist host $in{'autoselect_host'}, missing: user \n"; exit; }
  if ($in{'value_pass'} eq "")      { print "serverlisthost $in{'autoselect_host'}, missing: pw \n";   exit; }

  #debug
  #print "$in{'value_user'} $in{'value_pass'}\n";
}

###############     par output string
sub my_colors {
##############
my $r=$_[0];

     $r=~s/\bred\b/<b style=\"color:Red\">red<\/b>/gs;
     $r=~s/\borange\b/<b style=\"color:DarkOrange\">orange<\/b>/gs;
     $r=~s/\byellow\b/<b style=\"color:orange\">yellow<\/b>/gs;
     $r=~s/\bblue\b/<b style=\"color:Blue\">blue<\/b>/gs;
     $r=~s/\bgreen\b/<b style=\"color:Green\">green<\/b>/gs;
     $r=~s/\bgray\b/<b style=\"color:Gray\">gray<\/b>/gs;

     $r=~s/Successfully /<b style=\"color:Green\">Successfully<\/b> /gs;

#&mess($r);
     return($r);
}


###################
sub my_mass_create_snaps_moids {         # multiple moid
##################
   #my @p=&my_data;                      # all data
   #&print_array(@p);
   my $r;

   &my_read_serverlist;                  # ip root pw moids
   my @moids=split(/,/,$in{'moids'});

   foreach my $m (@moids) {
        if ($m eq "") { next; }
        $in{'autoselect_moid'}=$m;
        @p=&my_data;
        $r.=&my_mass_create_snaps(@p);
   }
   return($r);
   #&print_array(@moids);
}

###################
sub my_mass_remove_snaps_moids {         # multiple moid
##################
   #my @p=&my_data;                      # all data
   #&print_array(@p);
   my $r;

   &my_read_serverlist;                  # ip root pw moids
   my @moids=split(/,/,$in{'moids'});

   foreach my $m (@moids) {
        if ($m eq "") { next; }
        $in{'autoselect_moid'}=$m;
        @p=&my_data;
        $r.=&my_mass_remove_all_snaps(@p);
   }
   return($r);
   #&print_array(@moids);
}

###################
sub my_mass_remove_all_snaps {
##################
    my @p= @_;   # data
    my (@list,$p,@t,$t,$last,$c,$m,$r,$sleep);

    $sleep="6";

    &my_read_serverlist;          #get user,pw, opt datastores for selected host
    #&print_hash(%in);            #debug

    my $cmd="sudo perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/esxi/VMware_SOAP.pl";

    #host,moid,type,status,vmid,vmname,vmstatus,currentsnap,snap,..        #data
    #   0    1    2      3    4      5        6           7    8

    #get list
    foreach my $p (@p) {
      @t=split(/\t/,$p);
      if ($p eq "") { next; }        # empty line
      if ($in{'autoselect_moid'} ne "*") {
           if ($in{'autoselect_moid'} ne $t[1]) { next; }        # not moid
      }

      if ($t[7] eq "No snapshot")  { next; }                     # no snaps
      if ($t[8] eq "")             { next; }                     # only current

      push(@list,"$t[0]\t$t[1]\t$t[4]\t$in{'value_user'}\t$in{'value_pass'}\t$t[8]");           #host,moid,vmid,name,pass,snap
      $last=$t[4];          # last vm
    }

#&print_array(@list);        #debug

    foreach my $l (@list) {
            @t=split(/\t/,$l);
            $c="$cmd remove_snapshot --plain --host $t[0] --moid $t[1] --vm_id $t[2] --user $t[3] --password $t[4] --snapid $t[5]";
            $r=`$c`;
            $r=~s/\s/ /gs;
            $m.="remove_snapshot --host $t[0] --moid $t[1] --vm_id $t[2] --snapid $t[5]\t$r\n";
            sleep($sleep);
    }

    if ($m eq "") { $m="none"; }

    if ($in{'id'} ne "") {
      $m="<b style='margin-right:600px'>Action</b>\t<b>Result</b>\n$m";
      print &list2table($m);
      print "<br>";
    }
    return($m);
    #&print_array(@list);

}


###################
sub my_mass_remove_current_snaps {
##################
    my @p= @_;   # data
    my (@list,$p,@t,$t,$last,$c,$m,$r);

    &my_read_serverlist;          #get user,pw
    #&print_hash(%in);            #debug

    my $cmd="sudo perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/esxi/VMware_SOAP.pl";

    #host,moid,type,status,vmid,vmname,vmstatus,currentsnap,snap,..        #data
    #   0    1    2      3    4      5        6           7    8

    #get list
    foreach my $p (@p) {
      @t=split(/\t/,$p);
      if ($p eq "") { next; }        # empty line
      if ($in{'autoselect_moid'} ne "*") {
           if ($in{'autoselect_moid'} ne $t[1]) { next; }        # not moid
      }

      if ($t[7] eq "No snapshot") { next; }                      # no snaps
      if ($t[7] eq "") { next; }                                 # only current

      push(@list,"$t[0]\t$t[1]\t$t[4]\t$in{'value_user'}\t$in{'value_pass'}\t$t[7]");           #host,moid,vmid,name,pass,snap
      $last=$t[4];
    }

#&print_array(@list);

    foreach my $l (@list) {
            @t=split(/\t/,$l);
            $c="$cmd remove_snapshot --host $t[0] --moid $t[1] --vm_id $t[2] --user $t[3] --password $t[4] --snapid $t[5]";
            $r=`$c`;
            $r=~s/\s/ /gs;

            $m.="create_snapshot --host $t[0] --moid $t[1] --vm_id $t[2] --snapid $t[5]\t$r\n";
    }

    if ($in{'id'} ne "") {
       print "$in{'autoselect_host'}, $in{'autoselect_moid'}<br>";
       $m="<b>Action</b>\t<b>Result</b>\n$m";
       print &list2table($m);
       print "<br>";
    }
    return($m);

    #&print_array(@list);
}


###################
sub my_mass_create_snaps {
##################
    my @p= @_;   # data
    my (@list,$p,@t,$t,$last,$c,$m,$r,$m,$sleep,$opt);
    $sleep="4";           # default

    &my_read_serverlist;          #get user,pw
    #&print_hash(%in);            #debug

    $opt=" --snapdesc autosnap";                      # --desc --quiesce --mem
    if ($in{'opt'}=~/m/) { $opt=" --mem"; }
    if ($in{'opt'}=~/q/) { $opt.=" --quiesce"; }

    my $cmd="sudo perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/esxi/VMware_SOAP.pl";

    #host,moid,type,status,vmid,vmname,vmstatus,currentsnap,snap,..        #data
    #   0    1    2      3    4      5        6           7    8

    #get list
    foreach my $p (@p) {
      @t=split(/\t/,$p);
      if ($p eq "") { next; }        # empty line
      if ($in{'autoselect_moid'} ne "*") {
           if ($in{'autoselect_moid'} ne $t[1]) { next; }        # not moid
      }
      if ($last eq $t[4]) { next; }                              # vm already listed

      push(@list,"$t[0]\t$t[1]\t$t[4]\t$in{'value_user'}\t$in{'value_pass'}");           #host,moid,vmid,name,pass
      $last=$t[4];
    }

    foreach my $l (@list) {
            @t=split(/\t/,$l);
            $c="$cmd create_snapshot --plain --host $t[0] --moid $t[1] --vm_id $t[2] --user $t[3] --password $t[4] $opt";
            $r=`$c`;
            $r=~s/\s/ /gs;

            $m.="create_snapshot --plain --host $t[0] --moid $t[1] --vm_id $t[2] $opt\t$r\n";
            sleep($sleep);
    }

    if ($in{'id'} ne "") {
      print "$in{'autoselect_host'}, $in{'autoselect_moid'}<br>";
      $m="<b style='margin-right:600px'>Action</b>\t<b>Result</b>\n$m";
      print &list2table($m);
      print "<br>";
    }
    return($m);
    #&print_array(@list);
}

###################   for get data
sub my_table {
##################
    my @p= @_;   # data
    my $t=join("\n",@p);

        $t.=<<EoF;
<pre><b>Datastore Color States</b>
Status: red    critical event
Status:orange: major event
Status: blue:  unknown
Status: green: ok

<b>VM Color heartbeat states</b>
State: grey:   VMware tools not installed or not running
State: red:    no heartbeat. Guest operating system may have stopped responding
State: yellow: intermittent heartbeat. May be caused by heavy guest OS usage
State: green:  ok </pre>
EoF

    $t=&my_colors($t);
    print &list2table($t);


    return;


}


# eoF
1;
