# lib for esxi ssh actions
use strict;

#ssh lib 29.apr 2023


###################
sub ssh_remove_current  {                   # remove current=last snap  on selected vmid only
################## vim-cmd vmsvc/snapshot.remove [VmId] [snapshotId]

       my $vm=$_[0];
       my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
       my $s=&get_last_snap($vm);

       print "(15) ssh -l root $ip vim-cmd vmsvc/snapshot.remove $vm $s<br>\n";
       $t=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.remove $vm $s`;
       if ($t=~/Remove/) { $t='Remove Snapshot';  }    # success
       return ($t);
}

###################
sub ssh_last_remove {        # remove last snaps from all VMs on $in{'select_fs'}
##################
    # vim-cmd vmsvc/snapshot.removeall VMID
    # ex vim-cmd vmsvc/snapshot.remove 10
    #&mess("remove last");

    my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
    my (@v,$p,@t,$t,$last,$c,$m,$r,$m,$sleep,$m,$q,$q,$c1,$c2,$s);

    # from jobsettings or esxi_ip ex 4mq
    # $in{'select_create'} -> mem quiesce (boolean)

    #get vms on selected nfs
    $r=&ssh_nfs_vms('');     # list of vms ex:  10     _solaris11.4cbe.120   [192.168.2.203_nvme_nfs] solaris11.4cbe/solaris11.4cbe.vmx
#&mess($r);

   #print "vms: $r\n";
    @v=split(/\n/,$r);
    $r="";

    $c1=0; $c2=0;

#&mess("$sleep,$m,$q<hr>$r");
#&print_array(@v);

    foreach my $v (@v) {            #
         if (!($v=~/\[/)) { next; } # no path
         $t=$v; $t=~s/\s.*//;       # vmid

         $c1++;              # count snap/vm requ
         #last snap nr
         $s=&get_last_snap($t);
         if ($s > 0) {
            #
            #remove snap, ssh -l root 192.168.2.48 vim-cmd vmsvc/snapshot.remove vmid snapid
            print "(53) ssh -l root $ip vim-cmd vmsvc/snapshot.remove $t $s<br>\n";
            $t=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.remove $t $s`;
         } else {
            print "No Snap on vmid $t<br>\n";
         }
         if ($t=~/Remove/) { $c2++; }    # success
         #$r.=$t;
    }
    $t="ESXi ssh snaps removed: $c1 ; Successfull: $c2";
    return($t);
}

###################
sub ssh_autojob_remove {        # remove all autojob (description) snaps from all VMs on $in{'select_fs'}
##################

    # vim-cmd vmsvc/snapshot.removeall VMID
    # ex vim-cmd vmsvc/snapshot.removeall 10

    my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
    my (@v,@s,$p,@t,$t,$last,$c,$m,$r,$m,$sleep,$m,$q,$q,$c1,$c2,$vmid);

    # from jobsettings or esxi_ip ex 4mq
    # $in{'select_create'} -> mem quiesce (boolean)

    #get vms on selected nfs
    $r=&ssh_nfs_vms;
    @v=split(/\n/,$r);
    $r="";

    $c1=0; $c2=0;

#&mess("$sleep,$m,$q<hr>$r");
#&print_array(@v);

    foreach my $v (@v) {            # each vm
         if (!($v=~/\[/)) { next; } # no path
         $vmid=$v; $vmid=~s/\s.*//;       # vmid

         $c1++;              # count snap/vm requ

         # get all snaps from vm
         print "vim-cmd vmsvc/snapshot.get $vmid (desc=autosnap)<br>\n";
         $r=`sudo ssh -l root $ip vim-cmd "vmsvc/snapshot.get $vmid"`; chomp($t);

         @t=split(/Snapshot Name/,$r);
         #[0] -> 'Get Snapshot:\n|-ROOT\n--'
         #[1] -> '        : ssh\n--Snapshot Id        : 190\n--Snapshot Desciption  : autosnap\n--Snapshot Created On  : 4/29/2023 8:0:49\n--Snapshot State       : powered off\n--|-CHILD\n----'
         #[2] -> '        : ssh\n----Snapshot Id        : 191\n----Snapshot Desciption  : autosnap\n----Snapshot Created On  : 4/29/2023 8:1:13\n----Snapshot State       : powered off\n----|-CHILD\n------'
         #[3] -> '        : xx\n------Snapshot Id        : 193\n------Snapshot Desciption  : desc\n-

         @s=();
         foreach my $t (@t) {
            if (!($t=~/Snapshot Id/)) { next; }      # not a snap id
            if (!($t=~/autosnap/))    { next; }      # not desc=autosnap
            $t=~s/.*Snapshot Id +: +//s;
            $t=~s/\n.*//s;
            push (@s,$t);                            # autosnap list
         }
# &print_array(@s);
         foreach my $s (@s) {                        # remove autosnaps
              print "ssh -l root $ip vim-cmd vmsvc/snapshot.remove $vmid $s<br>\n";
              $r=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.remove $vmid $s 2>&1`;
              $c2++;
         }


        # $t=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.removeall $t`;
         if ($t=~/Remove All Snapshots/) { $c2++; }    # success
         #$r.=$t;
    }
    $t="ESXi ssh autosnaps removed from VMs: $c1 ; Successfull: $c2";
    return($t);
}
###################
sub ssh_all_remove {        # remove all snaps from all VMs on $in{'select_fs'}
##################
    # vim-cmd vmsvc/snapshot.removeall VMID
    # ex vim-cmd vmsvc/snapshot.removeall 10

    my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
    my (@v,$p,@t,$t,$last,$c,$m,$r,$m,$sleep,$m,$q,$q,$c1,$c2);

    # from jobsettings or esxi_ip ex 4mq
    # $in{'select_create'} -> mem quiesce (boolean)

    #get vms on selected nfs
    $r=&ssh_nfs_vms;
    @v=split(/\n/,$r);
    $r="";

    $c1=0; $c2=0;

#&mess("$sleep,$m,$q<hr>$r");
#&print_array(@v);

    foreach my $v (@v) {            #
         if (!($v=~/\[/)) { next; } # no path
         $t=$v; $t=~s/\s.*//;       #vmid

         $c1++;              # count snap/vm requ

         print "(53) ssh -l root $ip vim-cmd vmsvc/snapshot.removeall $t<br>\n";
         $t=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.removeall $t`;
         if ($t=~/Remove All Snapshots/) { $c2++; }    # success
         #$r.=$t;
    }
    $t="ESXi ssh snaps removed: $c1 ; Successfull: $c2";
    return($t);
}

##################
sub get_last_snap {
#################
#root@omnisan:~# ssh -l root 192.168.2.48 vim-cmd vmsvc/snapshot.get 10
#Get Snapshot:
#|-ROOT
#--Snapshot Name          : test
#--Snapshot Id            : 90
#--Snapshot Desciption    :
#--Snapshot Created On    : 4/6/2023 16:0:42
#--Snapshot State         : powered off
#--|-CHILD
#----Snapshot Name        : test2
#----Snapshot Id          : 91
#----Snapshot Desciption  :
#----Snapshot Created On  : 4/6/2023 16:1:17
#----Snapshot State       : powered off


my $vm=$_[0];
my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
my $s=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.get $vm | grep "Snapshot Id`;  chomp($s);
#&mess("sudo ssh -l root $ip vim-cmd vmsvc/snapshot.get $vm | grep \"Snapshot Id\"<hr>$s");

#--Snapshot Id        : 90
#----Snapshot Id        : 91
#------Snapshot Id        : 92


#get last only
$s=~s/.*: +//s;        # ex 92
#print "$vm with last snapid $s<br>";
return ($s);
}

###################
sub ssh_create {         # create snaps for VMs on nfs $in{'select_fs'}
##################

    # vim-cmd vmsvc/snapshot.create VMID snapshotName description includeMemory quiesced
    # ex vim-cmd vmsvc/snapshot.create 10 test date 0 1

    my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
    my (@v,$p,@t,$t,$last,$c,$m,$r,$m,$sleep,$m,$q,$q,$c1,$c2);

    # from jobsettings or esxi_ip ex 4mq
    # $in{'select_create'} -> mem quiesce (boolean)

    #get vms on selected nfs
    $r=&ssh_nfs_vms;
    @v=split(/\n/,$r);
    $r="";

#&mess("$sleep,$m,$q<hr>$r");
#&print_array(@v);

    foreach my $v (@v) {
         if (!($v=~/\[/)) { next; } # no path
         $t=$v; $t=~s/\s.*//;       #vmid

         $c1++;              # count snap requ
         #create snap, ssh -l root 192.168.2.48 vim-cmd vmsvc/snapshot.create 10 snapname mem quiesce
         print "ssh -l root $ip vim-cmd vmsvc/snapshot.create $t ssh autosnap $in{'select_create'}<br>\n";
         $t=`sudo ssh -l root $ip vim-cmd vmsvc/snapshot.create $t ssh autosnap $in{'select_create'}`;
         if ($t =~/Create Snapshot/) { $c2++; }    # success
         $r.=$t;
    }
    $t="ESXi ssh snaps created: $c1 ; Successfull: $c2";
    return($t);


 }


###############
sub ssh_all_vms {                          # list of all vms
##############
      #
      my ($t,@v,@t,@w,$v,$n,@n);
      my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
      my $opt=$_[0];

      print "(183) ssh -l root $ip vim-cmd \"vmsvc/getallvms\"<br>\n";
      my $r=`sudo ssh -l root $ip vim-cmd "vmsvc/getallvms"`;      chomp($r);
#&mess("sshlib 186 problem<hr>$r");
      # 10     solaris11.4cbe.120   [192.168.2.203_nvme_nfs] solaris11.4cbe/solaris11.4cbe.vmx   solaris11_64Guest

      if ($opt eq "tl") {                      #tablist of vmid

          @t=split(/\n/,$r);                   # all vms
          $r="";

          foreach my $t (@t) {                 # vmarray
                   if (!($t=~/\[/)) { next; }  # from datastore
                   $t=~s/ +\[.*//;             # vmid\tname only
                   $r.="$t\t";                 # tablist
          }
          $r=~s/\t+$//;                        # no tab at eol
      }
#&mess("sshlib 202 problem<hr>$r");
      return ($r);
}
###########

###############
sub ssh_nfs_vms {                          # list of all vms on selected nfs
##############
        my (@v,@t,@w,$v,$n,@n,$fs);
        my $ip=$in{'select_host'};  $ip=~s/[ ,].*//;

        my $r=&ssh_all_vms;             # multiline string
        # 10     solaris11.4cbe.120   [192.168.2.203_nvme_nfs] solaris11.4cbe/solaris11.4cbe.vmx   solaris11_64Guest        vmx-19

        $fs=$in{'select_fs'};          # /nvme/nfs
        $fs=~s/\//_/g;                 # _nvme_nfs

        # 192.168.2.203_nvme_nfs  192.168.2.203  /nvme/nfs          true     true      false  false  Not Supported
#&mess("$r");

        @t=split(/\n/,$r);              # vms
        $r="";


#&print_array(@t);
        foreach my $t (@t) {            # vmarray
             if (!($t=~/\[/)) { next; } # no datastore
             if (!($t=~/$fs/)){ next; } # not my nfs fs

             @w=split(/  +/,$t);        # 19     testx                [nfs2]  testx/testx.vmx                                       other24xLinuxGuest       vmx-20
#&print_array(@w);
             $w[2]=~s/\[|\]//g;         # [datastore] vmxpath
             $w[2]=~s/ .*//g;           # datastore

             push (@v,$t);              # vm on nfs datastore
        }
#&print_array(@v);
        $r=join("\n",@v);
#&mess($r);

        if ($_[0] eq "tl") {                   # tablist of vmid

          @t=split(/\n/,$r);                   # all vms
          $r="";

          foreach my $t (@t) {                 # vmarray
                   if (!($t=~/\[/)) { next; }  # from datastore
                   $t=~s/ *\[.*//;             # vmid\tname only
                   $r.="$t\t";                 # tablist
          }
          $r=~s/\t+$//;                        # no tab at eol
        }
#&mess($r);
        return($r);                            # str of vms on nfs
}

##############
sub ssh_snaps {                          # list snaps
##############
        my ($r,$v,@w,@s,@v,$t,$n);
        my $ip=$in{'select_host'};  $ip=~s/[ ,].*//;
        $ip=~s/ .*//;

        if ($in{'autoselect_action'} eq "Snaps") {
             $r=&ssh_all_vms('');     # list of vms
        } else {                      # Snaps on NFS
             $r=&ssh_nfs_vms('');     # list of vms on NFS
        }
#&mess($r);

        @t=split(/\n/,$r);         # array of vms
        foreach my $t (@t) {       # vmid,name only
           $t=~s/ +\[.*//;         #
           if ($t=~/\d/){ push(@v,$t); }# vmid
        }
#&print_array(@v);
        $r="";
                                   # vim-cmd vmsvc/snapshot.get [VmId]

        foreach my $v (@v) {

              #reload?
              if ($in{'checkbox_reload'}=~/yes/) {
                 print "vim-cmd vmsvc/reload $v, \n";
                 $t=`sudo ssh -l root $ip vim-cmd "vmsvc/reload $v"`;
              }

              $t=$v;
              $t=~s/\s.*//;         # vmid
              print "vim-cmd vmsvc/snapshot.get $t, \n";
              $t=`sudo ssh -l root $ip vim-cmd "vmsvc/snapshot.get $t"`;
#&mess($t);

              if (!($t=~/\-\-/s)) { next; }  # no snaps
              @t=split(/\-\-Snapshot Name +:/,$t);
#&print_array(@t);


              foreach my $t (@t) {
                     if ($t=~/-ROOT/) { next; }     # snap root info

                     # test\n--Snapshot Id        : 100\n--Snapshot Desciption  : \n--Snapshot Created On  : 4/12/2023 8:59:37\n--Snapshot State       : powered off\n--|-CHILD\n--
                     @w=split(/\n/,$t);
#&print_array(@w);    # name,id,desc,created,state


                    foreach my $w (@w) {
                            $w=~s/^ +//; #leading space
                            $w=~s/\-+//g; #
                            $w=~s/Snapshot .*: //; #header
                            $t="$v\t$w[0]\t$w[1]\t$w[2]\t$w[3]\t$w[4]";
                    }
                    push (@s,$t);   # list of name,id,desc,created,state
#&print_array(@w);

              }

#&print_array(@s);
        }

        if (@s==0) { push (@s,"none"); }
        $r=join("\n",@s);
        $r="VMid\tVMname\tSnap\tSnapid\tDesc\tCreated\tState\n$r";
        return($r);
}


###################
sub ssh_all_datastores {
   my $ip=$in{'select_host'}; $ip=~s/[ ,].*//;
   print "ssh -l root $ip esxcli storage filesystem list<br>\n";
   my $r=`sudo ssh -l root $ip esxcli storage filesystem list`;
   return ($r);
}

###################
sub ssh_nfs_datastores {
   my (@t);
   my $ip=$in{'select_host'};  $ip=~s/[ ,].*//;
   print "ssh -l root $ip esxcli storage nfs list<br>\n";
   my $r=`sudo ssh -l root $ip esxcli storage nfs list`;

   #tablist
   if ($_[0] eq "tl") {
      @t=split(/\n/,$r);
      $r="";
      foreach my $t (@t) {
           if (!($t=~/\//)) { next; }        # not a share
           $t=~s/ .*//;                      # volume name
           $r.="\t$t";                       # tablist of nfs datastores
      }
   }
   $r=~s/\t+$//;                              # no tab at eol
   return ($r);
}

# eoF
1;
