#!/usr/bin/perl
# (c) napp-it 2015-2021
# 19. feb 2020 increase timeout
# 5.11.2021 webapi

# thanks to chris fr.: nov 5.2018, fix a report problem with several pools
# 14.dez 2021, chris fr. job-push, improved alert
# 19.dez 2021 fix on multiline errors

# debug: run from console
# perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-push.pl run_123 456
# 123= jobid, 456=time()

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($par $id $action $f $t @t $r $p @p %sys %cfg %current $error $info $message $text $subject $smtp $ref $path);

$par=$ARGV[0];
 if (!(defined($par))) {
     &my_log("job-push:  missing parameter");
      exit;
 }

 $f=`uname -a`;
 if ($f=~/^Linux/){
       $f="linux";
       $path="";
 } else {
       $f="illumos";
       $path="/usr/sbin/";
 }

 use lib "/var/web-gui/data/napp-it/CGI";                       # add to perl search path for libs ex. Expect.pm and others
 require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/task-lib.pl";        #
 require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
 require "/var/web-gui/data/napp-it/zfsos/_lib/$f/zfslib.pl";

 ############

 #par: action_job timestamp
 $par=~s/ .*//;

 # parameter: action_$job time
 if (!($par =~/\w+\_\d+$/)) {
     print "job-push 30: wrong par $par";
     exit;
 }
 @t=();
 @t=split(/\_/,$par);    # action job
 $action=$t[0];
 $action=~s/[^a-z]//g;

 $id=$t[1];
 #############################################

 # get par -> %current
 &task_read_jobpar($id);


# run?
if ($action eq "")                     {  print "job-other 42: wrong action - must be not empty\n";      exit; }
if (!("run,cancel,delete"=~/$action/)) {  print "job-other 43: wrong action - must be run: $action \n";  exit; }

#cancel or delete
if ($action eq "cancel") { &my_cancel; $info="cancel job"; &my_log; exit; }
if ($action eq "delete") { &my_delete; $info="delete job"; exit; }

#debug
# print "job-scrub 38: run id=$id par $par\n";


    $error=&my_run;
    &my_log;
    exit;


 ## delete job
 sub my_delete {
 ##############
 my ($r);
      if ($id ne "") {
        $r=`/usr/bin/rm -f /var/web-gui/_log/jobs/$id.*`;
        print "##### job-72: delete $id ######  $r\n";
      } else {
        print "job-74 delete, no id !! ########### \n";
      }
 }

############ update last
sub my_last {
  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);
}

#############
 sub my_run {
 ############
  &getdate;                                #  adminlib

  $t=$id."_text1";
  if ($current{$t} eq "")  {
     $t=$id."_trigger";
  }

  if ($current{$t}=~/alert|Disk|Low|Job/i) {
       $ref="alert";
       #print "job-push 99 alert $id  $t -> $current{$t}\n";
       my $r=&my_alert;
       if ($r ne "1") { &my_last; exit; }          # already send
  }  else {
       #print "job-push 103 status $id  $t -> $current{$t}\n";
       $ref="status";
       &my_status;
  }



  &my_send();

  print "119 message was send .. \n";
  return();                                # return "" or errorvalue
 }

  ## run job (child process)
 #############
 sub my_alert  {
##############

  my ($t,@to,$r,$pools,$w,@l,$l,$tmp,@w);

  my $host=`hostname`;

  $t=$id."_trigger";
  my $trigger=$current{$t};


  $subject = "reason: ";                # Subject
  $text    = "Alert/ Error on $host time: $sys{'date_and_time'}\n\n$text";

#error/ action log
      my $err1="/var/web-gui/_log/tmp/push_disk_alert.log";           # current logfile diskerr
      my $err2="/var/web-gui/_log/tmp/push_cap_alert.log";            # current logfile caperr
      my $err3="/var/web-gui/_log/tmp/push_job_alert.log";            # current logfile joberr


      if (-f $err1) {
         $t = (-M "$err1");                                   # last alert $t ago (not an integer)
         if ($t > 1) {
              unlink ($err1);                                 # delete disk old error
         }
      }
      if (-f $err2) {
         $t = (-M "$err2");                                   # last alert $t ago
         if ($t > 1) {
              unlink ($err2);                                 # delete old cap error
         }
      }

      if (-f $err3) {
         $t = (-M "$err3");                                   # last alert $t ago
         if ($t > 1) {
              unlink ($err3);                                 # delete old job error
         }
      }

  ######

  $r="";                                                      # reasons for alert  Disk, Low, Job,

  if ($trigger=~/Disk/) {
  # Disk error ######################

        # get needed infos in $text
        #zpool status
        $t=$path."zpool status";
        $text=`$t`;

        @t=();
        @t=split(/\n/,$text);    # reduce output to pool, state and errors, push max 1024 char
        @l=();
        $text = "";
        my $inc = "";
        my $bad = 0;
        my $ok_for_multi = 0; # to capture multi-line status: and action:
        foreach my $t (@t) {
           $ok_for_multi = 0 if ($t!~/^\t/);

           if ($t=~/pool: /)        {
               $text .= $inc if $bad;
               $bad = 0;
               $inc = "$t\n";
           } elsif ($t=~/state: |status: |action: |scan: |see: /) {
               $inc .= "$t\n";
               $ok_for_multi = 1;
           } elsif ($t=~/errors: /) {
               $inc .= "$t\n\n";        # extra newline
           } elsif ($t=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED|resilvering/x) {
               $inc .= "$t\n";
           } elsif ($ok_for_multi) {
               $inc .= "$t\n";
           }

           $bad = 1 if ($t=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/x);
           # libzfs_status.c "ZFS-8000-8A", /* ZPOOL_STATUS_CORRUPT_DATA */
           # libzfs_status.c "ZFS-8000-9P", /* ZPOOL_STATUS_FAILING_DEV */
           $bad = 1 if ($t =~ /\b ZFS-8000-(?:8A|9P) \b/x);
        }
        $text .= $inc if $bad;

        # check disk error

        #debug
        #$text="DEGRADED";

        if ($text ne "") {
             $r.="1"; $subject.=" -DISK ERR- ";
             $text="-disk errors:\n$text";
             $info.="Disk alert, "
        } else {
             $text="-disk errors: none\n";
             if (-f $err1) {   unlink ($err1);  }                # delete disk old error
        }
  }

  if ($trigger=~/Job/) {
      # Job error ##########

        #jobinfos id.par
        $w="/var/web-gui/_log/jobs/";
        @t=();
        &read_dir($w,'t');

        $tmp="";
        my ($id,$j);
        foreach my $t (@t) {

            # check in id.par if status=active
            if (!($t=~/\.par$/))      { next; }

            $id=$t; $id=~s/\..*//; chomp($id);                         # jobid

            # check if status=active
            $j=`cat $w$t`;
            if (!($j=~/status=active/s))  { next; }                    # job is not active

            # check laststate
            if (!(-f "$w$id\.log"))       { next; }                    # no log
            $j=`cat $w$id\.log`;

            #check if log starts with error
            if ($j=~/^error/) {
               $j=~s/\n.*//s;
               $tmp.="Active Job $id error:\n$j\n\n";                       # log error fo email
            }
        }
        if ($tmp ne "") {
             $subject.=" -Job Alert-";
             $info.="Job alert, ";
             $text.="\n\n---------\nJob Alert\n---------\n$tmp";
             $r.="1";
        } else {
             if (-f $err3) {   unlink ($err3);  }                     # delete job error
        }
  }


  if ($trigger=~/Low/) {
  # Cap error ##########
        # check avail < 15%  ()
        $t=&zfslib_pool2used;                  # list of pools + % used based on zfs list

# debug
#$t="10%!";

        if ($t=~/\%\!/) {
           $subject.=" -Low CAP ALERT 15%-";
           $info.="Low CAP ALERT 15%-";
           $text.="\n\n---------\nCAP Alert\n---------\n$tmp";

           # header
           $pools=&exe("$path\zpool list");
           $text.="\n\n------------------------------\nzpool list (Sum of RAW disk capacity without redundancy counted)\n------------------------------\n$pools\n\nReal Pool capacity from zfs list\n------------------------------\n";

           $text.="$t";
           $r.="1";
        } else {
             if (-f $err2) {   unlink ($err2);  }                # delete disk cap error
        }
  }

  # user defined alerts
  if (-f "/var/web-gui/_log/tmp/push-alert.log") {
       $r.="1"; $subject.=" -OTHER ERR- ";
       $text.="\n\n-user defined/ other job alert:\n /var/web-gui/_log/tmp/push-alert.log\n\n";
       $text.=`cat /var/web-gui/_log/tmp/push-alert.log`;
  }

  print "$r\n";

  # no reason
  ##########################################################################################
  if (!($r=~/1/)) { return (); }                             # no reason


  #check if alerts are already send today
  $r="";

  #Disk error already send today?
  if ( (!(-f $err1)) && ($subject=~/DISK/i))  {
    $r.="1";
    if ($subject=~/DISK/i)  {
         open (PF, ">$err1");
             print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
         close (PF);
    }
  }

  #Job error already send today?
  if ( (!(-f $err3)) && ($subject=~/Job/i))   {
    $r.="1";
    if ($subject=~/Job/i)  {
       open (PF, ">$err3");
             print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
       close (PF);
    }
  }

  #Cap error already send today?
  if ( (!(-f $err2)) && ($subject=~/CAP/i))   {
     $r.="1";

     if ($subject=~/CAP/)  {
      open (PF, ">$err2");
           print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
      close (PF);
    }
  }

 $current{'message'}=$info;

  #
  if (!($r=~/1/)) { return (); } else { return(1);}                            # all errors are already send today
# return ("1");  # send alert always

  #ok alert !!
  ###########################################################################################





 }

 #############
 sub my_status  {
##############

    # get needed infos in $text
    #zpool status
    my $host=&exe("hostname");

    $subject="* napp-it status and logs from $host";

    $t=$path."zpool list";
    $text="Status of $host from $sys{'date'}  $sys{'hour'}:$sys{'min'} \n\n-----------------------------------------------------------\n";
    $text.=`$t`."\n-----------------------------------------------------------\n\n\n";
    $t=$path."zpool status";
    $text.=`$t`;
    $t=$path."zfs list";
    $text.=`$t`;

    # user defined status
    if (-f "/var/web-gui/_log/tmp/mail-status.log") {
         $text.="\n\n-user defined/ other job status:\n /var/web-gui/_log/tmp/mail-status.log\n\n";
         $text.=`cat /var/web-gui/_log/tmp/mail-status.log`;
         if (-f "/var/web-gui/_log/tmp/mail-status.last") { `rm /var/web-gui/_log/tmp/mail-status.last`; }
         rename("/var/web-gui/_log/tmp/mail-status.log","/var/web-gui/_log/tmp/mail-status.last");
    }
 }

 ###########
 sub my_send {
 ############

  my $cmd;
  print "job-push 385 send\n";

  my $host=&exe("hostname");

  my $t=$id."_user";
  my $user=$current{$t};

  $t=$id."_token";
  my $token=$current{$t};

  $t=$id."_push";
  my $push=$current{$t};

  #message
  $t="";
  my $title="napp-it alert from $host";
  $t="$subject";
  $t.="$text\n";

  $t=~s/\%/ percent/gs;
  $t=~s/\r|\n/\n/gs;

  # data for webapi
  $current{'token'}=$token;
  $current{'to'}=$user;
  $current{'subject'}=$title;
  $current{'host'}=`hostname`; chomp($current{'host'});


  # cf jan 3, 2021
  # --post-data requires application/x-www-form-urlencoded -- "The
  # ... percent-encode set contains all code points, except the ASCII
  # alphanumeric, U+002A (*), U+002D (-), U+002E (.), and U+005F (_)."
  $t=~ s/([^A-Za-z0-9\*\-\._])/sprintf("%%%02X", ord($1))/eg;

  #if ($push eq "Pushalot") {
  #    #
  #    $cmd = "wget -T 30 --post-data 'Title=$title&AuthorizationToken=$token&Body=$t' -O - https://pushalot.com/api/sendmessage";
  #    print "$cmd<hr>";
  #} else {
  #    $cmd = "wget -T 30 --post-data 'title=$title&token=$token&user=$user&message=$t' -O - https://api.pushover.net/1/messages";
  #    print "$cmd<hr>";
  #}

  # my or global
   if (-f "/var/web-gui/_my/scripts/webapi/webapi.pl") {
      $current{'subject'}="my $current{'subject'}";
      require "/var/web-gui/_my/scripts/webapi/webapi.pl";      # %current: token,to,subject,host,message
  } else {
      require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/webapi.pl";             # %current: token,to,subject,host,message
  }
  $current{'return'}=~s/^.*napp\-it//s;
  $info=substr($current{'return'},0,120);
  &my_log;

  print "381 push message ..";


 }

############
sub my_err {
############
  $error="error";
  $info=$_[0];

  print "job-push my_err $info\n";

  &my_log;
  exit;
}

###########  ## log last run in jobfile /_log/jobs/id...job
sub my_log {
###########
 require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/task-lib.pl";

  # print "job-repli 548 - call log id=$id action=$action\n";

  # line 1: lastrun = ok or err
  # line 2: time of last run
  # line 3+: info

  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}

  my (@v,$v,$n,$l,$f1,$f2,@data);

  $l=$error;
  if ($l eq "") { $l="ok"; } else { $l="error"; $info="$info $error"; }

  $l=~s/\n/ /gs;
  $info=~s/\n.*//s;                                        # first line
  $info=~s/ +/ /g;

 #stage 1: log general jobs
 ###########################
  my $log="/var/web-gui/_log/jobs/jobs.log";
  my $lock="/var/web-gui/_log/jobs/jobs.lock";
  open (X,"<$lock");
  flock(X, LOCK_EX);
          open (F,"<$log");
              flock(F, LOCK_EX);
              @data=<F>;
          close (F);

        #unshift   $l=ok/error
        unshift(@data,"$l; push $ref $id; time: $current{'timestamp'}; info: $info\n");

        if (@data > 50) {
                   $t=@data-50;
                   splice(@data,50,$t);
        }

       $t=join("",@data);
       open (PF, ">$log");
          flock(PF, LOCK_EX);
          print PF "$t";
       close (PF);
 close (X);

 if ($info=~/^delete /) { exit; }


 #stage 2 update job.par  $current{'logtime'};
  $log="/var/web-gui/_log/jobs/$id.log";

  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);                                         # update last


  # stage 3 id.log newest at top
  ###################
  &my_logid("$l","info: $info");

  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);

 exit;  # log always last action

}


##############  log to id.log
sub my_logid {
#############
my $err =$_[0];
my $data=$_[1];
$data=~s/ +/ /g;
my @data;
&task_gettime;

my $log="/var/web-gui/_log/jobs/$id.log";
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$err; time: $current{'timestamp'}; $data\n");

  if (@data > 50) {
             $t=@data-50;
             splice(@data,50,$t);                 # delete from 50+
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);


}



##
1;