#!/usr/bin/perl
# (c) napp-it

# request regular email job
# use this copy as job-email.pl of this file to send mail without tls
# to activate TLS, uncomment TLS in my_send
# active mail

# debug: run from console
# perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-email.pl run_123 456
# 123= jobid, 456=time()

# july 2016, use fqdn as hostname
# jan 2013 modify tls send

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($par $id $action $f $t @t $p @p %sys %cfg %current $error $info $message $text $subject $smtp $ref $path);

 $f=`uname -a`;
 if ($f=~/^Linux/){
       $f="linux";
       $path="";
 } else {
       $f="illumos";
       $path="/usr/sbin/";
 }

 use lib "/var/web-gui/data/napp-it/CGI";                       # add to perl search path for libs ex. Expect.pm and others
 require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/task-lib.pl";        #
 require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";
 require "/var/web-gui/data/napp-it/zfsos/_lib/$f/zfslib.pl";

$par=$ARGV[0];
 if (!(defined($par))) {
     &my_log("job-email:  missing parameter");
      exit;
 }

 ############

 #par: action_job timestamp
 $par=~s/ .*//;

 # parameter: action_$job time
 if (!($par =~/\w+\_\d+$/)) {
     print "job-email 30: wrong par $par";
     exit;
 }
 @t=();
 @t=split(/\_/,$par);    # action job
 $action=$t[0];
 $action=~s/[^a-z]//g;

 $id=$t[1];
 #############################################

 # get par -> %current
 &task_read_jobpar($id);


# run?
if ($action eq "")                     {  print "job-other 42: wrong action - must be not empty\n";      exit; }
if (!("run,cancel,delete"=~/$action/)) {  print "job-other 43: wrong action - must be run: $action \n";  exit; }

#cancel or delete
if ($action eq "cancel") { &my_cancel; $info="cancel job"; &my_log; exit; }
if ($action eq "delete") { &my_delete; $info="delete job";  exit; }

#debug
# print "job-scrub 38: run id=$id par $par\n";


    $error=&my_run;
    &my_log;
    exit;

 ## delete job
 sub my_delete {
 ##############
 my ($r);
      if ($id ne "") {
        $r=`sudo rm -f /var/web-gui/_log/jobs/$id.*`;
        print "##### job-72: delete $id ######  $r\n";
      } else {
        print "job-74 delete, no id !! ########### \n";
      }
 }

############ update last
sub my_last {
  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);
}

#############
 sub my_run {
 ############
  &getdate;                                #  adminlib

  $t=$id."_text1";
  if ($current{$t}=~/alert/) {
       $ref="alert";
      # print "job-email 69 status $t -> $current{$t}\n";
       my $r=&my_alert;
       if ($r ne "1") { &my_last; exit; }          # already send
  }  else {
       $ref="status";
       &my_status;
  }



  $t=$id."_to";
  my $to=$current{$t};                     # opt commalist a@xx.com,b@xx.com,c@xx.com
  my @to=split(/,/,$to);
  foreach my $to (@to) {
       print "## send job email 78 $to\n";
       &my_send($to);
  }


  print "message was send .. \n$smtp";
  return();                                # return "" or errorvalue
 }

  ## run job (child process)
  #############
 sub my_alert  {
##############

  my ($t,@to,$r,$pools,$w,@l,$l,$tmp,@w);

  my $host=`hostname`;

  $t=$id."_trigger";
  my $trigger=$current{$t};


  $subject = "*** napp-it Alert *** on $host\: ";                # Subject
  $text    = "Alert/ Error on $host from $sys{'date_and_time'}\n\n$text";

#error/ action log
      my $err1="/var/web-gui/_log/tmp/auto_mail_disk_alert.log";           # current logfile diskerr
      my $err2="/var/web-gui/_log/tmp/auto_mail_cap_alert.log";            # current logfile caperr
      my $err3="/var/web-gui/_log/tmp/auto_mail_job_alert.log";            # current logfile joberr


      if (-f $err1) {
         $t = (-M "$err1");                                   # last alert $t ago (not an integer)
         if ($t > 1) {
              unlink ($err1);                                 # delete disk old error
         }
      }
      if (-f $err2) {
         $t = (-M "$err2");                                   # last alert $t ago
         if ($t > 1) {
              unlink ($err2);                                 # delete old cap error
         }
      }

      if (-f $err3) {
         $t = (-M "$err3");                                   # last alert $t ago
         if ($t > 1) {
              unlink ($err3);                                 # delete old job error
         }
      }

  ######

  $r="";                                                      # reasons for alert  Disk, Low, Job,

  if ($trigger=~/Disk/) {
  # Disk error ######################

        # get needed infos in $text
        #zpool status
        $t=$path."zpool status";
        $text=`$t`;
        # check disk error
        if ($text=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/s) {
             $r.="1"; $subject.=" -DISK ERR- ";
             $text="-disk errors:\n$text";
             $info.="Disk alert, "
        } else {
             $text="-disk errors: none\n";
             if (-f $err1) {   unlink ($err1);  }                # delete disk old error
        }
  }

  if ($trigger=~/Job/) {
      # Job error ##########

        #jobinfos id.par
        $w="/var/web-gui/_log/jobs/";
        @t=();
        &read_dir($w,'t');

        $tmp="";
        my ($id,$j);
        foreach my $t (@t) {

            # check in id.par if status=active
            if (!($t=~/\.par$/))      { next; }

            $id=$t; $id=~s/\..*//; chomp($id);                         # jobid

            # check if status=active
            $j=`cat $w$t`;
            if (!($j=~/status=active/s))  { next; }                    # job is not active

            # check laststate
            if (!(-f "$w$id\.log"))       { next; }                    # no log
            $j=`cat $w$id\.log`;

            #check if log starts with error
            if ($j=~/^error/) {
               $j=~s/\n.*//s;
               $tmp.="Active Job $id error:\n$j\n\n";                       # log error fo email
            }
        }
        if ($tmp ne "") {
             $subject.=" -Job Alert-";
             $info.="Job alert, ";
             $text.="\n\n---------\nJob Alert\n---------\n$tmp";
             $r.="1";
        } else {
             if (-f $err3) {   unlink ($err3);  }                     # delete job error
        }
  }


  if ($trigger=~/Low/) {
  # Cap error ##########
        # check avail < 15%  ()
        $t=&zfslib_pool2used;                  # list of pools + % used based on zfs list

# debug
# $t="10%!";

        if ($t=~/\%\!/) {
           $subject.=" -Low CAP ALERT 15%-";
           $info.="Low CAP ALERT 15%-";
           $text.="\n\n---------\nCAP Alert\n---------\n$tmp";

           # header
           $pools=&exe("$path\zpool list");
           $text.="\n\n------------------------------\nzpool list (Sum of RAW disk capacity without redundancy counted)\n------------------------------\n$pools\n\nReal Pool capacity from zfs list\n------------------------------\n";

           $text.="$t";
           $r.="1";
        } else {
             if (-f $err2) {   unlink ($err2);  }                # delete disk cap error
        }
  }

  # user defined alerts
  if (-f "/var/web-gui/_log/tmp/mail-alert.log") {
       $r.="1"; $subject.=" -OTHER ERR- ";
       $text.="\n\n-user defined/ other job alert:\n /var/web-gui/_log/tmp/mail-alert.log\n\n";
       $text.=`cat /var/web-gui/_log/tmp/mail-alert.log`;
  }

  print "$r\n";

  # no reason
  ##########################################################################################
  if (!($r=~/1/)) { return (); }                             # no reason


  #check if alerts are already send today
  $r="";

  if (-f "/var/web-gui/_log/tmp/mail-alert.log") {
     $r.="1";
     if (-f "/var/web-gui/_log/tmp/mail-alert.last") { `rm /var/web-gui/_log/tmp/mail-alert.last`; }
     rename("/var/web-gui/_log/tmp/mail-alert.log","/var/web-gui/_log/tmp/mail-alert.last");
  }


  #Disk error already send today?
  if ( (!(-f $err1)) && ($subject=~/DISK/))  {
    $r.="1";
    open (PF, ">$err1");
         print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
    close (PF);
  }

  #Cap error already send today?
  if ( (!(-f $err2)) && ($subject=~/CAP/))   {
     $r.="1";
     open (PF, ">$err2");
        print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
     close (PF);
  }

  #Job error already send today?
  if ( (!(-f $err3)) && ($subject=~/Job/))   {
    $r.="1";
    if ($subject=~/Job/)  {
       open (PF, ">$err3");
             print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
       close (PF);
    }
  }

  # new alert due new failed job
  if ((-f $err3) && ($subject=~/Job/))   {
    $t=`cat $err3`;
    if (!($t=~/$id/s))  {
       open (PF, ">>$err3");
             print PF "\n--alert $id at $sys{'date_and_time'} \n\n$text\n";
       close (PF);
    }
  }


  #
  if ($r=~/1/)    { return (1); }              # send alert
  return ();                                   # all errors are already send today


  #ok alert !!
  ###########################################################################################



 }

 #############
 sub my_status  {
##############

    # get needed infos in $text
    #zpool status
    my $host=&exe("hostname");

    $subject="* napp-it status and logs from $host";

    $t=$path."zpool list";
    $text="Status of $host from $sys{'date'}  $sys{'hour'}:$sys{'min'} \n\n-----------------------------------------------------------\n";
    $text.=`$t`."\n-----------------------------------------------------------\n\n\n";
    $t=$path."zpool status";
    $text.=`$t`;
    $t=$path."zfs list";
    $text.=`$t`;

    # user defined status
    if (-f "/var/web-gui/_log/tmp/mail-status.log") {
         $text.="\n\n-user defined/ other job status:\n /var/web-gui/_log/tmp/mail-status.log\n\n";
         $text.=`cat /var/web-gui/_log/tmp/mail-status.log`;
         if (-f "/var/web-gui/_log/tmp/mail-status.last") { `rm /var/web-gui/_log/tmp/mail-status.last`; }
         rename("/var/web-gui/_log/tmp/mail-status.log","/var/web-gui/_log/tmp/mail-status.last");
    }
 }

 ###########
 sub my_send {
 ############

  print "job-email 67 to $_[0]\n";

  my ($t,$tls,$host);

  $t=$id."_tls";
  $tls=$current{$t};

  $t=$id."_server";
  my $server=$current{$t};

  $t=$id."_from";
  my $from=$current{$t};

  my $to=$_[0];

  $t=$id."_user";
  my $user=$current{$t};

  $t=$id."_pw";
  my $pw=$current{$t};


  #debug
 #  print "server,from,to,sub\n$server, $from, $to\n$subject\n ";

  if (!($server=~/\w+/))    { &my_err('please set a smtp-server in napp-it - setup'); }
  if (!($to=~/\@/))         { &my_err('please set a mailto in napp-it - setup'); }

 # test for sending mail vie module Net::SMTP see http://perldoc.perl.org/Net/SMTP.html

 $host=&my_fqdn;

 ## use tls; activate needed module
  use Net::SMTP;
  use Authen::SASL qw(Perl);

  my $smtp = Net::SMTP->new("$server",
  SSL => 1,
  #Port => 587,
  Debug => 0,
  Hello => "$host",
  Timeout => "30",) || &mess("could not connect smtp-server $server");

  $smtp->auth("$user","$pw");
 #
 ## without tls

 #       use Net::SMTP;
 #       $smtp = Net::SMTP->new($server) || &my_err("could not connect smtp-server $server");
 #
 #       if (($user ne "") && ($pw ne "")) {
 #         $smtp->auth ($user,$pw);
 #       }
  #####################################

  $text=~s/<br>/\n/gs;

  $smtp->mail($from);
  $smtp->to($to);
  $smtp->data();
  $smtp->datasend("From: $from\n");
  $smtp->datasend("To: $to\n");

  $smtp->datasend("Subject: $subject\n");
  $smtp->datasend("\n");
  $smtp->datasend("$text\n");
  $smtp->dataend();

  $smtp->quit;
  $info.=$smtp;

 }

############
sub my_err {
############
  $error="error";
  $info=$_[0];

  print "job-email my_err $info\n";

  &my_log;
  exit;
}

###########  ## log last run in jobfile /_log/jobs/id...job
sub my_log {
###########

  # print "job-repli 548 - call log id=$id action=$action\n";

  # line 1: lastrun = ok or err
  # line 2: time of last run
  # line 3+: info

  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}

  my (@v,$v,$n,$l,$f1,$f2,@data);

  $l=$error;
  if ($l eq "") { $l="ok"; } else { $l="error"; $info="$info $error"; }

  $l=~s/\n/ /gs;
  $info=~s/\n.*//s;                                        # first line
  $info=~s/ +/ /g;

 #stage 1: log general jobs
 ###########################
  my $log="/var/web-gui/_log/jobs/jobs.log";
  my $lock="/var/web-gui/_log/jobs/jobs.lock";
  open (X,"<$lock");
  flock(X, LOCK_EX);
          open (F,"<$log");
              flock(F, LOCK_EX);
              @data=<F>;
          close (F);

        #unshift   $l=ok/error
        unshift(@data,"$l; email $ref $id; time: $current{'timestamp'}; info: $info\n");

        if (@data > 50) {
                   $t=@data-50;
                   splice(@data,50,$t);
        }

       $t=join("",@data);
       open (PF, ">$log");
          flock(PF, LOCK_EX);
          print PF "$t";
       close (PF);
 close (X);

 if ($info=~/^delete /) { exit; }


 #stage 2 update job.par  $current{'logtime'};
  $log="/var/web-gui/_log/jobs/$id.log";

  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);                                         # update last


  # stage 3 id.log newest at top
  ###################
  &my_logid("$l","info: $info");

  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);

 exit;  # log always last action

}


##############  log to id.log
sub my_logid {
#############
my $err =$_[0];
my $data=$_[1];
$data=~s/ +/ /g;
my @data;
&task_gettime;

my $log="/var/web-gui/_log/jobs/$id.log";
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$err; time: $current{'timestamp'}; $data\n");

  if (@data > 50) {
             $t=@data-50;
             splice(@data,50,$t);                 # delete from 50+
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);


}


###########
sub my_fqdn {
###########
   my (@v,$v,$t,$h,@f,$f);
   $h=`hostname`;
   chomp($h);

   #hostname like host.domain.org
   if ($h=~/\w+\.\w+\.\w+/) { return($h); }

   # else add .local
   $h=$h.'.local';
   return ($h);

}

##
1;
