#!/usr/bin/perl
#
# report poolstatus based on zpool status
#

###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(%zfs %sys %disk %cfg %current %in @par @t $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";

#basic disk infos
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/disklib.pl";
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/get-disk.pl";                         # load basic disk infos

#process report and return results
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/report.lib";                                              # load my_report, set message, text and alertmess
print "message_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end


###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
        # pool status error?

        # if Alert enabled and alert: print alertlog
        # if Status enabled: print statlog

        # get needed infos in $text
        #zpool status
        my $host=&exe("hostname");

        $text="<pre> $host\n\n";

        # $t=$binpath."zpool status";
        # $text.=`$t`;

        $text.=&my_pooldetails();

        #debug
        #$text.="FAULTED";

        # check disk error
        if ($text=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/s) {
             $subject="Poolproblem";
             $alert="1";
             $alertmess=$text;
        } else {
             $subject="ok";
             $alert="0";

        }

        #hard error >= 1000s
        if ($text=~/ H:\d\d\d\d+ T:/s) {
             $subject.=" Poolproblem/ Harderror >999";
             $alert="1";
             $alertmess=$text;
        }

        #add %disk optionally
        # $text.=&my_hdisk;

        # cli debug?
        #$alert="1";
        #print $text; exit;
        #&print_hash(%disk);    exit;

        $text.="\n</pre>";
        return ($subject);          # use it ex for email subject
}

#####
sub my_pooldetails {
####
  #status with disk cap and  model

    $t=$binpath."zpool status";
    my $ant="";
    $ant.=`$t`;
    $ant.="\n";

    my @l=split(/\n/,$ant);
    my ($s,$t,$k,$id);

    my $prod="Product /Disks";
    $prod.=" " x16;
    $prod=substr($prod,0,16);


    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="      CAP            $prod   IOstat mess          SN/LUN"; }

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd|lofi/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices

             $id=$t;

             $k="$id"."_partcap";
             $s=15-length($disk{$k});
             $l.="      $disk{$k}"." "x $s;

             $k="$id"."_product";
             $k=~s/p\d//;                        #disk not part
             $s=$disk{$k}." " x 35;
             $s=substr($s,0,16);
             $l.=$s;

             $l.="  ";
             $k="$id"."_error";
             $k=~s/p\d//;                        #iostat err

             @t=();
             $t=$disk{$k};
             #$t=~s/.://g;                       # keep "0 0 0"
             #@t=split(/ /,$t);
             $t=$disk{$k}." "x20;
             $t=substr($t,0,18);

             if ($l=~/lofi/) {
                  $k="$id";
                  $t="$disk{$k}";

                  $k="$id"."_options";
                  $t.="  $disk{$k}";
             }

             $l.=$t;

             # add sn/lun

             $k="$id"."_sn";
             $k=~s/p\d//;                        #sn=lun
             $l.="    ".$disk{$k};
        }
    }
    $t=join("\n",@l);
    return ($t);

}

##########
sub my_hdisk {
#########
      my ($k,$v,@tmp,$r,$w);
      while (($k,$v) = each %disk) {
           $w=$k." "."." x 40;
           $w=substr($w,0,41);
           push (@tmp,"$w -> \'$v\'");
      }
      @tmp=sort(@tmp);
      foreach my $t (@tmp) {
        $r.="$t\n";
      }
      return ($r);

}

# eof
1;