#!/usr/bin/perl
#
# report poolcap, alert low cap
#

###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(%zfs %sys @par @t $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";

#process report and return results
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/report.lib";                                          # load my_report, set message, text and alertmess
print "message_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end


###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
    # pool fillrate?

    # if Alert enabled and alert: print alertlog
    # if Status enabled: print statlog

    # get needed infos in $text
    my $host=&exe("hostname");

    #header
    $text="Status of $host from $sys{'date'}  $sys{'hour'}:$sys{'min'} \n----------------------------------\n";

    # check avail < 15%  ()
    $text.=&zfslib_pool2used;       # list of pools + % used based on zfs list

                                # NAME    USED    AVAIL   MOUNTPOINT      %
                                # b1      46.2T   8.79T   /b1             16%
                                # rpool   44.1G   100G    /rpool          69%


    $alertmess="$text";         # use this for alerts

    $text.="\n\nzfs list | grep -v rpool/\n\n";

    $t=$binpath."zfs list | grep -v rpool/";
    $text.=`$t`;

    #debug
    #$text.="%!";

    if ($text=~/\%\!/s) {
       $subject =" Capacity LOW (less 15%)";
       $alert="1";
     } else {
       $subject="ok";
       $alert="0";
       $alertmess="";
     }

     # cli debug?
     # $alert="1"; $subject="test";
     # print "$text\n";

     return ($subject);          # use it ex for email subject
}

 ###############
 sub zfslib_pool2used  {  #hide:
 ###############  return list of pools with used in %
      $t="$binpath"."zfs list";
      my $r=`$t -H -o name,used,avail,mountpoint`;
      my @zfs=split(/\n/,$r);
      $r="NAME\tUSED\tAVAIL\tMOUNTPOINT\tavailable in %\n";
      my @w=();
      my ($used,$total,$t);
      foreach my $z (@zfs) {

               @w=split(/\t/,$z);

               if ($w[0]=~/\//) { next; }        # pool only
               $r.=$z;                           # poolname,used,avail,mp

     # &mess($z);

               $used=&zfslib_val2kb($w[1]);
               $total=$used + &zfslib_val2kb($w[2]);  #total=used+avail

              $t=&zfslib_val2proz($total,$used);
              if ($t <=15) { $t.='%!'; } else { $t.='%'; }         # alert  15%!
              $r.="\t\t$t\n";

      }
      return ($r);
 }

 ###############
 sub zfslib_val2kb  {  #hide:
 ###############

      my $w1=$_[0];
      if ($w1=~/K/) { $w1=~s/K//;  }
      if ($w1=~/M/) { $w1=~s/M//; $w1=$w1*1000; }
      if ($w1=~/G/) { $w1=~s/G//; $w1=$w1*1000000; }
      if ($w1=~/T/) { $w1=~s/T//; $w1=$w1*1000000000; }
      if ($w1=~/P/) { $w1=~s/P//; $w1=$w1*1000000000000; }
      return ($w1);
 }

  ###############
 sub zfslib_val2proz  {  #hide:  total, used return % value
 ###############


      my $total=$_[0];    # total
      my $used=$_[1];     # used
      if (($total eq "") || ($total eq "0")) { return ""; }

      my $p=($total-$used)/$total*100;       #avail in% =(total - used)/total * 100
      $p=sprintf ("%.0f", $p);               #runden
      return ($p);
 }

# eof
1;