#!/usr/bin/perl
#
# license reminder
# send an alert 21,14,7 days prior end then daily

###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(%zfs %sys @par @t $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/var/web-gui/data/wwwroot/cgi-bin/admin-lib.pl";

#process report and return results
require "/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/report.lib";                                          # load my_report, set message, text and alertmess
print "message_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end


###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
        # license reminder
        my ($p,$r);
        my $host=&exe("hostname");

        $t="";
        $text="";
        $alertmess="";

        $t=`/usr/sbin/fmdump -m -t $sys{'year'}\-$sys{'mon'}\-$sys{'mday'}`;
        #$t=`/usr/sbin/fmdump -m -t $sys{'year'}\-02\-$sys{'mday'}`;               #debug

        print "fmdump -m -t $sys{'year'}\-$sys{'mon'}\-$sys{'mday'}\n$t\n";

        my @fm=split(/SUNW\-MSG\-ID: /,$t);
        my @major=();

        foreach my $l (@fm) {
           if ($l=~/Major/) { push (@major,$l); }
        }

        if (@major>0) {
           $subject.=" -Major fmdumperr-";
           $alertmess="\n\nfmdump SEVERITY: Major\n\n".join("\n",@major);
           $text.="\n\nfmdump SEVERITY: Major\n\n".join("\n",@major);
        }


        if ($alertmess ne "") {
                     $subject.=" fmdump: Major problem";
                     $alert="1";
                     $alertmess="fmdump: Major problem";
        }  else {
                     $subject="ok";
                     $alert="0";
        }



        # cli debug?
        # print $text;
        # $alert="1"; $subject="test";

        return ($subject);          # use it ex for email subject
}

# eof
1;