#!/usr/bin/perl

# send messages and alerts via a Jamstack https provider
# call this script for tests without options: send Testmessage

 print "use webapi\n";

# values from settings on alert
my $r=`cat /var/web-gui/_log/napp-it.cfg | grep 'pushover\-token'`; @t=split(/\|/,$r);
$current{'token'}=$t[1];

$r=`cat /var/web-gui/_log/napp-it.cfg | grep 'pushover\-user'`; @t=split(/\|/,$r);
$current{'to'}=$t[1];

#print  "token: $current{'token'} to: $current{'to'}\n";      #debug

#overwrite on reports
if ($current{'pushover-token'} ne "") {  $current{'token'}=$current{'pushover-token'}; }
if ($current{'pushover-user'} ne "")  {  $current{'to'}=$current{'pushover-user'}; }

# webapi token
if ($current{'token'} eq "") { print "webapi 8, missing token in About > Settings\n"; exit; }

# to user, mail or chat
if ($current{'to'} eq "") { print "webapi 11, missing to in About > Settings\n"; exit; }

# or overwrite via %current  token,user,host,message
if ($current{'subject'} eq "")  { $current{'subject'}="** Test"; }
if ($current{'hostname'} eq "") { $current{'hostname'}=`hostname`; } chomp($current{'hostname'});
if ($current{'message'} eq "")  { $current{'message'}="This is a push test from $current{'hostname'}"; }

###################
# use this provider
###################

#&SendinBlue();
# &SendPushover();
#&SendTelegram;
&SendNappit;


#################
sub SendNappit {
###############
      # http://www.napp-it.org/cgi-bin/websmtp/websmtp.pl?ref=abc&subject=alert&token=XyZ&message=message

      my $token=$current{'token'};
      my $ref=$current{'to'};                     # ref, to in ref.cfg on napp-it

      my $subject=$current{'subject'};
      $subject=~s/[^A-Za-z0-9\*\-\._ ]//gs;
      print "webapi: nappit\nsubject:$subject\n\n";

      my $message=$current{'message'};   $message=~s/<n>/\n/gs; $message=~s/\r//gs;
      $messge=substr($message,0,2000);          # limit url

      $message=~s/[^A-Za-z0-9\*\-\._\n ]/*/gs;

      print "wget -O - \"https://www.napp-it.org/cgi-bin/websmtp/_app.pl?ref=$ref&subject=$subject&token=$token&message=$message\"\n ";
      my $r=`wget -O - \"https://www.napp-it.org/cgi-bin/websmtp/_app.pl?ref=$ref&subject=$subject&token=$token&message=$message\"`;

      $r=~s/\s+/ /gs;
      $current{'return'}=$r;  # return value

      print "webapi to $ref\n$r"; ;
}

##################
sub SendTelegram {
##################
# curl -s -X POST $URL -d chat_id=$ID -d text="Hello World"

# 1. create a Telegram account and a bot
# 2. start a chat (say hi)
# 3. get message id of chat (https://api.telegram.org/bot[HTTP-TOKEN]/getUpdates)

# ex https://www.christian-luetgens.de/homematic/telegram/botfather/Chat-Bot.htm
# follow instructions to get id number: "message":{"message_id":3,"from":{"id":2065143926,....

# opt, use Google to translate

$current{'message'}="$current{'subject'}\n\n$current{'message'}";

my $url="https://api.telegram.org/bot$current{'token'}/sendMessage";

#print "curl -s -X POST $url -d chat_id=$current{'to'} -d text=\"$current{'message'}\"";

my $r=`curl -s -X POST $url -d chat_id=$current{'to'} -d text=\"$current{'message'}\"`;
$current{'return'}=$r;  # return value

print "<pre>mess to $id\n$r</pre>";  sleep(2);

}

##############
sub SendinBlue {
##############
# sendinblue.com is a European provider (DSGVO conform)
# you can create a free account with up to 300 mails per day
# and enable transactional mails (single line, json syntax)

#curl --request POST \
#  --url https://api.sendinblue.com/v3/smtp/email \
#  --header 'accept: application/json' \
#  --header 'api-key:YOUR_API_KEY' \
#  --header 'content-type: application/json' \
#  --data '{
#   "sender":{
#      "name":"Sender Alex",
#      "email":"senderalex@example.com"
#   },
#   "to":[
#      {
#         "email":"testmail@example.com",
#         "name":"John Doe"
#      }
#   ],
#   "subject":"Hello world",
#   "htmlContent":"<html><head></head><body><p>Hello,</p>This is my first transactional email sent from Sendinblue.</p></body></html>"
#}'

 #token,to,subject,host,message

 my $token=$current{'token'};
 my $to=$current{'to'};

 my $subject=$current{'subject'};
 my $mess=$current{'message'};
 $mess=&json($mess);

 my $name="napp-it";
 $hostname=`hostname`; chomp($hostname);
 my $from="noreply\@".$hostname;

#debug
#print "$mess";     exit;

my $c=<<EoF;
curl --request POST --url https://api.sendinblue.com/v3/smtp/email  --header 'accept: application/json'  --header 'api-key:$token'  --header 'content-type: application/json'  --data '{
   "sender":{
      "name":"$name",
      "email":"$from"
   },
   "to":[
      {
         "email":"$to",
         "name":"$name"
      }
   ],
   "subject":"$subject",
   "htmlContent":"<html><head></head><body>$mess</body></html>"
}'

EoF

my $r=`$c`;              # send
$r=~s/\{|\}|\<|\>|\"//gs; # json   -> txt

$current{'return'}=$r;  # return value
print "<pre>$r</pre>"; sleep(2);
}


sub SendPushover {
###################
  # --post-data requires application/x-www-form-urlencoded -- "The
  # ... percent-encode set contains all code points, except the ASCII
  # alphanumeric, U+002A (*), U+002D (-), U+002E (.), and U+005F (_)."
     my $message=$current{'message'};
     my $token=$current{'token'};
     my $to=$current{'to'};
     my $title=$current{'subject'};

     $message=~ s/([^A-Za-z0-9\*\-\._])/sprintf("%%%02X", ord($1))/eg;
     $title=~ s/([^A-Za-z0-9\*\-\._])/sprintf("%%%02X", ord($1))/eg;

     print "wget -T 30 --post-data 'title=$title&token=$token&user=$to&message=$message' -O - https://api.pushover.net/1/messages";   # debug only

      my $r = `wget -T 30 --post-data 'title=$title&token=$token&user=$to&message=$message' -O - https://api.pushover.net/1/messages`;

      $current{'return'}=$r;  # return value
      print "<pre>$r</pre>";   sleep(2);

}

sub json {
##########
my $mess=$_[0];
 $mess=~s/\n|\r/<br>/gs;                  # single line

 $mess=~s/\"/\\"/gs;
 $mess=~s/\'/"/gs;

 $mess=~s/\/&auml;/gs;
 $mess=~s//&Auml;/gs;

 $mess=~s/\/&ouml;/gs;
 $mess=~s//&Ouml;/gs;

 $mess=~s/\/&uuml;/gs;
 $mess=~s//&Uuml;/gs;

 $mess=~s/\[/&#91;/gs;
 $mess=~s/\]/&#93;/gs;

 $mess=~s/\{/&#123;/gs;
 $mess=~s/\}/&#125;/gs;

 $mess=~s/\(/&#40;/gs;
 $mess=~s/\)/&#41;/gs;

 $mess=~s/\/&szlig;/gs;
 $mess=~s/\%/&#37;/gs;
 $mess=~s/\\\"/"/gs; # undo opt perl masking of "

 $mess=~s/[^a-zA-Z0-9\<\>\@\\\/:\.,;\&\-\"\n\#\=\_ ]//gs;        # allowed char

 return ($mess);

}
######


#
1;

