 # get-disk.pl
#
# (c) napp-it 2010-24
# windows jan 2024

 use strict;
 my ($diff,$last,$disk2);

 #&print_hash(%disk);                     #debug
 &get_mywdisk;                            # add disk{'all'} from windows

 #&print_hash(%disk);                     #debug


##############      PHYSICALDRIVE1
sub get_mywdisk  {
##############
  my (@w,$w,$key,$k,$n,@n,@p,$p,$r,$i,$v,@v,$d,@d,$id,$out,$pool);
  $disk{'all'}="";
  $disk{'all_unused'}="";       # 0 1 2

  ######################################################
  # Diskinfo via powershell Get-PhysicalDisk \n";
  ######################################################

  #print "call socket ps<br>";
  $r=&socket('ps Get-PhysicalDisk | Select DeviceID,UniqueId,Manufacturer,Model,CanPool,OperationalStatus,HealthStatus,Serialnumber,size');
  #&mess($r);
  $pool=&socket("zpool status"); # to check for disks in a pool

  #more options
  #$r=&socket('ps "Get-Disk');
  #$r=&socket('dir /b \ ');
  # $r=&socket('ps Get-PhysicalDisk | Select DeviceID,Status,HealthStatus,Serialnumber,size');

  #$r=~s/\n/   /gs;
  #$r=~s/  +:/: /gs;

  # $r
  #DeviceID          : 1
  #UniqueId          : 6000C299D14A0396309FEB7C108F7D78
  #opt##Objectid          : {1}\\W11\root/Microsoft/Windows/Storage/Providers_v2\SPACES_PhysicalDisk.ObjectId="{00ab754d-cdc9-1
  ####                    1ec-9a6b-806e6f6e6963}:PD:{929f7dd1-184d-b31c-1fe8-4f0b16b6ca98}"
  #Manufacturer      : VMware
  #Model             : Virtual disk
  #CanPool           : True
  #OperationalStatus : OK
  #HealthStatus      : Healthy
  #Serialnumber      : 6000c299d14a0396309feb7c108f7d78
  #size              : 5368709120
  #
  #DeviceID          : 2
  #UniqueId          : 6000C299C804BEEC87E2CF2FEE56FA8D
  #Manufacturer      : VMware
  #Model             : Virtual disk
  #CanPool           : True
  #OperationalStatus : OK
  #HealthStatus      : Healthy
  #Serialnumber      : 6000c299c804beec87e2cf2fee56fa8d
  #size              : 5368709120

  # ..

  @w=();
  @w=split(/DeviceID/,$r);
  @w=sort(@w);
  #&print_array(@w);

  # @w
  #[0] -> '\n\n'
  #[1] -> '          : 1\nUniqueId          : 6000C299D14A0396309FEB7C108F7D78\nManufacturer      : VMware\nModel             : Virtual disk\nCanPool           : True\nOperationalStatus : OK\nHealthStatus      : Healthy\nSerialnumber      : 6000c299d14a0396309feb7c108f7d78\nsize              : 5368709120\n\n'
  #..

  foreach $w (@w) {     # all disks
     if (!($w=~/:/))    { next;}
     #print "w=$w<br>";

     @p=split(/\n/,$w);

     # @w
     #[0] -> '          : 1'    -> DeviceID    -> physicaldrive1
     #[1] -> 'UniqueId          : 6000C299D14A0396309FEB7C108F7D78'
     #[2] -> 'Manufacturer      : VMware'
     #[3] -> 'Model             : Virtual disk'
     #[4] -> 'CanPool           : True'
     #[5] -> 'OperationalStatus : OK'
     #[6] -> 'HealthStatus      : Healthy'
     #[7] -> 'Serialnumber      : 6000c299d14a0396309feb7c108f7d78'
     #[8] -> 'size              : 5368709120'

     #&print_array(@p);

     foreach $p (@p) {
        if (!($p=~/:/)) { next; }
        #print "p=$p<br>";

        foreach $p (@p) {
          @n=split(/ +: +/,$p);
          if ($n[0] eq "") {
            $n[0]="DeviceID";
            $id="physicaldrive$n[1]";

            #all
                if (!($disk{'all'}=~/$id\b/)) {                                 # all disks, nvme are missing
                   $disk{'all'}.="$id\t";
                }
                if (!($disk{'all'}=~/$id\b/)) {                                # all disks, nvme are missing
                   $disk{'all'}.="$id\t";
                }
                next;
          }  else {
               $key="$id\_$n[0]";
                $disk{$key}=$n[1];       # 0_sizs -> 1234

                #canpool-> unused?

                #if (($n[0] eq "CanPool") && ($n[1] eq "True")) {

                  if ($pool=~/$id/is) {   # disk in a pool          # PHYSICALDRIVE1
#&mess("physicaldriv$id<hr>$pool");

                      if (!($disk{'all_poolmember'}=~/$id\b/)) {  # all disks, nvme are missing
                         $disk{'all_poolmember'}.="$id\t";
                      }

                   } else {

                      if (!($disk{'all_unused'}=~/$id\b/)) {       # all disks,
                         if ($id ne "physicaldrive0") {            # asume physicaldrive0= Windows bootdisk
                              if (!($pool=~/$id\b/s)) {            # not a pool member
                                $disk{'all_unused'}.="$id\t";
                              }
                          }  else {
                             if ($disk{'get-disk.pl'} eq "") {
                                $disk{'_get-disk.pl'}="asume physicaldrive0 is Windows bootdisk";
                              }
                          }
                      }
                   }
                #}
                if ($n[0] eq "size") {
                   &get_mydisk_bcap($id,$n[1]);
                }

          }


          # @n
          #[0] -> 'DeviceID'
          #[1] -> '1'

          #&print_array(@n);
        }
     }
  }

  $disk{'all'}=~s/\t+$//;
  $disk{'all_unused'}=~s/\t+$//;
  $disk{'all_poolmember'}=~s/\t+$//;

  #&print_hash(%disk);
  #&print_array(@w);
  #&mess($r);

}

#####################          !!
sub get_mydisk_bcap { #
###################
  my $id=$_[0];                           # diskid
  my $bytes=$_[1];                        # bytes
  my ($ib,$iu,$b,$u,$k);

 # &mess($bytes);
# &print_hash(%disk);
  my $dez=&b_convert("$bytes","b","s");
  my $bin=&b_convert("$bytes","b","is");

  $k="$id\_dcap";
  $disk{$k}="$dez";
  if (!($dez =~/\d/)) { $disk{$k}="-"; }


  $k="$id\_bcap";
  $disk{$k}="$bin";
  if (!($bin =~/\d/)) { $disk{$k}="-"; }

}

# eof
1;