# get zpool status
# disk -> vdev, replaceable etc
#
# (c) napp-it 2010-2024
# jan 2024, win
use strict;


# 1. zpool hash (info)
#######################

# zpool status
  &gethash_sys_myzpool;



########## ok thats it ################
#test
#&print_hash(%zpool);


##############
sub gethash_sys_special  {                                        #hide:    get special vdev info
##############
    my ($r,$p,@p,@l,$size,$free);
    my $pool=$_[0];
    $r=&socket("zpool list -Hpv $pool");     # tab separated, fillrate ohne %, bytes


    #    NAME        SIZE       ALLOC      FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALTROOT
#    c3t1d0      2013265920 1231208448  782057472  -            - 6       61 -     ONLINE
#        mirror  2013265920  434577408 1578688512 -  -            0       21 -     ONLINE
#        c1t2d0        -          -          -          -  - -  -  -     ONLINE
#        c1t3d0        -          -          -          -  - -  -  -     ONLINE
    $r=~s/.* special//s;          # list prior special vdev
    $r=~s/ \w.*//s;               # more/next vdev

    @l=split(/\n/,$r);
    foreach my $l (@l) {
        @p=split(/\s+/,$l);
        if (!($p[2]=~/\d/))  { next; }
        # debug #if ($p[1]=~/mirror/)  { next; }

        $t="$pool\_special_size";
        $zfs{$t}=$zfs{$t}+$p[2];
        $size=$zfs{$t};

        $t="$pool\_special_free";
        $zfs{$t}=$zfs{$t}+$p[4];
        $free=$zfs{$t};

       # &print_hash(%zfs);
       # print_array(@p);
    }
    $t="$pool\_special_used";
    $zfs{$t}=$free/$size*100;
    $zfs{$t}=sprintf("%.0f", $zfs{$t});
    $zfs{$t}.='%';

    $t="$pool\_special_size";
    $zfs{$t}=&b_convert($zfs{$t},"b","d");

   # if ($zfs{$t}>55) { $zfs{$t}='<font style="color:red">'.$zfs{$t}.'</font>'; }
   #&print_hash(%zfs);
   # print_array(@l);
   # &mess($zfs{$t});
}

##############
sub gethash_sys_myzpool  {                                        #hide:    get basic disk and pool infos
##############
  my (@w,$w,$key,$vdev,$k,$n,$b,@l,$l,$t,@d,$d,$m,@pools,$pool,$config,$errors,$v,$c,$i,@data,$repl,$repl_list,$repl_nr);
  my $ant="";


  if ($ant eq "") {
       $ant=&socket('zpool status');                                # get status info
  }
  #&mess($ant);

  @pools=split(/pool: /,$ant);                                 # line 1..n are pools

  #debug
  # print "Content-type: text/html\n\n";   &print_array(@pools);

  # windows
  #        NAME                STATE     READ WRITE CKSUM
  #      tank                ONLINE       0     0     0
  #        mirror-0          ONLINE       0     0     0
  #          physicaldrive1  ONLINE       0     0     0
  #          physicaldrive2  ONLINE       0     0     0

  #[10] -> '(tab) ->NAME                         STATE     READ WRITE CKSUM'
  #[11] -> '        b4                           DEGRADED     0     0     0'
  #[12] -> '        (2sp)raidz3-0                   DEGRADED     0     0     0'
  #                       spare-1
  #[13] -> '                replacing-0              UNAVAIL      0     0     0  insufficient replicas'
  #[14] -> '                  c6t5000C5004E94BE1Ad0  UNAVAIL      0     0     0  cannot open'
  #[15] -> '                  c6t5000C50066259F7Ed0  FAULTED      0     0     0  too many errors'
  #[16] -> '            c6t5000C5003CF4B7C1d0    ONLINE       0     0     0'
  #[17] -> '            replacing-2              DEGRADED     0     0     0'
  #[18] -> '              c6t5000C5004E94C6B0d0  UNAVAIL      0     0     0  cannot open'
  #[19] -> '              c6t5000CCA22BD43247d0  ONLINE       0     0     0  (resilvering)'
  #[20] -> '            c6t5000C5004EC60702d0    ONLINE       0     0     0'
  #[21] -> '            c6t5000C5004E94DC7Ed0    ONLINE       0     0     0'

  # basic
  #                   c6t5000C5004E94DC7Ed0

  # get all vdevs per pool for vdev remove
  # [8] -> '         ->test          ONLINE       0     0     0'        # poolname after tab
  # [9] -> '         ->  c2t1d0      ONLINE       0     0     0'        # basic vdev after tab # 2 spaces
  # [10] -> '        ->  c2t2d0      ONLINE       0     0     0'
  # [11] -> '        ->  mirror-3    ONLINE       0     0     0'        # vdev after tab # 2 spaces
  # [12] -> '        ->    c2t3d0    ONLINE       0     0     0'
  # [13] -> '        ->    c2t4d0    ONLINE       0     0     0'

  #&print_array(@pools);
  foreach $p (@pools) {
      $pool=$p;

      $pool=~s/\n.*//s;              # poolname
      if (!($pool=~/\w/)) { next; }  # not a pool (first line in split)

      #&mess("-$pool-");               #poolname
      @l=();
      @l=split(/\n/,$p);

      #&print_array(@l);            # whole zpool status of $pool
      #[0]  -> 'tank'
      #[1]  -> ' state: ONLINE'
      # ..
      #[5]  -> 'config:'
      #[6]  -> ''
      #[7]  -> '->NAME                STATE     READ WRITE CKSUM'
      #[8]  -> '->tank                ONLINE       0     0     0'
      #[9]  -> '->  physicaldrive2    ONLINE       0     0     0'
      #[10] -> '->  mirror-2          ONLINE       0     0     0'
      #[11] -> '->    physicaldrive1  ONLINE       0     0     0'
      #[12] -> '->    physicaldrive3  ONLINE       0     0     0'
      #[13] -> '->special        ?'
      #[14] -> '->  physicaldrive4    ONLINE       0     0     0'
      #[15] -> '->logs        ?'
      #[16] -> '->  mirror-4          ONLINE       0     0     0'
      #[17] -> '->    physicaldrive7  ONLINE       0     0     0'
      #[18] -> '->    physicaldrive5  ONLINE       0     0     0'
      #[17] -> '->cache'
      #[18] -> '->  physicaldrive6    ONLINE       0     0     0'
      #[19] -> '->spares'
      #[20] -> '->  physicaldrive5    AVAIL   '

      # get all vdevs

      # step1: basic vdev, the come prior special, cache, logs or spares
      $vdev="basic";
      #print "<pre>";

      foreach $l (@l) {
            if ($l=~/special|logs|cache|spares|errors/) { last; }  # end
            if (!($l=~/^\t  physical/)) { next; }
            #print "-$l-<br>";

            if ($l=~/^\t  physical/) {        # basic vdev
                $k="all_vdevs_$pool";
                $disk{$k}.="\tbasic";         # basic
                $disk{$k}=~s/^\t+//;

                # vdev of disk
                $k=$l;
                $k=~s/^\s+//; $k=~s/\s.*//;
                $b.="$k,";

                if (!($disk{'all_basic'}=~/$k/)) {
                  $disk{'all_basic'}.="\t$k";    # basic
                  $disk{'all_basic'}=~s/^\t+//;
                }                               # basic disks
                $k.="_vdev";
                $disk{$k}="basic";
            }
      }


      $vdev="-";
      # step 2 mirror,raidz,draid
      foreach $l (@l) {
            if ($l=~/special|logs|cache|spares|errors/) { last; }  # end

            if ($l=~/^\t  [mrd]/) {             #vdev type
                 $vdev=$l;
                 $vdev=~s/^\s+//;
                 $vdev=~s/\s.*//;
                 $k="all_vdevs_$pool";
                 $disk{$k}.="\t$vdev";         #
                 $disk{$k}=~s/^\t+//;
                 next; # skip to disks
            }

            #print "-$vdev,$l-<br>";
            if ($l=~/physical/)  {
                $d=$l;
                $d=~s/^\s+//;
                $d=~s/\s.*//;
                if ($b=~/$d\b/)   { next; } # disk is a basic or known vdev
            }

            if ($l=~/physical/) {
                   # vdev of disk
                   $k=$l;
                   $k=~s/^\s+//; $k=~s/\s.*//;
                   $b.="$k,";

                   $d="all_$vdev";
                   if (!($disk{$d}=~/$k/)) {
                     $disk{$d}.="\t$k";    #
                     $disk{$d}=~s/^\t+//;
                   }

                   $k.="_vdev";
                   $disk{$k}="$vdev";
                   next;
            }
      }

      #&print_hash(%disk);

      $vdev="-";
      # step 3 special,logs,cache,sparse
      foreach $l (@l) {
            if ($l=~/errors/) { last; }  # end

            if ($l=~/^\t[slc]/) {             #vdev type    special,log,cache,spare
                 $vdev=$l;
                 $vdev=~s/^\s+//;
                 $vdev=~s/\s.*//;
                 $k="all_vdevs_$pool";
                 $disk{$k}.="\t$vdev";         # type
                 $disk{$k}=~s/^\t+//;
                 next; # skip to disks
            }

            if ($l=~/physical/)  {
                $d=$l;
                $d=~s/^\s+//;
                $d=~s/\s.*//;
                if ($b=~/$d\b/)   { next; } # disk is a basic or known vdev
            }

            if ($l=~/physical/) {
                   # vdev of disk
                   $k=$l;
                   $k=~s/^\s+//; $k=~s/\s.*//;
                   $b.="$k,";

                   $d="all_$vdev";
                   if (!($disk{$d}=~/$k/)) {
                     $disk{$d}.="\t$k";    #
                     $disk{$d}=~s/^\t+//;
                   }

                   $k.="_vdev";
                   $disk{$k}="$vdev";
                   next;
            }
            #print "-$l-<br>";

      }

      #&print_hash(%disk);
  }



  $disk{'all_failed'}="";
  $repl_nr="0";
  foreach $p (@pools) {


           if (!($p=~/state: /s)) { next; }                # first line  of array

           $errors=$p; $errors=~s/.*errors:\s+//s;         # get/ remove errors:
           $p=~s/errors: .*//s;

           @l=();
           @l=split(/\n/,$p);

           $c="0";

           foreach $l (@l) {


                    # replacing            tab + 4/6 spaces
                    #   disk               tab + 6/8 spaces (8 on spare-xx)
                    #   disk2

                        if ($l=~/replacing|spare/) {
                          $repl="1";
                          next;
                        }

                        if ($repl eq "1") {
                             if ($l=~/^      +physical/) {            # a replacing disk c1 or 123

                               $t=$l;
                               $t=~s/^\s+//;
                               $t=~s/ .*//;
                               $t=~s/p0$//;
                               $repl_list.="\t$t";
                               $repl_list=~s/^\t+//;
                               $repl_nr++;
                             }
                       }
                       # end of repl/ spare
                       if (!($l=~/^      +\w/)) {
                           if ($repl_nr > 1) {                    # removeable disks only if nr > 0
                                    $disk{'all_replacing'}.="\t$repl_list";
                                    $disk{'all_replacing'}=~s/^\t+//;
                           }

                           $repl="0";
                           $repl_list="";
                           $repl_nr="0";

                       }

                    if ($l=~/^ *physical/) {                           # its a normal disk
                         $t=index($l,"c");

                         $t=$l;
                         $t=~s/^\s+//;
                         $t=~s/ .*//;
                         $t=~s/p0$//;                             # allow bootmirror is ex c1t1d0s0, was $t=~s/s0$|p0$//;

                         # add to inuse
                         if (!($disk{'all_inuse'}=~/$t/)) { $disk{'all_inuse'}.="$t\t";   }

                         #add to replaceable
                         if (!($disk{'all_replaceable'}=~/$t/)) { $disk{'all_replaceable'}.="$t\t";  }

                         if ($v ne "") {
                              $key="all_$v";        # vdev type
                              $disk{$key}.="$t\t";
                         }

                         $key=$t."_vdev";        #c1.._vdev=type
                         $disk{$key}=$v;

                         if ($v=~/mirror/) {
                               #add to all_mirror
                               if (!($disk{'all_mirror'}=~/$t/)) { $disk{'all_mirror'}.="$t\t";  }
                         }


                         $c=index($l,"c");       # first pos of c
                    }


                    if ($l=~/UNAVAIL/) {           # disk or vdev
                         if ($l=~/^\s+physical/)    {   # its a disk
                              $t=$l;
                              $t=~s/^\s+//;
                              $t=~s/ .*//;
                              $t=~s/p0$//;                          # bootmirror is ex c1t1d0s0

                              $key="all_unavail";
                              $disk{$key}.="$t\t";

                              $key=$t."_state";
                              $disk{$key}="UNAVAIL";

                              #get poolname
                              $key=$t."_pool";
                              $t=$p; $t=~s/\n.*//s;    # poolname
                              $disk{$key}=$t;

                              #failed
                              $disk{'all_failed'}.="\t$t";

                         }
                    }
                    if ($l=~/FAULTED/) {               # disk or vdev
                    #print "Content-type: text/html\n\n113";   &print_var($l);
                         if ($l=~/^\s*\d+.*was /)    {   # its a disk gid like: 7421814458019931978 FAULTED 0 0 0 was /dev/dsk/c3t0d0s0'
                              $t=$l;
                              $t=~s/^\s+//;
                              $t=~s/ .*//;
                              $t=~s/p0$//;

                              $key="all_unavail";
                              $disk{$key}.="$t\t";
                              #print "Content-type: text/html\n\n120";   &print_var($p);

                              $key=$t."_state";
                              $disk{$key}="FAULTED";

                              #get poolname
                              $key=$t."_pool";
                              $t=$p; $t=~s/\n.*//s;    # poolname
                              $disk{$key}=$t;

                              #add to replaceable
                              if (!($disk{'all_replaceable'}=~/$t/)) { $disk{'all_replaceable'}.="$t\t";  }

                         }
                    }

                    if ($l=~/^\s+phys/)    {   # its a disk
                        if ($l=~/OFFLINE|REMOVED|UNAVAIL/) {
                           #failed
                           $t=$l;
                           $t=~s/^\s+//;
                           $t=~s/ .*//;
                           $t=~s/p0$//;                          # bootmirror is ex c1t1d0s0
                           $disk{'all_failed'}.="\t$t";
                        }
                    }
           }

           $disk{'all_failed'}=~s/^\t+//;

           #&print_array(@l);
           #&print_hash(%disk);

           #get pool values
           $pool="";
           foreach $l (@l) {              # list of values from pools

                         if ($l eq "") { next; }
                         $l=~s/^\s+//;

                         #get  poolname
                          if ($pool eq "") {
                                 $pool=$l[0];
                                 if (!($zfs{'allpools'}=~/\b$pool\b/)) {
                                     $zfs{'allpools'}.="$pool\t";
                                 }
                                 #if ($pool ne $zfs{'syspool'})  {             # kein syspool
                                   if (!($zfs{'datapools'}=~/\b$pool\b/)) {
                                      $zfs{'datapools'}.="$pool\t";           # tablist
                                   }
                                #}

                                 if ($p=~/\tspecial\b/) {
                                    if (!($zfs{'specialpools'}=~/\b$pool\b/)) {
                                       $zfs{'specialpools'}.="$pool\t";
                                       $t="$pool\_special";
                                       $zfs{$t}="1";
                                       &gethash_sys_special($pool);;  # add special data
                                    }

                                 }

                                 $t="$pool\_config";                     #config state of pool
                                 $config=$p; $config=~s/.*CKSUM\s+$pool\s+//s;
                                 $config=~s/\s+$//s;
                                 $zfs{$t}=$config;

                                 $t="$pool\_errors";                     #config state of pool
                                 $errors=~s/\s+$//s;
                                 $zfs{$t}=$errors;
                                 $l="";
                                 next;
                         }

                         #get id
                         if ($l=~/id: /) {
                                $l=~s/id: //;
                                $t="$pool\_id";
                                $zfs{$t}=$l;                             # tank_id
                                $l="";
                                next;
                         }


                         #get state
                         if ($l=~/state: /) {
                                $l=~s/state: //;
                                $t="$pool\_state";
                                $zfs{$t}=$l;                             # tank_state
                                $l="";
                                next;
                         }

                         #get status
                         if ($l=~/status: /) {
                                $l=~s/status: //;
                                $t="$pool\_status";
                                $zfs{$t}=$l;                             # tank_status
                                $l="";
                                next;
                         }

                         #get action
                         if ($l=~/action: /) {
                                 $l=~s/action: //;
                                $t="$pool\_action";
                                $zfs{$t}=$l;                             # tank_action
                                 $l="";
                                next;
                         }

                         #get scan
                         if ($l=~/scan: /) {
                                $l=~s/scan: //;
                                $t="$pool\_scan";
                                $zfs{$t}=$l;                             # tank_scan
                                $l="";
                                next;
                         }


                         if ($l=~/^$pool\s+/) {                          # poolname ONLINE 0 0 0
                               $l="";
                               next;
                         }


                         #get used disks and pool member                 # if ($l )
                         if ($l=~/^physical/) {                           # disk
                               $l=~s/\t/ /g;
                               $l=~s/ +/\t/;                                # disk state
                               $l=~s/ +/\t/;                                # state read
                               $l=~s/ +/\t/;                                # read write
                               $l=~s/ +/\t/;                                # write cksum
                               $l=~s/ +/\t/;                                # cksum info
                               @d=();
                               @d=(split/\t/,$l);                           # c1t8d0 FAULTED 0 0 0 too many errors

                               # add to part

                               $d[0]=~s/p0$//;                           # no slices but mootmirror is ex c1t1d0s0

                               # add to inuse
                               if (!($disk{'all_inuse'}=~/$d[0]/)) { $disk{'all_inuse'}.="$d[0]\t";   }

                               #add to replaceable
                               if (!($disk{'all_replaceable'}=~/$d[0]/)) { $disk{'all_replaceable'}.="$d[0]\t";  }

                               $t="$pool\_members";                         # pool members
                               $zfs{$t}.="$d[0]\t";

                               $t="$d[0]\_state";                           # disk state
                               $disk{$t}=$d[1];
#&print_var("$t -> $d[1]");
                               $t="$d[0]\_pool";                            #disk pool
                               $disk{$t}=$pool;

                               $t="$d[0]\_rwc";                             # disk read write cksum
                               $disk{$t}="$d[2] $d[3] $d[4]";

                               $t="$d[0]\_info";                            # failure info
                               $disk{$t}=$d[5];

                         }

           }
           $v="";                                           # reset vdev type
           $t="$pool\_members";                             # remove last tab
           $zfs{$t}=~s/\t+$//;


  } # end foreach pool

  $zfs{'allpools'}=~s/\t+$//;
  $zfs{'datapools'}=~s/\t+$//;
  $zfs{'datapools'}=$zfs{'allpools'};
  $zfs{'specialpools'}=~s/\t+$//;

  $disk{'all_dsk_with_part'}=~s/\t+$//;                         #

  $disk{'all_inuse'}=~s/\t+$//;
  $disk{'all_replaceable'}=~s/\t+$//;

  $disk{'all_replacing'}=~s/\t+$//;

  $disk{'all_basic'}=~s/\t$//;
  $disk{'all_mirror'}=~s/\t$//;
  $disk{'all_raidz'}=~s/\t$//;
  $disk{'all_logs'}=~s/\t$//;
  $disk{'all_cache'}=~s/\t$//;
  $disk{'all_spares'}=~s/\t$//;
  $disk{'all_unavail'}=~s/\t$//;

  #add to %sys
  # print "Content-type: text/html\n\n";
  #&print_hash(%disk);
  #&print_hash(%zfs);

  # !! %disk must not be the up to date, only processed uner disks or pools

}


# eof
1;