#!

##############
# interface.pl
# all interface relevant functions are in this library
#############################

# windows only
# jan. 22 2024

############################
# If you like to bundle or distribute napp-it, you need an agreement with a bundling license
# on a per appliance base using continious serial numbers for your appliances
############################


################
# script to build the html header and to create napp-it menus and submenus
# per default this script is located in /var/web-gui/data/napp-it/zfsos/_lib/interface.pl

# if you like to create your own GUI, copy this file to
# /var/web-gui/_my/zfsos/_lib/interface.pl and edit/modify the file
# if you have this file it is loaded instead the default one (survive napp-it updates)


# menu translations                    3
# per default, napp-it displays the folder name as menu description
# if you have a file  /var/web-gui/data/napp-it/zfsos/_lib/lang/en/about_menus.txt it is used
# for names and to hide an item (at all or for non admins)

# if you copy the language files (menu.txt, 00.txt etc) to /var/web-gui/_my/zfsos/_lib/lang/
# they will be used instead. These files under a _my folder are independant from napp-it updates
# most important is the about_menus.txt


#################

use strict;
use File::Find;
&mh;

# exp  iop
if (($sys{'edition'} ne "Pro") && ($cfg{'select_lang'}=~/my|app/i))  {
  if (($in{'l1'} eq "")) {
    $in{'l1'}="20_Extensions";
    $in{'l2'}="01_register";
  }
  # no main menu system
  if (($in{'l1'} =~/^03/) || ($in{'l2'} eq "")) {
    $in{'l2'}="90_Settings";
  }
  if (($in{'l1'} =~/^20/) || ($in{'l2'} eq "")) {
    $in{'l2'}="01_register";
  }
  if (($in{'l1'} =~/^04/) || ($in{'l2'} eq "")) {  # user restore
    $in{'l2'}="20_Restore settings";
  }
}


#get private menus, add all folders for menu to $current{'menus'} on loading this lib
# my $p=&socket("dir $sys{'myospath'} /b");                   # only folders with action.pl

#################
&find_directories("$sys{'myospath'}\\");      #                # private filders end with a + ex 01_mymenu+
#&mess($current{'menues'});
my $p=$current{'menues'};

#$p=~s/$sys{'myospath'}//gs;
my @p=();
@p=split(/\n/,$p);

my $tt;
my @myp=();

my @t=();
$p="\t";
foreach my $t (@p) {
         # if (!($t=~/action\.pl$/)) { next; }
        if (!($t=~/\d+\_/)) { next; }
          $t=~s/\/action\.pl//;


          @myp=split(/\//,$t);
          foreach my $tt (@myp) {
              if ($tt=~/\=/) {
                  $tt=~s/\=/\&deg;\=/g;
              } else {
                #  $tt.="&deg;";
              }
          }
          $t = join("\/", @myp);

          push (@t,$t);
          $p.="$t\t";
}

#


#&print_array(@t);
# add all default menus
#&print_hash(%sys);
#&mess($sys{'ospath'});

################
&find_directories("$sys{'ospath'}");     # war os
my $o=$current{'menues'};
#&mess("$sys{'ospath'}<hr>$o");

my @n=();
@n=split(/\n/,$o);                                        # all default menus from $o

# add default to my menus
if (-f "$sys{'tmp'}\\napp-it_edit_on") {                   # allow double entries
    foreach my $t (@n) {
          if (!($t=~/\d_/)) { next; }                      # not a menu
          push (@t,$t);
    }
} else {
    foreach my $t (@n) {
          if ($p=~/\t$t\t/s) { next; }                     # no double entries
          if (!($t=~/\d_/))  { next; }
          push (@t,$t);
    }
}

### internal menus
    push(@t,"00_napp-it");

   #about
   push(@t," <a class=\"li2\" href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;l1=$in{'l1'}&amp;l2=about\"> $txt{'m00.00'}</a><font class='li2'> </font>");            # about

   #help
   if (!($txt{'m00.01'}=~/_H/))   {            # hide this menu item
        push(@t,"  <a class=\"li2\" href=\"http://www.napp-it.org\" target=\"_blank\">$txt{'m00.01'}</a><font class='li2'> </font>");            # help
   }

   if ($in{'id'}=~/^admin,/) {
           push(@t,"00_napp-it/02_settings");
         # push(@t,"00_napp-it/03_multilingual");                    # unsure on windows   ?
         # push(@t,"00_napp-it/04_functions");
         # push(@t,"00_napp-it/05_security");
         # push(@t,"00_napp-it/06_update");
         # push(@t,"00_napp-it/07_contribute");
   }
## end internal menus

# sort menu
@t=sort(@t);

# 'C:/xampp/web-gui/data/napp-it/zfsos/08_Snaps and clones/action.pl'
foreach my $t (@t) {
   $t=~s/.*zfsos.//;
   $t=~s/.action.pl//;
}
# '08_Snaps and clonesl

#debug
#&print_array(@t);

foreach my $t (@t) {
        if ($t=~/^_/)           { next; }  # ex libs
        if (!($t=~/^\d+_/))     { next; }  # ex libs

        @p=();
        @p=split(/\//,$t);

        #main menu l1
        if (@p==1) {
            if (!($p[0]=~/^\d+/ ))   { next; }

            $current{'menu'}.="\t$p[0]";
            $current{'menu'}=~s/^\t//;

            #numbers
            $o=$p[0];

            $o=~s/_.*//;

            $current{'menu_nr'}.="\t$o";
            $current{'menu_nr'}=~s/^\t//;

            next;
        }

        # menu l2 ex menu_01
        if (@p==2) {
            $o=$p[0];            # l1
            $o=~s/_.*//;

            if (!($o=~/^\d+/ ))   { next; }

            $i="menu_$o";
            $current{$i}.="\t$p[1]";
            $current{$i}=~s/^\t//;

            #numbers
            $p=$p[1];
            $p=~s/_.*//;
            $i="menu_nr_$o";
            $current{$i}.="\t$p";
            $current{$i}=~s/^\t//;

            next;
        }

        # menu l3 ex menu_01_01
        if (@p==3) {
            $o=$p[0];            # l1

            $o=~s/_.*//;


            if (!($o=~/^\d+/ ))   { next; }

            $p=$p[1];            # l1
            $p=~s/_.*//;


            if (!($p=~/^\d+/ ))   { next; }

            $i="menu_$o\_$p";
            $current{$i}.="\t$p[2]";
            $current{$i}=~s/^\t//;

            #numbers
            $i=$p[2];
            $i=~s/_.*//;
            $p="menu_nr_$o\_$p";
            $current{$p}.="\t$i";
            $current{$p}=~s/^\t//;

        }
}

#debug: show menus
#&mess($current{'menus'});
#&print_hash(%current);



###################
sub get_langtext {
################### display text from language files instead of foldername
#                   return (txt, edit)
&mess("obsolet function get_langtext");
}

##


##############
sub history {
############## links below current level + edit,rename,delete

      my ($l0,$l1,$l2,$l3,$history,$last,$txt,$opt,$i1,$i2,$i3);
      my $gt="<img src=\"/_doc/menu/ico/gt.png\" alt=''>";          # >>

      $l0="\&nbsp;<a title=\"home\" class=\"hist\" href=\"$current{'menu_href'}\"> home $gt </a>";             # home link
      $l0=~s/=l.=//g;

      if ($in{'l1'} ne "") {
           $i1=$in{'l1'};
           $i1=~s/_.*//;
          ($txt,$opt)=&l_opt($in{'l1'},$i1);
           $l1=" <a title=\"$in{'l1'}\" class=\"hist\" href=\"$current{'menu_href'}\">$txt</a>";
           $last=$in{'l1'};
      }

      if ($in{'l2'} ne "") {
           $i2=$in{'l2'};
           $i2=~s/_.*//;
          ($txt,$opt)=&l_opt($in{'l2'},"$i1.$i2");
           $l2=" $gt <a title=\"$in{'l2'}\" class=\"hist\" href=\"$current{'menu_href'}\">$txt</a>";
           $last=$in{'l2'};
      }

      if ($in{'l3'} ne "") {
           $i3=$in{'l3'};
           $i3=~s/_.*//;
          ($txt,$opt)=&l_opt($in{'l3'},"$i1.$i2.$i3");
           $l3=" $gt <a title=\"$in{'l3'}\" class=\"hist\" href=\"$current{'menu_href'}\">$txt</a>";
           $last=$in{'l3'};
      }

      $l1=~s/=l1=/$in{'l1'}/; $l1=~s/=l2=//;            $l1=~s/=l3=//;              # insert link
      $l2=~s/=l1=/$in{'l1'}/; $l2=~s/=l2=/$in{'l2'}/;   $l2=~s/=l3=//;
      $l3=~s/=l1=/$in{'l1'}/; $l3=~s/=l2=/$in{'l2'}/;   $l3=~s/=l3=/$in{'l3'}/;
      $history="$l0 $l1 $l2 $l3 ";

      #&print_hash(%in);
      # editoptions: del edit, -> disable
      if (!(($in{'l1'} eq "") || ($in{'l1'} eq "00_napp-it"))) {
         if (-f "$sys{'tmp'}\\napp-it_edit_on") {

           #edit/show (always)
           if ($last=~/[^A-Za-z0-9_\-\= ]/)  { $t="edit"; } else { $t="show";}

           #only on pro
           #if ($sys{'edition'} eq "Pro") {
             #$history.="\&nbsp;\&nbsp; [ \&nbsp; <a title=\"edit $last\" style=\"color:#ba2f28\" href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;action=editmenu&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=yes\"> $t </a> ";
           #}

           #rename if private
           if ($last=~/[^A-Za-z0-9_\-\= ]/) {
              #$history.="\&nbsp;\&nbsp;  <a title=\"rename $last\" style=\"color:#ba2f28\" href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;action=renamemenu&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=yes\"> rename </a> ";
           }

           #del if private
           if ($last=~/[^A-Za-z0-9_\-\= ]/) {
            #  $history.="\&nbsp;\&nbsp;  <a title=\"delete $last\" style='margin-left: 5px;color:#ba2f28' href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;action=removemenu&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}\"onclick=\"return(confirm('delete menu item $last?'))\"> <b>del</b> </a> ";
           }
           $history.=" \&nbsp; ]\n";
        }
      }
      return ($history);

}

##############
sub history2 {
############## links below current level +add
 my (@m,$t,$o,$i,$i1,$i2,$i3,$h2);
 my $gts="<img src=\"/_doc/menu/ico/gts.png\" alt=''>";          # >>

 #top-level (/)
 if ($in{'l1'} eq "")    {
        # main-menu
        @m=split(/\t/,$current{'menu'});
        @m=sort(@m);
        foreach my $m (@m) {
            $i1=$m; $i1=~s/_.*//;
            ($t,$o)=&l_opt($m,$i1);
            if ($o=~/A|H/) { next; }

            if ($sys{'edition'} ne "Pro")  { next; }

            $h2.="  $gts <a  title=\"$m\" href=\"$current{'menu_href'}\">$t</a>\n";
            $h2=~s/=l1=/$m/gs; $h2=~s/=l.=//gs;
        }
 }

 #1st-level (ex disks)
 if (($in{'l1'} ne "") && ($in{'l2'} eq "")) {

        $i1=$in{'l1'}; $i1=~s/_.*//;
        $i="menu_$i1";
        @m=split(/\t/,$current{$i});
        @m=sort(@m);
        foreach my $m (@m) {
            $i2=$m; $i2=~s/_.*//;
            ($t,$o)=&l_opt($m,"$i1.$i2");
            if ($o=~/A|H/) { next; }
            if ($sys{'edition'} ne "Pro")  { next; }

            $h2.="  $gts <a title=\"$m\" href=\"$current{'menu_href'}\">$t</a>\n";
            $h2=~s/=l1=/$in{'l1'}/gs; $h2=~s/=l2=/$m/gs; $h2=~s/=l3=//gs
        }
 }

  #2nd-level (ex disks/replace)
 if (($in{'l1'} ne "") && ($in{'l2'} ne "")) {
        $i1=$in{'l1'}; $i1=~s/_.*//;
        $i2=$in{'l2'}; $i2=~s/_.*//;

        $i="menu_$i1\_$i2";
        @m=split(/\t/,$current{$i});
        @m=sort(@m);
        foreach my $m (@m) {
            $i3=$m; $i3=~s/_.*//;
            ($t,$o)=&l_opt($m,"$i1.$i2.$i3");
            if ($o=~/A|H/) { next; }
            $h2.="  $gts <a title=\"$m\" href=\"$current{'menu_href'}\">$t</a>\n";
            $h2=~s/=l1=/$in{'l1'}/gs; $h2=~s/=l2=/$in{'l2'}/gs; $h2=~s/=l3=/$m/gs
        }
 }

 # editoptions: add, remove, edit
 if (-f "$sys{'tmp'}\\napp-it_edit_on") {
     if ($in{'l1'} ne "00_napp-it") {
        #add ?? obsolet
        #  $h2.="\&nbsp;\&nbsp; [ \&nbsp; <a title=\"add new menu\" style=\"color:#ba2f28\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=addmenu\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\"> <b>add</b> </a> &nbsp;]";
    }
 }
  #&mess("$in{'l1'},$in{'l2'},$in{'l3'}");
  return ("$h2");

}
##########



##########
sub menu {
##########  create console and menu
my ($menu1,$mainvmenu,$mainhmenu,$menus1,$menus2,$history,$history2,$t);

#topmenu ex logout
&topmenu;

##history2  (links below current level)
$history2=&history2();

##history  (current level)
$history=&history();

if ($in{'l1'} eq "")   { $in{'l1'}="00_napp-it"; }             # default


## print history border first
print <<EoF;
<div id="history"></div>

EoF

#debug
#&print_hash(%txt);

#headline
&headline;

$menu1=&menu_1;                                               # css menus

print <<EoF;

<div id="menupos">
<ul id="menu">
$menu1
</ul>
<!-- end menu -->
</div>

EoF

#debug
#exit;

#add console
&console;


# add history links on top
# add links below history
print <<EoF;


<div id="hist">$history</div>

<div id="hist2">$history2</div>

<div id="content" style="margin: 85px 0px 0 5px; width: 100%">          <!-- to < end body> -->



EoF

# obsolete
# edit-menu add
#if ($in{'action'} eq "addmenu" )    { &menue_add; }

# edit-menu rename
#if ($in{'action'} eq "renamemenu" ) { &menue_rename; }

# edit-menu edit,
#if ($in{'action'} eq "editmenu" )   { &edit_file; }                     # show sction only

# edit-menu del
#if ($in{'action'} eq "removemenu" ) { &menue_remove; }



}

#############
sub menu_1 {       # main menu
#############
   my (@m,$m,$menu,$i,$txt,$opt,$out,$m1,$m2);
   # get menu items
   # print 1st level menu, call prior to submenu definitions

   @m=split(/\t/,$current{'menu'});
   foreach $m (@m) {
      $i=$m;
      $i=~s/\_.*//;

      ($txt,$opt)=&l_opt($m,$i);                  # get text and options

      if ($opt=~/H|A/)     { next; }              # Hide

      if (($sys{'edition'} ne "Pro") && ($cfg{'select_lang'}=~/my|app/i))  {             # iopstor
         if (!($m=~/00|03|04|20/)) { next; }     #about system, extensions, user
      }

      $txt=~s/^\d+_//;                            # without nr

      $m2=&menu_2($m);
      $t=$m;
      $t=~s/=.*//;
      $t=~s/_/ /g;
      #$t=uc($t);

      $out.=<<EoF;

      <!-- l1 main menu $i -->
      <li>
           <a title=\"$t\" href=\"=href=\">=text=</a>$m2
      </li>

EoF

      # update menu items
      #if ($m=~//) { $txt.=""; $txt=~s/+//; }  # my menus end with + now
      $out=~s/=text=/$txt/gs;

      $out=~s/=href=/$current{'menu_href'}/gs;
      $out=~s/=l1=/$m/gs;
      $out=~s/=l2=//gs;
      $out=~s/=l3=//gs;
   }


   $out=<<EoF;

<!--        l1 menu          -->
$out
<!--        /l1 menu         -->
EoF

   return ($out);
}




############
sub menu_2 {       # 2nd level menu
############
my ($first,$item,$mitem,$items,$m,@m,$i,$opt,$out,@n,$n,$s,$nr,$txt,$nr2,$txt2,$txt,$ico,$n2,$m1,$m2);
$m1=$_[0];               # submenu for main menu item

# all menus numbers are in $current{'menu'}
@m=split(/\t/,$current{'menu'});
@m=sort(@m);

foreach my $m (@m) {                                    # m=l1 level

        if ($m ne $m1)  { next; }                       # omly current main menu

        $nr=$m;  $nr=~s/_.*//;
        $txt=$m; $txt=~s/^\d+_//;

        $ico=$nr;

        #localization
        $i="m$nr";
        if ($txt{$i} ne "") {
             $txt=$txt{$i};
        }


        $i="menu_$nr";
        @n=();
        @n=split(/\t/,$current{$i});                      # nn_names
        @n=sort(@n);

        if (@n < 1) {  return; }                          # no l3 menu

        # repeat l1 menu
        $current{'ico_folder'}="/_doc/menu/ico";
        $first=<<EoF;

           <!-- repeat menu $nr -->
           <li class="subbg0" style="">
              <a href="=href="><img src="$current{'ico_folder'}/$nr.png" class="icons">$txt</a>
           </li>
           <li style="height:3px">&nbsp;</li>
EoF


        $first=~s/=href=/$current{'menu_href'}/gs;
        $first=~s/=l1=/$m/gs;
        $first=~s/=l2=//gs;
        $first=~s/=l3=//gs;

        foreach my $n (@n) {

                 $nr2=$n;
                 $nr2=~s/_.*//;

                 $i="$nr.$nr2";
                 ($txt2,$opt)=&l_opt($n,$i);
                 if ($opt=~/H|A/)     { next; }             # Hide


                 #hide
                 if ($sys{'hide'}=~/,$i,/) { next; }

                # new ul
                $current{'l3_menu_avail'}="0";
                $m2=&menu_3("$m","$n");

                $out.=<<EoF;

           <!-- l2 sub menu $nr.$nr2 -->
           <li class="=bg=">
              <a href="=href="><img src="$current{'ico_folder'}/=ico=" class="icons">$txt2</a>$m2
           </li>
EoF

                 #bg or bgmore
                 if ($current{'l3_menu_avail'} eq "1") {
                    $out=~s/=bg=/subbgmore/gs;                           # subbgmore
                 } else {
                    $out=~s/=bg=/subbg/gs;
                 }


                 $out=~s/=text=/$txt2/gs;
                 if ($opt=~/I/) {                # I or I20
                      if ($opt=~/\d/) {          # I20 -> Icon 20.png
                         $n2=$opt;
                         $n2=~s/\D//;
                         $ico=$n2;
                      } else {
                         $ico="$nr.$nr2";
                      }

                      $out=~s/=ico=/$ico.png/gs;
                 } else {
                      if ($txt2=~/help|info/i)  {
                         $out=~s/=ico=/info24.png/gs;         # default info icon
                      }
                      if ($txt2=~/remove|destroy/i)  {
                         $out=~s/=ico=/critical24.png/gs;     # default info icon
                      }
                      if ($txt2=~/extension/i)  {
                         $out=~s/=ico=/20.png/gs;             # default info icon
                      }

                      $out=~s/=ico=/sp24.png/gs;               # default transparent icon

                 }
                 $out=~s/=href=/$current{'menu_href'}/;
                 $out=~s/=l1=/$m/gs;
                 $out=~s/=l2=/$n/gs;
                 $out=~s/=l3=//gs;


        }

   $out=<<EoF;

           <ul>
$first
$out
           </ul>
EoF

        $out=~s/menu_i/menu_$nr/gs;
  }
  return ($out);
}



############
sub menu_3 {   # 3rd level menu
############
my ($m1,$m2,$m3,@m1,@m2,@m3,$item,$mitem,$items,$m,@m,$i,$opt,$out,@n,$n,$s,$txt,$txt2,$pre,$post,$nr3,@s,$f,$mtxt,$nr,$nr1,$nr2,$nr3,$n2,$ico);

$m1=$_[0];
$m2=$_[1];


@m1=split(/\t/,$current{'menu'});                                         # main menu numbers
foreach my $m (@m1) {                                                     # m=l1 level

   if ($m ne $m1)  { next; }                                              # omly current main menu

   $mtxt=$m;
   $mtxt=~s/^d+\_//;

   $nr1=$m;
   $nr1=~s/_.*//;
                                                          # nr only
   $i="menu_$nr1";
   @m2=split(/\t/,$current{$i});

   if (@m2==0) { next; }
   foreach $s (@m2) {

        if ($s ne $m2)  { next; }                                              # omly current l2 menu

        $nr2=$s;  $nr2=~s/_.*//;

        $txt=$s; $txt=~s/^\d+_//;

        @n=();          # names
        $i="menu_$nr1\_$nr2";

        @n=split(/\t/,$current{$i});
        if (@n==0) { next; }

        $out.=$pre;
        $out=~s/=n=/($m.$s)/s;


        foreach $n (@n) {

                 $nr3=$n;
                 $nr3=~s/_.*//;

                 $i="$nr1.$nr2.$nr3";
                 ($txt2,$opt)=&l_opt($n,$i);

                 if ($opt=~/A|H/)     { next; }             # Hide

                 #hide
                 if ($sys{'hide'}=~/\b$i\b/) { next; }

                 $current{'l3_menu_avail'}="1";                                         # used fore more background
                 $out.=<<EoF;

                 <!-- l3 sub menu $nr1.$nr2.$nr3 -->
                 <li class="=bg=">
                    <a href="=href="><img src="$current{'ico_folder'}/=ico=" class="icons">$txt2</a>$m3
                 </li>
EoF

                 $out=~s/=text=/$txt2/gs;

                 if ($opt=~/I/) {                # I or I20
                      if ($opt=~/\d/) {          # I20 -> Icon 20.png
                         $t=$opt;
                         $t=~s/\D//;
                         $ico=$t;
                      } else {
                         $ico="$nr1.$nr2.$nr3";
                      }

                      $out=~s/=ico=/$ico.png/gs;
                 } else {
                      $out=~s/=ico=/sp24.png/gs;               # default transparent icon

                 }

                 $out=~s/=href=/$current{'menu_href'}/;

                 $out=~s/=l1=/$m/g;
                 $out=~s/=l2=/$s/g;
                 $out=~s/=l3=/$n/g;

                 #bg
                 $out=~s/=bg=/subbg/gs;                           # subbg or subbgmore
        }
   $out=<<EoF;

              <ul>
$out
              </ul>
EoF
        $out=~s/menu_i/menu_$nr1\_$nr2/gs;
   }
}


return ($out);
}



############
sub topmenu  {
############ headline
my ($url_lang);
my $u=$in{'id'}; $u=~s/,.*//;

my $status=&ample_state('','default');         # default status

 # switch Language from xx to en and back if lang ne "en"

   if ($cfg{'select_lang'} ne 'en') {
       $url_lang="<a title=\"switch menu from $cfg{'select_lang'} to en\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;lang=en\"> $cfg{'select_lang'} </a> |";
       if (-f "C:/xampp/web-gui/_log/force_en.log") {
               $url_lang="<a title=\"switch menu to $cfg{'select_lang'}\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;lang=$cfg{'select_lang'}\"> en </a> |";
       }
       if (-d "C:/xampp/web-gui/_my/zfsos/_lib/lang/MY!") {
               $url_lang ="MY! | ";           # show either MY!
               $url_lang =" ";                # or nothing per default
       }
  }
  # optional
  # if folder /var/web-gui/data/napp-it/_my/zfsos/_lib/lang/menus.txt exists it is used always !!
  # $url_lang="";  # hide lang switch


#editing hide/on/off
   my $url_edit_on="<a title=\"enable logs and edit\"  style=\"text-decoration: line-through;\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;editing=yes\"> <b> Edit </b></a> |";
   my $url_edit_off="<a title=\"disable logs and edit\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;editing=no\"> <b style='color:#ba2f28'>Edit:</b></a> |&nbsp;";
   my $url_edit="";

   if ($in{'editing'} eq 'yes')                                               {
     &socket("echo '' > $sys{'tmp'}\\napp-it_edit_on");
     #debug
     #print &socket("dir $sys{'tmp'}");  exit;
     &reload;
   }
   if (($in{'editing'} eq 'no') && (-f "$sys{'tmp'}\\napp-it_edit_on"))       {
     &exe("del $sys{'tmp'}\\napp-it_edit_on");
     &reload;
   }

   if (!(-f "$sys{'tmp'}\\napp-it_edit_on")) {
      $url_edit=$url_edit_on;
   }  else {
      $url_edit=$url_edit_off;
   }

  # if ($cfg{'select_editable'} eq "no")  { $url_edit=""; }
  # if ($txt{'app_editmenu'} =~/no/)      { $url_edit=""; }                 # in aboiut_menus
  # if (!($sys{'edition'} eq "Pro"))      { $url_edit=""; }                 # always on

   # optional
   # $url_edit="";  # hide edit switch

   # monitor on/off
      my $url_mon_on="<a title=\"enable realtime monitor agents\"  style=\"text-decoration: line-through;\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;monitor=yes\"> <b> Mon </b></a> ";
      my $url_mon_off="<a title=\"disable realtime monitor agents\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;monitor=no\"> <b> Mon </b></a>";
      my $url_mon="";

      if ($in{'monitor'} eq 'no')   { &exe("echo ' ' > C:/xampp/web-gui/_log/monitor_off"); print "<pre>disable stat agents</pre>"; &about_stat_disable; &reload; }
      if ($in{'monitor'} eq 'yes')  { &exe("del C:/xampp/web-gui/_log/monitor_off");    print "<pre>enable stat agents</pre>";  &about_stat_enable;  &reload; }

      if (-f "C:/xampp/web-gui/_log/monitor_off") {
         $url_mon=$url_mon_on;
      }  else {
         $url_mon=$url_mon_off;
      }
      if (!($cfg{'ver'}=~/c|m/)) { $url_mon="<a title='Stat monitoring requires monitor extension' href='#' style='text-decoration: line-through'>Mon</a>"; }


    #agent accelaereation on/off
      my $url_acc_on="<a title=\"enable napp-it Pro agents acceleration\"  style=\"text-decoration: line-through;\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;agent_acc=yes\"> <b> Acc </b></a> ";
      my $url_acc_off="<a title=\"disable napp-it Pro agents acceleration\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;agent_acc=no\"> <b> Acc </b></a>";
      my $url_acc="";

      if ($in{'agent_acc'} eq 'no')    { &exe("echo '' > C:/xampp/web-gui/_log/accelerate_off"); print "<pre>disable accelaration agents</pre>"; sleep(2); &about_acc_disable; &reload; }
      if ($in{'agent_acc'} eq 'yes')   { &exe("del C:/xampp/web-gui/_log/accelerate_off");    print "<pre>enable accelaration agents</pre>";  sleep(2); &about_acc_enable; &reload; }

      if (-f "C:/xampp/web-gui/_log/accelerate_off") {
         $url_acc=$url_acc_on;
      }  else {
         $url_acc=$url_acc_off;
      }
      if (!($cfg{'ver'}=~/\w/)) { $url_acc="<a title='GUI agent acceleration requires napp-it Pro' href='#' style='text-decoration: line-through'>Acc</a>"; }


 @t=split(/,/,$in{'id'});
 if ($sys{'auto_os'}=~/Win/i) {


 $url_acc="";                # not on win
 $url_mon="";

 #create topmenu
 print<<EoF;
   <div id="topmenu">
   |
   <a title="logout $t[1]" href=\"/cgi-bin/admin.pl?action=logout_$t[1]"><b>logout: $u</b></a>
   |
   $url_lang
   $url_edit
   $sys{'m_links'}

   $url_mon

   $url_acc

   </div>

$status
EoF
} #
}

##############
sub headline {
############## headline
 print<<EoF;
   <div id="hl">
        $txt{'processing'}
   </div>
   <br>
EoF
}

#############
sub console {
############# input shell_command + history + headline

# console
  if ($in{'id'}=~/^admin,/) {
         print<<EoF;

<div id="console">
         <form name="con" method="post" action="/cgi-bin/admin.pl" style="display:inline">
         <input type="hidden" name="cons" value="1">
         <input type="hidden" name="id" value="$in{'id'}">
         <input type="hidden" name="l1" value="$in{'l1'}">
         <input type="hidden" name="l2" value="$in{'l2'}">
         <input type="hidden" name="l3" value="$in{'l3'}">

         <input type="hidden" name="action" value="input">
         <input type="hidden" name="edited" value="1">

         <input type="text" name="console" style='font-size: 12px; width: 170px; height:12px'>
         <input type='submit' name='submit' value="cmd" style='font-size: 10px; margin-right: 0px' onclick="return(confirm(\'$txt{'txt_console'}\'))">
        </form>
        <script type="text/javascript">document.con.console.focus()</script>

EoF
       if (($in{'edited'}) && ($in{'console'}=~/\w+/)) { &console_do;  }
       print "</div>\n\n";
   }

   return;
}  # /


#################
sub console_do {
################# input shell_command
  my ($r,@r,$do,$f);
  if (!($in{'id'}=~/^admin,/)) {
         print "<div style='color: red'>Console: only for admin!</div>";
  } else {

      print <<EoF;
      <script type="text/javascript">
         \$("#mylog_close").animate({height: 'show', opacity: 'show'}, 'fast');
         \$("#mylog_cmd").animate({height: 'show', opacity: 'show'}, 'slow');
         \$('#hl').html('console')
      </script>
EoF

     &log_add("interface.pl 894# $in{'console'}");
     $r=&exe($in{'console'});

    exit;
 }
}  # /


############
sub header {
############


## websocket for realtime communication ##
my  $ample=&ample_state("id=$in{'id'}:l1=$in{'l1'}:l2=$in{'l2'}:l3=$in{'l3'}:action=$in{'action'}:zfs=$in{'zfs'}:list=$in{'list'}:prop=$in{'prop'}:prop2=$cfg{'ver'}");

my ($history);
my $hn=&exe('hostname');          # display hostname
if ($hn=~/password for/)  {
         $hn.="\n<br>    <font style='color: red'>setup error: allow user napp-it to use sudo in /etc/sudoers </font><br>";
}
my $css="";
if ($txt{'app_css'} ne "") {
   $css="  <link rel='stylesheet' type='text/css' href=\'$txt{'app_css'}\'>";
} else {
   $css="  <link rel='stylesheet' type='text/css' href='/_doc/menu.css'>";
}

my $js="";
if ($txt{'app_script'} ne "") {
   $js="  <script type='text/javascript' src=\'$txt{'app_script'}\'></script>";
} else {
   $js="  <script type='text/javascript' src='/_doc/napp-it.js'></script>";
}

my $title;
my $encoding="iso-8859-1";
if ($txt{'app_text_encoding'}=~/\w/) {
    $encoding=$txt{'app_text_encoding'};
}

if ($txt{'app_title'} ne "") {
  $title="$hn // $txt{'app_title'}";
} else {
  $title="$hn // ZFS appliance ";
}

my $logo;
# use _my/logo.png when available
if (-f "C:/xampp/web-gui/_my/wwwroot/logo.png") {
     $txt{'app_logo'}="<img src='/_my/logo.png' alt=''>";
}


if ($txt{'app_logo'} ne "") {
  $logo="$txt{'app_logo'}";
} else {
  if ($sys{'edition'}=~/pro/i) {
    $logo="<img src='/_doc/logo-p.png' alt=''>";
    $sys{'hide'}="";
  } else {
    $logo="<img src='/_doc/logo.png' alt=''>"; # free
    $sys{'hide'}=$sys{'fr'};
  }
  if ($cfg{'ver'}=~/e/i) {
      $logo="<img src='/_doc/logo-e.png' alt=''>";
  }
  if ($cfg{'ver'}=~/h/i) {
      $logo="<img src='/_doc/logo-h.png' alt=''>";
      $sys{'hide'}=$sys{'ho'};
  }
}

my $os;
if ($txt{'app_os'} ne "") {
  $os="$txt{'app_os'}";
} else {
  $os="";
}


my $favicon="/favicon.ico";
# use _my/favicon.ico when available
if (-f 'C:\xampp\web-gui\_my\wwwroot\favicon.ico') {
     $favicon="/_my/favicon.ico";
}
if ($txt{'app_favicon'} ne "") {  $favicon="$txt{'app_favicon'}"; }


my $logout;
if ($txt{'app_timeout'} eq "") {  $txt{'app_timeout'}="3600";  }   # default 1h, overwrite in about_menus.txt
if ($in{'id'}=~/operator/) {
    $logout="<meta http-equiv=\"refresh\" content=\"$txt{'app_timeout'};url=/cgi-bin/admin.pl?action=logout_operator\" />";
} else {
    $logout="<meta http-equiv=\"refresh\" content=\"$txt{'app_timeout'};url=/cgi-bin/admin.pl?action=logout_admin\" />";
}

my $rgraph=<<EoF;   # needed always or in about/statistics?
  <!-- rgraph related on about and statistics -->
  <script src="/_doc/rgraph/RGraph.common.core.js" ></script>
  <script src="/_doc/rgraph/RGraph.common.dynamic.js" ></script>
  <script src="/_doc/rgraph/RGraph.common.tooltips.js" ></script>
  <script src="/_doc/rgraph/RGraph.common.key.js" ></script>
  <script src="/_doc/rgraph/RGraph.hbar.js" ></script>
  <!--[if lt IE 9]><script src="/_doc/excanvas/excanvas.js"></script><![endif]-->
EoF

print <<EoF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
 <title>$title</title>
 <meta http-equiv="Content-Type" content="text/html; charset=$encoding">
 $logout
 <link rel="icon" href="$favicon" type="image/x-icon">

 <!-- jquery, always needed -->
 <script type="text/javascript" src="/_doc/menu/inc/jquery-3.2.1.min.js"></script>

 <!-- predefine to avoid error if missing on some pages -->
<script type="text/javascript">
   function  rgraph_iostat()      { }
   function  rgraph_arczilstat()  { }
   function  rgraph_netstat()     { }
   function  rgraph_cpustat()     { }
   function  rgraph_servicestat() { }
</script>

 <!-- napp-it related, you may edit a copy under /_my/ -->
 $css
 $js

 $rgraph

$ample

</head><body>

<div id="header">
  <div id="header2">
    <div id="nilogo">$logo</div>
    <span id="host">$hn</span>
    <span id="release">$os ZFS appliance $sys{'edition'} v. $sys{'version'} </span>
   </div>
</div>

EoF

return;
##############
}

#########     #   ask user
sub ask {     #   &ask('type_(n)','info','current','allowed','w1')
##########        type= begin,end,submit,confirm value,text,radio,checkbox,hidden
  my ($p1,$p2,$p3,$p4,$w,$txt,$i,$w1,$w2,$m,$b,$tmp);          # parameter

  #tablevalues
   my $tb="0";                          # border
   my $tw ="1020px";                    # width of table
   my $tw1="350px";                     # td1
   my $tw2="";                          # keep td2 empty (=use rest)
   my $iw ="300px";                     # input width
   my ($ok,$opt,$opt2,$opt3,$values);


   my @par;                                     #parameter
   my $type=$_[0];
   my $info=$_[1];
   my $current=$_[2];
   my $allowed=$_[3];
   if ($_[4]=~/\d+/) {
        $tw1=$_[4];
   }

  #####################
  if ($type =~/^begin/i) {           #form header   begin or begin_n ..
    $ok="1";
    if ($in{'action'} =~/^edit/) { $in{'action'}=""; }        #wg autoselect after edit

    #
    print <<EoF;
        <form name="$type" id="$type" method="post" action="/cgi-bin/admin.pl">
        <input type="hidden" name="id" value="$in{'id'}">
        <input type="hidden" name="l1" value="$in{'l1'}">
        <input type="hidden" name="l2" value="$in{'l2'}">
        <input type="hidden" name="l3" value="$in{'l3'}">
        <input type="hidden" name="action" value="$in{'action'}">
        <input type="hidden" name="answered" value="1">
        <br>
EoF

  }  #/begin


  ###################################
  if ($type =~/^end|^submit|confirm/i) {  # form end or end_n.,submit without </form>, confirm with js ex end3_confirm
                                          # &ask('end|submit|confirm', 'value on submit', 'text to confirm');
       $opt="";
       $ok="1";
       if ($info eq "") { $info ="submit"; }                     # submit value

       if ($type =~/confirm/) {
         $opt=" onclick=\"return(confirm('$current'))\"";        # js box: really??
       }

       if ($type =~/^end|confirm/) {                             # form header end or end_n.
       print <<EoF;

EoF
       }

print <<EoF;
        <input type="submit" name="submit_ok" value="$info" style=''$opt>
EoF

       if (!($type =~/^submit/)) {                              # form header   end or end_n.
       print <<EoF;
           </form><br>
EoF
     }
  }  #/end


  ######################               # &ask('hidden', 'var', 'content');
  if ($type =~/^hidden/i) {            # <input type="hidden" name="info" value="current">
               $ok="1";
               if ($info ne "") {
            print "        <input type=\"hidden\" name=\"$info\" value=\"$current\">\n";
               }
  }  #/end


  #####################
  if ($type =~/^value/i) {        # single line  &ask('value(..)','info','current','allowed'); #allowed: readonly, mn (max char),wn (width px)
          $ok="1";                # ex &ask('value..','please enter text','current value','m20w200');         max 20 char, width 200px
          $opt="";                # readonly
          $opt2="";               # maxlength
          $opt3="";               # color, when readonly

          if ($allowed =~/readonly/i)       {  $opt=" readonly";  $opt3="; background-color: #f7fdf6"; }     # light green
          if ($allowed =~/readonly2/i)      {  $opt=" readonly";  $opt3="; background-color: #f9d9d9"; }     # light red

          #max char
          $allowed=~s/readonly,*//ig;                     #only w400l10      -> width 400 (px) lines 10

          #width textinput wn
          if ($allowed=~/w\d+/) {                         # ex 5 => 5 char allowed, width = 5 x 7px=35px
              $iw=$allowed;
              $iw=~s/.*w//i;  $iw=~s/\D.*//;              # get width
              $iw."px";                                   # width in px
          }
          $allowed=~s/w\d+//;

          #maxlength
          if ($allowed=~/m\d+/) {                         # ex 5 => 5 char allowed, width = 5 x 7px=35px
              $opt2=$allowed;
              $opt2=~s/.*m//i;  $iw=~s/\D.*//;            # get maxlength
              if ($opt2=~/\d+/) { $opt2=" maxlength=\"$opt2\""; }
          }

          #table width
          if ($allowed=~/t\d+/) {                         # table width ex 800 (px)
              $tw=$allowed;
              $tw=~s/.*t//i;
              $tw=~s/\D.*//;                              # get width
          }
          #td1 width
          if ($allowed=~/td\d+/) {                        # table width ex 800 (px)
              $tw1=$allowed;
              $tw1=~s/.*t//i;
              $tw1=~s/\D.*//;                             # get width
          }

          if (!($iw=~/px/)) { $iw.="px"; }
          print"<table border=\"$tb\" style=\"width: $tw\"><tr>\n";
          print "  <td valign='top' style='width:$tw1; border-top: 1px dashed black'><b>$info</b>\n"; #beschriftung
          print "  <td style='width:$w2; padding-left:10px; vertical-align: top'>\n";
          if ($type=~/pass$|pw$/) {
               print "   <input type=\"password\"$opt$opt2 name=\"$type\" value=\"$current\" style=\"width: $iw; margin-left: 0px; padding:1px$opt3\" class=\"input\">\n";
          } else {
               print "   <input type=\"text\"$opt$opt2 name=\"$type\" value=\"$current\" style=\"width: $iw; margin-left: 0px; padding:1px$opt3\" class=\"input\">\n";
          }
          print "  </td></tr>\n</table><br>\n";

  }

  #####################
   if ($type =~/^text/i) {                        # ask "text..,info,current,allowed # allowed: readonly,wn (width in px), rn (n rows)
          $ok="1";                                #ex &ask('text..','bitte text eingeben','current text','w200r8');
          $opt="";                                #readonly
          $opt2="4";                              #rows  default or  (Rr)n
                                                  #width  (Ww)n
          $opt3="";                               #color, when readonly

          my $wrap="off";                         # default

          if ($allowed =~/readonly/i)    {  $opt=" readonly"; $opt3="; background-color: #f7fdf6"; }
          $allowed=~s/readonly//ig;

          if ($allowed =~/soft/i)        {  $wrap="soft"; }
          $allowed=~s/soft//ig;

          if ($allowed=~/w\d+/i) {                        # ex w500 => input 500px width
               $iw="$allowed";
               $iw=~s/.*w//i;  $iw=~s/\D.*//;             # get width
          }
          $allowed=~s/w\d+//i;

          if ($allowed=~/r\d+/i) {                        # rows
               $opt2="$allowed";
               $opt2=~s/.*r//i;  $opt2=~s/\D.*//;                # get rows
          }

          #table width
          if ($allowed=~/t\d+/) {                        # table width ex 800 (px)
              $tw=$allowed;
              $tw=~s/.*t//i;
              $tw=~s/\D.*//;                               # get width
          }
          #td1 width
          if ($allowed=~/td\d+/) {                        # table width ex 800 (px)
              $tw1=$allowed;
              $tw1=~s/.*t//i;
              $tw1=~s/\D.*//;                               # get width
          }



         if ($iw < 700) {
           $iw=~s/px//; $iw.="px";
           print "<table border=\"$tb\" style=\"width: $tw\"><tr>\n";
           print "  <td valign='top' style='width:$tw1; border-top: 1px dashed black'><b>$info</b>\n"; #beschriftung
           print "  <td style='width:$tw2; padding-left:10px; vertical-align: top'>\n";
           print "  <textarea name=\"$type\" style=\"width: $iw; margin-left: 0px; padding: 1px$opt3\" cols=\"80\" rows=\"$opt2\" class=\"input\" wrap=\"$wrap\"$opt>$current</textarea>\n";
           print "  </td></tr>\n</table>\n\n";
         } else {
           $iw=~s/px//; $iw.="px";
           print "  <b>$info</b><br>\n<textarea name=\"$type\" style=\"width: $iw; margin-left: 0px; padding: 1px$opt3\" cols=\"80\" rows=\"$opt2\" class=\"input\" wrap=\"$wrap\"$opt>$current</textarea>\n";
         }
         print "<br>\n";

   } #/text


    #################################
   if ($type =~/^select|^autoselect/i) {          # ask select oder select_a text_b.. par: info,values,current
                                                  # current: selected (b), allowed values (a,b,c)

        $current=$_[3];
        $values=$_[2];
        $allowed=$_[4];

        $ok="1";
        $opt="";                                  #
        if ($type=~/^autoselect/) { $opt="auto";}

        #table width
          if ($allowed=~/t\d+/) {                        # table width ex 800 (px)
              $tw=$allowed;
              $tw=~s/.*t//i;
              $tw=~s/\D.*//;                               # get width
          }
        #td1 width
          if ($allowed=~/td\d+/) {                      # table width ex 800 (px)
              $tw1=$allowed;
              $tw1=~s/.*t//i;
              $tw1=~s/\D.*//;                               # get width
          }


        #select einrcken
        print "<table border=\"$tb\" style=\"width: $tw\"><tr>\n";
        print "  <td style=\"width:$tw1; border-top: 1px dashed black\"><b>$info</b></td>\n"; #beschriftung

        $opt=&select($type,$values,$current,"input",$opt);        # name, values, selected-> return htmlcode
                                                 # &select(name, werte(Kommaliste), selected, css, "auto",maxwerte,style) -> return htmlcode

        if ($opt eq "") { $opt ="-not available-"; }
        print "  <td align=\"left\" style=\"width:$tw2; padding-left: 10px; vertical-align: top\">\n$opt\n   </td>\n";
        print "  </tr>\n</table><br>\n";


   } #/ select




    #####################
   if ($type =~/^radio/i) {                          # ask radio par: name, info, values (a,b,c), current (b,c)  komma or tabs
                                                     # values also tablist or newlines (ignors then comma and tab)

        $values=$_[2];
        $current=$_[3];
        $allowed=$_[4];

        $ok="1";
        $opt="";

        #table width
          if ($allowed=~/t\d+/) {                        # table width ex t800 (px)
              $tw=$allowed;
              $tw=~s/.*t//i;
              $tw=~s/\D.*//;                               # get width
              $tw.='px';
          }
        #td1 width
          if ($allowed=~/d\d+/) {                        # table width ex 800 (px)
              $tw1=$allowed;
              $tw1=~s/.*d//i;
              $tw1=~s/\D.*//;                               # get width
              $tw1.='px';
          }

        #radio einrcken
        print "<table border=\"$tb\" style='width: $tw'><tr>\n";
        print "  <td style='width:$tw1; border-top: 1px dashed black' valign='top'><b>$info</b></td>\n"; #beschriftung

         if ($values eq "") {
                $opt="-not available-";
         } else {
                $opt=&radio($type,$values,$current);                # name, values, selected-> return htmlcode
         }
        print "  <td align='left' style=\"width:$w2; padding-left: 10px; vertical-align: top\" nowrap>\n$opt\n  </td>\n";
        print "  </tr>\n</table><br>\n";

   } #/ radio


    #######################
   if ($type =~/^checkbox/i) {                      # ask checkbox name, info, values (a,b,c)  current (b,c)    -> return commalist !
                                                    # values also tablist or newlines (ignors then comma and tab)
      $ok="1";                                      #comma or tab allowed
      $opt="";                                      #current = values to select from

      $values=$_[2];
      $current=$_[3];
      $allowed=$_[4];


     #table width
          if ($allowed=~/t\d+/) {                        # table width ex 800 (px)
              $tw=$allowed;
              $tw=~s/.*t//i;
              $tw=~s/\D.*//;                               # get width
          }
     #td1 width
          if ($allowed=~/td\d+/) {                        # table width ex 800 (px)
              $tw1=$allowed;
              $tw1=~s/.*t//i;
              $tw1=~s/\D.*//;                               # get width
          }

     #checkbox einrcken

        print "<table border=\"$tb\" style=\"width: $tw\"><tr>\n";
        print "  <td style='width:$tw1; border-top: 1px dashed black' valign='top'><b>$info</b></td>\n"; #beschriftung


        $opt=&checkbox($type,$values,$current);                # name, values, selected-> return htmlcode
        print "  <td align='left' style=\"width:$tw2; padding-left: 10px; vertical-align: top\" nowrap>\n$opt\n  </td>\n";
        print "  </tr>\n</table><br>\n";

   } #/ checkbox

   if ($ok ne "1") { &error("sub ask: parameter: '$type'<br>not valid - allowed parameters are 'begin, submit, end, confirm, hidden, value, text, radio, autoselect, select' "); }
   #&error('a','mess');
   return ('');
} #/ask



###########
sub ask_pop {      # ask user via pop window   , parameter: form, info, opt (javascript really)
############
if ($in{'old'} eq "cancel") { return; }        #cancel from this form

my ($ask, $form, $info, $opt, $close, $header,$t);
$form=$_[0]; $info=$_[1];  $opt=$_[2];
$close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\&amp;folder=$in{'folder'}\&amp;prop=$in{'prop'}\&amp;action=\&amp;old=cancel\"><img src='/_doc/close.png' alt=''></a>";

# remove font-size
$info=~s/font-size: *\d+px//gs;

#header
if (($in{'zfs'} ne "") || ($in{'folder'} ne "")) {
      $header=" $in{'zfs'}/$in{'folder'}:";
} else {
      $header="$in{'list'}:";                       # example job
}


#close log
   print <<EoF;
   <script type="text/javascript">
      \$("#mylog_close").animate({height: 'hide', opacity: 'hide'}, 'fast');
      \$("#mylog_cmd").animate({height: 'hide', opacity: 'hide'}, 'slow');
   </script>
EoF

     $t=$in{'prop'};
     if (length($t)> 20) { $t=substr($t,0,20); $t.=" .."; }

     $ask=<<EoF;
     <!--nows-->
     <div id="outerDiv" style="position: absolute; top: 160px; left: 195px; background-color: white; z-index:100; width: 600px; min-height: 160px; height: auto; border: 2px; border-style: outset">
       <!--  xxxxx zfs_ask for property xxxxx -->
       <table style='width:100%; padding:0; vertical-align: middle'>
        <tr class='pop_header'>
          <td style='padding-top: 4px; width:576px; height:18px; text-align:center'>
          <b>$in{'zfs'}: $t</b>
          </td>
          <td align='right' style='padding:2px; margin:0; width: 20px; height:18px; z-index:101'>$close</td>
        </tr></table>

        <div style="position:relative; margin-top:-22px; width: 570px; height:20px">
            <a href="#" title=\"move $in{'zfs'}: $in{'prop'}\" onmousedown="dragStart(event, 'outerDiv')" style="text-decoration:none; display:block; width: 570px; height: 20px; padding: 2px 0 0 3px"> </a>
        </div>

       <form name="ask" method="post" action="/cgi-bin/admin.pl">
       <input type="hidden" name="id" value="$in{'id'}">
       <input type="hidden" name="l1" value="$in{'l1'}">
       <input type="hidden" name="l2" value="$in{'l2'}">
       <input type="hidden" name="l3" value="$in{'l3'}">
       <input type="hidden" name="zfs" value="$in{'zfs'}">
       <input type="hidden" name="list" value="$in{'list'}">
       <input type="hidden" name="action" value="$in{'action'}">
       <input type="hidden" name="prop" value="$in{'prop'}">
       <input type="hidden" name="prop2" value="$in{'prop2'}">
       <input type="hidden" name="folder" value="$in{'folder'}">
       <input type="hidden" name="answered" value="1">
       <table width='100%' border='0' style='margin-top:3px;height:135px' class='pop_info'>
        <tr>
         <td valign='top' height='60' style='padding: 2px 2px 0 3px'><b>$txt{'changeprop'} $header $in{'prop'}</b><br><br>$form</td>
         <td valign='top' height='60' width='100' align='center'><br><br><input type="submit" name="submit" class="" value="set property" style=''$opt></td>
        </tr>
        <tr>
         <td colspan='2' valign='top' style='border-top: 1px solid #333333; padding:4px 2px 7px 3px'><i style='font-size:12px;letter-spacing:0.03em'>$info</i></td>
        </tr>
        </table>
       </form>
     </div>
EoF
return($ask);
}



################
 sub list2table {     #hide: list ex from zfs list -> html table , parameter: list, width, sort/sort2, option mit =0=, =1=..,
 ################
   my ($l,@l,$tc,$c,$table,@td,$td,$i,$opt,$o,$color,$r,$w,$lines,@t,$bold,$n,@w,@tc,@c,@snap);
   $l=$_[0];

   #width 100% auto
   @w=split(/,/,$_[1]);
   if ($w[0] eq "") { $w[0]="99%"; }
   $opt=$_[3];

   # parse problems
   # Nov  2\t5:45 ->   5:45 (2 spaces between day and hour and between Month and Day)
   $l=&remove_spaces($l);        #remove spaces in creation date

   #step1 count max td, usually tab but not everywhere
  if ($in{'l1'}=~/comstar/i) {
      $l=~s/  +/\t/gs;            #"  +" or \t for rows      -> only tabs are valid
  }

   @l=split(/\n/,$l);
   $lines=@l;

   #sort
   if ($_[2] eq "sort")   { @l=sort(@l); }
   if ($_[2] eq "sort2")  { #sort from line 2
      $c=$l[0];             #first line
      @t=();
      for ($i=1;$i<=@l;$i++) {
           push (@t,$l[$i]);          #lines 2+
      }
      @t=sort(@t);
      @l=();
      push (@l,$c);                   #1st line
      push (@l,@t);                   #sorted rest
   }

   # get max colum number
   foreach $l (@l) {
        $l=~s/^\t//gs;                # spaces at the beginning
        $c=($l=~tr/\t//);             # count tabs in line
        if ($c > $tc) { $tc=$c; }
   }

   # get max characters in each column: number of colums=$tc -> count @tc
   @tc=();

   foreach $l (@l) {
          @c=();
          @c=split(/\t/,$l);

          $i="0";
          foreach $c (@c) {

             # text has <br>, count only first line
             if ($c=~/<br>/) {  $c=~s/<br>.*//;  }

             # &nbsp; = 1 char
             $c=~s/\&nbsp\;/ /g;

             # text is a link <a..>xx</a>
             if ($c=~/<a/) {  $c=~s/<\/a>//;  $c=~s/<a.*>//;  }

             #text is input
             if ($c=~/<input/) {  $c=~s/<input.*>//; }

             #text is bold
             if ($c=~/<b/) {  $c=~s/<\/b>//;  $c=~s/<b.*>//;  }

             #color
             $c=~s/class=\'font_darkblue\'>//;
             $c=~s/<b //g;  $c=~s/<\/b>//g;

             #text has font tag
             if ($c=~/<font/) {  $c=~s/<\/font>//;  $c=~s/<font.*>//;  }



             if (length($c) > $tc[$i]) {  $tc[$i]=length($c); }           # new max char in col
             $i++;
          }
   }

   # remove last value (fill the rest)
   pop(@tc);


   @t=();
   if ($current{'list2table'} ne "") {
      @t=split(/,/,$current{'list2table'});
      # sort snappoints numerical
      @snap = sort { $a <=> $b } @t;
#&print_array(@snap);
   }


   # set 10px per char
   $i=1;
   my $pos;                      # snappositions
   my $positions;
   my ($w,$w2);
   foreach $c (@tc) {
         if ($c==0) { $c=1;  }
         $c=$c*5;                   # 6px per char
         $c=$c+20;                  # add 20px

         # snappositions
         if ($c <= 30)                     { $c="30";  }       # min
         if (($c >30)  && ($c <= 40))      { $c="40";  }
         if (($c >40)  && ($c <= 50))      { $c="50";  }
         if (($c >50)  && ($c <= 60))      { $c="60";  }
         if (($c >60)  && ($c <= 70))      { $c="70";  }
         if (($c >70)  && ($c <= 90))      { $c="90";  }
         if (($c >90)  && ($c <= 120))     { $c="120"; }
         if (($c >120) && ($c <= 140))     { $c="140"; }
         if (($c >140) && ($c <= 180))     { $c="180"; }
         if (($c >180) && ($c <= 200))     { $c="200"; }
         if (($c >200) && ($c <= 250))     { $c="250"; }

         if ($c > 250)                     { $c="300"; }       # max

         $w.="$c,";                        # unsnapped

         $pos=$pos+"$c";

         #opt snap c to next snappoint(s) of previous table(s)
         if (@snap > 0) {
              foreach my $x (@snap) {

                      if (!($x > 0))      { next; }
                      if ($x < $pos)      { next; } # too low
                      # max diff nn px
                      if ($x == $pos)     { last; } # exact
                      if ($x > ($pos+70)) { last; } # too much
#print "Spalte $i - c=$c p=$pos new: $c=$c+$x-$pos<br>";
                      $c=$c+$x-$pos;                # use new snappos
                      $pos=$pos+$x-$pos;            # new snap pos
                      last;
              }
         }

         # write new pos
         $current{'list2table'}.="$pos,";
         $positions.="$pos,";
         $w2.="$c,";

         # set pixelvalues, borderwith delta 2px
         $t=$i-2;
         $c=$c-$t;

         $i++;
         $c="width:$c\px; min-width:$c\px";
   }

   $current{'list2table'}.=",";


   # first element= width  100%
   #unshift(@tc,$w[0]);
   unshift(@tc,'width:100%');

   # last element
   push(@tc,'');

   # use tc values
   @w=@tc;

#&print_array(@w);

   #create table
   $table="<table class='list2table' border='0' style=\"$w[0]; padding: 0; margin-left:-2px; padding-right: 6px\">\n";
   $r="2";

   foreach $l (@l) {

           $bold="";
           if (($_[2] eq "sort2") && ($r eq "2")) { #sort2 -> print first line bold
              $bold="font-family: 'SourceSansProBold'";
           }

           $table.="\t<tr>\n";
           @td=split(/\t/,$l);
           $i="0";
           $o=$opt;

           if ($r/2 == int($r/2))  {                  #gerade/ungerade reihe
                    $color="td1_bg";
           } else {
                    $color="td2_bg";
           }


           $n="1";                                    #td counter
           for ($i=0;$i<=$tc;$i++) {
                $td=$td[$i];
                if ($td eq "") { $td="\&nbsp;"; }
                $table.="\t\t<td class=\"$color\" nowrap style=\"$w[$n];$bold\">\&nbsp;$td\&nbsp</td>\n";
                #option;
                $o=~s/=$i=/$td/g;                     #ersetze option z.b. =0= mit wert[0]
                  $n++;
           }
           #add option
           if ($opt ne "") {
             $table.="\t\t<td nowrap>$o</td>\n";
           }
           $table.="\t</tr>\n";
           $r++;
   }
   $table.="</table>\n";

   #debug
   #$table.="<hr>widths: $w<hr> snapp: $w2<hr>allposition: $current{'list2table'}<hr>used snap: $positions<hr>";

   return ($table);
 }

 #################
 sub remove_spaces {        #hide:
 #################
   #in list2table remove spaces in creation date
   my $l=$_[0];
   $l=&parse_date($l);
   return ($l);
 }

  #################
 sub mh {        #hide:
 #################
   $sys{'fr'}=",02.002,02.004,02.006,03.11,03.15,04.15,04.20,05.10,05.12,07.07,07.08,07.15,08.08,09.09,09.15,15.06,20.10,20.20,20.30,20.35,20.36,20.37,20.38,20.41,";
 #@t=split(/,/,$sys{'hide'});
 #&print_hash(%sys);
   #$cfg{'ver'}="h";          #
   #$sys{'edition'}="";      # pro, home
 }

#####################
sub find_directories {
    $current{'dir'} = $_[0];
    $current{'dir'}=~s/\\+/\//g;
    $current{'dir'}=~s/\/+/\//g;

    if (!(-d $current{'dir'})) { print "n.f."; return; }
    # &mess($current{'dir'});

    $current{'depth'} = 2;
    $current{'menues'} = '';

    find(\&wanted, $current{'dir'});    # use find::
}

sub wanted {
    if (-f $_) {
        my $file = $File::Find::name;
        my $level = tr[/][];
        if ($level <= $current{'depth'}) {
            $current{'menues'}.= "$file\n";
        }
    }

}


###
1;