#
#task-lib.pl
#(c) napp-it 2014-2018
# nov 13 2017, add jobtype report
# common used task functions
# dec 30 2020 read complex options like -o a=1 -o b=2

######################                   # main script get all or single par
sub task_read_jobpar {                   # par -> %current
######################

    # .job file is obsolet from 0.9+
    # .par is used and optionally created from jobfile instead (script or /_my/script)

    # read jobparameter from jobfile to %current
    # if job is given: only this job
    # otherwise all or for a special jobtype (based on l2)

    my $id=$_[0];                        # optional jobnr
    my $ver=$_[1];
    my (@v,$v,$k,$p,@m,@d);
    @m=('','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

    my $f="/var/web-gui/_log/jobs/";  # jobfile

    #debug
    # print "task_read_jobpar 16: dir $f\n";

    my @files=&task_get_dir("$f","","task-lib 12");

    # step1 update .job -> .par from 0.9+
    # old: id~level2~level3~text1~opt1~text2~opt2~month~day~hour~min~id~status~last.job
    my @n;
    foreach my $t (@files) {
       if ($t=~/\.job$/) {

            # add timetable to par
            @v=();
            @v=split(/\~/,$t);

            @t=();
            $v=&task_read_array_t("$f$t");        # read .job to @t
            if ($v eq "0") { next; }

            # push info from filename
            @n=();
            push(@n,"job=$v[1]\n");
            push(@n,"month=$v[7]\n");
            push(@n,"day=$v[8]\n");
            push(@n,"hour=$v[9]\n");
            push(@n,"min=$v[10]\n");
            push(@n,"status=$v[12]\n");

            $v[13]=~s/\.job$//;
            push(@n,"last=$v[13]\n");

            #add values from .job
            foreach my $v (@t) {
                    if ($v=~/id\=|month\=|day\=|hour\=|min\=/) { next; }      # id only in filename, others from filename
                    chomp($v);

                    # update repli
                    if ($v[1] eq "replicate") {
                            if ($v=~/^text1=/) {                          # text1=192.168.88.3-59814
                                $p="transport=nc\n";                      push(@n,$p);       # transport
                                $v=~s/test1=//;
                                $p="$v"; $p=~s/.*\-//; $p="port=$p\n";    push(@n,$p);       # port
                                $p="$v"; $p=~s/\-.*//; $p="hostip=$p\n";  push(@n,$p);       # hostip
                            }
                            if ($v=~/^host|^source|^destination|^dest_sharename|^send_dedup|^rec_option|^send_option|^pv_limit/) {                          # host=oi3
                                push(@n,"$v\n");
                            }
                            if ($v=~/^dest_shareguest=\w+/) {            # dest_sharguest
                                push(@n,"dest_shareguest=yes\n");
                            }
                            if ($v=~/^send_rec=\-R/) {                   # dest_sharguest
                                push(@n,"recursiv=yes\n");
                            }
                            if ($v=~/^send_dedup=-D/) {                 # dest_sharguest
                                push(@n,"send_dedup=yes\n");
                            }
                            if ($v=~/^esxi/) {                          # esxi_ip
                                push(@n,"$v\n");
                            }

                    }
                    # update scrub
                    if ($v[1] eq "scrub") {
                       if ($v=~/^pool=/) {                               # host=oi3
                                push(@n,"$v\n");
                       }
                    }
                    # update snap
                    if ($v[1] eq "snap") {
                       if ($v=~/^pool|^keep/) {
                                push(@n,"$v\n");
                       }
                       if ($v=~/^delnull=yes/) {
                               push(@n,"delzero=yes\n");
                       }
                       if ($v=~/^esxi/) {                                  # esxi_ip
                                push(@n,"$v\n");
                       }
                    }
                    # update other
                    if ($v[1] eq "other") {
                       if ($v=~/^action|^condition|^noerr|^err|^text1/) {
                                push(@n,"$v\n");
                       }
                    }
                    # update email
                    if ($v[1] eq "email") {
                       if ($v=~/^server|^to|^from|^user|^pw|^trigger/) {
                                push(@n,"$v\n");
                       }
                    }
                    # update report
                    if ($v[1] eq "report") {
                       if ($v=~/^server|^to|^from|^user|^pw|^trigger/) {
                                push(@n,"$v\n");
                       }
                    }

                    # update backup
                    if ($v[1] eq "backup") {
                       if ($v=~/_|fs|pool/) {
                                push(@n,"$v\n");
                       }
                    }
            }

            unlink("$f$t");                       # del id.job
            $t=~s/~.*/.par/;                      # remove all but id  and add .par
            @t=();
            @t=sort(@n);
 #&print_array(@n);
            &task_write_array_t("$f$t");          # write par
            #
       }
    }

    # step 2: get all par
    my ($p,@p,$i);
    foreach my $t (@files) {

       #.pl (old): delete from napp-it < 0.9
       if ($t=~/\.pl$/)  {  unlink("$f$t");  next; }       #del .pl, obsolet (use job-script)

       if (!($t=~/\.par$/))  {   next; }                   # only .par

       # single id~
       if ( (!($t=~/^$id/)) && ($id > 0)) {   next; }      # only single job



       $i=$t;
       $i=~s/\..*$//;                       # jobid

       $k="$i\_state";
       $current{$k}="";                       # default: no state   (running etc)

       #joblist
       if (!($current{'joblist'}=~/$i/)) {
           $current{'joblist'}.="$i,";      # commalist
       }

       # jobvalues from .par files
       @t=();
       &task_read_array_t("$f$t");          # read to @t

       # par to %current
       foreach $v (@t)  {                  #all parameters

          if (!($v=~/\=/))      { next; }  # ip=1234
          @p=();
          $v=~s/\s+$//;
          $v=~s/=/_=_/;         # first
          @p=split(/\_\=\_/,$v);               # allow ip=123 -0 b=3


          # do not use state from file
          if ($p[0] eq "state")  { next; }
          if ($p[0] eq "allpar") { next; }

          $k="$i"."_$p[0]";                 #type ex: 1234_job -> scrub
          $current{$k}=$p[1];

      }


      $k="$i"."_month"; if ($current{$k} eq "") { $current{$k}="every"; }
      $k="$i"."_day";   if ($current{$k} eq "") { $current{$k}="every"; }
      $k="$i"."_hour";  if ($current{$k} eq "") { $current{$k}="0"; }
      $k="$i"."_min";   if ($current{$k} eq "") { $current{$k}="0"; }

      $k="$i"."_status";
      if ($current{$k} eq "") {
          $current{$k}="manual";
      }

      #replication set to manual
      if ($ver ne "") {
              $k="$i"."_job";
              if ( ($current{$k}=~/repli/) && (!($ver=~/c|r/)) )  {
                    $k="$i"."_status";
                    if ($current{$k} ne "manual") {
                         $current{$k}="manual";
                         &task_update_par($i);
                    }
                    $k="$i"."_month";   $current{$k}="manual";
              }
      }


      # get last run > current('id_last') from if.last
        @t=();
        $t=~s/\.par$/.last/;

        if (-f "$f$t") {
             &task_read_array_t("$f$t");                    # read to @t
             @t=reverse(@t);

             $k="$i"."_lastcall";                            # jobid: $i
             $current{$k}="n.a.";

             if ($t[0]=~/^\d+\.\d+\.\d+\.\d+\.\d+\./) {     # 2015.04.16.08.00.01

                  @d=();
                  @d=split(/\./,$t[0]);
                  $d[1]=$m[$d[1]];                          # 01 -> Jan
                  $current{$k}="$d[2].$d[1]&nbsp;$d[3]:$d[4]";

                  $k="$i"."_last";
                  $current{$k}="$d[2].$d[1]&nbsp;$d[3]:$d[4]";      # show lastcall. not new on some jobs

             }

             # debug
           # &print_hash(%current);

        }
 }

 &task_getstate;
 $current{'joblist'}=~s/,$//;

 #debug
 #&print_hash(%current);

}

###################
sub task_getstate {
###################   get state (ex running)
my (@r,$r,$k);

if ($sys{'Readsocket'} eq "1") { print "tasklib  140\n";}
     # get requests ex /tmp/nappit/job-scrub_1350378156.request
     @r=&task_get_dir("/tmp/nappit/",".request","task_getstate 61");

     foreach $r (@r) {
         if (!($r=~/job\-.*\.request$/)) { next; }
         $r=~s/\.request//;
         $r=~s/.*\_//;       # keep jobid
         if ($r=~/^\d+$/) {
            $k="$r\_state";
            $current{$k}="request";                              # set state to request
         }
     }

     # get local running like job-scrub_1350378156.pl

     $r=`ps axw | grep job-`;

#debug
#$r=~s/\n/<br>/gs;  print "<!--wscontent-->task socket $sys{'Readsocket'} $r";  exit;

     @r=();
     @r=split(/\n/,$r);

     foreach $r (@r) {
           chomp($r);

           if ($r=~/grep/) { next; }
           $r=~s/.*\_//;                       # ..run_id
           $r=~s/ .*//;                        # remove opt second parameter
           $r=~s/\D//g;# keep jobid

          # print "#### task-lib 153 running=$r\n";
           $t="$r\_job";
           $t=$current{$t};

           if (($r=~/^\d+$/) && ($t ne "")) {                   # valid job
              $k="$r\_state";
              $current{$k}="running";                           # set state to running

              if (-f "/tmp/nappit/$r.cancel")   {
                     $current{$k} = "run/cancel";
              }
           }


     }
#&print_hash(%current);
}



sub task_gettime {
###########
 my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 my @m=('','jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec');
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $current{'logtime'}="$mday\.$m[$mon]\_$hour\_$min";
 $current{'timestamp'}="$year\.$mon\.$mday\.$hour\.$min\.$sec";

}

#############
sub task_get_dir    { # &task_get_dir("dir","Muster","Zeilennr") return array
############
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;
 local (*F);
 if ($par[0] eq "") { print"(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])\n"; exit; }
 if (!(-d $par[0])) { print"(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[2])\n"; exit; }

 opendir(F, $par[0]);
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file";
        if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[1]=~/\./) {        #.xxx
                if ($file=~/$par[1]$/) {  push (@liste,$file); }
        } else {
                push (@liste,$file);
        }
 }
 closedir(F);
 return(@liste);
}


#####################
sub task_read_array_t {
####################
  my $f=$_[0];
  @t=();
  if (-f $f) {
     open (F,"<$f");
          flock(F, LOCK_EX);
          @t=<F>;                    # read to public @t
     close (F);
     return(1);
  }  else {
     $t[0]="error: in task_read_array- file $f not found";
     return(0);
  }
}

###################
sub task_update_par {
###################  write new par-file from %current
     &task_gettime;        # update logtime

     my $id=$_[0];

     if (!($id=~/^\d+$/)) { print "\n###tasklib update 237: no id\n"; return(0); }
     my ($k,$v,$t);
     @t=();
     while (($k,$v) = each %current) {
            if (!($k=~/^$id\_/))    { next; }

            #do not write state like running
            if ($k=~/^state|allpar|lastrun/)       { next; }

            $t=$k; $t=~s/^\d+\_//;           # 12345_job -> job
            push (@t,"$t\=$v");
     }

     my $f=`uname -a`;
     if ($f=~/Linux/){
          `sudo chown -R napp-it /var/web-gui/_log/jobs/`;
          &task_write_array_t("/var/web-gui/_log/jobs/$id.par");
          `sudo chmod -R 755 /var/web-gui/_log/jobs/`;
     } else {
          `sudo /usr/bin/chown -R napp-it /var/web-gui/_log/jobs/`;
          &task_write_array_t("/var/web-gui/_log/jobs/$id.par");
          `sudo /usr/bin/chmod -R 755 /var/web-gui/_log/jobs/`;
     }


}

######################
sub task_write_array_t {
####################          # write public @t
  my $f=$_[0];                # filename
  my $a=$_[1];                # append if a

  if ($a=~/a/) {
    open (F,">>$f");
  } else {
    open (F,">$f");
  }
  flock(F, LOCK_EX);
  foreach my $t (@t) {
    if (!($t=~/\w/)) { next; }
    chomp($t);
    print F "$t\n";
  }
  close (F);
}



### end ###
1;
