#!
# zfs lib
###############################
# zfs functions for napp-it    Copyright (c) 2010-2024 napp-it
################################
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require

# jan 2024, win


#########
sub zfslib {  #
###########################
}


 ###############
 sub zfslib_val2kb  {  #hide:
 ###############

      my $w1=$_[0];
      $w1=~s/,/./;
      if ($w1=~/K/) { $w1=~s/K//;  }
      if ($w1=~/M/) { $w1=~s/M//; $w1=$w1*1000; }
      if ($w1=~/G/) { $w1=~s/G//; $w1=$w1*1000000; }
      if ($w1=~/T/) { $w1=~s/T//; $w1=$w1*1000000000; }
      if ($w1=~/P/) { $w1=~s/P//; $w1=$w1*1000000000000; }
      return ($w1);
 }

  ###############
 sub zfslib_val2xb  {  #hide:  kb -> gb,tb..
 ###############

      my $w1=$_[0];
      if ($w1 < 1000) { $w1.="K"; return($w1);  }

      $w1=$w1/1000;
      $w1=sprintf ("%.1f", $w1);
      if ($w1 < 1000) { $w1.="M"; return($w1);  }

      $w1=$w1/1000;
      $w1=sprintf ("%.1f", $w1);
      if ($w1 < 1000) { $w1.="G"; return($w1);  }

      $w1=$w1/1000;
      $w1=sprintf ("%.1f", $w1);
      if ($w1 < 1000) { $w1.="T"; return($w1);  }

      $w1=$w1/1000;
      $w1=sprintf ("%.1f", $w1);
      if ($w1 < 1000) { $w1.="P"; return($w1);  }

      return ($w1);
 }

 ###############
 sub zfslib_val2proz  {  #hide:  total, used return % value
 ###############


      my $total=$_[0];    # total
      my $used=$_[1];     # used
      if (($total eq "") || ($total eq "0")) { return ""; }

      my $p=($total-$used)/$total*100;       #avail in% =(total - used)/total * 100
      $p=sprintf ("%.0f", $p);               #runden
      return ($p);
 }

 ###############
 sub zfslib_pool2used  {  #hide:
 ###############  return list of pools with used in %
      my $r=&exe("zfs list -H -o name,used,avail,mountpoint", "n");
      my @zfs=split(/\n/,$r);
      $r="NAME\tUSED\tAVAIL\tMOUNTPOINT\t%\n";
      my @w=();
      my ($used,$total,$t);
      foreach my $z (@zfs) {

               @w=split(/\t/,$z);

               if ($w[0]=~/\//) { next; }        # pool only
               $r.=$z;                           # poolname,used,avail,mp

     # &mess($z);

               $used=&zfslib_val2kb($w[1]);
               $total=$used + &zfslib_val2kb($w[2]);  #total=used+avail

              $t=&zfslib_val2proz($total,$used);
              if ($t <=15) { $t.='%!'; } else { $t.='%'; }         # alert  15%!
              $r.="\t$t\n";

      }
      return ($r);
 }



###################
sub zfslib_create_datasnap {          #create snap vol@date
#####################
    my ($zfs,$out,$r);

    if ($in{'select_snapzfs'} ne "") {

    $r=$in{'checkbox_recursiv'};
       if ($r=~/on/i) {
          $r=" -r";
       } else {
          $r="";
       }


       $in{'value_comment'}=~s/ /_/g; $in{'value_comment'}=~s/[^a-zA-Z0-9\_]//g;
       if ($in{'value_comment'} ne "") { $in{'value_comment'}="_$in{'value_comment'}"; }
       #&mess("zfs snapshot$r \"$in{'select_snapzfs'}\"\@$sys{'date_all'}$in{'value_comment'}\"");
       $t="zfs snapshot$r $in{'select_snapzfs'}".'@'."$sys{'date_all'}$in{'value_comment'}";
       $out=&exe("$t");
  #&mess("$t<hr>$out");
       if ($out ne "") { print $out; sleep(2); }
       print "zfs snapshot$r \"$in{'select_snapzfs'}\"\@$sys{'date_all'}  done.. <br><br>";
       &zfslib_list_datasnaps;
       return;
    }

    $zfs=&zfslib_list('comma');         #commalist

    print "Name: ZFS\@date<br><br>\n";
    &ask('begin');
    &ask('select_snapzfs','ZFS',$zfs);
    &ask('checkbox_recursiv','Recursiv','on','on');
    &ask('value_comment','Comment:','','m40');
    &ask('end');

    #&print_array(@pools);
}



#############         ##########################
sub zfslib_list {        #  list zfs datasets par: 'source (filesystem,volume,snapshot,syspool,comma,nl,br,array,header,mountpoint)' , 'below zfs'
#############         ##########################
                      # comma,nl,br,array -> form of return value
                      # header -> incl header, mount(point) -> returns mountpoint instead of name
                      # sys | all   all pools inkl sys

   my ($r,$z,@n,$h,$par);

  if ($_[0]=~/header/) { $h=""; } else { $h="-H "; }

  if ($_[0]=~/filesystem/) {
          # zfs acc


          $r=&exe("zfs list $h-t filesystem");
  } elsif  ($_[0]=~/volume/)   {
          $r=&exe("zfs list $h-t volume");
  } elsif  ($_[0]=~/snapshot/) {
          $r=&exe("zfs list $h-t snapshot");
  } else {
          $r=&exe("zfs list $h");
  }

  @t=();
  @t=split(/\n/,$r);
  foreach $z (@t) {
           if (($z=~/^$zfs{'syspool'}\s/) && (!($_[0]=~/sys|all/)))          { next; }        #no syspool itself

           if ($z=~/^$zfs{'syspool'}\/\w/)     {                             # allow user fs
             if($z=~/\/ROOT|\/dump|\/swap|\/export|VARSHARE/) { next; }
           }

           if (($_[1] ne "") && (!($z=~/^$_[1]/))) { next; }                 # list only zfs below

           if ($_[0]=~/mount/) {
                   $z=~s/^.*\s//;
                   if (($z eq "-") || ($z eq "legacy"))                     { next; }  # no mountpoint
           } else { $z=~s/\s.*//; }

           push (@n,$z);
  }

  $r=join("\n",@n);
  #rows
  if ($_[0]=~/nl/)  {
        if ($_[0]=~/br/)  {  $r=~s/\n/<br>\n/gs;    }
        $par="zfslib_list_$_[0]_nl"; $current{$par}=$r;
        return ($r);
  }

  #array
  if ($_[0]=~/array/)  {
         $par="zfslib_list_$_[0]_array"; $current{$par}=$r;
          return (@n); }

  #kommalist
  if ($_[1]=~/comma/)  {
        $r=join(",",@n);
        $par="zfslib_list_$_[0]_comma";
        $current{$par}=$r;
        return ($r);
  }

  #default tablist
  $par="zfslib_list_$_[0]_tab";
  $current{$par}=$r;
  $r=join("\t",@n); return ($r);
}



#################
 sub zfslib_overview {            # folder settings
 ##############                   # print overview if user zfs
    my (@zfs,$zfs,$dl,@z,$z,$url,$url2,$u,$n,$p,@p,$r,@w,@prop,$prop,$name,$acl,$w1,$w2,$l,$sharename,$prop2,$ip,$title,$perm,@shares_www,@shares_ftp,$guest,$ssb,$rs,$ps);
    my (%ssbcache);

    if ($in{'list'}  eq "details") { &zfslib_details; exit; }

    #change zfs property
    if ($in{'answered'})           { &zfslib_change_property; }

    #url
    $url="<a title=\"=title=\" class=\"=class=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;zfs==zfs=\&amp;prop==prop=\&amp;prop2==prop2=\&amp;old==old=\">=text=</a>";

    #url2=goto
    $url2="<a title=\"=title=\" class=\"=class=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1==l1=\&amp;l2==l2=\&amp;l3==l3=\&amp;zfs==zfs=\">=text=</a>";


    # list of filesystems, headline

    $t="ZFS (all properties)";
    if ($zfs{'all_clones'}=~/\@/) {
         $t.="\tCL";                                                        # Clones when needed
    }


    # Header
    $o='&nbsp;'x 2;
    @zfs=("NAME\tORIGIN\tDRIVELETTER\tMOUNTPOINT\tSMB_SHARE:\tCANMOUNT\tMOUNTED\tNBMAND\tREC\tAVAILABLE$o\tUSED\tRES\tRFRES\tQUO\tRFQU\tSBS\tSYNC\tCOMPR\tDEDUP\tCRYPT\tRDONLY");
    @t=();
    @t=split(/\t/,$zfs{'allfs'});
    @t=sort(@t);
    push(@zfs,@t);

#&print_array(@t);
#&print_hash(%current);
#&print_array(@shares_www);


     ## generate list
     #  ex NAME,SHARESMB,SHARENFS,..
     foreach $zfs (@zfs) {                          # list of zfs names

         # Headers
         if ($zfs=~/^NAME\t/i) {  next;  }          # headers (tablist)

         $name=$zfs;
         #&mess($name);                              #ex tank/data

         if (!($name=~/\//))  {                     # pool itself
           $o=" (pool)";
         } else {
           $o="";
         }


         # phase 1: get values for each ZFS

         # encrypted without key ??
         ############################
           $r="1";
           $t=$name."_encryption";
           $t=$zfs{$t};
           if ($t=~/on|\d+/) {
                         $t=$name."_keystatus";
                         $t=$zfs{$t};
                         if ($t ne "available") {
                            $r="0";
                         }
           }

           ## ZFS name
          $r="1";          # optional, offer option to display all fs properties even on enc filesystems

          if ($r) {
                            $u=$url;
                            $t="$name$o";
                            if (length($t) > 22) {
                               $u=~s/=title=/$t/g;
                               $t=substr($t,0,22);
                               $t.=" ...";
                            } else {
                               $u=~s/=title=/$t/g;
                            }

                            $u=~s/=text=/$t/g;         $u=~s/=zfs=/$name/g;     $u=~s/=style=//g;           # =zfs=     -> show details of zfs
                            $u=~s/=prop=//g;           $u=~s/=list=/details/g;  $u=~s/=old=/$name/g;   # =zfs= -> edit =prop=    (property)
                            $zfs="$u";
          } else {
                            $zfs=$name;
          }
          if ($o ne "") { $zfs="\n$zfs"; }          # pools after newline


         # get properties off all ZFS, must be same like headline above

         @prop=('','origin','driveletter','mountpoint','smb_share:','canmount','mounted','nbmand','recsize','avail','used','reservation','refreservation','quota','refquota','ssb','sync','compression','dedup','encryption','readonly');
         foreach $prop (@prop)   {                  # for all properties
             # NAME of ZFS (always first)
             if ($prop eq "NAME") {                 #NAME
                next;
             }

             $prop=lc($prop);                       #lowercase

             ############################
             ##origin (clone)
             if ($prop =~/origin/i) {
                  if ($zfs{'all_clones'}=~/\@/) {
                      $t=$name."_origin";
                      $t=$zfs{$t};                   #ORIGIN (clone)

                      $zfs.="\t";

                      $u="";
                      # check if fs contains a iscsi_clone below
                      # not on pool itself
                      if ($name=~/\//)  {
                         if ($zfs{'all_clones'}=~/$name\/iscsi_\d+/) {  # a iscsi clone is located below
                              $u=$zfs{'all_clones'};
                              $u=~s/.*$name\/iscsi_\d+//;
                              $u=~s/\t.*//;                                                   # source snap
                              $u="<a title=\"iscsi volume clone from snap: $u\">vol&nbsp;</a>";
                         }
                      }

                      if ($t=~/\@/) {
                          $u.="<a title=\"clone from snap: $t\">@&nbsp;</a>";            # clone from snap
                      }
                      if ($u eq "") {
                          $u="-";
                      }
                      $zfs.="$u";

                      next;
                  }   else {
                      next;
                  }
             }

             if ($prop eq "smb_share:") {   # is filesystem shared
                  $sharename="n.a.";
                  $r=&socket("ps Get-SmbShare");
                  # print_var($r);

                  # pool driveletter
                  $dl=$name;
                  $dl=~s/\/.*//;          # pool
                  $dl=&exe("ps zfs get -H -o value driveletter $dl");
                  #print_var($dl);

                  # pool?
                  if (!($name=~/\//)) {
                       $zfs.="\t(not recommended)";
                       next;
                  }

                  #&mess($t);
                  #Name   ScopeName Path       Description
                  #----   --------- ----       -----------
                  #ADMIN$ *         C:\Windows Remoteverwaltung
                  #C$     *         C:\        Standardfreigabe
                  #data   *         E:\data    tank/data
                  #IPC$   *                    Remote-IPC

                  @z=split(/\n/,$r);
                  foreach my $z (@z) {          # zeilen
                     if ($z=~/^\-|ScopeName|\$/i) { next; }

                     $z=~s/\*| +/ /g;
                     @p=split(/ +/,$z);
                     #[0] -> 'data'
                     #[1] -> 'E:\data'
                     #[2] -> 'tank/data'
                     $sharename="off";
                     $p[2]=~s/ //g;
                     $prop2="";

                     #&print_var($r);
                     if ($p[2] eq "$name") {
                          $sharename=$p[0];
                          last;
                     }

                     #&mess ($name);
                  }
                  #print "$sharename<br>";
                  #&mess($sharename);

                  ######################
                  #$zfs.="\t$sharename";

                  $u=$url;
                  $u=~s/=title=/SMB_Share/g;

                  $u=~s/=text=/$sharename/g;  $u=~s/=zfs=/$name/g;     $u=~s/=title=//g;
                  $u=~s/=prop=/$prop/g;       $u=~s/=list=/overview/g; $u=~s/=old=/$sharename/;
                  $u=~s/=prop2=/$sharename/g;
                  $zfs.="\t$u";

                  ######################
                  next;
             }

            # regular zfs properties
            #########################

                    $u=$url;
                    $t=$name."_$prop";
                    #&mess($t);

                    $t=$zfs{$t};
                    if ($t eq "") {
                            $zfs.="\tn.a.";
                    } else {
                        #    # encrypted without key ??
                        #    $o=$name."_encryption";
                        #    $o=$zfs{$o};
                        #    if ($o eq "on") {
                        #         $o=$name."_keystatus";
                        #         $o=$zfs{$o};
                        #          if ($o ne "available") {
                        #               $zfs.="\t$t";
                        #               next;
                        #          }
                        #     }

                             #avail total = avail + used -> in %
                             if ($prop eq "avail") {
                                  $w1=$t;
                                  $w1=&zfslib_val2kb($w1);


                                  $w2=$name."_used";
                                  $w2=$zfs{$w2};
                                  $w2=&zfslib_val2kb($w2);

                                  if ($w2>0) {
                                         $w2=&zfslib_val2proz($w1+$w2,$w2);              # total, used -> prozent value

                                         # pool: show percent, filesystem show iB

                                         if (!($name=~/\//)) {          # pool. add percent
                                                     if ($w2 < 26) {
                                                          if ($w2 < 16) {              #alert!
                                                               $t.="<font color='red'> [$w2%]</font>";
                                                          } else {
                                                               $t.="<font class='font_orange'> [$w2%]</font>";
                                                          }
                                                     }  else {
                                                          $t.=" [$w2%]";
                                                     }
                                         }
                                  }
                             }


                             # read-only-value
                             if ("canmount,mounted,mountpoint,type,creation,available,referenced,compressratio,mounted,avail,"=~/$prop,/i) {
                                # used in %

                                $zfs.="\t$t";
                                next;
                             }

                             $u=$url;
                             # readonly zfs red
                             if (($prop eq "readonly") && ($t eq "on")) {
                                  $o="<font class=\"font_darkred\">$t</font>";
                             } else {
                                  $o=$t;
                             }

                             if ($prop eq "used") {
                                   $u=~s/=title=/User and Group-Quotas/g;
                             }

                             if ($prop eq "driveletter") {
                                   $u=~s/=title=/Driveletter/g;
                                   $o="use letter $t";
                             }




                             $u=~s/=text=/$o/g;         $u=~s/=zfs=/$name/g;     $u=~s/=title=//g;
                             $u=~s/=prop=/$prop/g;      $u=~s/=list=/overview/g; $u=~s/=old=/$t/;
                             $zfs.="\t$u";
                    }
        }
     }

#&print_array(@zfs);
#&print_hash(%current);

    $zfs="";
    $zfs=join("\n",@zfs);

    #show as table
    if (!($zfs =~/\d/s)) { $zfs.="-none-"; }      # ex available

    $zfs=~s/  +/\t/gs;
    $zfs=&list2table($zfs);
    $zfs="<!--wsarea-->\n<div id='wsarea'>\n$zfs\n</div>\n<!--wsarea_end-->\n";    # realtime update of list only

    print "$zfs<br>$txt{'zfslist_footer'} <br>Size example 1T means 1 TiB";

    # add user and group quotas
    if ($in{'prop'} =~/^use/) {
         &zfslib_userquotas;

         if ($in{'prop'} ne "used")  {
              print &zfslib_ask_property;              # edit user
              print "\n</body></html>";
              return;
         } else {
              $in{'prop'}="";
         }
    }

    #ask property
    if (($in{'prop'} ne "") && ($in{'answered'} ne "1")) { print &zfslib_ask_property; }


    print "\n</body></html>";
    return;

 }


 ################
 sub zfslib_details {                 #hide:
 ################    show list of current zfs details  or show list of available zfs properties

    my ($zfs,$r,$url,$url2,$f,$l,@l,$acl);


   if ($in{'list'}  eq "overview") { &zfslib_overview; exit; }


if (!($in{'zfs'} eq $zfs{'syspool'})) {
   #########################

   #change zfs property
    if ($in{'answered'}) { &zfslib_change_property; }

   #overview
   $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=overview\&amp;zfs=\">Overview</a>";

   #list of  properies
   $url2=" <a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs=$in{'zfs'}\&amp;list=options\">Properties</a>";

   print "$url &nbsp; $url2\n";


   print "\n<br><br><b>ACL + Permissions /$in{'zfs'}:</b><br>\n";

   ### get folder acl ######################
   ###################
   #$f= &exe("ls -dV /$in{'zfs'}");

   #print set
   $r=&zfslib_acl2set($f);            # show sets
   $r=~s/  +/\t/gs;
   print &list2table($r);


   #get share acl
   #################

   $f=$in{'zfs'}; $f=~s/^.*\///;               # -> zfs name
   $f="/$in{'zfs'}/.zfs/shares/$f";

   #$f= &exe("ls -dV $f");

   $f=&zfslib_acl2set($f);                            # show sets
   $acl=$f;

   $r=$f;

   #######################
   #print "<br>\n";
   print "\n<br><br><b> Share ACL /$in{'zfs'} for everybody\@</b> \n";

   $r=~s/  +/\t/gs;
   print &list2table($r);


   #ask property
    if (($in{'prop'} ne "") && ($in{'answered'} ne "1")) { print &zfslib_ask_property; }
   #################################

   # !!

 } #/syspool

   ##print overview of "zfs"-folder
   ##################################
   print "<br><br>\n<b>ZFS Properties $in{'zfs'}</b><br>zfs set PROPERTY=VALUE NAME<br>";



   if ($in{'list'} eq "options") {
      $l=&exe("zfs set");                  #list options
      @l=split(/\n/,$l);  $l="";
      foreach $t (@l) {
        if ($t=~/^missing|^usage:|^The |^Sizes |^User-|^a user|^\s+set /) { next; }
        if (!($t=~/\w/)) { next; }
        $t=~s/^ +|^\t+//;
        $l.="$t\n";
      }
   } else {
     $l=&exe("zfs get all $in{'zfs'}");
   }

   #insert ask to table
   $l=&parse_date($l);
   $l=~s/  +/\t/gs;
   print &list2table($l);
   ##################################

   ## solaris 11
   if ($sys{'auto_os'} eq "Solaris 11") {
     print "<br><b>Solaris 11 share settings: zfs get -o name,value share</b>";

     $l=&exe("zfs get -o name,value share");
     $l=~s/,/\t/gs;
     $l=~s/  +/\t/gs;
     print &list2table($l); ;
   }


    print "\n</body></html>";

   return;

 }

 ##user and groupquotas
 sub zfslib_userquotas {
 ######################
     #url
     my $url="<a title=\"=title=\" href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;zfs==zfs=\&amp;prop==prop=\&amp;prop2==prop2=\&amp;old==old=\">=text=</a>";
     my (@l,$l,$t,@w,$w,$u);

     ##user
     ######

     my $header="SOURCE\tTYPE\tNAME\tUSED\tSET QUOTA (acl-extension only)\n";     # type, name, used, quota
     print "\n<br><br><br><b>User-Quota settings /$in{'zfs'}:</b><br>\n";

     my $r=&exe("zfs userspace -H \'$in{'zfs'}\'");

     @l=split(/\n/,$r);
     foreach $l (@l) {
                   $l=~s/^\s+//g;
                   $l=~s/\s+/\t/g;
                   @w=();
                   @w=split(/\t/,$l);

                   # set in c4
                   $t=$w[4];
                   $w[4]=$url;
                   $w[4]=~s/=text=/$t/; $w[4]=~s/=zfs=/$in{'zfs'}/; $w[4]=~s/=prop=/userquota:$w[2]/;
                   $w[4]=~s/=list=/$w[2]/; $w[4]=~s/=prop2=/userquota/; $w[4]=~s/=title=/set userquota of $w[2]/;  if (!($cfg{'ver'}=~/a|c/)) { $w[4]=$t; }

                   $l=join("\t",@w);

     }
     $r=join("\n",@l);

     $r="$header\n$r";
     print &list2table($r);


     # group
     #######

     $header="SOURCE\tTYPE\tNAME &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\tUSED\tSET QUOTA (acl-extension only)\n";
     print "\n<br><br><br><b>Group-Quota settings /$in{'zfs'}:</b><br>\n";

     $r=&exe("zfs groupspace -H \'$in{'zfs'}\'");

     @l=split(/\n/,$r);
     foreach $l (@l) {
                   $l=~s/^\s+//g;
                   $l=~s/\s+/\t/g;
                   @w=();
                   @w=split(/\t/,$l);

                   # set in c4
                   $t=$w[4];
                   $w[4]=$url;
                   $w[4]=~s/=text=/$t/; $w[4]=~s/=zfs=/$in{'zfs'}/; $w[4]=~s/=prop=/usergquota:$w[2]/;
                   $w[4]=~s/=list=/$w[2]/; $w[4]=~s/=prop2=/usergquota/; $w[4]=~s/=title=/set groupquota of $w[2]/;  if (!($cfg{'ver'}=~/a|c/)) { $w[4]=$t; }

                   $l=join("\t",@w);

     }
     $r=join("\n",@l);

     $r="$header\n$r";
     print &list2table($r);

     &log_end;
     print "<br><br><br><br>";
     return;
 }

 #######################
 sub zfslib_refresh_svc  {                   #hide: refresh or reload all share services (smb,afp,nfs,www) - needed for ex if you lock/ unlock encrypted zfs
 #######################
  my ($smb,$nfs,$apache,$afp,$r);
  my $s=&exe("svcs");
  my @s=split(/\n/,$s);
  foreach $t (@s) {
           # smb
           if (($s=~/online/) && ($s=~/\/smb\/server/) && ($smb ne "1")) {
              $smb="1";
              $t=$in{'zfs'}."_sharesmb";
              if ($zfs{$t}=~/on|\=/) {
               $r=`sudo svcadm disable smb/server && sudo svcadm enable -r smb/server | at -s now`;
              }
           }
           # nfs
           if (($s=~/online/) && ($s=~/\/nfs\/server/) && ($nfs ne "1")) {
              $nfs="1";
              $t=$in{'zfs'}."_sharenfs";
              if ($zfs{$t}=~/on/) {
                `sudo svcadm refresh nfs/server | at -s now | > /dev/null`;
              }
           }
           # apache2 (nexenta)
           if (($s=~/online/) && ($s=~/apache2$/) && ($apache ne "1")) {
                 $apache="1";
                 `sudo svcadm refresh apache2 | at -s now | > /dev/null`;
           }
           # apache22 (solaris)
           if (($s=~/online/) && ($s=~/apache22$/) && ($apache ne "1")) {
                 $apache="1";
                `sudo svcadm refresh apache22 | at -s now | > /dev/null`;;
           }
           #afp
           $t=&exe("ps ax");
           if (($t=~/afpd/s) && ($afp ne "1")) {
                $afp="1";
                #print "restart AFPd";
                `sudo /etc/init.d/netatalk stop`;
                `sudo /etc/init.d/netatalk start`;
           }
  }
  #exit;

 }

 ##########################
 sub zfslib_update_rsync {      #hide: update /var/web-gui/_log/rsyncd.conf
 ##########################
    my (@pools,$r,@s,$f,$sn,$n,$cf,$pf,$t);
    # read shares, verify if ZFS is available
    # for all shares, add settings to /var/web-gui/_log/rsyncd.conf

    `sudo touch /var/web-gui/_log/rsyncd.conf`;
    `sudo chmod 666 /var/web-gui/_log/rsyncd.conf`;

    $n=`cat /var/web-gui/_log/rsyncd.conf`;
    $n=~s/\[.*//s;   # keep header

    # part 1: verify shares
    @pools=split(/\t/,$zfs{'datapools'});
    foreach my $p (@pools) {
            # read shares

             $f="/$p/.rsyncd_shares";

             `sudo touch $f`;
             `sudo chmod 666 $f`;

              $r=`cat \'$f\'`;

              @s=();
              @s=split(/\n/,$r);                           # rsync shares

              open (PF, ">$f");                            # open share config file
              foreach my $s (@s) {

                  $sn=$s; $sn=~s/\//./g;                    # tank/data -> tank.data
                  $cf="/$p/.rsyncd_shares_config_$sn";      # share config file
                  $pf="/$p/.rsyncd_shares_scrt_$sn";        # share pw file

                  if (-d "/$s") {
                       print PF "$s\n";                     # write zfs filesystem

                       # add to n(ew)
                       if (-f "$cf") {
                          $t=`cat $cf`;
                          $n.=$t;
                          $n.="\n";

                          if ((-f "$pf") && ($t=~/auth users *= *\w+/)) {
                               $n.="secrets file = $pf\n";
                          }
                          $n.="\n";
                       }

                  } else {

                       #if (-f "$cf")  { `sudo rm $cf`; }     # config file, optional
                       #if (-f "$pf")  { `sudo rm $pf`; }     # pw file
                  }
              }
              close (PF);

              # update configfile
              $n=~s/\n +/\n/gs;
              open (PF, ">/var/web-gui/_log/rsyncd.conf");
                       print PF "$n\n";
              close (PF);

    }

 }
######
sub zfslib_get_ftp_par {  # hide: parameter: configfile, ParameterList -> par to %current
######
 my ($t,$c,$p,$o);
 my $config=$_[0];

 #  $par="VirtualHost,ServerName,Port";
 my @c=split(/\n/,$config);

 foreach $c (@c) {
         if ($c=~/<VirtualHost/) {
              $o="vftp_ip";
              $current{$o}=$c;    $current{$o}=~s/.*VirtualHost +|\>//g;    #ip
              if ($current{$o} eq "") { $current{$o}="127.0.0.1"; }
         }
         if ($c=~/Port/) {
              $o="vftp_port";
              $current{$o}=$c;    $current{$o}=~s/.*Port *//g;              #port
              if ($current{$o} eq "") { $current{$o}="21"; }
         }
         if ($c=~/<Anonymous/) {
              $o="vftp_dir";
              $current{$o}=$c;    $current{$o}=~s/.*Anonynmous *|>//g;        #dir
              if ($current{$o} eq "") { $current{$o}="/$in{'zfs'}"; }
         }
 }
 $current{'vftp_host'}="$current{'vftp_ip'}:$current{'vftp_port'}";

 #debug
  #&print_array(@c);
  #&print_hash(%current);

}

######
sub zfslib_get_vhost_par {  # hide: parameter: configfile, ParameterList -> par to %current
######
 my ($t,$c,$p,$o);
 my $config=$_[0];
 my $par=$_[1];
 if ($par eq "") {  $par="VirtualHost,DocumentRoot,ErrorLog,CustomLog,ServerAdmin,ServerName,Listen"; }
 my @par=split(/,/,$par);
 my @c=split(/\n/,$config);

 foreach $c (@c) {                       # every line of config
     foreach $p (@par) {                 # every par

         $c=~s/<|>//g;                   # ex <VirtualHost
         if (!($c=~/^\s*$p/i)) { next; } # ex DocumentRoot /path

         chomp($c);
         $c=~s/^\s*$p\s+//;


         $t="vhost_$p";

         # 'path with spaces'
         if ($c=~/\'$|\"$/) {
           $c=~s/\'|\"//g;
           if ($c=~/ /) { $c="\"$c\""; }   # mask
         }

         if ($p eq "VirtualHost") {
              #port
              if ($c=~/:/) {
                   $o="vhost_port";
                   $current{$o}=$c;
                   $current{$o}=~s/.*://;    # port only

                   $o="vhost_ip";
                   $current{$o}=$c;
                   $current{$o}=~s/:.*//;    # port only
              }

         }
         $current{$t}=$c;

     }
 }

 #debug
 # &print_array(@c);
 # &print_hash(%current);
}


 ##########################
 sub zfslib_update_ftp {      #hide: update   /opt/local/etc/proftpd.conf
 ##########################
    my (@pools,$r,@s,$f,$sn,$n,$cf,$pf,$t,$l,$c);
    # read shares, verify if ZFS is available
    # for all shares, add settings to /var/web-gui/_log/rsyncd.conf

    if ($sys{'auto_os_type'} eq "sol_s") {
          $c="/etc/proftpd.conf";                        # Solaris
    } else {
          $c="/opt/local/etc/proftpd.conf";
    }

    `sudo touch $c`;
    `sudo chmod 666 $c`;

    if (!(-f $c)) { &mess("FTP configuration $c not found"); }

    # generate new config
    $n=`cat \'$c\'`;
    $n=~s/ *<VirtualHost.*/\n#VirtualHosts: created from Menu ZFS folders, do not edit manually/s;

    # add virtual ftp from all pools
    # part 1: verify shares
    @pools=split(/\t/,$zfs{'datapools'});
    foreach my $p (@pools) {
            # read shares

             $f="/$p/.ftp_shares";

             `sudo touch $f`;
             `sudo chmod 666 $f`;

              $r=`cat \'$f\'`;

              @s=();
              @s=split(/\n/,$r);                        # www shares

              open (PF, ">$f");
              foreach my $s (@s) {
                  $l=$s;                                # keep line
                  $s=~s/,.*//;                          # remove ip and name
                  $sn=$s; $sn=~s/\//./g;                # tank/data -> tank.data
                  $cf="/$p/.ftp_shares_config_$sn";     # share config file

                  if (-d "/$s") {
                       print PF "$l\n";

                       # add to n(ew)
                       if (-f "$cf") {

                          $t=`cat $cf`;
                          if ($t eq "") { next; }

                          $n.="\n\n################# vftp: /$in{'zfs'} ##################\n";
                          $n.=$t;
                          $n.="\n";
                       }

                  } else {

                       if (-f "$cf")  { `sudo rm $cf`; }     # config file
                  }
              }
              close (PF);
    }
    # update configfile
              $n=~s/\n +/\n/gs;
              open (PF, ">$c");
                       print PF "$n\n";
              close (PF);

              #refresh
              &exe("svcadm clear proftpd");
              &exe("svcadm refresh proftpd"); sleep(2);

              print "service state: in case of problems, check menu Services-Apache<hr><pre>";
              print `svcs proftpd`;
              print "</pre>";
              sleep(2)
}

 ##########################
 sub zfslib_update_www {      #hide: update
 ##########################
    my (@pools,$r,@s,$f,$sn,$n,$cf,$pf,$t,$l);
    # read shares, verify if ZFS is available
    # for all shares, add settings to /var/web-gui/_log/rsyncd.conf

    `sudo touch /opt/local/etc/httpd/httpd-vhosts.conf`;
    `sudo chmod 666 /opt/local/etc/httpd/httpd-vhosts.conf`;

    # generate /opt/local/etc/httpd/httpd-vhosts.conf
    $n=<<EoF;
# Virtual Hosts
#
# Required modules: mod_log_config

# If you want to maintain multiple domains/hostnames on your
# machine you can setup VirtualHost containers for them. Most configurations
# use only name-based virtual hosts so the server doesn't need to worry about
# IP addresses. This is indicated by the asterisks in the directives below.
#
# Please see the documentation at
# <URL:http://httpd.apache.org/docs/2.4/vhosts/>
# for further details before you try to setup virtual hosts.
#
# You may use the command line option '-S' to verify your virtual host
# configuration.

#
# VirtualHost example:
# Almost any Apache directive may go into a VirtualHost container.
# The first VirtualHost section is used for all requests that do not
# match a ServerName or ServerAlias in any <VirtualHost> block.
#
# This file is autogenerated from zfslib.pl module zfslib_update_www
# do not edit manually, edit in napp-it menu zfs folder
#

EoF

    # part 1: verify shares
    @pools=split(/\t/,$zfs{'datapools'});
    foreach my $p (@pools) {
            # read shares

             $f="/$p/.www_shares";

             `sudo touch $f`;
             `sudo chmod 666 $f`;

              $r=`cat \'$f\'`;

              @s=();
              @s=split(/\n/,$r);                        # www shares

              open (PF, ">$f");
              foreach my $s (@s) {
                  $l=$s;                                # keep line
                  $s=~s/,.*//;                          # remove ip and name
                  $sn=$s; $sn=~s/\//./g;                # tank/data -> tank.data
                  $cf="/$p/.www_shares_config_$sn";     # share config file

                  if (-d "/$s") {
                       print PF "$l\n";

                       # add to n(ew)
                       if (-f "$cf") {

                          $t=`cat $cf`;
                          if ($t eq "") { next; }

                          $n.="\n\n################# vhost: /$in{'zfs'} ##################\n";
                          $n.=$t;
                          $n.="\n";
                       }

                  } else {

                       if (-f "$cf")  { `sudo rm $cf`; }     # config file
                  }
              }
              close (PF);
        }

        # update configfile
              $n=~s/\n +/\n/gs;
              open (PF, ">/opt/local/etc/httpd/httpd-vhosts.conf");
                       print PF "$n\n";
              close (PF);

              #refresh
              if ($sys{'auto_os_type'} eq "sol_s") {
                   $t="apache2";                       # Solaris
              } else {
                   $t="apache";
              }
              &exe("svcadm clear $t");
              &exe("svcadm refresh $t"); sleep(2);

              print "service state: in case of problems, check menu Services-Apache<hr><pre>";
              print `svcs $t`;
              print "</pre>";
              sleep(2);
 }

 ######################
 sub zfslib_change_property {                 #hide:
 #######################    set zfs details
 my ($e,$r,$s,$t,@l,$l,@n,$i,$o,$p,$z,$f,$ok,$pool,$dl,$k);

 #smb_share:
  if ($in{'prop'} eq "smb_share:") {
        #&print_hash(%in);
        $in{'text'}=lc($in{'text'});
        $in{'text'}=~s/[^a-z0-9]//g;           # off or sharename

        if ($in{'text'} eq "off") {
            $t="ps Remove-SmbShare -Name $in{'prop2'} -force";
            #$t="ps Remove-SmbShare -Name $in{'prop2'} -Confirm";
            print &exe("$t");
            # &mess($t);
        } else {
          # driveletter
          $t=$in{'zfs'};     # tank/data
          $t=~s/\/.*//;      # tank
          $dl=&exe("zfs get -H -o value driveletter $t");
          #&print_var($dl);

          $dl=~s/[^a-z:]//gs;
          #&print_var($dl);

          # driveletter?
          if (!($dl=~/[a-z]:/)) {
            &mess("You must set ZFS property driveletter on poollevel ex e:");
          }
          $i=$in{'zfs'};  # tank/data
          $i=~s/\//\\/g;
          $i="$dl\\$i";
          #&mess ($i);
          # New-SmbShare -Name "Data" -Path "C:\Data" -Access "Read,Full" -PermissionGroup "Everyone,Administrators"

          $t="ps New-SmbShare -Name $in{'text'} -path \"$i\" -Description $in{'zfs'}";
          print "$t<br>"; sleep(3);
          print &exe($t);

          #&mess($t);

        }
        # set to off
  }


   ##### execute lock
   ##################
   if ($in{'prop'} eq "lock") {
        print "please wait...\n";


        #remember smb
        if ($in{'remember'} eq "last") {

            # get smb share value
            if ($sys{'auto_os'} eq "Solaris 11") {
                #$r=`sudo /sbin/zfs get -H -o name,value share $in{'zfs'} | grep prot=smb`; chomp($r); # name=geheim6,path=/tank/geheim6,prot=smb,guestok=true
            } else {
                $r=`sudo /sbin/zfs get -H -o value sharesmb $in{'zfs'}`;
            }
            chomp($r);

            $r=`sudo /sbin/zfs set enc_smbshare:=$r $in{'zfs'}`;
        }

        #unshare
        if ($in{'remember'} eq "off") {
            $r=`sudo /sbin/zfs set sharesmb=off $in{'zfs'}`;
            $r=&exe("zfs inherit -r enc_smbshare: $in{'zfs'}");
            $r=&exe("zfs inherit -r sharesmb $in{'zfs'}");
        }

        # Open-ZFS

             $r=`sudo /sbin/zfs unmount -f $in{'zfs'}`;      # key unload require unmounted fs
             $r=`sudo /sbin/zfs unload-key -r $in{'zfs'}`;
             if (!($r =~/ success/)) {  &mess($r); }



        #if ($in{'smbrefresh'} eq "yes") {  # opt SMB refresh
        #  print "<br>refresh services";
        #  &zfslib_refresh_svc;
        #}
   }


   ##### unlock
   ###########
   if ($in{'prop'} eq "unlock") {
        print "please wait ...\n";

        if (($in{'call'} =~/agent|boot/) && ($in{'pass'}=~/[LW]\d:[LW]\d/)) { print "Split=$in{'pass'}"; }

        $k=$in{'pass'};
        if ($in{'pass'}=~/[LW]\d:[LW]\d/) {  # ex L1:L2
             $in{'pass'}=~s/[^LW\d:]//g;
             require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/keyserverlib.pl";
             $k=&key_get_lw($in{'zfs'},$in{'pass'});

        }

        if (!($k=~/\w+/)) {
          if ($in{'call'} eq "agent") { return "error, missing key"; }
          &mess("invalid or missing key");
        }

        #debug
        if ($in{'call'} eq "agent")   {            # auto/userunlock
           print "\ncall=$in{'call'}\n";
           $t=&key_get_smbak($k);   # text only
           print "\n\n#######user smbkey: $in{'user_smbkey'}\nsmbkey: $t\n######\n";   #$in{'user_smbkey'} from auto_lock.pl line 309
           if ($t ne "$in{'user_smbkey'}") {
               print "####### wrong smbkey in =switcher.move\n";
               return("error, wrong or missing smbkey");
           }
        }

        if ($sys{'auto_os'} eq "Solaris 11") {
             # not prompt
             $r=`sudo /sbin/zfs get -H -o value keysource $in{'zfs'}`;
             chomp($r);

             if ($r=~/,prompt/) {
                #
               # use Expect;
                my $exp; #->raw_pty(1);
     ### martingo 20180306 >>> mount hat die Option -r fuer rekursives mounten nicht; key fuehrt ebenfalls den mount durch (mit -r inklusive aller UnterZFS)
                #$exp = Expect->spawn("sudo zfs mount $in{'zfs'}") or die "Couldn't mount: $!\n";
                $exp = Expect->spawn("sudo /sbin/zfs key -l -r $in{'zfs'}") or die "Couldn't mount: $!\n";
     ### <<<

                $exp->expect(1,
                        [ 'Enter' =>
                                 sub {
                                     $exp->send("$k\r");
                                     print "<br><br>\n";
                                     exp_continue;
                                 }
                        ]
                 );
                 $exp->soft_close();


             } else {
                 print "<br>";
                 print `sudo /sbin/zfs key -l $in{'zfs'} 2>&1`; # unlock
             }

             # on success
             $r=`sudo /sbin/zfs get -H -o value keystatus $in{'zfs'}`; chomp($r);
             if ($r eq "available") {
                  #

                  # restore smb shares?
                  $r=`sudo /sbin/zfs get -H -o name,value share $in{'zfs'} | grep prot=smb`; chomp($r); # name=geheim6,path=/tank/geheim6,prot=smb,guestok=true

                  if ($r eq "") {  # no share currently activated
                       $r=`sudo /sbin/zfs get -H -o value enc_smbshare: $in{'zfs'}`; chomp($r);

                       if ($r=~/[a-z]/) {                      # sharesmb=name=data,guestok=true
                              #reshare
                              $t=$r;
                              $t=~s/.*name=//; $t=~s/\+.*//;   # keep name

                              if ($t ne "off") {              # do not share with name=off
                                #
                                if ($t eq "on") {
                                  $t="=on";
                                } else {
                                  $t="=name=$t";
                                }

                                $t="share$t,path=/$in{'zfs'},prot=smb";
                                if ($r=~/\+guest/) { $t.=',guestok=true'; }
                                if ($r=~/\+abe/)   { $t.=',abe=true'; }

                                $t.=" $in{'zfs'}";

                                $r=`sudo /sbin/zfs set $t`;
                                $r=`sudo /sbin/zfs set sharesmb=on $in{'zfs'}`;
                              }
                       }
                  }

                  if ($in{'pass'}=~/^[LW]\d:[LW]\d$/) {  # ex L1:L2
                     $r=`sudo /sbin/zfs set enc_split:=$in{'pass'} $in{'zfs'}`; # remember last enc_split:
                  }  else {
                     if ($in{'call'} =~/agent|boot/) { return "error, split info missing"; }
                  }


              } else {
                 if ($in{'call'} =~/agent|boot/) { return "error, wrong key"; }
                 &mess("wrong key, unlock not possible");
              }

        } else { # Illumos

             $r=`sudo /sbin/zfs get -H -o value keylocation $in{'zfs'}`;
             chomp($r);

             if ($r=~/prompt/) {
                #
                #use Expect;
                my $exp; #->raw_pty(1);
     ### martingo 20180306 >>> mount hat die Option -r für rekursives mounten nicht; key führt ebenfalls den mount durch (mit -r inklusive aller UnterZFS)
                #$exp = Expect->spawn("sudo zfs mount $in{'zfs'}") or die "Couldn't mount: $!\n";
                $exp = Expect->spawn("sudo /sbin/zfs load-key $in{'zfs'}") or die "Couldn't load key: $!\n";
     ### <<<

                $exp->expect(1,
                        [ 'Enter' =>
                                 sub {
                                     $exp->send("$k\r");
                                     print "<br><br>\n";
                                     exp_continue;
                                 }
                        ]
                 );
                 $exp->soft_close();

                 print `sudo /sbin/zfs mount $in{'zfs'} 2>&1`; # mount, key is available

             } else {      # file
                 print "<br>";
                 print `sudo /sbin/zfs load-key $in{'zfs'} 2>&1`; # unlock and mount, key is available as file
             }


             # on success (Ill)
             $r=`sudo /sbin/zfs get -H -o value keystatus $in{'zfs'}`; chomp($r);
             if ($r eq "available") {

               #on success, mount subfilesystems 7.10.2021, not mounted with smb=off on parent
               $r=`sudo /sbin/zfs list -H -o name -t filesystem | grep $in{'zfs'}/`; chomp($r);
               @t=split(/\n/,$r);
               foreach my $t (@t) {
                    print `sudo /sbin/zfs mount $t 2>&1`; # mount sub, key is available
                    print "mount $t<br>";
               }
               #&print_array(@t);

               ###
               $r=`sudo /sbin/zfs set sharesmb=off $in{'zfs'}`;    #  off as default


               if ($in{'smbrefresh'} eq "off") {

                  $r=&exe("zfs inherit -r sharesmb $in{'zfs'}");   # inherit off

               } else {         #last

                  # restore smb shares?

                  $r=`sudo /sbin/zfs get -H -o value enc_smbshare: $in{'zfs'}`; chomp($r);

                  if ($r=~/[a-z]/) {                      # sharesmb=name=data,guestok=true
                              #reshare
                              $t=$r;
                              $t=~s/.*name=//; $t=~s/,.*//;  #keep name

                              if ($t ne "off") {           # do not share with name=off
                                #
                                if ($t eq "on") {
                                  $t="on";
                                } else {
                                  $t="name=$t";
                                }

                                if ($r=~/guest/) { $t.=',guestok=true'; }
                                if ($r=~/abe/)   { $t.=',abe=true'; }

                                $r=`sudo /sbin/zfs set sharesmb=$t $in{'zfs'}`;
#&mess("zfs set sharesmb=$t $in{'zfs'}<br>$r");
                              }
                  }

                  # (re)set local zfs prop (ex missing after replication)
                  $t=&key_get_smbak($in{'pass'});
                  $r=`sudo /sbin/zfs set enc_smbak:=$t $in{'zfs'}`;           # enc_smbak:

                  if ($in{'pass'}=~/^[LW]\d:[LW]\d$/) {  # ex L1:L2
                    $r=`sudo /sbin/zfs set enc_split:=$in{'pass'} $in{'zfs'}`; # remember last enc_split:
                  } else {
                     if ($in{'call'} =~/agent|boot/) { return "error, split info missing"; }
                  }
               }

              } else {
                 if ($in{'call'} =~/agent|boot/) { return "error, wrong key"; }
                 &mess("wrong key, unlock not possible");
              }
        }
   }


  #driveletter
  ############
  if ($in{'prop'} eq "driveletter") {
  #&print_hash(%in);

        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('select a value'); }
        $r=&exe("zfs set driveletter=$in{'text'} $in{'zfs'}");

        # require unmount + mount
        print "execute unmount<br>";
        print &exe("zfs unmount $in{'zfs'}");

        print "execute mount<br>";
        print &exe("zfs mount $in{'zfs'}");

        # if pool, mount recursive
        $t=&exe("zfs list -H -o name");
        @t=split(/\n/,$t);
        foreach my $t (@t) {
               if (!($t=~/\//)) { next; }    # subfilesystems only
               print "execute mount sub filesystem $t<br>";
               print &exe("zfs mount $t")
        }


        sleep(4);
  }

  #compression
  ############
  if ($in{'prop'} eq "compression") {

        # use always lz4
        $t="lz4";

        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }
        if ($in{'text'} eq "off") {  $r=&exe("zfs set compression=off $in{'zfs'}");  }
        if ($in{'text'} ne "off")  {
             # lz4?
             $r=&exe("zfs set compression=$t $in{'zfs'}");
        }
        if ($r ne "") {  print $r; sleep(2); }
  }

  #nbmand
  #######
  if ($in{'prop'} eq "nbmand") {
        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }
        if ($in{'text'} eq "off") {  $r=&exe("zfs set nbmand=off $in{'zfs'}");   }
        if ($in{'text'} eq "on")  {  $r=&exe("zfs set nbmand=on $in{'zfs'}");  }

        if ($r ne "") {  print $r; sleep(2); }
#&mess("$in{'text'} $r");

        #unmount/mount is needed !!
        $r.=&exe("zfs unmount -f $in{'zfs'}");
        $r.=&exe("zfs mount $in{'zfs'}");

  }

  #&print_hash(%in);
  #readonly
  if ($in{'prop'} eq "readonly") {

        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }

        #recursiv?
        if ($in{'recursive'}) {

                  # load ZFS and ZFS below
                  my $zfs=`zfs list -H -o name`;   # all ZFS names
                  @t=();
                  @t=split(/\n/,$zfs);

                  #collect ZFS
                  my @zfs=();
                  foreach my $p (@t) {
                                      chomp($p);
                                      if (!($p=~/^$in{'zfs'}\b/)) { next; }            # not below

                                      $type=`zfs list -H -o type`;           # do not post-process volumes
                                      chomp($type);
                                      if ($type eq "volume") { next; }
                                      push (@zfs,$p);
                  }
#&print_array(@zfs);
                  foreach my $p (@zfs) {
                          if ($in{'text'} eq "off") {  $r=&exe("zfs set readonly=off $p");  }
                          if ($in{'text'} eq "on")  {  $r=&exe("zfs set readonly=on $p");  }
                  }

        } else {

          if ($in{'text'} eq "off") {  $r=&exe("zfs set readonly=off $in{'zfs'}");  }
          if ($in{'text'} eq "on")  {  $r=&exe("zfs set readonly=on $in{'zfs'}");  }
          if ($r ne "") {  print $r; sleep(2); }
        }
  }


  #recsize
  if ($in{'prop'} eq "recsize") {
        $in{'text'}=lc($in{'text'});
        $in{'text'}=~s/[^a-z0-9]//g;
        if ($in{'text'} eq '') { $in{'text'}="128k"; }
        $r="";
        $r=&exe("zfs set recsize=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  #dedup
  if ($in{'prop'} eq "dedup") {
        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }
        if ($in{'text'} eq "off") {  $r=&exe("zfs set dedup=off $in{'zfs'}");  }
        if ($in{'text'} eq "on")  {  $r=&exe("zfs set dedup=on $in{'zfs'}");  }
        if ($r ne "") {  print $r; sleep(2); }
  }

  #quota
  if ($in{'prop'} eq "quota") {

        if ($in{'text'} eq "") { $in{'text'} = 'none';   }
        if ($in{'text'} ne 'none') {
            if (!($in{'text'}=~/M|G|T/i)) { &mess('MGT (Mega/Giga/Tera)-Byte'); }
            if (!($in{'text'}=~/\d+\w/)) {  &mess('Incorrect size! Enter Quota for example: 10G'); }
        }
        $r="";
        $r=&exe("zfs set quota=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  #refquota
  if ($in{'prop'} eq "refquota") {

        if ($in{'text'} eq "") { $in{'text'} = 'none';   }
        if($in{'text'} ne 'none') {
            if (!($in{'text'}=~/M|G|T/i)) { &mess('MGT (Mega/Giga/Tera)-Byte'); }
            if (!($in{'text'}=~/\d+\w/)) {  &mess('Incorrect size! Enter RefQuota for example: 10G'); }
        }
        $r="";
        $r=&exe("zfs set refquota=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  #reservation
  if ($in{'prop'} eq "reservation") {

        if ($in{'text'} eq "") { $in{'text'} = 'none';   }
        if($in{'text'} ne 'none') {
            if (!($in{'text'}=~/M|G|T/i)) { &mess('MGT (Mega/Giga/Tera)-Byte'); }
            if (!($in{'text'}=~/\d+\w/)) {  &mess('Incorrect size! Enter reservation for example: 10G'); }
        }


         $r="";
        $r=&exe("zfs set reservation=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  #refreservation
  if ($in{'prop'} eq "refreservation") {

        if ($in{'text'} eq "") { $in{'text'} = 'none';   }
        if($in{'text'} ne 'none') {
            if (!($in{'text'}=~/M|G|T/i)) { &mess('MGT (Mega/Giga/Tera)-Byte'); }
            if (!($in{'text'}=~/\d+\w/)) {  &mess('Incorrect size! Enter refreservation for example: 10G'); }
        }


         $r="";
        $r=&exe("zfs set refreservation=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  # userquota: zfs set userquota@student1=10G students/compsci
  if ($in{'prop'} =~/userquota/) {
        $t=$in{'prop'}; $t=~s/userquota://;
        if ($in{'text'} =~/^\d+[KMGTP]$|^none$/) {
           $r=&exe("zfs set userquota\@$t=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  &mess($r); }
        } else {
           &mess("none or a value like 5G");
        }
        $in{'prop'}="used";
       # &reload;
  }

  # groupquota: zfs set groupquota@staff=10G students/compsci
  if ($in{'prop'} =~/usergquota/) {
        $t=$in{'prop'}; $t=~s/usergquota://;
        if ($in{'text'} =~/^\d+[KMGTP]$|^none$/) {
           $r=&exe("zfs set groupquota\@$t=$in{'text'} $in{'zfs'}");
        if ($r ne "") {  &mess($r); }
        } else {
           &mess("none or a value like 5G");
        }
        $in{'prop'}="used";
        #&reload;
  }

  #aclinherit
  if ($in{'prop'} eq "aclinherit") {
        $r=&exe("zfs set aclinherit=$in{'aclinherit'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

  #aclmode obsolet in zfs v. 25+
  #if ($in{'prop'} eq "aclmode") {
  #      $r=&exe("zfs set aclmode=$in{'aclmode'} $in{'zfs'}");
  #      if ($r ne "") {  print $r; sleep(2); }
  #}

  #sync
  if ($in{'prop'} eq "sync") {
        $r=&exe("zfs set sync=$in{'sync'} $in{'zfs'}");
        if ($r ne "") {  print $r; sleep(2); }
  }

 #snapdir
  if ($in{'prop'} eq "snapdir") {
        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('snapdir hidden or visible?'); }
        if ($in{'text'} eq "hidden")   {  $r=&exe("zfs set snapdir=hidden $in{'zfs'}");  }
        if ($in{'text'} eq "visible")  {  $r=&exe("zfs set snapdir=visible $in{'zfs'}");  }
        if ($r ne "") {  print $r; sleep(2); }
  }

  #readonly
  if ($in{'prop'} eq "readonly") {
        $in{'text'}=~s/[^a-zA-Z0-9\-\_]//g;
        $r="";
        if ($in{'text'} eq "") {  &mess('on or off?'); }
        if ($in{'text'} eq "off") {  $r=&exe("zfs set readonly=off $in{'zfs'}");  }
        if ($in{'text'} eq "on")  {  $r=&exe("zfs set readonly=on $in{'zfs'}");  }
        if ($r ne "") {  print $r; sleep(2); }
  }


   $in{'action'}="";
   $in{'prop'}="";
   $in{'zfs'}="";
   if ($in{'call'} eq "agent") { return "ok, $smb"; }


   &reload;

 }

##############
sub zfslib_get_default_ftp {
##############
my $d= <<EoF;

<VirtualHost =ip=>
  ServerName                     "FTP server"
  Port                           21
  Umask                          022

  <Limit LOGIN>
    DenyAll
  </Limit>

  <Anonymous  =path=>
    User                         nobody
    Group                        nobody
    UserAlias                    anonymous nobody

    <Limit LOGIN>
      AllowAll
    </Limit>

    <Limit WRITE>
      DenyAll
    </Limit>
  </Anonymous>
</VirtualHost>

EoF
return($d)
}


##############
sub zfslib_get_default_vhost {
##############

my $d= <<EoF;

<VirtualHost auto_set>
    ServerAdmin auto_set
    DocumentRoot auto_set
    ServerName auto_set
    ErrorLog auto_set
    CustomLog auto_set
    DirectoryIndex index.php index.html

   # Directory options "/pool/zfs/_wwwroot"
   <Directory "=document_root=">
      Require all granted
      Options Indexes FollowSymLinks
      AllowOverride None
      Order allow,deny
      Allow from all
    </Directory>

   # ScriptAlias ex /cgi-bin/ "/pool/zfs/wwwroot/cgi-bin/"
   ScriptAlias /cgi-bin/ "=document_root=/cgi-bin/"

   #Directory options "/$in{'zfs'}/_wwwroot/cgi-bin"
   <Directory "=document_root=/cgi-bin">
      Require all granted
      AllowOverride None
      Options +ExecCGI
      Order allow,deny
      Allow from all
   </Directory>
</VirtualHost>
EoF
return($d);
 }

 ##############
 sub zfslib_get_iplist {         # to %current
 #############
         # get current ip_list
        $t=`sudo ipadm show-addr`;
        my @p=split(/\n/,$t);
        $current{'ip_list'}="";
        foreach my $p (@p) {
              @t=();
              @t=split(/ +/,$p);
              if (!($p=~/ok/))          { next; }
              if ($p=~/::/)             { next; }     # ip6
              if ($p=~/127\.0\.0\.1/)   { next; }     # ip6
              $t[3]=~s/\/.*//;                        # 192.168.1.1/24
             $current{'ip_list'}.="\t$t[3]";
        }
        $current{'ip_list'}=~/\t+$/;
  }

 ##############
 sub zfslib_get_ftpshares {      # to %current
 #############
        my (@ip,@t,$p,$t,$i,@v,$a,$f,@s,@w,$np);

        #get ip
        &zfslib_get_iplist;
        my @t=();
        @t=split(/\t/,$current{'ip_list'});                   # available ip
        foreach my $t (@t) {
           if(!($t=~/\d+/)) { next; }                         # default ftp port 21 only
           push(@ip,$t);
        }

        # read all wwwshares
        my @ftpshares=();

        $p="";
        @t=split(/\t/,$zfs{'datapools'});
        foreach my $t (@t) {
                if (-f "/$t/.ftp_shares") {
                     $p.=`cat /$t/.ftp_shares`;               # ex tank/data,192.168.1.1:21
                     $p.="\n";
                }
        }

        # get avail ip:port
        @s=split(/\n/,$p);

        # get avail adress:ip
        $a=",";

        # step1, determine used ports for every ip
        foreach my $s (@s) {                            # tank/data,192.168.1.1:80,name
                      @w=();
                      @w=split(/,/,$s);

                      $p="";
                      if ($w[1]=~/\]:/) {                       # ip6 [2001:0db8:85a3:08d3:1319:8a2e:0370:7344]:8080
                         $i=$w[1];
                         $i=~s/\].*/\]/;
                         $p=$w[1];
                         $p=~s/.*://;
                         $ip="[$ip]";
                         $current{'vftp_ip'}="$p";
                      } else {                                  # ip4
                         $i=$w[1];
                         $i=~s/:.*//;
                         $p=$w[1];
                         $p=~s/.*://;
                         $current{'vftp_ip'}="$p";
                      }

                      #

                      $t="vftp_ports_$i";
                      if (!($current{$t}=~/\b$p\b/)) {
                         $current{$t}.="$p,";
                      }

                     # &print_hash(%in);
                     #
                      # add used to avail for current share
                      if ($w[0] eq $in{'zfs'})  {
                         $current{'vftp_avail'}.="$i:$p,";
                      }

        }

        # avail port:ip
        my $c="1";
        foreach my $ip (@ip) {                                  # 192.168.1.1 or 2001:0db8:85a3:08d3:1319:8a2e:0370:7344

             # max 1 extra port per ip
             $t="vftp_ports_$ip";

             # no port used
             if ($current{$t} eq "") {
                  $a.="$ip:21,";
             } else {
                  if (!($current{$t} =~/\b21\b/)) { $a.="$ip:21,";   $c++; }  if ($c > 1) { $c="1"; next; }
                  if (!($current{$t} =~/2121/))   { $a.="$ip:2121,"; $c++; }  if ($c > 1) { $c="1"; next; }
             }
        }
        $a=~s/,$//;
        $current{'vftp_avail'}.=$a;
        $current{'vftp_avail'}=~s/,+/,/g;
        $current{'vftp_avail'}=~s/,$|^,//g;
 # debug
 # &print_array(@a);
 # &mess($a);
 # &print_hash(%current);

 }

 ##############
 sub zfslib_get_wwwshares {      # to %current
 #############
        my (@ip,@t,$p,$t,$i,@v,$a,$f,@s,@w,$np);

        #get ip
        &zfslib_get_iplist;
        my @t=();
        @t=split(/\t/,$current{'ip_list'});                   # available ip
        foreach my $t (@t) {
           if(!($t=~/\d+/)) { next; }
           $p="www_share_nextport_$t";
           $current{$p}="80";                                # default www port 80
           push(@ip,$t);
        }

        # read all wwwshares
        my @wwwshares=();

        $p="";
        @t=split(/\t/,$zfs{'datapools'});
        foreach my $t (@t) {
                if (-f "/$t/.www_shares") {
                     $p.=`cat /$t/.www_shares`;               # ex tank/data,192.168.1.1:80
                     $p.="\n";
                }
        }

        # get avail ip:port
        @s=split(/\n/,$p);

        # get avail adress:ip
        $a=",";

        # step1, determine used ports for every ip
        foreach my $s (@s) {                            # tank/data,192.168.1.1:80,name
                      @w=();
                      @w=split(/,/,$s);

                      $p="";
                      if ($w[1]=~/\]:/) {                       # ip6 [2001:0db8:85a3:08d3:1319:8a2e:0370:7344]:8080
                         $i=$w[1];
                         $i=~s/\].*/\]/;
                         $p=$w[1];
                         $p=~s/.*://;
                         $ip="[$ip]";
                         $current{'vhost_VirtualHost'}="[$i]:$p";
                      } else {                                  # ip4
                         $i=$w[1];
                         $i=~s/:.*//;
                         $p=$w[1];
                         $p=~s/.*://;
                         $current{'vhost_VirtualHost'}="$i:$p";
                      }

                      #

                      $t="www_ports_$i";
                      if (!($current{$t}=~/\b$p\b/)) {
                         $current{$t}.="$p,";
                      }

                     # &print_hash(%in);
                     #
                      # add used to avail for current share
                      if ($w[0] eq $in{'zfs'})  {
                         $current{'www_avail'}.="$i:$p,";
                      }

        }

        # avail port:ip
        my $c="1";
        foreach my $ip (@ip) {                                  # 192.168.1.1 or 2001:0db8:85a3:08d3:1319:8a2e:0370:7344

             # max 1 extra per ip
             $t="www_ports_$ip";

             # no port used
             if ($current{$t} eq "") {
                  $a.="$ip:80,$ip:8080,";
             } else {
                  if (!($current{$t} =~/\b80\b/)) { $a.="$ip:80,";   $c++; }  if ($c > 1) { $c="1"; next; }
                  if (!($current{$t} =~/8080/))   { $a.="$ip:8080,"; $c++; }  if ($c > 1) { $c="1"; next; }
                  if (!($current{$t} =~/8081/))   { $a.="$ip:8081,"; $c++; }  if ($c > 1) { $c="1"; next; }
                  if (!($current{$t} =~/8082/))   { $a.="$ip:8082,"; $c++; }  if ($c > 1) { $c="1"; next; }
                  if (!($current{$t} =~/8083/))   { $a.="$ip:8083,"; $c++; }  if ($c > 1) { $c="1"; next; }
             }
        }
        $a=~s/,$//;
        $current{'www_avail'}.=$a;
        $current{'www_avail'}=~s/,+/,/g;
        $current{'www_avail'}=~s/,$|^,//g;
 # debug
 # &print_array(@a);
 # &mess($a);
 # &print_hash(%current);

 }



 #####################
 sub zfslib_ask_property {       #hide: ask for property
 #####################        (div window in front)

    if ($in{'answered'}) { &zfslib_change_property; &zfslib_details; exit; }

    my ($ask,$close,$form,$info,$t,$opt,$r,$p,$d,$z,$f,$r,$l);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";

    #########
    #ask lock
    #########

    if ($in{'prop'} eq "lock") {
        #remember

        $r="";
        if ($sys{'auto_os'} =~/Solaris/) {   # Solaris
           $r=&exe("zfs get -H -o value share $in{'zfs'} | grep prot=smb");
           $r=~s/,*path=.*prot=smb//;  #name=abc,abe=..
           $r=~s/=true//g;   #name=abc,abe=.
        } else {
           $r=&exe("zfs get -H -o value sharesmb $in{'zfs'}");
        }

#&mess("zfs get -H -o name,value share $in{'zfs'} | grep prot=smb<br>$r");
        $r=~s/,/+/g;
        $r.=",off"; $r=~s/^,+//;

        #ad last
        $t=&exe("zfs get -H -o value enc_smbshare: $in{'zfs'}");
        $t=~s/,*path=.*prot=smb//;  #name=abc,abe=..
        $t=~s/=true//g;   #name=abc,abe=.

        $t=~s/,/;/g;
        if ($t ne "-") {          # not set
          $r.=",last: $t";
        } else {
          $r.=",last";
        }
        $r=~s/off,off/off/;       # avoid 2 x off

        $r="last,off";            # always
#&mess($r);

        $form="<table border='1'><tr><td>Encrypted filesystem:\&nbsp;\&nbsp;</td><td><input type='text' class='input' name='text' value='lock it' style='width: 150px' readonly>";
        $form.="</td></tr><tr><td>";
        $form.="Remember SMB share:\&nbsp;</td><td>". &select('remember',$r)."</td></tr></table>";  # smb shares are always disabled
        $info="If you want to reaccess this filesystem, you have to unlock it with your passphrase or a key location <br>like W1:W2 or L1:L1. SMB shares are set to off can be remembered as a user defined ZFS property<br>";
    }

    ###########
    #ask unlock
    ###########

    if ($in{'prop'} eq "unlock") {

        $t=&exe("zfs get -H -o value enc_split: $in{'zfs'}");  chomp($t);           # ex L1:L2
        if (!($t=~/\d:/)) { $t="-"; }

        #same info on all options
        $info="Enter your passphrase or a key location like L1:L1 or W1:W2 to unlock this filesystem. <br>The former state of an SMB share can be restored from a user defined ZFS property.";

        $r="file";
        if ($sys{'auto_os_type'}=~/ill/) {  # Illumos
             $r=&exe("zfs get -H -o value keylocation $in{'zfs'}"); chomp($r);
        }

        if ($sys{'auto_os'}=~/Solaris/) {  # Solaris
             $r=&exe("zfs get -H -o value keysource $in{'zfs'}");   chomp($r);
        }


        if ($r=~/prompt/) {
                 if ($t=~/\d:/) {
                   $form="<table><tr><td>Unlock with Passphrase:\&nbsp;\&nbsp;</td><td><input type='text' name='pass' value=\"$t\" style='width: 150px'> ";
                 } else {
                   $form="<table><tr><td>Unlock with Passphrase:\&nbsp;\&nbsp;</td><td><input type='password' name='pass' value=\"\" style='width: 150px'> ";
                 }
                 $form.="</td></tr><tr><td>";
                 $form.="</td></tr><tr><td>";
                 $form.="Restore SMB share:</td><td>". &select('smbrefresh','last,off')."</td></tr></table>";

        } else {
                 $r=~s/.*,//;
                 $form="<table><tr><td>Unlock from source:\&nbsp;\&nbsp;</td><td><input type='text' name='pass' value=\"$r\" style='width: 250px' readonly> ";
                 $form.="</td></tr><tr><td>";
                 $form.="Restore SMB share:</td><td>". &select('smbrefresh','last,off')."</td></tr></table>";
        }
    }



    #ask sharesmb
    ##########

    if ($in{'prop'} =~/smb_share:/) {
      if (($in{'old'} eq "off") || ($in{'prop'}=~/\(add/)) {
        $t=$in{'zfs'}; $t=~s/^.*\///;

        $form=<<Eof;
        <table>
        <tr>
        <td style="padding-top: 5px">share_name:&nbsp;</td>
        <td><input class="input" type='text' name='text' value='$t' style='width: 160px; height:16px'></td>
        <td>&nbsp;&nbsp;guest allowed: <input type='checkbox' name='guest' value='guest'>&nbsp;&nbsp;
          ABE: <input type='checkbox' name='abe' value='abe'></td>

        </tr><tr>
        <td style="padding-top: 6px">share_acl: </td>
        <td>
        <select name="shareacl" class="input" style='width: 166px; height: 20px'>
                <option>root=full, last shareacl</option>
                <option>everyone=full</option>
                <option>root=full, everyone=modify</option>
                <option>root=full, everyone=read</option>
        </select>
        </td>
        <td>&nbsp;</td>
        </tr><tr>
        <td style="padding-top: 9px">last share_acl&nbsp;</td>
        <td colspan="2">
        <div id="" style="overflow:auto; height:70px; padding:5px; width: 320px; font-size: 12px; border:1px solid silver">
        $r</div></td></tr>
        </table><br>
Eof

        $form=<<Eof;
        <table>
        <tr>
        <td style="padding-top: 5px">share_name:&nbsp;</td>
        <td><input class="input" type='text' name='text' value='$t' style='width: 160px; height:16px'></td>
        <td>&nbsp;</td>

        </tr>
        </table><br>
Eof

        $info="$txt{'form_smb_info'}";

      } else {

        $form="Sharesmb: <input type='text' class='input' name='text' value='off' style='width: 150px; margin-left:5px' readonly> ";
        $opt= "onclick=\"return(confirm('unshare zfs folder $in{'zfs'}?'))\"";
        $info="smb-sharing $in{'zfs'} off<br>info:";
      }
    }

    #ask driveletter
    if ($in{'prop'} =~/driveletter/) {
    $info=<<EoF;
    <pre>
    driveletter     YES       NO   off | on | A-Z

    -  means     pool filesystem: driveletter = on   (this is default when unset)
                   mount on next free driveletter
                 sub filesystems: driveletter = off
                   mount below root driveletter

    on means    root filesystem: use next free driveletter
                   root filesystem: mount pool ex as e:\\
                 sub filesystems: use next free driveletter
                   sub filesystems: mount pool/filesystem ex as f:\\

    off means    pool filesystem: normal Unix behaviour
                   root filesystem: mount as c:\pool
                 sub filesystems
                   sub filesystems mount below pool (c:\\pool\\filesystem)

    a-z means    use the driveletter for this filesystem
                  for pool or sub filesystems)

    recommended: set driveletter only on pool level, subfilesystems set to -
                 prefer "high" letters ex t-z or set to off to mount below c:
                 check current and wanted driveletters in Windows Explorer first
                 A unmount + mount is executed recursively to make settings valid

    </pre>
EoF
     $form="Set driveletter to ". &select('text','-,on,off,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z',$in{'old'});

} # /dl

    #use compression LZ4
    if ($in{'prop'} eq "compression") {

      # ask lz4 on pool
      $t=$in{'zfs'}; $t=~s/\/.*//;     # get pool
      $t="(LZ4)";

      if ($in{'old'} eq "off") {
        $form="compression = <input type='text' class='input' name='text' value='on' style='width: 150px' readonly> $t";
        $info="compression $in{'zfs'} on";
      } else {
        $form="compression = <input type='text' class='input' name='text' value='off' style='width: 150px' readonly> ";
        $info="compression $in{'zfs'} off";
      }
    }

    #ask nbmand
    if ($in{'prop'} eq "nbmand") {
      if ($in{'old'} eq "off") {
        $form="nbmand = <input type='text' class='input' name='text' value='on' style='width: 150px' readonly> ";
        $info="nbmand $in{'zfs'} off means: <br>deactivate systemwide mandatory coordination of file-lockings ex between NFS and SMB<br><br>should be on for SMB shares<br>This command needs an unmount/mount cycle!";
      } else {
        $form="nbmand = <input type='text' class='input' name='text' value='off' style='width: 150px' readonly> ";
        $info="nbmand $in{'zfs'} off means: <br>deactivate systemwide mandatory coordination of file-lockings ex between NFS and SMB<br><br>should be on for SMB shares<br>This command needs an unmount/mount cycle!";
      }
    }

    #ask readonly
    if ($in{'prop'} eq "readonly") {
      if ($in{'old'} eq "off") {
        $form="readonly = <input type='text' class='input' name='text' value='on' style='width: 150px' readonly> set recursive: <input type='checkbox' name='recursive' value='1'>";
        $info="readonly of $in{'zfs'} on = read only";
      } else {
        $form="readonly = <input type='text' class='input' name='text' value='off' style='width: 150px' readonly> set recursive: <input type='checkbox' name='recursive' value='1'>";
        $info="readonly $in{'zfs'} off = read/write";
      }
    }


    #ask dedup
    if ($in{'prop'} eq "dedup") {
      if ($in{'old'} eq "off") {
        $form="dedup = <input type='text' class='input' name='text' value='on' style='width: 150px' readonly> ";
        $info="dedup $in{'zfs'} on<br><br>";
        $info.="$txt{'form_dedup_on'}";
      } else {
        $form="dedup = <input type='text' class='input' name='text' value='off' style='width: 150px' readonly> ";
        $info="dedup $in{'zfs'} off<br>$txt{'form_dedup_off'}";
      }
    }

    #ask quota
    if ($in{'prop'} eq "quota") {
        $r=&zfslib_get_property('quota');

        $form="quota = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info=$txt{'zfs_info_quota'};
        $info=~s/=zfs=/$in{'zfs'}/gs;
        # ex. $info="set quota of $in{'zfs'} to none or a value in MGT for example 10G<br><br>";
    }

    #ask refquota
    if ($in{'prop'} eq "refquota") {
        $r=&zfslib_get_property('refquota');

        $form="refquota = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info=$txt{'zfs_info_refquota'};
        $info=~s/=zfs=/$in{'zfs'}/gs;
        #$info="set refquota of $in{'zfs'} to none or a value in MGT for example 10G";
    }

    #ask userquota
    if ($in{'prop'} =~/userquota/) {
        $t=$in{'prop'}; $t=~s/userquota://;
        $r=&exe("zfs get -H -o value userquota\@$t $in{'zfs'}");

        $form="userquota = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info="none, n[KMGT] ex 5G<br>$txt{'zfs_info_userquota'}";
        $info=~s/=zfs=/$in{'zfs'}/gs;
    }

    #ask usergquota (group)
    if ($in{'prop'} =~/usergquota/) {
        $t=$in{'prop'}; $t=~s/usergquota://;
        $r=&exe("zfs get -H -o value groupquota\@$t $in{'zfs'}");

        $form="groupquota = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info="none, n[KMGT] ex 5G<br>$txt{'zfs_info_usergquota'}";
        $info=~s/=zfs=/$in{'zfs'}/gs;
    }

    #ask SSB, small special blocks
    if ($in{'prop'} eq "SSB") {
      $info="The ZFS special_small_block property controls the size of small io that goes to the special vdev instead the regular pool. The special vdev must have the same redundancy level than the regular vdevs in the pool. If a special vdev is lost, the pool is lost.<br><br>This value MUST be lower than pool recordsize or all ZFS datablocks not only the smaller ones will try to land on the special vdev. Size=0 will disable using the special vdev. This value is not related to filesysize but ZFS datablock size. This is a filesystem property. The pool setting is the default for child filesystems.";
      $form="Set small special blocks to ". &select('ssb','0,1K,2K,4K,8K,16K,32K,64K,128K',$in{'old'});             #
    }

    #ask recsize
    if ($in{'prop'} eq "recsize") {
        #$form="recsize = <input type='text' class='input' name='text' value='$in{'old'}' style='width: 150px'> ";
        $form="Set recsize to ". &select('text','8K,16K,32K,64K,128K,256K,512K,1M',$in{'old'});
        $info=<<EoF;
         A performance parameter of ZFS is the recordsize that determines the size of filesystem blocks for large files.<br>
         This is also the unit that ZFS validates through checksums. Filesystem blocks are dynamically striped over the vdevs of a pool.<br><br>
         ZFS recordsize can be set for new files with values like 8k, 16k, 32k, 64k, 128k, 256k, 512k or 1m<br>
         The default value is 128K that suits for most workloads. If your applikation is using a very low read/write blocksize, for
         example in an ESXi/ NFS environment for VMs you may reduce latency with a lower value between 16k and 64k. Start with 32k.
EoF
        # ex. $info="set quota of $in{'zfs'} to none or a value in MGT for example 10G<br><br>";
    }

    #ask aclinherit
    if ($in{'prop'} eq "aclinherit") {
        $r=&zfslib_get_property('aclinherit');
        $form="aclinherit = ". &select('aclinherit','discard,noallow,restricted,passthrough,passthrough-x',$r);             # name, values, selected-> return htmlcode   ;
        $info=<<EoF;
<pre>aclinherit — <b>discard</b>: for new objects, no ACL entries are inherited.
<b>noallow</b>: access type of deny is inherited.
<b>restricted</b>: (os default) — write_owner and write_acl permissions are removed.
<b>passthrough</b>: (more win-like) — files are created with inheritable ACEs.
<b>passthrough-x</b>: like passthrough with execute (x) permission.</pre>
EoF
    }


    #ask reservation
    if ($in{'prop'} eq "reservation") {
        $r=&zfslib_get_property('reservation');

        $form="reservation = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info=$txt{'zfs_info_res'};
        $info=~s/=zfs=/$in{'zfs'}/gs;
        #$info="set reservation of $in{'zfs'} to none or a value in MGT for example 10G";
    }

    #ask refreservation
    if ($in{'prop'} eq "refreservation") {
        $r=&zfslib_get_property('refreservation');

        $form="refreservation = <input type='text' class='input' name='text' value='$r' style='width: 150px'> ";
        $info=$txt{'zfs_info_refres'};
        $info=~s/=zfs=/$in{'zfs'}/gs;
        #$info="set refreservation of $in{'zfs'} to none or a value in MGT for example 10G";
    }



    #ask snapdir
    if ($in{'prop'} eq "snapdir") {
      if ($in{'old'} eq "hidden") {
        $form="snapdir = <input type='text' class='input' name='text' value='visible' style='width: 150px' readonly> ";
        $info="snapdir $in{'zfs'} = visible";
      } else {
        $form="snapdir = <input type='text' class='input' name='text' value='hidden' style='width: 150px' readonly> ";
        $info="snapdir $in{'zfs'} = hidden";
      }
    }

    #ask sync
    if ($in{'prop'} eq "sync") {
        $r=&zfslib_get_property('sync');
        $form="sync = ". &select('sync','standard,always,disabled',$r);             # name, values, selected-> return htmlcode   ;
        $info=$txt{'form_sync'};
    }


    ### form ###
    $ask=&ask_pop("$form","$info","$opt");
    return ($ask);
 }

 #########################
 sub zfslib_get_property {  # parameter property, return value of current zfs or par2
 ####################
        my $p=$_[0];
        my $zfs=$_[1];
        my $r;
        if ($zfs eq "") { $zfs=$in{'zfs'}; }                   # parameter2 or via %in
        $r=&exe("zfs get -H $p $zfs");
        if ($r=~/bad |suspended/s) { return ""; }              # bad property or io suspended
        $r=~s/^.*\s$p\s+//gs;
        $r=~s/\s.*//s;
#&mess("-$p-<br>-$in{'zfs'}-<br>-$r-");
        return ($r);
 }

 sub zfslib_selectform {   # hide: values: 'property','values,,,','default','r'  (r=really)
 #######################
   my ($r,@v,$opt,$p,$s);
  if ($_[0] eq "") { &mess('zfs_selectform: property is missing'); }
  if ($_[1] eq "") { &mess('zfs_selectform: value is missing'); }

  if ($_[3]=~/r/i) {
   $opt="onclick=\"return(confirm('change/set property ?'))\"";     # js box: really??
  }

   $r=<<EoF;
  <!-- select xxxxx zfs property xxxxx -->
  <form name="ask" method="post" action="/cgi-bin/admin.pl">
  <input type="hidden" name="id" value="$in{'id'}">
  <input type="hidden" name="l1" value="$in{'l1'}">
  <input type="hidden" name="l2" value="$in{'l2'}">
  <input type="hidden" name="l3" value="$in{'l3'}">
  <input type="hidden" name="zfs" value="$in{'zfs'}">
  <input type="hidden" name="prop" value="$_[0]">
  <input type="hidden" name="answered" value="1">
=sel=
 <input type="submit" name="submit" value="set" style='font-size: 10px;'$opt>
  </form>
EoF

   $s=&select($_[0],$_[1],$_[2]);             # name, values, selected-> return htmlcode
   $r=~s/=sel=/$s/s;
   $r=~s/\n|  +|\t//gs;
   return($r);
 }





  ###############
  sub zfslib_delete {               #delete zfs from list
 #################    show_set details
    my ($zfs,@z,$url,$n,@zfs,$r,$cl,$t);


    #show list
    ############

    #del url
       $url="<a style='color:#ba2f28; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs_del=1\&amp;zfs==z=\" onclick=\"return(confirm('destroy zfs filesystem =f= with all snaps and clones?'))\">";

   #del selected
        my $sel="<input type=\"checkbox\" name=\"sel_zfs\" value=\"Z.+\">";

        $zfs=&exe("zfs list -o name,readonly,used,avail,creation -t filesystem");
        #$zfs.="\n Pool rpool\n";
       # $zfs.=&exe("zfs list -t filesystem -o name | grep / | grep rpool | grep -v ROOT | grep -v export");

        # parse date for double spaces
        $zfs=&parse_date($zfs);

        @z=split(/\n/,$zfs);
##

        foreach $t (@z) {

           $n=$t; $n=~s/ .*//;
            if (!($t=~/\w+\//))   {
               if (!($t=~/^NAME/)) {
                   push (@zfs,"");
                   push (@zfs,"<b>Pool $n </b>\t");          #zpool itself
               } else {
                  $t="<b>$t</b>";
                  $t=~s/NAME/NAME\tSEL/;                     # add select
                  $t.="\tCLONE ORIGIN";
               }
           }
           push (@zfs,$t);
         }
#&print_array(@zfs);
         foreach $t (@zfs) {
             if (!($t=~/\w+/))      { next; }               #
             if ($t=~/^<b>NAME/)    { next; }               # no zfs/ header
             if ($t=~/^<b>Pool/)    { next; }
             $n=$t; $n=~s/  +.*//;
             if (!($n=~/\//))       {
                                     $t=~s/  /\t/;         # add column for select
                                     next;                  # poolname
             }

             $zfs=$t; $zfs=~s/ .*//;
             $t=~s/  /<\/a> /;
             $t="$url$t";
             $t=~s/=f=/$n/g;
             #$t=~s/zfs\=/zfs\=$zfs/g;
             $t=~s/=z=/$zfs/g;

             # readonly=red
             $t=~s/on  /<font class='font_darkred'><b>on<\/b><\/font>  /;

             #add select
             $r=$sel;
             $r=~s/Z/$zfs/;
             $t=~s/  /\t$r/;

             # add clone origin
             $cl=$zfs."_origin";
             $t.="\t$zfs{$cl}";

        }

#&print_array(@zfs);

    $t=join("\n",@zfs);
    $t=~s/  +/\t/gs;
    #&mess($t);
    $t=&list2table($t);

    # delete selected
    &ask('begin_selzfs');

    $zfs="<b>ZFS Overview $in{'zfs'}</b>\n\n$t";

    print "<pre class='tt'>$zfs</pre>";
    &ask('confirm','destroy selected','destroy selected filesystems with all snaps and clones?');
    print "</body></html>";

    return;


 }


####################
sub zfslib_list_datasnaps  {          #opt d=inkl. delete option, r=rollback, l=return commalist ex &list_datasnaps('l'), &list_datasnaps('f') with date,<br>&list_datasnaps('d') print with delete
################ show snaps
  # thanks to rick for code-review and bugfix :-))

  my ($s,@snap,$url,$url2,$n,$old,$oldsnap,$new,@w,$z,$r,@data,$clone,@clones,$u);
  $old=""; $new="";

  if (!($_[0]=~/l|f/)) {    #commalist
    print "<b>zfs list -r -t snapshot: </b><br>";

    # not in delete -> l3="" but in Release or Hold
    if (($in{'l2'} eq "") || ($in{'l2'} =~/release|hold/i)) {
      if ($in{'select_sort'} eq "") { $in{'select_sort'}="name+"; }

      &ask('begin','b');
      &ask('value_filter','Filter snaps: ',$in{'value_filter'});
      &ask('value_filter2','and (opt): ',$in{'value_filter2'});
      &ask('select_sort','sort/select snaps by',"name+,name-,creation+,creation-,used-,holded,released,cloned",$in{'select_sort'});
      print "<div style='position: relative; top: -37px; left: 700px'><input type='submit' name='submit_ok' value='submit' style='font-size: 10px;'></div></form>";
    }
  }

  $in{'value_filter'}=~s/^ +//;         # no spaces
  $in{'value_filter2'}=~s/^ +//;

  $in{'value_filter'}=~s/ +$//;         # no trailing spaces
  $in{'value_filter2'}=~s/ +$//;

  if (defined($in{'id'})) {             # only via napp-it, not within auto-jobs

       #del single snap
       $url="<a style='color:#ba2f28; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=delete\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;value_filter=$in{'value_filter'}\&amp;delsnap==f=\" onclick=\"return(confirm('destroy snapshot =f= ?'))\">destroy</a>";

       # rollback
       if ($_[0]=~/r/) {
          $url="<a style='color:#ba2f28; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=rollback\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;value_filter=$in{'value_filter'}\&amp;delsnap==f=\" onclick=\"return(confirm('rollback to snapshot =f= ?'))\">rollback</a>";
       }

       # holded
       if ($_[0]=~/H/) {
          $url="<a style='color:#ba2f28; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=release\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;value_filter=$in{'value_filter'}\&amp;delsnap==f=\" onclick=\"return(confirm('release snapshot =f= and distroy when defer=on?'))\">release</a>";
       }

       # released
       if ($_[0]=~/R/) {
          $url="<a style='color:#ba2f28; font-weight:bold' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=hold\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;value_filter=$in{'value_filter'}\&amp;delsnap==f=\" onclick=\"return(confirm('hold snapshot =f= ?'))\">hold</a>";
       }

#&print_hash(%in);
       if ($in{'delsnap'}=~/\@/) {
           $in{'delsnap'}=~s/\s//g;

           # delete
           if ($in{'action'} eq "delete") {
             print "delete snapshot $in{'delsnap'}<br>";
             $r=&exe("zfs destroy $in{'delsnap'}");
             print "$r";
             if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
           }
           # rollback
           if ($in{'action'} eq "rollback") {
             print "rollback snapshot $in{'delsnap'}<br>";
             $r=&exe("zfs rollback -f -r -R $in{'delsnap'}");
             print "$r";
             if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
           }

           # HOLDED
           if ($in{'action'} eq "release") {
             print "release snapshot $in{'delsnap'}<br>";
             $r=&exe("zfs release -r keep $in{'delsnap'}");
             print "$r";
             if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
           }

           # RELEASED
           if ($in{'action'} eq "hold") {
             print "hold snapshot $in{'delsnap'}<br>";
             $r=&exe("zfs hold -r keep $in{'delsnap'}");
             print "$r";
             if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
           }
           sleep (2);
           &reload;
       }

  }
  #

  @data=();

  # check accelerator
  if ((-f "/tmp/nappit/zfs_last.zfs") && ($cfg{'ver'} ne "")) {
                open (F,"</tmp/nappit/zfs_last.zfs");
                     flock(F, LOCK_EX);
                     @data=<F>;
                close (F);
                $t=time();

                # read acc
                if (($t-$data[0] < 1200) && (-f "/tmp/nappit/zfs_list_snaps1.zfs"))   { # max 20min
                      @data=();
                      open (F,"</tmp/nappit/zfs_list_snaps1.zfs");
                           flock(F, LOCK_EX);
                           @data=<F>;
                      close (F);
                      $s=join("",@data);
                      &exe("echo acc_read_zfs snaps");
                 } else {
                      &exe("rm /tmp/nappit/*.zfs");
                }

               if (!($s=~/\@/s)) { $s=""; }
 }

 # $s=""; # debug only

 # clones not valid on Solaris
 $t=",clones";
 if ($sys{'auto_os'}=~/Solaris/i) {
   $t="";
 }

 if ($in{'select_sort'} eq "used-") {
        $s=&exe("zfs list -H -r -t snapshot -o name,creation,used,avail,refer,defer_destroy,userrefs$t -S used");
        $s=&parse_date($s);                # Dez 1 -> Dez 01
 } else {

    if ($s eq "") {
        $s=&exe("zfs list -H -r -t snapshot -o name,creation,used,avail,refer,defer_destroy,userrefs$t -S creation");  # default newest first, no header
        $s=&parse_date($s);                # Dez 1 -> Dez 01
    }
  }

  @w=();
  @snap=();
  @w=split(/\n/,$s);


  # clone, print cloned with title
  foreach my $w (@w) {
    if ($w=~/^NAME/) { next; }

    @t=();
    @t=split(/\t/,$w);
#&print_array(@t);
    if (($t[7] eq "-") || ($t[7] eq "")) {
       $t[7]="-";
    } else {
        $t[7]="<a title=\"$t[7]\">cloned</a>";
    }
    $w=join("\t",@t);
  }

 # &print_array(@w);

  # default sort order: newest first
  if ($in{'select_sort'} eq "name+")     { @w=sort(@w); }
  if ($in{'select_sort'} eq "name-")     { @w=reverse sort(@w); }
  if ($in{'select_sort'} eq "creation-") { @w=reverse (@w); }

  # add header
  $t='&nbsp;'x170;
  unshift @w,"NAME$t\t<b<CREATION</b>\t<b>USED</b>\t<b>AVAIL</b>\t<b>REFER</b>\t<b><a title='defer_destroy'>DEFER</b>\t<b>HOLDS</b>\tCLONE";   # add header after sort

  #step 1: filter
  my $count=@w;            # ??
  my $count2='0';

  # count filter
  foreach $t (@w) {
     if (($in{'value_filter'} ne "")  && (!($t=~/$in{'value_filter'}/)))  { next; }
     if (($in{'value_filter2'} ne "") && (!($t=~/$in{'value_filter2'}/))) { next; }
     $count2++;
  }

  foreach $t (@w) {
     #if ($t=~/^$zfs{'syspool'}\//) { next; }          # rpool  ??

     if ($_[0] =~/d|H|R/) {                        # header for datasnaps, Hold and Release

       # add always header
        if ($t=~/^NAME/) {
             $t="<b>ZFS</b>\t<input type='checkbox' style='margin:0 0 0 4px' onclick='toggleChecked(this.checked)'>\t$t";
             $t=~s/NAME/<b>NAME<\/b>/;
             $t=~s/CLONE/<b>CLONE<\/b>\t<b>SNAPS: $count2\/$count<\/b>/;
             push (@snap,$t);
             next;
        }
     }

     #Hold counter > 0: red
     @t=split(/\t/,$t);
#&print_array(@t);
     if ($t[6]>0) {
         $t[6]="<font style='color:#ba2f28'>$t[6]<\/font>";
         $t=join("\t",@t);

         # released only
         if ($in{'select_sort'} eq "released")  {       # released only
                next;
         }
     } else {
         # hold only
         if ($in{'select_sort'} eq "holded")  {         # holded only
                next;
         }
     }

    # cloned
    if ($in{'select_sort'} eq "cloned")  {         # with clones only
          if (!($t=~/>yes</)) { next; }
    }

    if (($in{'value_filter'} ne "")  && (!($t=~/$in{'value_filter'}/)))  { next; }
    if (($in{'value_filter2'} ne "") && (!($t=~/$in{'value_filter2'}/))) { next; }

    push (@snap,$t);
  }

 # &print_array(@snap);

  my $sel="<input type=\"checkbox\" name=\"sel_snaps\" value=\"Z.+\">";
  @clones=();
  @clones=split(/\t/,$zfs{'all_clones'});           # list of clones

  foreach $t (@snap) {

        $t=~s/  1 / 01 /;                            # Oct  1  -> Oct 01
        $t=~s/  2 / 02 /;
        $t=~s/  3 / 03 /;
        $t=~s/  4 / 04 /;
        $t=~s/  5 / 05 /;
        $t=~s/  6 / 06 /;
        $t=~s/  7 / 07 /;
        $t=~s/  8 / 08 /;
        $t=~s/  9 / 09 /;

        $t=~s/  0:/ 00:/;                            # hour   0: -> 00:
        $t=~s/  1:/ 01:/;
        $t=~s/  2:/ 02:/;
        $t=~s/  3:/ 03:/;
        $t=~s/  4:/ 04:/;
        $t=~s/  5:/ 05:/;
        $t=~s/  6:/ 06:/;
        $t=~s/  7:/ 07:/;
        $t=~s/  8:/ 08:/;
        $t=~s/  9:/ 09:/;

        $t=~s/  +/\t/g;                              # default seperator tab

        $n=$t;                                       # name of snap

        $n=~s/\s.*//;
        if (($t=~/\@/) && ($_[0] =~/d|r|H|R/)) {     # delete or rollback or Hold/Release


                    @t=();
                    @t=split(/\t/,$t);

                    $u=$url;                           # default
#&print_array(@t);
                   # has a clone
                   if ($t=~/>cloned</) {

                     $u=$t[7];    # clone as title     <a title="snap">yes</a>
                     $u=~s/\">.*//;
                     $u=~s/.*\"//;

                   }  else {

                     #
                     # link to hold
                     $r=$t[6]; $r=~s/\D//g;
                     if (($r>0) && (!($in{'l2'}=~/release/i)))  {
                       $u="holded";
                     }

                     # link to hold
                     if (($r==0) && ($in{'l2'}=~/release/i)) {
                       $u="released";
                     }
                   }
                   $t.="\t$u";

        }
        $t=~s/=f=/$n/g;

        #@ insert selects
        if (!($_[0]=~/l/)) {                         # whorfin - no tabs!, thanks rick

             if ($_[0] =~/d|H|R/) {
                #$t=~s/NAME +/ZFS\tSEL\tSNAP/;
                $t=~s/SELNAME +/SEL\tSNAP  /;
                $z=$t; $z=~s/\@.*//;                 # name of snap

                # default, show select
                $r=$sel;
                $r=~s/Z/$n/;

               # no checkbox if there is clone base on this snap
                if ($t=~/>cloned</) {      # has a clone or set to hold
                  $r="";
                }

                # no checkbox if holded
                if ($in{'l2'}=~/release/i) {
                  if (!($t=~/>[1-9]</))  {
                     $r="";
                  }
                }  else {
                  if ($t=~/>[1-9]</)  {
                     $r="";
                  }
                }

                # no checkbox without hold activated in submenu release
                if (($t=~/>off</) && ($in{'l2'}=~/release/i)) {
                   $r="";
                }

                $t=~s/\@/\t$r\t$z\@/;
             } else {
                $t=~s/NAME/ZFS\t\tSNAP/;
                $z=$t; $z=~s/\@.*//;                 # name of snap
                $t=~s/\@/\t\t$z\@/;
             }
        }
    }

  #&print_array(@snap);


  if ($_[0]=~/l|f/) {    #commalist  list,
       @w=();
       foreach $t (@snap) {
          if (!($t=~/\@/)) { next; }                   #no snap
             if ($_[0]=~/l/) {
             $t=~s/^\s+//;  $t=~s/ .*//;               #only snap name
          } else {
             $t=~s/^\t+//; $t=~s/\t+/\t/g;
             $t=~s/<.*//;                              # no delete url
          }
          push (@w,$t);
       }
       ## thanks to rick
       if ($_[0]=~/l/) {
           # 'l' is used for retention policy, so list in REVERSE order
           @w=sort {$b cmp $a} @w;      # sort num
       } else {
           @w=sort(@w);                 # sort char
       }
       ##
       $n=join(",",@w);
       return($n);

  } else {            #print list

     if ($_[0]=~/d|H|R/) {
          &ask('begin_sel');
     }
     print "\n<div id='chb'>\n";   # select all input

     $n=join("\n",@snap);
     $n=~s/  +/\t/gs;
     $n=&list2table($n);

     print  "$n<br>\n";
     print "</div>\n"; # /chb

     if ($_[0]=~/d/) {
        &ask('confirm','destroy selected','destroy selected snaps?');
     }

     if ($_[0]=~/H/) {
        &ask('confirm','release selected','release selected snaps and destroy when defer=on?');
     }

     if ($_[0]=~/R/) {
        &ask('checkbox_defer','defer_destroy<br></b>This will detroy a holded snap immediately when you release it<b>',"enable defer_destroy");
        &ask('confirm','hold selected','hold selected snaps?');
     }

  # js for select all
  print <<EoF;
  <script type="text/javascript">
      function toggleChecked(status) {
      \$(".checkbox").each( function() {
      \$(this).attr("checked",status);
      })
      }

      function toggleChecked(status) {
      \$("#chb input").each( function() {
      \$(this).attr("checked",status);
      })
      }
</script>

EoF

     return();
  }
}

#####################
sub zfslib_pool_zdb {  # show pooldetails via zdb, parameter1="1" -> print
#####################  # show all or parameter(2)=pool
  my (@w,$w,$key,$k,$n,@p,$p,$r,$i,$v,@v,$d,@d,$id,$guid,$phys,$devid,$j,$ids,$out);

  &load_lib('get-disk.pl');   # get required values

  @p=();
  @p=split(/\t/,$zfs{'allpools'});

  #only special pool(s)
  if ($_[1] ne "")  {
    @p=$_[1];
  }

  $r="";
  $out="Pool\tVersion\tPool GUID\tVdev\tAshift\tAsize\tVdev GUID\tDisk\tDisk-GUID\tCap\tProduct/ Phys_Path/ Dev_Id/ Sn";

  ##each pool
  ###########
  foreach $p (@p) {

      $r=&exe("zdb -C $p");

      @w=();   #values
      @w=split(/\n/,$r);

      #basic pool values and search first children[0]= first vdev
      ###########################################################
      foreach $w (@w) {
             #pool-version
             if ($w=~/version: /) {
                  $key=$p."_version";
                  $disk{$key}=$w;
                  $disk{$key}=~s/.*version: //;
                  $out.="\n\n$p\t$disk{$key}";   # pool + version

             }
             #pool-guid
             if ($w=~/pool_guid: /) {
                  $key=$p."_guid";
                  $disk{$key}=$w;
                  $disk{$key}=~s/.*pool_guid: //;
                  $out.="\t$disk{$key}"
             }
             #vdevs_children
             if ($w=~/vdev_children: /) {
                  $key=$p."_vdev_children";
                  $disk{$key}=$w;
                  $disk{$key}=~s/.*vdev_children: //;
                  $out.= "\t vdevs: $disk{$key}";
             }
             #hostid
             if ($w=~/hostid: /) {
                  $key="hostid";
                  $sys{$key}=$w;
                  $sys{$key}=~s/.*hostid: //;
             }

             if ($w=~/children\[/) {         #first children -> vdev-list
                $v=$w;
                $v=~s/\[.*//;
                last;
             }

      }

      # $v="         children[0]   -> vdev1
      $r=~s/\n$v/\nvdev:/gs;
      @v=();
      @v=split(/vdev:/,$r);      # @v=list of vdevs, [0]=pool, 1..n vdevs

      #each vdev
      ##########
      for ($i=1;$i<@v;$i++) {    # each vdevs


         @d=();
         @d=split(/children/,$v[$i]);


         for ($j=0;$j<@d;$j++) {              # each member disk (value=0: vdev info)


            ## [0] get vdev info
            @w=();
            @w=split(/\n/,$d[$j]);            #type, id, guid, path, devid, phys_path,

            $guid="";

            foreach $w (@w) {                 #get vdev info

                     if ($j eq "0") {         #vdev info only
                              if ($w=~/type: /) {
                                $key=$p."_vdev_$i"."_type";                 #vdev type (mirror, raidz))
                                $disk{$key}=$w;
                                $disk{$key}=~s/.*type: //;
                                $disk{$key}=~s/'//g;
                                $out.="\n\t\t\t\tvdev $i: $disk{$key}";

                                #raid-z level
                                if  (($disk{$key} eq "raidz") && ($d[$j]=~/nparity: /)) {
                                      $key=$p."_vdev_$i"."_nparity";
                                      if ($disk{$key} eq "") {
                                        $disk{$key}=$d[$j];
                                        $disk{$key}=~s/.*nparity: //s;
                                        $disk{$key}=~s/ .*//gs;
                                        $disk{$key}=~s/\D//gs;
                                        $out.=$disk{$key};
                                      }
                                }

                                if ($d[$j]=~/ashift: /) {                    #vdev ashift, post disk info
                                  $key=$p."_vdev_$i"."_ashift";
                                  if ($disk{$key} eq "") {
                                    $disk{$key}=$d[$j];
                                    $disk{$key}=~s/.*ashift: //s;
                                    $disk{$key}=~s/ .*//gs;
                                    $disk{$key}=~s/\D//gs;
                                    $disk{$key}=~s/'//g;
                                    $out.="\t$disk{$key}";
                                  }

                                }
                                if ($d[$j]=~/asize: /) {                    #vdev asize, post disk info
                                  $key=$p."_vdev_$i"."asize";
                                  if ($disk{$key} eq "") {
                                    $disk{$key}=$d[$j];
                                    $disk{$key}=~s/.*asize: //s;
                                    $disk{$key}=~s/ .*//gs;
                                    $disk{$key}=~s/\D//gs;
                                    $disk{$key}=~s/'//g;

                                    $t=$disk{$key};
                                    if ($disk{$key} > 1000000) {
                                       $t=$t/1000000;
                                       $t=sprintf "%0.2f",$t;
                                       $t.=" MB ";
                                    }
                                    if ($disk{$key} > 1000000000) {
                                      $t=$disk{$key};
                                      $t=$t/1000000000;
                                      $t=sprintf "%0.2f",$t;
                                      $t.=" GB ";
                                    }

                                    if ($disk{$key} > 1000000000000) {
                                      $t=$disk{$key};
                                      $t=$t/1000000000000;
                                      $t=sprintf "%0.2f",$t;
                                      $t.=" TB ";
                                    }

                                    $out.="\t$t";
                                  }
                                }


                                next;
                              }

                              if ($w=~/guid: /) {                           #vdev guid
                                $key=$p."_vdev_$i"."_guid";
                                $disk{$key}=$w;
                                $disk{$key}=~s/.*guid: //;
                                $disk{$key}=~s/'//g;
                                $out.="\t$disk{$key}";
                                next;
                              }

                      } # /(0)


                      if ($w=~/guid: /) {                         #disk guid
                         $guid=$w; $guid=~s/.*guid: //;
                         next;
                      }

                      if ($w=~/\spath: /) {                       #disk id from path
                         $id=$w; $id=~s/.*path: //;
                         $id=~s/\'//g;
                         $id=~s/.*\///;
                         $id=~s/s0|p0//;                          # ex c1t1d0
                          next;
                      }


                      if ($w=~/devid: /) {                       # device id
                         $devid=$w; $devid=~s/.*devid: //;
                         $devid=~s/\'//g;
                          next;
                      }

                      if ($w=~/phys_path: /) {                       # phys id
                         $phys=$w; $phys=~s/.*phys_path: //;
                         $phys=~s/\'//g;
                          next;
                      }
                      #write to %disk
                      if (($id ne "") && (!($ids=~/$id\t/))) {
                         $key=$id."_guid";
                         $disk{$key}="$guid";

                         $key=$id."_phys";
                         $disk{$key}="$phys";

                         $key=$id."_devid";
                         $disk{$key}="$devid";

                         $key=$p."_vdev_$i"."_members";
                         $disk{$key}.="$id\t";

                         $out.="\n\t\t\t\t\t\t\t\t$id\t$guid";
                         $key="$id\_cap";
                         $out.="\t$disk{$key}";

                         $key="$id\_product";
                         $out.="\t$disk{$key}<br>$phys <br>$devid";

                         $key="$id\_sn";
                         $out.="<br>$disk{$key}";

                         $ids.="$id\t";

                      }

            }  # /w

         }   # /j

      } #i

  } #/pools

  if ($_[0] eq "1") {
        $out=&list2table($out);
        return ($out);
  }
}

##########################
 sub zfslib_pool_overview {            # print pool overview
 ############### print overview if user zfs, opr parameter "e" for poef encrypted pool
    my ($zfs,@z,$url,$u,$n,$r,@w,$dedup,$z,$out,$pool,@pools,$row,$sync,$l,$b1,$b2,$df1,$df2,$size, $avail,$used,$res,$fres,$ssb);


    #change zfs property
    if ($in{'answered'}) { &zfslib_change_poolproperty; }

    #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;zfs==zfs=\&amp;prop==prop=\&amp;old==old=\">=text=</a>";

    $out="Pool\tVER\tRAW SIZE/ USABLE\tALLOC\tRES\tFRES\tAVAIL zfs [df -h/df -H]\tDEDUP\tFAILM\tEXP\tREPL\tAlt\tGUID\tHEALTH\tAutotrim\tSYNC\tENCRYPT\tACTION\tATIME\tPriCache\tSecCache\tACLinherit\tACLmode\t<a title='System Checkpoints'>CP</a>\t<a title='Pool is mounted readonly'>Rdonly</a>\t";

    $t="$zfs{'allpools'}"; $t=~s/\t+$//;
    @pools=split(/\t/,$t);

    foreach $pool (@pools) {

        if (($_[0] eq "e") && (!($pool=~/^poef_/))) { next; }
        &log_add("zfslib.pl 2494. zpool get 'version,size,allocated,free,dedupratio,sync,failmode,autoexpand,autoreplace,altroot,guid,health' $pool");
        $zfs=&socket("zpool get 'version,size,allocated,free,dedupratio,failmode,autoexpand,autoreplace,altroot,guid,health' $pool");

        &log_add($zfs);
                                                                         # name      used         avail        refer        mountp
        $size=&socket("zfs list -H $pool");                  # b1        31.0T        10.5T        1.29M        /b1

        if ($size eq "") {
             $size="$pool   0   0   0   /$pool";                        # ex pool io suspended
        }

        # res and fres
        $res=&zfslib_get_property('reservation',$pool);
        $fres=&zfslib_get_property('refreservation',$pool);

        #small allocation classes
        $t=&socket("zpool status $pool");
        $ssb="-";
        if ($t=~/\tspecial\t/s) {
          $ssb=&zfslib_get_property('special_small_blocks',$pool);       #&mess($ssb);
        }

        $t=~s/ +/\t/g;  @t=();  @t=split(/\t/,$size);
        $used=$t[1];                                                     #name used avail
        $avail=$t[2];

        if ($fres=~/\d/) {
          $size=&zfslib_val2kb($used)+&zfslib_val2kb($avail)-&zfslib_val2kb($fres);
        } else {
          $size=&zfslib_val2kb($used)+&zfslib_val2kb($avail);
        }
        $size=&zfslib_val2xb($size);                                    # useable size = used + avail - fres

        #df values: fs  size used avail
        ##
        if ($pool eq "rpool") {
            # $t=`/usr/gnu/bin/df -h /`;                                  # base 1024
        } else {
            # $t=`/usr/gnu/bin/df -h /$pool`;


             if ($t=~/\nrpool/s) {
               $t="";             # pool io suspended
             }
        }
        $t=~s/\n/ /gs;                                                   # data in second or third line
        $t=~s/ +/\t/g;  @t=();  @t=split(/\t/,$t);
        $df1=$t[10];    # avail power of 1024

        ##

        if ($pool eq "rpool") {
             #$t=`/usr/gnu/bin/df -H /`;                                  # base 1000
        } else {
             #$t=`/usr/gnu/bin/df -H /$pool`;


             if ($t=~/\nrpool/s) {
               $t="";             # pool io suspended
             }
        }


        $t=~s/\n/ /gs;                                                   # data in second or third line
        $t=~s/ +/\t/g;  @t=();  @t=split(/\t/,$t);                       # 7=name, 8=size,9=used, 10=avail, use avail only
        $df2=$t[10];       #avail power of 1000

        ##

        #each value on pos 2 in a new line
        # convert to one line with tabs
        @z=split(/\n/,$zfs);

        #poolname
            $u=$url;
            $u=~s/=zfs=/$pool/;
            $u=~s/=prop=//;
            $u=~s/=text=/$pool/;
            $u=~s/=old=/details/;

        $out.="\n$u\t";

        $row="1";
        foreach $z (@z) {
                if ($z=~/^NAME /)  { next; }

                @w=split(/ +/,$z);                                    # name  property  value

                ## size
                if ($w[1] eq 'size') {                                # repla alloc with avail from df
                   if ($size > 0) {
                     $w[2].="/ <b>$size</b>";                          # usable
                   } else {
                     $w[2].="/ <b>0</b>";
                   }
                }


                ## avail
                # less than 10%
                if ($avail > 0) {
                  if (&zfslib_val2kb($size) > 0) {
                     $t=&zfslib_val2kb($avail)/&zfslib_val2kb($size);
                     if ($t < 0.1)  { $t="<font style='color:#ba2f28'>$avail</font>"; }  else { $t=$avail; }
                  }
                } else {
                     $t="0";  # ex not avail, suspended
                }

                if ($w[1] eq 'free') {                                # size replace with avail from df
                     $w[2]="<b>$t</b> &nbsp; [$df1 /$df2]";
                }

                #edit item?
                if ($w[1] eq 'version') {
                        if (!($w[2]=~/\d/)) { $w[2]="5000"; }
                        $u=$url;
                        $u=~s/=zfs=/$pool/;
                        $u=~s/=prop=/poolupgrade/;
                        $u=~s/=text=/$w[2]/;
                        $u=~s/=old=/$w[2]/;
                        $w[2]=$u;
                }

                if ($w[1] eq 'failmode') {
                        $u=$url;
                        $u=~s/=zfs=/$pool/;
                        $u=~s/=prop=/failmode/;
                        $u=~s/=text=/$w[2]/;
                        $u=~s/=old=/$w[2]/;
                        $w[2]=$u;

                }
                if ($w[1] eq 'autoexpand') {
                        $u=$url;
                        $u=~s/=zfs=/$pool/;
                        $u=~s/=prop=/autoexpand/;
                        $u=~s/=text=/$w[2]/;
                        $u=~s/=old=/$w[2]/;
                        $w[2]=$u;

                }
                if ($w[1] eq 'autoreplace') {
                        $u=$url;
                        $u=~s/=zfs=/$pool/;
                        $u=~s/=prop=/autoreplace/;
                        $u=~s/=text=/$w[2]/;
                        $u=~s/=old=/$w[2]/;
                        $w[2]=$u;
                }


                $w[2]=~s/DEGRADED/<font style='color:blue'>DEGRADED<\/font>/gs;                #health
                $w[2]=~s/UNAVAIL/<font style='color:#ba2f28'>UNAVAIL<\/font>/gs;
                $w[2]=~s/FAULTED/<font style='color:#ba2f28'>FAULTED<\/font>/gs;

                $out.="$w[2]\t";

                # add zfs parameter to pool overview
                if ($row eq "3") {   # 4=alloc
                   if ($res=~/\d/) {$out.="$res\t"; } else { $out.="-\t";}
                   if ($fres=~/\d/) {$out.="$fres\t"; } else { $out.="-\t";}
                }
                $row++;
        }


        # add autotrim
                 $t=&socket("zpool get -H -o value autotrim $pool 2>/dev/null",'','zfslib 4883');
                 $t=~s/\n.*//s;         # bad property or on/off
                 if ($t=~/on|off/) {
                    $u=$url;
                    $u=~s/=zfs=/$pool/;
                    $u=~s/=prop=/autotrim/;
                    $u=~s/=text=/$t/;
                    $t="$u\t";
                 } else {
                    $t="-\t";
                 }
                 $out.="$t";

        #add sync
                 # get sync
                 $sync=&socket("zfs get -H  sync $pool",'','zfslib 2575');

                 if ($sync=~/error|suspended|cannot/is) { $sync="-"; }
                 $sync=~s/ +/\t/g;

                 @t=split(/\t/,$sync);
                 $u=$url;
                 $u=~s/=zfs=/$pool/;
                 $u=~s/=prop=/sync/;
                 $u=~s/=text=/$t[2]/;
                 $out.="$u\t";

        #add encrypt
                $t=&socket("zfs get encryption $pool");
                if ($t =~/bad|suspended|cannot/is) { $t="n.a."; } else {
                     $t=~s/.*encryption +//s;
                     $t=~s/ .*//s;
                }
                if (length($t) > 4)  { $t="err"; }
                if ($t eq "on") {
                   $t=&zfslib_get_property('keystatus',$pool);

                   # lock/ unlock
                        $u=$url;
                        $u=~s/=zfs=/$pool/;

                   if ($t eq 'available') {
                        $t="<b class='font_darkblue'>unlocked</b>";
                        $u=~s/=prop=/lock/;
                   } else {
                         $t="<b class='font_darkred'>locked</b>";
                         $u=~s/=prop=/unlock/;
                   }


                   $u=~s/=text=/$t/;
                   $u=~s/=old=/$w[2]/;
                   $w[2]=$u;

                        $out.="$w[2]\t";
                }   else {

                        #&mess($t);
                        $out.="$t\t";
                }
        #add clear errors
                $u=$url;
                $u=~s/=zfs=/$pool/;
                $u=~s/=prop=/clear/;
                $u=~s/=text=/clear errors/;
                $out.=$u;

        # add atime for pool
                        $t=&socket("zfs get -H atime $pool");
                        if ($t =~/on/s) { $t="on"; } else { $t="off"; }
                        $u=$url;
                        $u=~s/=zfs=/$pool/;
                        $u=~s/=prop=/atime/;
                        $u=~s/=text=/$t/;
                        $u=~s/=old=/$t/;
                        $out.="\t$u";


         # primary cache
                $t=&socket("zfs get -H primarycache $pool");
                chomp($t);
                @t=split(/\s+/,$t);
                $t=$t[2];
                $u=$url;
                $u=~s/=zfs=/$pool/;
                $u=~s/=prop=/p-cache/;
                $u=~s/=text=/$t/;
                $u=~s/=old=/$t/;
                $out.="\t$u";
        # secondary cache
                $t=&socket("zfs get -H secondarycache $pool");
                @t=split(/\s+/,$t);
                $t=$t[2];
                $u=$url;
                $u=~s/=zfs=/$pool/;
                $u=~s/=prop=/s-cache/;
                $u=~s/=text=/$t/;
                $u=~s/=old=/$t/;
                $out.="\t$u";

        # aclinherit
                $t=&socket("zfs get -H aclinherit $pool");
                @t=split(/\s+/,$t);
                $t=$t[2];
                $u=$url;
                $u=~s/=zfs=/$pool/;
                $u=~s/=prop=/aclinherit/;
                $u=~s/=text=/$t/;
                $u=~s/=old=/$t/;
                $out.="\t$u";
        # aclmode
                $t=&socket("zfs get -H aclmode $pool");
                @t=split(/\s+/,$t);
                $t=$t[2];
                $u=$url;
                $u=~s/=zfs=/$pool/;
                $u=~s/=prop=/aclmode/;
                $u=~s/=text=/$t/;
                $u=~s/=old=/$t/;
                $out.="\t$u";

        # Checkpoints
                $u=&socket("zpool status $pool | grep checkpoint:");
                if ($u=~/created/) {
                    $out.="\tyes";
                } else {
                    $out.="\tno";
                }
        # readonly
                $u=&socket("zpool get -H -o value readonly $pool");
                if ($u=~/on/) {
                    $out.="\t<font style='color:#ba2f28'>yes</font>";
                } else {
                    $out.="\tno";
                }

    }

    if (!($out =~/\d/s)) { $out.="-none-"; }
    $l= &list2table($out,'100%,200px');
    $l="<!--wsarea-->\n<div id='wsarea'>\n$l\n</div>\n<!--wsarea_end-->\n";    # realtime update of list only
    print $l;
    print "$txt{'pool_footer'}";

    #ask property
    if (($in{'prop'} ne "") && ($in{'answered'} ne "1")) { print &zfslib_ask_poolproperty; }

    #zpool status with details?
    if ($in{'old'} eq "details") {

         print "\n\nPool Properties:<hr>";
         $r=&socket("zpool get all $in{'zfs'}");
         $r=~s/  +/\t/gs;
         print &list2table($r);

         print "<pre>\n\n<hr>zpool status -v $in{'zfs'}<hr>";
         print &socket("zpool status -v $in{'zfs'}");

         print "<hr>\n";
         print "Pool details zdb -C $in{'zfs'}\n";
         print &socket("zdb -C $in{'zfs'}");

         print "\n\n</pre></body></html>";   &log_end; exit;
    }

    print "\n</body></html>";
    return;

 }


#####################
 sub zfslib_ask_poolproperty {       #hide: ask for property
 #####################        (div window in front)

    if ($in{'answered'}) { &zfslib_change_poolproperty; exit; }

    my ($ask,$close,$form,$info,$t,$opt,$r);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";

    #ask poolupgrade
    if ($in{'prop'} eq "poolupgrade") {
      $info="The new ZFS-Version must be supported, if you want to import the pool on another ZFS-Server";
      $form="Upgrade pool ". &select('poolupgrade','yes',$r);             #
    }


    #ask p-cache
    if ($in{'prop'} eq "p-cache") {
      $info="Default=all for best performance. Set none for benchmarks without cache effecs.<br>This is a pool default. You can force this property per filesystem.";
      $form="set primarycache to ". &select('p-cache','all,metadata,none',$in{'old'});             #
    }

    #ask s-cache
    if ($in{'prop'} eq "s-cache") {
      $info="Default=all for best performance. Set none for benchmarks without cache effecs.<br>This is a pool default. You can force this property per filesystem.";
      $form="set secondarycache to ". &select('s-cache','all,metadata,none',$in{'old'});             #
    }

    #ask atime
    if ($in{'prop'} eq "atime") {
      $t=&exe("zfs get -H atime $in{'zfs'}");
      chomp($t);
      if ($t =~/on/s)  { $r="off"; } else { $r="on"; }
      $info="Log access time. Set Off for best performance. <br>This is a pool default. You can force this property per filesystem.";
      $form="set atime to ". &select('atime','on,off',$r);             #
    }

    #aclmode
    if ($in{'prop'} eq "aclmode") {
      $t=&exe("zfs get -H -o value aclmode $in{'zfs'}");
      chomp($t);

      $info="ACL mode settings. Passthrough is a most open setting while the default discard restrict options via chmod. <br>This is a pool default. You can force this property per filesystem.";
      $form="set aclmode to ". &select('aclmode','passthrough,discard,groupmask,restricted',$t);             #
    }

    #aclinherit
    if ($in{'prop'} eq "aclinherit") {
      $t=&exe("zfs get -H -o value aclinherit $in{'zfs'}");
      chomp($t);
      $info="ACL-Inheritance settings. Set passthrough for a Windows alike behaviour. <br>The default value is restricted that removes write-owner/write acl. <br>This is a pool default. You can force this property per filesystem.";
      $form="set aclinherit to ". &select('aclinherit','passthrough,discard,noallow,restricted,passthrough-x',$t);             #
    }

    #ask autotrim
    if ($in{'prop'} eq "autotrim") {
      $r=&exe("zpool get -H -o value autotrim $in{'zfs'}");
      chomp($r);
      if ($r eq "on")  { $r="off"; } else { $r="on"; }
      $info="This feature enables autotrim for a pool<br>This feature is new so use with care!";
      $form="set autotrim to ". &select('autotrim','on,off',$r);             #
    }

    #ask autoexpand
    if ($in{'prop'} eq "autoexpand") {
      $r=&exe("zpool get autoexpand $in{'zfs'}"); $r=~s/^.*autoexpand\s+//s; $r=~s/\s.*//s;
      chomp($r);
      if ($r eq "on")  { $r="off"; } else { $r="on"; }
      $info="This feature enable you to expand a LUN after replacing/resilvering a drive. The resulting pool can access the expanded space without having to export and import pool or reboot the system. default is off";
      $form="set autoexpand to ". &select('autoexpand','on,off',$r);             #
    }

    #ask autoreplace
    if ($in{'prop'} eq "autoreplace") {
      $r=&exe("zpool get autoreplace $in{'zfs'}"); $r=~s/^.*autoreplace\s+//s; $r=~s/\s.*//s;
      chomp($r);
      if ($r eq "on")  { $r="off"; } else { $r="on"; }
      $info="If set to on, any new device, found in the same physical location as a device that previously belonged to the pool, is automatically formatted and replaced. default is off";
      $form="set autoreplace to ". &select('autoreplace','on,off',$r);             #
    }


    #ask failmode
    if ($in{'prop'} eq "failmode") {
        $r=&exe("zpool get failmode $in{'zfs'}"); $r=~s/^.*failmode\s+//s; $r=~s/\s.*//s;
        chomp($r);
        $form="set failmode to ". &select('failmode','wait,continue,panic',$r);             # name, values, selected-> return htmlcode   ;
        $info="Failmode property is needed for determining the behavior of a catastrophic pool failure due to a loss of device connectivity or the failure of all devices in the pool. The failmode property can be set to these values: wait, continue, or panic. The default value is wait, which means you must reconnect the device or replace a failed device and clear the error with the zpool clear command.";
    }


    #ask sync
    if ($in{'prop'} eq "sync") {
        $form="set sync mode to ". &select('sync','standard,always,disabled');             # name, values, selected-> return htmlcode   ;
        $info="How should ZFS handle sync write requests? <br>standard: depends on client request. <br>This is a pool default. You can force this property per filesystem.";
    }

    #ask lock
    if ($in{'prop'} eq "lock") {
        $form="encrypted $in{'zfs'}: <input type='text' class='input' name='text' value='lock it' style='width: 150px' readonly> ";
        $info="if you want to reaccess this ZFS, you have to unlock it with your passphrase<br>all shares are forced to be offline";
    }
    #ask unlock
    if ($in{'prop'} eq "unlock") {
        $form="unlock with Passphrase <input type='password' name='pass' value='' style='width: 150px'> ";
        $info="enter your passphrase to unlock this ZFS";
    }
    #ask clear
    if ($in{'prop'} eq "clear") {
        $form="clear error-state: ". &select('clear','yes',$r);
        $info="clear pool error-state is only possible, if there are no current errors.";
    }

     ### form ###
     $ask=&ask_pop("$form","$info","$opt");
     return ($ask);
 }


######################
 sub zfslib_change_poolproperty {                 #hide:
 #######################    set pool details
 my ($r,$s,$t);


   ##### poolupgrade
   if ($in{'prop'} eq "poolupgrade") {
        $r= &exe("zpool upgrade $in{'zfs'}");
        print $r;
        sleep(2);
        $in{'prop'}="";
        &reload;
   }


   ##### autotrim
   if ($in{'prop'} eq "autotrim") {
        $r= &exe("zpool set autotrim=$in{'autotrim'} $in{'zfs'}");
   }

   ##### sync
   if ($in{'prop'} eq "sync") {
        $r= &exe("zfs set sync=$in{'sync'} $in{'zfs'}");
   }

   #p-cache
   if ($in{'prop'} eq "p-cache") {
        $r= &exe("zfs set primarycache=$in{'p-cache'} $in{'zfs'}");
   }

   #s-cache
   if ($in{'prop'} eq "s-cache") {
        $r= &exe("zfs set secondarycache=$in{'s-cache'} $in{'zfs'}");
   }

   #atime
   #####
   if ($in{'prop'} eq "atime") {
        $r= &exe("zfs set atime=$in{'atime'} $in{'zfs'}");
   }

   #aclmode
   #####
   if ($in{'prop'} eq "aclmode") {
        $r= &exe("zfs set aclmode=$in{'aclmode'} $in{'zfs'}");
   }

   #aclinherit
   #####
   if ($in{'prop'} eq "aclinherit") {
        $r= &exe("zfs set aclinherit=$in{'aclinherit'} $in{'zfs'}");
   }

   ##### failmode
   if ($in{'prop'} eq "failmode") {
        $r= &exe("zpool set failmode=$in{'failmode'} $in{'zfs'}");
   }
   ##### autoexpand
   if ($in{'prop'} eq "autoexpand") {
        $r= &exe("zpool set autoexpand=$in{'autoexpand'} $in{'zfs'}");
   }
   ##### autoreplace
   if ($in{'prop'} eq "autoreplace") {
        $r= &exe("zpool set autoreplace=$in{'autoreplace'} $in{'zfs'}");
   }


   ##### clear
   if ($in{'prop'} eq "clear") {
        $r= &exe("zpool clear $in{'zfs'}");
        if (-f "/tmp/poolstat.log") {  &exe("rm /tmp/poolstat.log"); }
   }

   ##### lock
   if ($in{'prop'} eq "lock") {
        print "please wait...\n";
### martingo 20180306 >>> Keys sicherheitshalber rekursiv entladen; vermutlich nicht notwendig, schadet aber nicht
        #$r= &exe("zfs key -u -f $in{'zfs'}");
        $r= &exe("zfs key -u -r -f $in{'zfs'}");
### <<<
        &zfslib_refresh_svc;
   }



   ##### unlock
   if ($in{'prop'} eq "unlock") {
        print "please wait...\n";
       # use Expect;
        my $exp; #->raw_pty(1);
        $exp = Expect->spawn("sudo zfs mount $in{'zfs'}") or die "Couldn't mount: $!\n";

        $exp->expect(2,
                [ 'Enter' =>
                         sub {
                             $exp->send("$in{'pass'}\r");
                             print "<br><br>\n";
                             exp_continue;
                         }
                ]
         );
         $exp->soft_close();
         &zfslib_refresh_svc;
         sleep(1);
   }

   #if (-f '/tmp/nappit/zfs.cfg') { unlink('/tmp/nappit/zfs.cfg'); }  # old
   if (-f "/tmp/nappit/zfs_list.zfs") { `sudo rm /tmp/nappit/*.zfs`;  }

   if ($r ne"") {  &mess($r); }

   $in{'prop'}="";
   &reload;


  #######
 }





####################
sub zfslib_list_pools  {   # list pools par: 'source (all,exported,destroyed,comma,nl,br,array,),state,status,action,scan,config'
####################
                      ##########################
                      # comma,nl,br,array -> form of return value
                      # header -> incl header,
                      # all all pools inkl sys
                      #   (exported) and/or D (destroyed) pools only
                      #########################
                      # default, list datapools as tablist  tank\tdata
                      # options: state,status,action,scan,config

 #$_[0]="state,status,header,imp,des,action";
  my (@w,$w,$key,$k,$n,@l,$t,@d,$d,$m,$ant,$par);
  $par=$_[0];

  if ($_[0] =~/imp|des/i) {
    if ($_[0] =~/ex/i)  {   $ant.=&exe('zpool import');   }   # get exported pools
    if ($_[0] =~/des/i) {   $ant.=&exe('zpool import -D'); }  # get destroyed pools
  } else {
          $ant=&socket('zpool status');                             # get status info
  }



  $ant=~s/\s/ /gs; $ant=~s/ +/ /gs; $ant=~s/^ +//gs;     #every item trimmed in new line
  $ant=~s/pool: /\npool:/gs;                                #in new line

  #valid pools
  @w=split(/\n/,$ant);
  foreach $n (@w) {
      if ($_[0] =~/all/i)                                         {  push (@n,$n); }
      if (($_[0] =~/ex|des/i) &&  ($n=~/pool can.* be imported/))  {
        if ($n=~/DESTROYED/) {
                      $n=~s/ id: /_D/;
        } else {
                      $n=~s/ id: /_/;
         }
         push (@n,$n);
         }
  }
  $ant=join("\n",@n);

  #  &mess($ant);


  $ant=~s/state: /\nstate:/gs;                                  #in new line
  $ant=~s/scan: /\nscan:/gs;                                    #in new line
  $ant=~s/status: /\nstatus:/gs;                                #in new line
  $ant=~s/action: /\naction:/gs;                                #in new line
  $ant=~s/config: /\nconfig:/gs;                                #in new line
  $ant=~s/id: /\nid:/gs;                                        #in new line

  # example
  # pool:syspool
  # id:1793635354   (opt)
  # state:ONLINE (DESTROYED)
  # status:The pool is formatted using an older on-disk format. The pool can still be used, but some features are unavailable.
  # action:Upgrade the pool using 'zpool upgrade'. Once this is done, the pool will no longer be accessible on older software versions.
  # scan:none requested
  # config:NAME STATE READ WRITE CKSUM syspool ONLINE 0 0 0 c1t0d0s0 ONLINE 0 0 0 errors: No known data errors

  @l=split(/\n/,$ant);

#test
#print @l; exit;
#&print_array(@l);

  my $pools;
  my $header;
  my $lastpool;
  if ($_[0]=~/header/) { $header="pool\t"; }
  if (($_[0]=~/header/i) && ($_[0]=~/state/i))  { $header.="state\t"; }
  if (($_[0]=~/header/i) && ($_[0]=~/status/i)) { $header.="status\t"; }
  if (($_[0]=~/header/i) && ($_[0]=~/action/i)) { $header.="action\t"; }
  if (($_[0]=~/header/i) && ($_[0]=~/scan/i))   { $header.="scan\t"; }
  if (($_[0]=~/header/i) && ($_[0]=~/config/i)) { $header.="config\t"; }
  $header=~s/\t$//;

  foreach my $l (@l) {
        if (!($l =~/\:/)) {  next; }                        # no value

        $l=~s/ +$//;
        @w=split(/:/,$l);                               #pool:tank
        $w[1]=~s/ +$//g;                                #rtrim

        if ($w[0] eq "pool") {
                 $pool=~s/\t+$//s;
                if (($w[1] ne $zfs{'syspool'}) || ($_[0]=~/all/))  {        # incl syspool
                        $pools.="\n$w[1]\t";        # tablist
                         $lastpool=$w[1];
                }
                 next;
        }
         #only pools

         if (!($_[0]=~/state|status|action|scan|config/))   { next; }        #only poollist
         #otherwise every pool in a line

         if (($_[0]=~/all/i) || ($lastpool ne $zfs{'syspool'}))  {

          if (($w[0] eq "state") && ($_[0]=~/state/i)) {                        # tank_state
                 $par.="nl";
                 $w[1]=~s/\t//g;   $w[1]=~s/^\s+|\s+$//g;
                $pools.="$w[1]\t";
                 next;
           }


          if (($w[0] eq "status") && ($_[0]=~/status/i)) {
                 $par.="nl";
                 $w[1]=~s/\t//g;   $w[1]=~s/^\s+|\s+$//g;
                $pools.="$w[1]\t";
                 next;
          }


          if (($w[0] eq "action") && ($_[0]=~/action/i)) {
                 $par.="nl";
                 $w[1]=~s/\t//g;    $w[1]=~s/^\s+|\s+$//g;
                 $pools.="$w[1]\t";
                 next;
          }

          if (($w[0] eq "scan")  && ($_[0]=~/scan/i)) {
                 $par.="nl";
                 $w[1]=~s/\t//g;    $w[1]=~s/^\s+|\s+$//g;
                 $pools.="$w[1]\t";
                 next;
          }


           if (($w[0] eq "config")  && ($_[0]=~/config/i)) {
                 $par.="nl";
                 $w[1]=~s/\t//g;   $w[1]=~s/^\s+|\s+$//g;
                 $pools.="$w[1]\t";
                 next;
          }
         }
  }
  ##
  $pools=~s/^\n//;  $pools=~s/\t$//s;
  $pools=~s/\t\n/\n/gs;

  if ($par=~/header/i) {
     $pools="$header\n$pools";
  }

#default tablist
  #&mess($pools);

  #rows
  if ($par=~/nl/)  {
        if ($par=~/br/)  {
                        $pools=~s/\n/<br>\n/gs;
        }
        $par="zfslib_list_pools_$_[0]_nl";
        $current{$par}=$pools;
        return ($pools);
  }

  #array
  if ($par=~/array/)  {
          @w=();
         @w=split(/\n/,$pools);
         $par="zfslib_list_pools_$_[0]_array";
         $current{$par}=$pools;
         return (@w);
  }

  #kommalist
  if ($par=~/omma/)  {
          $pools=~s/\n/,/gs;
         $par="zfslib_list_pools_$_[0]_comma";
         $current{$par}=$pools;
         return ($pools);          #komma, comma

  }
  #default tablist

  $pools=~s/\n/\t/gs;
  $par="zfslib_list_pools_$_[0]_tab";
  $current{$par}=$pools;
  return ($pools);

}

#############################     when smb set to off
sub zfslib_remember_shareacl {
#############################
    # shareacl as zfs property shareacl_00:, shareacl_01:, ..
    my (@r,@t,$r,$fi,$t,@acl);
    $t=$in{'zfs'}; $t=~s/.*\///;        #fs name only
    $fi="/$in{'zfs'}/.zfs/shares/$t";  #share acl file ex /tank/data/.zfs/shares/data
    #&mess($fi);


    # step1: delete old
    ###################
    $r=`sudo /sbin/zfs get all $fs | grep shareacl_ | grep -v @`;   chomp($r);      # without snaps
    # ex
    # shareacl_00:                  user:a:rwxpdDaARWcCos:-------:deny              local

    @t=split(/\n/,$r);
    #&print_array(@t);

    foreach my $i (@t) {
            @p=split(/\s+/,$i);               # prop=val1
            print "zfs inherit $p[1] $fs <br>";
            `sudo /sbin/zfs inherit $p[1] $in{'zfs'}`;
    }

    #step2, get share acl
    $r=`/usr/bin/ls -V $fi`; chomp($r);

    @acl=split(/\n/,$r);
    splice @acl, 0, 1;         # remove first entry (filename)

    #step3 save shareacl as prop

    for (my $i=0; $i < @acl; $i++) {
       $n="0$i"; $n=~s/^00/0/; if ($n eq "0") {$n="00"; }      # count 00, 01, 02, ..
       $acl[$i]=~s/ +//;    # remove spaces
       print "zfs set shareacl_$n:=$acl[$i] $in{'zfs'}<br>";
       `sudo zfs set shareacl_$n:=$acl[$i] $in{'zfs'}`;
    }

    sleep(1);
    #&print_array (@acl);       # debug, exit;
}

#############################     when smb set to off
sub zfslib_set_shareacl {
#############################
    # shareacl as zfs property shareacl_00:, shareacl_01:, ..
    my (@r,@t,$r,$fi,$t,@acl,$n,@n);
    $t=$in{'zfs'}; $t=~s/.*\///;        #fs name only
    $fi="/$in{'zfs'}/.zfs/shares/$t";   #share acl file ex /tank/data/.zfs/shares/data

    # full
    if ($in{'shareacl'} eq "everyone=full") { return; }   #default



    # modify
    if ($in{'shareacl'} eq "root=full, everyone=modify") {

       print   "chmod A=user:root:rwxpdDaARWcCos:-------:allow<br>";
       $r=`sudo /usr/bin/chmod A=user:root:rwxpdDaARWcCos:-------:allow $fi`;   # root always full

       print   "/usr/bin/chmod A1+everyone\@:rwxpdDaARWc--s:-------:allow $fi<br>";
       $r=`sudo /usr/bin/chmod A1+everyone\@:rwxpdDaARWc--s:-------:allow $fi`;    # other modify
       return;
    }

    # read
    if ($in{'shareacl'} eq "root=full, everyone=read") {

       print   "chmod A=user:root:rwxpdDaARWcCos:-------:allow<br>";
       $r=`sudo /usr/bin/chmod A=user:root:rwxpdDaARWcCos:-------:allow $fi`;   # root always full

       print   "/usr/bin/chmod A1+everyone\@:r-----a-R-c--s::-------:allow $fi<br>";
       $r=`sudo /usr/bin/chmod A1+everyone\@:r-----a-R-c--s:-------:allow $fi`;    # other modify
       return;
    }

    #last setting
    #&print_hash(%in);
    print "restore last share acl<br>";

    # otherwise restore  last properies
    #ex shareacl_00:=everyone@:rwxpdDaARWcCos:-------:allow
    #ex shareacl_01:=..
    # ..
    $r=`sudo /sbin/zfs get all $in{'zfs'} | grep shareacl_`;
    @t=split(/\n/,$r); @t=reverse sort(@t);        # sort

    foreach my $l (@t) {                                      #
          if ($l=~/:root:/) {   next; }
          @p=split(/ +/,$l);
          push (@n,$p[2]);
    }
    push(@n,"user:root:rwxpdDaARWcCos:-------:allow");          # allow/add root always (full)

    #
    #print_array(@n);

    for (my $i=0; $i<@n; $i++) {
        if ($i==0) {
           print "chmod A=$n[$i]<br>";
           $r=`sudo /usr/bin/chmod A=$n[$i] $fi`;
        } else  {
           print "chmod A$i+$n[$i]<br>";
           $r=`sudo /usr/bin/chmod A$n+$n[$i] $fi`;
        }
    }
    sleep(2);
}

########### eof ##########
1;