#!"\xampp\perl\bin\perl.exe"

# admin-mon.pl
# (c) Guenther Alka, 2012-2024

# 22. mar 18 secure requ 145

# function: display realtime graphics and reload pages to update values
# this script is called as an ajax function from a webpage and loads stat data from disk or shows time
# stats data and page divs are generated by agents
#
#
# data is send as string with values separated by <~>
######################################################################################
# load via
# <script type="text/javascript" src="/_doc/menu/inc/jquery-3.1.1.min.js"></script>
# <script type="text/javascript">
#
#     function auto_load(){
#         $.ajax({
#              url: "/cgi-bin/admin-mon.pl",
#              cache: false,
#              data: {
#                 name : "The name",
#                 desc : "The description"
#              },
#              success: function(data){
#                  $("#auto_load_div").html(data);
#
#                  var mess = data;
#                  var arr = mess.split("<~>");
#                  if (arr[0] != '') { $('#status_time').html(arr[0]);  }         // time
#                  if (arr[1] != '') { $('#status_info').html(arr[1]);  }         // status ample
#                  if (arr[2] != '') { $('#content').html(arr[2]);      }         // div  #content update
#                  if (arr[3] != '') { $('#wsarea').html(arr[3]);       }         // div  #wsarea update
#                  if (arr[4] != '') { $('#wsdata').html(arr[4]);       }         // div  #wsdata update
#                  if (arr[5] != '') { rgraph_iostat(arr[5]);           }         // draw rgraph with ws data5
#                  if (arr[6] != '') { rgraph_arczilstat(arr[6]);       }         // draw rgraph with ws data
#                  if (arr[7] != '') { rgraph_netstat(arr[7]);          }         // draw rgraph with ws data
#                  if (arr[8] != '') { rgraph_cpustat(arr[8]);          }         // draw rgraph with ws data
#                  if (arr[9] != '') { rgraph_servicestat(arr[9]);      }         // draw rgraph with ws data
#              }
#         });
#     }
#
#     $(document).ready(function(){
#            auto_load(); //Call auto_load() function when DOM is Ready
#     });
#
#     //Refresh auto_load() function after 10000 milliseconds
#     setInterval(auto_load,1000);
# </script>
###############################################################################


use strict;
# use lib "/var/web-gui/data/napp-it/CGI";                  # optional, add to perl search path for libs ex. Expect.pm and others
use CGI::Carp qw (fatalsToBrowser);                         # optional, use for debugging

use Fcntl qw(:flock);                                       # filelocking
$|=1;                                                       # keine Pufferung, no buffering

use vars qw($id $si $message $tmp $log $type $nop $time $page_id $cgipath $i $t $p $o $action $txt $status %t %p %in %cfg @p @v @i @t @cfg %disk %sys %zfs %action %current %opt %txt @data %data $r);         # menues and global var + global temp

require "C:/xampp/napp-it/data/wwwroot/cgi-bin/admin-wlib.pl";                           # common used functions of napp-it
#require "C:xampp/napp-it/data/napp-it/zfsos/_lib/illumos/agents/monitor-lib.pl";       # monitor calls  !!

$tmp="C:\\xampp\\napp-it\\data\\napp-it\\tmp";             # win tmp folder
&ReadParse;
$time=time();

###########
      # check session
      @t=();
      @t=split(/,/,$in{'id'});
      $r="$tmp\\session.$t[1]";
      $id=$t[1];
      @data=();
      if (-f "$r") {
            open (F,"<$r");
              flock(F, LOCK_EX);
              @data=<F>;
            close (F);

            # S_AGENT|Mozilla/5.0 (Windows NT 10.0; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0|
            # S_ID|QkLzbvzqQUYcgx5N|
            # S_LID|QkLzxxzqQUYcgx5N|
            # S_IP|172.19.1.140|
            # S_TIME|1482937282|
            # S_USER|admin|
            # S_VER|carm|

            @i=(); @i=split(/\|/,$data[1]);  # id
            @p=(); @p=split(/\|/,$data[5]);  # user
            @t=(); @t=split(/\|/,$data[4]);  # time max 1h
            @v=(); @v=split(/\|/,$data[6]);  # time max 1h

            #check session id
            if (!($in{'id'} eq "$p[1],$id,$i[1]"))   { print "Content-type: text/plain\n\n session id $id invalid";    exit; }  # id=user,time,sid
            if ($time - $t[1] > 3700)                { print "Content-type: text/plain\n\n session time invalid";  exit; }  # id=user,time,sid
            if (!($v[1]=~/\w/) )                     { print "Content-type: text/plain\n\n Pro only";  exit; }              # id=user,time,sid
            $status="1";
      }   else {
           $status="0";  # show status ample only
          #  print "Content-type: text/plain\n\n session invalid";  exit;   # id=user,time,sid                               # if disabled, status is shown on logout
      }
###########
if ($in{'id'} eq "") {
     $status="1";  # show status ample only
}

$message="l1=$in{'l1'}:l2=$in{'l2'}:l3=$in{'l3'}:prop=$in{'prop'}:prop2=$in{'prop2'}:list=$in{'list'}";         # path

#data is an array and sended as string with <~> as seperator
@data=();

#data type
$type="time,ministat";              # update always

if ($sys{'sec'}=~/0$|5$/) {
    $type.=",page";                 # page update every 5s
}


# request page reload               # page is created in agent_acc.pl
#####################

$t=$in{'l1'};  $t=~s/\_.*//;
$t.=$in{'l2'}; $t=~s/\_.*//;
$t.=$in{'l3'}; $t=~s/\_.*//;
$page_id=$t;

if (("05,0501,07,15,1502,1510"=~/$t/) && ($t ne "") && ($in{'id'} ne "") && ($status)) {         # disks/details, filesystems, jobs

        $si=substr($in{'id'},0,24);                                                         # use in filename
        $t.="_$si.req_htm";

        #  done in admin.pl
        # `sudo /usr/bin/chown napp-it /tmp/nappit/htm/$t`;
        # `sudo /usr/bin/chmod 777 /tmp/nappit/htm/$t`;

        open (PF, ">$tmp\\$t");                                                   # write request, processed in agent_acc.pl, owner napp-it
           flock(PF, LOCK_EX);
           print PF "time: $time\n";
           print PF "$in{'id'}\n";
           print PF "$in{'l1'}\n";
           print PF "$in{'l2'}\n";
           print PF "$in{'l3'}\n";
        close (PF);
       # `sudo /usr/bin/chmod 700 /tmp/nappit/htm/$t`;                                        # acc runs as root
}

# menu extension
      if ($in{'l2'}=~/3\d_real/i)  {
           $type.=",data";
      }

# menu shorttime
      if ($in{'l2'}=~/36_Short/i)  {
           $type.=",data";
           if ($in{'list'} eq "") { $message.="rpool";  }          # default
      }

# menu longterm
      if ($in{'l2'}=~/37_Long/i)  {
           $type.=",data";
           if ($in{'list'} eq "") { $message.="rpool";  }          # default
      }

#system overview
      if (($in{'l1'}=~/^03_/i) && ($in{'l2'} eq "")) {
           $type.=",data";
      }

#about, show iostat data
      if (($in{'l1'}=~/^00_/) && ($in{'l2'} eq "")) {
           $type.=",data";
      }

#about, after login
      if (($in{'l1'} eq "") && ($in{'id'} ne "")) {
           $type.=",data";
      }

# add time always
##########

&getdate;
$data[0]="Pro Monitor: $sys{'hour'}:$sys{'min'} $sys{'sec'}s ";


# only when mon active on Solarish
#$t=`uname -a`;
if ( (!($t=~/^Linux/i)) && ($status)) {
 if (!(-f 'C:\xampp\napp-it\_log\monitor_off')) {
    #

    # 1. add ample
    ############
    #$data[1]=&monitor;


    # all processes
    #$data{'ps'}=`ps axw`;


    # page reload every 5s
    #################   $out="$tm<~>$stat<~>$content<~>$wsarea<~>$wsdata<~>$iostat<~>$arczilstat<~>$nicstat<~>$cpustat<~>$fsstat<~>";
                        #     0     1       2          3         4          5         6            7          8          9

    if ($sys{'sec'}=~/0$|2$|4$|6$|8$/) {
         #
          # load page_id
          $si=substr($in{'id'},0,24);
          $log="$page_id"."_$si.htm";                         # use short id in name


          @p=(); $r="";
          if (-f "$tmp\\$log") {

                          open (F,"<$tmp\\$log");   # htm owner napp-it in acc
                              flock(F, LOCK_EX);
                              @p=<F>;
                          close (F);

                          #check time
                          $i="1";
                          if ($p[0]=~/time: \d+/) {
                               $i=$p[0]; $i=~s/\D//g;
                               $p[0]="";

                               $t=time();
                               if ($t-$i > 10) {
                                   $i="1";                 # too old or no date
                               }
                          }

                          # delete this one
                          unlink ("$tmp\\$log");

                          # request re generation
                          $r=join("",@p);
                          $t=$r;

                          # do not update, ex when current message contains prop=abc
                          if ($nop eq "0")   { $r=""; }

                          # update only wscontent
                          if ($r=~/^<!\-\-wscontent/) {
                                   $data[2]=$r;
                          } else {
                               if ($r=~/^<!--wsarea/) {
                                   $data[3]=$r;
                               }
                          }

                          if ($i eq "1") {  # no date or data too old
                             $data[2]="";
                             $data[3]="";
                          }
            } else {
              # debug
              #
            }
    }




    # 2. add iostat
    ############
            #
            if ($data{'ps'}=~/stat.pl iostat/s) {
                 $r="$sys{'hour'}:$sys{'min'} $sys{'sec'}s ";

                 if ($type =~/data/) {
                    # pure data
                    if ($message=~/iostat2/i) {
                           $r="";
                           $log=&iostat('data');
                           $log=&stat2table($log);
                           $log="iostat<br><br>$log";
                    } else {
                        if ($in{'l3'} eq "") {
                           ($log,$r)=&iostat('pools');          # menu l3="" -> pools only
                        } else {
                           ($log,$r)=&iostat;
                        }
                    }
                    if ($message=~/shortterm/i) {
                        #($wsdata,$iostat)=&short_iostat($message);  #old
                        ($log,$r)=&short_iostat($message);
                    }
                    if ($message=~/longterm/i) {
                        #($wsdata,$iostat)=&short_iostat($message);  #old
                        ($log,$r)=&long_iostat($message);
                    }

                 }

            } else {
                  $log="$sys{'hour'}:$sys{'min'} $sys{'sec'}s: iostat disabled";
                  @t=();
                  $t[0]="iostat: disabled";
                  $t[1]="1000";                          # x-unit1
                  $t[2]="(n.a.)";                        # y-labels (c0t1,c0t2)
                  $t[3]="iostat: no data";               # keys1    (read,write,wait)
                  $t[4]="0";                             # data1
                  $t[5]="100";                           # x-unit2
                  $t[6]="(n.a.)";                        # y-labels2 (c0t1,c0t2)
                  $t[7]="no data";                       # keys2     (%b,%w)
                  $t[8]="0";                             # data2
                  $t[9]="-";                             # cpu busy
                  $t[10]="-";                            # cpu busy av10s
                  $r=join(";",@t);
            }
            $data[4]=$log;   # wsdata
            $data[5]=$r;     # iostat



    # 3. add arcstat
    #################   $out="$tm<~>$stat<~>$content<~>$wsarea<~>$wsdata<~>$iostat<~>$arczilstat<~>$nicstat<~>$cpustat<~>$fsstat<~>";
                        #     0     1       2          3         4          5         6            7          8          9
            #
            $r="0";
            if ($data{'ps'}=~/stat.pl arcstat/s) {
                  if ($type =~/data/) {
                       $r=&arcstat;
                  }
             } else {
                  # $r="data;disabled;0;disabled.;0;-;";            # no data
                  $r="0,0,0,0";            # no data
             }
             $data[6]="$r";                                         # arczilstat

             # pure arcdata
             if ($message=~/arcstat/i) {
                           $log=&arcstat('raw');
                           $data[4]=&stat2table($log);             # wsdata
                           $data[4]="arcstat<br><br>$data[4]";
                           $data[6]="";                            # arczilstat
             }

             # zilstat, pure data
             if ($message=~/zilstat/i) {
                           $log=&zilstat('raw');
                           $log=~s/ s/s/gs;                         # no extra col for sec

                           $data[4]=&stat2table($log);              # wsdata
                           $data[4]="zilstat<br><br>$data[4]";
                           $data[6]="";                            # arczilstat ;
             }


    # 4. add anet/nicstat
    #################   $out="$tm<~>$stat<~>$content<~>$wsarea<~>$wsdata<~>$iostat<~>$arczilstat<~>$nicstat<~>$cpustat<~>$fsstat<~>";
                        #     0     1       2          3         4          5         6            7          8          9

             #
             $r="0";
             if ($data{'ps'}=~/stat.pl nicstat/s) {
                   if ($type =~/data/) {
                        $r=&nicstat;
                   }
              } else {
                   $r="n.a.;nicstat disabled;0;nicstat disabled";            # no data
              }
              $data[7]=$r;  # nicstat
              # pure data
              if ($message=~/netstat/) {
                            $r="";
                            $log=&nicstat('raw');
                            $log=~s/,/  /gs;
                            $log=~s/;/\n/gs;
                            $log=~s/\n+/\n/gs;
                            $log=&stat2table($log);
                            $data[7]="";                                  # nicstat
                            $data[4]=$log;                                # wsdata
                            $data[4]="netstat<br><br>$data[4]";
              }


    # 5. add prstat/ CPU /RAM
    #################   $out="$tm<~>$stat<~>$content<~>$wsarea<~>$wsdata<~>$iostat<~>$arczilstat<~>$nicstat<~>$cpustat<~>$fsstat<~>";
                        #     0     1       2          3         4          5         6            7          8          9

             $r="0";
             if ($data{'ps'}=~/stat.pl prstat/s) {
                   if ($type =~/data/) {
                      $r=&prstat;
                   }
             } else {
                    $r="(n.a.);1;10;prstat disabled;";
             }
             $data[8]="$r";             # cpustst

             #raw
             if ($message=~/prstat/) {
                            $r="";
                            $log=&prstat('raw');
                            $log=~s/\n+/\n/gs;
                            $log=~s/Total/\nTotal/s;
                            $log=&stat2table($log);
                            $data[8]="";
                            $data[4]=$log;                           # wsdata
                            $data[4]="prstat<br><br>$data[4]";
              }


    # 6. add fsstat
    #################   $out="$tm<~>$stat<~>$content<~>$wsarea<~>$wsdata<~>$iostat<~>$arczilstat<~>$nicstat<~>$cpustat<~>$fsstat<~>";
                        #     0     1       2          3         4          5         6            7          8          9

              $r="0";
              if ($data{'ps'}=~/stat.pl fsstat/s) {
                    if ($type =~/data/) {
                         $r=&fsstat;
                    }
               } else {
                     $r="(na);0;100;fsstat disabled";            # no data
               }
              $data[9]="$r";                                     #fssstat

              #raw
              if ($message=~/fsstat/) {
                             $log=&fsstat('raw');
                             $log=~s/,/\t/gs;
                             $log=~s/;/\n/gs;
                             $log=~s/\n+/\n/gs;
                             $data[4]=&stat2table($log);         #wsdata
                             $data[4]="fsstat<br><br>$data[4]";
                             $data[9]="";
               }

     #####
     if (!(defined $data[4])) { $data[4]=""; }       # wsdata

 }  # /monitor on
}

###########
# send data
###########
$txt=join("<~>",@data);
print "Content-type: text/plain\n\n";
print "$txt\n";

exit;

##########
sub socket {
##########

my $input = $_[0];
$input=~s/^ +//;
$input="'".$input."'";

# Erstelle einen Socket, der mit dem Server auf Port 1234 verbindet
my $socket = IO::Socket::INET->new(
    PeerHost => 'localhost',
    PeerPort => '63000',
    Proto    => 'tcp',
) or return("Kann keine socket Verbindung herstellen: $!\n");

    # sende sie an den Server
    $socket->syswrite($input);
    # Warte auf die Antwort vom Server
    my $output;
    $socket->sysread($output, 1024);
    # Gib die Antwort aus
    # print "Antwort vom Server: $output";

    # Schliee den Socket
    $socket->close or die "close: $!";
    return ($output);
}

##################
sub reload_pages {
##################
my ($i,$t);
# when a page is displayed, new state of the page is generated and saved
 $p=&get_pageid;                                                                         # ex 15.01.htm

  # last access in general and to a menu ex 15 to increase gui accelaeration for some time
      $i=time();
      $t=$p; $t=~s/\..*//;     # main only
      if ($t eq "") { $t="00"; }
      open (PF, ">$tmp\\menue-$t.log");   flock(PF, LOCK_EX); print PF "$i"; close (PF);
      open (PF, ">$tmp\\menue-last.log"); flock(PF, LOCK_EX); print PF "$i"; close (PF);


}